
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1

/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yylval          base_yylval
#define yychar          base_yychar
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs
#define yylloc          base_yylloc

/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "gram.y"


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRES SQL YACC rules/actions
 *
 * Portions Copyright (c) 1996-2009, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  $PostgreSQL: pgsql/src/backend/parser/gram.y,v 2.665.2.1 2009/07/06 02:58:48 tgl Exp $
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *	  SQL92-specific syntax is separated from plain SQL/Postgres syntax
 *	  to help isolate the non-extensible portions of the parser.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET SQL_inheritance TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.  The handling of SQL_inheritance is
 *	  a good example.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/gramparse.h"
#include "security/sepgsql.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"


/* Location tracking support --- simpler than bison's default */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if (N) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (Rhs)[0]; \
	} while (0)

/*
 * The %name-prefix option below will make bison call base_yylex, but we
 * really want it to call filtered_base_yylex (see parser.c).
 */
#define base_yylex filtered_base_yylex

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

extern List *parsetree;			/* final parse result is delivered here */

static bool QueryIsRule = FALSE;

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantObjectType objtype;
	List	   *objs;
} PrivTarget;

/*
 * If you need access to certain yacc-generated variables and find that
 * they're static by default, uncomment the next line.  (this is not a
 * problem, yet.)
 */
/*#define __YYSCLASS*/

static Node *makeColumnRef(char *colname, List *indirection, int location);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static FuncCall *makeOverlaps(List *largs, List *rargs, int location);
static void check_qualified_name(List *names);
static List *check_func_name(List *names);
static List *check_indirection(List *indirection);
static List *extractArgTypes(List *parameters);
static SelectStmt *findLeftmostSelect(SelectStmt *node);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								Node *limitOffset, Node *limitCount,
								WithClause *withClause);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);



/* Line 189 of yacc.c  */
#line 225 "gram.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ABORT_P = 258,
     ABSOLUTE_P = 259,
     ACCESS = 260,
     ACTION = 261,
     ADD_P = 262,
     ADMIN = 263,
     AFTER = 264,
     AGGREGATE = 265,
     ALL = 266,
     ALSO = 267,
     ALTER = 268,
     ALWAYS = 269,
     ANALYSE = 270,
     ANALYZE = 271,
     AND = 272,
     ANY = 273,
     ARRAY = 274,
     AS = 275,
     ASC = 276,
     ASSERTION = 277,
     ASSIGNMENT = 278,
     ASYMMETRIC = 279,
     AT = 280,
     AUTHORIZATION = 281,
     BACKWARD = 282,
     BEFORE = 283,
     BEGIN_P = 284,
     BETWEEN = 285,
     BIGINT = 286,
     BINARY = 287,
     BIT = 288,
     BOOLEAN_P = 289,
     BOTH = 290,
     BY = 291,
     CACHE = 292,
     CALLED = 293,
     CASCADE = 294,
     CASCADED = 295,
     CASE = 296,
     CAST = 297,
     CATALOG_P = 298,
     CHAIN = 299,
     CHAR_P = 300,
     CHARACTER = 301,
     CHARACTERISTICS = 302,
     CHECK = 303,
     CHECKPOINT = 304,
     CLASS = 305,
     CLOSE = 306,
     CLUSTER = 307,
     COALESCE = 308,
     COLLATE = 309,
     COLUMN = 310,
     COMMENT = 311,
     COMMIT = 312,
     COMMITTED = 313,
     CONCURRENTLY = 314,
     CONFIGURATION = 315,
     CONNECTION = 316,
     CONSTRAINT = 317,
     CONSTRAINTS = 318,
     CONTENT_P = 319,
     CONTINUE_P = 320,
     CONVERSION_P = 321,
     COPY = 322,
     COST = 323,
     CREATE = 324,
     CREATEDB = 325,
     CREATEROLE = 326,
     CREATEUSER = 327,
     CROSS = 328,
     CSV = 329,
     CURRENT_P = 330,
     CURRENT_CATALOG = 331,
     CURRENT_DATE = 332,
     CURRENT_ROLE = 333,
     CURRENT_SCHEMA = 334,
     CURRENT_TIME = 335,
     CURRENT_TIMESTAMP = 336,
     CURRENT_USER = 337,
     CURSOR = 338,
     CYCLE = 339,
     DATA_P = 340,
     DATABASE = 341,
     DAY_P = 342,
     DEALLOCATE = 343,
     DEC = 344,
     DECIMAL_P = 345,
     DECLARE = 346,
     DEFAULT = 347,
     DEFAULTS = 348,
     DEFERRABLE = 349,
     DEFERRED = 350,
     DEFINER = 351,
     DELETE_P = 352,
     DELIMITER = 353,
     DELIMITERS = 354,
     DESC = 355,
     DICTIONARY = 356,
     DISABLE_P = 357,
     DISCARD = 358,
     DISTINCT = 359,
     DO = 360,
     DOCUMENT_P = 361,
     DOMAIN_P = 362,
     DOUBLE_P = 363,
     DROP = 364,
     EACH = 365,
     ELSE = 366,
     ENABLE_P = 367,
     ENCODING = 368,
     ENCRYPTED = 369,
     END_P = 370,
     ENUM_P = 371,
     ESCAPE = 372,
     EXCEPT = 373,
     EXCLUDING = 374,
     EXCLUSIVE = 375,
     EXECUTE = 376,
     EXISTS = 377,
     EXPLAIN = 378,
     EXTERNAL = 379,
     EXTRACT = 380,
     FALSE_P = 381,
     FAMILY = 382,
     FETCH = 383,
     FIRST_P = 384,
     FLOAT_P = 385,
     FOLLOWING = 386,
     FOR = 387,
     FORCE = 388,
     FOREIGN = 389,
     FORWARD = 390,
     FREEZE = 391,
     FROM = 392,
     FULL = 393,
     FUNCTION = 394,
     GLOBAL = 395,
     GRANT = 396,
     GRANTED = 397,
     GREATEST = 398,
     GROUP_P = 399,
     HANDLER = 400,
     HAVING = 401,
     HEADER_P = 402,
     HOLD = 403,
     HOUR_P = 404,
     IDENTITY_P = 405,
     IF_P = 406,
     ILIKE = 407,
     IMMEDIATE = 408,
     IMMUTABLE = 409,
     IMPLICIT_P = 410,
     IN_P = 411,
     INCLUDING = 412,
     INCREMENT = 413,
     INDEX = 414,
     INDEXES = 415,
     INHERIT = 416,
     INHERITS = 417,
     INITIALLY = 418,
     INNER_P = 419,
     INOUT = 420,
     INPUT_P = 421,
     INSENSITIVE = 422,
     INSERT = 423,
     INSTEAD = 424,
     INT_P = 425,
     INTEGER = 426,
     INTERSECT = 427,
     INTERVAL = 428,
     INTO = 429,
     INVOKER = 430,
     IS = 431,
     ISNULL = 432,
     ISOLATION = 433,
     JOIN = 434,
     KEY = 435,
     LANCOMPILER = 436,
     LANGUAGE = 437,
     LARGE_P = 438,
     LAST_P = 439,
     LC_COLLATE_P = 440,
     LC_CTYPE_P = 441,
     LEADING = 442,
     LEAST = 443,
     LEFT = 444,
     LEVEL = 445,
     LIKE = 446,
     LIMIT = 447,
     LISTEN = 448,
     LOAD = 449,
     LOCAL = 450,
     LOCALTIME = 451,
     LOCALTIMESTAMP = 452,
     LOCATION = 453,
     LOCK_P = 454,
     LOGIN_P = 455,
     MAPPING = 456,
     MATCH = 457,
     MAXVALUE = 458,
     MINUTE_P = 459,
     MINVALUE = 460,
     MODE = 461,
     MONTH_P = 462,
     MOVE = 463,
     NAME_P = 464,
     NAMES = 465,
     NATIONAL = 466,
     NATURAL = 467,
     NCHAR = 468,
     NEW = 469,
     NEXT = 470,
     NO = 471,
     NOCREATEDB = 472,
     NOCREATEROLE = 473,
     NOCREATEUSER = 474,
     NOINHERIT = 475,
     NOLOGIN_P = 476,
     NONE = 477,
     NOSUPERUSER = 478,
     NOT = 479,
     NOTHING = 480,
     NOTIFY = 481,
     NOTNULL = 482,
     NOWAIT = 483,
     NULL_P = 484,
     NULLIF = 485,
     NULLS_P = 486,
     NUMERIC = 487,
     OBJECT_P = 488,
     OF = 489,
     OFF = 490,
     OFFSET = 491,
     OIDS = 492,
     OLD = 493,
     ON = 494,
     ONLY = 495,
     OPERATOR = 496,
     OPTION = 497,
     OPTIONS = 498,
     OR = 499,
     ORDER = 500,
     OUT_P = 501,
     OUTER_P = 502,
     OVER = 503,
     OVERLAPS = 504,
     OVERLAY = 505,
     OWNED = 506,
     OWNER = 507,
     PARSER = 508,
     PARTIAL = 509,
     PARTITION = 510,
     PASSWORD = 511,
     PLACING = 512,
     PLANS = 513,
     POSITION = 514,
     PRECEDING = 515,
     PRECISION = 516,
     PRESERVE = 517,
     PREPARE = 518,
     PREPARED = 519,
     PRIMARY = 520,
     PRIOR = 521,
     PRIVILEGES = 522,
     PROCEDURAL = 523,
     PROCEDURE = 524,
     QUOTE = 525,
     RANGE = 526,
     READ = 527,
     REAL = 528,
     REASSIGN = 529,
     RECHECK = 530,
     RECURSIVE = 531,
     REFERENCES = 532,
     REINDEX = 533,
     RELATIVE_P = 534,
     RELEASE = 535,
     RENAME = 536,
     REPEATABLE = 537,
     REPLACE = 538,
     REPLICA = 539,
     RESET = 540,
     RESTART = 541,
     RESTRICT = 542,
     RETURNING = 543,
     RETURNS = 544,
     REVOKE = 545,
     RIGHT = 546,
     ROLE = 547,
     ROLLBACK = 548,
     ROW = 549,
     ROWS = 550,
     RULE = 551,
     SAVEPOINT = 552,
     SCHEMA = 553,
     SCROLL = 554,
     SEARCH = 555,
     SECOND_P = 556,
     SECURITY = 557,
     SELECT = 558,
     SEQUENCE = 559,
     SERIALIZABLE = 560,
     SERVER = 561,
     SESSION = 562,
     SESSION_USER = 563,
     SET = 564,
     SETOF = 565,
     SHARE = 566,
     SHOW = 567,
     SIMILAR = 568,
     SIMPLE = 569,
     SMALLINT = 570,
     SOME = 571,
     STABLE = 572,
     STANDALONE_P = 573,
     START = 574,
     STATEMENT = 575,
     STATISTICS = 576,
     STDIN = 577,
     STDOUT = 578,
     STORAGE = 579,
     STRICT_P = 580,
     STRIP_P = 581,
     SUBSTRING = 582,
     SUPERUSER_P = 583,
     SYMMETRIC = 584,
     SYSID = 585,
     SYSTEM_P = 586,
     TABLE = 587,
     TABLESPACE = 588,
     TEMP = 589,
     TEMPLATE = 590,
     TEMPORARY = 591,
     TEXT_P = 592,
     THEN = 593,
     TIME = 594,
     TIMESTAMP = 595,
     TO = 596,
     TRAILING = 597,
     TRANSACTION = 598,
     TREAT = 599,
     TRIGGER = 600,
     TRIM = 601,
     TRUE_P = 602,
     TRUNCATE = 603,
     TRUSTED = 604,
     TYPE_P = 605,
     UNBOUNDED = 606,
     UNCOMMITTED = 607,
     UNENCRYPTED = 608,
     UNION = 609,
     UNIQUE = 610,
     UNKNOWN = 611,
     UNLISTEN = 612,
     UNTIL = 613,
     UPDATE = 614,
     USER = 615,
     USING = 616,
     VACUUM = 617,
     VALID = 618,
     VALIDATOR = 619,
     VALUE_P = 620,
     VALUES = 621,
     VARCHAR = 622,
     VARIADIC = 623,
     VARYING = 624,
     VERBOSE = 625,
     VERSION_P = 626,
     VIEW = 627,
     VOLATILE = 628,
     WHEN = 629,
     WHERE = 630,
     WHITESPACE_P = 631,
     WINDOW = 632,
     WITH = 633,
     WITHOUT = 634,
     WORK = 635,
     WRAPPER = 636,
     WRITE = 637,
     XML_P = 638,
     XMLATTRIBUTES = 639,
     XMLCONCAT = 640,
     XMLELEMENT = 641,
     XMLFOREST = 642,
     XMLPARSE = 643,
     XMLPI = 644,
     XMLROOT = 645,
     XMLSERIALIZE = 646,
     YEAR_P = 647,
     YES_P = 648,
     ZONE = 649,
     NULLS_FIRST = 650,
     NULLS_LAST = 651,
     WITH_TIME = 652,
     IDENT = 653,
     FCONST = 654,
     SCONST = 655,
     BCONST = 656,
     XCONST = 657,
     Op = 658,
     ICONST = 659,
     PARAM = 660,
     POSTFIXOP = 661,
     UMINUS = 662,
     TYPECAST = 663
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 149 "gram.y"

	int					ival;
	char				chr;
	char				*str;
	const char			*keyword;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;

	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	FuncWithArgs		*funwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;

	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;



/* Line 214 of yacc.c  */
#line 707 "gram.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 732 "gram.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  661
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   56268

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  426
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  480
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1997
/* YYNRULES -- Number of states.  */
#define YYNSTATES  3640

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   663

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   414,     2,     2,
     419,   420,   412,   410,   424,   411,   422,   413,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   425,   423,
     407,   406,   408,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   417,     2,   418,   415,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   409,   416,   421
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     9,    11,    13,    15,    17,    19,
      21,    23,    25,    27,    29,    31,    33,    35,    37,    39,
      41,    43,    45,    47,    49,    51,    53,    55,    57,    59,
      61,    63,    65,    67,    69,    71,    73,    75,    77,    79,
      81,    83,    85,    87,    89,    91,    93,    95,    97,    99,
     101,   103,   105,   107,   109,   111,   113,   115,   117,   119,
     121,   123,   125,   127,   129,   131,   133,   135,   137,   139,
     141,   143,   145,   147,   149,   151,   153,   155,   157,   159,
     161,   163,   165,   167,   169,   171,   173,   175,   177,   179,
     181,   183,   185,   187,   189,   191,   193,   195,   197,   199,
     201,   203,   205,   207,   209,   211,   213,   214,   220,   222,
     223,   226,   227,   230,   233,   237,   241,   243,   245,   247,
     249,   251,   253,   255,   257,   259,   261,   263,   265,   269,
     273,   276,   279,   282,   285,   289,   293,   299,   305,   310,
     316,   321,   325,   331,   335,   341,   347,   354,   356,   358,
     362,   368,   376,   382,   384,   385,   388,   389,   391,   393,
     395,   397,   399,   401,   404,   408,   412,   416,   420,   424,
     428,   432,   436,   439,   445,   448,   451,   454,   457,   461,
     465,   469,   471,   475,   477,   481,   483,   485,   487,   490,
     493,   496,   498,   500,   502,   504,   506,   508,   510,   514,
     521,   523,   525,   527,   529,   531,   532,   534,   536,   539,
     543,   548,   552,   555,   558,   560,   563,   567,   572,   576,
     579,   584,   586,   588,   590,   592,   594,   597,   600,   603,
     606,   611,   616,   621,   626,   628,   632,   636,   641,   648,
     655,   662,   669,   674,   682,   685,   690,   694,   698,   702,
     706,   710,   715,   720,   724,   728,   732,   736,   740,   744,
     749,   754,   758,   761,   765,   769,   773,   776,   779,   783,
     786,   788,   790,   791,   794,   795,   799,   802,   803,   805,
     809,   813,   815,   821,   825,   828,   831,   842,   849,   851,
     853,   855,   857,   859,   862,   863,   865,   867,   871,   875,
     877,   879,   883,   887,   891,   896,   898,   899,   902,   903,
     907,   908,   910,   911,   924,   938,   940,   942,   945,   948,
     951,   954,   955,   957,   958,   960,   964,   966,   968,   970,
     975,   978,   979,   983,   985,   987,   990,   992,   996,  1001,
    1006,  1009,  1015,  1017,  1020,  1023,  1026,  1030,  1033,  1034,
    1037,  1040,  1043,  1046,  1049,  1052,  1056,  1058,  1063,  1070,
    1078,  1090,  1094,  1095,  1097,  1101,  1103,  1106,  1109,  1112,
    1113,  1115,  1117,  1120,  1123,  1124,  1128,  1132,  1135,  1137,
    1139,  1142,  1145,  1150,  1151,  1154,  1157,  1160,  1161,  1165,
    1170,  1175,  1176,  1179,  1180,  1185,  1186,  1194,  1200,  1204,
    1205,  1207,  1211,  1213,  1216,  1220,  1221,  1228,  1233,  1235,
    1236,  1238,  1241,  1244,  1246,  1249,  1253,  1256,  1259,  1262,
    1265,  1269,  1273,  1275,  1279,  1281,  1282,  1284,  1287,  1289,
    1295,  1305,  1307,  1308,  1310,  1313,  1316,  1319,  1321,  1322,
    1325,  1326,  1332,  1340,  1342,  1343,  1350,  1353,  1354,  1358,
    1364,  1372,  1379,  1388,  1396,  1403,  1410,  1415,  1416,  1418,
    1422,  1427,  1429,  1433,  1435,  1438,  1441,  1444,  1447,  1449,
    1451,  1462,  1465,  1466,  1469,  1472,  1474,  1475,  1480,  1487,
    1493,  1498,  1503,  1512,  1514,  1516,  1518,  1526,  1536,  1545,
    1560,  1580,  1582,  1584,  1586,  1590,  1592,  1594,  1596,  1598,
    1602,  1603,  1605,  1606,  1608,  1610,  1612,  1616,  1617,  1619,
    1621,  1623,  1625,  1627,  1629,  1632,  1633,  1635,  1638,  1640,
    1643,  1644,  1647,  1649,  1652,  1655,  1662,  1671,  1680,  1685,
    1691,  1696,  1701,  1706,  1710,  1718,  1727,  1734,  1741,  1748,
    1755,  1759,  1761,  1765,  1769,  1771,  1773,  1775,  1777,  1779,
    1781,  1785,  1789,  1793,  1795,  1799,  1803,  1805,  1809,  1823,
    1825,  1829,  1834,  1840,  1845,  1853,  1856,  1858,  1859,  1862,
    1863,  1865,  1866,  1873,  1882,  1891,  1893,  1897,  1903,  1909,
    1917,  1927,  1935,  1945,  1951,  1958,  1965,  1970,  1972,  1974,
    1976,  1978,  1980,  1982,  1984,  1986,  1990,  1994,  1998,  2002,
    2004,  2008,  2010,  2013,  2016,  2020,  2026,  2029,  2032,  2033,
    2040,  2048,  2056,  2064,  2073,  2082,  2089,  2098,  2108,  2118,
    2126,  2137,  2145,  2154,  2163,  2172,  2181,  2183,  2185,  2187,
    2189,  2191,  2193,  2195,  2197,  2199,  2201,  2203,  2205,  2207,
    2209,  2214,  2217,  2222,  2225,  2226,  2228,  2230,  2232,  2234,
    2237,  2240,  2242,  2244,  2246,  2249,  2252,  2254,  2257,  2260,
    2262,  2264,  2272,  2280,  2291,  2293,  2295,  2298,  2303,  2309,
    2311,  2315,  2318,  2321,  2324,  2327,  2329,  2332,  2335,  2340,
    2344,  2347,  2350,  2353,  2356,  2359,  2361,  2365,  2367,  2370,
    2374,  2375,  2377,  2381,  2384,  2391,  2398,  2408,  2412,  2413,
    2417,  2418,  2432,  2447,  2449,  2450,  2453,  2454,  2456,  2460,
    2465,  2470,  2477,  2479,  2482,  2483,  2485,  2487,  2488,  2490,
    2492,  2493,  2503,  2516,  2524,  2527,  2528,  2532,  2535,  2537,
    2541,  2545,  2548,  2550,  2554,  2558,  2562,  2565,  2568,  2570,
    2572,  2574,  2576,  2579,  2581,  2583,  2585,  2587,  2592,  2598,
    2600,  2604,  2608,  2610,  2613,  2618,  2624,  2626,  2628,  2630,
    2632,  2636,  2640,  2643,  2646,  2649,  2652,  2654,  2657,  2660,
    2662,  2664,  2666,  2668,  2672,  2675,  2676,  2679,  2681,  2685,
    2691,  2693,  2696,  2698,  2699,  2705,  2713,  2719,  2727,  2733,
    2741,  2745,  2751,  2757,  2763,  2765,  2769,  2781,  2792,  2803,
    2806,  2809,  2810,  2820,  2823,  2824,  2829,  2834,  2839,  2841,
    2843,  2845,  2846,  2854,  2861,  2868,  2875,  2882,  2890,  2900,
    2910,  2917,  2924,  2931,  2938,  2945,  2954,  2963,  2970,  2977,
    2984,  2993,  3002,  3011,  3020,  3027,  3029,  3030,  3033,  3034,
    3042,  3049,  3056,  3063,  3070,  3077,  3084,  3092,  3099,  3106,
    3113,  3120,  3128,  3136,  3146,  3156,  3163,  3170,  3177,  3186,
    3195,  3204,  3211,  3216,  3221,  3226,  3234,  3239,  3244,  3246,
    3247,  3251,  3252,  3267,  3269,  3271,  3275,  3279,  3281,  3283,
    3285,  3287,  3289,  3291,  3293,  3294,  3296,  3298,  3300,  3302,
    3304,  3306,  3307,  3314,  3323,  3326,  3329,  3332,  3335,  3338,
    3342,  3346,  3349,  3352,  3355,  3358,  3362,  3365,  3371,  3376,
    3380,  3384,  3388,  3390,  3392,  3393,  3397,  3400,  3403,  3405,
    3409,  3412,  3414,  3415,  3424,  3435,  3439,  3444,  3449,  3450,
    3453,  3459,  3462,  3463,  3467,  3471,  3475,  3479,  3483,  3487,
    3491,  3495,  3499,  3503,  3507,  3511,  3515,  3520,  3524,  3528,
    3530,  3532,  3533,  3539,  3546,  3551,  3554,  3555,  3560,  3564,
    3570,  3577,  3582,  3589,  3596,  3602,  3610,  3612,  3613,  3620,
    3632,  3644,  3656,  3670,  3680,  3692,  3703,  3708,  3711,  3717,
    3720,  3721,  3726,  3732,  3738,  3741,  3746,  3748,  3750,  3752,
    3753,  3755,  3756,  3758,  3759,  3763,  3764,  3769,  3771,  3773,
    3775,  3777,  3779,  3781,  3783,  3785,  3786,  3792,  3796,  3797,
    3799,  3801,  3803,  3805,  3809,  3818,  3822,  3823,  3826,  3830,
    3833,  3837,  3843,  3845,  3850,  3853,  3855,  3859,  3862,  3865,
    3866,  3873,  3876,  3877,  3883,  3887,  3888,  3891,  3894,  3897,
    3901,  3903,  3907,  3909,  3912,  3914,  3915,  3923,  3925,  3929,
    3931,  3933,  3937,  3943,  3946,  3948,  3952,  3960,  3961,  3965,
    3968,  3971,  3974,  3975,  3978,  3981,  3983,  3985,  3989,  3993,
    3995,  3998,  4003,  4008,  4011,  4015,  4021,  4027,  4029,  4031,
    4041,  4043,  4046,  4051,  4056,  4061,  4064,  4068,  4070,  4074,
    4079,  4082,  4083,  4087,  4091,  4096,  4101,  4106,  4111,  4114,
    4116,  4118,  4119,  4121,  4123,  4124,  4126,  4132,  4134,  4135,
    4137,  4138,  4142,  4144,  4148,  4153,  4157,  4162,  4167,  4170,
    4173,  4178,  4182,  4188,  4197,  4199,  4200,  4202,  4204,  4206,
    4210,  4211,  4213,  4215,  4217,  4219,  4221,  4223,  4227,  4228,
    4231,  4232,  4234,  4238,  4240,  4241,  4243,  4246,  4251,  4256,
    4259,  4260,  4263,  4267,  4270,  4271,  4273,  4277,  4279,  4282,
    4284,  4287,  4293,  4300,  4306,  4308,  4311,  4313,  4318,  4322,
    4327,  4333,  4338,  4344,  4349,  4355,  4358,  4363,  4365,  4368,
    4371,  4374,  4376,  4378,  4379,  4384,  4387,  4389,  4392,  4395,
    4400,  4402,  4406,  4408,  4411,  4415,  4417,  4420,  4421,  4424,
    4429,  4434,  4435,  4437,  4441,  4444,  4447,  4451,  4457,  4464,
    4467,  4471,  4475,  4480,  4481,  4483,  4485,  4487,  4489,  4491,
    4494,  4500,  4502,  4504,  4506,  4508,  4511,  4515,  4519,  4520,
    4522,  4524,  4526,  4528,  4530,  4533,  4536,  4539,  4542,  4545,
    4547,  4551,  4552,  4554,  4556,  4558,  4560,  4566,  4569,  4571,
    4573,  4575,  4577,  4583,  4586,  4589,  4592,  4594,  4598,  4602,
    4605,  4607,  4608,  4612,  4613,  4619,  4622,  4628,  4631,  4633,
    4636,  4640,  4641,  4643,  4645,  4647,  4649,  4651,  4653,  4657,
    4661,  4665,  4669,  4673,  4677,  4681,  4682,  4684,  4689,  4691,
    4695,  4701,  4704,  4707,  4711,  4715,  4719,  4723,  4727,  4731,
    4735,  4739,  4743,  4747,  4750,  4753,  4757,  4761,  4764,  4768,
    4774,  4779,  4786,  4790,  4796,  4801,  4808,  4813,  4820,  4826,
    4834,  4838,  4841,  4846,  4849,  4853,  4857,  4862,  4866,  4871,
    4875,  4880,  4886,  4893,  4900,  4908,  4915,  4923,  4930,  4938,
    4942,  4947,  4952,  4959,  4962,  4966,  4971,  4973,  4977,  4980,
    4983,  4987,  4991,  4995,  4999,  5003,  5007,  5011,  5015,  5019,
    5023,  5026,  5029,  5035,  5042,  5049,  5057,  5061,  5066,  5068,
    5070,  5073,  5078,  5080,  5082,  5084,  5087,  5090,  5093,  5095,
    5100,  5106,  5113,  5122,  5129,  5136,  5142,  5144,  5146,  5151,
    5153,  5158,  5160,  5165,  5167,  5172,  5174,  5176,  5178,  5180,
    5182,  5184,  5191,  5196,  5201,  5206,  5211,  5218,  5224,  5230,
    5236,  5241,  5248,  5253,  5258,  5263,  5268,  5274,  5282,  5290,
    5300,  5305,  5312,  5318,  5326,  5334,  5342,  5345,  5349,  5353,
    5357,  5362,  5363,  5368,  5370,  5374,  5378,  5380,  5382,  5384,
    5387,  5390,  5391,  5394,  5395,  5397,  5401,  5405,  5408,  5411,
    5412,  5419,  5421,  5422,  5426,  5427,  5430,  5433,  5434,  5436,
    5441,  5444,  5447,  5450,  5455,  5459,  5465,  5467,  5469,  5471,
    5473,  5475,  5477,  5479,  5481,  5483,  5485,  5487,  5489,  5491,
    5493,  5495,  5500,  5502,  5507,  5509,  5514,  5516,  5519,  5521,
    5524,  5526,  5530,  5532,  5536,  5540,  5544,  5547,  5549,  5553,
    5557,  5558,  5560,  5562,  5564,  5566,  5568,  5570,  5572,  5574,
    5579,  5583,  5586,  5590,  5591,  5595,  5599,  5602,  5605,  5607,
    5608,  5611,  5614,  5618,  5621,  5623,  5625,  5629,  5635,  5637,
    5640,  5645,  5648,  5649,  5651,  5652,  5654,  5657,  5660,  5663,
    5667,  5673,  5675,  5678,  5679,  5682,  5684,  5685,  5687,  5689,
    5691,  5695,  5699,  5701,  5705,  5709,  5712,  5714,  5716,  5718,
    5720,  5722,  5726,  5728,  5731,  5733,  5737,  5739,  5741,  5743,
    5745,  5747,  5749,  5751,  5754,  5756,  5758,  5760,  5762,  5764,
    5767,  5773,  5776,  5780,  5787,  5789,  5791,  5793,  5795,  5797,
    5799,  5801,  5804,  5807,  5809,  5811,  5813,  5815,  5817,  5819,
    5821,  5823,  5825,  5827,  5829,  5831,  5833,  5835,  5837,  5839,
    5841,  5843,  5845,  5847,  5849,  5851,  5853,  5855,  5857,  5859,
    5861,  5863,  5865,  5867,  5869,  5871,  5873,  5875,  5877,  5879,
    5881,  5883,  5885,  5887,  5889,  5891,  5893,  5895,  5897,  5899,
    5901,  5903,  5905,  5907,  5909,  5911,  5913,  5915,  5917,  5919,
    5921,  5923,  5925,  5927,  5929,  5931,  5933,  5935,  5937,  5939,
    5941,  5943,  5945,  5947,  5949,  5951,  5953,  5955,  5957,  5959,
    5961,  5963,  5965,  5967,  5969,  5971,  5973,  5975,  5977,  5979,
    5981,  5983,  5985,  5987,  5989,  5991,  5993,  5995,  5997,  5999,
    6001,  6003,  6005,  6007,  6009,  6011,  6013,  6015,  6017,  6019,
    6021,  6023,  6025,  6027,  6029,  6031,  6033,  6035,  6037,  6039,
    6041,  6043,  6045,  6047,  6049,  6051,  6053,  6055,  6057,  6059,
    6061,  6063,  6065,  6067,  6069,  6071,  6073,  6075,  6077,  6079,
    6081,  6083,  6085,  6087,  6089,  6091,  6093,  6095,  6097,  6099,
    6101,  6103,  6105,  6107,  6109,  6111,  6113,  6115,  6117,  6119,
    6121,  6123,  6125,  6127,  6129,  6131,  6133,  6135,  6137,  6139,
    6141,  6143,  6145,  6147,  6149,  6151,  6153,  6155,  6157,  6159,
    6161,  6163,  6165,  6167,  6169,  6171,  6173,  6175,  6177,  6179,
    6181,  6183,  6185,  6187,  6189,  6191,  6193,  6195,  6197,  6199,
    6201,  6203,  6205,  6207,  6209,  6211,  6213,  6215,  6217,  6219,
    6221,  6223,  6225,  6227,  6229,  6231,  6233,  6235,  6237,  6239,
    6241,  6243,  6245,  6247,  6249,  6251,  6253,  6255,  6257,  6259,
    6261,  6263,  6265,  6267,  6269,  6271,  6273,  6275,  6277,  6279,
    6281,  6283,  6285,  6287,  6289,  6291,  6293,  6295,  6297,  6299,
    6301,  6303,  6305,  6307,  6309,  6311,  6313,  6315,  6317,  6319,
    6321,  6323,  6325,  6327,  6329,  6331,  6333,  6335,  6337,  6339,
    6341,  6343,  6345,  6347,  6349,  6351,  6353,  6355,  6357,  6359,
    6361,  6363,  6365,  6367,  6369,  6371,  6373,  6375,  6377,  6379,
    6381,  6383,  6385,  6387,  6389,  6391,  6393,  6395,  6397,  6399,
    6401,  6403,  6405,  6407,  6409,  6411,  6413,  6415,  6417,  6419,
    6421,  6423,  6425,  6427,  6429,  6431,  6433,  6435,  6437,  6439,
    6441,  6443,  6445,  6447,  6449,  6451,  6453,  6455,  6457,  6459,
    6461,  6463,  6465,  6467,  6469,  6471,  6473,  6475,  6477,  6479,
    6481,  6483,  6485,  6487,  6489,  6491,  6493,  6495,  6497,  6499,
    6501,  6503,  6505,  6507,  6509,  6511,  6513,  6515,  6517,  6519,
    6521,  6523,  6525,  6527,  6529,  6531,  6533,  6535,  6537,  6539,
    6541,  6543,  6545,  6547,  6549,  6551,  6553,  6555,  6557,  6559,
    6561,  6563,  6565,  6567,  6569,  6571,  6573,  6575,  6577,  6579,
    6581,  6583,  6585,  6587,  6589,  6591,  6593,  6595,  6597,  6599,
    6601,  6603,  6605,  6607,  6609,  6611,  6613,  6615
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     427,     0,    -1,   428,    -1,   428,   423,   429,    -1,   429,
      -1,   702,    -1,   703,    -1,   708,    -1,   541,    -1,   555,
      -1,   655,    -1,   442,    -1,   673,    -1,   674,    -1,   675,
      -1,   522,    -1,   467,    -1,   436,    -1,   435,    -1,   711,
      -1,   710,    -1,   559,    -1,   438,    -1,   437,    -1,   716,
      -1,   465,    -1,   477,    -1,   713,    -1,   607,    -1,   462,
      -1,   478,    -1,   515,    -1,   574,    -1,   663,    -1,   712,
      -1,   707,    -1,   539,    -1,   550,    -1,   636,    -1,   441,
      -1,   586,    -1,   592,    -1,   593,    -1,   528,    -1,   445,
      -1,   521,    -1,   487,    -1,   536,    -1,   560,    -1,   430,
      -1,   434,    -1,   556,    -1,   698,    -1,   730,    -1,   749,
      -1,   576,    -1,   736,    -1,   466,    -1,   575,    -1,   665,
      -1,   540,    -1,   554,    -1,   444,    -1,   596,    -1,   597,
      -1,   598,    -1,   534,    -1,   686,    -1,   600,    -1,   538,
      -1,   573,    -1,   439,    -1,   440,    -1,   558,    -1,   706,
      -1,   728,    -1,   722,    -1,   610,    -1,   613,    -1,   624,
      -1,   628,    -1,   731,    -1,   688,    -1,   697,    -1,   738,
      -1,   687,    -1,   725,    -1,   599,    -1,   667,    -1,   659,
      -1,   658,    -1,   660,    -1,   670,    -1,   614,    -1,   625,
      -1,   678,    -1,   752,    -1,   690,    -1,   605,    -1,   689,
      -1,   742,    -1,   715,    -1,   459,    -1,   449,    -1,   461,
      -1,   695,    -1,    -1,    69,   292,   896,   431,   432,    -1,
     378,    -1,    -1,   432,   433,    -1,    -1,   256,   895,    -1,
     256,   229,    -1,   114,   256,   895,    -1,   353,   256,   895,
      -1,   328,    -1,   223,    -1,   161,    -1,   220,    -1,    70,
      -1,   217,    -1,    71,    -1,   218,    -1,    72,    -1,   219,
      -1,   200,    -1,   221,    -1,    61,   192,   897,    -1,   363,
     358,   895,    -1,   360,   885,    -1,   330,   894,    -1,     8,
     885,    -1,   292,   885,    -1,   156,   292,   885,    -1,   156,
     144,   885,    -1,    69,   360,   896,   431,   432,    -1,    13,
     292,   896,   431,   432,    -1,    13,   292,   896,   460,    -1,
      13,   360,   896,   431,   432,    -1,    13,   360,   896,   460,
      -1,   109,   292,   885,    -1,   109,   292,   151,   122,   885,
      -1,   109,   360,   885,    -1,   109,   360,   151,   122,   885,
      -1,    69,   144,   896,   431,   432,    -1,    13,   144,   896,
     443,   360,   885,    -1,     7,    -1,   109,    -1,   109,   144,
     885,    -1,   109,   144,   151,   122,   885,    -1,    69,   298,
     446,    26,   896,   676,   447,    -1,    69,   298,   898,   676,
     447,    -1,   898,    -1,    -1,   447,   448,    -1,    -1,   487,
      -1,   628,    -1,   521,    -1,   560,    -1,   613,    -1,   695,
      -1,   309,   450,    -1,   309,   195,   450,    -1,   309,   307,
     450,    -1,   451,   341,   452,    -1,   451,   406,   452,    -1,
     451,   341,    92,    -1,   451,   406,    92,    -1,   451,   137,
      75,    -1,   339,   394,   456,    -1,   343,   693,    -1,   307,
      47,    20,   343,   693,    -1,    43,   895,    -1,   298,   895,
      -1,   210,   457,    -1,   292,   458,    -1,   307,    26,   458,
      -1,   307,    26,    92,    -1,   383,   242,   834,    -1,   898,
      -1,   451,   422,   898,    -1,   453,    -1,   452,   424,   453,
      -1,   455,    -1,   458,    -1,   527,    -1,   272,   352,    -1,
     272,    58,    -1,   282,   272,    -1,   305,    -1,   347,    -1,
     126,    -1,   239,    -1,   235,    -1,   895,    -1,   398,    -1,
     821,   895,   823,    -1,   821,   419,   894,   420,   895,   823,
      -1,   527,    -1,    92,    -1,   195,    -1,   895,    -1,    92,
      -1,    -1,   898,    -1,   895,    -1,   285,   451,    -1,   285,
     339,   394,    -1,   285,   343,   178,   190,    -1,   285,   307,
      26,    -1,   285,    11,    -1,   309,   450,    -1,   459,    -1,
     312,   451,    -1,   312,   339,   394,    -1,   312,   343,   178,
     190,    -1,   312,   307,    26,    -1,   312,    11,    -1,   309,
      63,   463,   464,    -1,    11,    -1,   883,    -1,    95,    -1,
     153,    -1,    49,    -1,   103,    11,    -1,   103,   334,    -1,
     103,   336,    -1,   103,   258,    -1,    13,   332,   793,   468,
      -1,    13,   159,   884,   468,    -1,    13,   304,   884,   468,
      -1,    13,   372,   884,   468,    -1,   469,    -1,   468,   424,
     469,    -1,     7,   671,   492,    -1,    13,   671,   898,   470,
      -1,    13,   671,   898,   109,   224,   229,    -1,    13,   671,
     898,   309,   224,   229,    -1,    13,   671,   898,   309,   321,
     897,    -1,    13,   671,   898,   309,   324,   898,    -1,   109,
     671,   898,   471,    -1,    13,   671,   898,   672,   350,   801,
     472,    -1,     7,   500,    -1,   109,    62,   886,   471,    -1,
     309,   378,   237,    -1,   309,   379,   237,    -1,    52,   239,
     886,    -1,   309,   379,    52,    -1,   112,   345,   886,    -1,
     112,    14,   345,   886,    -1,   112,   284,   345,   886,    -1,
     112,   345,    11,    -1,   112,   345,   360,    -1,   102,   345,
     886,    -1,   102,   345,    11,    -1,   102,   345,   360,    -1,
     112,   296,   886,    -1,   112,    14,   296,   886,    -1,   112,
     284,   296,   886,    -1,   102,   296,   886,    -1,   161,   884,
      -1,   216,   161,   884,    -1,   252,   341,   896,    -1,   309,
     333,   886,    -1,   309,   473,    -1,   285,   473,    -1,   309,
      92,   825,    -1,   109,    92,    -1,    39,    -1,   287,    -1,
      -1,   361,   825,    -1,    -1,   419,   475,   420,    -1,   378,
     473,    -1,    -1,   476,    -1,   475,   424,   476,    -1,   900,
     406,   580,    -1,   900,    -1,   900,   422,   900,   406,   580,
      -1,   900,   422,   900,    -1,    51,   886,    -1,    51,    11,
      -1,    67,   483,   884,   502,   484,   479,   480,   485,   431,
     481,    -1,    67,   753,   341,   480,   431,   481,    -1,   137,
      -1,   341,    -1,   895,    -1,   322,    -1,   323,    -1,   481,
     482,    -1,    -1,    32,    -1,   237,    -1,    98,   709,   895,
      -1,   229,   709,   895,    -1,    74,    -1,   147,    -1,   270,
     709,   895,    -1,   117,   709,   895,    -1,   133,   270,   503,
      -1,   133,   224,   229,   503,    -1,    32,    -1,    -1,   378,
     237,    -1,    -1,   486,    99,   895,    -1,    -1,   361,    -1,
      -1,    69,   488,   332,   884,   419,   489,   420,   510,   511,
     512,   513,   676,    -1,    69,   488,   332,   884,   234,   884,
     419,   489,   420,   511,   512,   513,   676,    -1,   336,    -1,
     334,    -1,   195,   336,    -1,   195,   334,    -1,   140,   336,
      -1,   140,   334,    -1,    -1,   490,    -1,    -1,   491,    -1,
     490,   424,   491,    -1,   492,    -1,   497,    -1,   500,    -1,
     898,   801,   493,   676,    -1,   493,   494,    -1,    -1,    62,
     886,   495,    -1,   495,    -1,   496,    -1,   224,   229,    -1,
     229,    -1,   355,   652,   514,    -1,   265,   180,   652,   514,
      -1,    48,   419,   825,   420,    -1,    92,   826,    -1,   277,
     884,   502,   505,   506,    -1,    94,    -1,   224,    94,    -1,
     163,    95,    -1,   163,   153,    -1,   191,   884,   498,    -1,
     498,   499,    -1,    -1,   157,    93,    -1,   119,    93,    -1,
     157,    63,    -1,   119,    63,    -1,   157,   160,    -1,   119,
     160,    -1,    62,   886,   501,    -1,   501,    -1,    48,   419,
     825,   420,    -1,   355,   419,   503,   420,   652,   514,    -1,
     265,   180,   419,   503,   420,   652,   514,    -1,   134,   180,
     419,   503,   420,   277,   884,   502,   505,   506,   570,    -1,
     419,   503,   420,    -1,    -1,   504,    -1,   503,   424,   504,
      -1,   898,    -1,   202,   138,    -1,   202,   254,    -1,   202,
     314,    -1,    -1,   507,    -1,   508,    -1,   507,   508,    -1,
     508,   507,    -1,    -1,   239,   359,   509,    -1,   239,    97,
     509,    -1,   216,     6,    -1,   287,    -1,    39,    -1,   309,
     229,    -1,   309,    92,    -1,   162,   419,   883,   420,    -1,
      -1,   378,   473,    -1,   378,   237,    -1,   379,   237,    -1,
      -1,   239,    57,   109,    -1,   239,    57,    97,   295,    -1,
     239,    57,   262,   295,    -1,    -1,   333,   886,    -1,    -1,
     361,   159,   333,   886,    -1,    -1,    69,   488,   332,   516,
      20,   752,   520,    -1,   884,   517,   511,   512,   513,    -1,
     419,   518,   420,    -1,    -1,   519,    -1,   518,   424,   519,
      -1,   898,    -1,   378,    85,    -1,   378,   216,    85,    -1,
      -1,    69,   488,   304,   884,   523,   676,    -1,    13,   304,
     884,   524,    -1,   524,    -1,    -1,   525,    -1,   524,   525,
      -1,    37,   527,    -1,    84,    -1,   216,    84,    -1,   158,
     526,   527,    -1,   203,   527,    -1,   205,   527,    -1,   216,
     203,    -1,   216,   205,    -1,   251,    36,   603,    -1,   319,
     431,   527,    -1,   286,    -1,   286,   431,   527,    -1,    36,
      -1,    -1,   399,    -1,   411,   399,    -1,   897,    -1,    69,
     529,   535,   182,   458,    -1,    69,   529,   535,   182,   458,
     145,   530,   532,   533,    -1,   349,    -1,    -1,   886,    -1,
     886,   604,    -1,   364,   530,    -1,   216,   364,    -1,   531,
      -1,    -1,   181,   895,    -1,    -1,   109,   535,   182,   458,
     471,    -1,   109,   535,   182,   151,   122,   458,   471,    -1,
     268,    -1,    -1,    69,   333,   886,   537,   198,   895,    -1,
     252,   886,    -1,    -1,   109,   333,   886,    -1,   109,   333,
     151,   122,   886,    -1,    69,   134,    85,   381,   886,   532,
     542,    -1,   109,   134,    85,   381,   886,   471,    -1,   109,
     134,    85,   381,   151,   122,   886,   471,    -1,    13,   134,
      85,   381,   886,   531,   544,    -1,    13,   134,    85,   381,
     886,   531,    -1,    13,   134,    85,   381,   886,   544,    -1,
     243,   419,   543,   420,    -1,    -1,   547,    -1,   543,   424,
     547,    -1,   243,   419,   545,   420,    -1,   546,    -1,   545,
     424,   546,    -1,   547,    -1,   309,   547,    -1,     7,   547,
      -1,   109,   548,    -1,   548,   549,    -1,   900,    -1,   895,
      -1,    69,   306,   886,   551,   553,   134,    85,   381,   886,
     542,    -1,   350,   895,    -1,    -1,   371,   895,    -1,   371,
     229,    -1,   552,    -1,    -1,   109,   306,   886,   471,    -1,
     109,   306,   151,   122,   886,   471,    -1,    13,   306,   886,
     552,   544,    -1,    13,   306,   886,   552,    -1,    13,   306,
     886,   544,    -1,    69,   360,   201,   132,   557,   306,   886,
     542,    -1,    82,    -1,   360,    -1,   896,    -1,   109,   360,
     201,   132,   557,   306,   886,    -1,   109,   360,   201,   151,
     122,   132,   557,   306,   886,    -1,    13,   360,   201,   132,
     557,   306,   886,   544,    -1,    69,   345,   886,   561,   562,
     239,   884,   564,   121,   269,   892,   419,   567,   420,    -1,
      69,    62,   345,   886,     9,   562,   239,   884,   569,   570,
     132,   110,   294,   121,   269,   892,   419,   567,   420,    -1,
      28,    -1,     9,    -1,   563,    -1,   562,   244,   563,    -1,
     168,    -1,    97,    -1,   359,    -1,   348,    -1,   132,   565,
     566,    -1,    -1,   110,    -1,    -1,   294,    -1,   320,    -1,
     568,    -1,   567,   424,   568,    -1,    -1,   894,    -1,   399,
      -1,   895,    -1,   401,    -1,   402,    -1,   898,    -1,   137,
     884,    -1,    -1,   571,    -1,   571,   572,    -1,   572,    -1,
     572,   571,    -1,    -1,   224,    94,    -1,    94,    -1,   163,
     153,    -1,   163,    95,    -1,   109,   345,   886,   239,   884,
     471,    -1,   109,   345,   151,   122,   886,   239,   884,   471,
      -1,    69,    22,   886,    48,   419,   825,   420,   570,    -1,
     109,    22,   886,   471,    -1,    69,    10,   892,   581,   577,
      -1,    69,    10,   892,   582,    -1,    69,   241,   662,   577,
      -1,    69,   350,   603,   577,    -1,    69,   350,   603,    -1,
      69,   350,   603,    20,   419,   799,   420,    -1,    69,   350,
     603,    20,   116,   419,   585,   420,    -1,    69,   337,   300,
     253,   603,   577,    -1,    69,   337,   300,   101,   603,   577,
      -1,    69,   337,   300,   335,   603,   577,    -1,    69,   337,
     300,    60,   603,   577,    -1,   419,   578,   420,    -1,   579,
      -1,   578,   424,   579,    -1,   900,   406,   580,    -1,   900,
      -1,   646,    -1,   904,    -1,   851,    -1,   527,    -1,   895,
      -1,   419,   854,   420,    -1,   419,   412,   420,    -1,   419,
     583,   420,    -1,   584,    -1,   583,   424,   584,    -1,   398,
     406,   580,    -1,   895,    -1,   585,   424,   895,    -1,    69,
     241,    50,   603,   589,   132,   350,   801,   361,   888,   590,
      20,   587,    -1,   588,    -1,   587,   424,   588,    -1,   241,
     894,   662,   591,    -1,   241,   894,   662,   661,   591,    -1,
     139,   894,   892,   638,    -1,   139,   894,   419,   854,   420,
     892,   638,    -1,   324,   801,    -1,    92,    -1,    -1,   127,
     603,    -1,    -1,   275,    -1,    -1,    69,   241,   127,   603,
     361,   888,    -1,    13,   241,   127,   603,   361,   888,     7,
     587,    -1,    13,   241,   127,   603,   361,   888,   109,   594,
      -1,   595,    -1,   594,   424,   595,    -1,   241,   894,   419,
     854,   420,    -1,   139,   894,   419,   854,   420,    -1,   109,
     241,    50,   603,   361,   888,   471,    -1,   109,   241,    50,
     151,   122,   603,   361,   888,   471,    -1,   109,   241,   127,
     603,   361,   888,   471,    -1,   109,   241,   127,   151,   122,
     603,   361,   888,   471,    -1,   109,   251,    36,   885,   471,
      -1,   274,   251,    36,   885,   341,   886,    -1,   109,   601,
     151,   122,   602,   471,    -1,   109,   601,   602,   471,    -1,
     332,    -1,   304,    -1,   372,    -1,   159,    -1,   350,    -1,
     107,    -1,    66,    -1,   298,    -1,   337,   300,   253,    -1,
     337,   300,   101,    -1,   337,   300,   335,    -1,   337,   300,
      60,    -1,   603,    -1,   602,   424,   603,    -1,   898,    -1,
     898,   604,    -1,   422,   889,    -1,   604,   422,   889,    -1,
     348,   762,   794,   606,   471,    -1,    65,   150,    -1,   286,
     150,    -1,    -1,    56,   239,   608,   603,   176,   609,    -1,
      56,   239,    10,   892,   581,   176,   609,    -1,    56,   239,
     139,   892,   638,   176,   609,    -1,    56,   239,   241,   662,
     661,   176,   609,    -1,    56,   239,    62,   886,   239,   603,
     176,   609,    -1,    56,   239,   296,   886,   239,   603,   176,
     609,    -1,    56,   239,   296,   886,   176,   609,    -1,    56,
     239,   345,   886,   239,   603,   176,   609,    -1,    56,   239,
     241,    50,   603,   361,   888,   176,   609,    -1,    56,   239,
     241,   127,   603,   361,   888,   176,   609,    -1,    56,   239,
     183,   233,   527,   176,   609,    -1,    56,   239,    42,   419,
     801,    20,   801,   420,   176,   609,    -1,    56,   239,   535,
     182,   603,   176,   609,    -1,    56,   239,   337,   300,   253,
     603,   176,   609,    -1,    56,   239,   337,   300,   101,   603,
     176,   609,    -1,    56,   239,   337,   300,   335,   603,   176,
     609,    -1,    56,   239,   337,   300,    60,   603,   176,   609,
      -1,    55,    -1,    86,    -1,   298,    -1,   159,    -1,   304,
      -1,   332,    -1,   107,    -1,   350,    -1,   372,    -1,    66,
      -1,   333,    -1,   292,    -1,   895,    -1,   229,    -1,   128,
     611,   612,   886,    -1,   128,   886,    -1,   208,   611,   612,
     886,    -1,   208,   886,    -1,    -1,   215,    -1,   266,    -1,
     129,    -1,   184,    -1,     4,   897,    -1,   279,   897,    -1,
     897,    -1,    11,    -1,   135,    -1,   135,   897,    -1,   135,
      11,    -1,    27,    -1,    27,   897,    -1,    27,    11,    -1,
     137,    -1,   156,    -1,   141,   615,   239,   618,   341,   619,
     621,    -1,   290,   615,   239,   618,   137,   619,   471,    -1,
     290,   141,   242,   132,   615,   239,   618,   137,   619,   471,
      -1,   616,    -1,    11,    -1,    11,   267,    -1,    11,   419,
     503,   420,    -1,    11,   267,   419,   503,   420,    -1,   617,
      -1,   616,   424,   617,    -1,   303,   502,    -1,   277,   502,
      -1,    69,   502,    -1,   898,   502,    -1,   883,    -1,   332,
     883,    -1,   304,   883,    -1,   134,    85,   381,   885,    -1,
     134,   306,   885,    -1,   139,   622,    -1,    86,   885,    -1,
     182,   885,    -1,   298,   885,    -1,   333,   885,    -1,   620,
      -1,   619,   424,   620,    -1,   896,    -1,   144,   896,    -1,
     378,   141,   242,    -1,    -1,   623,    -1,   622,   424,   623,
      -1,   892,   638,    -1,   141,   616,   341,   885,   626,   627,
      -1,   290,   616,   137,   885,   627,   471,    -1,   290,     8,
     242,   132,   616,   137,   885,   627,   471,    -1,   378,     8,
     242,    -1,    -1,   142,    36,   896,    -1,    -1,    69,   629,
     159,   890,   239,   884,   630,   419,   631,   420,   474,   513,
     797,    -1,    69,   629,   159,    59,   890,   239,   884,   630,
     419,   631,   420,   474,   513,   797,    -1,   355,    -1,    -1,
     361,   888,    -1,    -1,   632,    -1,   631,   424,   632,    -1,
     898,   633,   634,   635,    -1,   828,   633,   634,   635,    -1,
     419,   825,   420,   633,   634,   635,    -1,   603,    -1,   361,
     603,    -1,    -1,    21,    -1,   100,    -1,    -1,   395,    -1,
     396,    -1,    -1,    69,   637,   139,   892,   640,   289,   645,
     648,   652,    -1,    69,   637,   139,   892,   640,   289,   332,
     419,   654,   420,   648,   652,    -1,    69,   637,   139,   892,
     640,   648,   652,    -1,   244,   283,    -1,    -1,   419,   639,
     420,    -1,   419,   420,    -1,   642,    -1,   639,   424,   642,
      -1,   419,   641,   420,    -1,   419,   420,    -1,   647,    -1,
     641,   424,   647,    -1,   643,   644,   646,    -1,   644,   643,
     646,    -1,   644,   646,    -1,   643,   646,    -1,   646,    -1,
     156,    -1,   246,    -1,   165,    -1,   156,   246,    -1,   368,
      -1,   899,    -1,   646,    -1,   801,    -1,   899,   604,   414,
     350,    -1,   310,   899,   604,   414,   350,    -1,   642,    -1,
     642,    92,   825,    -1,   642,   406,   825,    -1,   650,    -1,
     648,   650,    -1,    38,   239,   229,   166,    -1,   289,   229,
     239,   229,   166,    -1,   325,    -1,   154,    -1,   317,    -1,
     373,    -1,   124,   302,    96,    -1,   124,   302,   175,    -1,
     302,    96,    -1,   302,   175,    -1,    68,   527,    -1,   295,
     527,    -1,   460,    -1,    20,   651,    -1,   182,   458,    -1,
     377,    -1,   677,    -1,   649,    -1,   895,    -1,   895,   424,
     895,    -1,   378,   577,    -1,    -1,   644,   646,    -1,   653,
      -1,   654,   424,   653,    -1,    13,   139,   623,   656,   657,
      -1,   649,    -1,   656,   649,    -1,   287,    -1,    -1,   109,
     139,   892,   638,   471,    -1,   109,   139,   151,   122,   892,
     638,   471,    -1,   109,    10,   892,   581,   471,    -1,   109,
      10,   151,   122,   892,   581,   471,    -1,   109,   241,   662,
     661,   471,    -1,   109,   241,   151,   122,   662,   661,   471,
      -1,   419,   801,   420,    -1,   419,   801,   424,   801,   420,
      -1,   419,   222,   424,   801,   420,    -1,   419,   801,   424,
     222,   420,    -1,   848,    -1,   898,   422,   662,    -1,    69,
      42,   419,   801,    20,   801,   420,   378,   139,   623,   664,
      -1,    69,    42,   419,   801,    20,   801,   420,   379,   139,
     664,    -1,    69,    42,   419,   801,    20,   801,   420,   378,
     165,   664,    -1,    20,   155,    -1,    20,    23,    -1,    -1,
     109,    42,   666,   419,   801,    20,   801,   420,   471,    -1,
     151,   122,    -1,    -1,   278,   668,   884,   669,    -1,   278,
     331,   886,   669,    -1,   278,    86,   886,   669,    -1,   159,
      -1,   332,    -1,   133,    -1,    -1,    13,    10,   892,   581,
     281,   341,   886,    -1,    13,    66,   603,   281,   341,   886,
      -1,    13,    86,   887,   281,   341,   887,    -1,    13,   139,
     623,   281,   341,   886,    -1,    13,   144,   896,   281,   341,
     896,    -1,    13,   535,   182,   886,   281,   341,   886,    -1,
      13,   241,    50,   603,   361,   888,   281,   341,   886,    -1,
      13,   241,   127,   603,   361,   888,   281,   341,   886,    -1,
      13,   298,   886,   281,   341,   886,    -1,    13,   332,   793,
     281,   341,   886,    -1,    13,   304,   884,   281,   341,   886,
      -1,    13,   372,   884,   281,   341,   886,    -1,    13,   159,
     884,   281,   341,   886,    -1,    13,   332,   793,   281,   671,
     886,   341,   886,    -1,    13,   345,   886,   239,   884,   281,
     341,   886,    -1,    13,   292,   896,   281,   341,   896,    -1,
      13,   360,   896,   281,   341,   896,    -1,    13,   333,   886,
     281,   341,   886,    -1,    13,   337,   300,   253,   603,   281,
     341,   886,    -1,    13,   337,   300,   101,   603,   281,   341,
     886,    -1,    13,   337,   300,   335,   603,   281,   341,   886,
      -1,    13,   337,   300,    60,   603,   281,   341,   886,    -1,
      13,   350,   603,   281,   341,   886,    -1,    55,    -1,    -1,
     309,    85,    -1,    -1,    13,    10,   892,   581,   309,   298,
     886,    -1,    13,   107,   603,   309,   298,   886,    -1,    13,
     139,   623,   309,   298,   886,    -1,    13,   332,   793,   309,
     298,   886,    -1,    13,   304,   884,   309,   298,   886,    -1,
      13,   372,   884,   309,   298,   886,    -1,    13,   350,   603,
     309,   298,   886,    -1,    13,    10,   892,   581,   252,   341,
     896,    -1,    13,    66,   603,   252,   341,   896,    -1,    13,
      86,   887,   252,   341,   896,    -1,    13,   107,   603,   252,
     341,   896,    -1,    13,   139,   623,   252,   341,   896,    -1,
      13,   535,   182,   886,   252,   341,   896,    -1,    13,   241,
     662,   661,   252,   341,   896,    -1,    13,   241,    50,   603,
     361,   888,   252,   341,   896,    -1,    13,   241,   127,   603,
     361,   888,   252,   341,   896,    -1,    13,   298,   886,   252,
     341,   896,    -1,    13,   350,   603,   252,   341,   896,    -1,
      13,   333,   886,   252,   341,   896,    -1,    13,   337,   300,
     101,   603,   252,   341,   896,    -1,    13,   337,   300,    60,
     603,   252,   341,   896,    -1,    13,   134,    85,   381,   886,
     252,   341,   896,    -1,    13,   306,   886,   252,   341,   896,
      -1,    13,    86,   887,   677,    -1,    13,   298,   886,   677,
      -1,    13,   332,   793,   677,    -1,    13,   332,   793,    13,
     671,   898,   677,    -1,    13,   304,   793,   677,    -1,    13,
     139,   623,   677,    -1,   677,    -1,    -1,   398,   701,   895,
      -1,    -1,    69,   637,   296,   886,    20,   679,   239,   684,
     341,   884,   797,   105,   685,   680,    -1,   225,    -1,   682,
      -1,   419,   681,   420,    -1,   681,   423,   683,    -1,   683,
      -1,   752,    -1,   731,    -1,   742,    -1,   736,    -1,   687,
      -1,   682,    -1,    -1,   303,    -1,   359,    -1,    97,    -1,
     168,    -1,   169,    -1,    12,    -1,    -1,   109,   296,   886,
     239,   884,   471,    -1,   109,   296,   151,   122,   886,   239,
     884,   471,    -1,   226,   898,    -1,   193,   898,    -1,   357,
     898,    -1,   357,   412,    -1,     3,   691,    -1,    29,   691,
     694,    -1,   319,   343,   694,    -1,    57,   691,    -1,   115,
     691,    -1,   293,   691,    -1,   297,   898,    -1,   280,   297,
     898,    -1,   280,   898,    -1,   293,   691,   341,   297,   898,
      -1,   293,   691,   341,   898,    -1,   263,   343,   895,    -1,
      57,   264,   895,    -1,   293,   264,   895,    -1,   380,    -1,
     343,    -1,    -1,   178,   190,   454,    -1,   272,   240,    -1,
     272,   382,    -1,   692,    -1,   693,   424,   692,    -1,   693,
     692,    -1,   693,    -1,    -1,    69,   488,   372,   884,   502,
      20,   752,   696,    -1,    69,   244,   283,   488,   372,   884,
     502,    20,   752,   696,    -1,   378,    48,   242,    -1,   378,
      40,    48,   242,    -1,   378,   195,    48,   242,    -1,    -1,
     194,   891,    -1,    69,    86,   887,   431,   699,    -1,   699,
     700,    -1,    -1,   333,   701,   886,    -1,   333,   701,    92,
      -1,   198,   701,   895,    -1,   198,   701,    92,    -1,   335,
     701,   886,    -1,   335,   701,    92,    -1,   113,   701,   895,
      -1,   113,   701,   894,    -1,   113,   701,    92,    -1,   185,
     701,   895,    -1,   185,   701,    92,    -1,   186,   701,   895,
      -1,   186,   701,    92,    -1,    61,   192,   701,   897,    -1,
     252,   701,   886,    -1,   252,   701,    92,    -1,   677,    -1,
     406,    -1,    -1,    13,    86,   887,   431,   704,    -1,    13,
      86,   887,   309,   333,   886,    -1,    13,    86,   887,   460,
      -1,   704,   705,    -1,    -1,    61,   192,   701,   897,    -1,
     109,    86,   887,    -1,   109,    86,   151,   122,   887,    -1,
      69,   107,   603,   709,   801,   493,    -1,    13,   107,   603,
     470,    -1,    13,   107,   603,   109,   224,   229,    -1,    13,
     107,   603,   309,   224,   229,    -1,    13,   107,   603,     7,
     500,    -1,    13,   107,   603,   109,    62,   886,   471,    -1,
      20,    -1,    -1,    13,   337,   300,   101,   603,   577,    -1,
      13,   337,   300,    60,   603,     7,   201,   132,   885,   378,
     602,    -1,    13,   337,   300,    60,   603,    13,   201,   132,
     885,   378,   602,    -1,    13,   337,   300,    60,   603,    13,
     201,   283,   603,   378,   603,    -1,    13,   337,   300,    60,
     603,    13,   201,   132,   885,   283,   603,   378,   603,    -1,
      13,   337,   300,    60,   603,   109,   201,   132,   885,    -1,
      13,   337,   300,    60,   603,   109,   201,   151,   122,   132,
     885,    -1,    69,   589,    66,   603,   132,   895,   341,   895,
     137,   603,    -1,    52,   718,   884,   714,    -1,    52,   718,
      -1,    52,   718,   890,   239,   884,    -1,   361,   890,    -1,
      -1,   362,   719,   720,   718,    -1,   362,   719,   720,   718,
     884,    -1,   362,   719,   720,   718,   716,    -1,   717,   718,
      -1,   717,   718,   884,   721,    -1,    16,    -1,    15,    -1,
     370,    -1,    -1,   138,    -1,    -1,   136,    -1,    -1,   419,
     885,   420,    -1,    -1,   123,   724,   718,   723,    -1,   752,
      -1,   731,    -1,   742,    -1,   736,    -1,   749,    -1,   515,
      -1,   728,    -1,   717,    -1,    -1,   263,   886,   726,    20,
     727,    -1,   419,   854,   420,    -1,    -1,   752,    -1,   731,
      -1,   742,    -1,   736,    -1,   121,   886,   729,    -1,    69,
     488,   332,   516,    20,   121,   886,   729,    -1,   419,   853,
     420,    -1,    -1,    88,   886,    -1,    88,   263,   886,    -1,
      88,    11,    -1,    88,   263,    11,    -1,   168,   174,   884,
     732,   735,    -1,   752,    -1,   419,   733,   420,   752,    -1,
      92,   366,    -1,   734,    -1,   733,   424,   734,    -1,   898,
     875,    -1,   288,   880,    -1,    -1,    97,   137,   795,   737,
     798,   735,    -1,   361,   786,    -1,    -1,   199,   762,   794,
     739,   741,    -1,   156,   740,   206,    -1,    -1,     5,   311,
      -1,   294,   311,    -1,   294,   120,    -1,   311,   359,   120,
      -1,   311,    -1,   311,   294,   120,    -1,   120,    -1,     5,
     120,    -1,   228,    -1,    -1,   359,   795,   309,   743,   785,
     798,   735,    -1,   744,    -1,   743,   424,   744,    -1,   745,
      -1,   746,    -1,   747,   406,   877,    -1,   419,   748,   420,
     406,   879,    -1,   898,   875,    -1,   747,    -1,   748,   424,
     747,    -1,    91,   886,   750,    83,   751,   132,   752,    -1,
      -1,   750,   216,   299,    -1,   750,   299,    -1,   750,    32,
      -1,   750,   167,    -1,    -1,   378,   148,    -1,   379,   148,
      -1,   754,    -1,   753,    -1,   419,   754,   420,    -1,   419,
     753,   420,    -1,   756,    -1,   755,   766,    -1,   755,   765,
     779,   770,    -1,   755,   765,   769,   780,    -1,   757,   755,
      -1,   757,   755,   766,    -1,   757,   755,   765,   779,   770,
      -1,   757,   755,   765,   769,   780,    -1,   756,    -1,   753,
      -1,   303,   764,   880,   760,   785,   797,   777,   778,   836,
      -1,   784,    -1,   332,   793,    -1,   755,   354,   763,   755,
      -1,   755,   172,   763,   755,    -1,   755,   118,   763,   755,
      -1,   378,   758,    -1,   378,   276,   758,    -1,   759,    -1,
     758,   424,   759,    -1,   886,   721,    20,   753,    -1,   174,
     761,    -1,    -1,   336,   762,   884,    -1,   334,   762,   884,
      -1,   195,   336,   762,   884,    -1,   195,   334,   762,   884,
      -1,   140,   336,   762,   884,    -1,   140,   334,   762,   884,
      -1,   332,   884,    -1,   884,    -1,   332,    -1,    -1,    11,
      -1,   104,    -1,    -1,   104,    -1,   104,   239,   419,   853,
     420,    -1,    11,    -1,    -1,   766,    -1,    -1,   245,    36,
     767,    -1,   768,    -1,   767,   424,   768,    -1,   825,   361,
     851,   635,    -1,   825,   634,   635,    -1,   192,   771,   236,
     773,    -1,   236,   773,   192,   771,    -1,   192,   771,    -1,
     236,   773,    -1,   192,   771,   424,   773,    -1,   236,   774,
     775,    -1,   128,   776,   772,   775,   240,    -1,   236,   774,
     775,   128,   776,   772,   775,   240,    -1,   769,    -1,    -1,
     825,    -1,    11,    -1,   897,    -1,   419,   825,   420,    -1,
      -1,   825,    -1,   827,    -1,   294,    -1,   295,    -1,   129,
      -1,   215,    -1,   144,    36,   853,    -1,    -1,   146,   825,
      -1,    -1,   781,    -1,   132,   272,   240,    -1,   779,    -1,
      -1,   782,    -1,   781,   782,    -1,   132,   359,   783,   741,
      -1,   132,   311,   783,   741,    -1,   234,   883,    -1,    -1,
     366,   879,    -1,   784,   424,   879,    -1,   137,   786,    -1,
      -1,   787,    -1,   786,   424,   787,    -1,   793,    -1,   793,
     789,    -1,   796,    -1,   796,   789,    -1,   796,    20,   419,
     799,   420,    -1,   796,    20,   898,   419,   799,   420,    -1,
     796,   898,   419,   799,   420,    -1,   753,    -1,   753,   789,
      -1,   788,    -1,   419,   788,   420,   789,    -1,   419,   788,
     420,    -1,   787,    73,   179,   787,    -1,   787,   790,   179,
     787,   792,    -1,   787,   179,   787,   792,    -1,   787,   212,
     790,   179,   787,    -1,   787,   212,   179,   787,    -1,    20,
     898,   419,   885,   420,    -1,    20,   898,    -1,   898,   419,
     885,   420,    -1,   898,    -1,   138,   791,    -1,   189,   791,
      -1,   291,   791,    -1,   164,    -1,   247,    -1,    -1,   361,
     419,   885,   420,    -1,   239,   825,    -1,   884,    -1,   884,
     412,    -1,   240,   884,    -1,   240,   419,   884,   420,    -1,
     793,    -1,   794,   424,   793,    -1,   793,    -1,   793,   898,
      -1,   793,    20,   898,    -1,   828,    -1,   375,   825,    -1,
      -1,   375,   825,    -1,   375,    75,   234,   886,    -1,   375,
      75,   234,   405,    -1,    -1,   800,    -1,   799,   424,   800,
      -1,   898,   801,    -1,   803,   802,    -1,   310,   803,   802,
      -1,   803,    19,   417,   894,   418,    -1,   310,   803,    19,
     417,   894,   418,    -1,   803,    19,    -1,   310,   803,    19,
      -1,   802,   417,   418,    -1,   802,   417,   894,   418,    -1,
      -1,   805,    -1,   807,    -1,   809,    -1,   813,    -1,   820,
      -1,   821,   823,    -1,   821,   419,   894,   420,   823,    -1,
     807,    -1,   810,    -1,   814,    -1,   820,    -1,   899,   806,
      -1,   899,   604,   806,    -1,   419,   853,   420,    -1,    -1,
     170,    -1,   171,    -1,   315,    -1,    31,    -1,   273,    -1,
     130,   808,    -1,   108,   261,    -1,    90,   806,    -1,    89,
     806,    -1,   232,   806,    -1,    34,    -1,   419,   894,   420,
      -1,    -1,   811,    -1,   812,    -1,   811,    -1,   812,    -1,
      33,   818,   419,   853,   420,    -1,    33,   818,    -1,   815,
      -1,   816,    -1,   815,    -1,   816,    -1,   817,   419,   894,
     420,   819,    -1,   817,   819,    -1,    46,   818,    -1,    45,
     818,    -1,   367,    -1,   211,    46,   818,    -1,   211,    45,
     818,    -1,   213,   818,    -1,   369,    -1,    -1,    46,   309,
     898,    -1,    -1,   340,   419,   894,   420,   822,    -1,   340,
     822,    -1,   339,   419,   894,   420,   822,    -1,   339,   822,
      -1,   173,    -1,   397,   394,    -1,   379,   339,   394,    -1,
      -1,   392,    -1,   207,    -1,    87,    -1,   149,    -1,   204,
      -1,   824,    -1,   392,   341,   207,    -1,    87,   341,   149,
      -1,    87,   341,   204,    -1,    87,   341,   824,    -1,   149,
     341,   204,    -1,   149,   341,   824,    -1,   204,   341,   824,
      -1,    -1,   301,    -1,   301,   419,   894,   420,    -1,   827,
      -1,   825,   421,   801,    -1,   825,    25,   339,   394,   825,
      -1,   410,   825,    -1,   411,   825,    -1,   825,   410,   825,
      -1,   825,   411,   825,    -1,   825,   412,   825,    -1,   825,
     413,   825,    -1,   825,   414,   825,    -1,   825,   415,   825,
      -1,   825,   407,   825,    -1,   825,   408,   825,    -1,   825,
     406,   825,    -1,   825,   850,   825,    -1,   850,   825,    -1,
     825,   850,    -1,   825,    17,   825,    -1,   825,   244,   825,
      -1,   224,   825,    -1,   825,   191,   825,    -1,   825,   191,
     825,   117,   825,    -1,   825,   224,   191,   825,    -1,   825,
     224,   191,   825,   117,   825,    -1,   825,   152,   825,    -1,
     825,   152,   825,   117,   825,    -1,   825,   224,   152,   825,
      -1,   825,   224,   152,   825,   117,   825,    -1,   825,   313,
     341,   825,    -1,   825,   313,   341,   825,   117,   825,    -1,
     825,   224,   313,   341,   825,    -1,   825,   224,   313,   341,
     825,   117,   825,    -1,   825,   176,   229,    -1,   825,   177,
      -1,   825,   176,   224,   229,    -1,   825,   227,    -1,   846,
     249,   846,    -1,   825,   176,   347,    -1,   825,   176,   224,
     347,    -1,   825,   176,   126,    -1,   825,   176,   224,   126,
      -1,   825,   176,   356,    -1,   825,   176,   224,   356,    -1,
     825,   176,   104,   137,   825,    -1,   825,   176,   224,   104,
     137,   825,    -1,   825,   176,   234,   419,   854,   420,    -1,
     825,   176,   224,   234,   419,   854,   420,    -1,   825,    30,
     876,   826,    17,   826,    -1,   825,   224,    30,   876,   826,
      17,   826,    -1,   825,    30,   329,   826,    17,   826,    -1,
     825,   224,    30,   329,   826,    17,   826,    -1,   825,   156,
     866,    -1,   825,   224,   156,   866,    -1,   825,   852,   847,
     753,    -1,   825,   852,   847,   419,   825,   420,    -1,   355,
     753,    -1,   825,   176,   106,    -1,   825,   176,   224,   106,
      -1,   827,    -1,   826,   421,   801,    -1,   410,   826,    -1,
     411,   826,    -1,   826,   410,   826,    -1,   826,   411,   826,
      -1,   826,   412,   826,    -1,   826,   413,   826,    -1,   826,
     414,   826,    -1,   826,   415,   826,    -1,   826,   407,   826,
      -1,   826,   408,   826,    -1,   826,   406,   826,    -1,   826,
     850,   826,    -1,   850,   826,    -1,   826,   850,    -1,   826,
     176,   104,   137,   826,    -1,   826,   176,   224,   104,   137,
     826,    -1,   826,   176,   234,   419,   854,   420,    -1,   826,
     176,   224,   234,   419,   854,   420,    -1,   826,   176,   106,
      -1,   826,   176,   224,   106,    -1,   872,    -1,   893,    -1,
     405,   875,    -1,   419,   825,   420,   875,    -1,   867,    -1,
     828,    -1,   753,    -1,   122,   753,    -1,    19,   753,    -1,
      19,   855,    -1,   846,    -1,   892,   419,   420,   839,    -1,
     892,   419,   853,   420,   839,    -1,   892,   419,   368,   825,
     420,   839,    -1,   892,   419,   853,   424,   368,   825,   420,
     839,    -1,   892,   419,    11,   853,   420,   839,    -1,   892,
     419,   104,   853,   420,   839,    -1,   892,   419,   412,   420,
     839,    -1,    77,    -1,    80,    -1,    80,   419,   894,   420,
      -1,    81,    -1,    81,   419,   894,   420,    -1,   196,    -1,
     196,   419,   894,   420,    -1,   197,    -1,   197,   419,   894,
     420,    -1,    78,    -1,    82,    -1,   308,    -1,   360,    -1,
      76,    -1,    79,    -1,    42,   419,   825,    20,   801,   420,
      -1,   125,   419,   857,   420,    -1,   250,   419,   859,   420,
      -1,   259,   419,   861,   420,    -1,   327,   419,   862,   420,
      -1,   344,   419,   825,    20,   801,   420,    -1,   346,   419,
      35,   865,   420,    -1,   346,   419,   187,   865,   420,    -1,
     346,   419,   342,   865,   420,    -1,   346,   419,   865,   420,
      -1,   230,   419,   825,   424,   825,   420,    -1,    53,   419,
     853,   420,    -1,   143,   419,   853,   420,    -1,   188,   419,
     853,   420,    -1,   385,   419,   853,   420,    -1,   386,   419,
     209,   900,   420,    -1,   386,   419,   209,   900,   424,   831,
     420,    -1,   386,   419,   209,   900,   424,   853,   420,    -1,
     386,   419,   209,   900,   424,   831,   424,   853,   420,    -1,
     387,   419,   832,   420,    -1,   388,   419,   834,   825,   835,
     420,    -1,   389,   419,   209,   900,   420,    -1,   389,   419,
     209,   900,   424,   825,   420,    -1,   390,   419,   825,   424,
     829,   830,   420,    -1,   391,   419,   834,   825,    20,   803,
     420,    -1,   371,   825,    -1,   371,   216,   365,    -1,   424,
     318,   393,    -1,   424,   318,   216,    -1,   424,   318,   216,
     365,    -1,    -1,   384,   419,   832,   420,    -1,   833,    -1,
     832,   424,   833,    -1,   825,    20,   900,    -1,   825,    -1,
     106,    -1,    64,    -1,   262,   376,    -1,   326,   376,    -1,
      -1,   377,   837,    -1,    -1,   838,    -1,   837,   424,   838,
      -1,   898,    20,   840,    -1,   248,   840,    -1,   248,   898,
      -1,    -1,   419,   841,   842,   765,   843,   420,    -1,   898,
      -1,    -1,   255,    36,   853,    -1,    -1,   271,   844,    -1,
     295,   844,    -1,    -1,   845,    -1,    30,   845,    17,   845,
      -1,   351,   260,    -1,   351,   131,    -1,    75,   294,    -1,
     294,   419,   853,   420,    -1,   294,   419,   420,    -1,   419,
     853,   424,   825,   420,    -1,    18,    -1,   316,    -1,    11,
      -1,   403,    -1,   849,    -1,   410,    -1,   411,    -1,   412,
      -1,   413,    -1,   414,    -1,   415,    -1,   407,    -1,   408,
      -1,   406,    -1,   403,    -1,   241,   419,   662,   420,    -1,
     848,    -1,   241,   419,   662,   420,    -1,   848,    -1,   241,
     419,   662,   420,    -1,   191,    -1,   224,   191,    -1,   152,
      -1,   224,   152,    -1,   825,    -1,   853,   424,   825,    -1,
     801,    -1,   854,   424,   801,    -1,   417,   853,   418,    -1,
     417,   856,   418,    -1,   417,   418,    -1,   855,    -1,   856,
     424,   855,    -1,   858,   137,   825,    -1,    -1,   398,    -1,
     392,    -1,   207,    -1,    87,    -1,   149,    -1,   204,    -1,
     301,    -1,   895,    -1,   825,   860,   863,   864,    -1,   825,
     860,   863,    -1,   257,   825,    -1,   826,   156,   826,    -1,
      -1,   825,   863,   864,    -1,   825,   864,   863,    -1,   825,
     863,    -1,   825,   864,    -1,   853,    -1,    -1,   137,   825,
      -1,   132,   825,    -1,   825,   137,   853,    -1,   137,   853,
      -1,   853,    -1,   753,    -1,   419,   853,   420,    -1,    41,
     871,   868,   870,   115,    -1,   869,    -1,   868,   869,    -1,
     374,   825,   338,   825,    -1,   111,   825,    -1,    -1,   825,
      -1,    -1,   882,    -1,   882,   874,    -1,   422,   889,    -1,
     422,   412,    -1,   417,   825,   418,    -1,   417,   825,   425,
     825,   418,    -1,   873,    -1,   874,   873,    -1,    -1,   875,
     873,    -1,    24,    -1,    -1,   825,    -1,    92,    -1,   877,
      -1,   878,   424,   877,    -1,   419,   878,   420,    -1,   881,
      -1,   880,   424,   881,    -1,   825,    20,   900,    -1,   825,
     398,    -1,   825,    -1,   412,    -1,   905,    -1,   898,    -1,
     884,    -1,   883,   424,   884,    -1,   882,    -1,   882,   874,
      -1,   886,    -1,   885,   424,   886,    -1,   898,    -1,   898,
      -1,   898,    -1,   900,    -1,   898,    -1,   895,    -1,   899,
      -1,   882,   874,    -1,   894,    -1,   399,    -1,   895,    -1,
     401,    -1,   402,    -1,   892,   895,    -1,   892,   419,   853,
     420,   895,    -1,   804,   895,    -1,   821,   895,   823,    -1,
     821,   419,   894,   420,   895,   823,    -1,   347,    -1,   126,
      -1,   229,    -1,   404,    -1,   400,    -1,   898,    -1,   894,
      -1,   410,   894,    -1,   411,   894,    -1,   398,    -1,   901,
      -1,   902,    -1,   398,    -1,   901,    -1,   903,    -1,   398,
      -1,   901,    -1,   902,    -1,   903,    -1,   904,    -1,     3,
      -1,     4,    -1,     5,    -1,     6,    -1,     7,    -1,     8,
      -1,     9,    -1,    10,    -1,    12,    -1,    13,    -1,    14,
      -1,    22,    -1,    23,    -1,    25,    -1,    27,    -1,    28,
      -1,    29,    -1,    36,    -1,    37,    -1,    38,    -1,    39,
      -1,    40,    -1,    43,    -1,    44,    -1,    47,    -1,    49,
      -1,    50,    -1,    51,    -1,    52,    -1,    56,    -1,    57,
      -1,    58,    -1,    59,    -1,    60,    -1,    61,    -1,    63,
      -1,    64,    -1,    65,    -1,    66,    -1,    67,    -1,    68,
      -1,    70,    -1,    71,    -1,    72,    -1,    74,    -1,    75,
      -1,    83,    -1,    84,    -1,    85,    -1,    86,    -1,    87,
      -1,    88,    -1,    91,    -1,    93,    -1,    95,    -1,    96,
      -1,    97,    -1,    98,    -1,    99,    -1,   101,    -1,   102,
      -1,   103,    -1,   106,    -1,   107,    -1,   108,    -1,   109,
      -1,   110,    -1,   112,    -1,   113,    -1,   114,    -1,   116,
      -1,   117,    -1,   119,    -1,   120,    -1,   121,    -1,   123,
      -1,   124,    -1,   127,    -1,   129,    -1,   131,    -1,   133,
      -1,   135,    -1,   139,    -1,   140,    -1,   142,    -1,   145,
      -1,   147,    -1,   148,    -1,   149,    -1,   150,    -1,   151,
      -1,   153,    -1,   154,    -1,   155,    -1,   157,    -1,   158,
      -1,   159,    -1,   160,    -1,   161,    -1,   162,    -1,   166,
      -1,   167,    -1,   168,    -1,   169,    -1,   175,    -1,   178,
      -1,   180,    -1,   181,    -1,   182,    -1,   183,    -1,   184,
      -1,   185,    -1,   186,    -1,   190,    -1,   193,    -1,   194,
      -1,   195,    -1,   198,    -1,   199,    -1,   200,    -1,   201,
      -1,   202,    -1,   203,    -1,   204,    -1,   205,    -1,   206,
      -1,   207,    -1,   208,    -1,   209,    -1,   210,    -1,   215,
      -1,   216,    -1,   217,    -1,   218,    -1,   219,    -1,   220,
      -1,   221,    -1,   223,    -1,   225,    -1,   226,    -1,   228,
      -1,   231,    -1,   233,    -1,   234,    -1,   237,    -1,   241,
      -1,   242,    -1,   243,    -1,   251,    -1,   252,    -1,   253,
      -1,   254,    -1,   255,    -1,   256,    -1,   258,    -1,   260,
      -1,   263,    -1,   264,    -1,   262,    -1,   266,    -1,   267,
      -1,   268,    -1,   269,    -1,   270,    -1,   271,    -1,   272,
      -1,   274,    -1,   275,    -1,   276,    -1,   278,    -1,   279,
      -1,   280,    -1,   281,    -1,   282,    -1,   283,    -1,   284,
      -1,   285,    -1,   286,    -1,   287,    -1,   289,    -1,   290,
      -1,   292,    -1,   293,    -1,   295,    -1,   296,    -1,   297,
      -1,   298,    -1,   299,    -1,   300,    -1,   301,    -1,   302,
      -1,   304,    -1,   305,    -1,   306,    -1,   307,    -1,   309,
      -1,   311,    -1,   312,    -1,   314,    -1,   317,    -1,   318,
      -1,   319,    -1,   320,    -1,   321,    -1,   322,    -1,   323,
      -1,   324,    -1,   325,    -1,   326,    -1,   328,    -1,   330,
      -1,   331,    -1,   333,    -1,   334,    -1,   335,    -1,   336,
      -1,   337,    -1,   343,    -1,   345,    -1,   348,    -1,   349,
      -1,   350,    -1,   351,    -1,   352,    -1,   353,    -1,   356,
      -1,   357,    -1,   358,    -1,   359,    -1,   362,    -1,   363,
      -1,   364,    -1,   365,    -1,   369,    -1,   371,    -1,   372,
      -1,   373,    -1,   376,    -1,   379,    -1,   380,    -1,   381,
      -1,   382,    -1,   383,    -1,   392,    -1,   393,    -1,   394,
      -1,    31,    -1,    33,    -1,    34,    -1,    45,    -1,    46,
      -1,    53,    -1,    89,    -1,    90,    -1,   122,    -1,   125,
      -1,   130,    -1,   143,    -1,   165,    -1,   170,    -1,   171,
      -1,   173,    -1,   188,    -1,   211,    -1,   213,    -1,   222,
      -1,   230,    -1,   232,    -1,   246,    -1,   250,    -1,   259,
      -1,   261,    -1,   273,    -1,   294,    -1,   310,    -1,   315,
      -1,   327,    -1,   339,    -1,   340,    -1,   344,    -1,   346,
      -1,   366,    -1,   367,    -1,   384,    -1,   385,    -1,   386,
      -1,   387,    -1,   388,    -1,   389,    -1,   390,    -1,   391,
      -1,    26,    -1,    30,    -1,    32,    -1,    73,    -1,    79,
      -1,   136,    -1,   138,    -1,   152,    -1,   164,    -1,   176,
      -1,   177,    -1,   179,    -1,   189,    -1,   191,    -1,   212,
      -1,   227,    -1,   247,    -1,   248,    -1,   249,    -1,   291,
      -1,   313,    -1,   370,    -1,    11,    -1,    15,    -1,    16,
      -1,    17,    -1,    18,    -1,    19,    -1,    20,    -1,    21,
      -1,    24,    -1,    35,    -1,    41,    -1,    42,    -1,    48,
      -1,    54,    -1,    55,    -1,    62,    -1,    69,    -1,    76,
      -1,    77,    -1,    78,    -1,    80,    -1,    81,    -1,    82,
      -1,    92,    -1,    94,    -1,   100,    -1,   104,    -1,   105,
      -1,   111,    -1,   115,    -1,   118,    -1,   126,    -1,   128,
      -1,   132,    -1,   134,    -1,   137,    -1,   141,    -1,   144,
      -1,   146,    -1,   156,    -1,   163,    -1,   172,    -1,   174,
      -1,   187,    -1,   192,    -1,   196,    -1,   197,    -1,   214,
      -1,   224,    -1,   229,    -1,   235,    -1,   236,    -1,   238,
      -1,   239,    -1,   240,    -1,   244,    -1,   245,    -1,   257,
      -1,   265,    -1,   277,    -1,   288,    -1,   303,    -1,   308,
      -1,   316,    -1,   329,    -1,   332,    -1,   338,    -1,   341,
      -1,   342,    -1,   347,    -1,   354,    -1,   355,    -1,   360,
      -1,   361,    -1,   368,    -1,   374,    -1,   375,    -1,   377,
      -1,   378,    -1,   238,    -1,   214,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   585,   585,   589,   595,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   706,   716,   727,   728,
     737,   738,   742,   747,   751,   756,   761,   765,   769,   773,
     777,   781,   785,   789,   793,   798,   802,   806,   810,   814,
     819,   824,   828,   832,   836,   840,   854,   872,   883,   900,
     912,   932,   939,   958,   965,   982,  1000,  1011,  1012,  1024,
    1031,  1048,  1061,  1074,  1075,  1079,  1080,  1088,  1089,  1090,
    1091,  1092,  1093,  1107,  1113,  1119,  1128,  1136,  1144,  1151,
    1158,  1166,  1177,  1185,  1193,  1201,  1209,  1220,  1228,  1236,
    1243,  1253,  1254,  1261,  1262,  1265,  1267,  1269,  1273,  1274,
    1275,  1276,  1280,  1281,  1282,  1283,  1295,  1299,  1303,  1318,
    1341,  1342,  1343,  1347,  1348,  1349,  1353,  1354,  1358,  1365,
    1372,  1379,  1386,  1396,  1397,  1402,  1408,  1414,  1420,  1426,
    1436,  1446,  1447,  1451,  1452,  1460,  1475,  1481,  1487,  1493,
    1511,  1519,  1527,  1535,  1546,  1547,  1552,  1560,  1569,  1577,
    1585,  1594,  1603,  1615,  1625,  1633,  1642,  1649,  1656,  1664,
    1672,  1680,  1688,  1696,  1703,  1710,  1718,  1725,  1732,  1740,
    1748,  1756,  1764,  1772,  1780,  1788,  1796,  1804,  1814,  1815,
    1819,  1820,  1821,  1825,  1826,  1830,  1833,  1834,  1838,  1839,
    1844,  1848,  1852,  1857,  1872,  1878,  1901,  1923,  1938,  1939,
    1948,  1949,  1950,  1956,  1957,  1962,  1966,  1970,  1974,  1978,
    1982,  1986,  1990,  1994,  1998,  2007,  2011,  2015,  2019,  2024,
    2028,  2032,  2033,  2044,  2059,  2086,  2087,  2088,  2089,  2090,
    2091,  2092,  2096,  2097,  2101,  2105,  2112,  2113,  2114,  2117,
    2130,  2131,  2135,  2156,  2157,  2176,  2187,  2198,  2210,  2222,
    2233,  2244,  2273,  2279,  2285,  2291,  2309,  2319,  2320,  2324,
    2325,  2326,  2327,  2328,  2329,  2338,  2359,  2363,  2373,  2385,
    2397,  2415,  2416,  2420,  2421,  2424,  2430,  2434,  2442,  2447,
    2459,  2461,  2463,  2465,  2468,  2471,  2474,  2478,  2479,  2480,
    2481,  2482,  2485,  2486,  2491,  2492,  2493,  2494,  2497,  2498,
    2499,  2500,  2503,  2504,  2507,  2508,  2518,  2543,  2555,  2556,
    2560,  2561,  2565,  2581,  2582,  2583,  2596,  2608,  2617,  2618,
    2621,  2622,  2625,  2629,  2633,  2637,  2641,  2645,  2649,  2653,
    2657,  2661,  2665,  2669,  2675,  2676,  2680,  2681,  2686,  2698,
    2708,  2722,  2723,  2731,  2732,  2736,  2737,  2741,  2742,  2746,
    2747,  2751,  2759,  2770,  2771,  2781,  2791,  2792,  2805,  2812,
    2828,  2845,  2853,  2870,  2879,  2887,  2898,  2899,  2903,  2907,
    2915,  2919,  2923,  2930,  2934,  2939,  2944,  2951,  2958,  2963,
    2973,  2987,  2988,  2993,  2994,  2998,  2999,  3009,  3017,  3034,
    3043,  3051,  3067,  3079,  3080,  3081,  3091,  3099,  3116,  3135,
    3153,  3176,  3177,  3181,  3183,  3192,  3193,  3194,  3195,  3199,
    3204,  3214,  3215,  3219,  3220,  3224,  3225,  3226,  3230,  3236,
    3237,  3238,  3239,  3240,  3244,  3245,  3249,  3251,  3260,  3267,
    3277,  3281,  3282,  3286,  3287,  3292,  3302,  3324,  3343,  3366,
    3376,  3387,  3397,  3407,  3418,  3454,  3461,  3470,  3479,  3488,
    3499,  3502,  3503,  3506,  3510,  3517,  3518,  3519,  3520,  3521,
    3524,  3525,  3528,  3531,  3532,  3540,  3546,  3548,  3565,  3580,
    3581,  3585,  3594,  3603,  3612,  3622,  3631,  3632,  3635,  3636,
    3639,  3653,  3658,  3668,  3677,  3689,  3690,  3694,  3702,  3714,
    3723,  3735,  3744,  3765,  3775,  3793,  3802,  3814,  3815,  3816,
    3817,  3818,  3819,  3820,  3821,  3822,  3823,  3824,  3825,  3829,
    3830,  3833,  3834,  3837,  3839,  3852,  3863,  3864,  3865,  3890,
    3899,  3908,  3917,  3926,  3935,  3944,  3954,  3963,  3972,  3981,
    3990,  3999,  4008,  4016,  4024,  4032,  4043,  4044,  4045,  4046,
    4047,  4048,  4049,  4050,  4051,  4052,  4053,  4054,  4058,  4059,
    4069,  4076,  4085,  4092,  4105,  4111,  4118,  4125,  4132,  4139,
    4146,  4153,  4160,  4167,  4174,  4181,  4188,  4195,  4202,  4211,
    4212,  4222,  4237,  4250,  4275,  4277,  4279,  4281,  4288,  4297,
    4298,  4301,  4308,  4315,  4322,  4336,  4343,  4350,  4357,  4364,
    4371,  4378,  4385,  4392,  4399,  4410,  4411,  4414,  4424,  4438,
    4439,  4443,  4444,  4449,  4465,  4478,  4488,  4500,  4501,  4504,
    4505,  4520,  4536,  4555,  4556,  4560,  4561,  4564,  4565,  4573,
    4582,  4591,  4602,  4603,  4604,  4607,  4608,  4609,  4612,  4613,
    4614,  4630,  4642,  4655,  4670,  4671,  4674,  4675,  4679,  4680,
    4688,  4689,  4693,  4694,  4709,  4718,  4727,  4736,  4745,  4757,
    4758,  4759,  4760,  4761,  4767,  4771,  4786,  4787,  4793,  4803,
    4807,  4812,  4822,  4823,  4830,  4834,  4838,  4842,  4846,  4850,
    4854,  4858,  4862,  4866,  4870,  4874,  4878,  4886,  4890,  4894,
    4898,  4902,  4908,  4909,  4916,  4917,  4920,  4932,  4936,  4951,
    4962,  4963,  4968,  4969,  4984,  4994,  5007,  5017,  5030,  5040,
    5053,  5061,  5063,  5065,  5070,  5072,  5083,  5094,  5105,  5118,
    5119,  5120,  5124,  5135,  5136,  5150,  5158,  5168,  5181,  5182,
    5185,  5186,  5196,  5205,  5213,  5221,  5230,  5238,  5246,  5255,
    5264,  5272,  5281,  5290,  5299,  5308,  5317,  5326,  5334,  5342,
    5350,  5358,  5366,  5374,  5382,  5392,  5393,  5396,  5397,  5407,
    5416,  5424,  5433,  5441,  5449,  5457,  5473,  5482,  5490,  5498,
    5506,  5515,  5523,  5532,  5541,  5550,  5558,  5566,  5574,  5582,
    5590,  5598,  5614,  5622,  5630,  5638,  5647,  5655,  5666,  5667,
    5670,  5686,  5685,  5704,  5705,  5706,  5711,  5717,  5726,  5727,
    5728,  5729,  5730,  5734,  5735,  5738,  5739,  5740,  5741,  5745,
    5746,  5747,  5752,  5762,  5783,  5791,  5800,  5806,  5825,  5832,
    5839,  5846,  5853,  5860,  5867,  5875,  5883,  5891,  5899,  5907,
    5914,  5921,  5930,  5931,  5932,  5936,  5939,  5942,  5949,  5951,
    5953,  5958,  5960,  5972,  5983,  5997,  6003,  6009,  6015,  6025,
    6041,  6051,  6052,  6056,  6060,  6064,  6068,  6072,  6076,  6080,
    6084,  6088,  6092,  6096,  6100,  6104,  6108,  6112,  6116,  6120,
    6130,  6131,  6142,  6149,  6160,  6171,  6172,  6176,  6190,  6197,
    6214,  6226,  6235,  6243,  6251,  6260,  6271,  6272,  6283,  6293,
    6303,  6313,  6323,  6333,  6341,  6362,  6385,  6393,  6402,  6413,
    6414,  6426,  6439,  6452,  6465,  6478,  6494,  6495,  6499,  6500,
    6503,  6504,  6507,  6508,  6512,  6513,  6524,  6535,  6536,  6537,
    6538,  6539,  6540,  6541,  6545,  6546,  6556,  6566,  6567,  6571,
    6572,  6573,  6574,  6584,  6592,  6609,  6610,  6620,  6626,  6632,
    6638,  6654,  6663,  6669,  6675,  6684,  6686,  6691,  6702,  6703,
    6714,  6727,  6728,  6739,  6750,  6751,  6754,  6755,  6756,  6757,
    6758,  6759,  6760,  6761,  6764,  6765,  6776,  6793,  6794,  6798,
    6799,  6803,  6811,  6839,  6850,  6851,  6861,  6872,  6873,  6874,
    6875,  6876,  6879,  6880,  6881,  6929,  6930,  6934,  6935,  6949,
    6950,  6956,  6963,  6970,  6977,  6984,  6991,  7001,  7002,  7029,
    7044,  7045,  7064,  7068,  7072,  7087,  7094,  7104,  7105,  7108,
    7120,  7130,  7138,  7143,  7148,  7153,  7158,  7163,  7168,  7173,
    7180,  7181,  7184,  7185,  7186,  7193,  7194,  7195,  7196,  7200,
    7201,  7205,  7209,  7210,  7213,  7222,  7235,  7237,  7239,  7241,
    7243,  7253,  7255,  7257,  7262,  7264,  7268,  7269,  7282,  7283,
    7284,  7288,  7296,  7301,  7302,  7307,  7308,  7312,  7313,  7317,
    7318,  7322,  7323,  7327,  7328,  7332,  7333,  7337,  7345,  7356,
    7357,  7362,  7368,  7386,  7387,  7391,  7392,  7402,  7406,  7411,
    7418,  7426,  7433,  7443,  7453,  7481,  7488,  7492,  7518,  7522,
    7534,  7547,  7561,  7572,  7587,  7593,  7598,  7604,  7611,  7612,
    7613,  7614,  7618,  7619,  7631,  7632,  7637,  7644,  7651,  7658,
    7669,  7670,  7683,  7687,  7694,  7704,  7709,  7710,  7715,  7716,
    7724,  7732,  7737,  7741,  7747,  7768,  7773,  7780,  7785,  7791,
    7796,  7805,  7807,  7810,  7814,  7815,  7816,  7817,  7818,  7819,
    7824,  7854,  7855,  7856,  7857,  7868,  7874,  7882,  7883,  7889,
    7894,  7899,  7904,  7909,  7914,  7919,  7924,  7930,  7936,  7942,
    7949,  7971,  7980,  7984,  7992,  7996,  8004,  8016,  8037,  8041,
    8047,  8051,  8064,  8083,  8106,  8108,  8110,  8112,  8114,  8116,
    8121,  8122,  8126,  8127,  8134,  8143,  8151,  8160,  8171,  8179,
    8180,  8181,  8185,  8187,  8189,  8191,  8193,  8195,  8197,  8202,
    8207,  8213,  8221,  8226,  8233,  8240,  8244,  8248,  8278,  8279,
    8281,  8302,  8304,  8306,  8308,  8310,  8312,  8314,  8316,  8318,
    8320,  8322,  8325,  8327,  8329,  8332,  8334,  8336,  8339,  8341,
    8353,  8355,  8367,  8369,  8381,  8383,  8396,  8408,  8420,  8432,
    8454,  8461,  8468,  8475,  8482,  8486,  8493,  8500,  8507,  8514,
    8521,  8528,  8532,  8540,  8544,  8553,  8560,  8567,  8580,  8593,
    8612,  8633,  8643,  8650,  8666,  8671,  8689,  8691,  8693,  8695,
    8697,  8699,  8701,  8703,  8705,  8707,  8709,  8711,  8713,  8715,
    8717,  8719,  8721,  8725,  8730,  8734,  8738,  8743,  8760,  8761,
    8762,  8777,  8789,  8791,  8793,  8803,  8813,  8823,  8831,  8849,
    8861,  8873,  8885,  8897,  8913,  8925,  8947,  8968,  8978,  8991,
    9007,  9020,  9030,  9043,  9053,  9066,  9078,  9090,  9102,  9114,
    9126,  9138,  9140,  9152,  9169,  9182,  9197,  9218,  9233,  9245,
    9257,  9269,  9273,  9280,  9288,  9296,  9300,  9304,  9308,  9312,
    9316,  9320,  9329,  9333,  9337,  9342,  9356,  9358,  9362,  9364,
    9366,  9369,  9372,  9375,  9376,  9379,  9387,  9397,  9398,  9401,
    9402,  9403,  9410,  9411,  9415,  9416,  9421,  9429,  9431,  9443,
    9446,  9470,  9471,  9474,  9475,  9484,  9488,  9493,  9496,  9511,
    9540,  9544,  9548,  9565,  9566,  9567,  9570,  9571,  9572,  9575,
    9576,  9579,  9580,  9581,  9582,  9583,  9584,  9585,  9586,  9587,
    9590,  9592,  9597,  9599,  9604,  9606,  9608,  9610,  9612,  9614,
    9626,  9630,  9636,  9637,  9640,  9644,  9648,  9654,  9655,  9660,
    9664,  9671,  9672,  9673,  9674,  9675,  9676,  9677,  9678,  9687,
    9691,  9698,  9705,  9706,  9722,  9726,  9731,  9735,  9750,  9755,
    9759,  9762,  9765,  9766,  9767,  9770,  9777,  9787,  9801,  9802,
    9806,  9817,  9818,  9821,  9822,  9830,  9834,  9841,  9845,  9849,
    9856,  9866,  9867,  9871,  9872,  9875,  9876,  9887,  9888,  9897,
    9898,  9906,  9917,  9918,  9921,  9937,  9945,  9953,  9975,  9976,
    9980,  9981,  9992, 10000, 10028, 10030, 10035, 10038, 10041, 10043,
   10045, 10047, 10057, 10059, 10067, 10071, 10075, 10079, 10083, 10092,
   10099, 10107, 10111, 10117, 10134, 10138, 10142, 10148, 10149, 10150,
   10152, 10153, 10154, 10170, 10171, 10172, 10177, 10178, 10179, 10185,
   10186, 10187, 10188, 10189, 10209, 10210, 10211, 10212, 10213, 10214,
   10215, 10216, 10217, 10218, 10219, 10220, 10221, 10222, 10223, 10224,
   10225, 10226, 10227, 10228, 10229, 10230, 10231, 10232, 10233, 10234,
   10235, 10236, 10237, 10238, 10239, 10240, 10241, 10242, 10243, 10244,
   10245, 10246, 10247, 10248, 10249, 10250, 10251, 10252, 10253, 10254,
   10255, 10256, 10257, 10258, 10259, 10260, 10261, 10262, 10263, 10264,
   10265, 10266, 10267, 10268, 10269, 10270, 10271, 10272, 10273, 10274,
   10275, 10276, 10277, 10278, 10279, 10280, 10281, 10282, 10283, 10284,
   10285, 10286, 10287, 10288, 10289, 10290, 10291, 10292, 10293, 10294,
   10295, 10296, 10297, 10298, 10299, 10300, 10301, 10302, 10303, 10304,
   10305, 10306, 10307, 10308, 10309, 10310, 10311, 10312, 10313, 10314,
   10315, 10316, 10317, 10318, 10319, 10320, 10321, 10322, 10323, 10324,
   10325, 10326, 10327, 10328, 10329, 10330, 10331, 10332, 10333, 10334,
   10335, 10336, 10337, 10338, 10339, 10340, 10341, 10342, 10343, 10344,
   10345, 10346, 10347, 10348, 10349, 10350, 10351, 10352, 10353, 10354,
   10355, 10356, 10357, 10358, 10359, 10360, 10361, 10362, 10363, 10364,
   10365, 10366, 10367, 10368, 10369, 10370, 10371, 10372, 10373, 10374,
   10375, 10376, 10377, 10378, 10379, 10380, 10381, 10382, 10383, 10384,
   10385, 10386, 10387, 10388, 10389, 10390, 10391, 10392, 10393, 10394,
   10395, 10396, 10397, 10398, 10399, 10400, 10401, 10402, 10403, 10404,
   10405, 10406, 10407, 10408, 10409, 10410, 10411, 10412, 10413, 10414,
   10415, 10416, 10417, 10418, 10419, 10420, 10421, 10422, 10423, 10424,
   10425, 10426, 10427, 10428, 10429, 10430, 10431, 10432, 10433, 10434,
   10435, 10436, 10437, 10438, 10439, 10440, 10441, 10442, 10443, 10444,
   10445, 10446, 10447, 10448, 10449, 10450, 10451, 10452, 10453, 10454,
   10468, 10469, 10470, 10471, 10472, 10473, 10474, 10475, 10476, 10477,
   10478, 10479, 10480, 10481, 10482, 10483, 10484, 10485, 10486, 10487,
   10488, 10489, 10490, 10491, 10492, 10493, 10494, 10495, 10496, 10497,
   10498, 10499, 10500, 10501, 10502, 10503, 10504, 10505, 10506, 10507,
   10508, 10509, 10510, 10511, 10512, 10526, 10527, 10528, 10529, 10530,
   10531, 10532, 10533, 10534, 10535, 10536, 10537, 10538, 10539, 10540,
   10541, 10542, 10543, 10544, 10545, 10546, 10547, 10557, 10558, 10559,
   10560, 10561, 10562, 10563, 10564, 10565, 10566, 10567, 10568, 10569,
   10570, 10571, 10572, 10573, 10574, 10575, 10576, 10577, 10578, 10579,
   10580, 10581, 10582, 10583, 10584, 10585, 10586, 10587, 10588, 10589,
   10590, 10591, 10592, 10593, 10594, 10595, 10596, 10597, 10598, 10599,
   10600, 10601, 10602, 10603, 10604, 10605, 10606, 10607, 10608, 10609,
   10610, 10611, 10612, 10613, 10614, 10615, 10616, 10617, 10618, 10619,
   10620, 10621, 10622, 10623, 10624, 10625, 10626, 10627, 10628, 10629,
   10630, 10631, 10632, 10633, 10634, 10635, 10640, 10650
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ABORT_P", "ABSOLUTE_P", "ACCESS",
  "ACTION", "ADD_P", "ADMIN", "AFTER", "AGGREGATE", "ALL", "ALSO", "ALTER",
  "ALWAYS", "ANALYSE", "ANALYZE", "AND", "ANY", "ARRAY", "AS", "ASC",
  "ASSERTION", "ASSIGNMENT", "ASYMMETRIC", "AT", "AUTHORIZATION",
  "BACKWARD", "BEFORE", "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT",
  "BOOLEAN_P", "BOTH", "BY", "CACHE", "CALLED", "CASCADE", "CASCADED",
  "CASE", "CAST", "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER",
  "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER",
  "COALESCE", "COLLATE", "COLUMN", "COMMENT", "COMMIT", "COMMITTED",
  "CONCURRENTLY", "CONFIGURATION", "CONNECTION", "CONSTRAINT",
  "CONSTRAINTS", "CONTENT_P", "CONTINUE_P", "CONVERSION_P", "COPY", "COST",
  "CREATE", "CREATEDB", "CREATEROLE", "CREATEUSER", "CROSS", "CSV",
  "CURRENT_P", "CURRENT_CATALOG", "CURRENT_DATE", "CURRENT_ROLE",
  "CURRENT_SCHEMA", "CURRENT_TIME", "CURRENT_TIMESTAMP", "CURRENT_USER",
  "CURSOR", "CYCLE", "DATA_P", "DATABASE", "DAY_P", "DEALLOCATE", "DEC",
  "DECIMAL_P", "DECLARE", "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED",
  "DEFINER", "DELETE_P", "DELIMITER", "DELIMITERS", "DESC", "DICTIONARY",
  "DISABLE_P", "DISCARD", "DISTINCT", "DO", "DOCUMENT_P", "DOMAIN_P",
  "DOUBLE_P", "DROP", "EACH", "ELSE", "ENABLE_P", "ENCODING", "ENCRYPTED",
  "END_P", "ENUM_P", "ESCAPE", "EXCEPT", "EXCLUDING", "EXCLUSIVE",
  "EXECUTE", "EXISTS", "EXPLAIN", "EXTERNAL", "EXTRACT", "FALSE_P",
  "FAMILY", "FETCH", "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR", "FORCE",
  "FOREIGN", "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION", "GLOBAL",
  "GRANT", "GRANTED", "GREATEST", "GROUP_P", "HANDLER", "HAVING",
  "HEADER_P", "HOLD", "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE",
  "IMMUTABLE", "IMPLICIT_P", "IN_P", "INCLUDING", "INCREMENT", "INDEX",
  "INDEXES", "INHERIT", "INHERITS", "INITIALLY", "INNER_P", "INOUT",
  "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD", "INT_P", "INTEGER",
  "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS", "ISNULL", "ISOLATION",
  "JOIN", "KEY", "LANCOMPILER", "LANGUAGE", "LARGE_P", "LAST_P",
  "LC_COLLATE_P", "LC_CTYPE_P", "LEADING", "LEAST", "LEFT", "LEVEL",
  "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOGIN_P", "MAPPING", "MATCH",
  "MAXVALUE", "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P",
  "NAMES", "NATIONAL", "NATURAL", "NCHAR", "NEW", "NEXT", "NO",
  "NOCREATEDB", "NOCREATEROLE", "NOCREATEUSER", "NOINHERIT", "NOLOGIN_P",
  "NONE", "NOSUPERUSER", "NOT", "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT",
  "NULL_P", "NULLIF", "NULLS_P", "NUMERIC", "OBJECT_P", "OF", "OFF",
  "OFFSET", "OIDS", "OLD", "ON", "ONLY", "OPERATOR", "OPTION", "OPTIONS",
  "OR", "ORDER", "OUT_P", "OUTER_P", "OVER", "OVERLAPS", "OVERLAY",
  "OWNED", "OWNER", "PARSER", "PARTIAL", "PARTITION", "PASSWORD",
  "PLACING", "PLANS", "POSITION", "PRECEDING", "PRECISION", "PRESERVE",
  "PREPARE", "PREPARED", "PRIMARY", "PRIOR", "PRIVILEGES", "PROCEDURAL",
  "PROCEDURE", "QUOTE", "RANGE", "READ", "REAL", "REASSIGN", "RECHECK",
  "RECURSIVE", "REFERENCES", "REINDEX", "RELATIVE_P", "RELEASE", "RENAME",
  "REPEATABLE", "REPLACE", "REPLICA", "RESET", "RESTART", "RESTRICT",
  "RETURNING", "RETURNS", "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROW",
  "ROWS", "RULE", "SAVEPOINT", "SCHEMA", "SCROLL", "SEARCH", "SECOND_P",
  "SECURITY", "SELECT", "SEQUENCE", "SERIALIZABLE", "SERVER", "SESSION",
  "SESSION_USER", "SET", "SETOF", "SHARE", "SHOW", "SIMILAR", "SIMPLE",
  "SMALLINT", "SOME", "STABLE", "STANDALONE_P", "START", "STATEMENT",
  "STATISTICS", "STDIN", "STDOUT", "STORAGE", "STRICT_P", "STRIP_P",
  "SUBSTRING", "SUPERUSER_P", "SYMMETRIC", "SYSID", "SYSTEM_P", "TABLE",
  "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY", "TEXT_P", "THEN", "TIME",
  "TIMESTAMP", "TO", "TRAILING", "TRANSACTION", "TREAT", "TRIGGER", "TRIM",
  "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P", "UNBOUNDED", "UNCOMMITTED",
  "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN", "UNLISTEN", "UNTIL",
  "UPDATE", "USER", "USING", "VACUUM", "VALID", "VALIDATOR", "VALUE_P",
  "VALUES", "VARCHAR", "VARIADIC", "VARYING", "VERBOSE", "VERSION_P",
  "VIEW", "VOLATILE", "WHEN", "WHERE", "WHITESPACE_P", "WINDOW", "WITH",
  "WITHOUT", "WORK", "WRAPPER", "WRITE", "XML_P", "XMLATTRIBUTES",
  "XMLCONCAT", "XMLELEMENT", "XMLFOREST", "XMLPARSE", "XMLPI", "XMLROOT",
  "XMLSERIALIZE", "YEAR_P", "YES_P", "ZONE", "NULLS_FIRST", "NULLS_LAST",
  "WITH_TIME", "IDENT", "FCONST", "SCONST", "BCONST", "XCONST", "Op",
  "ICONST", "PARAM", "'='", "'<'", "'>'", "POSTFIXOP", "'+'", "'-'", "'*'",
  "'/'", "'%'", "'^'", "UMINUS", "'['", "']'", "'('", "')'", "TYPECAST",
  "'.'", "';'", "','", "':'", "$accept", "stmtblock", "stmtmulti", "stmt",
  "CreateRoleStmt", "opt_with", "OptRoleList", "OptRoleElem",
  "CreateUserStmt", "AlterRoleStmt", "AlterRoleSetStmt", "AlterUserStmt",
  "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "DropGroupStmt", "CreateSchemaStmt",
  "OptSchemaName", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "var_name", "var_list", "var_value", "iso_level",
  "opt_boolean", "zone_value", "opt_encoding", "ColId_or_Sconst",
  "VariableResetStmt", "SetResetClause", "VariableShowStmt",
  "ConstraintsSetStmt", "constraints_set_list", "constraints_set_mode",
  "CheckPointStmt", "DiscardStmt", "AlterTableStmt", "alter_table_cmds",
  "alter_table_cmd", "alter_column_default", "opt_drop_behavior",
  "alter_using", "reloptions", "opt_reloptions", "reloption_list",
  "reloption_elem", "ClosePortalStmt", "CopyStmt", "copy_from",
  "copy_file_name", "copy_opt_list", "copy_opt_item", "opt_binary",
  "opt_oids", "copy_delimiter", "opt_using", "CreateStmt", "OptTemp",
  "OptTableElementList", "TableElementList", "TableElement", "columnDef",
  "ColQualList", "ColConstraint", "ColConstraintElem", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_column_list", "columnList",
  "columnElem", "key_match", "key_actions", "key_update", "key_delete",
  "key_action", "OptInherit", "OptWith", "OnCommitOption", "OptTableSpace",
  "OptConsTableSpace", "CreateAsStmt", "create_as_target", "OptCreateAs",
  "CreateAsList", "CreateAsElement", "opt_with_data", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "SeqOptList", "SeqOptElem", "opt_by",
  "NumericOnly", "CreatePLangStmt", "opt_trusted", "handler_name",
  "validator_clause", "opt_validator", "opt_lancompiler", "DropPLangStmt",
  "opt_procedural", "CreateTableSpaceStmt", "OptTableSpaceOwner",
  "DropTableSpaceStmt", "CreateFdwStmt", "DropFdwStmt", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "DropForeignServerStmt",
  "AlterForeignServerStmt", "CreateUserMappingStmt", "auth_ident",
  "DropUserMappingStmt", "AlterUserMappingStmt", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerForSpec", "TriggerForOpt", "TriggerForType", "TriggerFuncArgs",
  "TriggerFuncArg", "OptConstrFromTable", "ConstraintAttributeSpec",
  "ConstraintDeferrabilitySpec", "ConstraintTimeSpec", "DropTrigStmt",
  "CreateAssertStmt", "DropAssertStmt", "DefineStmt", "definition",
  "def_list", "def_elem", "def_arg", "aggr_args", "old_aggr_definition",
  "old_aggr_list", "old_aggr_elem", "enum_val_list", "CreateOpClassStmt",
  "opclass_item_list", "opclass_item", "opt_default", "opt_opfamily",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type", "any_name_list", "any_name", "attrs", "TruncateStmt",
  "opt_restart_seqs", "CommentStmt", "comment_type", "comment_text",
  "FetchStmt", "fetch_direction", "from_in", "GrantStmt", "RevokeStmt",
  "privileges", "privilege_list", "privilege", "privilege_target",
  "grantee_list", "grantee", "opt_grant_grant_option",
  "function_with_argtypes_list", "function_with_argtypes", "GrantRoleStmt",
  "RevokeRoleStmt", "opt_grant_admin_option", "opt_granted_by",
  "IndexStmt", "index_opt_unique", "access_method_clause", "index_params",
  "index_elem", "opt_class", "opt_asc_desc", "opt_nulls_order",
  "CreateFunctionStmt", "opt_or_replace", "func_args", "func_args_list",
  "func_args_with_defaults", "func_args_with_defaults_list", "func_arg",
  "arg_class", "param_name", "func_return", "func_type",
  "func_arg_with_default", "createfunc_opt_list", "common_func_opt_item",
  "createfunc_opt_item", "func_as", "opt_definition", "table_func_column",
  "table_func_column_list", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "CreateCastStmt", "cast_context",
  "DropCastStmt", "opt_if_exists", "ReindexStmt", "reindex_type",
  "opt_force", "RenameStmt", "opt_column", "opt_set_data",
  "AlterObjectSchemaStmt", "AlterOwnerStmt", "AlterSecLabelStmt",
  "OptSecCxt", "SecCxtItem", "RuleStmt", "$@1", "RuleActionList",
  "RuleActionMulti", "RuleActionStmt", "RuleActionStmtOrEmpty", "event",
  "opt_instead", "DropRuleStmt", "NotifyStmt", "ListenStmt",
  "UnlistenStmt", "TransactionStmt", "opt_transaction",
  "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "ViewStmt", "opt_check_option",
  "LoadStmt", "CreatedbStmt", "createdb_opt_list", "createdb_opt_item",
  "opt_equal", "AlterDatabaseStmt", "AlterDatabaseSetStmt",
  "alterdb_opt_list", "alterdb_opt_item", "DropdbStmt", "CreateDomainStmt",
  "AlterDomainStmt", "opt_as", "AlterTSDictionaryStmt",
  "AlterTSConfigurationStmt", "CreateConversionStmt", "ClusterStmt",
  "cluster_index_specification", "VacuumStmt", "AnalyzeStmt",
  "analyze_keyword", "opt_verbose", "opt_full", "opt_freeze",
  "opt_name_list", "ExplainStmt", "ExplainableStmt", "opt_analyze",
  "PrepareStmt", "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "DeallocateStmt", "InsertStmt", "insert_rest",
  "insert_column_list", "insert_column_item", "returning_clause",
  "DeleteStmt", "using_clause", "LockStmt", "opt_lock", "lock_type",
  "opt_nowait", "UpdateStmt", "set_clause_list", "set_clause",
  "single_set_clause", "multiple_set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_options", "opt_hold",
  "SelectStmt", "select_with_parens", "select_no_parens", "select_clause",
  "simple_select", "with_clause", "cte_list", "common_table_expr",
  "into_clause", "OptTempTableName", "opt_table", "opt_all",
  "opt_distinct", "opt_sort_clause", "sort_clause", "sortby_list",
  "sortby", "select_limit", "opt_select_limit", "select_limit_value",
  "opt_select_fetch_first_value", "select_offset_value",
  "select_offset_value2", "row_or_rows", "first_or_next", "group_clause",
  "having_clause", "for_locking_clause", "opt_for_locking_clause",
  "for_locking_items", "for_locking_item", "locked_rels_list",
  "values_clause", "from_clause", "from_list", "table_ref", "joined_table",
  "alias_clause", "join_type", "join_outer", "join_qual", "relation_expr",
  "relation_expr_list", "relation_expr_opt_alias", "func_table",
  "where_clause", "where_or_current_clause", "TableFuncElementList",
  "TableFuncElement", "Typename", "opt_array_bounds", "SimpleTypename",
  "ConstTypename", "GenericType", "opt_type_modifiers", "Numeric",
  "opt_float", "Bit", "ConstBit", "BitWithLength", "BitWithoutLength",
  "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "opt_charset",
  "ConstDatetime", "ConstInterval", "opt_timezone", "opt_interval",
  "interval_second", "a_expr", "b_expr", "c_expr", "func_expr",
  "xml_root_version", "opt_xml_root_standalone", "xml_attributes",
  "xml_attribute_list", "xml_attribute_el", "document_or_content",
  "xml_whitespace_option", "window_clause", "window_definition_list",
  "window_definition", "over_clause", "window_specification",
  "opt_existing_window_name", "opt_partition_clause", "opt_frame_clause",
  "frame_extent", "frame_bound", "row", "sub_type", "all_Op", "MathOp",
  "qual_Op", "qual_all_Op", "subquery_Op", "expr_list", "type_list",
  "array_expr", "array_expr_list", "extract_list", "extract_arg",
  "overlay_list", "overlay_placing", "position_list", "substr_list",
  "substr_from", "substr_for", "trim_list", "in_expr", "case_expr",
  "when_clause_list", "when_clause", "case_default", "case_arg",
  "columnref", "indirection_el", "indirection", "opt_indirection",
  "opt_asymmetric", "ctext_expr", "ctext_expr_list", "ctext_row",
  "target_list", "target_el", "relation_name", "qualified_name_list",
  "qualified_name", "name_list", "name", "database_name", "access_method",
  "attr_name", "index_name", "file_name", "func_name", "AexprConst",
  "Iconst", "Sconst", "RoleId", "SignedIconst", "ColId",
  "type_function_name", "ColLabel", "unreserved_keyword",
  "col_name_keyword", "type_func_name_keyword", "reserved_keyword",
  "SpecialRuleRelation", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,    61,    60,    62,   661,
      43,    45,    42,    47,    37,    94,   662,    91,    93,    40,
      41,   663,    46,    59,    44,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   426,   427,   428,   428,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   430,   431,   431,
     432,   432,   433,   433,   433,   433,   433,   433,   433,   433,
     433,   433,   433,   433,   433,   433,   433,   433,   433,   433,
     433,   433,   433,   433,   433,   433,   434,   435,   436,   437,
     438,   439,   439,   440,   440,   441,   442,   443,   443,   444,
     444,   445,   445,   446,   446,   447,   447,   448,   448,   448,
     448,   448,   448,   449,   449,   449,   450,   450,   450,   450,
     450,   450,   450,   450,   450,   450,   450,   450,   450,   450,
     450,   451,   451,   452,   452,   453,   453,   453,   454,   454,
     454,   454,   455,   455,   455,   455,   456,   456,   456,   456,
     456,   456,   456,   457,   457,   457,   458,   458,   459,   459,
     459,   459,   459,   460,   460,   461,   461,   461,   461,   461,
     462,   463,   463,   464,   464,   465,   466,   466,   466,   466,
     467,   467,   467,   467,   468,   468,   469,   469,   469,   469,
     469,   469,   469,   469,   469,   469,   469,   469,   469,   469,
     469,   469,   469,   469,   469,   469,   469,   469,   469,   469,
     469,   469,   469,   469,   469,   469,   469,   469,   470,   470,
     471,   471,   471,   472,   472,   473,   474,   474,   475,   475,
     476,   476,   476,   476,   477,   477,   478,   478,   479,   479,
     480,   480,   480,   481,   481,   482,   482,   482,   482,   482,
     482,   482,   482,   482,   482,   483,   483,   484,   484,   485,
     485,   486,   486,   487,   487,   488,   488,   488,   488,   488,
     488,   488,   489,   489,   490,   490,   491,   491,   491,   492,
     493,   493,   494,   494,   494,   495,   495,   495,   495,   495,
     495,   495,   496,   496,   496,   496,   497,   498,   498,   499,
     499,   499,   499,   499,   499,   500,   500,   501,   501,   501,
     501,   502,   502,   503,   503,   504,   505,   505,   505,   505,
     506,   506,   506,   506,   506,   507,   508,   509,   509,   509,
     509,   509,   510,   510,   511,   511,   511,   511,   512,   512,
     512,   512,   513,   513,   514,   514,   515,   516,   517,   517,
     518,   518,   519,   520,   520,   520,   521,   522,   523,   523,
     524,   524,   525,   525,   525,   525,   525,   525,   525,   525,
     525,   525,   525,   525,   526,   526,   527,   527,   527,   528,
     528,   529,   529,   530,   530,   531,   531,   532,   532,   533,
     533,   534,   534,   535,   535,   536,   537,   537,   538,   538,
     539,   540,   540,   541,   541,   541,   542,   542,   543,   543,
     544,   545,   545,   546,   546,   546,   546,   547,   548,   549,
     550,   551,   551,   552,   552,   553,   553,   554,   554,   555,
     555,   555,   556,   557,   557,   557,   558,   558,   559,   560,
     560,   561,   561,   562,   562,   563,   563,   563,   563,   564,
     564,   565,   565,   566,   566,   567,   567,   567,   568,   568,
     568,   568,   568,   568,   569,   569,   570,   570,   570,   570,
     570,   571,   571,   572,   572,   573,   573,   574,   575,   576,
     576,   576,   576,   576,   576,   576,   576,   576,   576,   576,
     577,   578,   578,   579,   579,   580,   580,   580,   580,   580,
     581,   581,   582,   583,   583,   584,   585,   585,   586,   587,
     587,   588,   588,   588,   588,   588,   589,   589,   590,   590,
     591,   591,   592,   593,   593,   594,   594,   595,   595,   596,
     596,   597,   597,   598,   599,   600,   600,   601,   601,   601,
     601,   601,   601,   601,   601,   601,   601,   601,   601,   602,
     602,   603,   603,   604,   604,   605,   606,   606,   606,   607,
     607,   607,   607,   607,   607,   607,   607,   607,   607,   607,
     607,   607,   607,   607,   607,   607,   608,   608,   608,   608,
     608,   608,   608,   608,   608,   608,   608,   608,   609,   609,
     610,   610,   610,   610,   611,   611,   611,   611,   611,   611,
     611,   611,   611,   611,   611,   611,   611,   611,   611,   612,
     612,   613,   614,   614,   615,   615,   615,   615,   615,   616,
     616,   617,   617,   617,   617,   618,   618,   618,   618,   618,
     618,   618,   618,   618,   618,   619,   619,   620,   620,   621,
     621,   622,   622,   623,   624,   625,   625,   626,   626,   627,
     627,   628,   628,   629,   629,   630,   630,   631,   631,   632,
     632,   632,   633,   633,   633,   634,   634,   634,   635,   635,
     635,   636,   636,   636,   637,   637,   638,   638,   639,   639,
     640,   640,   641,   641,   642,   642,   642,   642,   642,   643,
     643,   643,   643,   643,   644,   645,   646,   646,   646,   647,
     647,   647,   648,   648,   649,   649,   649,   649,   649,   649,
     649,   649,   649,   649,   649,   649,   649,   650,   650,   650,
     650,   650,   651,   651,   652,   652,   653,   654,   654,   655,
     656,   656,   657,   657,   658,   658,   659,   659,   660,   660,
     661,   661,   661,   661,   662,   662,   663,   663,   663,   664,
     664,   664,   665,   666,   666,   667,   667,   667,   668,   668,
     669,   669,   670,   670,   670,   670,   670,   670,   670,   670,
     670,   670,   670,   670,   670,   670,   670,   670,   670,   670,
     670,   670,   670,   670,   670,   671,   671,   672,   672,   673,
     673,   673,   673,   673,   673,   673,   674,   674,   674,   674,
     674,   674,   674,   674,   674,   674,   674,   674,   674,   674,
     674,   674,   675,   675,   675,   675,   675,   675,   676,   676,
     677,   679,   678,   680,   680,   680,   681,   681,   682,   682,
     682,   682,   682,   683,   683,   684,   684,   684,   684,   685,
     685,   685,   686,   686,   687,   688,   689,   689,   690,   690,
     690,   690,   690,   690,   690,   690,   690,   690,   690,   690,
     690,   690,   691,   691,   691,   692,   692,   692,   693,   693,
     693,   694,   694,   695,   695,   696,   696,   696,   696,   697,
     698,   699,   699,   700,   700,   700,   700,   700,   700,   700,
     700,   700,   700,   700,   700,   700,   700,   700,   700,   700,
     701,   701,   702,   702,   703,   704,   704,   705,   706,   706,
     707,   708,   708,   708,   708,   708,   709,   709,   710,   711,
     711,   711,   711,   711,   711,   712,   713,   713,   713,   714,
     714,   715,   715,   715,   716,   716,   717,   717,   718,   718,
     719,   719,   720,   720,   721,   721,   722,   723,   723,   723,
     723,   723,   723,   723,   724,   724,   725,   726,   726,   727,
     727,   727,   727,   728,   728,   729,   729,   730,   730,   730,
     730,   731,   732,   732,   732,   733,   733,   734,   735,   735,
     736,   737,   737,   738,   739,   739,   740,   740,   740,   740,
     740,   740,   740,   740,   741,   741,   742,   743,   743,   744,
     744,   745,   746,   747,   748,   748,   749,   750,   750,   750,
     750,   750,   751,   751,   751,   752,   752,   753,   753,   754,
     754,   754,   754,   754,   754,   754,   754,   755,   755,   756,
     756,   756,   756,   756,   756,   757,   757,   758,   758,   759,
     760,   760,   761,   761,   761,   761,   761,   761,   761,   761,
     762,   762,   763,   763,   763,   764,   764,   764,   764,   765,
     765,   766,   767,   767,   768,   768,   769,   769,   769,   769,
     769,   769,   769,   769,   770,   770,   771,   771,   772,   772,
     772,   773,   774,   775,   775,   776,   776,   777,   777,   778,
     778,   779,   779,   780,   780,   781,   781,   782,   782,   783,
     783,   784,   784,   785,   785,   786,   786,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   788,   788,
     788,   788,   788,   788,   789,   789,   789,   789,   790,   790,
     790,   790,   791,   791,   792,   792,   793,   793,   793,   793,
     794,   794,   795,   795,   795,   796,   797,   797,   798,   798,
     798,   798,   799,   799,   800,   801,   801,   801,   801,   801,
     801,   802,   802,   802,   803,   803,   803,   803,   803,   803,
     803,   804,   804,   804,   804,   805,   805,   806,   806,   807,
     807,   807,   807,   807,   807,   807,   807,   807,   807,   807,
     808,   808,   809,   809,   810,   810,   811,   812,   813,   813,
     814,   814,   815,   816,   817,   817,   817,   817,   817,   817,
     818,   818,   819,   819,   820,   820,   820,   820,   821,   822,
     822,   822,   823,   823,   823,   823,   823,   823,   823,   823,
     823,   823,   823,   823,   823,   823,   824,   824,   825,   825,
     825,   825,   825,   825,   825,   825,   825,   825,   825,   825,
     825,   825,   825,   825,   825,   825,   825,   825,   825,   825,
     825,   825,   825,   825,   825,   825,   825,   825,   825,   825,
     825,   825,   825,   825,   825,   825,   825,   825,   825,   825,
     825,   825,   825,   825,   825,   825,   825,   825,   825,   825,
     825,   825,   825,   825,   825,   825,   826,   826,   826,   826,
     826,   826,   826,   826,   826,   826,   826,   826,   826,   826,
     826,   826,   826,   826,   826,   826,   826,   826,   827,   827,
     827,   827,   827,   827,   827,   827,   827,   827,   827,   828,
     828,   828,   828,   828,   828,   828,   828,   828,   828,   828,
     828,   828,   828,   828,   828,   828,   828,   828,   828,   828,
     828,   828,   828,   828,   828,   828,   828,   828,   828,   828,
     828,   828,   828,   828,   828,   828,   828,   828,   828,   828,
     828,   828,   828,   828,   828,   828,   829,   829,   830,   830,
     830,   830,   831,   832,   832,   833,   833,   834,   834,   835,
     835,   835,   836,   836,   837,   837,   838,   839,   839,   839,
     840,   841,   841,   842,   842,   843,   843,   843,   844,   844,
     845,   845,   845,   846,   846,   846,   847,   847,   847,   848,
     848,   849,   849,   849,   849,   849,   849,   849,   849,   849,
     850,   850,   851,   851,   852,   852,   852,   852,   852,   852,
     853,   853,   854,   854,   855,   855,   855,   856,   856,   857,
     857,   858,   858,   858,   858,   858,   858,   858,   858,   859,
     859,   860,   861,   861,   862,   862,   862,   862,   862,   862,
     863,   864,   865,   865,   865,   866,   866,   867,   868,   868,
     869,   870,   870,   871,   871,   872,   872,   873,   873,   873,
     873,   874,   874,   875,   875,   876,   876,   877,   877,   878,
     878,   879,   880,   880,   881,   881,   881,   881,   882,   882,
     883,   883,   884,   884,   885,   885,   886,   887,   888,   889,
     890,   891,   892,   892,   893,   893,   893,   893,   893,   893,
     893,   893,   893,   893,   893,   893,   893,   894,   895,   896,
     897,   897,   897,   898,   898,   898,   899,   899,   899,   900,
     900,   900,   900,   900,   901,   901,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   901,   901,
     902,   902,   902,   902,   902,   902,   902,   902,   902,   902,
     902,   902,   902,   902,   902,   902,   902,   902,   902,   902,
     902,   902,   902,   902,   902,   902,   902,   902,   902,   902,
     902,   902,   902,   902,   902,   902,   902,   902,   902,   902,
     902,   902,   902,   902,   902,   903,   903,   903,   903,   903,
     903,   903,   903,   903,   903,   903,   903,   903,   903,   903,
     903,   903,   903,   903,   903,   903,   903,   904,   904,   904,
     904,   904,   904,   904,   904,   904,   904,   904,   904,   904,
     904,   904,   904,   904,   904,   904,   904,   904,   904,   904,
     904,   904,   904,   904,   904,   904,   904,   904,   904,   904,
     904,   904,   904,   904,   904,   904,   904,   904,   904,   904,
     904,   904,   904,   904,   904,   904,   904,   904,   904,   904,
     904,   904,   904,   904,   904,   904,   904,   904,   904,   904,
     904,   904,   904,   904,   904,   904,   904,   904,   904,   904,
     904,   904,   904,   904,   904,   904,   905,   905
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     5,     1,     0,
       2,     0,     2,     2,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       2,     2,     2,     2,     3,     3,     5,     5,     4,     5,
       4,     3,     5,     3,     5,     5,     6,     1,     1,     3,
       5,     7,     5,     1,     0,     2,     0,     1,     1,     1,
       1,     1,     1,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     5,     2,     2,     2,     2,     3,     3,
       3,     1,     3,     1,     3,     1,     1,     1,     2,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     3,     6,
       1,     1,     1,     1,     1,     0,     1,     1,     2,     3,
       4,     3,     2,     2,     1,     2,     3,     4,     3,     2,
       4,     1,     1,     1,     1,     1,     2,     2,     2,     2,
       4,     4,     4,     4,     1,     3,     3,     4,     6,     6,
       6,     6,     4,     7,     2,     4,     3,     3,     3,     3,
       3,     4,     4,     3,     3,     3,     3,     3,     3,     4,
       4,     3,     2,     3,     3,     3,     2,     2,     3,     2,
       1,     1,     0,     2,     0,     3,     2,     0,     1,     3,
       3,     1,     5,     3,     2,     2,    10,     6,     1,     1,
       1,     1,     1,     2,     0,     1,     1,     3,     3,     1,
       1,     3,     3,     3,     4,     1,     0,     2,     0,     3,
       0,     1,     0,    12,    13,     1,     1,     2,     2,     2,
       2,     0,     1,     0,     1,     3,     1,     1,     1,     4,
       2,     0,     3,     1,     1,     2,     1,     3,     4,     4,
       2,     5,     1,     2,     2,     2,     3,     2,     0,     2,
       2,     2,     2,     2,     2,     3,     1,     4,     6,     7,
      11,     3,     0,     1,     3,     1,     2,     2,     2,     0,
       1,     1,     2,     2,     0,     3,     3,     2,     1,     1,
       2,     2,     4,     0,     2,     2,     2,     0,     3,     4,
       4,     0,     2,     0,     4,     0,     7,     5,     3,     0,
       1,     3,     1,     2,     3,     0,     6,     4,     1,     0,
       1,     2,     2,     1,     2,     3,     2,     2,     2,     2,
       3,     3,     1,     3,     1,     0,     1,     2,     1,     5,
       9,     1,     0,     1,     2,     2,     2,     1,     0,     2,
       0,     5,     7,     1,     0,     6,     2,     0,     3,     5,
       7,     6,     8,     7,     6,     6,     4,     0,     1,     3,
       4,     1,     3,     1,     2,     2,     2,     2,     1,     1,
      10,     2,     0,     2,     2,     1,     0,     4,     6,     5,
       4,     4,     8,     1,     1,     1,     7,     9,     8,    14,
      19,     1,     1,     1,     3,     1,     1,     1,     1,     3,
       0,     1,     0,     1,     1,     1,     3,     0,     1,     1,
       1,     1,     1,     1,     2,     0,     1,     2,     1,     2,
       0,     2,     1,     2,     2,     6,     8,     8,     4,     5,
       4,     4,     4,     3,     7,     8,     6,     6,     6,     6,
       3,     1,     3,     3,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     1,     3,     3,     1,     3,    13,     1,
       3,     4,     5,     4,     7,     2,     1,     0,     2,     0,
       1,     0,     6,     8,     8,     1,     3,     5,     5,     7,
       9,     7,     9,     5,     6,     6,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     3,     3,     1,
       3,     1,     2,     2,     3,     5,     2,     2,     0,     6,
       7,     7,     7,     8,     8,     6,     8,     9,     9,     7,
      10,     7,     8,     8,     8,     8,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       4,     2,     4,     2,     0,     1,     1,     1,     1,     2,
       2,     1,     1,     1,     2,     2,     1,     2,     2,     1,
       1,     7,     7,    10,     1,     1,     2,     4,     5,     1,
       3,     2,     2,     2,     2,     1,     2,     2,     4,     3,
       2,     2,     2,     2,     2,     1,     3,     1,     2,     3,
       0,     1,     3,     2,     6,     6,     9,     3,     0,     3,
       0,    13,    14,     1,     0,     2,     0,     1,     3,     4,
       4,     6,     1,     2,     0,     1,     1,     0,     1,     1,
       0,     9,    12,     7,     2,     0,     3,     2,     1,     3,
       3,     2,     1,     3,     3,     3,     2,     2,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     4,     5,     1,
       3,     3,     1,     2,     4,     5,     1,     1,     1,     1,
       3,     3,     2,     2,     2,     2,     1,     2,     2,     1,
       1,     1,     1,     3,     2,     0,     2,     1,     3,     5,
       1,     2,     1,     0,     5,     7,     5,     7,     5,     7,
       3,     5,     5,     5,     1,     3,    11,    10,    10,     2,
       2,     0,     9,     2,     0,     4,     4,     4,     1,     1,
       1,     0,     7,     6,     6,     6,     6,     7,     9,     9,
       6,     6,     6,     6,     6,     8,     8,     6,     6,     6,
       8,     8,     8,     8,     6,     1,     0,     2,     0,     7,
       6,     6,     6,     6,     6,     6,     7,     6,     6,     6,
       6,     7,     7,     9,     9,     6,     6,     6,     8,     8,
       8,     6,     4,     4,     4,     7,     4,     4,     1,     0,
       3,     0,    14,     1,     1,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     1,     1,     1,     1,
       1,     0,     6,     8,     2,     2,     2,     2,     2,     3,
       3,     2,     2,     2,     2,     3,     2,     5,     4,     3,
       3,     3,     1,     1,     0,     3,     2,     2,     1,     3,
       2,     1,     0,     8,    10,     3,     4,     4,     0,     2,
       5,     2,     0,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     4,     3,     3,     1,
       1,     0,     5,     6,     4,     2,     0,     4,     3,     5,
       6,     4,     6,     6,     5,     7,     1,     0,     6,    11,
      11,    11,    13,     9,    11,    10,     4,     2,     5,     2,
       0,     4,     5,     5,     2,     4,     1,     1,     1,     0,
       1,     0,     1,     0,     3,     0,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     5,     3,     0,     1,
       1,     1,     1,     3,     8,     3,     0,     2,     3,     2,
       3,     5,     1,     4,     2,     1,     3,     2,     2,     0,
       6,     2,     0,     5,     3,     0,     2,     2,     2,     3,
       1,     3,     1,     2,     1,     0,     7,     1,     3,     1,
       1,     3,     5,     2,     1,     3,     7,     0,     3,     2,
       2,     2,     0,     2,     2,     1,     1,     3,     3,     1,
       2,     4,     4,     2,     3,     5,     5,     1,     1,     9,
       1,     2,     4,     4,     4,     2,     3,     1,     3,     4,
       2,     0,     3,     3,     4,     4,     4,     4,     2,     1,
       1,     0,     1,     1,     0,     1,     5,     1,     0,     1,
       0,     3,     1,     3,     4,     3,     4,     4,     2,     2,
       4,     3,     5,     8,     1,     0,     1,     1,     1,     3,
       0,     1,     1,     1,     1,     1,     1,     3,     0,     2,
       0,     1,     3,     1,     0,     1,     2,     4,     4,     2,
       0,     2,     3,     2,     0,     1,     3,     1,     2,     1,
       2,     5,     6,     5,     1,     2,     1,     4,     3,     4,
       5,     4,     5,     4,     5,     2,     4,     1,     2,     2,
       2,     1,     1,     0,     4,     2,     1,     2,     2,     4,
       1,     3,     1,     2,     3,     1,     2,     0,     2,     4,
       4,     0,     1,     3,     2,     2,     3,     5,     6,     2,
       3,     3,     4,     0,     1,     1,     1,     1,     1,     2,
       5,     1,     1,     1,     1,     2,     3,     3,     0,     1,
       1,     1,     1,     1,     2,     2,     2,     2,     2,     1,
       3,     0,     1,     1,     1,     1,     5,     2,     1,     1,
       1,     1,     5,     2,     2,     2,     1,     3,     3,     2,
       1,     0,     3,     0,     5,     2,     5,     2,     1,     2,
       3,     0,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     3,     3,     3,     3,     0,     1,     4,     1,     3,
       5,     2,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     2,     3,     3,     2,     3,     5,
       4,     6,     3,     5,     4,     6,     4,     6,     5,     7,
       3,     2,     4,     2,     3,     3,     4,     3,     4,     3,
       4,     5,     6,     6,     7,     6,     7,     6,     7,     3,
       4,     4,     6,     2,     3,     4,     1,     3,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     2,     5,     6,     6,     7,     3,     4,     1,     1,
       2,     4,     1,     1,     1,     2,     2,     2,     1,     4,
       5,     6,     8,     6,     6,     5,     1,     1,     4,     1,
       4,     1,     4,     1,     4,     1,     1,     1,     1,     1,
       1,     6,     4,     4,     4,     4,     6,     5,     5,     5,
       4,     6,     4,     4,     4,     4,     5,     7,     7,     9,
       4,     6,     5,     7,     7,     7,     2,     3,     3,     3,
       4,     0,     4,     1,     3,     3,     1,     1,     1,     2,
       2,     0,     2,     0,     1,     3,     3,     2,     2,     0,
       6,     1,     0,     3,     0,     2,     2,     0,     1,     4,
       2,     2,     2,     4,     3,     5,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     1,     4,     1,     4,     1,     2,     1,     2,
       1,     3,     1,     3,     3,     3,     2,     1,     3,     3,
       0,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       3,     2,     3,     0,     3,     3,     2,     2,     1,     0,
       2,     2,     3,     2,     1,     1,     3,     5,     1,     2,
       4,     2,     0,     1,     0,     1,     2,     2,     2,     3,
       5,     1,     2,     0,     2,     1,     0,     1,     1,     1,
       3,     3,     1,     3,     3,     2,     1,     1,     1,     1,
       1,     3,     1,     2,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1,     2,
       5,     2,     3,     6,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
     106,   914,   444,   987,   986,   914,   225,     0,   989,     0,
     914,   306,   321,     0,     0,     0,     0,   444,   914,     0,
    1005,   644,     0,     0,     0,     0,  1101,   644,     0,     0,
       0,     0,     0,     0,     0,   914,     0,  1108,     0,     0,
       0,     0,  1101,     0,     0,   991,     0,     0,     0,     0,
       2,     4,    49,    50,    18,    17,    23,    22,    71,    72,
      39,    11,    62,    44,   103,   102,   104,    29,    25,    57,
      16,    26,    30,    46,    31,    45,    15,    43,    66,    47,
      69,    36,    60,     8,    37,    61,     9,    51,    73,    21,
      48,    70,    32,    58,    55,    40,    41,    42,    63,    64,
      65,    87,    68,    98,    28,    77,    78,    93,    79,    94,
      80,    38,    10,    90,    89,    91,    33,    59,    88,    92,
      12,    13,    14,    95,    67,    85,    82,    99,    97,   105,
      83,    52,     5,     6,    74,    35,     7,    20,    19,    34,
      27,   101,    24,   989,    76,    86,    75,    53,    81,    56,
      84,   100,    54,    96,  1078,  1065,  1110,  1077,     0,  1080,
     913,   912,   898,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   443,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   922,  1604,  1605,  1606,  1607,
    1608,  1609,  1610,  1611,   285,  1612,  1613,  1614,  1615,  1616,
    1617,  1618,  1619,  1620,  1850,  1851,  1852,  1621,  1622,  1623,
    1624,  1625,  1626,  1627,  1853,  1854,  1628,  1629,  1630,  1631,
    1632,  1855,  1633,  1634,  1635,  1636,  1637,  1638,  1639,  1640,
    1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,  1650,
    1651,  1652,  1653,  1654,  1655,  1856,  1857,  1656,  1657,  1658,
    1659,  1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,
    1669,  1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,
    1858,  1679,  1680,  1859,  1681,  1682,  1860,  1683,  1684,  1685,
    1686,  1687,  1688,  1861,  1689,  1690,  1691,  1692,  1693,  1694,
    1695,  1696,  1697,  1698,  1699,  1700,  1701,  1702,  1703,  1862,
    1704,  1705,  1706,  1707,  1863,  1864,  1865,  1708,  1709,  1710,
    1711,  1712,  1713,  1714,  1715,  1716,  1866,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1867,  1868,  1734,  1735,  1736,  1737,
    1738,  1739,  1740,  1869,  1741,  1742,  1743,  1744,  1870,  1745,
    1871,  1746,  1747,  1748,  1749,  1750,  1751,  1872,  1873,  1752,
    1753,  1754,  1755,  1756,  1757,  1758,  1874,  1759,  1875,  1762,
    1760,  1761,  1763,  1764,  1765,  1766,  1767,  1768,  1769,  1876,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1877,  1787,  1788,
    1789,  1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,
    1799,  1878,  1800,  1801,  1802,  1879,  1803,  1804,  1805,  1806,
    1807,  1808,  1809,  1810,  1811,  1812,  1880,  1813,  1814,  1815,
    1816,  1817,  1818,  1819,  1820,  1881,  1882,  1821,  1883,  1822,
    1884,  1823,  1824,  1825,  1826,  1827,  1828,  1829,  1830,  1831,
    1832,  1833,  1834,  1835,  1836,  1885,  1886,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1847,  1848,  1849,  1593,   284,
    1566,  1594,  1595,   988,   977,   444,     0,   901,   305,     0,
       0,     0,     0,     0,     0,     0,   566,     0,     0,     0,
       0,     0,     0,     0,     0,   154,     0,     0,   316,   315,
       0,     0,   431,     0,   703,     0,     0,   444,     0,     0,
       0,  1019,  1760,  1017,  1057,     0,   226,   229,   227,   228,
       0,     0,   804,   593,     0,   592,     0,     0,     0,   590,
       0,     0,     0,     0,   594,   588,     0,   587,     0,     0,
       0,   591,     0,   589,     0,     0,   902,  1016,  1004,   989,
    1605,   652,   656,   647,   653,   648,   645,   646,  1774,  1587,
       0,     0,     0,   641,  1590,   651,   665,   362,   362,   362,
       0,   664,   669,   362,     0,   895,  1588,   929,  1571,  1100,
       0,     0,   643,   894,  1821,  1008,     0,     0,   808,     0,
     809,     0,  1789,   906,   212,  1798,  1881,  1821,   208,   181,
    1609,     0,     0,   664,     0,   903,   904,  1107,  1105,     0,
    1626,  1639,  1720,   205,  1785,  1790,  1798,  1881,  1821,  1846,
     163,     0,   219,  1798,  1881,  1821,   215,   922,  1997,  1996,
       0,  1081,  1562,  1186,  1559,  1558,     0,   897,   896,  1192,
       0,   990,   993,     0,  1151,  1772,  1085,  1087,   995,  1078,
       0,     1,   106,   984,  1104,  1104,     0,  1104,     0,  1070,
    1078,  1073,  1077,     0,  1895,  1896,  1897,  1898,  1899,  1900,
    1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,  1910,
    1911,  1912,  1913,  1914,  1915,  1916,  1593,     0,     0,  1572,
    1594,  1598,     0,   601,   109,  1567,     0,     0,     0,     0,
       0,  1589,     0,  1630,  1681,  1469,  1479,  1477,  1478,  1471,
    1472,  1473,  1474,  1475,  1476,     0,   794,  1470,     0,   109,
       0,     0,  1186,     0,     0,     0,     0,     0,     0,  1724,
     109,     0,     0,     0,     0,   918,   921,   899,   980,     0,
    1559,     0,     0,   626,     0,   635,   627,   632,     0,   629,
       0,     0,   637,     0,   628,   630,   631,   636,     0,     0,
     633,   634,     0,     0,   910,   362,     0,     0,     0,     0,
       0,   109,   967,     0,   320,   319,   109,   318,   317,  1630,
    1681,     0,   724,   109,     0,   869,   472,   447,     0,     0,
     533,  1724,   109,     0,     0,     0,     0,     0,     0,     0,
       0,  1020,  1018,     0,  1032,  1694,     0,   272,     0,     0,
    1694,   958,     0,  1694,     0,  1694,   149,  1564,  1630,  1681,
    1694,     0,     0,  1694,   141,  1694,     0,  1694,   272,  1694,
     448,     0,  1694,     0,  1694,  1724,   143,     0,  1694,   272,
     599,     0,  1013,     0,   649,   658,   657,   655,   654,   650,
    1591,  1592,   659,   660,     0,   666,     0,     0,   673,   672,
     671,     0,     0,     0,   674,     0,  1190,  1035,     0,   909,
       0,     0,     0,   811,   811,   811,   905,   211,   209,     0,
       0,     0,     0,     0,     0,   911,     0,     0,     0,  1850,
    1851,  1852,  1534,     0,  1853,  1854,  1855,  1399,  1386,  1395,
    1400,  1387,  1389,  1396,  1856,  1857,  1668,  1858,  1859,  1585,
    1860,  1861,  1863,  1864,  1865,  1866,  1391,  1393,  1867,  1868,
       0,  1586,  1870,  1871,  1749,  1873,  1874,  1876,  1877,  1397,
    1879,  1880,  1881,  1882,  1883,  1884,  1584,     0,  1398,  1886,
    1888,  1889,  1890,  1891,  1892,  1893,  1894,  1575,  1577,  1578,
    1480,  1543,     0,     0,  1557,     0,  1374,     0,  1221,  1222,
    1244,  1245,  1223,  1250,  1251,  1263,  1224,     0,  1556,  1288,
    1373,  1378,     0,  1372,  1368,  1091,  1552,  1535,     0,  1369,
    1574,  1576,   174,   221,     0,   222,  1560,  1798,   164,   204,
     176,   203,   177,   207,   206,   175,     0,  1628,   165,     0,
     172,     0,     0,     0,     0,   218,   216,     0,   900,     0,
    1188,     0,     0,  1541,  1563,  1187,   608,     0,  1193,     0,
     992,   989,  1548,  1547,  1549,     0,  1086,     0,     0,     0,
    1068,  1067,     3,   995,  1102,  1103,     0,     0,     0,     0,
       0,     0,     0,     0,  1144,  1125,  1141,  1145,     0,  1074,
    1152,  1573,     0,     0,     0,     0,     0,   602,     0,     0,
       0,   108,   951,   956,   214,   954,   862,     0,     0,     0,
       0,   961,     0,     0,     0,     0,   757,     0,     0,     0,
       0,     0,     0,   758,   756,   759,   766,   780,   783,   867,
       0,   693,   147,   148,     0,     0,   836,   836,     0,     0,
     836,     0,     0,     0,     0,     0,     0,     0,   231,   234,
       0,     0,     0,     0,     0,     0,     0,   111,   138,     0,
       0,   863,   866,     0,   413,   425,     0,     0,     0,     0,
       0,   422,     0,   109,   232,   407,   410,     0,     0,     0,
     481,   480,   836,   836,     0,   230,   864,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   111,
     140,     0,     0,   233,     0,     0,   916,   917,     0,   920,
       0,   976,     0,     0,     0,     0,     0,     0,  1630,  1681,
       0,     0,     0,     0,     0,     0,   308,   291,   292,   109,
     290,     0,     0,   530,     0,  1232,  1261,  1239,  1261,  1261,
    1228,  1228,  1241,  1229,  1230,  1268,     0,  1261,  1228,  1233,
       0,  1231,  1271,  1271,  1256,  1596,     0,  1213,  1214,  1215,
    1216,  1242,  1243,  1217,  1248,  1249,  1218,  1285,  1228,  1597,
       0,   932,   966,     0,     0,   111,   567,     0,     0,   531,
       0,   111,     0,   156,   868,     0,   476,     0,     0,     0,
       0,     0,     0,   492,   491,     0,     0,   532,     0,   111,
     409,     0,   399,   362,     0,     0,  1636,     0,  1570,     0,
       0,  1060,  1062,  1061,     0,  1059,     0,  1201,     0,   272,
     270,   271,   528,   803,     0,     0,     0,     0,   272,     0,
       0,  1694,     0,  1694,     0,     0,   272,   272,     0,     0,
       0,     0,   477,     0,   598,   596,   595,   597,     0,     0,
       0,     0,     0,  1694,   272,     0,     0,   586,  1490,     0,
     321,  1002,   996,  1003,   998,  1000,   999,  1001,   997,   640,
       0,     0,   363,   365,     0,  1653,     0,  1686,  1712,  1790,
    1795,     0,  1816,     0,   675,   698,   670,     0,     0,  1029,
    1022,     0,     0,  1045,   642,  1492,     0,     0,     0,   810,
     807,   806,   805,   210,   182,     0,     0,     0,   700,  1789,
     908,     0,     0,  1376,  1377,  1260,  1247,  1533,     0,     0,
    1255,  1254,     0,     0,     0,     0,  1237,  1236,  1235,  1375,
    1500,     0,  1234,     0,     0,     0,     0,  1261,  1261,  1259,
    1307,     0,  1238,     0,     0,  1513,     0,  1519,     0,     0,
       0,  1267,     0,  1265,     0,     0,  1343,     0,     0,     0,
       0,     0,     0,     0,  1370,  1291,  1292,  1885,  1374,  1490,
       0,  1581,     0,     0,  1253,     0,  1285,     0,     0,     0,
    1546,  1488,     0,     0,  1321,  1486,     0,  1323,     0,     0,
       0,  1555,  1480,  1479,  1477,  1478,  1471,  1472,  1473,  1474,
    1475,  1476,     0,  1484,  1304,     0,     0,  1303,     0,     0,
    1154,  1536,     0,  1579,   223,   224,   220,     0,     0,   179,
     178,     0,   201,   202,   197,   426,     0,   171,   200,     0,
     196,   428,  1438,  1437,   180,   170,   168,   193,   195,   194,
     192,   166,   183,   185,   186,   187,   169,   167,   217,     0,
       0,  1917,  1918,  1919,  1920,  1921,  1922,  1923,  1924,  1925,
    1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,
    1936,  1937,  1938,  1939,  1940,  1941,  1942,  1943,  1944,  1945,
    1946,  1947,  1948,  1949,  1950,  1951,  1952,  1953,  1954,  1955,
    1956,  1957,  1958,  1959,  1960,  1961,  1962,  1963,  1964,  1965,
    1966,  1967,  1968,  1969,  1970,  1971,  1972,  1973,  1974,  1975,
    1976,  1977,  1978,  1979,  1980,  1981,  1982,  1983,  1984,  1985,
    1986,  1987,  1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,
    1599,  1538,  1537,  1569,  1600,  1601,  1602,  1603,  1542,     0,
       0,   272,  1194,     0,  1154,  1047,  1049,  1050,     0,  1543,
     981,  1551,     0,  1088,     0,     0,   985,  1084,  1083,  1111,
    1112,   717,  1082,  1135,  1136,  1130,     0,  1150,  1150,  1127,
    1118,  1126,  1119,     0,  1131,  1288,  1143,  1072,  1124,  1071,
       0,  1146,  1144,  1125,     0,     0,     0,     0,     0,     0,
       0,   603,     0,     0,     0,  1816,   213,   950,     0,   952,
       0,     0,     0,     0,     0,   964,   356,     0,   269,     0,
       0,     0,     0,     0,     0,     0,   764,     0,     0,     0,
       0,   765,   762,   763,  1790,   782,   781,   779,   739,   741,
     740,     0,   743,   727,     0,   728,     0,     0,   738,   746,
     744,     0,     0,   835,   244,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   262,     0,     0,     0,
       0,   267,     0,     0,     0,   266,     0,     0,     0,     0,
       0,     0,   795,     0,   137,     0,     0,   412,   424,     0,
     416,   417,   414,   418,   419,     0,     0,     0,     0,     0,
       0,   411,     0,     0,   474,   473,   479,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   483,   484,     0,   485,     0,   139,     0,     0,     0,
       0,     0,     0,   191,   915,   919,   979,   978,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   294,  1596,     0,
     553,   529,     0,  1213,     0,  1209,  1205,  1274,  1275,  1276,
    1273,  1286,  1272,     0,  1219,  1277,  1228,  1225,     0,   930,
     331,   438,   145,     0,     0,     0,   541,   544,     0,   107,
     869,   152,   471,   475,     0,   446,     0,     0,     0,     0,
       0,   496,   495,   498,   497,     0,   493,     0,     0,     0,
     136,   869,   408,     0,     0,   323,   387,     0,   429,     0,
       0,     0,     0,     0,   871,     0,     0,     0,  1058,     0,
    1164,  1031,  1155,  1166,  1157,  1159,  1195,  1562,     0,     0,
    1029,     0,   786,     0,   959,  1694,   272,     0,   784,   150,
    1565,     0,     0,     0,     0,     0,   788,   583,   142,     0,
     272,   272,   449,     0,   272,   144,     0,     0,     0,   441,
     272,   600,  1015,     0,     0,     0,   667,     0,   361,   681,
       0,     0,   680,   691,   682,   683,   677,   676,   684,     0,
       0,   700,  1024,     0,  1025,  1543,     0,  1021,     0,  1042,
       0,  1040,     0,  1191,  1044,  1033,  1007,     0,  1006,  1010,
    1012,  1011,  1009,     0,     0,     0,   664,     0,     0,   272,
     907,     0,  1496,     0,  1497,     0,     0,     0,  1532,  1528,
       0,     0,     0,     0,     0,  1504,  1505,  1506,  1503,  1507,
    1502,  1501,     0,     0,  1508,     0,     0,     0,     0,     0,
    1258,  1257,     0,     0,     0,     0,     0,     0,     0,  1346,
    1378,     0,     0,  1464,     0,  1490,  1518,     0,     0,  1269,
       0,     0,     0,     0,     0,     0,     0,  1490,  1524,     0,
       0,     0,  1436,     0,  1433,     0,     0,     0,     0,  1544,
    1543,     0,     0,     0,     0,  1582,  1305,  1554,     0,  1545,
       0,     0,  1312,     0,  1525,  1339,     0,  1344,  1327,     0,
    1320,     0,  1325,  1329,  1308,  1546,  1489,     0,  1487,     0,
       0,  1306,     0,  1301,  1299,  1300,  1293,  1294,  1295,  1296,
    1297,  1298,  1289,  1302,  1468,  1466,  1467,     0,     0,     0,
    1324,  1687,  1720,     0,  1101,  1101,  1090,  1099,  1553,     0,
    1197,     0,     0,     0,     0,  1449,     0,  1561,     0,   427,
       0,  1285,     0,  1189,  1539,     0,   606,   607,   605,  1054,
       0,     0,  1201,     0,  1053,   983,   982,  1550,   994,  1089,
       0,   715,   716,     0,   720,     0,     0,  1128,  1142,     0,
    1045,  1045,     0,     0,     0,  1133,  1134,  1121,  1076,  1075,
     551,   550,     0,     0,     0,   847,   813,   604,   848,   814,
     953,   870,     0,   955,     0,     0,     0,     0,     0,   272,
     962,   849,   268,   963,   840,     0,     0,     0,   454,   455,
       0,   760,   761,   850,   815,     0,   841,   742,  1228,   726,
       0,     0,   737,     0,   736,  1228,  1228,   816,   146,   236,
       0,   838,   248,   261,   256,   257,   255,   272,   272,     0,
       0,     0,     0,   258,   253,   254,   250,   263,   264,   824,
       0,   278,   281,   265,   246,   249,   247,   235,     0,  1568,
       0,     0,   790,     0,     0,   827,     0,     0,   120,   122,
     124,     0,     0,   118,   126,   121,   123,   125,   119,   127,
     117,     0,     0,   116,     0,     0,     0,     0,   110,   855,
     820,   415,   420,   822,   423,   843,   421,  1608,  1669,  1799,
       0,   461,   463,     0,   468,   861,   838,   821,     0,   842,
     857,   829,     0,     0,     0,     0,     0,     0,     0,   968,
       0,     0,     0,   856,   834,   845,     0,   828,   823,   844,
       0,     0,   189,   188,   190,     0,     0,     0,     0,     0,
       0,     0,     0,   639,   615,   638,     0,     0,     0,     0,
       0,     0,     0,   609,   307,   288,   289,     0,   287,     0,
     552,     0,     0,  1210,  1206,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1226,     0,     0,   951,   951,   951,
     951,   951,   951,   951,   949,   931,   960,   437,   457,     0,
     572,   540,     0,     0,   362,   156,   321,     0,   155,   157,
     159,   160,   161,   158,   162,     0,   445,   539,   537,   536,
     538,     0,     0,     0,     0,  1202,     0,     0,   406,     0,
     405,     0,     0,     0,   322,   324,   326,   327,   328,     0,
     400,   402,     0,     0,   391,     0,     0,     0,     0,   706,
     731,     0,   749,   732,     0,     0,     0,   769,   775,   771,
     752,   770,     0,  1063,  1064,     0,  1078,     0,  1166,     0,
    1165,  1177,     0,     0,  1183,  1181,     0,  1183,     0,  1183,
       0,  1158,     0,  1160,  1177,  1563,     0,  1649,  1198,  1030,
     272,     0,     0,   451,   272,     0,   272,     0,   272,   272,
       0,   892,   478,     0,   525,     0,     0,   272,   585,  1491,
       0,   668,   364,     0,   679,     0,     0,   690,   685,   687,
       0,   694,     0,     0,  1027,  1028,  1043,  1036,  1038,  1037,
       0,     0,  1034,  1493,   584,     0,     0,   272,     0,   695,
    1106,  1494,  1495,     0,     0,     0,     0,  1529,     0,     0,
    1412,  1388,  1390,  1227,  1402,     0,  1240,  1413,  1414,  1392,
    1394,     0,  1481,     0,     0,  1403,  1348,  1349,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1361,  1360,  1404,  1463,     0,     0,  1516,  1517,  1405,
    1270,  1271,  1271,     0,     0,  1523,     0,     0,     0,  1410,
    1415,     0,     0,  1420,     0,  1441,     0,     0,     0,  1371,
    1491,  1262,  1263,     0,     0,     0,     0,     0,     0,     0,
       0,  1345,  1328,  1322,     0,  1326,  1330,     0,     0,     0,
       0,  1314,  1340,  1310,     0,     0,  1316,     0,  1341,  1101,
    1101,  1101,  1101,  1098,     0,     0,  1153,     0,  1138,     0,
       0,     0,  1449,     0,  1379,  1449,     0,   173,     0,   198,
     184,     0,     0,     0,  1048,  1029,  1051,  1113,     0,  1482,
     720,   718,   719,  1115,     0,     0,  1149,  1148,  1147,  1116,
    1120,  1117,     0,   846,   812,   839,   951,     0,   355,     0,
       0,     0,   965,   436,     0,   435,   433,   453,   754,     0,
    1228,   729,   734,   735,     0,   331,     0,     0,   237,     0,
     245,   242,   259,   251,   260,   252,   275,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   852,
     132,     0,     0,     0,     0,   113,   112,   133,   131,     0,
     130,     0,   465,   466,   464,   460,     0,   467,   469,   865,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   851,   817,   610,     0,     0,   611,   619,     0,
       0,   612,     0,     0,     0,     0,     0,     0,   621,   310,
     295,   299,   967,   967,     0,   300,   967,   296,   967,   293,
    1749,  1471,  1472,   548,   555,   545,   547,   549,   546,     0,
     554,   520,     0,     0,     0,  1211,     0,  1279,  1280,  1281,
    1282,  1283,  1284,     0,  1278,  1285,     0,   951,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   342,     0,
       0,   336,     0,     0,   775,   330,   333,   334,     0,   450,
       0,   542,   543,     0,   151,     0,     0,     0,   500,   494,
       0,   556,   534,     0,  1204,   457,  1016,     0,   396,   323,
     348,   383,     0,   398,     0,   385,   384,   386,     0,   393,
     928,   438,     0,   706,     0,     0,   730,     0,     0,     0,
     767,   772,   768,     0,     0,   745,     0,   753,   723,     0,
    1056,  1168,  1175,     0,  1156,     0,  1182,  1178,     0,  1179,
       0,     0,  1180,     0,     0,  1175,     0,     0,     0,   787,
       0,   272,   785,     0,   579,     0,   581,   789,   272,   272,
     486,     0,   442,   399,   678,   692,   688,     0,     0,   661,
     697,  1023,  1026,  1041,  1039,   700,     0,   662,   699,  1498,
    1246,     0,  1531,  1527,     0,  1499,     0,  1511,  1510,  1512,
       0,  1366,     0,     0,  1358,  1356,  1357,  1350,  1351,  1352,
    1353,  1354,  1355,  1347,  1359,  1521,  1520,  1514,  1515,  1266,
    1264,     0,  1407,  1408,  1409,  1522,  1416,     0,  1435,  1434,
       0,     0,     0,  1422,     0,     0,  1431,     0,  1465,  1252,
    1285,  1290,     0,     0,  1313,  1526,  1331,     0,     0,     0,
    1309,     0,     0,     0,     0,  1318,  1481,     0,     0,     0,
       0,     0,     0,  1093,  1092,  1196,     0,  1140,  1449,  1449,
    1449,  1385,  1452,  1447,  1448,  1380,  1580,     0,     0,  1540,
       0,  1055,  1046,     0,  1114,  1129,  1122,  1130,     0,   357,
       0,     0,   775,   860,   434,   755,     0,   747,   869,     0,
     837,     0,     0,     0,     0,   279,   280,   283,     0,     0,
       0,     0,     0,   573,   559,     0,     0,   574,   575,     0,
       0,   792,   793,   791,   128,   114,   135,   134,   115,   129,
     462,   825,     0,     0,     0,     0,     0,   859,   833,   858,
     831,   830,   832,   826,   488,     0,   613,     0,     0,   614,
     625,   623,   622,   624,   616,   311,   109,     0,     0,     0,
       0,     0,     0,     0,   522,     0,     0,   527,   516,   518,
       0,     0,     0,  1207,  1212,  1287,  1220,   515,     0,   941,
     940,   939,   943,   942,   945,   944,   936,   935,   948,   947,
     934,   933,   938,   937,     0,     0,   340,   344,   345,   343,
     335,   775,   362,   395,     0,     0,     0,   321,     0,     0,
     502,     0,   535,     0,  1203,   482,  1014,   403,     0,     0,
     346,     0,   387,   325,   401,   402,     0,     0,   397,     0,
     923,   440,     0,     0,   705,     0,   733,   750,   751,     0,
       0,   775,   774,   887,   888,   885,   886,     0,  1167,     0,
       0,  1169,     0,     0,  1171,  1173,     0,     0,     0,     0,
       0,  1566,  1449,  1200,  1199,   272,   452,   272,   272,   893,
     526,     0,     0,     0,   686,   272,     0,  1530,  1401,  1411,
    1509,     0,     0,  1367,     0,     0,  1406,  1887,     0,     0,
    1439,  1440,  1421,     0,  1735,  1426,     0,     0,     0,  1583,
    1337,  1335,  1332,     0,  1333,     0,     0,  1315,  1311,     0,
    1317,  1342,  1097,  1096,  1095,  1094,     0,     0,  1443,  1383,
    1384,  1381,  1454,  1451,     0,  1285,  1052,     0,     0,   957,
       0,   775,   395,   748,   329,   238,   239,   240,   241,   274,
       0,   853,   818,     0,     0,   565,     0,     0,     0,     0,
     854,   819,     0,     0,     0,   973,     0,     0,   617,   618,
     294,     0,   297,   302,     0,   303,   298,   301,   524,   523,
     521,   517,   519,  1208,     0,   801,   801,     0,   520,   946,
       0,     0,   332,   395,   369,     0,   337,     0,   458,     0,
     928,     0,   457,   501,     0,     0,   557,   404,   387,     0,
       0,   347,     0,   391,     0,   388,     0,   392,     0,     0,
       0,     0,   430,     0,     0,     0,     0,   707,   714,   714,
     773,     0,   777,     0,   744,   721,     0,     0,  1176,  1185,
       0,  1172,  1170,  1161,     0,  1163,   802,   580,   582,   487,
     689,   696,   272,  1362,     0,     0,     0,     0,  1417,     0,
    1418,  1423,  1427,     0,  1424,  1425,  1334,  1338,  1336,  1319,
    1137,  1139,     0,  1079,     0,  1110,  1449,   199,  1483,     0,
       0,   395,   358,     0,   243,   282,     0,     0,   571,   560,
       0,     0,   576,     0,     0,     0,     0,     0,   620,   286,
     309,   304,   801,     0,   798,   797,   514,     0,   339,   338,
       0,   374,     0,   456,     0,   569,   924,   323,   470,   503,
     504,   499,     0,   391,   352,   350,   354,   351,   349,   353,
       0,   393,   389,   390,     0,   925,     0,   439,   975,     0,
       0,   277,     0,     0,   712,   717,   717,   776,     0,     0,
    1197,  1174,     0,  1162,   663,  1363,     0,  1364,     0,     0,
    1429,  1428,  1442,  1444,     0,     0,  1457,  1109,  1382,  1123,
     362,   359,   273,     0,   563,   570,   561,   571,     0,     0,
     969,     0,   970,   971,   974,   796,   800,   799,     0,   366,
     367,   368,     0,   341,   370,   371,     0,   459,     0,     0,
       0,   393,   382,   869,   926,   927,   277,   714,     0,   393,
     708,   713,   720,   720,   775,   778,     0,  1184,  1365,  1432,
    1419,  1430,     0,     0,  1453,     0,     0,     0,   369,     0,
     562,   578,   577,     0,     0,     0,     0,     0,   372,     0,
     373,   394,   568,     0,   507,   869,   313,   393,   717,   276,
    1197,   710,   709,   722,   891,  1445,  1446,     0,     0,     0,
    1455,  1458,  1456,  1450,   374,     0,   972,     0,   379,     0,
     378,     0,   376,   375,   558,   509,   511,   512,     0,   505,
     508,   510,   513,   314,  1197,   720,   701,   890,   889,     0,
       0,  1462,  1461,  1460,   520,   564,     0,   377,   381,   380,
     489,     0,   702,   711,   873,   884,   872,   874,   882,   879,
     881,   880,   878,     0,   360,     0,   506,     0,   883,   877,
    1078,  1065,  1459,     0,   875,   884,   507,   876,     0,   490
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    49,    50,    51,    52,  1073,  1744,  2268,    53,    54,
      55,    56,    57,    58,    59,    60,    61,  1105,    62,    63,
     794,  1851,  2378,    64,  1666,   631,  1511,  1512,  1794,  1513,
    1497,  1000,  1514,  1074,  1096,    66,    67,   994,  1486,    68,
      69,    70,  1118,  1119,  2678,  1292,  3394,  1735,  3519,  2230,
    2231,    71,    72,  2337,  1199,  2338,  2759,   489,  1816,  3076,
    3077,    73,  1250,  2403,  2404,  2405,  2406,  2366,  2805,  2806,
    2807,  2407,  3140,  3321,  2408,  1676,   868,  1341,  1342,  3421,
    3503,  3504,  3505,  3582,  3142,  2414,  2839,  3148,  3306,    74,
    1271,  1876,  2409,  2410,  2828,    75,    76,  1871,  1145,  1146,
    1749,  2763,    77,   517,  2665,  2367,  2368,  3332,    78,   184,
      79,  1258,    80,    81,    82,    83,  2809,  3307,  1150,  2280,
    2281,  2282,  2283,  2717,    84,  1256,  1151,  1854,    85,    86,
      87,  1783,    88,    89,    90,  1265,  1865,  1866,  3131,  3314,
    3431,  3588,  3589,  3298,  3087,  3088,  3089,    91,    92,    93,
      94,  1249,  1845,  1846,  2764,  1063,  1203,  1819,  1820,  2820,
      95,  3033,  3034,   518,  3509,  3486,    96,    97,  3037,  3038,
      98,    99,   100,   101,   102,   555,   849,   850,  2206,   103,
    1611,   104,   773,  2324,   105,   572,   864,   106,   107,   580,
    1976,   582,  1353,  2487,  2488,  2899,  1942,   708,   108,   109,
    1951,  1979,   110,   519,  2845,  3336,  3337,  3455,  2144,  2643,
     111,   520,  1101,  1704,  1883,  2421,  2422,  1706,  1707,  2854,
    1708,  2423,  2428,  2429,  2430,  2850,  2858,  3342,  3343,   112,
    1098,  1697,   113,   114,   115,  1123,   725,   116,  3414,   117,
     819,   118,   601,  1370,   119,  1715,  2679,   120,   121,   122,
    1253,  1254,   123,  2432,  3616,  3627,  3628,  3629,  3167,  3599,
     124,  3618,   126,   127,   128,   162,   745,   746,   747,   129,
    3150,   130,   131,  1839,  2365,  1668,   132,   133,  1669,  2173,
     134,   135,   136,  1243,   137,   138,   139,   140,  1181,   141,
     142,   143,   484,   652,  1031,  1039,   144,  1332,   559,   145,
     881,  1968,   146,   852,   147,  3619,  1359,  1953,  1954,  1957,
    3620,  1287,   150,  1363,  1962,  1965,  3621,  1614,  1615,  1616,
    1617,  1618,  2130,   152,   813,  1887,  3622,   966,   155,   156,
     157,   158,   656,   657,  1480,  2106,   590,  1046,   619,   668,
     669,  1629,  1630,  1648,  1649,  1640,  2146,  1642,  1643,  2157,
    1635,  2987,  3238,  1646,  1647,  1056,  1057,  2150,   159,  2110,
    1891,  1892,  1893,  2440,  2450,  2867,  3174,  1894,   877,   650,
    1895,  2618,  1900,  2394,  2395,  1709,  1826,  1227,   967,  1228,
    1837,   968,  1402,  1230,   969,   970,   971,  1233,   972,   973,
     974,   975,  1386,  1444,   976,   977,  1421,  1834,  1835,  1328,
    2018,   979,   980,  2956,  3217,  3208,  2043,  2044,  1504,  2952,
    3383,  3472,  3473,  2995,  2993,  3242,  3385,  3537,  3570,  3571,
     981,  2097,  1473,   727,   982,  2766,  1475,  2038,  1655,  1384,
    1985,  2002,  2003,  2015,  2534,  2022,  2027,  2557,  2558,  2039,
    2065,   983,  1988,  1989,  2518,  1388,   984,  1023,  1024,  1434,
    2061,  1034,  1035,   654,   985,   986,   987,  1354,   643,  3170,
     827,   704,  2238,  1602,   749,   587,   988,   989,   990,   991,
    1784,  1501,   644,   699,  2284,   481,   482,   701,  1607,   645
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -3275
static const int yypact[] =
{
    7856,   -19,  6082, -3275, -3275,   -19, -3275, 37654,   412,   141,
      10,   115,  9806, 38050, 43198,   695,   164,  7312,   -19, 43198,
    1147, 28118, 33298,   830, 43198,   567,   685, 28118, 43198, 43594,
     843,   577, 43990, 38446, 32902,   586, 43198,   264, 44386, 38842,
     783, 34486,   685, 25703, 34486,  1085,   853, 44782,   961,  1287,
     876, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275,   412, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275,   200, -3275,   600,   202,   861,   891,
   -3275, -3275, -3275, 31318, 43198, 43198, 43198,  1248, 31318, 43198,
   36070, 23242, -3275, 43198, 43198, 34486, 43198, 34486, 43198,  1037,
   43198, 43198, 45178, 36070,  1180,   135, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, 36070,  4048,   567, -3275, -3275, 36070,
    1053, 31318, 43198,   858,  1039, 43198, -3275, 43198,  1317,   458,
   43198,   721, 23655,  1142, 43198, 43198, 43198, 43198, -3275, -3275,
    1145, 43198, -3275, 43198, -3275, 45574,   744,  1182,  1416,  1301,
     110, -3275, 39238, -3275, -3275, 34486, -3275, -3275, -3275, -3275,
   31714, 43198,  1383, -3275, 45970, -3275,  1425, 32110, 46366, -3275,
   24068,  1550, 46762, 47158, -3275, -3275, 47554, -3275, 47950,  1220,
   48346, -3275, 48742, -3275,  1411, 49138, -3275,  1202, -3275,   412,
     931, -3275,   225,   142,   257,   144,   152,   162,   931, -3275,
    1233,  1233,  1077, -3275, -3275, -3275,   -14,  1229,  1229,  1229,
    1419,   375, -3275,  1229, 36070, -3275, -3275, -3275, -3275, -3275,
   34486,  1077, -3275, -3275,   567,  1255,  1627, 43198, -3275, 43198,
   -3275, 36070, 43198, -3275, -3275,  1650,  1295,  1517,  1282, -3275,
    1468,  1496,  1476,    55,   567,  1402, -3275, -3275,  1513, 14224,
     567, 34882, 49534,   348, 29730,   567, 39634,  1367,   135,  1547,
   -3275,   409, -3275,  1761,  1403,  1652,  1282,   135, -3275, -3275,
   21218, -3275,   -90,  1393, -3275, -3275, 34486, -3275, -3275, 49930,
    1523, -3275,  1725, 14641, -3275, 43198,  1439, -3275,  1455,  1459,
    1461, -3275,  7856, 36070,   714,   714,  1860,   714,  1127,  1129,
   -3275,  1369, -3275,   853, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275,   964,   -90,  1486, -3275,
     982, -3275,    73,  1488,   890, -3275,   178,  1534,  1257,  1502,
     337, -3275,  1838, 43198, 43198, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275,  1507, -3275, -3275,  1490,   913,
     421,  1536,  2888,   650,   146,    76,   598,  1707,   872,  1835,
     936,  2023, 43198,  1749,    21, -3275,    27, -3275,  1611,  1734,
    1735, 31318,  1561, -3275, 43198, -3275, -3275, -3275, 31318, -3275,
    1758, 24481, -3275, 43198, -3275, -3275, -3275, -3275,  1682, 43198,
   -3275, -3275,  1811, 43198, -3275,  1229,   704,  1579,  1955, 54286,
   43198,  1665,  2012,  1668, -3275, -3275,  1665, -3275, -3275, 43198,
   43198,  1634,   601,  1665,  2024,   153,  1709,  1815,   599,  1405,
     118,  1950,  1665, 36070, 36070, 36070,  1902, 43198, 50326, 31318,
   43198, -3275, -3275,   920,  1738,  1969,  1486,   172,  1974,  1683,
    1979, -3275,  1723,  1995,  1502,  2000,  1703, -3275, 50722, 51118,
    2002,  1507, 43198,  2007,  1703,  2014,  1895,  2021,   172,  2022,
   -3275,   641,  2027,  1922,  2042,  1308,  1703, 30128,  2045,   132,
   -3275, 16309, -3275,   854, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, 43198,  1750, 43198, 43198, -3275, -3275,
   -3275, 33694, 43198, 35278, -3275,   417, -3275,    41, 43198, -3275,
   54286,  2151, 43198,  2041,  2041,  2041, -3275, -3275, -3275,  1985,
   43198,  2044,  2046, 33694, 43198, -3275, 51514,  1762,   540,  1777,
     866,  1780, 16309,  1763,    97,    97,  1764, -3275, -3275, -3275,
    1086,  1766,  1767, -3275,  1088,  1088,  1926,  1771,  1772, -3275,
    1095,  1774,  1794,  1795,  1121,  1781,  1782,  1785,  1453,    97,
   16309, -3275,  1789,  1088,  1790,  1796,  1797,  1814,  1798, -3275,
    1818,  1803,  1065,  1106,  1804,  1808, -3275,  1771, -3275,   197,
    1809,  1817,  1819,  1823,  1825,  1826,  1827, -3275, -3275, -3275,
   -3275, -3275, 16309, 16309, -3275, 13390, -3275,   567, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275,   130, -3275,  1126,  4401, -3275,
   -3275,  1947, 16309, -3275, -3275,    53, -3275,   -90,  1128, -3275,
   -3275, -3275, -3275, -3275,   216,  1806, -3275,   313, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, 29332,  2213, -3275,   630,
      27,   917,  2159, 26891, 27300, -3275, -3275,  2047, -3275, 36070,
   -3275, 16309, 25307, -3275,   -90, -3275,    89, 43198, -3275, 21616,
   -3275,   412, -3275,  9571, -3275,  1022,  1439, 43198, 43198,  2227,
   -3275, -3275, -3275,  1455, -3275, -3275,   861,   861, 16309,   861,
     649,    29, 15058, 16309,  2118,   638,  2120, -3275,  1127,  1129,
   -3275,   -90, 26099,   875,  1912,  1914, 30526,  1834,  1916,  1917,
   51910, -3275,  1853, -3275, -3275, -3275, -3275,   148,   208,  1919,
     173, -3275, 43198,  2025,  1230,  1959, -3275,  1930,  1933,  2049,
    1230,   224, 52306, -3275, -3275, -3275, -3275, -3275,  2078, -3275,
   12181, -3275, -3275, -3275,  1935,  1920,   322,  2224,  2043,    56,
    1235,   176, 36070,  2122,  1940,  1943,  1866,  1052,  1862, -3275,
    1927,  1928, 53494,  2038, 24894,  1957, 49534, -3275, -3275,  1961,
    1962, -3275, -3275,  1230, -3275,  2255,  1230,  1230,   902,  2264,
    1965,  1177,   862,  1665,  1862,  1649, -3275,  1888,  1970,    33,
   -3275,  2069,  2224,   190,   870,  1862, -3275,  1972,  1977, 43198,
   43198, 43198, 43198, 36070,  1978,  1980,  2017, 36466,  1982, -3275,
   -3275,  1983,  1089,  1862,   821,  1031, -3275, -3275,   135, -3275,
   43198, -3275, 36070,  1486, 54286,  2086,  1502,  1230, 43198, 43198,
    1507,   157,   675,  2087, 43198,  2152,  1949, -3275, -3275,  1665,
   -3275, 26495,  1634, -3275,  1915, -3275,  1964, -3275,  1964,  1964,
    1929,  1929,  1932, -3275, -3275, -3275,  1453,  1964,  1929, -3275,
   55474, -3275,   713,   904, -3275, -3275,  2311,  2316, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275,   101,   318, -3275,
    2327, -3275, -3275, 54286, 43198, -3275,  2246,  1986, 30526, -3275,
    1984, -3275, 43198, -3275, -3275,   567,  1975, 43198,  2162, 43198,
   43198, 43198, 43198, -3275, -3275,   676,    85, -3275, 36466, -3275,
    1649,  2337,    -1,  1229, 29730,  2229, 43198,  2125, -3275,  1953,
    2346, -3275,  1234, -3275,  2079, -3275, 19626,  2004, 31318,   172,
   -3275, -3275, -3275, -3275, 54286, 43198, 52702, 31318,   172, 43198,
   43198,  2262,  2028,  2263,  2030, 24894,   172,   133, 43198, 43198,
   36070, 43198, -3275, 43198, -3275, -3275, -3275, -3275, 43198, 36070,
   43198, 36466,  2266,  2270,   172, 43198, 43198, -3275,  9571,  1103,
     548, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   43198,  1148, -3275, -3275,  1159, 43198,   131, 31318, 43198, 43198,
   36070, 36070, 43198,  2052,  1806,   745, -3275,  2031, 20820,  2108,
   -3275,   381, 34486,  2170, -3275, -3275,  1267,  1134,   648, -3275,
   -3275, -3275, -3275, -3275, -3275, 35278, 33298,  2267,   181, 43198,
   -3275, 16309, 13807, -3275, -3275, -3275,  1987,  9571,  2034, 16309,
   -3275, -3275, 16309,  1233,  1233, 16309, -3275, -3275, -3275, -3275,
     778,  1233, -3275, 16309, 16309,  1233,  1233,  1964,  1964, -3275,
    3805, 16309, -3275, 24894, 16309, 17977, 11367, 16309,  2060,  2011,
    1233, -3275,  1233, -3275, 16309, 12973, -3275, 16309,  2192, 16309,
     917,  2201, 16309,   917,   -90,  1990,  1990,   853,  1277,  5117,
    1988, -3275,  2105,  1233, -3275,  1233,   207, 16309, 30526,  2077,
     183, 16309,  1998,  1192, -3275, 16309,   226, -3275,  1999, 16309,
    2080, -3275,   267, 16309, 16309, 16309, 16309, 16309, 16309, 16309,
   16309, 16309, 54286, -3275, 18394,   285,   -28,   734, 35674, 14224,
    2287,  1036, 10949, -3275, -3275, -3275, -3275, 36070,  2213, -3275,
   -3275,  2084, -3275, -3275, -3275, -3275,   -62, -3275, -3275,  1144,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275,  2006, -3275, -3275, -3275, -3275, -3275,  2006, -3275,  2008,
    2883, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,  2282,
    2283,   172, -3275, 43198,    57, -3275, -3275, -3275,  2032, -3275,
   34090, -3275, 14641, -3275,  1270,  1771, -3275,  2265, -3275,  2019,
   -3275,  4081,  2265, -3275, -3275,  1207,  2196,  2207,  2207, -3275,
     -30,  9571,  2252,  1341,  9571,  1456, -3275, -3275, -3275, -3275,
       8, -3275,  2118,   638,  2029,  1276,  2107,  2109,  2156, 43198,
   43198, -3275, 30526, 43198, 43198, 43198, -3275, -3275,   567,  2394,
    2039, 43198,  2279,  2281,  2061, -3275, -3275, 43198, -3275,  2233,
   43198, 16309,  2234, 43198,   596,  2236, -3275,   850, 43198, 43198,
    2242, -3275, -3275, -3275, 29730, -3275, -3275, -3275,  2222, -3275,
   -3275, 55474, -3275, -3275,  1278, -3275, 54682, 40030, -3275, -3275,
     287, 43198, 43198, -3275, -3275, 43198, 43198, 43198, 43198, 36862,
   43198, 43198,   654,   832, 43198, 37258, -3275, 36070, 43198, 43198,
   30526, -3275, 43198,  2245,   186, -3275,  2241, 43198, 43198,  2059,
    1285,  2147, -3275, 43198,  5617, 43198, 43198, -3275, -3275,  1230,
   -3275, -3275, -3275, -3275, -3275, 43198, 43198,  1230, 43198,  1230,
     813, -3275, 30922, 43198, -3275, -3275, -3275, 43198, 43198, 43198,
   43198, 43198, 43198,   717,     7,  2208,  2209,  2210, 43198, 43198,
   43198, -3275, -3275,  2188, -3275, 43198,  5617, 43198, 43198,  2154,
    2158,   122,  2225, -3275, -3275, -3275, -3275, -3275,  2322,  2481,
   43198,  2328,  2329,  2142,  2146,  2333,   424, 43198, 43198, 43198,
   43198, 43198, 43198,  2339,   424,  2271,    98, -3275,  2110,  1296,
   -3275, -3275, 16309,  2494, 54286,  2101,  2111,  2184,  2189,  2194,
   -3275,  2123,  2198,  1233, -3275, -3275,  1302, -3275,   676,   703,
   -3275,    65,  5617,  2397, 43198,  1298, -3275,  2143, 36070,  5617,
    1536,   223, -3275, -3275,  2417, -3275,   567,  1634,  1634,  1634,
    1634, -3275, -3275, -3275, -3275,   642, -3275,  2141, 43198,  2257,
    5617,  1536,  1649,   558, 36070, 32506,  1392,  2532,  2419,   567,
    2326, 36070, 12577,  2332, -3275,  2418,  2420,  2435, -3275, 19228,
   40426,  2145,  1166, -3275, 40426, 40822, -3275,   -90,  2153, 16726,
    2108,  1486, -3275,  2551, -3275,  2452,   172,  1502, -3275,  1703,
   -3275, 43198, 43198, 43198, 43198,  1507, -3275, -3275,  1703,  2336,
     172,   172, -3275,  2338,   172,  1703,  2272,  2448, 29730, -3275,
     132, -3275, -3275, 16309,  2249,  1306, -3275, 43198, -3275,  1703,
    2203, 43198,  2163, -3275,  1703,  1703,  1806,  1806,  1703, 41218,
    2578,  2447, -3275,  1321, -3275, -3275, 14224, -3275,   127, -3275,
     535,   416,  2384, -3275, -3275, -3275, -3275, 54286, -3275, -3275,
   -3275, -3275, -3275, 43198,   165,  2356,  2172, 41218,  2561,   172,
   -3275,  1329, -3275,  1112, -3275,  1176, 16309, 16309,   143, -3275,
    5196,  1338,  2178,  2179,  1358, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275,  2181,  2466, -3275,  2186,  1359,  1401,  2195,  2202,
   -3275, -3275,  3714,  2205,  6342,  2206, 17977, 17977,  2403, -3275,
   -3275, 17977,  2211, -3275,  1426,  4614,  2180,  2215,  2214, -3275,
    2216,  2218,  6682, 15475, 16309, 15475, 15475,  5867,  2180,  2219,
    1429, 30526,  7161,  1442, -3275, 16309, 30526,  4001, 16309, -3275,
   -3275, 16309, 43198,  2220,  2226, -3275,  3805, -3275,  2248, -3275,
   17977, 17977,  3161, 13390, -3275, -3275,  2479, -3275, -3275,  1100,
   -3275,  2200, -3275, -3275,  4764,   252, 16309,  1998, 16309,  2277,
   24894,  4361, 16309,  4561,  3672,  3672,   270,   270,   121,   121,
     121,   120, -3275,   734, -3275, -3275, -3275,  2204,  1798, 16309,
   -3275,  1043,  1076, 36070,  3555,  3807, -3275, -3275, -3275, 19626,
    2253, 16309, 16309, 16309,  2228,  2402,  1444, -3275,   135, -3275,
    1233,   207, 27709, -3275, -3275, 16309, -3275, -3275, -3275, -3275,
    1462, 21616,  2004, 14641,   -90, -3275, -3275, -3275, -3275, -3275,
   16309, -3275, -3275,  3115,  1417, 16309,  1341, -3275, -3275, 36070,
    2170,  2170, 16309, 16309, 15058, -3275, -3275,  2523, -3275, -3275,
   -3275, -3275, 43198, 43198, 43198, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275,  2461, -3275, 16309,   249,  2237,  2239, 43198,   172,
   -3275, -3275,  9571, -3275, -3275,  2291,  2319, 43198,  2069, -3275,
    2497, -3275, -3275, -3275, -3275,  2436, -3275, -3275,   318, -3275,
   40030, 54682, -3275, 54682, -3275,   318,  1238, -3275,  1703, -3275,
   54286,   106, -3275, -3275, -3275, -3275, -3275,   172,   172, 43198,
   43198, 43198, 43198, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
    1464, -3275,   -77, -3275, -3275, -3275, -3275, -3275,   977, -3275,
     720, 54286, -3275, 53890, 43198, -3275, 43198,  2472, -3275, -3275,
   -3275,  2410,   215, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275,   440, 43198, -3275,  1233,  2411, 43198,  2310, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, 30526, 30526, 30526,
    1467, -3275, -3275,   567, -3275, -3275,    84, -3275,  2331, -3275,
   -3275, -3275,  2468,  2469,  2473,  2334,  2342,  2343,  2344, -3275,
    2347,  2348,  2349, -3275, -3275, -3275, 43198, -3275, -3275, -3275,
   43198, 43198, -3275, -3275, -3275,   424, 54286,  2502,   424,   424,
   43198, 43198,   424, -3275, -3275, -3275,  2503,  2511,  2516,  2517,
    2519,  2520,   424, -3275, -3275, -3275, -3275,   704,  2526, 22829,
   -3275,  2299,  6755,  2284,  2111,  2278,  1233,   711,   483,   513,
    2399,  1233,  2495,  2286, -3275,   793,  2522,  1853,  1853,  1853,
    1853,  1853,  1853,  1853, -3275, -3275,   147, -3275,  2460,  2361,
   -3275, -3275, 30526, 22829,  1229, -3275,   856, 33298, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275,  2631, -3275, -3275, -3275, -3275,
   -3275, 36070,   676,   567,  1473, -3275, 54286, 43198, -3275, 43198,
    2340,  2300, 36070,  2303,  2302, -3275, -3275, -3275, -3275,  1482,
   -3275, 54286,     9,  2487,  2488,   961, 43198,  2388, 36070,  2370,
   -3275,  1484,    86, -3275,   567, 29730, 53098, -3275,  3617, -3275,
   -3275, -3275,  2496, -3275, -3275,   961, 11785,  1166,  2313, 43198,
   -3275,  2315, 19626,  2557,  2490, -3275, 19626,  2490,   184,  2490,
    2559, -3275, 22014, -3275,  2320,   692, 10949,  2508,  9571, -3275,
     172, 54286, 43198, -3275,   172,  2382,   172,  2385,   172,   172,
   36070, -3275, -3275, 36070, -3275, 43198, 36466,   172, -3275,  9571,
   36070, -3275, -3275, 43198,  1703, 31318, 43198,   755, -3275, -3275,
    2505, -3275,   961, 43198,   -90,  2325, -3275, -3275, -3275, -3275,
    2630,  2634, -3275, -3275, -3275, 43198, 33694,   193, 43198, -3275,
   -3275, -3275, -3275,  2341,  1487,  7525, 16309, -3275,  2647, 54286,
   -3275, -3275, -3275, -3275, -3275, 16309, -3275, -3275, -3275, -3275,
   -3275, 16309, -3275, 16309,  2627, -3275,  2345,  2345, 17977,   927,
    1790, 17977, 17977, 17977, 17977, 17977, 17977, 17977, 17977, 17977,
   54286, 18811,   457, -3275, -3275, 16309, 16309,  2633,  2627, -3275,
   -3275,   623,   623, 54286,  2351,  2180,  2359,  2360, 16309, -3275,
   -3275,  1493, 30526, -3275, 16309,  5091,  1498,  2396,  7956,   -90,
    8450, -3275,  2723,   567, 16309,  1599,  1658, 16309,  1508, 16309,
    2644, -3275, -3275, -3275,  2364, -3275, -3275, 54286, 16309, 17977,
   17977,  5140, -3275,  5638, 16309,  2365,  5997, 13390, -3275,   685,
     685,   685,   685, -3275, 36070, 36070,  2145, 16309,  2640,  1509,
    1524,  8473,  2402, 22412, -3275,    43, 15892,    27,  2367, -3275,
   -3275,  8131,  2386, 43198, -3275,  2108, -3275, -3275,  2369, -3275,
    1417, -3275, -3275, -3275,  8556,  2553,  1806, -3275, -3275, -3275,
   -3275, -3275,   649, -3275, -3275, -3275,  1853,  8605, -3275, 43198,
   43198,  1529, -3275, -3275, 43198, -3275,  1488, -3275, -3275,  2625,
    1266, -3275, -3275, -3275,  2445, -3275,   701,   750, -3275,  2458,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, 30526, 22829, 30526,
    2471,  2480,   125,   632,  2484,  2485,  2400,  2408,  2409, -3275,
    1703,   931,   567, 43198, 43198, -3275, -3275,  1703, -3275,   567,
    1703,   567, -3275, -3275, -3275, -3275, 30922, -3275, -3275, -3275,
   43198,  2690,   539,  1424, 43198, 43198, 43198, 43198, 43198, 43198,
   43198,  2069, -3275, -3275, -3275,  2412,   424, -3275, -3275,  2654,
    2655, -3275,   424,   424,   424,   424,   424,   424, -3275,   109,
   -3275, -3275,  2012,  2012,   973, -3275,  2012, -3275,  2012, -3275,
    2369,  1233,   -62, -3275, -3275, -3275, -3275, -3275, -3275,  2110,
   -3275,   582,  1233,  1445,  2415, -3275,  2416, -3275, -3275, -3275,
   -3275, -3275, -3275,  2423, -3275,   207, 36070,  1853,    63,    91,
      95,    99, 41614, 42010, 42406,  2426, 43198, 17977, -3275,   610,
     658, -3275,  2656, 36070,  2457, -3275, -3275, -3275,  2427, -3275,
   54286, -3275, -3275,  2818,   223,  2556,   749,  2470,  2715, -3275,
    1531, -3275, -3275, 43198, -3275,  2460,  1202,   643, -3275, 32506,
   -3275,  2687, 32506, -3275, 43198, -3275, -3275, -3275,  2793,  2524,
    2474,    65,   567,  2370, 43198,  2434, -3275, 40030, 16309, 16309,
   -3275,  2438, -3275,  2439,  3305, -3275,  1634, -3275, -3275,   563,
   -3275, 40426,  2440, 43198,  1166, 19626, -3275, -3275,  1807, -3275,
   19626,  2684, -3275, 19626, 43198,  2450, 43198,  1532, 28527, -3275,
    2444,   172, -3275, 43198, -3275, 43198, -3275, -3275,   172,   172,
   -3275,  2569, -3275,  2459,  1703, -3275, -3275,  2744, 41218, -3275,
   -3275, -3275, -3275, -3275, -3275,   181,  2756, -3275, -3275, -3275,
   -3275, 16309,  9571, -3275,  2478,  9571,  8886,  9571,  2633,  2840,
    2762, -3275,   682,  2483,  2840,  2476,  2476,  1258,  1258,  1244,
    1244,  1244,  2345, -3275,   457,  9571,  9571, -3275, -3275, -3275,
   -3275,  2486, -3275, -3275, -3275,  2180, -3275, 17143, -3275, -3275,
    2527,  2528,  2492, -3275, 16309, 17560,  2491, 55474, -3275, -3275,
     207,  1990, 17977, 17977,  2199, -3275,   114, 16309, 54286,  1545,
    2199,  1700,  2064, 16309, 16309,  7180,   298, 16309,  8918, 36070,
   36070, 36070, 36070, -3275, -3275,  9571,  2869,  2761,  2402,  2402,
    2402, -3275, 55078, -3275, -3275, -3275, -3275, 16309,   567, -3275,
     853, -3275, -3275, 24894, -3275, -3275, -3275,  1207,   931, -3275,
    1546,  1555,  2457, -3275,  1834, -3275,  2560, -3275,  2157,  2685,
   -3275,  2688,   931, 43198, 54286, -3275, -3275,  2510, 43198, 43198,
    1233,  1233, 54286,  2512, -3275,  1233,  1233,  2513, -3275, 43198,
   43198, -3275, -3275, -3275, -3275, -3275,  1703,  1703, -3275, -3275,
   -3275, -3275, 43198, 43198, 43198, 43198,  2796, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275,  2743, -3275,   424,   424, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275,  1665,  2821,   567,   567,
    2692, 43198,   567,   567, -3275,   818,  2833, -3275,  2766,   659,
    2514,  1079,  2795, -3275, -3275, -3275, -3275,  2798,   931, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, 16309,   536,  2840, -3275, -3275, -3275,
   -3275,  2457,  1229,  2577, 30526,  2580,   961,   548, 36070, 43198,
    2829,  2822, -3275,   567, -3275, -3275, -3275, -3275,  2859,  2525,
     895,  2529,  1392, -3275, -3275, -3275,   180, 43198, -3275,   278,
   -3275,  2769,  2810,  2534, -3275, 20024, -3275,  9571,  9571,   567,
   55870,  3617, -3275, -3275, -3275, -3275, -3275,  2610, -3275, 43198,
    1563, -3275, 16309,  2535, -3275, -3275, 19626,  1807,  1568, 43198,
    1570, 54286,  2402, -3275, -3275,   172, -3275,   172,   172, -3275,
   -3275, 43198, 43198,  2713, -3275,   172, 41218,  9571, -3275, -3275,
   -3275, 17977,  2819, -3275,  2539, 54286, -3275,  2540,  1584,  1602,
   -3275, -3275, -3275,  8964,  2596,  9571,  2645,  2542,  2544, -3275,
    2133,  2133,   114,  1603, -3275, 17977, 17977,  2199,  2199, 16309,
    2199, -3275, -3275, -3275, -3275, -3275, 16309, 16309,  2589, -3275,
   -3275, -3275,  2712, -3275,  9235,   207, -3275,  2548,  1341, -3275,
    2693,  2457,  2577, -3275, -3275, -3275, -3275, -3275, -3275,  2608,
   22829, -3275, -3275, 20422, 24894, -3275,   125,  2552,  2554,   632,
   -3275, -3275,   852,   -20,  2597,  1703,  2842,   424, -3275, -3275,
   -3275,   567, -3275, -3275, 43198,  2558, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, 31318,  2956,  2956, 36070,   582, -3275,
    9251,  2748, -3275,  2577,  2778,  2825, -3275,  1604, -3275, 43198,
    2474,    38,  2460, -3275,   930,  2716, -3275, -3275,  1392,   694,
     946, -3275, 36070,  2488,  2691, -3275,  2694, -3275,  2940,  2749,
    2944,   567, -3275, 43198, 20024, 16309,  1609, -3275, 42802, 10548,
   -3275, 54682, -3275,  1615, -3275, -3275, 36070,  1617, -3275,  9571,
   43198, -3275, -3275, -3275,  1618, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275,   193,  1232, 17977, 54286,  1624, 16309, -3275, 16309,
   -3275, -3275, -3275,   -12, -3275, -3275, -3275,  2133,  2133,  2199,
    2180,  9571, 43198, -3275,  2957,  2750,  2402, -3275, -3275,  2754,
   36070,  2577, -3275, 16309, -3275, -3275, 54286,  1502,    39, -3275,
   54286, 54286, -3275, 43198, 43198, 43198, 43198, 43198, -3275,  2526,
   -3275,  2558,  2956,   777, -3275, -3275, -3275,  2864, -3275, -3275,
     527,  2759,  2666, -3275, 30526,  2874, -3275, 32506, -3275, -3275,
   -3275, -3275, 31318,  2488, -3275, -3275, -3275, -3275, -3275, -3275,
    1631,  2524, -3275, -3275,  2760, -3275,  2765, -3275, -3275,  1632,
    9443,  2626, 20024, 43198, -3275,   300,   300, -3275,  3305, 55870,
    2253, -3275,  1638, -3275, -3275,  1232,  1654, -3275,  1656,  1669,
    2638, -3275,  2584, -3275,  2991, 16309,  1011, -3275, -3275, -3275,
    1229, -3275,  9571,  1730, -3275, -3275, -3275,  2737,  1731,  1736,
    2591,  2635,  2591, -3275,  1703, -3275, -3275, -3275,  2907, -3275,
   -3275, -3275,   290, -3275,  2779,  2780, 43198, -3275, 43198,  3002,
    2605,  2524, -3275,  1536, -3275, -3275,  2626, 42802,  1866,  2524,
   -3275, -3275,  1417,  1417,  3617, -3275,  2921, -3275, -3275, -3275,
   -3275, -3275, 43198,  2611,  2180,   159,   159,  2612,  2778, 31318,
   -3275, -3275, -3275, 43198,  2742,   480,   480,  2941, -3275,  2678,
   -3275, -3275, -3275,   125, 28930,  1536, -3275,  2524,   300, -3275,
    2253, -3275, -3275, -3275,   240, -3275, -3275,   280,  2753,   550,
   -3275, -3275, -3275, -3275,  2759,  1502, -3275,  2922, -3275,  3036,
   -3275,   206, -3275, -3275,  2512, -3275, -3275, -3275,  1739, -3275,
   -3275, -3275, -3275, -3275,  2253,  1417, -3275, -3275, -3275,  2564,
    3033, -3275, -3275, -3275,   582, -3275,  2783, -3275, -3275, -3275,
   -3275, 28930, -3275, -3275, -3275,  1963, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275,   280, -3275, 31318, -3275,  1361, -3275, -3275,
    1379,  1461, -3275,  2637, -3275,  1963, 28930, -3275,  1742, -3275
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -3275, -3275, -3275,  2395, -3275,  -693,   203, -3275, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275, -3275,
   -3275,   686, -3275, -3275,    93,  1629,  2048,   942, -3275, -3275,
   -3275, -3275,  -596,   123,   476, -3275, -3275, -3275, -3275, -3275,
   -3275, -3275,   826,  1330,  2362,  -668, -3275, -1095,  -449, -3275,
     383, -3275, -3275, -3275,   735,  -207, -3275, -3275, -3275, -3275,
   -3275, -1754,     1,   246, -3275,   247,  1363,   405, -3275,   -33,
   -3275, -3275, -3275, -3275,   188,   908,  -552,  -818,  1149,  -454,
    -489,  -416,  -414,  -440, -3275, -2902, -2628, -2549, -2529,  2244,
   -3275, -3275, -3275,   274, -3275, -1744, -3275, -3275,  1839, -1023,
   -3275,  -853, -3275, -3275,   696,  1427,   272, -3275, -3275,   117,
   -3275, -3275, -3275, -3275, -3275, -3275, -2688, -3275, -1108, -3275,
     398, -2161,   837, -3275, -3275, -3275,  1864, -3275, -3275, -3275,
   -3275, -1209, -3275, -3275, -1736, -3275,  1284,   724, -3275, -3275,
   -3275,  -513,  -483, -3275, -3099,    36,    44, -3275, -3275, -3275,
   -3275,  -761, -3275,   759, -2254,  -714, -3275, -3275,   792, -3275,
   -3275,  -419,  -131,  1890, -3275,  -350, -3275, -3275, -3275,  -128,
   -3275, -3275, -3275, -3275, -3275, -3275, -1311,   330,  -665, -3275,
   -3275, -3275, -3275, -1678, -3275,  3111,  2555, -1731, -3275,    22,
      32,  2269,  -852, -1926,   245, -3275, -3275, -1331, -3275, -3275,
   -3275, -1855, -1730, -3275,   301,  -187,  -304, -3072, -2516, -2539,
   -3275, -3275,  -814, -3275, -3275, -3275, -1035,  1446, -1664, -3275,
   -1593,   305, -2726,  -551, -2357, -3275, -2677,  -303, -3275, -3275,
   -3275, -3275, -3275, -3275, -3275,  -825,  -482, -3275, -3023, -3275,
   -3275, -3275, -3275,   953, -3275,   444, -3275, -3275, -3275, -3275,
   -1767,  -701, -3275, -3275, -3275, -3275,  -444,  -469, -3275, -3275,
   -3275,   129, -3275, -3275, -3275,  1560,  -724,  -583,  2531, -1725,
    -140, -3275, -3275, -3275, -3275, -2194, -3275, -3275, -3275, -3275,
   -3275, -3275, -3275, -1075, -3275, -3275, -3275, -3275, -3275, -3275,
    1551,  3152,   -26, -3275, -3275,  2132, -3275, -3275, -3275, -3275,
   -3275, -3275,  2330,   352, -3275,    46, -3275, -3275,   687, -1775,
      50, -3275, -3275, -3275, -3275,  -214,    52, -3275,  1048, -3275,
   -3275, -1521, -3275,  2335, -3275, -3275,     4,     0,   -46,   -59,
     -52, -3275,  2530,  2144, -3275, -3275,   -18,   767, -3275,  -670,
    -663, -3275,  1042,  -494,  1537,  1030,   185,  -195, -3275, -2082,
     541, -3275, -3275,  -486,  1535, -3275,  2138,  1562, -3275,  1585,
    1092, -1748,  1309, -1816,   754,  -827,    28,    67,  2562,  2679,
   -3275, -2653,  1074, -2690,   386,  1268,  1387, -1183, -3275, -3275,
    -880,  4119, -3275, -3275, -3275,  5242,  5303, -3275, -3275,  6090,
    6139, -3275,  -756,   629,  6377,  4841,  -911, -1431,  -746,  4692,
     256,   616, -1246, -3275, -3275, -3275,  -155,   639,   414, -3275,
   -3275, -3275,  -318, -2010,  -313, -3275, -3275, -3275,  -315, -3274,
   -1068, -3275,  -166, -3275,  7160,  1080, -3275,  -648,  -863, -1325,
   -3275, -3275, -3275, -3275, -3275, -3275, -3275, -1206, -2380,  -164,
    1151, -3275, -3275,  1236, -3275, -3275, -3275,  -951,  -637, -1479,
    1150, -1487, -3275,  -661,  1273,  1743,  1394,  -612,  2782,   -74,
    2847,  -410, -1694,  -936,  -657, -3275,  -145, -3275,    -2,   726,
     -79,    47,    48,  4090,  -933,  3659,  -762,  -671, -2241, -3275
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1900
static const yytype_int16 yytable[] =
{
     154,  1058,   660,  1076,   153,   726,  1306,  1099,  1059,   995,
    1298,   490,  1060,   516,  1930,  2055,  1943,  1366,   698,   574,
     791,  1731,  1179,   709,   646,   574,   869,   870,  1002,  1131,
    1132,   874,  1423,  1156,  1396,  1397,  1127,  1823,  1067,  1267,
    1896,  1377,  2201,  1766,  2240,  1010,   148,  1169,   659,  1344,
     149,  2507,   151,  1412,   581,   480,   612,  1984,   831,  1869,
    1061,   480,   480,  1202,  2645,  1705,   613,   480,   575,   480,
     583,  2857,   585,  1608,   575,   480,   593,   480,  2451,  2453,
     603,   609,   583,  2375,   616,   781,   609,   609,  1241,  1603,
     710,   648,  2129,  1245,   729,   480,  2491,  2379,  2768,   671,
    1251,  3004,  1289,   740,  2398,  2624,   672,  2380,   641,  1269,
    1608,   649,  1926,  2202,  2204,  2381,  2712,   663,  2714,  2812,
    2382,  2383,  1761,    65,   821,  2459,  2384,  3123,  3161,   125,
    1661,   630,  2768,  1603,   554,  2137,  2333,  3135,  1266,  1449,
    2134,  2437, -1682, -1261, -1714,  1449,  1449,   488,  1390,  1391,
    2370,  1277, -1734,  1106,  1609,  3099,  1498,  1097,   670,  1152,
    1515,  1515, -1763,  2788,  2789,  2790,  2791,  2792,  2793,  2794,
    1312,  1290,  1290,  1409,  1054,   526,  1442,  2937,  2848,  -153,
    2312,  1327,  1055,  3102,  3178,  1077,  3180,  3104,  1827,  3567,
    1722,  3106,   894,  2676,  2109,  2795,  1670,  1361,  1108,  3417,
   -1066,  1867, -1069,  1329,  3470,   743,  2152,  2059,  -312,  2796,
    1671,  1290,   703,   705,   703,  2676,  1940,   711,  2466,   728,
    2468,   711,   480,  1196,   480, -1618,   480,  1478,   480,   703,
     711,  1686,  1290,  1874,  3568,  2335,   855,  1691,  2235,  2797,
    3323,  2798,   731, -1256,   734,  1713,  2835,  2496,  1109,   809,
    1828,  1324,  3597,   865,  2516,  1110,  2075, -1685,  1111,  2297,
    1605,  1176,  1764,  3404,  3030,  1681,  2098,  3456,   857, -1066,
    1677, -1069,  1874,  3415,   486,   617,  2059,  3324, -1469,  1190,
    1747,  2185,  1672,  1750,  1751, -1469,  1179,  1078,  2298,  3325,
   -1900,  2623,  2376,  3600,  1827,  1449,  2094,  1670,  3608,   744,
    1678,  1636,  2505,  2095,  1605,  1829, -1228,  1112,  1830, -1485,
    2799,  1484,  1423,   743,  3485,  1847, -1485,  1440,  3328,  1637,
    1692,  2141,  2444,  1978,   160,  1064,  3329,  1021,  1157,  2688,
    1396,  1397,  1022,  1806,  1802,  3252,   726,  2119,  1412,  1006,
    1637, -1066,   569, -1069,  1102,  2689,   777,  2020,  2445,  3632,
    1481,  1606,  1718,   160,  1065,  3568,  1828,  1158,  3405,  2703,
    1488,   161,  1113,  2870,  2377,  1805,  3031,  1638,   618,  1485,
    1670,  2800,  1801,  2447,   726,  1610,  2801,  1713,  2076, -1228,
     485,  3471,  2077,  1672,  1671,   816,  1958,  3545,  1638,  3495,
     161,  2099,   824,  2677,  2153,  1606,  1807,  1682,  1114,  1693,
    2142,  1719,  1831,  1177,  1300,   866,   810,   744,  2100,  3598,
    1490,  1829,  2802,  1673,  1830,  2677,  3433,  2078,  1875,  1291,
    1291,   786,   527,  2236,  2803,   793,  1248,  1153,  1730,  2187,
    1079,  1116,  1679,   586,  3026,  3609,   802,  1941,  2497,  2336,
     999,  1821,  3326,   586,  3303,  3558,  1103,  2768,  1757,  3032,
    1759,  1178,  1390,  1391,  1795,  1154,  1672,  3427,  1122,  1291,
    1723,  1409,  3008,   586,   826,  1362,  1385,   569,   834,  1798,
    3075,  1683,  1724,  3330,  2313,  2449,  2494,  1479,   846,   873,
    1291,  2131,  1072,  2049,  3345, -1733,  1605,  1080, -1066,  3354,
   -1069,   586,  2849,  1832,   702,   586,   706, -1261,   528,   586,
     529,  1959,  2804,  1674,  1868,  3624,  1817,  2704,  1831,  1357,
    3569,   738,  2060,  1362,  1673,  2057, -1261,  1987,  1823,  3578,
    1833,  1725,  1935,  1796,  1466,  1467,  1468,  1469,  1470,  1471,
    1608,  1768,   750,   853,    48,  1472,  1471,  1248,  3200,  2079,
     480,  1472,  1472,   705,  1072,   703,  1012,  1696,   711,  1443,
     728,  1072,   711,   795,   480,   480,  1326,  1300,   574,   480,
     574,   703,   574,   711,  1652, -1682,   574, -1714,   860,   861,
     480,  2579,  1653,  1836,  3391, -1734,  2189,  1606, -1066,   480,
   -1069,  2599,   705, -1469,  2795, -1763,   480,  1673,   728,   873,
     480,   480,   649,  3098,   480,   726,   480, -1256,   480,  1832,
     480,  2096,   772,   703,  1674,  1300,  1183,   854,  2672,   856,
    2673,   858,  2991,  1186, -1485,   859, -1256,  2898,  1104,  1880,
   -1066,  1902, -1069, -1066,  3428, -1069,  2739,  2740,  2797,   569,
    1908,  3569,  2777,  2539,   806,   570,   571,  2734,  1916,  1917,
    2737,  2738,  1742,  1896,  2741,   480,  2636,   480, -1618,  3546,
     886,  2010,  2011,  2323,  2748,  2498,  1929,   876,  1159,  1259,
    3163,   569,   154,   597,  1279,  3499,   153,   570,   571,  2705,
     609,  3053,  1004,  1129,   609,  1960,  3084,  1674,  1878,  2399,
   -1685,  3602,  1468,  1469,  1470,  1471,  1605,  2778,   499, -1733,
    2629,  1472,  1961, -1228,  2864,  3441,  3579,  1028,  2868,  1160,
    1260,  1314,  1130,   480, -1228,  3117,  1395, -1228,   148,  1066,
    2500, -1228,   149,   876,   151,   998,   872,  2780,   664,  1008,
      37,  1877,  1492,  3392,  2292,  1044,  2167,  2692,  3137,  1603,
    2293,  3164,  3524,  1981,  1983,  1808,   598,  1395,  1946,  1947,
    1066,   499,  1315,   501,  1991,  3085,  2765,  1994,   586,    41,
    1013,   588,  3119,  3084, -1733,  2006,  2007,  3434,  1307,  1449,
    3301,   703,   703,  3118,  2356,  2801,  1050,  3580,  2024,  2026,
   -1733,  3035,   665,  1861,  3419,  2501,  1809,  1606,  1633,  2040,
    2765,  3500,   483,    46,  1831,    65,  3202,  3435,  3203,  3581,
     480,   125,   784,  1678,   785,    47,   501,  2232,  1355,   873,
    3496,  2802,   480,  1215,  2857,  3511,  3086,  3526,  1368,   728,
    3603,   480,  2185,  2803,  1831,  1014,  2357,   480,  1045,  1072,
    1378,   703,  3054,  1915,   586,  1493,  2294,   782,   480,  2693,
    1052,   890,   525,  2855,  2116,  3020,  1358,   703,   703,  1147,
     586,  3501,  1681,   800,  1862,   666,  2499,  3563,  2186,  1761,
     614,  1161,  1261,   154,  3436,   703,  1278,  1338,   480,  3138,
    3002,    37,  3481,  1896,  1634,  1995,  3165,  2544,  2545,  2546,
    2547,  2548,  2549,  3036,  1053,   154,   703,   703,  2550,  1360,
     480,  2391,   508,  3086,   509,  1904,  2392,  3120,  2358,  2359,
      41,  2804,  3513,  1147,  1316,  1004,  2271,  1752,  1383,  1334,
    1605,  2360,  1148,  1335,  2274,  1336,  2276,  3596,   599,   600,
    1453,  1454,   480,  3288,  1343,  1343,  3204,  1399,   494,   660,
     480,   583,  3166,  1330,    46,  3019,   480,  1996,  1810,   160,
     480,  2013,  3497,  1162,  1262,   508,    47,   509,  1374,  3522,
    3523,  3612,   480,  2128,  1380,    14,  2191,  1426,  2020,  2020,
    2219,    15,  1281,  2020,   667,  2361,  2354,  1382,   726,    48,
    2187,  1457,  3555,  3308,  1624,  1438,   161,   586,  1605,  2295,
    3560,  3289,  2694,  -321,  3021,    19,  1317,    48,  3239,  3240,
    3241,  1502,  1997,  3561,  3562,  1998,  1752,  1627,  1628,  1973,
    1632,  1606,  2020,  2020,   672,   672,   499,   672,  2296,  2220,
    1605,  2695,  1418,  1282,   584,  1620,  3395,   574,  3594,  3437,
    1811,   574,   574,  2299,  3319,  -704,  1753,   589,  1754,  2768,
    1419,  1149,    23,  1503,  1863,  2192,  1197,  1198,  1494,  1495,
     586,  2920,  2786,  2921,   569,  1864,  2362,  2392,  2363,  3438,
     570,  1496,  3595,  1120,  1121,  3168,   670,   670,   803,   670,
    3195,   501,  3320,   803,  1004,   787,  3613,   788,  3066,  1606,
    2379,  1004,  1004,  1727,  3069,  3070,  3071,  3072,  3073,  3074,
    2380,  3022,  1300,  1789,  3023,  1612,   804,  1619,  2381,  1999,
    2667,  3128,   574,  2382,  2383,   480,   480,  1283,   574,  2384,
    2469,  1606,  1418,  2464,   596,  2765,  2387,  2388,  2389,  2390,
    2815,  1072,  1790,  1195,   586,  1753,  3439,  1754,  2571,  1021,
    1419, -1573,  3001,  2576,  1022,   569,   805,  3171,   609,  1246,
    1247,   805,  3175,  1950,  1164,  3177,   637,  1656,  2221,  2775,
     480,   574,  1420,  2897,   574,   574,  1284,  1275,  2364,   726,
     609,  1898,  1068,  1901,  1466,  1467,  1468,  1469,  1470,  1471,
    3154,  2922,  1907,  1165,  2895,  1472,  1657,    37,  1302,  1304,
    1758,  2923,     3,     4,    37,  2671,  3389,  2857,  1770,  1300,
    2000,  1069,   728,  1850,   609,    33,  2001,  2222,   586,  2898,
    1075,  1166,  2431,  2049,  1658,   574,    41,  2460,  2909,  3187,
     508,  3188,   509,    41,  1125,  1732,  1896,  3080,    33,  1070,
    1896,   511,   709,  1732,  2590,  1128,  2591,   703,   703,   703,
     703,   514,   774,    44,   862,   711,  1170,  1168,  3294,  1285,
      46,    33,  1126,   651,  3429,  1909,  2592,    46,  1278,  2690,
    3403,    15,    47,   863,  1918,  1385,   703,   703,  2463,  2443,
    1733,  1734,   703,  3081,  3295,  1126,  1925,   726,  1733,  1734,
    3430,  3254,  2471,  2472,  2169,  1050,  2474, -1109,  2691,  1051,
    2455, -1109,  2478,  3507,    37,  1675, -1261,  2891,  1071,  1515,
    3362,  1939,   653,    48,  1944,  1945,  1300,   779,  1948,  1605,
      48,  1730,  3535,  1418,  1605, -1261,  1890,   661,  1072,  1730,
    1713,  1071,   480,    41,  1714,  1083,  2066,  1720,  2067,   662,
     711,  1419,    23,  1791,  2444,   480,  3536,   703,   703,   703,
     703,  2509,   660,  1792,  1071,   673,   711,  2836,  2068,  1052,
     879, -1109,  1004,  1422,  1278,  1084,  2354,    46,  2918,  2593,
    2445,  1934,  2477,   707,  2594,   569,  1793,   736,  2514,    47,
     895,   570,   571,   705,   480,  2446,   992,   480,   480,  1001,
    1003,  1005,  2938,   728,  3096,  2447,   480,   480,   659,   480,
    2661,   480,   742,  1053, -1596, -1109,   480,   154,   480,   711,
    1606,  1972,  1786,   703,   703,  1606,  3478,  2609,  2448,  2610,
      48,  1085, -1597, -1596,   780,  1732,  2565,  1788,  1343,  3278,
    3279,  1992,  1993,   480,   776, -1078,   480,   480,  1975,  2005,
     480, -1597,   783,  2008,  2009, -1078,  1955,  1974, -1900, -1078,
    2611,  1086,  2612,  1969,  1263,  2588,  2069,  1970,  2030,  1971,
    2031,  2070,  1732,   583,   583,   792,  2071,  1980,  3351,  1963,
    1733,  1734,  1047,  1264,  1049,   642, -1573,    37,   642,  1847,
    1321,  2053,  1621,  2054,  1418,   798,  1622,  2595,  1842, -1078,
     172,  1440,  2064,  1021,  1849, -1573,  2596,  2449,  1022,  1322,
     808,   728,  1419,  2619,  2620, -1271,    41,  1733,  1734, -1078,
    2020,  1730,  1870,  2020,  2020,  2020,  2020,  2020,  2020,  2020,
    2020,  2020,   807,  2020,  1420,  1418, -1899,   664, -1228,  1773,
    1774,  1775,  1776,    44,   861, -1241,  3341, -1110,  1407,  1408,
      46, -1110,  1200,  1419,  1608, -1899, -1271,  1395,  1730,  1087,
     822,  2662,    47, -1078,  1401,  1605,  1605,  1605,  1803,  1804,
     841, -1268, -1078,  1932,  1813,  1422,   586,  1933,   586,  3219,
    2511,  2020,  2020,  2670,   818,  2627,  1933,  2646,  1088,  2072,
   -1268,   665,    33,  2049,   586,  1445,  1089,  1482,  2073,  2680,
    2681,  1716,  1090,    48,  1721,  1071,  3055,   697,  1144,  1091,
    1155, -1110,   697,  2120,   642,   185,  1092,  1173,  1936,   642,
     487,   642,  1937,  1003,  1093,  3056,  -109,   642,   556,  1938,
    2165,  -109,  1094,  1937,  2168,  2719,   832,  -109,  -109,  1857,
    1858,  1859,  1860,   847,  2512,   615,  1767,  1769,  2605,  3408,
    2513,  2181,  2779,  2781,  2782, -1110,  1606,  1606,  1606,  2193,
    1605,   569,  1885,  1886,   666,  3425,  2962,   570,   571,  1896,
    2869,   851,  2872,  3064,  1896,  2139,  2145,  1896,  2049,  1495,
    1095, -1078,  2207,   574,   569,  2155,  2156,   569,  2208,  2948,
     570,  1496,  2544,  2545,  2546,  2547,  2548,  2549,   867,  2228,
    2939,  2940,  2674,  2550,  2906,  1072,  1931,  1395,   871,  2549,
    1662,  1619,   608,   882,  2245,  2550,  2269,  2765,   636,  1645,
    2546,  2547,  2548,  2549,   880,  2963,   887,  3078,  3079,  2550,
    3016,  3082,  2147,  3083,  2285,  1395,  1133,  1966,  1662,   888,
    2138,  1967,  2290,  1441,  1300,   889,  2161,  1040,  2199,  2303,
    1967,  1606,  2200,  1446,   890,  2242,  2307,   711,   480,  2243,
     891,   711,   705,   480,  1483,   893,  2340,  3225,  2371,   480,
    2341,  1395,  2372,   667,  1662,   480,  2481,  2431,   711,  2020,
    1937,   480,  1003,  1134,  2969,  1500,   711,   480,   892,  1003,
    1003,  2492,   480,   896,  1898,  2493,  3556,   574,  3457,  2510,
   -1132, -1132,   897,  1933,  2232,   574,  3027,   574,  2520,   711,
     480,  1009,  1933,  2210,  2211,   480,   480,   480,   480,  2218,
    2412,  2413,   480,   480,  3218,  2539,   711,   480,  2523,  2527,
     480,  3634,  1933,  1933,  3635,  2239,  2239,  1015,  3593,  1011,
    2354,   711,  2879,   711,   480,  3341,  2882,  1016,  2884,  1040,
    2886,  2887, -1066,   703,   480,  1025,   480,  1135,  2877,  2892,
    1605,   711,  2641,  2642,  3387,  2286,   480,   480,   480,   711,
     480,  2528,  2813,  3091,  3092,  1933,   711,   480,   480,  2852,
    1017,  2353,  1029,   711,  2539,   480,   480,  1371,  1372,  2907,
    2540,  3010,  3011,   660,  2045,  1106,  2554,  2048,   703,  2570,
    1933,  1107,  1136,  1933,  1137,   703,   703,   703,   703,   703,
     703,  1030,  2573,  1037,  2625,  1760,  2574,  2484,  2626,  2564,
    2489,  2566,  2567,   154,  1038,  1765,  2539,  2400,   642,  1040,
    2443,  1041,  2632,   642,  2686,   697,  2633,  2715,  2687,  2436,
    1108,  2716,  2239,  2822,  2020,  2020,  1048,  2823,  2489,  2540,
    1139,  1606,  2833,  1179,  2846,  1062,  2834,  2910,  2847,  3338,
    1066,  1933,  1124,  2946,   726,  1082,  2396,  2947,  2953,   642,
    2945,  1100,  2954,  2411,   697,  1605,  1122,  1605,  2965,  2988,
    1896,   697,  1933,  1933,  1072,  1141,  2647,  2648,  2441,  1175,
    1109,  2540,  2441,  2454,  2989,  2444,  1163,  1110,  1933,  3012,
    1111,  3132,  3182,  1937,  1605,  3133,  2626,  2649,  2650,   703,
    2239,   703,  2239,  3412,  1898,  3224,  3250,  1167,  1143,  1967,
    1937,  2445,  1180,  1182, -1570,  3251,  1004,  2639,   642,  1937,
    1184,  1852,  1192,  3348,   642,  1343,  2446,  1300,  3353,   480,
    3355,  1187,  2823,  1194,  2823,   642,  2447,   711,  1201,  1112,
    1003,  3014,   960,  1204,  3368,  2541,  2542,  2543,  3369,  2544,
    2545,  2546,  2547,  2548,  2549,   642,  1606,   660,  1606,  2448,
    2550,   480,  3370,  3376,  3423,   711,  1933,  1967,  3424,  3451,
    1106,  2019,  1242,  3452,   642,  3458,  1107,  3461,  3463,  3459,
     642,  1300,  2823,  1071,  3467,  1606,  3172,  1226,  1967,  1244,
    1252,  3512,  3516,  1248,  1113,  1487,  3452,   642,  3527,  1255,
      15,   960,  1300,  1438,  2541,  2542,  2543,  1257,  2544,  2545,
    2546,  2547,  2548,  2549,  3528,  1108,  3529,  2064,  1967,  2550,
    2574,  3226,  1268,  2653,  1274,  2272,  2614,  2615,  3338,  3530,
    1114,  1288,  3490,  1933,  3492,  3162,  1293,  2608,  2449,  1286,
    2581,  1295,  1294,   960,  1296,  3223,  2541,  2542,  2543,  1890,
    2544,  2545,  2546,  2547,  2548,  2549,  1083,  1297,  2628,  1115,
     574,  2550,  1299,  1116,  1305,  1109,  2004,  1300,   728,  1308,
    2317,    23,  1110,  2020,  1310,  1111,  1309,  2326,  2327,  2328,
    2329,  2330,  2331,  1311,  1313,   697,  1084,  1117,  1365,  1318,
    3539,  3541,   697,  2431,  1967,  1967,  3542,  2020,  2020,  3610,
    1967,  1319,  3639,  3611,  1320,  2699,  3611,  1325,  3173,  1340,
    1004,  1367,  2700,  2639,  1369,  1373,  1375, -1232,  1376,  1619,
   -1239,  1381,  1389,  1392,  1112,  1393,  1394,  1398,  2707,    28,
      48,  1400,  2710,  1403, -1229, -1230,  1476,   642,   642,   642,
    1404,  1405,  1085,   697,  1406,  2795,  3338,  2639,  1411,  1413,
     711,   480,   480,  3186, -1233,  1414,  1415,  1416, -1231,  2796,
    3189,  3190,  1417,  1424,  1449,  2121,  1343,  1425,  1427,  1450,
    1487,  2732,  1086,  1491,  1505,   480,  1428,  1518,  1429,  1113,
    2539,  2465,  1430,  2467,  1431,  1432,  1433,  1625,  1106,  2797,
    1051,  2798,  1650,  1659,  1107,  1660,  1662,  1663,  1664,  1667,
    1680,  1687,  2708,  3285,  1685,   642,    37,   480,   480,   480,
     480,  1688,  2536,  2537,  1689,  1114,  1711,  2552,  1690,  1713,
    1712,  1728,  1717,  1727,  1729,  1730,  1736,   642,  1737,  1738,
    1741,  1748,   711,  1108,   480,    41,  2020,  1898,  1743,  3209,
    1755,  1898,  1745,  1746,  1171,  2540,  1756,  1762,  1116,  2539,
     480,  1763,  1147,  1771,   480,  1780,  2585,  2586,  1772,  1778,
    2799,  1779,    44,  1785,  1787,  1800,  1812,  1815,  1814,    46,
    1365,  1824,  1172,  1385,  1822,  1825,  1838,   574,   496,  3246,
     709,    47,  3366,  1109,  2774,  2776,  1149,  1844,  1395,  2783,
    1110,  1401,  2424,  1111,   480,  1452,  1848,  1873,   711,   480,
    1856,  1879,  1605,    33,  1881,  1695,  1884,  1089,  2239,  2239,
    1083,   574,  1882,  1090,  2540,  1453,  1454,  2816,  1888,  1899,
    1091,  2800,    48,  3280,  1911,  1913,  2801,  1126,  1927,  1912,
    1740,  1914,  1928,  1949,  2171,  1093,  1956,  1952,  1964,  2028,
    1084,  2041,  1112,  1094,  1977,  2029,  1986,  2896,  1987,  2894,
    2046,  1472,  2051,   642,  2052,   154,  2058,  2063,  2080,  2840,
    1005,  2082,  2802,  3559,  2109,   583,  1457,  2118,  2123,  2908,
    2122,  2905,  2126,  2127,  2803,   154,  2148,   665,  2133,  2860,
    1458,  2149,  1890,  2140,  2154,   480,  1890,   480,  2162,  2160,
    2163,  1095,  1799,  1606,  2164,  2172,  1085,  1113,  2174,  2176,
    2431,  2177,  2180,  2183,   480,  2190,  3411,   960,  2197,  1365,
    2541,  2542,  2543,  1004,  2544,  2545,  2546,  2547,  2548,  2549,
    2178,  2195,  2234,  2241,  2441,  2550,  1086,  2862,  2244,  2300,
    2301,  2302,   154,  1114,  2306,  2310,  2901,  2314,  2315,  2311,
    2875,  2316,  3466,  2320,  2318,  2319,   642,  2321,  2334,  2322,
     480,  1840,  2804,  2343,  2425,  2332,  2339,  3356,  2346,  3357,
    3358,  3247,  2639,   480,   711,  2348,  1116,  3361,  2347,  2369,
    2349,   480,  2325,  3483,   711,  2350,   960,  3488,  3489,  2352,
    2325,  1955,  2351,  2544,  2545,  2546,  2547,  2548,  2549,  2373,
    1117,  2385,  2415,   480,  2550,  1072,   711,   642,  2750,  2538,
    2393,   660,  1903,  2397,  2416,  2418,  2433,  2435,  2434,  2442,
    3304,  2461,  2456,  3487,  2462,  2470,   642,  2473,  2475,  2539,
    2476,  2480,  2386,  3484,  2483,  3013,  2490,  2485,  3380,  1978,
    2502,  2979,  2980,  2981,  2982,  2506,   873,  2508,  2521,  2522,
    2751,  2524,  1462,  2525,  1933,  2417,  2526,  1438,  2560,  1466,
    1467,  1468,  1469,  1470,  1471,  2529,  2589,    33,  2604,  2597,
    1472,  2426,  2530,  2607,  2752,  2532,  2535,  1090,  2617,  3046,
    3047,  2553,  2019,  2019,  1091,  2559,  2561,  2019,  2562,  2569,
    2582,  1126,  2584,  2753,  2540,  3057,  2583,  3059,  2622,  1093,
    2623,  2652,  2539,  2656,  1003,  2663,  2659,  1094,  2660,  2754,
    2664,    15,  1605,  2668,  2701,  2669,  2702,  2709,  2711,  2721,
    2722,  2994,  2720,  2755,  2723,  2724,  2019,  2019,  2736,  2742,
    1897,  1619,   697,  2725,  2726,  2727,   574,  2743,  2728,  2729,
    2730,   697,  2744,  2745,  3464,  2746,  2747,  2769,  2773,   574,
    1831,  2772,  2784,  2808,   642,  1095,  2785,  1343,  1343,  2427,
    3440,  2810,   711,   642,  2787,  3476,  2817,  2540,  2827,  2829,
    1898,  3469,  3477,  2831,  2837,  1898,  2832,  2838,  1898,  2842,
    1072,  2844,    23,  2861,  2863,  2859,  2865,  2866,  2873,  2876,
    2092,   697,  2878,  2883,   642,   642,  2885,  2900,  3044,  1479,
    2903,   480,   480,  1606,  2904,  2756,   642,  2431,  1382,   860,
     861,  3605,  2913,  2757,  2556,  2555,  2550,  2955,   480,  1442,
    3090,  2942,   711,   480,   711,   480,   480,   480,   480,  2943,
    2944,  2967,  3398,  2968,  2986,  2976,  3100,  2998,  3003,  3614,
      28,  3015,  3000,  3006,  2919,  3017,  2758,  2924,  2925,  2926,
    2927,  2928,  2929,  2930,  2931,  2932,   960,  2934,  3024,  2541,
    2542,  2543,  3028,  2544,  2545,  2546,  2547,  2548,  2549,  2489,
    3041,  3029,  3052,  2431,  2550,  3039,  3040,  3534,  3042,  3043,
    3067,  3068,  3065,  3093,  3094,  2856,  3121,   726,  3126,  3127,
     480,   480,   480,  3095,   480,  3114,  3124,  3130,  1003,  3141,
    3146,  3129,  3149,  3155,   479,  2971,  2972,  3147,  3160,  3169,
     523,   524,  3159,  3176,  3185,  1890,   557,    37,   573,  3179,
    1890,  2396,   642,  1890,   592,  3191,   595,  2210,  3192,   960,
    2210,   642,  3145, -1900, -1900,  3193,  2544,  2545,  2546,  2547,
    2548,  2549,  2239,  3196,   658,  1106,    41,  2550,  3198,  3201,
    1447,  1107,  3205,  3210,  3211,  3236,  3206,  3237,  1449,  2441,
    3253,   480,  3212,  1450,  3255,  3216,  3260,  3256,  3276,  3277,
    3281,  3284,  2396,    44,  3181,  1133,   480,  3290,  3538,  3085,
      46,  2239,  3293,  2239,  3296,  3297,  3266,  3269,  3305,  3313,
    1108,  3309,    47,  3315,  3317,  3318,   711,  3333,  3322,  3261,
    3331,  3346,   712,  3334,  3350,  3360,  3364,   732,  3365,  3367,
    3270,  3372,  3374,  3373,  3375,   741,  3382,  3384,  3388,  3393,
    3390,  3400,  1134,  3401,  3407,  3406,  3413,  3120,  3272,  3273,
    3420,  3275,  1937,  3615,  3422,  3432,  3442,  2706,  3444,  3443,
    1109,  3445,  3446,  3475,  3479,   666,  3498,  1110,  3502,  3506,
    1111,  3508,  3514,  3531,  3518,   574,   574,  3515,  3532,  2718,
    1898,  3533,  3485,  3543,   642,  1326,  2539,  3544,  3547,  3549,
     574,   730,  3553,   733,  3554,   735,  3564,   737,  3263,  3264,
    2992,  1898,  3573,  3267,  3268,  1451,  3577,  3546,  3545,  1452,
    3243,  2325,  3607,  3606,  2325,  2325,  1135,  3601,  2325,  1112,
    3623,   728,  3625,  3116,  2147,  3249,  3636,  1042,  2325,  1453,
    1454,  2814,  1517,  1200,  2630,  2767,  2237,  3557,  1081,  3257,
    3025,  3258,  2749,  3409,  1455,  3139,   711,   480,  2209,  3143,
    3018,  2540,  3302,  2658,  3574,  3604,  2482,   711,   480,  3550,
    3548,  1136,  2345,  1137,  2639,  3347,   574,  1331,   726,  2767,
     480,   480,   703,   480,  1138,  3347,  3583,  1456,  3144,  1872,
    1457,  2188,  2841,  3151,  3050,  2713,  2819,  2489,  3397,  2821,
    1853,   642,  2355,  3638,  1458,  3292,   154,  1459,  3626,  1343,
    3310,  2811,  3291,  2770,  3584,  3399,  1843,  3540,   591,  1139,
    1114,  3402,  1356,  3194,  3153,  3299,   878,  3449,  3520,   709,
    2851,  1003,  3156,  2203,  2019,  3617,  3525,  2019,  2019,  2019,
    2019,  2019,  2019,  2019,  2019,  2019,  3637,  2019,  1018,  1140,
    3426,  2135,   558,  1116,  1141,  1626,  1890,   480,  3136,  2634,
    2902,  1623,  2637,  1333,  2651,  1036,  1449,  2158,  1337,  1898,
    2159,  1450,  3248,  3007,  1651,   480,  1460,  1142,  2438,  2132,
    2151,  2616,  2871,  3339,   814,  3352,  2635,  1143,  1026,  3134,
    2344,  2959,  3468,  2949,  3565,  2019,  2019,   480,  3220,  3221,
    3566,  3572,  2108,  2640,  2517,  2600,     0,  3181,  2602,  2495,
       0,     0,     0,     0,     0,  2503,     0,     0,     0,   480,
    3145,     0,   642,   960,   711,     0,  2541,  2542,  2543,     0,
    2544,  2545,  2546,  2547,  2548,  2549,     0,     0,   574,     0,
       0,  2550,     0,     0,     0,     0,   748,     0,   642,     0,
       0,   775,     0,     0,     0,   642,  3462,     0,  2587,     0,
       0,     0,     0,  1897,     0,     0,  1462,  3510,     0,  1463,
    1464,  1465,     0,  1466,  1467,  1468,  1469,  1470,  1471,     0,
    1025,  2124,     0,     0,  1472,     0,     0,  1898,  2125,  2960,
       0,     0,   728, -1900,     0,     0,     0,  1452,     0,     0,
       0,     0,     0,     0,     0,  2424,     0,     0,     0,     0,
       0,     0,  1343,  3494,     0,     0,     0,  1453,  1454,   778,
       0,     0,     0,  1083,     0,     0,     0,     0,     0,     0,
       0,  2996, -1900,   796,   797,     0,  2638,  2239,   799,     0,
       0,     0,     0,     0,     0,     0,   875,     0,     0,   812,
       0,     0,     0,  1084,     0,     0,     0,     0,   817,     0,
       0,   703,  3339,   885,  3274,     0,   703,   703,  1457,     0,
     836,     0,     0,   838,  3575,   840,     0,   843,   480,     0,
       0,     0,  1458,   996,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2019,  2767,     0,     0,     0,     0,     0,
       0,     0,  1020,     0,     0,     0,     0,     0,  3045,  1085,
    3474,     0,     0,     0,     0,  3048,     0,  3049,     0,     0,
       0,     0,     0,     0,   883,  1043,   884,     0,     0,     0,
       0,   703,   703,   703,   703,   480,     0,  3363,     0,  1086,
       0,     0,  2325,     0,     0,     0,     0,     0,  2325,  2325,
    2325,  2325,  2325,  2325, -1900,  2210,     0,     0,  2675,     0,
    3633,  3377,  3378,     0,     0,     0,     0,  2425,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   642,     0,     0,
    3339,   703,   658,  1897,     0,     0,     0,     0,     0,  2696,
       0,  2698,     0,     0,  3101,  3103,  3105,  3107,   715,     0,
       0,   716,   717,   718,     0,   719,   720,   721,   722,   723,
     724,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   642,     0,     0,     0,     0,     0,     0,
       0,     0,  3590,     0,   480, -1817,   703,     0,     0,     0,
       0,     0,     0,     0,  1462,   703,     0,     0,  3152,  3631,
       0,  1466,  1467,  1468,  1469,  1470,  1471,     0,  2019,  2019,
    3474,     0,  1472,     0,  2735,  1270,  1272,  1273,     0,  1174,
      33,   703,     0,     0,  1089,     0,     0,     0,     0,   154,
    1090,  1185,  3592,     0,     0,     0,     0,  1091,     0,  3590,
    1191,     0,     0,     0,  1126,  3630,  1193,     0,     0,     0,
    3465,     0,  1093,     0, -1817,     0,     0,  1240,     0,     0,
    1094,     0,     0,     0,  3590,   154,     0,  2424,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   996,     0,  1083,     0,  1280,     0,  3592,
       0,     0,     0,  3448,  2824,     0,     0,     0,  3454,  3454,
       0,     0,     0, -1817,     0,   996,     0,     0,  1095,  2675,
       0,     0,  2427, -1817,  3592,  1084,     0, -1817,     0,     0,
       0,     0, -1817,     0,     0,     0, -1817,  1449,     0, -1817,
       0, -1817,  1450,  1072,     0,     0,     0,     0,     0,     0,
       0,  1339,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3245,  1364,     0, -1817,     0,  2880,
       0,  1447,     0,     0,  3491,     0,  3493,     0,     0,  1449,
       0,  1085,     0,     0,  1450,     0,     0, -1817,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1086,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3521,     0,   642,     0,  2914,     0,     0,
       0, -1817,     0,  2325,  2325,     0,   642,     0,     0,  2425,
   -1817,  1519,     0,     0,  3282,  3283,     0, -1819,  3286,  3287,
       0,     0,   642,     0,     0,     0,     0,  2019,  2933,     0,
       0,     0,   700,     0,  1451,     0,     0,   700,  1452,     0,
    1449,  2941,     0,     0,     0,  1450,  1897,     0,  3552,     0,
    1897,  2019,  2019, -1817,     0,     0,     0,  3454,  1453,  1454,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3316,
       0,     0,     0,  1455,   642,  1365,  1451,   642,     0,     0,
    1452,     0,     0,  3576,   642,     0, -1819,     0,     0,   697,
       0,     0,     0,     0,   658,  3340,     0,   589,     0,     0,
    1453,  1454,     0,     0,  1726,     0,     0,     0,     0,  1457,
     642,     0,    33,     0,     0,  1455,  1089,     0,     0, -1817,
       0,     0,  1090,  1458,     0,     0,     0,     0,     0,  1091,
       0,     0,     0,     0,     0, -1819,  1126,     0,     0,  1684,
   -1817,     0, -1817, -1817,  1093, -1819,     0,     0,  1456, -1819,
       0,  1457,  1094,     0, -1819,  1777,     0,     0, -1819,     0,
       0, -1819,     0, -1819,     0,  1458,     0,  1451,  1459,     0,
       0,  1452,     0,     0,  1797,     0,     0,     0,     0,     0,
       0,     0, -1817,     0,     0, -1817,     0, -1817, -1817, -1819,
    2019,  1453,  1454,     0,     0,  1460,  2767,     0,     0,     0,
    1095,     0,     0,     0,  2427,  2856,  1455,     0,     0, -1819,
       0,     0,     0,  2325,     0,     0,     0,  3410,   642,   642,
       0,     0,     0,     0,     0,  1072,     0,     0,  1447,     0,
       0,     0,     0,     0,     0,     0,  1449,  1460,     0,  1456,
       0,  1450,  1457,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0, -1819,     0,     0,  1458,     0,     0,     0,
       0,     0, -1819,     0,     0,     0,     0,  3447,   751,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1462,     0,     0,  3125, -1900,
   -1900,     0,  1466,  1467,  1468,  1469,  1470,  1471,     0,     0,
     752,  1841,  1920,  1472,     0, -1819,     0,     0,  1447,     0,
       0,  1924,  2141,   753,  1855,     0,  1449,     0,     0,     0,
     754,  1450,     0,     0,   755,     0,     0,  1462,  1460,     0,
    1463,  1464,  1465,     0,  1466,  1467,  1468,  1469,  1470,  1471,
       0,     0,   996,   996,   756,  1472,     0,     0,  2531,   589,
       0,     0,     0,  1906,     0,     0,     0,  1910,     0,     0,
     700,     0,     0,  1451,     0,   757,  1919,  1452,  1921,     0,
    1922, -1819,     0,     0,     0,  1923,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1453,  1454,     0,
     642,  2142, -1819,     0, -1819, -1819,     0,   758,     0,   700,
       0,     0,  1455,     0,     0,     0,   700,   642,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   759,  1462,     0,
       0,  1463,  1464,  1465,     0,  1466,  1467,  1468,  1469,  1470,
    1471,     0,     0,     0, -1819,  1456,  1472, -1819,  1457, -1819,
   -1819,   760,     0,  1451,     0,     0,  1365,  1452,     0,     0,
       0,     0,  1458,     0,     0,  1459,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1453,  1454,  1897,
    2107,     0,     0,     0,  1897,     0,     0,  1897,     0,  2117,
       0,     0,  1455,     0,     0,     0,     0,     0,   700,     0,
    3591,     0,     0,     0,     0,     0,     0,     0,     0,   761,
       0,     0,  3259,     0,     0,     0,     0,     0,     0,     0,
    3265,     0,     0,     0,     0,  1456,     0,     0,  1457,     0,
       0,     0,   700,     0,  1460,     0,   172,     0,     0,     0,
       0,     0,  1458,     0,     0,  1459,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3591,     0,     0,
     762,     0,     0,     0,   763,     0,   764,     0,     0,     0,
       0,     0,   765,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3591,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   642,   642,   642,   642,     0,  1447,     0,
     766,   767,     0,     0,     0,   768,  1449,     0,     0,     0,
       0,  1450,     0,   769,  1460,     0,     0,     0,   770,     0,
       0,     0,  2136,     0,  1462,     0,     0,  1463,  1464,  1465,
     700,  1466,  1467,  1468,  1469,  1470,  1471,   700,  1447,     0,
     771,  1448,  1472,     0,     0,  2577,  1449,     0,     0,     0,
       0,  1450,     0,     0,     0,     0,     0,     0,  1239,     0,
       0,     0,  2143,     0,     0,     0,     0,     0,     0,  2824,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   700,     0,
       0,     0,     0,  1365,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1462,     0,     0,  1463,  1464,  1465,
       0,  1466,  1467,  1468,  1469,  1470,  1471,     0,     0,     0,
       0,     0,  1472,     0,     0,     0,     0,  2166,     0,  2227,
     700,     0,  2170,  1451,     0,     0,     0,  1452,  2175,     0,
       0,     0,   642,     0,  2179,     0,     0,     0,     0,     0,
    2184,     0,     0,     0,     0,     0,  2194,  1453,  1454,  1239,
       0,  2196,     0,     0,     0,     0,     0,     0,     0,   697,
       0,     0,  1455,  1451,     0,     0,     0,  1452,     0,     0,
       0,   700,     0,     0,  2212,  2213,  2216,  2217,     0,     0,
    1897,  2223,  2226,     0,     0,     0,  2229,  1453,  1454,  2233,
       0,     0,     0,     0,     0,  1456,  1449,     0,  1457,   700,
       0,  1450,  1455,  2270,     0,     0,     0,     0,     0,     0,
       0,     0,  1458,  2273,     0,  2275,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2287,  2288,  2289,     0,  2291,
       0,   700,   700,     0,   700,  1456,  2304,  2305,  1457,     0,
    2374,  1447,     0,  1365,  2308,  2309,     0,     0,     0,  1449,
       0,   700,  1458,     0,  1450,  1459,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2401,   697,     0,     0,
       0,     0,     0,  2419,  1365,     0,     0,     0,  1365,  1365,
       0,     0,     0,     0,  1460,     0,     0,     0,     0,     0,
     700,  1604,     0,     0,     0,     0,     0,     0,   697,     0,
       0,   642,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   700,     0,     0,
       0,   700,   700,  1451,  1460,     0,   642,  1452,     0,     0,
       0,  1239,     0,     0,     0,  1604,     0,     0,   697,     0,
       0,     0,     0,     0,     0,     0,     0,  1453,  1454,     0,
     642,     0,     0,     0,     0,     0,  2555,     0,     0,     0,
       0,  2556,  1455,     0,     0,     0,     0,     0,     0,  1239,
       0,     0,     0,     0,  1462,     0,  1451,  1463,  1464,  1465,
    1452,  1466,  1467,  1468,  1469,  1470,  1471,     0,     0,     0,
       0,  1239,  1472,     0,   642,     0,     0,     0,  1457,  1449,
    1453,  1454,     0,     0,  1450,     0,     0,     0,     0,  1461,
       0,     0,  1458,     0,  1462,  1455,     0,  1463,  1464,  1465,
       0,  1466,  1467,  1468,  1469,  1470,  1471,     0,     0,     0,
    2504,     0,  1472,     0,     0,     0,   697,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1456,     0,
       0,  1457,     0,  1239,     0,     0,   697,     0,     0,     0,
       0,     0,     0,     0,     0,  1458,     0,     0,  1459,     0,
    1239,     0,     0,     0,     0,     0,     0,     0,     0,  1238,
       0,     0,     0,     0,  1460,     0,     0,     0,     0,  1239,
       0,  2598,     0,     0,     0,  2613,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1229,     0,
       0,     0,  1239,     0,     0,     0,     0,  1604,     0,     0,
       0,     0,     0,     0,     0,     0, -1900,     0,     0,     0,
    1452,     0,     0,     0,     0,     0,     0,  1460,     0,     0,
       0,   996,     0,   697,     0,     0,     0,     0,     0,     0,
    1453,  1454,     0,     0,     0,   700,     0,   700,     0,     0,
       0,     0,     0,  1239,     0, -1900,   700,     0,     0,     0,
       0,     0,     0,     0,  1462,     0,     0,  1463,  1464,  1465,
    1238,  1466,  1467,  1468,  1469,  1470,  1471,     0,     0,     0,
       0,     0,  1472,     0,     0,     0,     0,     0,     0,     0,
       0,  1457,     0,     0,     0,     0,     0,     0,     0,  1229,
       0,     0,     0,     0,     0,  1458,   700,     0,     0,     0,
    2654,  2655,     0,     0,     0,     0,     0,  1462,     0,   697,
    1463,  1464,  1465,     0,  1466,  1467,  1468,  1469,  1470,  1471,
       0,     0,     0,     0,  2666,  1472,     0,     0,     0,     0,
     700,   700,     0,     0,     0,     0,     0,     0,   700,     0,
       0,   700,     0,     0,   700,     0,     0,     0,     0,     0,
       0,     0,   700,   700,     0,     0,  2682,  2683,  2684,  2685,
     700,     0,     0,   700,   700,   700,   700, -1900,     0,     0,
       0,     0,     0,   700,   700,     0,   700,     0,   700,     0,
       0,   700,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   700,  1604,  1447,     0,
     700,     0,     0,     0,   700,     0,  1449,     0,   700,     0,
       0,  1450,   700,   700,   700,   700,   700,   700,   700,   700,
     700,  1239,     0,   700,  1447,     0,     0,     0,   700,     0,
       0,   700,  1449,     0,     0,     0,     0,  1450,     0,     0,
       0,     0,  1238,  2731,     0,     0,     0,     0,  2733,     0,
       0,     0,     0,     0,     0,  1449,     0,  1462,     0,     0,
    1450,     0,     0,  2818,  1466,  1467,  1468,  1469,  1470,  1471,
       0,  1229,     0,     0,  2830,  1472,     0,     0,     0,     0,
    1710,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2843,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1238,  1447,     0,     0,  2519,     0,     0,  1229,
       0,  1449,     0,     0,     0,     0,  1450,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1229,     0,  1451,  2825,     0,  2826,  1452,     0,     0,
       0,     0,  2888,     0,     0,  2889,     0,  2973,     0,     0,
       0,     0,  2893,  2666,     0,     0,     0,  1453,  1454,  1451,
       0,     0,     0,  1452,  1238,     0,     0,     0,     0,     0,
       0,   700,  1455,     0,     0,     0,     0,     0,   996,     0,
       0,  1238, -1900,  1453,  1454,     0,  1452,     0,     0,     0,
       0,     0,     0,  1229,     0,     0,     0,     0,  1455,  2881,
    1238,   978,     0,     0,     0,  1456,  1453,  1454,  1457,     0,
    1229,  1604,  2890,     0,     0,     0,     0,     0,     0,     0,
       0, -1900,  1458,  1238,     0,  1459,     0,     0,     0,  1229,
     700,  1456,     0,     0,  1457,  1033,     0,     0,  1451,     0,
       0,     0,  1452,  2950,     0,     0,     0,     0,  1458,     0,
    1239,  1459,  1229,     0,     0,  1239,  1239,  1457,     0,     0,
       0,     0,  1453,  1454,     0,     0,     0,     0,     0,     0,
       0,  1458,     0,     0,  1238,     0,     0,  1455,     0,  1604,
       0,     0,     0,     0,     0,     0,  2983,  2984,     0,     0,
       0,     0,     0,     0,  1460,     0,     0,     0,     0,     0,
       0,     0,     0,  1229,     0,     0,     0,  2951,     0,     0,
    1456,  1604,     0,  1457,     0,     0,     0,     0,     0,     0,
    1460,     0,     0,     0,     0,     0,     0,  1458,     0,     0,
    1459,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0, -1900,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   700,     0,  1239,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1462,     0,     0,  1463,  1464,  1465,
       0,  1466,  1467,  1468,  1469,  1470,  1471,     0,     0,  1460,
       0,     0,  1472,     0,     0,     0,     0,     0,     0,     0,
    1462,     0,     0,  1463,  1464,  1465,     0,  1466,  1467,  1468,
    1469,  1470,  1471,     0,     0,     0,     0,  2050,  1472,     0,
       0,  1239,     0,  1462,     0,     0,     0,     0,   700,     0,
    1466,  1467,  1468,  1469,  1470,  1471,     0,     0,   700,     0,
       0,  1472,  1238,     0,     0,     0,     0,  3051,  3097,     0,
       0,     0,  3058,     0,  3060,  3061,  3062,  3063,     0,     0,
       0,     0,     0,     0,     0,  3122,     0,     0,     0,     0,
       0,  1229,   700,     0,  1387,     0,     0,     0,     0,  1462,
       0,     0,  1463,  1464,  1465,     0,  1466,  1467,  1468,  1469,
    1470,  1471,     0,     0,     0,   700,     0,  1472,     0,     0,
    1237,     0,  1410,     0,     0,  2246,  1239,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3109,
    3111,  3113,     0,  3115,     0,   700,   700,     0,     0,     0,
       0,     0,     0,     0,  1435,  1436,     0,  1439,     0,     0,
       0,     0,     0,  1449,     0,     0,     0,     0,  1450,     0,
       0,     0,     0,     0,  1477,   700,   700,     0,  2247,     0,
     700,     0,     0,     0,     0,     0,     0,  2248,  2249,  2250,
       0,     0,   700,   700,   700,   700,     0,     0,     0,     0,
    1604,     0,     0,     0,   700,  1604,     0,   700,     0,     0,
     700,     0,     0,  1520,     0,     0,     0,     0,     0,   700,
     700,  1237,   700,     0,     0,  3184,     0,     0,     0,     0,
       0,  2251,     0,     0,     0,   700,     0,   700,     0,     0,
    1631,   700,     0,     0,  1641,  1644,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2974,     0,     0,   700,     0,
       0,  3232,  3233,  3234,  3235,     0,     0,     0,   700,     0,
     700,   700,   700,  2252,     0,     0,     0,     0,  2253,     0,
       0,     0,     0,     0,   700,     0,     0,     0,     0,     0,
   -1900,  2198,   700,     0,  1452,     0,  1710,  2205,     0,   700,
       0,     0,     0,     0,   700,     0,     0,     0,     0,     0,
       0,   700,   700,   700,  1453,  1454,     0,  2254,     0,     0,
    1229,     0,     0,     0,     0,  1229,  1229,     0,     0, -1900,
       0,     0,     0,   700,  2255,  2256,  2257,  2258,  2259,     0,
    2260,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1499,     0,     0,     0,     0,     0,     0,     0,     0,  1239,
    1239,     0,  1239,     0,     0,  1457,     0,     0,     0,  1239,
       0,     0,     0,  2261,     0,     0,  3262,     0,     0,  1458,
       0,     0,     0,     0,  1447,     0,     0,  3271,     0,     0,
       0,     0,  1449,     0,     0,     0,     0,  1450,     0,     0,
    1239,     0,  1239,  1237,     0,     0,     0,     0,     0,  2262,
    3311,     0,     0,     0,  1238,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1604,  1604,  1604,     0,
       0,  1237,     0,  1229,     0,  2263,     0,  2264,     0,     0,
       0, -1900,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1237,     0,     0,     0,     0,     0,     0,
    2265,     0,  1710,     0,     0,  1239,  3312,  2266,     0,     0,
    2267,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3327,     0,     0,     0,  1239,     0,
       0,  1229,     0,     0,  2568,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1451,
       0,  1231,  1449,  1452,     0,  1237,     0,  1450,     0,     0,
       0,  1604,  1239,     0,     0,     0,     0,     0,  3359,     0,
       0,  1462,  1237,  1453,  1454,     0,     0,     0,  1466,  1467,
    1468,  1469,  1470,  1471,     0,  1239,     0,  1238,  1455,  1472,
       0,  1237,     0,     0,     0,     0,     0,     0,     0,     0,
    1239,     0,     0,     0,     0,     0,     0,     0,     0,  3416,
       0,  1990,  1232,     0,  1237,  1239,  1229,     0,     0,     0,
       0,  1456,   163,     0,  1457,     0,     0,     0,     0,     0,
       0,   700,     0,  2012,   996,   700,  2014,     0,  1458,  2025,
       0,  1459,     0,     0,  2977,   700,  2032,  2037,     0,     0,
    1239,  2042,  1231,     0,  2047,     0,     0,     0,  3460,     0,
       0,     0,     0,     0,     0,  1237,     0,     0,     0,  2056,
       0,     0,     0,  2062,   700,     0,     0,  2074,   164, -1900,
       0,  2081,     0,  1452,     0,  2083,  2084,  2085,  2086,  2087,
    2088,  2089,  2090,  2091,     0,     0,  2093,     0,   165,     0,
       0,   978,  3480,  1453,  1454,   700,     0,     0,  1239,     0,
    1460,     0,     0,  1232,   700,     0,     0,     0, -1900,   166,
     700,     0,   700,     0,     0,     0,     0,   700,     0,     0,
     700,   700,   700,   700,   700,   700,   700,   700,   700,  1239,
     700,     0,     0,     0,   700,   700,   167,     0,     0,     0,
       0,   168,  1239,     0,  1457,     0,   169,   700,     0,     0,
       0,  1604,     0,   700,     0,     0,     0,     0,  1458,     0,
       0,   170,     0,   700,     0,     0,   700,     0,   700,     0,
       0,     0,     0,     0,     0,     0,  1239,   700,   700,   700,
       0,     0,     0,   700,     0,     0,   700,     0,     0,     0,
    1462,     0,     0,  1463,  1464,  1465,   700,  1466,  1467,  1468,
    1469,  1470,  1471,     0,     0,   700,     0,     0,  1472,     0,
    1710,  2205,     0,  2205,     0,     0,     0,     0,     0,     0,
    1238,     0,     0,     0,  1231,     0,     0,     0,     0,     0,
   -1900,     0,     0,  1237,  1033,     0,     0,     0,     0,  1229,
    1229,     0,  1229,   171,     0,     0,     0,     0,     0,  1229,
       0,  1238,     0,  1238,     0,     0,     0,     0,     0,     0,
       0,     0,  1231,     0,     0,     0,  1604,  1239,  1604,     0,
     172,     0,     0,  3551,     0,     0,     0,     0,     0,  1447,
    1229,     0,  1229,     0,  1231,  1232,     0,  1449,     0,     0,
       0,     0,  1450,  2182,   173,  1604,     0,     0,     0,     0,
     174,     0,     0,     0,     0,     0,   175,     0,   176,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1462,     0,     0,  1232,     0,     0,  1238,  1466,  1467,  1468,
    1469,  1470,  1471,     0,   177,   178,     0,     0,  1472,   179,
       0,     0,     0,     0,     0,  1232,  1231,   180,     0,  2205,
       0,     0,   181,     0,     0,  1229,     0,     0,     0,     0,
       0,     0,   182,  1231,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   183,     0,   700,     0,  1229,     0,
       0,     0,  1231,  2205,     0,     0,     0,     0,     0,  1239,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1231,  1238,  1232,     0,     0,
       0,     0,  1229,     0,  1451,     0,     0,     0,  1452,     0,
       0,  1238,     0,     0,  1232,     0,  1239,   700,   700,     0,
       0,     0,     0,     0,  2342,  1229,  2205,     0,  1453,  1454,
       0,     0,     0,  1232,   700,     0,     0,     0,     0,   700,
    1229,     0,   700,  1455,     0,     0,  1231,     0,     0,     0,
       0,     0,  1237,     0,     0,  1229,  1232,  1237,  1237,     0,
       0,  1238,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1456,     0,     0,  1457,
     700,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1229,     0,     0,  1458,     0,     0,  1459,     0,     0,     0,
       0,  2458,     0,     0,     0,     0,     0,  1232,     0,  2533,
       0,     0,     0,     0,     0,     0,   700,     0,     0,  1238,
       0,     0,     0,   700,   700,     0,  1239,     0,     0,     0,
       0,   700,   700,     0,     0,  2479,   700,  1239,     0,     0,
       0,     0,   700,   700,     0,     0,   700,     0,  1229,     0,
    1238,     0,     0,     0,     0,     0,     0,     0,   978,     0,
       0,     0,     0,  1238,     0,  1460,   700,     0,     0,     0,
       0,     0,     0,     0,     0,  1237,     0,     0,     0,  1229,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2515,
       0,     0,  1229,  1239,     0,     0,     0,  1238,     0,     0,
       0,  1239,     0,     0,     0,     0,     0,     0,     0,  1447,
       0,     0,  2563,     0,     0,     0,     0,  1449,     0,     0,
       0,     0,  1450,     0,  1231,     0,  1229,     0,     0,     0,
       0,     0,     0,  1237,     0,  2037,     0,  2037,  2037,     0,
       0,     0,     0,     0,     0,     0,     0,  2575,     0,     0,
    2578,     0,     0,  2580,     0,  1462,     0,     0,  1463,  1464,
    1465,     0,  1466,  1467,  1468,  1469,  1470,  1471,     0,     0,
       0,     0,     0,  1472,     0,     0,     0,     0,  2601,     0,
    2603,     0,  1447,   700,  2606,  1232,     0,     0,  2205,     0,
    1449,     0,     0,  1604,     0,  1450,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2621,     0,  1229,  1237,     0,
       0,     0,     0,     0,   700,     0,     0,  2631,     0,  1239,
       0,     0,     0,     0,     0,  1033,     0,     0,     0,     0,
       0,   700,  1631,     0,  1451,   700,     0,  2644,  1452,     0,
    1239,     0,     0,     0,  1644,  1644,  1641,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1453,  1454,
     700,     0,     0,     0,  1239,     0,  2657,     0,     0,  1234,
       0,     0,     0,  1455,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   700,   700,     0,     0,   700,     0,
       0,     0,     0,     0,     0,   700,   700,     0,     0,     0,
    1238,     0,     0,     0,     0,     0,  1456,  1451,     0,  1457,
       0,  1452,     0,     0,     0,     0,     0,     0,  1235,  1239,
       0,     0,   700,  1458,     0,     0,  1459,     0,     0,  1229,
       0,  1453,  1454,     0,     0,     0,     0,  1710,     0,     0,
       0,     0,     0,  1231,     0,     0,  1455,     0,  1231,  1231,
       0,     0,     0,   700,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1229,     0,     0,     0,
    1234,     0,     0,     0,     0,     0,     0,     0,     0,  1456,
       0,     0,  1457,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   700,   700,  1460,  1458,     0,     0,  1459,
    1239,     0,     0,     0,  1232,     0,     0,     0,     0,  1232,
    1232,     0,     0,     0,     0,     0,     0,     0,     0,  1235,
       0,     0,     0,   700,  1239,     0,   700,     0,   700,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1237,  1237,     0,  1237,     0,     0,  1238,     0,     0,
       0,  1237,   700,     0,     0,  1239,     0,     0,  1238,  1239,
    1239,     0,     0,     0,     0,     0,  1231,     0,  1460,     0,
       0,     0,     0,     0,     0,     0,  1229,     0,     0,     0,
       0,     0,  1237,  1604,  1237,  1462,     0,  1229,  1463,  1464,
    1465,   700,  1466,  1467,  1468,  1469,  1470,  1471,     0,     0,
       0,     0,     0,  1472,     0,     0,     0,     0,     0,     0,
       0,   700,     0,     0,  1238,     0,     0,     0,  1239,     0,
       0,     0,  1238,     0,  1231,     0,     0,  1232,     0,     0,
       0,     0,     0,     0,   700,     0,     0,     0,     0,     0,
       0,     0,     0,  1229,     0,     0,     0,     0,     0,     0,
       0,  1229,  1234,     0,     0,     0,  1236,  1237,  1462,     0,
       0,  1463,  1464,  1465,     0,  1466,  1467,  1468,  1469,  1470,
    1471,     0,     0,     0,     0,  2771,  1472,     0,  1447,     0,
    1237,  2572,     0,     0,     0,  1232,  1449,     0,     0,     0,
    1234,  1450,     0,     0,     0,     0,     0,     0,   700,     0,
       0,  1235,     0,     0,     0,  1449,     0,     0,  2912,  1231,
    1450,     0,  1234,     0,  1237,     0,     0,  2915,     0,     0,
       0,     0,     0,  2916,     0,  2917,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1237,     0,  1235,
       0,     0,     0,     0,     0,     0,     0,  2935,  2936,     0,
    3344,     0,  1237,     0,     0,     0,     0,  1236,     0,     0,
       0,  1235,     0,     0,     0,     0,  2042,  1237,     0,     0,
    1232,  1238,     0,     0,  1234,     0,  2961,     0,     0,  2964,
       0,  2966,     0,     0,   700,     0,     0,     0,     0,     0,
    2970,  1234,     0,     0,     0,  1238,  2975,  3229,     0,  2978,
    1229,     0,  1237,     0,     0,     0,     0,     0,     0,  2985,
    1234,     0,     0,  1451,     0,     0,     0,  1452,  2479,     0,
       0,     0,   530,  1235,  1229,     0,     0,     0,     0,     0,
       0,     0, -1900,  1234,   531,     0,  1452,  1453,  1454,     0,
    1235,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2205,     0,  1455,     0,   532,     0,  1453,  1454,     0,  1235,
    1237,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0, -1900,     0,     0,     0,     0,     0,     0,   533,  1229,
       0,     0,  1235,     0,  1234,  1456,     0,     0,  1457,     0,
       0,  1237,     0,     0,     0,     0,     0,     0,   534,     0,
       0,     0,  1458,     0,  1237,  1459,     0,  1457,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   535,
       0,  1458,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2205,     0,  1235,     0,     0,     0,     0,  1237,  1236,
       0,     0,  1231,  1231,     0,  1231,   536,     0,     0,     0,
       0,   537,  1231,     0,     0,  1238,   538,     0,     0,     0,
    1229,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   539,     0,     0,  1460,     0,     0,  1236,     0,     0,
       0,     0,     0,  1231,  1229,  1231,  1238,     0,     0,     0,
    1238,  1238,     0, -1900,     0,     0,     0,     0,     0,  1236,
       0,     0,     0,  1232,  1232,     0,  1232,     0,     0,     0,
       0,     0,     0,  1232,     0,  1229,     0,     0,     0,  1229,
    1229,     0,     0,     0,     0,     0,     0,     0,     0,  1237,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3157,  3158,  1447,     0,  1232,     0,  1232,     0,     0,  3344,
    1449,     0,     0,   540,     0,  1450,     0,     0,  1231,     0,
       0,  1236,  1234,   541,  1462,     0,     0,  1463,  1464,  1465,
       0,  1466,  1467,  1468,  1469,  1470,  1471,     0,  1236,     0,
     172,  1231,  1472,  1462,     0,     0,     0,     0,     0,     0,
    1466,  1467,  1468,  1469,  1470,  1471,     0,  1236,     0,     0,
       0,  1472,     0,  3197,   542,     0,     0,     0,   543,     0,
     544,  1235,     0,     0,     0,  1231,   545,     0,   546,  1232,
    1236,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1231,     0,
       0,     0,  1232,     0,   547,   548,  3213,  3215,     0,   549,
       0,  1237,     0,  1231,     0,     0,     0,   550,     0,  3222,
       0,     0,   551,     0,     0,  3227,  3228,     0,  1231,  3230,
       0,  1236,   552,     0,     0,     0,  1232,  1451,     0,     0,
       0,  1452,     0,     0,   553,     0,     0,     0,  1237,  3244,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1232,
       0,  1453,  1454,  1231,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1232,     0,  1455,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1232,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1456,
       0,     0,  1457,     0,     0,     0,     0,     0,     0,     0,
       0,  1231,     0,     0,  1232,     0,  1458,     0,     0,  1459,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1234,  1231,     0,     0,     0,  1234,  1234,  1237,     0,
       0,     0,     0,     0,     0,  1231,  3300,     0,     0,  1237,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1232,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1460,  1231,
    1235,     0,     0,     0,     0,  1235,  1235,     0,     0,  1236,
       0,     0,     0,  1232,     0,     0,     0,     0,     0,     1,
       0,     0,     0,  2911,  3349,  1237,  1232,     0,     0,     2,
       0,     3,     4,  1237,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     5,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1232,     0,     0,     0,     0,     6,     0,     7,     8,     0,
       0,     0,     9,    10,  1234,     0,     0,     0,     0,     0,
       0,  3379,     0,    11,     0,    12,     0,     0,  1462,  3381,
    1231,  1463,  1464,  1465,     0,  1466,  1467,  1468,  1469,  1470,
    1471,     0,     0,     0,    13,     0,  1472,    14,     0,     0,
       0,     0,     0,    15,     0,     0,     0,     0,     0,    16,
       0,     0,     0,  1235,     0,    17,     0,     0,     0,     0,
       0,    18,  1234,  1447,     0,     0,  2957,    19,     0,    20,
       0,  1449,     0,     0,    21,     0,  1450,     0,     0,     0,
       0,  1232,     0,     0,     0,     0,     0,    22,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1235,  1237,     0,    23,     0,     0,  3450,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1237,     0,     0,    24,
      25,     0,  1231,     0,     0,    26,     0,  1234,     0,  2042,
       0,     0,     0,     0,    27,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1236,     0,
       0,     0,    28,  1236,  1236,  3482,     0,     0,     0,  1231,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1237,     0,     0,     0,     0,  1235,     0,  1451,     0,
       0,     0,  1452,  1232,     0,     0,     0,     0,     0,    29,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      30,     0,  1453,  1454,    31,     0,    32,     0,  1474,     0,
       0,    33,     0,     0,     0,     0,    34,  1455,  1447,    35,
    1232,     0,     0,    36,     0,     0,  1449,     0,     0,    37,
       0,  1450,     0,     0,     0,    38,     0,     0,    39,     0,
       0,     0,     0,     0,     0,    40,     0,     0,     0,     0,
    1456,     0,  1237,  1457,     0,     0,     0,     0,    41,     0,
       0,     0,     0,  1474,     0,     0,     0,  1458,     0,  1231,
    1459,  1236,     0,     0,    42,     0,  1237,     0,     0,     0,
    1231,     0,     0,    43,     0,    44,     0,     0,    45,     0,
       0,     0,    46,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    47,     0,     0,  1237,     0,     0,
       0,  1237,  1237,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1236,
    1232,     0,     0,     0,     0,     0,  1231,     0,     0,  1460,
       0,  1232,     0,     0,  1231,    48,     0,     0,     0,     0,
       0,     0,     0,  1451,     0,     0,     0,  1452,     0,     0,
    1234,  1234,     0,  1234,     0,     0,     0,     0,     0,     0,
    1234,     0,     0,     0,     0,     0,     0,  1453,  1454,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1455,     0,     0,     0,     0,  1232,     0,     0,
       0,  1234,     0,  1234,     0,  1232,     0,     0,     0,  1235,
    1235,     0,  1235,     0,  1236,     0,     0,     0,     0,  1235,
       0,     0,     0,     0,     0,  1456,     0,     0,  1457,  1462,
       0,     0,  1463,  1464,  1465,     0,  1466,  1467,  1468,  1469,
    1470,  1471,  1458,     0,     0,  1459,     0,  1472,     0,     0,
    1235,     0,  1235,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1234,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1231,     0,     0,     0,     0,     0,  1234,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1460,     0,     0,  1231,     0,     0,
       0,     0,     0,     0,     0,  1235,     0,     0,     0,     0,
       0,     0,     0,  1234,     0,     0,     0,  1447,     0,     0,
       0,     0,     0,     0,     0,  1449,     0,     0,  1235,     0,
    1450,     0,     0,     0,  1232,     0,  1234,     0,  1474,     0,
    1447,     0,     0,     0,     0,     0,     0,     0,  1449,     0,
       0,  1234,  1231,  1450,     0,     0,     0,     0,  1232,     0,
       0,     0,  1235,     0,     0,     0,  1234,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1462,  1235,     0,  1463,  1464,  1465,
       0,  1466,  1467,  1468,  1469,  1470,  1471,  1474,     0,  2999,
    1235,  1234,  1472,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1232,     0,  1235,     0,     0,     0,     0,
    1474,     0,     0,  1447,     0,  2021,     0,  1236,  1236,     0,
    1236,  1449,     0,  1231,     0,     0,  1450,  1236,     0,     0,
       0,     0,     0,     0,     0,  1474,  1474,     0,     0,  1474,
    1235,     0,  1451,     0,     0,     0,  1452,  1231,     0,  1234,
       0,     0,     0,     0,     0,     0,     0,     0,  1236,     0,
    1236,     0,  1447,     0,     0,  1451,  1453,  1454,     0,  1452,
    1449,     0,     0,     0,     0,  1450,     0,  1474,  1231,     0,
    1234,  1455,  1231,  1231,  1232,     0,     0,     0,     0,  1453,
    1454,     0,     0,  1234,     0,     0,     0,     0,  1235,     0,
       0,     0,     0,     0,  1455,     0,     0,     0,  1232,     0,
       0,     0,     0,     0,  1456,     0,     0,  1457,     0,     0,
    1474,     0,     0,     0,     0,     0,     0,  1234,     0,  1235,
       0,  1458,     0,  1236,  1459,     0,     0,  1456,     0,  1232,
    1457,     0,  1235,  1232,  1232,     0,     0,     0,  1451,     0,
       0,     0,  1452,     0,  1458,     0,  1236,  1459,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1453,  1454,     0,     0,  1235,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1455,     0,     0,
    1236,     0,     0,     0,     0,     0,     0,  1451,     0,     0,
       0,  1452,     0,  1460,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1236,     0,     0,     0,     0,  1234,     0,
    1456,  1453,  1454,  1457,     0,     0,  1460,     0,  1236,     0,
       0,  1474,     0,     0,     0,     0,  1455,  1458,     0,     0,
    1459,  1474,     0,  1236,  1474,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1235,     0,  1456,
       0,     0,  1457,     0,     0,     0,     0,     0,  1236,     0,
       0,     0,     0,     0,     0,     0,  1458,     0,     0,  1459,
       0,     0,     0,  1462,     0,     0,  1463,  1464,  1465,     0,
    1466,  1467,  1468,  1469,  1470,  1471,     0,     0,     0,  1460,
    2958,  1472,     0,     0,     0,     0,  1462,     0,     0,  1463,
    1464,  1465,     0,  1466,  1467,  1468,  1469,  1470,  1471,     0,
       0,     0,     0,  2990,  1472,     0,  1236,     0,     0,     0,
    1234,     0,     0,  1447,     0,     0,     0,     0,     0,     0,
       0,  1449,     0,     0,     0,     0,  1450,     0,  1460,     0,
       0,     0,     0,     0,     0,     0,     0,  1236,     0,     0,
       0,     0,     0,     0,     0,  1447,     0,  1234,     0,     0,
    1236,     0,     0,  1449,     0,     0,     0,     0,  1450,  1235,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1462,
       0,     0,  1463,  1464,  1465,     0,  1466,  1467,  1468,  1469,
    1470,  1471,     0,     0,  1236,     0,  3005,  1472,     0,     0,
       0,  1447,     0,     0,     0,     0,  1235,     0,     0,  1449,
       0,     0,     0,     0,  1450,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1462,     0,
       0,  1463,  1464,  1465,     0,  1466,  1467,  1468,  1469,  1470,
    1471,     0,     0,     0,     0,  3009,  1472,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1451,     0,
       0,     0,  1452,     0,     0,     0,     0,  1234,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1234,     0,
       0,     0,  1453,  1454,     0,  1236,     0,     0,     0,     0,
    1451,     0,     0,     0,  1452,     0,     0,  1455,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1453,  1454,  1235,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1235,     0,  1455,
    1456,     0,     0,  1457,  1234,     0,  1451,     0,     0,     0,
    1452,     0,  1234,     0,     0,     0,     0,  1458,     0,     0,
    1459,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1453,  1454,  1456,     0,     0,  1457,     0,     0,     0,     0,
    1474,     0,     0,     0,     0,  1455,     0,     0,     0,  1458,
       0,     0,  1459,  1235,     0,     0,     0,     0,     0,     0,
       0,  1235,  1474,     0,  1474,     0,  2021,  2021,  2551,     0,
       0,  2021,     0,     0,     0,  1474,     0,  1236,  1456,     0,
       0,  1457,  1474,     0,     0,     0,     0,  1474,     0,  1460,
       0,     0,  1474,     0,     0,  1458,     0,  1474,  1459,     0,
       0,     0,     0,     0,     0,     0,  1474,     0,     0,     0,
    2021,  2021,  1474,     0,  1236,     0,     0,     0,     0,     0,
       0,  1460,     0,     0,  1474,     0,     0,     0,     0,     0,
       0,  1474,     0,  1474,  1474,  1474,  1474,  1474,  1474,  1474,
    1474,  1474,  1447,  1474,     0,     0,     0,     0,     0,     0,
    1449,     0,     0,     0,     0,  1450,     0,     0,  1447,     0,
       0,  1234,     0,     0,     0,     0,  1449,  1460,     0,     0,
       0,  1450,     0,     0,     0,     0,     0,     0,     0,  1462,
       0,     0,  1463,  1464,  1465,  1234,  1466,  1467,  1468,  1469,
    1470,  1471,     0,     0,     0,     0,  3199,  1472,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1235,  1462,     0,     0,  1463,  1464,  1465,     0,  1466,  1467,
    1468,  1469,  1470,  1471,  1236,     0,     0,     0,  3231,  1472,
       0,     0,  1474,     0,  1235,  1236,     0,     0,     0,     0,
    1234,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1462,     0,     0,
    1463,  1464,  1465,     0,  1466,  1467,  1468,  1469,  1470,  1471,
       0,     0,     0,     0,  3371,  1472,     0,  1451,     0,     0,
       0,  1452,     0,     0,     0,     0,     0,     0,     0,  1235,
       0,  1236,     0,  1451,     0,     0,     0,  1452,     0,  1236,
       0,  1453,  1454,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1455,  1453,  1454,     0,
       0,  1234,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1455,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1234,     0,     0,     0,  1456,
    1447,     0,  1457,     0,     0,     0,     0,     0,  1449,     0,
       0,     0,     0,  1450,     0,  1456,  1458,     0,  1457,  1459,
    1235,     0,     0,     0,     0,     0,  1234,     0,     0,     0,
    1234,  1234,  1458,     0,     0,  1459,     0,     0,     0,     0,
       0,     0,  1474,     0,  1235,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1235,     0,     0,     0,  1235,
    1235,     0,     0,     0,     0,     0,     0,     0,  1460,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1236,     0,
       0,     0,     0,     0,  1460,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1236,     0,     0,     0,     0,     0,  1447,     0,
       0,     0,     0,     0,     0,  1451,  1449,     0,     0,  1452,
       0,  1450,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1474,  1453,
    1454,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1455,     0,     0,  1236,  1462,  1474,
       0,  1463,  1464,  1465,     0,  1466,  1467,  1468,  1469,  1470,
    1471,     0,     0,     0,  1462,  3386,  1472,  1463,  1464,  1465,
       0,  1466,  1467,  1468,  1469,  1470,  1471,  1456,     0,     0,
    1457,  3418,  1472,     0,     0,  1474,     0,     0,     0,     0,
       0,     0,     0,     0,  1458,     0,     0,  1459,     0,     0,
       0,     0,     0,     0,     0,     0,  2551,  2551,  2021,     0,
       0,  2021,  2021,  2021,  2021,  2021,  2021,  2021,  2021,  2021,
       0,  2021,  2551,     0,     0,     0,     0,     0,  1236,     0,
       0,     0,     0,  1451,     0,     0,     0,  1452,     0,     0,
       0,     0,     0,     0,     0,  1474,     0,     0,  1474,     0,
    1474,     0,  1236,     0,     0,  2551,  2551,  1453,  1454,     0,
       0,     0,     0,     0,     0,     0,  1460,     0,     0,  2021,
    2021,  1474,  1455,  1474,     0,     0,  1474,     0,     0,     0,
       0,     0,     0,  1236,     0,     0,     0,  1236,  1236,     0,
       0,  1474,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1474,     0,     0,     0,  1456,     0,     0,  1457,     0,
       0,     0,     0,     0,  1474,     0,     0,     0,     0,     0,
       0,     0,  1458,     0,     0,  1459,   491,  1474,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   492,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1462,     0,   493,  1463,
    1464,  1465,     0,  1466,  1467,  1468,  1469,  1470,  1471,     0,
       0,     0,     0,  3517,  1472,     0,     0,     0,   494,     0,
       0,     0,  -567,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1460,     0,     0,     0,     0,     0,
       0,     0,   495,     0,     0,     0,     0,     0,   496,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   497,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     498,     0,     0,     0,     0,  -725,   499,     0,     0,     0,
     500,     0,     0,     0,     0,     0,     0,  2021,     0,     0,
       0,     0,     0,     0,     0,  -704,     0,     0,     0,     0,
       0,     0,     0,     0,  1462,     0,     0,  1463,  1464,  1465,
       0,  1466,  1467,  1468,  1469,  1470,  1471,     0,  -432,     0,
       0,     0,  1472,     0,     0,     0,     0,     0,     0,     0,
       0,   501,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   502,     0,     0,
     503,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1474,     0,  -432,  1474,  1474,  1474,     0,  2551,
       0,     0,     0,     0,  2551,  2551,  2551,  2551,  2551,  2551,
    2551,  2551,  2551,     0,  2551,  1474,  1474,     0,   504,     0,
       0,     0,  -725,     0,   505,     0,     0,     0,     0,     0,
       0,     0,   506,     0,     0,     0,     0,     0,     0,     0,
       0,  1474,  2021,  2021,  1474,     0,  1474,     0,     0,     0,
    1474,  2551,  2551,     0,     0,  1474,     0,     0,  1474,   507,
     508,     0,   509,   510,     0,  1474,     0,     0,     0,     0,
       0,   511,     0,     0,     0,   512,   513,     0,     0,     0,
       0,   514,     0,     0,     0,     0,   515,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2551,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1474,  1474,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1474,     0,     0,
       0,  2021,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1474,     0,  1474,     0,     0,     0,     0,
    2551,  2551,  1474,     0,     0,  2021,  2021,  1474,  1474,     0,
    1474,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1474,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1474,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1474,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2551,  2021,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2551,  2551,  1474,
       0,  1474,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   186,   187,   188,   189,   190,   191,   192,   193,     0,
     195,   196,   197,     0,     0,     0,     0,     0,     0,     0,
     198,   199,     0,   200,     0,   201,   202,   203,     0,   204,
       0,   205,   206,     0,   207,   208,   209,   210,   211,     0,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
     220,   221,     0,     0,   222,   223,   224,   225,   226,   227,
    1474,   228,   229,   230,   231,   232,   233,     0,   234,   235,
     236,     0,   237,   238,     0,  2551,     0,     0,     0,     0,
       0,   239,   240,   241,   242,   243,   244,   245,   246,   247,
       0,   248,  1474,   249,   250,   251,   252,   253,     0,   254,
     255,   256,     0,     0,   257,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,     0,   267,   268,   269,
     270,   271,   272,   273,     0,   274,     0,   275,   276,   277,
       0,   278,     0,   279,     0,     0,     0,   280,   281,     0,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   299,   300,   301,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,   319,   320,     0,     0,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
       0,   335,     0,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,     0,   353,     0,     0,     0,   354,
     355,   356,     0,     0,   357,     0,     0,     0,   358,   359,
     360,   361,   362,   363,   364,     0,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,     0,   406,   407,   408,   409,     0,   410,   411,   412,
     413,     0,   414,   415,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
       0,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,     0,   447,   448,   449,   450,     0,  3453,
     451,   452,   453,   454,   455,   456,     0,   457,     0,   458,
     459,   460,     0,     0,   461,     0,     0,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     0,     0,     0,   478,     0,     0,     0,
       0,     0,   186,   187,   188,   189,   190,   191,   192,   193,
    2111,   195,   196,   197,     0, -1559,     0,     0,   898,     0,
   -1559,   198,   199,     0,   200,   674,   201,   202,   203,   675,
     899,   676,   900,   901,     0,   207,   208,   209,   210,   211,
     902,   903,   212,   213,   904,   905,   216,     0,   217,   218,
     219,   220,   906,     0,     0,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   677,   237,   238,   907,   908,   909,   910,   911,
     912,   913,   239,   240,   241,   242,   243,   244,   914,   915,
     247,     0,   248,     0,   249,   250,   251,   252,   253,     0,
     254,   255,   256,  2112,     0,   257,   258,   916,   260,   261,
       0,   262,   263,   264,     0,   265,   266,     0,   267,   268,
     269,   917,   271,   272,   918,   919,   274,     0,   275,   920,
     277,     0,   278,     0,   279,   679,     0,   680,   280,   281,
       0,   282,   921,     0,   284,     0,   285,   286,   287,   288,
     289,   681,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,   682,   299,   300,   301,   302,   303,   922,
     923,     0,   924,     0,   307,   683,   684,   308,   685,   309,
     310,   311,   312,   313,   314,   315,     0,   925,   686,   317,
     687,     0,   318,   319,   320,   926,   927,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     928,   688,   929,   638,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   930,   345,   346,   689,   347,   931,   932,
     349,   933,   351,   352,     0,     0,   353,   639,     0,     0,
     934,   355,   356,     0,     0,   357,   690,   691,   692,   935,
     359,   360,   361,   362,   363,   364,     0,   365,   936,   367,
     368,   369,   370,   371,     0,   372,   373,   374,   375,   376,
     377,   378,   937,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,     0,   393,   394,
     693,   395,   396,   938,   398,   399,   400,   401,   402,   403,
     404,   405,     0,   406,   407,   408,   409,   939,   410,   411,
     412,   413,   694,   414,   940,     0,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   941,   427,     0,   428,
     429,     0,   430,   431,   432,   433,   434,     0,   942,   943,
       0,     0,   437,   944,   439,   945,   946,   441,   442,   443,
     444,   445,   446,     0,   947,   447,   448,   449,   450,   948,
       0,   451,   452,   453,   454,   455,   949,  2113,   457,   695,
     458,   459,   460,     0,     0,   461,     0,     0,   462,   463,
     464,   465,   466,   467,   950,   951,   952,   953,   954,   955,
     956,   475,   476,   477,     0,     0,     0,   696,   957,   586,
     958,   959,   960,   569,   961,     0,     0,     0,     0,   962,
     963,  2114,     0,     0,     0,     0,     0,     0,   965,  2115,
     186,   187,   188,   189,   190,   191,   192,   193,     0,   195,
     196,   197,     0,     0,     0,     0,   898,     0,     0,   198,
     199,     0,   200,   674,   201,   202,   203,   675,   899,   676,
     900,   901,     0,   207,   208,   209,   210,   211,   902,   903,
     212,   213,   904,   905,   216,     0,   217,   218,   219,   220,
     906,     0,     0,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     677,   237,   238,   907,   908,   909,   910,   911,   912,   913,
     239,   240,   241,   242,   243,   244,   914,   915,   247,     0,
     248,     0,   249,   250,   251,   252,   253,     0,   254,   255,
     256,     0,     0,   257,   258,   916,   260,   261,     0,   262,
     263,   264,     0,   265,   266,     0,   267,   268,   269,   917,
     271,   272,   918,   919,   274,     0,   275,   920,   277,     0,
     278,     0,   279,   679,     0,   680,   280,   281,     0,   282,
     921,     0,   284,     0,   285,   286,   287,   288,   289,   681,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,   682,   299,   300,   301,   302,   303,   922,   923,     0,
     924,     0,   307,   683,   684,   308,   685,   309,   310,   311,
     312,   313,   314,   315,     0,   925,   686,   317,   687,     0,
     318,   319,   320,   926,   927,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   928,   688,
     929,   638,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   930,   345,   346,   689,   347,   931,   932,   349,   933,
     351,   352,     0,     0,   353,   639,     0,     0,   934,   355,
     356,     0,     0,   357,   690,   691,   692,   935,   359,   360,
     361,   362,   363,   364,     0,   365,   936,   367,   368,   369,
     370,   371,     0,   372,   373,   374,   375,   376,   377,   378,
     937,   380,   381,   382,     0,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,   394,   693,   395,
     396,   938,   398,   399,   400,   401,   402,   403,   404,   405,
       0,   406,   407,   408,   409,   939,   410,   411,   412,   413,
     694,   414,   940,     0,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   941,   427,     0,   428,   429,     0,
     430,   431,   432,   433,   434,     0,   942,   943,     0,     0,
     437,   944,   439,   945,   946,   441,   442,   443,   444,   445,
     446,     0,   947,   447,   448,   449,   450,   948,     0,   451,
     452,   453,   454,   455,   949,     0,   457,   695,   458,   459,
     460,     0,     0,   461,     0,     0,   462,   463,   464,   465,
     466,   467,   950,   951,   952,   953,   954,   955,   956,   475,
     476,   477,     0,     0,     0,   696,   957,   586,   958,   959,
     960,   569,   961,     0,     0,     0,     0,   962,   963,     0,
       0,     0,     0,     0,     0,     0,   965,  2023,   186,   187,
     188,   189,   190,   191,   192,   193,     0,   195,   196,   197,
       0,     0,     0,     0,     0,  2439,     0,   198,   199,     0,
     200,     0,   201,   202,   203,     0,   204,     0,   205,   206,
       0,   207,   208,   209,   210,   211,     0,     0,   212,   213,
     214,   215,   216,     0,   217,   218,   219,   220,   221,     0,
       0,   222,   223,   224,   225,   226,   227,     0,   228,   229,
     230,   231,   232,   233,     0,   234,   235,   236, -1164,   237,
     238,     0,     0,     0,     0,     0,     0,     0,   239,   240,
     241,   242,   243,   244,   245,   246,   247,     0,   248,     0,
     249,   250,   251,   252,   253,     0,   254,   255,   256,     0,
       0,   257,   258,   259,   260,   261,     0,   262,   263,   264,
       0,   265,   266,     0,   267,   268,   269,   270,   271,   272,
     273,     0,   274,     0,   275,   276,   277,     0,   278,     0,
     279,     0,     0, -1164,   280,   281,     0,   282,   283,     0,
     284,     0,   285,   286,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0, -1164,
     299,   300,   301,   302,   303,   304,   305,     0,   306,     0,
     307,     0,     0,   308, -1164,   309,   310,   311,   312,   313,
     314,   315,     0,   316, -1164,   317,     0,     0,   318,   319,
     320,     0,     0,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334, -1164,   335,     0,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,     0,   353,     0,     0,     0,   354,   355,   356,     0,
       0,   357,     0,     0,     0,   358,   359,   360,   361,   362,
     363,   364,     0,   365,   366,   367,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,     0,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,     0,   393,   394, -1164,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,     0,   406,
     407,   408,   409,     0,   410,   411,   412,   413,     0,   414,
     415,     0,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,     0,   428,   429,     0,   430,   431,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
       0,   447,   448,   449,   450,     0,     0,   451,   452,   453,
     454,   455,   456,     0,   457,     0,   458,   459,   460,     0,
       0,   461,     0,     0,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
       0,     0,     0,   478,   186,   187,   188,   189,   190,   191,
     192,   193,     0,   195,   196,   197,     0,     0,     0,     0,
       0,     0,     0,   198,   199,  1040,   200,   674,   201,   202,
     203,   675,  1205,   676,  1206,  1207,     0,   207,   208,   209,
     210,   211,     0,     0,   212,   213,  1208,  1209,   216,     0,
     217,   218,   219,   220,     0,     0,     0,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   677,   237,   238,     0,     0,     0,
     678,     0,     0,     0,   239,   240,   241,   242,   243,   244,
    1210,  1211,   247,     0,   248,     0,   249,   250,   251,   252,
     253,     0,   254,   255,   256,     0,     0,   257,   258,   916,
     260,   261,     0,   262,   263,   264,     0,   265,   266,     0,
     267,   268,   269,     0,   271,   272,     0,     0,   274,     0,
     275,  1212,   277,     0,   278,     0,   279,   679,     0,   680,
     280,   281,     0,   282,     0,     0,   284,     0,   285,   286,
     287,   288,   289,   681,   290,   291,   292,  1698,   293,   294,
     295,   296,   297,   298,     0,   682,  1699,   300,   301,   302,
     303,  1213,  1214,     0,  1215,     0,   307,   683,   684,   308,
     685,   309,   310,   311,   312,   313,   314,   315,     0,     0,
     686,   317,   687,     0,   318,   319,   320,     0,     0,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,  1216,   688,  1217,     0,   336,   337,   338,   339,
     340,   341,   342,     0,   344,     0,   345,   346,   689,   347,
       0,     0,   349,  1218,   351,   352,     0,     0,   353,     0,
       0,     0,   354,   355,   356,     0,     0,  1700,   690,   691,
     692,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,   367,     0,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,  1219,   380,   381,   382,     0,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,     0,
     393,   394,   693,   395,   396,     0,   398,   399,   400,   401,
     402,   403,   404,   405,     0,   406,   407,   408,   409,     0,
     410,  1701,   412,   413,   694,   414,  1221,     0,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   427,
       0,   428,   429,     0,   430,   431,   432,   433,   434,     0,
    1222,  1223,     0,     0,   437,     0,   439,     0,     0,   441,
     442,   443,   444,   445,   446,     0,     0,   447,   448,   449,
     450,     0,     0,   451,   452,   453,   454,     0,  1224,  1702,
     457,   695,   458,   459,   460,     0,     0,   461,     0,     0,
     462,   463,   464,   465,   466,     0,     0,     0,     0,     0,
       0,     0,     0,   475,   476,   477,     0,     0,     0,  1225,
     186,   187,   188,   189,   190,   191,   192,   193,     0,   195,
     196,   197,     0,     0,     0,     0,     0,     0,     0,   198,
     199,  1703,   200,   674,   201,   202,   203,   675,  1205,   676,
    1206,  1207,     0,   207,   208,   209,   210,   211,     0,     0,
     212,   213,  1208,  1209,   216,     0,   217,   218,   219,   220,
       0,     0,     0,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     677,   237,   238,     0,     0,     0,   678,     0,     0,     0,
     239,   240,   241,   242,   243,   244,  1210,  1211,   247,     0,
     248,     0,   249,   250,   251,   252,   253,     0,   254,   255,
     256,     0,     0,   257,   258,   916,   260,   261,     0,   262,
     263,   264,     0,   265,   266,     0,   267,   268,   269,     0,
     271,   272,     0,     0,   274,     0,   275,  1212,   277,     0,
     278,     0,   279,   679,     0,   680,   280,   281,     0,   282,
       0,     0,   284,     0,   285,   286,   287,   288,   289,   681,
     290,   291,   292,  1698,   293,   294,   295,   296,   297,   298,
       0,   682,  1699,   300,   301,   302,   303,  1213,  1214,     0,
    1215,     0,   307,   683,   684,   308,   685,   309,   310,   311,
     312,   313,   314,   315,     0,     0,   686,   317,   687,     0,
     318,   319,   320,     0,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,  1216,   688,
    1217,     0,   336,   337,   338,   339,   340,   341,   342,     0,
     344,     0,   345,   346,   689,   347,     0,     0,   349,  1218,
     351,   352,     0,     0,   353,     0,     0,     0,   354,   355,
     356,     0,     0,  1700,   690,   691,   692,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,   367,     0,   369,
     370,   371,     0,   372,   373,   374,   375,   376,   377,   378,
    1219,   380,   381,   382,     0,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,   394,   693,   395,
     396,     0,   398,   399,   400,   401,   402,   403,   404,   405,
       0,   406,   407,   408,   409,     0,   410,  1701,   412,   413,
     694,   414,  1221,     0,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   427,     0,   428,   429,     0,
     430,   431,   432,   433,   434,     0,  1222,  1223,     0,     0,
     437,     0,   439,     0,     0,   441,   442,   443,   444,   445,
     446,     0,     0,   447,   448,   449,   450,     0,     0,   451,
     452,   453,   454,     0,  1224,  1702,   457,   695,   458,   459,
     460,     0,     0,   461,     0,     0,   462,   463,   464,   465,
     466,     0,     0,     0,     0,     0,     0,     0,     0,   475,
     476,   477,     0,     0,     0,  1225,   186,   187,   188,   189,
     190,   191,   192,   193,     0,   195,   196,   197,     0,     0,
       0,     0,   898,     0,     0,   198,   199,  2420,   200,   674,
     201,   202,   203,   675,   899,   676,   900,   901,  2033,   207,
     208,   209,   210,   211,   902,   903,   212,   213,   904,   905,
     216,     0,   217,   218,   219,   220,   906,     0,     0,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   677,   237,   238,   907,
     908,   909,   910,   911,   912,   913,   239,   240,   241,   242,
     243,   244,   914,   915,   247,     0,   248,     0,   249,   250,
     251,   252,   253,     0,   254,   255,   256,     0,     0,   257,
     258,   916,   260,   261,     0,   262,   263,   264,     0,   265,
     266,     0,   267,   268,   269,   917,   271,   272,   918,   919,
     274,     0,   275,   920,   277,     0,   278,     0,   279,   679,
    2034,   680,   280,   281,     0,   282,   921,     0,   284,     0,
     285,   286,   287,   288,   289,   681,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,   682,   299,   300,
     301,   302,   303,   922,   923,     0,   924,     0,   307,   683,
     684,   308,   685,   309,   310,   311,   312,   313,   314,   315,
    2035,   925,   686,   317,   687,     0,   318,   319,   320,   926,
     927,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   928,   688,   929,   638,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   930,   345,   346,
     689,   347,   931,   932,   349,   933,   351,   352,     0,     0,
     353,   639,     0,     0,   934,   355,   356,     0,     0,   357,
     690,   691,   692,   935,   359,   360,   361,   362,   363,   364,
       0,   365,   936,   367,   368,   369,   370,   371,     0,   372,
     373,   374,   375,   376,   377,   378,   937,   380,   381,   382,
       0,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,     0,   393,   394,   693,   395,   396,   938,   398,   399,
     400,   401,   402,   403,   404,   405,     0,   406,   407,   408,
     409,   939,   410,   411,   412,   413,   694,   414,   940,     0,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     941,   427,     0,   428,   429,     0,   430,   431,   432,   433,
     434,     0,   942,   943,     0,  2036,   437,   944,   439,   945,
     946,   441,   442,   443,   444,   445,   446,     0,   947,   447,
     448,   449,   450,   948,     0,   451,   452,   453,   454,   455,
     949,     0,   457,   695,   458,   459,   460,     0,     0,   461,
       0,     0,   462,   463,   464,   465,   466,   467,   950,   951,
     952,   953,   954,   955,   956,   475,   476,   477,     0,     0,
       0,   696,   957,   586,   958,   959,   960,   569,   961,     0,
       0,     0,     0,   962,   963,     0,     0,     0,     0,     0,
       0,     0,   965,   186,   187,   188,   189,   190,   191,   192,
     193,     0,   195,   196,   197,     0,     0,     0,     0,   898,
       0,     0,   198,   199,     0,   200,   674,   201,   202,   203,
     675,   899,   676,   900,   901,     0,   207,   208,   209,   210,
     211,   902,   903,   212,   213,   904,   905,   216,     0,   217,
     218,   219,   220,   906,     0,     0,   222,   223,   224,   225,
     226,   227,     0,   228,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   677,   237,   238,   907,   908,   909,   910,
     911,   912,   913,   239,   240,   241,   242,   243,   244,   914,
     915,   247,     0,   248,     0,   249,   250,   251,   252,   253,
       0,   254,   255,   256,     0,     0,   257,   258,   916,   260,
     261,     0,   262,   263,   264,     0,   265,   266,     0,   267,
     268,   269,   917,   271,   272,   918,   919,   274,     0,   275,
     920,   277,     0,   278,     0,   279,   679,     0,   680,   280,
     281,     0,   282,   921,     0,   284,     0,   285,   286,   287,
     288,   289,   681,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   682,   299,   300,   301,   302,   303,
     922,   923,     0,   924,     0,   307,   683,   684,   308,   685,
     309,   310,   311,   312,   313,   314,   315,     0,   925,   686,
     317,   687,     0,   318,   319,   320,   926,   927,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   928,   688,   929,   638,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   930,   345,   346,   689,   347,   931,
     932,   349,   933,   351,   352,     0,     0,   353,   639,     0,
       0,   934,   355,   356,     0,     0,   357,   690,   691,   692,
     935,   359,   360,   361,   362,   363,   364,     0,   365,   936,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,   937,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   693,   395,   396,   938,   398,   399,   400,   401,   402,
     403,   404,   405,    37,   406,   407,   408,   409,   939,   410,
     411,   412,   413,   694,   414,   940,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   941,   427,     0,
     428,   429,    41,   430,   431,   432,   433,   434,     0,   942,
     943,     0,     0,   437,   944,   439,   945,   946,   441,   442,
     443,   444,   445,   446,     0,   947,   447,   448,   449,   450,
     948,     0,   451,   452,   453,   454,  1437,   949,     0,   457,
     695,   458,   459,   460,     0,     0,   461,     0,    47,   462,
     463,   464,   465,   466,   467,   950,   951,   952,   953,   954,
     955,   956,   475,   476,   477,     0,     0,     0,   696,   957,
     586,   958,   959,   960,   569,   961,     0,     0,     0,     0,
     962,   963,     0,     0,     0,     0,     0,     0,     0,   965,
     186,   187,   188,   189,   190,   191,   192,   193,     0,   195,
     196,   197,     0,     0,     0,     0,   898,     0,     0,   198,
     199,     0,   200,   674,   201,   202,   203,   675,   899,   676,
     900,   901,     0,   207,   208,   209,   210,   211,   902,   903,
     212,   213,   904,   905,   216,     0,   217,   218,   219,   220,
     906,     0,     0,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     677,   237,   238,   907,   908,   909,   910,   911,   912,   913,
     239,   240,   241,   242,   243,   244,   914,   915,   247,     0,
     248,     0,   249,   250,   251,   252,   253,     0,   254,   255,
     256,     0,     0,   257,   258,   916,   260,   261,     0,   262,
     263,   264,     0,   265,   266,     0,   267,   268,   269,   917,
     271,   272,   918,   919,   274,     0,   275,   920,   277,     0,
     278,     0,   279,   679,     0,   680,   280,   281,     0,   282,
     921,     0,   284,     0,   285,   286,   287,   288,   289,   681,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,   682,   299,   300,   301,   302,   303,   922,   923,     0,
     924,     0,   307,   683,   684,   308,   685,   309,   310,   311,
     312,   313,   314,   315,     0,   925,   686,   317,   687,     0,
     318,   319,   320,   926,   927,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   928,   688,
     929,   638,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   930,   345,   346,   689,   347,   931,   932,   349,   933,
     351,   352,     0,     0,   353,   639,     0,     0,   934,   355,
     356,     0,     0,   357,   690,   691,   692,   935,   359,   360,
     361,   362,   363,   364,     0,   365,   936,   367,   368,   369,
     370,   371,     0,   372,   373,   374,   375,   376,   377,   378,
     937,   380,   381,   382,     0,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,   394,   693,   395,
     396,   938,   398,   399,   400,   401,   402,   403,   404,   405,
       0,   406,   407,   408,   409,   939,   410,   411,   412,   413,
     694,   414,   940,     0,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   941,   427,     0,   428,   429,     0,
     430,   431,   432,   433,   434,     0,   942,   943,     0,     0,
     437,   944,   439,   945,   946,   441,   442,   443,   444,   445,
     446,     0,   947,   447,   448,   449,   450,   948,     0,   451,
     452,   453,   454,   455,   949,     0,   457,   695,   458,   459,
     460,     0,     0,   461,     0,     0,   462,   463,   464,   465,
     466,   467,   950,   951,   952,   953,   954,   955,   956,   475,
     476,   477,     0,     0,     0,   696,   957,   586,   958,   959,
     960,   569,   961,     0,     0,     0,     0,   962,   963,     0,
       0,     0,     0,     0,  1382,  1982,   965,   186,   187,   188,
     189,   190,   191,   192,   193,     0,   195,   196,   197,     0,
       0,     0,     0,   898,     0,     0,   198,   199,     0,   200,
     674,   201,   202,   203,   675,   899,   676,   900,   901,     0,
     207,   208,   209,   210,   211,   902,   903,   212,   213,   904,
     905,   216,     0,   217,   218,   219,   220,   906,     0,     0,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   677,   237,   238,
     907,   908,   909,   910,   911,   912,   913,   239,   240,   241,
     242,   243,   244,   914,   915,   247,     0,   248,     0,   249,
     250,   251,   252,   253,     0,   254,   255,   256,     0,     0,
     257,   258,   916,   260,   261,     0,   262,   263,   264,     0,
     265,   266,     0,   267,   268,   269,   917,   271,   272,   918,
     919,   274,     0,   275,   920,   277,     0,   278,     0,   279,
     679,     0,   680,   280,   281,     0,   282,   921,     0,   284,
       0,   285,   286,   287,   288,   289,   681,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   682,   299,
     300,   301,   302,   303,   922,   923,     0,   924,     0,   307,
     683,   684,   308,   685,   309,   310,   311,   312,   313,   314,
     315,     0,   925,   686,   317,   687,     0,   318,   319,   320,
     926,   927,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   928,   688,   929,   638,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   930,   345,
     346,   689,   347,   931,   932,   349,   933,   351,   352,     0,
       0,   353,   639,     0,     0,   934,   355,   356,     0,     0,
     357,   690,   691,   692,   935,   359,   360,   361,   362,   363,
     364,     0,   365,   936,   367,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,   937,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,   693,   395,   396,   938,   398,
     399,   400,   401,   402,   403,   404,   405,     0,   406,   407,
     408,   409,   939,   410,   411,   412,   413,   694,   414,   940,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   941,   427,     0,   428,   429,     0,   430,   431,   432,
     433,   434,     0,   942,   943,     0,     0,   437,   944,   439,
     945,   946,   441,   442,   443,   444,   445,   446,     0,   947,
     447,   448,   449,   450,   948,     0,   451,   452,   453,   454,
     455,   949,     0,   457,   695,   458,   459,   460,     0,     0,
     461,     0,     0,   462,   463,   464,   465,   466,   467,   950,
     951,   952,   953,   954,   955,   956,   475,   476,   477,     0,
       0,     0,   696,   957,   586,   958,   959,   960,   569,   961,
       0,     0,     0,     0,   962,   963,   964,     0,     0,     0,
       0,     0,     0,   965,   186,   187,   188,   189,   190,   191,
     192,   193,     0,   195,   196,   197,     0,     0,     0,     0,
     898,     0,     0,   198,   199,     0,   200,   674,   201,   202,
     203,   675,   899,   676,   900,   901,     0,   207,   208,   209,
     210,   211,   902,   903,   212,   213,   904,   905,   216,     0,
     217,   218,   219,   220,   906,     0,     0,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   677,   237,   238,   907,   908,   909,
     910,   911,   912,   913,   239,   240,   241,   242,   243,   244,
     914,   915,   247,  1032,   248,     0,   249,   250,   251,   252,
     253,     0,   254,   255,   256,     0,     0,   257,   258,   916,
     260,   261,     0,   262,   263,   264,     0,   265,   266,     0,
     267,   268,   269,   917,   271,   272,   918,   919,   274,     0,
     275,   920,   277,     0,   278,     0,   279,   679,     0,   680,
     280,   281,     0,   282,   921,     0,   284,     0,   285,   286,
     287,   288,   289,   681,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,   682,   299,   300,   301,   302,
     303,   922,   923,     0,   924,     0,   307,   683,   684,   308,
     685,   309,   310,   311,   312,   313,   314,   315,     0,   925,
     686,   317,   687,     0,   318,   319,   320,   926,   927,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   928,   688,   929,   638,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   930,   345,   346,   689,   347,
     931,   932,   349,   933,   351,   352,     0,     0,   353,   639,
       0,     0,   934,   355,   356,     0,     0,   357,   690,   691,
     692,   935,   359,   360,   361,   362,   363,   364,     0,   365,
     936,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,   937,   380,   381,   382,     0,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,     0,
     393,   394,   693,   395,   396,   938,   398,   399,   400,   401,
     402,   403,   404,   405,     0,   406,   407,   408,   409,   939,
     410,   411,   412,   413,   694,   414,   940,     0,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   941,   427,
       0,   428,   429,     0,   430,   431,   432,   433,   434,     0,
     942,   943,     0,     0,   437,   944,   439,   945,   946,   441,
     442,   443,   444,   445,   446,     0,   947,   447,   448,   449,
     450,   948,     0,   451,   452,   453,   454,   455,   949,     0,
     457,   695,   458,   459,   460,     0,     0,   461,     0,     0,
     462,   463,   464,   465,   466,   467,   950,   951,   952,   953,
     954,   955,   956,   475,   476,   477,     0,     0,     0,   696,
     957,   586,   958,   959,   960,   569,   961,     0,     0,     0,
       0,   962,   963,     0,     0,     0,     0,     0,     0,     0,
     965,   186,   187,   188,   189,   190,   191,   192,   193,  1639,
     195,   196,   197,     0,     0,     0,     0,   898,     0,     0,
     198,   199,     0,   200,   674,   201,   202,   203,   675,   899,
     676,   900,   901,     0,   207,   208,   209,   210,   211,   902,
     903,   212,   213,   904,   905,   216,     0,   217,   218,   219,
     220,   906,     0,     0,   222,   223,   224,   225,   226,   227,
       0,   228,   229,   230,   231,   232,   233,     0,   234,   235,
     236,   677,   237,   238,   907,   908,   909,   910,   911,   912,
     913,   239,   240,   241,   242,   243,   244,   914,   915,   247,
       0,   248,     0,   249,   250,   251,   252,   253,     0,   254,
     255,   256,     0,     0,   257,   258,   916,   260,   261,     0,
     262,   263,   264,     0,   265,   266,     0,   267,   268,   269,
     917,   271,   272,   918,   919,   274,     0,   275,   920,   277,
       0,   278,     0,   279,   679,     0,   680,   280,   281,     0,
     282,   921,     0,   284,     0,   285,   286,   287,   288,   289,
     681,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,   682,   299,   300,   301,   302,   303,   922,   923,
       0,   924,     0,   307,   683,   684,   308,   685,   309,   310,
     311,   312,   313,   314,   315,     0,   925,   686,   317,   687,
       0,   318,   319,   320,   926,   927,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   928,
     688,   929,   638,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   930,   345,   346,   689,   347,   931,   932,   349,
     933,   351,   352,     0,     0,   353,   639,     0,     0,   934,
     355,   356,     0,     0,   357,   690,   691,   692,   935,   359,
     360,   361,   362,   363,   364,     0,   365,   936,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,   937,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,   693,
     395,   396,   938,   398,   399,   400,   401,   402,   403,   404,
     405,     0,   406,   407,   408,   409,   939,   410,   411,   412,
     413,   694,   414,   940,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   941,   427,     0,   428,   429,
       0,   430,   431,   432,   433,   434,     0,   942,   943,     0,
       0,   437,   944,   439,   945,   946,   441,   442,   443,   444,
     445,   446,     0,   947,   447,   448,   449,   450,   948,     0,
     451,   452,   453,   454,   455,   949,     0,   457,   695,   458,
     459,   460,     0,     0,   461,     0,     0,   462,   463,   464,
     465,   466,   467,   950,   951,   952,   953,   954,   955,   956,
     475,   476,   477,     0,     0,     0,   696,   957,   586,   958,
     959,   960,   569,   961,     0,     0,     0,     0,   962,   963,
       0,     0,     0,     0,     0,     0,     0,   965,   186,   187,
     188,   189,   190,   191,   192,   193,     0,   195,   196,   197,
       0,     0,     0,     0,   898,     0,     0,   198,   199,     0,
     200,   674,   201,   202,   203,   675,   899,   676,   900,   901,
       0,   207,   208,   209,   210,   211,   902,   903,   212,   213,
     904,   905,   216,     0,   217,   218,   219,   220,   906,     0,
       0,   222,   223,   224,   225,   226,   227,     0,   228,   229,
     230,   231,   232,   233,     0,   234,   235,   236,   677,   237,
     238,   907,   908,   909,   910,   911,   912,   913,   239,   240,
     241,   242,   243,   244,   914,   915,   247,     0,   248,     0,
     249,   250,   251,   252,   253,     0,   254,   255,   256,     0,
       0,   257,   258,   916,   260,   261,     0,   262,   263,   264,
       0,   265,   266,     0,   267,   268,   269,   917,   271,   272,
     918,   919,   274,     0,   275,   920,   277,     0,   278,     0,
     279,   679,  2034,   680,   280,   281,     0,   282,   921,     0,
     284,     0,   285,   286,   287,   288,   289,   681,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   682,
     299,   300,   301,   302,   303,   922,   923,     0,   924,     0,
     307,   683,   684,   308,   685,   309,   310,   311,   312,   313,
     314,   315,     0,   925,   686,   317,   687,     0,   318,   319,
     320,   926,   927,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   928,   688,   929,   638,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   930,
     345,   346,   689,   347,   931,   932,   349,   933,   351,   352,
       0,     0,   353,   639,     0,     0,   934,   355,   356,     0,
       0,   357,   690,   691,   692,   935,   359,   360,   361,   362,
     363,   364,     0,   365,   936,   367,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,   937,   380,
     381,   382,     0,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,     0,   393,   394,   693,   395,   396,   938,
     398,   399,   400,   401,   402,   403,   404,   405,     0,   406,
     407,   408,   409,   939,   410,   411,   412,   413,   694,   414,
     940,     0,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   941,   427,     0,   428,   429,     0,   430,   431,
     432,   433,   434,     0,   942,   943,     0,     0,   437,   944,
     439,   945,   946,   441,   442,   443,   444,   445,   446,     0,
     947,   447,   448,   449,   450,   948,     0,   451,   452,   453,
     454,   455,   949,     0,   457,   695,   458,   459,   460,     0,
       0,   461,     0,     0,   462,   463,   464,   465,   466,   467,
     950,   951,   952,   953,   954,   955,   956,   475,   476,   477,
       0,     0,     0,   696,   957,   586,   958,   959,   960,   569,
     961,     0,     0,     0,     0,   962,   963,     0,     0,     0,
       0,     0,     0,     0,   965,   186,   187,   188,   189,   190,
     191,   192,   193,     0,   195,   196,   197,     0,     0,     0,
       0,   898,     0,     0,   198,   199,     0,   200,   674,   201,
     202,   203,   675,   899,   676,   900,   901,     0,   207,   208,
     209,   210,   211,   902,   903,   212,   213,   904,   905,   216,
       0,   217,   218,   219,   220,   906,     0,     0,   222,   223,
     224,   225,   226,   227,     0,   228,   229,   230,   231,   232,
     233,     0,   234,   235,   236,   677,   237,   238,   907,   908,
     909,   910,   911,   912,   913,   239,   240,   241,   242,   243,
     244,   914,   915,   247,     0,   248,     0,   249,   250,   251,
     252,   253,     0,   254,   255,   256,     0,     0,   257,   258,
     916,   260,   261,     0,   262,   263,   264,     0,   265,   266,
       0,   267,   268,   269,   917,   271,   272,   918,   919,   274,
       0,   275,   920,   277,     0,   278,     0,   279,   679,     0,
     680,   280,   281,     0,   282,   921,     0,   284,     0,   285,
     286,   287,   288,   289,   681,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,   682,   299,   300,   301,
     302,   303,   922,   923,     0,   924,     0,   307,   683,   684,
     308,   685,   309,   310,   311,   312,   313,   314,   315,     0,
     925,   686,   317,   687,     0,   318,   319,   320,   926,   927,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   928,   688,   929,   638,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   930,   345,   346,   689,
     347,   931,   932,   349,   933,   351,   352,     0,     0,   353,
     639,     0,     0,   934,   355,   356,     0,     0,   357,   690,
     691,   692,   935,   359,   360,   361,   362,   363,   364,     0,
     365,   936,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,   937,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,   693,   395,   396,   938,   398,   399,   400,
     401,   402,   403,   404,   405,     0,   406,   407,   408,   409,
     939,   410,   411,   412,   413,   694,   414,   940,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   941,
     427,     0,   428,   429,     0,   430,   431,   432,   433,   434,
       0,   942,   943,     0,     0,   437,   944,   439,   945,   946,
     441,   442,   443,   444,   445,   446,     0,   947,   447,   448,
     449,   450,   948,     0,   451,   452,   453,   454,   455,   949,
    2997,   457,   695,   458,   459,   460,     0,     0,   461,     0,
       0,   462,   463,   464,   465,   466,   467,   950,   951,   952,
     953,   954,   955,   956,   475,   476,   477,     0,     0,     0,
     696,   957,   586,   958,   959,   960,   569,   961,     0,     0,
       0,     0,   962,   963,     0,     0,     0,     0,     0,     0,
       0,   965,   186,   187,   188,   189,   190,   191,   192,   193,
       0,   195,   196,   197,     0,     0,     0,     0,   898,     0,
       0,   198,   199,     0,   200,   674,   201,   202,   203,   675,
     899,   676,   900,   901,     0,   207,   208,   209,   210,   211,
     902,   903,   212,   213,   904,   905,   216,     0,   217,   218,
     219,   220,   906,     0,     0,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   677,   237,   238,   907,   908,   909,   910,   911,
     912,   913,   239,   240,   241,   242,   243,   244,   914,   915,
     247,     0,   248,     0,   249,   250,   251,   252,   253,     0,
     254,   255,   256,     0,     0,   257,   258,   916,   260,   261,
       0,   262,   263,   264,     0,   265,   266,     0,   267,   268,
     269,   917,   271,   272,   918,   919,   274,     0,   275,   920,
     277,     0,   278,     0,   279,   679,     0,   680,   280,   281,
       0,   282,   921,     0,   284,     0,   285,   286,   287,   288,
     289,   681,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,   682,   299,   300,   301,   302,   303,   922,
     923,     0,   924,     0,   307,   683,   684,   308,   685,   309,
     310,   311,   312,   313,   314,   315,     0,   925,   686,   317,
     687,     0,   318,   319,   320,   926,   927,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     928,   688,   929,   638,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   930,   345,   346,   689,   347,   931,   932,
     349,   933,   351,   352,     0,     0,   353,   639,     0,     0,
     934,   355,   356,     0,     0,   357,   690,   691,   692,   935,
     359,   360,   361,   362,   363,   364,     0,   365,   936,   367,
     368,   369,   370,   371,     0,   372,   373,   374,   375,   376,
     377,   378,   937,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,     0,   393,   394,
     693,   395,   396,   938,   398,   399,   400,   401,   402,   403,
     404,   405,     0,   406,   407,   408,   409,   939,   410,   411,
     412,   413,   694,   414,   940,     0,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   941,   427,     0,   428,
     429,     0,   430,   431,   432,   433,   434,     0,   942,   943,
       0,     0,   437,   944,   439,   945,   946,   441,   442,   443,
     444,   445,   446,     0,   947,   447,   448,   449,   450,   948,
       0,   451,   452,   453,   454,   455,   949,     0,   457,   695,
     458,   459,   460,     0,     0,   461,     0,     0,   462,   463,
     464,   465,   466,   467,   950,   951,   952,   953,   954,   955,
     956,   475,   476,   477,     0,     0,     0,   696,   957,   586,
     958,   959,   960,   569,   961,     0,     0,     0,     0,   962,
     963,     0,     0,     0,     0,     0,     0,     0,   965,   186,
     187,   188,   189,   190,   191,   192,   193,     0,   195,   196,
     197,     0,     0,     0,     0,   898,     0,     0,   198,   199,
       0,   200,   674,   201,   202,   203,   675,   899,   676,   900,
     901,     0,   207,   208,   209,   210,   211,   902,   903,   212,
     213,   904,   905,   216,     0,   217,   218,   219,   220,   906,
       0,     0,   222,   223,   224,   225,   226,   227,     0,   228,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   677,
     237,  2457,   907,   908,   909,   910,   911,   912,   913,   239,
     240,   241,   242,   243,   244,   914,   915,   247,     0,   248,
       0,   249,   250,   251,   252,   253,     0,   254,   255,   256,
       0,     0,   257,   258,   916,   260,   261,     0,   262,   263,
     264,     0,   265,   266,     0,   267,   268,   269,   917,   271,
     272,   918,   919,   274,     0,   275,   920,   277,     0,   278,
       0,   279,   679,     0,   680,   280,   281,     0,   282,   921,
       0,   284,     0,   285,   286,   287,   288,   289,   681,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
     682,   299,   300,   301,   302,   303,   922,   923,     0,   924,
       0,   307,   683,   684,   308,   685,   309,   310,   311,   312,
     313,   314,   315,     0,   925,   686,   317,   687,     0,   318,
     319,   320,   926,   927,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   928,   688,   929,
     638,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     930,   345,   346,   689,   347,   931,   932,   349,   933,   351,
     352,     0,     0,   353,   639,     0,     0,   934,   355,   356,
       0,     0,   357,   690,   691,   692,   935,   359,   360,   361,
     362,   363,   364,     0,   365,   936,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,   937,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,   693,   395,   396,
     938,   398,   399,   400,   401,   402,   403,   404,   405,     0,
     406,   407,   408,   409,   939,   410,   411,   412,   413,   694,
     414,   940,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   941,   427,     0,   428,   429,     0,   430,
     431,   432,   433,   434,     0,   942,   943,     0,     0,   437,
     944,   439,   945,   946,   441,   442,   443,   444,   445,   446,
       0,   947,   447,   448,   449,   450,   948,     0,   451,   452,
     453,   454,   455,   949,     0,   457,   695,   458,   459,   460,
       0,     0,   461,     0,     0,   462,   463,   464,   465,   466,
     467,   950,   951,   952,   953,   954,   955,   956,   475,   476,
     477,     0,     0,     0,   696,   957,   586,   958,   959,   960,
     569,   961,     0,     0,     0,     0,   962,   963,     0,     0,
       0,     0,     0,     0,     0,   965,   186,   187,   188,   189,
     190,   191,   192,   193,     0,   195,   196,   197,     0,     0,
       0,     0,   898,     0,     0,   198,   199,     0,   200,   674,
     201,   202,   203,   675,   899,   676,   900,   901,     0,   207,
     208,   209,   210,   211,   902,   903,   212,   213,   904,   905,
     216,     0,   217,   218,   219,   220,   906,     0,     0,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   677,   237,   238,   907,
     908,   909,   910,   911,   912,   913,   239,   240,   241,   242,
     243,   244,   914,   915,   247,     0,   248,     0,   249,   250,
     251,   252,   253,     0,   254,   255,   256,     0,     0,   257,
     258,   916,   260,   261,     0,   262,   263,   264,     0,   265,
     266,     0,   267,   268,   269,   917,   271,   272,   918,   919,
     274,     0,   275,   920,   277,     0,   278,     0,   279,   679,
       0,   680,   280,   281,     0,   282,   921,     0,   284,     0,
     285,   286,   287,   288,   289,   681,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,   682,   299,   300,
     301,   302,   303,   922,   923,     0,   924,     0,   307,   683,
     684,   308,   685,   309,   310,   311,   312,   313,   314,   315,
       0,   925,   686,   317,   687,     0,   318,   319,   320,   926,
     927,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   928,   688,   929,   638,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   930,   345,   346,
     689,   347,   931,   932,   349,   933,   351,   352,     0,     0,
     353,   639,     0,     0,   934,   355,   356,     0,     0,   357,
     690,   691,   692,   935,   359,   360,   361,   362,   363,   364,
       0,   365,   936,   367,   368,   369,   370,   371,     0,   372,
     373,   374,   375,   376,   377,   378,   937,   380,   381,   382,
       0,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,     0,   393,   394,   693,   395,   396,   938,   398,   399,
     400,   401,   402,   403,   404,   405,     0,   406,   407,   408,
     409,   939,   410,   411,   412,   413,   694,   414,   940,     0,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     941,   427,     0,   428,   429,     0,   430,   431,   432,   433,
     434,     0,   942,   943,     0,     0,   437,   944,   439,   945,
     946,   441,   442,   443,   444,   445,   446,     0,   947,   447,
     448,   449,   450,   948,     0,   451,   452,   453,   454,   455,
     949,     0,   457,   695,   458,   459,   460,     0,     0,   461,
       0,     0,   462,   463,   464,   465,   466,  3207,   950,   951,
     952,   953,   954,   955,   956,   475,   476,   477,     0,     0,
       0,   696,   957,   586,   958,   959,   960,   569,   961,     0,
       0,     0,     0,   962,   963,     0,     0,     0,     0,     0,
       0,     0,   965,   186,   187,   188,   189,   190,   191,   192,
     193,     0,   195,   196,   197,     0,     0,     0,     0,   898,
       0,     0,   198,   199,     0,   200,   674,   201,   202,   203,
     675,   899,   676,   900,   901,     0,   207,   208,   209,   210,
     211,   902,   903,   212,   213,   904,   905,   216,     0,   217,
     218,   219,   220,   906,     0,     0,   222,   223,   224,   225,
     226,   227,     0,   228,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   677,   237,   238,   907,   908,   909,   910,
     911,   912,   913,   239,   240,   241,   242,   243,   244,   914,
     915,   247,     0,   248,     0,   249,   250,   251,   252,   253,
       0,   254,   255,   256,     0,     0,   257,   258,   916,   260,
     261,     0,   262,   263,   264,     0,   265,   266,     0,   267,
     268,   269,   917,   271,   272,   918,   919,   274,     0,   275,
     920,   277,     0,   278,     0,   279,   679,     0,   680,   280,
     281,     0,   282,   921,     0,   284,     0,   285,   286,   287,
     288,   289,   681,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   682,   299,   300,   301,   302,   303,
     922,   923,     0,   924,     0,   307,   683,   684,   308,   685,
     309,   310,   311,   312,   313,   314,   315,     0,   925,   686,
     317,   687,     0,   318,   319,   320,   926,   927,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   928,   688,   929,   638,   336,  3214,   338,   339,   340,
     341,   342,   343,   344,   930,   345,   346,   689,   347,   931,
     932,   349,   933,   351,   352,     0,     0,   353,   639,     0,
       0,   934,   355,   356,     0,     0,   357,   690,   691,   692,
     935,   359,   360,   361,   362,   363,   364,     0,   365,   936,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,   937,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   693,   395,   396,   938,   398,   399,   400,   401,   402,
     403,   404,   405,     0,   406,   407,   408,   409,   939,   410,
     411,   412,   413,   694,   414,   940,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   941,   427,     0,
     428,   429,     0,   430,   431,   432,   433,   434,     0,   942,
     943,     0,     0,   437,   944,   439,   945,   946,   441,   442,
     443,   444,   445,   446,     0,   947,   447,   448,   449,   450,
     948,     0,   451,   452,   453,   454,   455,   949,     0,   457,
     695,   458,   459,   460,     0,     0,   461,     0,     0,   462,
     463,   464,   465,   466,   467,   950,   951,   952,   953,   954,
     955,   956,   475,   476,   477,     0,     0,     0,   696,   957,
     586,   958,   959,   960,   569,   961,     0,     0,     0,     0,
     962,   963,     0,     0,     0,     0,     0,     0,     0,   965,
     186,   187,   188,   189,   190,   191,   192,   193,     0,   195,
     196,   197,     0,     0,     0,     0,   898,     0,     0,   198,
     199,     0,   200,   674,   201,   202,   203,   675,   899,   676,
     900,   901,     0,   207,   208,   209,   210,   211,   902,   903,
     212,   213,   904,   905,   216,     0,   217,   218,   219,   220,
     906,     0,     0,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     677,   237,   238,   907,   908,   909,   910,   911,   912,   913,
     239,   240,   241,   242,   243,   244,   914,   915,   247,     0,
     248,     0,   249,   250,   251,   252,   253,     0,   254,   255,
     256,     0,     0,   257,   258,   916,   260,   261,     0,   262,
     263,   264,     0,   265,   266,     0,   267,   268,   269,   917,
     271,   272,   918,   919,   274,     0,   275,   920,   277,     0,
     278,     0,   279,   679,     0,   680,   280,   281,     0,   282,
     921,     0,   284,     0,   285,   286,   287,   288,   289,   681,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,   682,   299,   300,   301,   302,   303,   922,   923,     0,
     924,     0,   307,   683,   684,   308,   685,   309,   310,   311,
     312,   313,   314,   315,     0,   925,   686,   317,   687,     0,
     318,   319,   320,   926,   927,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   928,   688,
     929,   638,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,   346,   689,   347,   931,   932,   349,   933,
     351,   352,     0,     0,   353,   639,     0,     0,   934,   355,
     356,     0,     0,   357,   690,   691,   692,   935,   359,   360,
     361,   362,   363,   364,     0,   365,   936,   367,   368,   369,
     370,   371,     0,   372,   373,   374,   375,   376,   377,   378,
     937,   380,   381,   382,     0,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,   394,   693,   395,
     396,   938,   398,   399,   400,   401,   402,   403,   404,   405,
       0,   406,   407,   408,   409,   939,   410,   411,   412,   413,
     694,   414,   940,     0,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   941,   427,     0,   428,   429,     0,
     430,   431,   432,   433,   434,     0,   942,   943,     0,     0,
     437,   944,   439,   945,   946,   441,   442,   443,   444,   445,
     446,     0,     0,   447,   448,   449,   450,   948,     0,   451,
     452,   453,   454,   455,   949,     0,   457,   695,   458,   459,
     460,     0,     0,   461,     0,     0,   462,   463,   464,   465,
     466,   467,   950,   951,   952,   953,   954,   955,   956,   475,
     476,   477,     0,     0,     0,   696,   957,   586,   958,   959,
     960,   569,   961,     0,     0,     0,     0,  2016,  2017,     0,
       0,     0,     0,     0,     0,     0,   965,   186,   187,   188,
     189,   190,   191,   192,   193,     0,   195,   196,   197,     0,
       0,     0,     0,   898,     0,     0,   198,   199,     0,   200,
     674,   201,   202,   203,     0,   899,   676,   900,   901,     0,
     207,   208,   209,   210,   211,   902,   903,   212,   213,   904,
     905,   216,     0,   217,   218,   219,   220,   906,     0,     0,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   677,   237,   238,
     907,   908,   909,   910,   911,   912,   913,   239,   240,   241,
     242,   243,   244,   914,   915,   247,     0,   248,     0,   249,
     250,   251,   252,   253,     0,   254,   255,   256,     0,     0,
     257,   258,   916,   260,   261,     0,   262,   263,   264,     0,
     265,     0,     0,   267,   268,   269,   917,   271,   272,   918,
     919,   274,     0,   275,   920,   277,     0,   278,     0,   279,
     679,     0,   680,   280,   281,     0,   282,   921,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   682,   299,
     300,   301,   302,   303,   922,   923,     0,   924,     0,   307,
     683,   684,   308,   685,   309,   310,   311,   312,   313,   314,
     315,     0,   925,   686,   317,     0,     0,   318,   319,   320,
     926,   927,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   928,   688,   929,   638,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   689,   347,   931,   932,   349,   933,   351,   352,     0,
       0,   353,   639,     0,     0,   934,   355,   356,     0,     0,
     357,   690,   691,   692,   935,   359,   360,   361,   362,   363,
     364,     0,   365,   936,   367,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,   937,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,   693,   395,   396,   938,   398,
     399,   400,   401,   402,   403,   404,   405,     0,   406,   407,
     408,   409,   939,   410,   411,   412,   413,     0,   414,   940,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   941,   427,     0,   428,   429,     0,   430,   431,   432,
     433,   434,     0,   942,   943,     0,     0,   437,   944,   439,
     945,   946,   441,   442,   443,   444,   445,   446,     0,   947,
     447,   448,   449,   450,   948,     0,   451,   452,   453,   454,
     455,   949,     0,   457,   695,   458,   459,   460,     0,     0,
     461,     0,     0,   462,   463,   464,   465,   466,   467,   950,
     951,   952,   953,   954,   955,   956,   475,   476,   477,     0,
       0,     0,   696,   957,   586,   958,   959,   960,   569,   961,
       0,     0,     0,     0,   962,   963,     0,     0,     0,     0,
       0,     0,     0,   965,   186,   187,   188,   189,   190,   191,
     192,   193,     0,   195,   196,   197,     0,     0,     0,     0,
     898,     0,     0,   198,   199,     0,   200,   674,   201,   202,
     203,     0,   899,   676,   900,   901,     0,   207,   208,   209,
     210,   211,   902,   903,   212,   213,   904,   905,   216,     0,
     217,   218,   219,   220,   906,     0,     0,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   677,   237,   238,   907,   908,   909,
     910,   911,   912,   913,   239,   240,   241,   242,   243,   244,
     914,   915,   247,     0,   248,     0,   249,   250,   251,   252,
     253,     0,   254,   255,   256,     0,     0,   257,   258,   916,
     260,   261,     0,   262,   263,   264,     0,   265,     0,     0,
     267,   268,   269,   917,   271,   272,   918,   919,   274,     0,
     275,   920,   277,     0,   278,     0,   279,   679,     0,   680,
     280,   281,     0,   282,   921,     0,   284,     0,   285,   286,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,   682,   299,   300,   301,   302,
     303,   922,   923,     0,   924,     0,   307,   683,   684,   308,
     685,   309,   310,   311,   312,   313,   314,   315,     0,   925,
     686,   317,     0,     0,   318,   319,   320,   926,   927,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   928,   688,   929,   638,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   689,   347,
     931,   932,   349,   933,   351,   352,     0,     0,   353,   639,
       0,     0,   934,   355,   356,     0,     0,   357,   690,   691,
     692,   935,   359,   360,   361,   362,   363,   364,     0,   365,
     936,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,   937,   380,   381,   382,     0,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,     0,
     393,   394,   693,   395,   396,   938,   398,   399,   400,   401,
     402,   403,   404,   405,     0,   406,   407,   408,   409,   939,
     410,   411,   412,   413,     0,   414,   940,     0,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   941,   427,
       0,   428,   429,     0,   430,   431,   432,   433,   434,     0,
     942,   943,     0,     0,   437,   944,   439,   945,   946,   441,
     442,   443,   444,   445,   446,     0,     0,   447,   448,   449,
     450,   948,     0,   451,   452,   453,   454,   455,   949,     0,
     457,   695,   458,   459,   460,     0,     0,   461,     0,     0,
     462,   463,   464,   465,   466,   467,   950,   951,   952,   953,
     954,   955,   956,   475,   476,   477,     0,     0,     0,   696,
     957,   586,   958,   959,   960,   569,   961,     0,     0,     0,
       0,  2016,  2017,     0,     0,     0,     0,     0,     0,     0,
     965,   186,   187,   188,   189,   190,   191,   192,   193,     0,
     195,   196,   197,     0,     0,     0,     0,     0,     0,     0,
     198,   199,     0,   200,   674,   201,   202,   203,   675,   204,
     676,   205,   206,     0,   207,   208,   209,   210,   211,     0,
     903,   212,   213,   214,   215,   216,     0,   217,   218,   219,
     220,   906,     0,     0,   222,   223,   224,   225,   226,   227,
       0,   228,   229,   230,   231,   232,   233,     0,   234,   235,
     236,   677,   237,   238,   907,   908,   909,   910,   911,   912,
     913,   239,   240,   241,   242,   243,   244,   245,   246,   247,
       0,   248,     0,   249,   250,   251,   252,   253,     0,   254,
     255,   256,     0,     0,   257,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,     0,   267,   268,   269,
     270,   271,   272,   918,     0,   274,     0,   275,   276,   277,
       0,   278,     0,   279,   679,     0,   680,   280,   281,     0,
     282,   921,     0,   284,     0,   285,   286,   287,   288,   289,
     681,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,   682,   299,   300,   301,   302,   303,   304,   305,
       0,   306,     0,   307,   683,   684,   308,   685,   309,   310,
     311,   312,   313,   314,   315,     0,   925,   686,   317,   687,
       0,   318,   319,   320,   926,   927,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     688,   335,   638,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,   689,   347,     0,   932,   349,
     350,   351,   352,     0,     0,   353,   639,     0,   640,   354,
     355,   356,     0,     0,   357,   690,   691,   692,   935,   359,
     360,   361,   362,   363,   364,     0,   365,   936,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,   693,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,    37,   406,   407,   408,   409,   939,   410,   411,   412,
     413,   694,   414,   415,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   941,   427,     0,   428,   429,
      41,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   944,   439,   945,     0,   441,   442,   443,   444,
     445,   446,     0,     0,   447,   448,   449,   450,   948,     0,
     451,   452,   453,   454,  1437,   456,     0,   457,   695,   458,
     459,   460,     0,     0,   461,     0,    47,   462,   463,   464,
     465,   466,   467,   950,   951,   952,   953,   954,   955,   956,
     475,   476,   477,     0,     0,     0,   696,     0,     0,   186,
     187,   188,   189,   190,   191,   192,   193,     0,   195,   196,
     197,     0,     0,     0,     0,     0,     0,  1889,   198,   199,
       0,   200,   674,   201,   202,   203,   675,   204,   676,   205,
     206,     0,   207,   208,   209,   210,   211,     0,   903,   212,
     213,   214,   215,   216,     0,   217,   218,   219,   220,   906,
       0,     0,   222,   223,   224,   225,   226,   227,     0,   228,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   677,
     237,   238,   907,   908,   909,   910,   911,   912,   913,   239,
     240,   241,   242,   243,   244,   245,   246,   247,     0,   248,
       0,   249,   250,   251,   252,   253,     0,   254,   255,   256,
       0,     0,   257,   258,   259,   260,   261,     0,   262,   263,
     264,     0,   265,   266,     0,   267,   268,   269,   270,   271,
     272,   918,     0,   274,     0,   275,   276,   277,     0,   278,
       0,   279,   679,     0,   680,   280,   281,     0,   282,   921,
       0,   284,     0,   285,   286,   287,   288,   289,   681,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
     682,   299,   300,   301,   302,   303,   304,   305,     0,   306,
       0,   307,   683,   684,   308,   685,   309,   310,   311,   312,
     313,   314,   315,     0,   925,   686,   317,   687,     0,   318,
     319,   320,   926,   927,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   688,   335,
     638,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,   689,   347,     0,   932,   349,   350,   351,
     352,     0,     0,   353,   639,     0,   640,   354,   355,   356,
       0,     0,   357,   690,   691,   692,   935,   359,   360,   361,
     362,   363,   364,     0,   365,   936,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,   693,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,     0,
     406,   407,   408,   409,   939,   410,   411,   412,   413,   694,
     414,   415,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   941,   427,     0,   428,   429,     0,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     944,   439,   945,     0,   441,   442,   443,   444,   445,   446,
       0,     0,   447,   448,   449,   450,   948,     0,   451,   452,
     453,   454,   455,   456,     0,   457,   695,   458,   459,   460,
       0,     0,   461,     0,     0,   462,   463,   464,   465,   466,
     467,   950,   951,   952,   953,   954,   955,   956,   475,   476,
     477,     0,     0,     0,   696,     0,     0,   186,   187,   188,
     189,   190,   191,   192,   193,     0,   195,   196,   197,     0,
       0,     0,     0,     0,     0,  1889,   198,   199,     0,   200,
     674,   201,   202,   203,   675,   204,   676,   205,   206,     0,
     207,   208,   209,   210,   211,     0,   903,   212,   213,   214,
     215,   216,     0,   217,   218,   219,   220,   906,     0,     0,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   677,   237,   238,
     907,   908,   909,   910,   911,   912,   913,   239,   240,   241,
     242,   243,   244,   245,   246,   247,     0,   248,     0,   249,
     250,   251,   252,   253,     0,   254,   255,   256,     0,     0,
     257,   258,   259,   260,   261,     0,   262,   263,   264,     0,
     265,   266,     0,   267,   268,   269,   270,   271,   272,   918,
       0,   274,     0,   275,   276,   277,     0,   278,     0,   279,
     679,     0,   680,   280,   281,     0,   282,   921,     0,   284,
       0,   285,   286,   287,   288,   289,   681,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   682,   299,
     300,   301,   302,   303,   304,   305,     0,   306,     0,   307,
     683,   684,   308,   685,   309,   310,   311,   312,   313,   314,
     315,     0,   925,   686,   317,   687,     0,   318,   319,   320,
     926,   927,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   688,   335,   638,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   689,   347,     0,   932,   349,   350,   351,   352,     0,
       0,   353,   639,     0,     0,   354,   355,   356,     0,     0,
     357,   690,   691,   692,   935,   359,   360,   361,   362,   363,
     364,     0,   365,   936,   367,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,   693,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,     0,   406,   407,
     408,   409,   939,   410,   411,   412,   413,   694,   414,   415,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   941,   427,     0,   428,   429,     0,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   944,   439,
     945,     0,   441,   442,   443,   444,   445,   446,     0,     0,
     447,   448,   449,   450,   948,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   695,   458,   459,   460,     0,     0,
     461,     0,     0,   462,   463,   464,   465,   466,   467,   950,
     951,   952,   953,   954,   955,   956,   475,   476,   477,     0,
       0,     0,   696,     0,     0,   186,   187,   188,   189,   190,
     191,   192,   193,     0,   195,   196,   197,     0,     0,     0,
       0,     0,     0,  3335,   198,   199,     0,   200,   674,   201,
     202,   203,   675,   204,   676,   205,   206,     0,   207,   208,
     209,   210,   211,     0,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,   220,   221,     0,     0,   222,   223,
     224,   225,   226,   227,     0,   228,   229,   230,   231,   232,
     233,     0,   234,   235,   236,   677,   237,   238,     0,     0,
       0,   678,     0,     0,     0,   239,   240,   241,   242,   243,
     244,   245,   246,   247,     0,   248,     0,   249,   250,   251,
     252,   253,     0,   254,   255,   256,     0,     0,   257,   258,
     259,   260,   261,     0,   262,   263,   264,     0,   265,   266,
       0,   267,   268,   269,   270,   271,   272,   273,     0,   274,
       0,   275,   276,   277,     0,   278,     0,   279,   679,     0,
     680,   280,   281,     0,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,   681,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,   682,   299,   300,   301,
     302,   303,   304,   305,     0,   306,     0,   307,   683,   684,
     308,   685,   309,   310,   311,   312,   313,   314,   315,     0,
     316,   686,   317,   687,     0,   318,   319,   320,     0,     0,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   688,   335,   638,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,   689,
     347,     0,   348,   349,   350,   351,   352,     0,     0,   353,
     639,     0,     0,   354,   355,   356,     0,     0,   357,   690,
     691,   692,   358,   359,   360,   361,   362,   363,   364,     0,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,   693,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,     0,   406,   407,   408,   409,
       0,   410,   411,   412,   413,   694,   414,   415,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   428,   429,     0,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,     0,   447,   448,
     449,   450,     0,     0,   451,   452,   453,   454,   455,   456,
       0,   457,   695,   458,   459,   460,     0,     0,   461,     0,
       0,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     0,     0,     0,
     696,     0,     0,   186,   187,   188,   189,   190,   191,   192,
     193,     0,   195,   196,   197,     0,     0,     0,     0,     0,
       0,  3396,   198,   199,     0,   200,     0,   201,   202,   203,
       0,   204,     0,   205,   206,     0,   207,   208,   209,   210,
     211,     0,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,   220,   221,     0,     0,   222,   223,   224,   225,
     226,   227,     0,   228,   229,   230,   231,   232,   233,     0,
     234,   235,   236,     0,   237,   238,     0,     0,     0,     0,
       0,     0,     0,   239,   240,   241,   242,   243,   244,   245,
     246,   247,     0,   248,     0,   249,   250,   251,   252,   253,
       0,   254,   255,   256,     0,     0,   257,   258,   259,   260,
     261,     0,   262,   263,   264,     0,   265,   266,     0,   267,
     268,   269,   270,   271,   272,   273,     0,   274,     0,   275,
     276,   277,     0,   278,     0,   279,     0,     0,     0,   280,
     281,     0,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   299,   300,   301,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,   319,   320,     0,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,     0,   335,     0,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,     0,
     348,   349,   350,   351,   352,     0,     0,   353,     0,     0,
       0,   354,   355,   356,     0,     0,   357,     0,     0,     0,
     358,   359,   360,   361,   362,   363,   364,     0,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,    37,   406,   407,   408,   409,     0,   410,
     411,   412,   413,     0,   414,   415,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,    41,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,     0,   447,   448,   449,   450,
       0,     0,   451,   452,   453,   454,  1437,   456,     0,   457,
       0,   458,   459,   460,     0,     0,   461,     0,    47,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,     0,     0,     0,   478,     0,
       0,   186,   187,   188,   189,   190,   191,   192,   193,     0,
     195,   196,   197,     0,     0,     0,     0,     0,     0,    48,
     198,   199,     0,   200,     0,   201,   202,   203,     0,   204,
       0,   205,   206,     0,   207,   208,   209,   210,   211,     0,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
     220,   221,     0,     0,   222,   223,   224,   225,   226,   227,
       0,   228,   229,   230,   231,   232,   233,     0,   234,   235,
     236,     0,   237,   238,     0,     0,     0,     0,     0,     0,
       0,   239,   240,   241,   242,   243,   244,   245,   246,   247,
       0,   248,     0,   249,   250,   251,   252,   253,     0,   254,
     255,   256,     0,     0,   257,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,     0,   267,   268,   269,
     270,   271,   272,   273,     0,   274,     0,   275,   276,   277,
       0,   278,     0,   279,     0,     0,     0,   280,   281,     0,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   299,   300,   301,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,   319,   320,     0,     0,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
       0,   335,   638,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,     0,   353,   639,     0,     0,   354,
     355,   356,     0,     0,   357,     0,     0,     0,   358,   359,
     360,   361,   362,   363,   364,     0,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,     0,   406,   407,   408,   409,     0,   410,   411,   412,
     413,     0,   414,   415,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
       0,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,     0,   447,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,     0,   457,     0,   458,
     459,   460,     0,     0,   461,     0,     0,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     0,     0,     0,   478,     0,     0,   186,
     187,   188,   189,   190,   191,   192,   193,     0,   195,   196,
     197,     0,     0,     0,     0,     0,     0,  1019,   198,   199,
       0,   200,     0,   201,   202,   203,     0,   204,     0,   205,
     206,     0,   207,   208,   209,   210,   211,     0,     0,   212,
     213,   214,   215,   216,     0,   217,   218,   219,   220,   221,
       0,     0,   222,   223,   224,   225,   226,   227,     0,   228,
     229,   230,   231,   232,   233,     0,   234,   235,   236,     0,
     237,   238,     0,     0,     0,     0,     0,     0,     0,   239,
     240,   241,   242,   243,   244,   245,   246,   247,     0,   248,
       0,   249,   250,   251,   252,   253,     0,   254,   255,   256,
       0,     0,   257,   258,   259,   260,   261,     0,   262,   263,
     264,     0,   265,   266,     0,   267,   268,   269,   270,   271,
     272,   273,     0,   274,     0,   275,   276,   277,     0,   278,
       0,   279,     0,     0,     0,   280,   281,     0,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   299,   300,   301,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
     319,   320,     0,     0,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,     0,   335,
       0,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,     0,   348,   349,   350,   351,
     352,     0,     0,   353,     0,     0,     0,   354,   355,   356,
       0,     0,   357,     0,     0,     0,   358,   359,   360,   361,
     362,   363,   364,     0,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,     0,
     406,   407,   408,   409,     0,   410,   411,   412,   413,     0,
     414,   415,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,     0,   428,   429,     0,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,     0,   447,   448,   449,   450,     0,     0,   451,   452,
     453,   454,   455,   456,     0,   457,     0,   458,   459,   460,
       0,     0,   461,     0,     0,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,     0,     0,     0,   478,     0,     0,   186,   187,   188,
     189,   190,   191,   192,   193,     0,   195,   196,   197,     0,
       0,     0,     0,     0,     0,  1613,   198,   199,     0,   200,
       0,   201,   202,   203,     0,   204,     0,   205,   206,     0,
     207,   208,   209,   210,   211,     0,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,   220,   221,     0,     0,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,     0,   237,   238,
       0,     0,     0,     0,     0,     0,     0,   239,   240,   241,
     242,   243,   244,   245,   246,   247,     0,   248,     0,   249,
     250,   251,   252,   253,     0,   254,   255,   256,     0,     0,
     257,   258,   259,   260,   261,     0,   262,   263,   264,     0,
     265,   266,     0,   267,   268,   269,   270,   271,   272,   273,
       0,   274,     0,   275,   276,   277,     0,   278,     0,   279,
       0,     0,     0,   280,   281,     0,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   299,
     300,   301,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,   319,   320,
       0,     0,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,     0,   335,     0,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,     0,   348,   349,   350,   351,   352,     0,
       0,   353,     0,     0,     0,   354,   355,   356,     0,     0,
     357,     0,     0,     0,   358,   359,   360,   361,   362,   363,
     364,     0,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,     0,   406,   407,
     408,   409,     0,   410,   411,   412,   413,     0,   414,   415,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,   428,   429,     0,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,     0,
     447,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,     0,   457,     0,   458,   459,   460,     0,     0,
     461,     0,     0,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,     0,
       0,     0,   478,     0,     0,   186,   187,   188,   189,   190,
     191,   192,   193,     0,   195,   196,   197,     0,     0,     0,
       0,     0,     0,  2874,   198,   199,     0,   200,     0,   201,
     202,   203,     0,   204,     0,   205,   206,     0,   207,   208,
     209,   210,   211,     0,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,   220,   221,     0,     0,   222,   223,
     224,   225,   226,   227,     0,   228,   229,   230,   231,   232,
     233,     0,   234,   235,   236,     0,   237,   238,     0,     0,
       0,     0,     0,     0,     0,   239,   240,   241,   242,   243,
     244,   245,   246,   247,     0,   248,     0,   249,   250,   251,
     252,   253,     0,   254,   255,   256,     0,     0,   257,   258,
     259,   260,   261,     0,   262,   263,   264,     0,   265,   266,
       0,   267,   268,   269,   270,   271,   272,   273,     0,   274,
       0,   275,   276,   277,     0,   278,     0,   279,     0,     0,
       0,   280,   281,     0,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   299,   300,   301,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,   319,   320,     0,     0,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,   335,     0,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,     0,   353,
       0,     0,     0,   354,   355,   356,     0,     0,   357,     0,
       0,     0,   358,   359,   360,   361,   362,   363,   364,     0,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,     0,   406,   407,   408,   409,
       0,   410,   411,   412,   413,     0,   414,   415,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   428,   429,     0,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,     0,   447,   448,
     449,   450,     0,     0,   451,   452,   453,   454,   455,   456,
       0,   457,     0,   458,   459,   460,     0,     0,   461,     0,
       0,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     0,     0,     0,
     478,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2992,   186,   187,   188,   189,   190,   191,   192,   193,
    1521,   195,   196,   197,  1522,  1523,  1524,  1525,  1526,  1527,
    1528,   198,   199,  1529,   200,   674,   201,   202,   203,   675,
    1205,   676,  1206,  1207,  1530,   207,   208,   209,   210,   211,
    1531,  1532,   212,   213,  1208,  1209,   216,  1533,   217,   218,
     219,   220,     0,  1534,  1535,   222,   223,   224,   225,   226,
     227,  1536,   228,   229,   230,   231,   232,   233,  1537,   234,
     235,   236,   677,   237,   238,  1538,  1539,  1540,   678,  1541,
    1542,  1543,   239,   240,   241,   242,   243,   244,  1210,  1211,
     247,  1544,   248,  1545,   249,   250,   251,   252,   253,  1546,
     254,   255,   256,  1547,  1548,   257,   258,   916,   260,   261,
    1549,   262,   263,   264,  1550,   265,   266,  1551,   267,   268,
     269,     0,   271,   272,     0,  1552,   274,  1553,   275,  1212,
     277,  1554,   278,  1555,   279,   679,  1556,   680,   280,   281,
    1557,   282,     0,  1558,   284,  1559,   285,   286,   287,   288,
     289,   681,   290,   291,   292,  1560,   293,   294,   295,   296,
     297,   298,  1561,   682,     0,   300,   301,   302,   303,  1213,
    1214,  1562,  1215,  1563,   307,   683,   684,   308,   685,   309,
     310,   311,   312,   313,   314,   315,  1564,     0,   686,   317,
     687,  1565,   318,   319,   320,  1566,  1567,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
    1216,   688,  1217,  1568,   336,   337,   338,   339,   340,   341,
     342,     0,   344,  1569,   345,   346,   689,   347,  1570,     0,
     349,  1218,   351,   352,  1571,  1572,   353,  1573,  1574,  1575,
    2760,   355,   356,  1576,  1577,     0,   690,   691,   692,     0,
     359,   360,   361,   362,   363,   364,  1578,   365,     0,   367,
       0,   369,   370,   371,  1579,   372,   373,   374,   375,   376,
     377,   378,  1219,   380,   381,   382,  1580,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,  1581,   393,   394,
     693,   395,   396,     0,   398,   399,   400,   401,   402,   403,
     404,   405,  1582,   406,   407,   408,   409,  1583,   410,  1701,
     412,   413,   694,   414,  1221,  1584,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   427,  1585,   428,
     429,  1586,   430,   431,   432,   433,   434,  1587,  1222,  1223,
    1588,  1589,   437,     0,   439,     0,  1590,   441,   442,   443,
     444,   445,   446,  1591,  1592,   447,   448,   449,   450,  1593,
    1594,   451,   452,   453,   454,     0,  1224,  1595,   457,   695,
     458,   459,   460,  1596,  1597,   461,  1598,  1599,   462,   463,
     464,   465,   466,     0,     0,     0,     0,     0,     0,     0,
       0,   475,   476,   477,     0,     0,     0,  1225,  1495,   586,
       0,     0,   715,   569,     0,   716,   717,   718,     0,  2761,
    2762,   721,   722,   723,   724,   186,   187,   188,   189,   190,
     191,   192,   193,     0,   195,   196,   197,     0,     0,     0,
       0,     0,     0,     0,   198,   199,     0,   200,     0,   201,
     202,   203,     0,   204,     0,   205,   206,     0,   207,   208,
     209,   210,   211,     0,     0,   212,   213,   214,   215,   216,
       0,   217,   713,   219,   220,   221,     0,     0,   222,   223,
     224,   225,   226,   227,     0,   228,   229,   230,   231,   232,
     233,     0,   234,   235,   236,     0,   237,   238,     0,     0,
       0,     0,     0,     0,     0,   239,   240,   241,   242,   243,
     244,   245,   246,   247,     0,   248,     0,   249,   250,   251,
     252,   253,     0,   254,   255,   256,     0,     0,   257,   258,
     259,   260,   261,     0,   262,   263,   264,     0,   265,   266,
       0,   267,   268,   269,   270,   271,   272,   273,     0,   714,
       0,   275,   276,   277,     0,   278,     0,   279,     0,     0,
       0,   280,   281,     0,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   299,   300,   301,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,   319,   320,     0,     0,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,   335,     0,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,     0,   353,
       0,     0,     0,   354,   355,   356,     0,     0,   357,     0,
       0,     0,   358,   359,   360,   361,   362,   363,   364,     0,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,     0,   406,   407,   408,   409,
       0,   410,   411,   412,   413,     0,   414,   415,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   428,   429,     0,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,     0,   447,   448,
     449,   450,     0,     0,   451,   452,   453,   454,   455,   456,
       0,   457,     0,   458,   459,   460,     0,     0,   461,     0,
       0,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     0,     0,     0,
     478,     0,     0,     0,     0,   715,     0,     0,   716,   717,
     718,     0,   719,   720,   721,   722,   723,   724,   186,   187,
     188,   189,   190,   191,   192,   193,     0,   195,   196,   197,
       0,     0,     0,     0,     0,     0,     0,   198,   199,     0,
     200,     0,   201,   202,   203,     0,   204,     0,   205,   206,
       0,   207,   208,   209,   210,   211,     0,     0,   212,   213,
     214,   215,   216,     0,   217,   789,   219,   220,   221,     0,
       0,   222,   223,   224,   225,   226,   227,     0,   228,   229,
     230,   231,   232,   233,     0,   234,   235,   236,     0,   237,
     238,     0,     0,     0,     0,     0,     0,     0,   239,   240,
     241,   242,   243,   244,   245,   246,   247,     0,   248,     0,
     249,   250,   251,   252,   253,     0,   254,   255,   256,     0,
       0,   257,   258,   259,   260,   261,     0,   262,   263,   264,
       0,   265,   266,     0,   267,   268,   269,   270,   271,   272,
     273,     0,   790,     0,   275,   276,   277,     0,   278,     0,
     279,     0,     0,     0,   280,   281,     0,   282,   283,     0,
     284,     0,   285,   286,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,     0,
     299,   300,   301,   302,   303,   304,   305,     0,   306,     0,
     307,     0,     0,   308,     0,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,     0,     0,   318,   319,
     320,     0,     0,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,     0,   335,     0,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,     0,   353,     0,     0,     0,   354,   355,   356,     0,
       0,   357,     0,     0,     0,   358,   359,   360,   361,   362,
     363,   364,     0,   365,   366,   367,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,     0,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,     0,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,     0,   406,
     407,   408,   409,     0,   410,   411,   412,   413,     0,   414,
     415,     0,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,     0,   428,   429,     0,   430,   431,
     432,   433,   434,     0,   435,   436,     0,     0,   437,   438,
     439,   440,     0,   441,   442,   443,   444,   445,   446,     0,
       0,   447,   448,   449,   450,     0,     0,   451,   452,   453,
     454,   455,   456,     0,   457,     0,   458,   459,   460,     0,
       0,   461,     0,     0,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
       0,     0,     0,   478,     0,     0,     0,     0,   715,     0,
       0,   716,   717,   718,     0,   719,   720,   721,   722,   723,
     724,   186,   187,   188,   189,   190,   191,   192,   193,     0,
     195,   196,   197,     0,     0,     0,     0,     0,     0,     0,
     198,   199,     0,   200,     0,   201,   202,   203,     0,   204,
       0,   205,   206,     0,   207,   208,   209,   210,   211,     0,
       0,   212,   213,   214,   215,   216,     0,   217,   828,   219,
     220,   221,     0,     0,   222,   223,   224,   225,   226,   227,
       0,   228,   229,   230,   231,   232,   233,     0,   234,   235,
     236,     0,   237,   238,     0,     0,     0,     0,     0,     0,
       0,   239,   240,   241,   242,   243,   244,   245,   246,   247,
       0,   248,     0,   249,   250,   251,   252,   253,     0,   254,
     255,   256,     0,     0,   257,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,     0,   267,   268,   269,
     270,   271,   272,   273,     0,   829,     0,   275,   276,   277,
       0,   278,     0,   279,     0,     0,     0,   280,   281,     0,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   830,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   299,   300,   301,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,   319,   320,     0,     0,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
       0,   335,     0,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,     0,   353,     0,     0,     0,   354,
     355,   356,     0,     0,   357,     0,     0,     0,   358,   359,
     360,   361,   362,   363,   364,     0,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,     0,   406,   407,   408,   409,     0,   410,   411,   412,
     413,     0,   414,   415,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
       0,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,     0,   447,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,     0,   457,     0,   458,
     459,   460,     0,     0,   461,     0,     0,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     0,     0,     0,   478,     0,     0,     0,
       0,   715,     0,     0,   716,   717,   718,     0,   719,   720,
     721,   722,   723,   724,   186,   187,   188,   189,   190,   191,
     192,   193,     0,   195,   196,   197,     0,     0,     0,     0,
       0,     0,     0,   198,   199,     0,   200,     0,   201,   202,
     203,     0,   204,     0,   205,   206,     0,   207,   208,   209,
     210,   211,     0,     0,   212,   213,   214,   215,   216,     0,
     217,  1188,   219,   220,   221,     0,     0,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,     0,   237,   238,     0,     0,     0,
       0,     0,     0,     0,   239,   240,   241,   242,   243,   244,
     245,   246,   247,     0,   248,     0,   249,   250,   251,   252,
     253,     0,   254,   255,   256,     0,     0,   257,   258,   259,
     260,   261,     0,   262,   263,   264,     0,   265,   266,     0,
     267,   268,   269,   270,   271,   272,   273,     0,  1189,     0,
     275,   276,   277,     0,   278,     0,   279,     0,     0,     0,
     280,   281,     0,   282,   283,     0,   284,     0,   285,   286,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,     0,   299,   300,   301,   302,
     303,   304,   305,     0,   306,     0,   307,     0,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,   319,   320,     0,     0,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,     0,   335,     0,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
       0,   348,   349,   350,   351,   352,     0,     0,   353,     0,
       0,     0,   354,   355,   356,     0,     0,   357,     0,     0,
       0,   358,   359,   360,   361,   362,   363,   364,     0,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,     0,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,     0,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,     0,   406,   407,   408,   409,     0,
     410,   411,   412,   413,     0,   414,   415,     0,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
       0,   428,   429,     0,   430,   431,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,   440,     0,   441,
     442,   443,   444,   445,   446,     0,     0,   447,   448,   449,
     450,     0,     0,   451,   452,   453,   454,   455,   456,     0,
     457,     0,   458,   459,   460,     0,     0,   461,     0,     0,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,     0,     0,     0,   478,
       0,     0,     0,     0,   715,     0,     0,   716,   717,   718,
       0,   719,   720,   721,   722,   723,   724,   186,   187,   188,
     189,   190,   191,   192,   193,     0,   195,   196,   197,     0,
       0,     0,     0,     0,     0,     0,   198,   199,     0,   200,
       0,   201,   202,   203,     0,   204,     0,   205,   206,     0,
     207,   208,   209,   210,   211,     0,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,   220,   221,     0,     0,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,     0,   237,   238,
       0,     0,     0,     0,     0,     0,     0,   239,   240,   241,
     242,   243,   244,   245,   246,   247,     0,   248,     0,   249,
     250,   251,   252,   253,     0,   254,   255,   256,     0,     0,
     257,   258,   259,   260,   261,     0,   262,   263,   264,     0,
     265,   266,     0,   267,   268,   269,   270,   271,   272,   273,
       0,   274,     0,   275,   276,   277,     0,   278,     0,   279,
       0,     0,     0,   280,   281,     0,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   299,
     300,   301,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,   319,   320,
       0,     0,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,     0,   335,     0,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,     0,   348,   349,   350,   351,   352,     0,
       0,   353,     0,     0,     0,   354,   355,   356,     0,     0,
     357,     0,     0,     0,   358,   359,   360,   361,   362,   363,
     364,     0,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,     0,   406,   407,
     408,   409,     0,   410,   411,   412,   413,     0,   414,   415,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,   428,   429,     0,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,     0,
     447,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,     0,   457,     0,   458,   459,   460,     0,     0,
     461,     0,     0,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,     0,
       0,     0,   478,     0,     0,     0,     0,   715,     0,     0,
     716,   717,   718,     0,   719,   720,   721,   722,   723,   724,
     186,   187,   188,   189,   190,   191,   192,   193,  1521,   195,
     196,   197,  1522,  1523,  1524,  1525,  1526,  1527,  1528,   198,
     199,  1529,   200,   674,   201,   202,   203,   675,   204,   676,
     205,   206,  1530,   207,   208,   209,   210,   211,  1531,  1532,
     212,   213,   214,   215,   216,  1533,   217,   218,   219,   220,
     221,  1534,  1535,   222,   223,   224,   225,   226,   227,  1536,
     228,   229,   230,   231,   232,   233,  1537,   234,   235,   236,
     677,   237,   238,  1538,  1539,  1540,   678,  1541,  1542,  1543,
     239,   240,   241,   242,   243,   244,   245,   246,   247,  1544,
     248,  1545,   249,   250,   251,   252,   253,  1546,   254,   255,
     256,  1547,  1548,   257,   258,   259,   260,   261,  1549,   262,
     263,   264,  1550,   265,   266,  1551,   267,   268,   269,   270,
     271,   272,   273,  1552,   274,  1553,   275,   276,   277,  1554,
     278,  1555,   279,   679,  1556,   680,   280,   281,  1557,   282,
     283,  1558,   284,  1559,   285,   286,   287,   288,   289,   681,
     290,   291,   292,  1560,   293,   294,   295,   296,   297,   298,
    1561,   682,   299,   300,   301,   302,   303,   304,   305,  1562,
     306,  1563,   307,   683,   684,   308,   685,   309,   310,   311,
     312,   313,   314,   315,  1564,   316,   686,   317,   687,  1565,
     318,   319,   320,  1566,  1567,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   688,
     335,  1568,   336,   337,   338,   339,   340,   341,   342,   343,
     344,  1569,   345,   346,   689,   347,  1570,   348,   349,   350,
     351,   352,  1571,  1572,   353,  1573,  1574,  1575,   354,   355,
     356,  1576,  1577,   357,   690,   691,   692,   358,   359,   360,
     361,   362,   363,   364,  1578,   365,   366,   367,   368,   369,
     370,   371,  1579,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,  1580,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,  1581,   393,   394,   693,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
    1582,   406,   407,   408,   409,  1583,   410,   411,   412,   413,
     694,   414,   415,  1584,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,  1585,   428,   429,  1586,
     430,   431,   432,   433,   434,  1587,   435,   436,  1588,  1589,
     437,   438,   439,   440,  1590,   441,   442,   443,   444,   445,
     446,  1591,  1592,   447,   448,   449,   450,  1593,  1594,   451,
     452,   453,   454,   455,   456,  1595,   457,   695,   458,   459,
     460,  1596,  1597,   461,  1598,  1599,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     0,     0,     0,  1600,   186,   187,   188,   189,
     190,   191,   192,   193,     0,   195,   196,   197,     0,  1601,
       0,     0,     0,     0,     0,   198,   199,     0,   200,     0,
     201,   202,   203,     0,   204,     0,   205,   206,     0,   207,
     208,   209,   210,   211,     0,     0,   212,   213,   214,   215,
     216,     0,   217,   218,   219,   220,   221,     0,     0,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,     0,   237,   238,     0,
       0,     0,     0,     0,     0,     0,   239,   240,   241,   242,
     243,   244,   245,   246,   247,     0,   248,     0,   249,   250,
     251,   252,   253,     0,   254,   255,   256,     0,     0,   257,
     258,   259,   260,   261,     0,   262,   263,   264,     0,   265,
     266,     0,   267,   268,   269,   270,   271,   272,   273,     0,
     274,     0,   275,   276,   277,     0,   278,     0,   279,     0,
       0,     0,   280,   281,     0,   282,   283,     0,   284,     0,
     285,   286,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,     0,   299,   300,
     301,   302,   303,   304,   305,     0,   306,     0,   307,     0,
       0,   308,     0,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,     0,     0,   318,   319,   320,     0,
       0,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,     0,   335,     0,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
       0,   347,     0,   348,   349,   350,   351,   352,     0,     0,
     353,     0,     0,     0,   354,   355,   356,     0,     0,   357,
       0,     0,     0,   358,   359,   360,   361,   362,   363,   364,
       0,   365,   366,   367,   368,   369,   370,   371,     0,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
       0,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,     0,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,     0,   406,   407,   408,
     409,     0,   410,   411,   412,   413,     0,   414,   415,     0,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,     0,   428,   429,     0,   430,   431,   432,   433,
     434,     0,   435,   436,     0,     0,   437,   438,   439,   440,
       0,   441,   442,   443,   444,   445,   446,     0,     0,   447,
     448,   449,   450,     0,     0,   451,   452,   453,   454,   455,
     456,     0,   457,     0,   458,   459,   460,     0,     0,   461,
       0,     0,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     0,     0,
       0,   478,   186,   187,   188,   189,   190,   191,   192,   193,
       0,   195,   196,   197,     0,   647,     0,     0,     0,     0,
       0,   198,   199,     0,   200,   674,   201,   202,   203,   675,
    1205,   676,  1206,  1207,     0,   207,   208,   209,   210,   211,
       0,     0,   212,   213,  1208,  1209,   216,     0,   217,   218,
     219,   220,     0,     0,     0,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   677,   237,   238,     0,     0,     0,   678,     0,
       0,     0,   239,   240,   241,   242,   243,   244,  1210,  1211,
     247,     0,   248,     0,   249,   250,   251,   252,   253,     0,
     254,   255,   256,     0,     0,   257,   258,   916,   260,   261,
       0,   262,   263,   264,     0,   265,   266,     0,   267,   268,
     269,     0,   271,   272,     0,     0,   274,     0,   275,  1212,
     277,     0,   278,     0,   279,   679,     0,   680,   280,   281,
       0,   282,     0,     0,   284,     0,   285,   286,   287,   288,
     289,   681,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,   682,     0,   300,   301,   302,   303,  1213,
    1214,     0,  1215,     0,   307,   683,   684,   308,   685,   309,
     310,   311,   312,   313,   314,   315,     0,     0,   686,   317,
     687,     0,   318,   319,   320,     0,     0,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
    1216,   688,  1217,     0,   336,   337,   338,   339,   340,   341,
     342,     0,   344,     0,   345,   346,   689,   347,     0,     0,
     349,  1218,   351,   352,     0,     0,   353,     0,     0,     0,
     354,   355,   356,     0,     0,     0,   690,   691,   692,     0,
     359,   360,   361,   362,   363,   364,     0,   365,     0,   367,
       0,   369,   370,   371,     0,   372,   373,   374,   375,   376,
     377,   378,  1219,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,     0,   393,   394,
     693,   395,   396,     0,   398,   399,   400,   401,   402,   403,
     404,   405,     0,   406,   407,   408,   409,     0,   410,  1220,
     412,   413,   694,   414,  1221,     0,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   427,     0,   428,
     429,     0,   430,   431,   432,   433,   434,     0,  1222,  1223,
       0,     0,   437,     0,   439,     0,     0,   441,   442,   443,
     444,   445,   446,     0,     0,   447,   448,   449,   450,     0,
       0,   451,   452,   453,   454,     0,  1224,     0,   457,   695,
     458,   459,   460,     0,     0,   461,     0,     0,   462,   463,
     464,   465,   466,     0,     0,     0,     0,     0,     0,     0,
       0,   475,   476,   477,     0,     0,     0,  1225,   186,   187,
     188,   189,   190,   191,   192,   193,     0,   195,   196,   197,
       0,  1654,     0,     0,     0,     0,     0,   198,   199,     0,
     200,   674,   201,   202,   203,   675,  1205,   676,  1206,  1207,
       0,   207,   208,   209,   210,   211,     0,     0,   212,   213,
    1208,  1209,   216,     0,   217,   218,   219,   220,     0,     0,
       0,   222,   223,   224,   225,   226,   227,     0,   228,   229,
     230,   231,   232,   233,     0,   234,   235,   236,   677,   237,
     238,     0,     0,     0,   678,     0,     0,     0,   239,   240,
     241,   242,   243,   244,  1210,  1211,   247,     0,   248,     0,
     249,   250,   251,   252,   253,     0,   254,   255,   256,     0,
       0,   257,   258,   916,   260,   261,     0,   262,   263,   264,
       0,   265,   266,     0,   267,   268,   269,     0,   271,   272,
       0,     0,   274,     0,   275,  1212,   277,     0,   278,     0,
     279,   679,     0,   680,   280,   281,     0,   282,     0,     0,
     284,     0,   285,   286,   287,   288,   289,   681,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   682,
       0,   300,   301,   302,   303,  1213,  1214,     0,  1215,     0,
     307,   683,   684,   308,   685,   309,   310,   311,   312,   313,
     314,   315,     0,     0,   686,   317,   687,     0,   318,   319,
     320,     0,     0,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,  1216,   688,  1217,     0,
     336,   337,   338,   339,   340,   341,   342,     0,   344,     0,
     345,   346,   689,   347,     0,     0,   349,  1218,   351,   352,
       0,     0,   353,     0,     0,     0,   354,   355,   356,     0,
       0,     0,   690,   691,   692,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,   367,     0,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,  1219,   380,
     381,   382,     0,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,     0,   393,   394,   693,   395,   396,     0,
     398,   399,   400,   401,   402,   403,   404,   405,     0,   406,
     407,   408,   409,     0,   410,  1220,   412,   413,   694,   414,
    1221,     0,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   427,     0,   428,   429,     0,   430,   431,
     432,   433,   434,     0,  1222,  1223,     0,     0,   437,     0,
     439,     0,     0,   441,   442,   443,   444,   445,   446,     0,
       0,   447,   448,   449,   450,     0,     0,   451,   452,   453,
     454,     0,  1224,     0,   457,   695,   458,   459,   460,     0,
       0,   461,     0,     0,   462,   463,   464,   465,   466,     0,
       0,     0,     0,     0,     0,     0,     0,   475,   476,   477,
       0,     0,     0,  1818,   186,   187,   188,   189,   190,   191,
     192,   193,     0,   195,   196,   197,     0,  1654,     0,     0,
       0,     0,     0,   198,   199,     0,   200,     0,   201,   202,
     203,     0,   204,     0,   205,   206,     0,   207,   208,   209,
     210,   211,     0,     0,   212,   213,   214,   215,   216,     0,
     217,   218,   219,   220,   221,     0,     0,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,     0,   237,   238,     0,     0,     0,
       0,     0,     0,     0,   239,   240,   241,   242,   243,   244,
     245,   246,   247,  1506,   248,     0,   249,   250,   251,   252,
     253,     0,   254,   255,   256,     0,     0,   257,   258,   259,
     260,   261,     0,   262,   263,   264,     0,   265,   266,     0,
     267,   268,   269,   270,   271,   272,   273,  1507,   274,     0,
     275,   276,   277,     0,   278,     0,   279,     0,     0,     0,
     280,   281,     0,   282,   283,     0,   284,     0,   285,   286,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,     0,   299,   300,   301,   302,
     303,   304,   305,     0,   306,     0,   307,     0,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,   319,   320,     0,     0,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,     0,   335,     0,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
       0,   348,   349,   350,   351,   352,  1508,     0,   353,     0,
    1509,     0,   354,   355,   356,     0,     0,   357,     0,     0,
       0,   358,   359,   360,   361,   362,   363,   364,     0,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,     0,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,     0,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,     0,   406,   407,   408,   409,     0,
     410,   411,   412,   413,     0,   414,   415,     0,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
       0,   428,   429,     0,   430,   431,   432,   433,   434,     0,
     435,   436,     0,     0,   437,   438,   439,   440,  1510,   441,
     442,   443,   444,   445,   446,     0,     0,   447,   448,   449,
     450,     0,     0,   451,   452,   453,   454,   455,   456,     0,
     457,     0,   458,   459,   460,     0,     0,   461,     0,     0,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,     0,     0,     0,   478,
    1495,   586,     0,     0,     0,   569,     0,     0,     0,     0,
       0,   570,  1496,   186,   187,   188,   189,   190,   191,   192,
     193,     0,   195,   196,   197,     0,     0,     0,     0,     0,
       0,     0,   198,   199,     0,   200,     0,   201,   202,   203,
       0,   204,     0,   205,   206,     0,   207,   208,   209,   210,
     211,     0,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,   220,   221,     0,     0,   222,   223,   224,   225,
     226,   227,     0,   228,   229,   230,   231,   232,   233,     0,
     234,   235,   236,     0,   237,   238,     0,     0,     0,     0,
       0,     0,     0,   239,   240,   241,   242,   243,   244,   245,
     246,   247,  1516,   248,     0,   249,   250,   251,   252,   253,
       0,   254,   255,   256,     0,     0,   257,   258,   259,   260,
     261,     0,   262,   263,   264,     0,   265,   266,     0,   267,
     268,   269,   270,   271,   272,   273,  1507,   274,     0,   275,
     276,   277,     0,   278,     0,   279,     0,     0,     0,   280,
     281,     0,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   299,   300,   301,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,   319,   320,     0,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,     0,   335,     0,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,     0,
     348,   349,   350,   351,   352,  1508,     0,   353,     0,  1509,
       0,   354,   355,   356,     0,     0,   357,     0,     0,     0,
     358,   359,   360,   361,   362,   363,   364,     0,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,     0,   406,   407,   408,   409,     0,   410,
     411,   412,   413,     0,   414,   415,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,     0,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,   440,  1510,   441,   442,
     443,   444,   445,   446,     0,     0,   447,   448,   449,   450,
       0,     0,   451,   452,   453,   454,   455,   456,     0,   457,
       0,   458,   459,   460,     0,     0,   461,     0,     0,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,     0,     0,     0,   478,  1495,
     586,     0,     0,     0,   569,     0,     0,     0,     0,     0,
     570,  1496,   186,   187,   188,   189,   190,   191,   192,   193,
       0,   195,   196,   197,     0,     0,     0,     0,     0,     0,
       0,   198,   199,     0,   200,     0,   201,   202,   203,     0,
     204,     0,   205,   206,     0,   207,   208,   209,   210,   211,
       0,     0,   212,   213,   214,   215,   216,     0,   217,   218,
     219,   220,   221,     0,     0,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,     0,   237,   238,     0,     0,     0,     0,     0,
       0,     0,   239,   240,   241,   242,   243,   244,   245,   246,
     247,     0,   248,     0,   249,   250,   251,   252,   253,     0,
     254,   255,   256,     0,     0,   257,   258,   259,   260,   261,
       0,   262,   263,   264,     0,   265,   266,     0,   267,   268,
     269,   270,   271,   272,   273,  1507,   274,     0,   275,   276,
     277,     0,   278,     0,   279,     0,     0,     0,   280,   281,
       0,   282,   283,     0,   284,     0,   285,   286,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,     0,   299,   300,   301,   302,   303,   304,
     305,     0,   306,     0,   307,     0,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,   319,   320,     0,     0,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,     0,   335,     0,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,     0,   348,
     349,   350,   351,   352,  1508,     0,   353,     0,  1509,     0,
     354,   355,   356,     0,     0,   357,     0,     0,     0,   358,
     359,   360,   361,   362,   363,   364,     0,   365,   366,   367,
     368,   369,   370,   371,     0,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,     0,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,     0,   406,   407,   408,   409,     0,   410,   411,
     412,   413,     0,   414,   415,     0,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,     0,   428,
     429,     0,   430,   431,   432,   433,   434,     0,   435,   436,
       0,     0,   437,   438,   439,   440,  1510,   441,   442,   443,
     444,   445,   446,     0,     0,   447,   448,   449,   450,     0,
       0,   451,   452,   453,   454,   455,   456,     0,   457,     0,
     458,   459,   460,     0,     0,   461,     0,     0,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,     0,     0,     0,   478,  1495,   586,
       0,     0,     0,   569,     0,     0,     0,     0,     0,   570,
    1496,   186,   560,   188,   189,   190,   191,   192,   193,   561,
     195,   196,   197,     0,     0,     0,     0,     0,     0,     0,
     198,   199,     0,   200,     0,   562,   202,   203,     0,   204,
       0,   205,   206,     0,   207,   208,   209,   210,   211,     0,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
     220,   221,     0,     0,   222,   223,   224,   225,   226,   227,
       0,   228,   229,   230,   231,   232,   233,     0,   234,   235,
     236,     0,   237,   238,     0,     0,     0,     0,     0,     0,
       0,   239,   240,   241,   242,   243,   244,   245,   246,   247,
       0,   248,     0,   249,   250,   251,   252,   253,     0,   254,
     255,   256,     0,     0,   257,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,     0,   267,   268,   269,
     270,   271,   272,   273,     0,   274,     0,   563,   276,   277,
       0,   278,     0,   564,     0,     0,     0,   280,   281,     0,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   299,   300,   301,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,   308,     0,   309,   310,
     311,   312,   565,   314,   315,     0,   316,     0,   317,     0,
       0,   318,   319,   320,     0,     0,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
       0,   335,     0,   566,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,     0,   353,     0,     0,     0,   354,
     355,   356,     0,     0,   357,     0,     0,     0,   358,   359,
     360,   361,   362,   363,   364,     0,   365,   366,   367,   368,
     369,   370,   371,     0,   567,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   568,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,     0,   406,   407,   408,   409,     0,   410,   411,   412,
     413,     0,   414,   415,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
       0,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,     0,   447,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,     0,   457,     0,   458,
     459,   460,     0,     0,   461,     0,     0,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     0,     0,     0,   478,     0,     0,     0,
       0,     0,   569,     0,     0,     0,     0,     0,   570,   571,
     186,   187,   188,   189,   190,   191,   192,   193,     0,   195,
     196,   197,     0,     0,     0,     0,     0,     0,     0,   198,
     199,     0,   200,     0,   201,   202,   203,     0,   204,     0,
     205,   206,     0,   207,   208,   209,   210,   211,     0,     0,
     212,   213,   214,   215,   216,     0,   217,   218,   219,   220,
     221,     0,     0,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
       0,   237,   238,     0,     0,     0,     0,     0,     0,     0,
     239,   240,   241,   242,   243,   244,   245,   246,   247,     0,
     248,     0,   249,   250,   251,   252,   253,     0,   254,   255,
     256,     0,     0,   257,   258,   259,   260,   261,     0,   262,
     263,   264,     0,   265,   266,     0,   267,   268,   269,   270,
     271,   272,   273,     0,   274,     0,   275,   276,   277,     0,
     278,     0,   279,     0,     0,     0,   280,   281,     0,   282,
     283,     0,   284,     0,   285,   286,   287,   288,   289,     0,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,     0,   299,   300,   301,   302,   303,   304,   305,     0,
     306,     0,   307,     0,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,   319,   320,     0,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,     0,
     335,     0,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,     0,   348,   349,   350,
     351,   352,     0,     0,   353,     0,     0,     0,   354,   355,
     356,     0,     0,   357,     0,     0,     0,   358,   359,   360,
     361,   362,   363,   364,     0,   365,   366,   367,   368,   369,
     370,   371,     0,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,     0,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
       0,   406,   407,   408,   409,     0,   410,   411,   412,   413,
       0,   414,   415,     0,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,     0,   428,   429,     0,
     430,   431,   432,   433,   434,     0,   435,   436,     0,     0,
     437,   438,   439,   440,     0,   441,   442,   443,   444,   445,
     446,     0,     0,   447,   448,   449,   450,     0,     0,   451,
     452,   453,   454,   455,   456,     0,   457,     0,   458,   459,
     460,     0,     0,   461,     0,     0,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     0,     0,     0,   478,     0,     0,     0,     0,
       0,     0,  3183,   186,   187,   188,   189,   190,   191,   192,
     193,     0,   195,   196,   197,     0,     0,     0,     0,     0,
       0,     0,   198,   199,     0,   200,     0,   201,   202,   203,
       0,   204,     0,   205,   206,     0,   207,   208,   209,   210,
     211,     0,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,   220,   221,     0,     0,   222,   223,   224,   225,
     226,   227,     0,   228,   229,   230,   231,   232,   233,     0,
     234,   235,   236,     0,   237,   238,     0,     0,     0,     0,
       0,     0,     0,   239,   240,   241,   242,   243,   244,   245,
     246,   247,     0,   248,     0,   249,   250,   251,   252,   253,
       0,   254,   255,   256,     0,     0,   257,   258,   259,   260,
     261,     0,   262,   263,   264,     0,   265,   266,     0,   267,
     268,   269,   270,   271,   272,   273,     0,   274,     0,   275,
     276,   277,     0,   278,     0,   279,     0,     0,     0,   280,
     281,     0,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   299,   300,   301,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,   319,   320,     0,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,     0,   335,     0,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,     0,
     348,   349,   350,   351,   352,     0,     0,   353,     0,     0,
       0,   354,   355,   356,     0,     0,   357,     0,     0,     0,
     358,   359,   360,   361,   362,   363,   364,     0,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,     0,   406,   407,   408,   409,     0,   410,
     411,   412,   413,     0,   414,   415,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,     0,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,     0,   447,   448,   449,   450,
       0,     0,   451,   452,   453,   454,   455,   456,     0,   457,
       0,   458,   459,   460,     0,     0,   461,     0,     0,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,     0,     0,     0,   478,  3585,
     586,  3586,  3587,     0,   569,   186,   187,   188,   189,   190,
     191,   192,   193,     0,   195,   196,   197,     0,     0,     0,
       0,     0,     0,     0,   198,   199,     0,   200,     0,   201,
     202,   203,     0,   204,     0,   205,   206,     0,   207,   208,
     209,   210,   211,     0,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,   220,   221,     0,     0,   222,   223,
     224,   225,   226,   227,     0,   228,   229,   230,   231,   232,
     233,     0,   234,   235,   236,     0,   237,   238,     0,     0,
       0,     0,     0,     0,     0,   239,   240,   241,   242,   243,
     244,   245,   246,   247,  1489,   248,     0,   249,   250,   251,
     252,   253,     0,   254,   255,   256,     0,     0,   257,   258,
     259,   260,   261,     0,   262,   263,   264,     0,   265,   266,
       0,   267,   268,   269,   270,   271,   272,   273,     0,   274,
       0,   275,   276,   277,     0,   278,     0,   279,     0,     0,
       0,   280,   281,     0,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   299,   300,   301,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,   319,   320,     0,     0,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,   335,     0,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,     0,   353,
       0,     0,     0,   354,   355,   356,     0,     0,   357,     0,
       0,     0,   358,   359,   360,   361,   362,   363,   364,     0,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,     0,   406,   407,   408,   409,
       0,   410,   411,   412,   413,     0,   414,   415,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   428,   429,     0,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,     0,   447,   448,
     449,   450,     0,     0,   451,   452,   453,   454,   455,   456,
       0,   457,     0,   458,   459,   460,     0,     0,   461,     0,
       0,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     0,     0,     0,
     478,     0,   586,   186,   187,   188,   189,   190,   191,   192,
     193,     0,   195,   196,   197,     0,     0,     0,     0,     0,
       0,     0,   198,   199,     0,   200,     0,   201,   202,   203,
       0,   204,     0,   205,   206,     0,   207,   208,   209,   210,
     211,     0,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,   220,   221,     0,     0,   222,   223,   224,   225,
     226,   227,     0,   228,   229,   230,   231,   232,   233,     0,
     234,   235,   236,     0,   237,   238,     0,     0,     0,     0,
       0,     0,     0,   239,   240,   241,   242,   243,   244,   245,
     246,   247,     0,   248,     0,   249,   250,   251,   252,   253,
       0,   254,   255,   256,     0,     0,   257,   258,   259,   260,
     261,     0,   262,   263,   264,     0,   265,   266,     0,   267,
     268,   269,   270,   271,   272,   273,     0,   274,     0,   275,
     276,   277,     0,   278,     0,   279,     0,     0,     0,   280,
     281,     0,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   299,   300,   301,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,   319,   320,     0,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,     0,   335,     0,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,     0,
     348,   349,   350,   351,   352,     0,     0,   353,     0,     0,
       0,   354,   355,   356,     0,     0,   357,     0,     0,     0,
     358,   359,   360,   361,   362,   363,   364,     0,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,     0,   406,   407,   408,   409,     0,   410,
     411,   412,   413,     0,   414,   415,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,     0,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,     0,   447,   448,   449,   450,
       0,     0,   451,   452,   453,   454,   455,   456,     0,   457,
       0,   458,   459,   460,     0,     0,   461,     0,     0,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,     0,     0,     0,   478,     0,
     586,   186,   187,   188,   189,   190,   191,   192,   193,     0,
     195,   196,   197,     0,     0,     0,     0,     0,     0,     0,
     198,   199,     0,   200,     0,   201,   202,   203,     0,   204,
       0,   205,   206,     0,   207,   208,   209,   210,   211,     0,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
     220,   221,     0,     0,   222,   223,   224,   225,   226,   227,
       0,   228,   229,   230,   231,   232,   233,     0,   234,   235,
     236,     0,   237,   238,     0,     0,     0,     0,     0,     0,
       0,   239,   240,   241,   242,   243,   244,   245,   246,   247,
       0,   248,     0,   249,   250,   251,   252,   253,     0,   254,
     255,   256,     0,     0,   257,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,     0,   267,   268,   269,
     270,   271,   272,   273,     0,   274,     0,   275,   276,   277,
       0,   278,     0,   279,     0,     0,     0,   280,   281,     0,
     282,   283,     0,   284,     0,   285,   286,   287,   288,  1323,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   299,   300,   301,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,   319,   320,     0,     0,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
       0,   335,     0,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,     0,   353,     0,     0,     0,   354,
     355,   356,     0,     0,   357,     0,     0,     0,   358,   359,
     360,   361,   362,   363,   364,     0,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,     0,   406,   407,   408,   409,     0,   410,   411,   412,
     413,     0,   414,   415,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
       0,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,     0,   447,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,     0,   457,     0,   458,
     459,   460,     0,     0,   461,     0,     0,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     0,     0,     0,   478,     0,   586,   186,
     187,   188,   189,   190,   191,   192,   193,  1521,   195,   196,
     197,  1522,  1523,  1524,  1525,  1526,  1527,  1528,   198,   199,
    1529,   200,   674,   201,   202,   203,   675,   204,   676,   205,
     206,  1530,   207,   208,   209,   210,   211,  1531,  1532,   212,
     213,   214,   215,   216,  1533,   217,   218,   219,   220,   221,
    1534,  1535,   222,   223,   224,   225,   226,   227,  1536,   228,
     229,   230,   231,   232,   233,  1537,   234,   235,   236,   677,
     237,   238,  1538,  1539,  1540,   678,  1541,  1542,  1543,   239,
     240,   241,   242,   243,   244,   245,   246,   247,  1544,   248,
    1545,   249,   250,   251,   252,   253,  1546,   254,   255,   256,
    1547,  1548,   257,   258,   259,   260,   261,  1549,   262,   263,
     264,  1550,   265,   266,  1551,   267,   268,   269,   270,   271,
     272,   273,  1552,   274,  1553,   275,   276,   277,  1554,   278,
    1555,   279,   679,  1556,   680,   280,   281,  1557,   282,   283,
    1558,   284,  1559,   285,   286,   287,   288,   289,   681,   290,
     291,   292,  1560,   293,   294,   295,   296,   297,   298,  1561,
     682,   299,   300,   301,   302,   303,   304,   305,  1562,   306,
    1563,   307,   683,   684,   308,   685,   309,   310,   311,   312,
     313,   314,   315,  1564,   316,   686,   317,   687,  1565,   318,
     319,   320,  1566,  1567,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   688,   335,
    1568,   336,   337,   338,   339,   340,   341,   342,   343,   344,
    1569,   345,   346,   689,   347,  1570,   348,   349,   350,   351,
     352,  1571,  1572,   353,  1573,  1574,  1575,   354,   355,   356,
    1576,  1577,   357,   690,   691,   692,   358,   359,   360,   361,
     362,   363,   364,  1578,   365,   366,   367,   368,   369,   370,
     371,  1579,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,  1580,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,  1581,   393,   394,   693,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,  1582,
     406,   407,   408,   409,  1583,   410,   411,   412,   413,   694,
     414,   415,  1584,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,  1585,   428,   429,  1586,   430,
     431,   432,   433,   434,  1587,   435,   436,  1588,  1589,   437,
     438,   439,   440,  1590,   441,   442,   443,   444,   445,   446,
    1591,  1592,   447,   448,   449,   450,  1593,  1594,   451,   452,
     453,   454,   455,   456,  1595,   457,   695,   458,   459,   460,
    1596,  1597,   461,  1598,  1599,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,     0,     0,     0,  1600,   186,   187,   188,   189,  2277,
     191,   192,   193,  1521,   195,   196,   197,  1522,  1523,  1524,
    1525,  1526,  1527,  1528,   198,   199,  1529,   200,   674,   201,
     202,   203,   675,   204,   676,   205,   206,  1530,   207,   208,
     209,   210,   211,  1531,  1532,   212,   213,   214,   215,   216,
    1533,   217,   218,   219,   220,   221,  1534,  1535,   222,   223,
     224,   225,   226,   227,  1536,   228,   229,   230,   231,   232,
     233,  1537,   234,   235,   236,   677,   237,   238,  1538,  1539,
    1540,   678,  1541,  1542,  1543,   239,   240,   241,   242,   243,
     244,   245,   246,   247,  1544,   248,  1545,   249,   250,   251,
     252,   253,  1546,   254,   255,   256,  1547,  1548,   257,   258,
     259,  2278,   261,  1549,   262,   263,   264,  1550,   265,   266,
    1551,   267,   268,   269,   270,   271,   272,   273,  1552,   274,
    1553,   275,   276,   277,  1554,   278,  1555,   279,   679,  1556,
     680,   280,   281,  1557,   282,   283,  1558,   284,  1559,   285,
     286,   287,   288,   289,   681,   290,   291,   292,  1560,   293,
     294,   295,   296,   297,   298,  1561,   682,   299,   300,   301,
     302,   303,   304,   305,  1562,   306,  1563,   307,   683,   684,
     308,   685,   309,   310,   311,   312,   313,   314,   315,  1564,
     316,   686,   317,   687,  1565,   318,   319,   320,  1566,  1567,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   688,   335,  1568,   336,   337,   338,
     339,   340,   341,   342,   343,   344,  1569,   345,   346,   689,
     347,  1570,   348,   349,   350,   351,   352,  1571,  1572,   353,
    1573,  1574,  1575,   354,   355,   356,  1576,  1577,   357,   690,
     691,   692,   358,   359,   360,   361,   362,   363,   364,  1578,
     365,   366,   367,   368,   369,   370,   371,  1579,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,  1580,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
    1581,   393,   394,   693,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,  1582,   406,   407,   408,   409,
    1583,  2279,   411,   412,   413,   694,   414,   415,  1584,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,  1585,   428,   429,  1586,   430,   431,   432,   433,   434,
    1587,   435,   436,  1588,  1589,   437,   438,   439,   440,  1590,
     441,   442,   443,   444,   445,   446,  1591,  1592,   447,   448,
     449,   450,  1593,  1594,   451,   452,   453,   454,   455,   456,
    1595,   457,   695,   458,   459,   460,  1596,  1597,   461,  1598,
    1599,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     0,     0,     0,
    1600,   186,   187,   188,   189,   190,   191,   192,   193,     0,
     195,   196,   197,     0,     0,     0,     0,     0,     0,     0,
     198,   199,     0,   200,   674,   201,   202,   203,   675,   204,
     676,   205,   206,     0,   207,   208,   209,   210,   211,     0,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
     220,   221,     0,     0,   222,   223,   224,   225,   226,   227,
       0,   228,   229,   230,   231,   232,   233,     0,   234,   235,
     236,   677,   237,   238,     0,     0,     0,   678,     0,     0,
       0,   239,   240,   241,   242,   243,   244,   245,   246,   247,
       0,   248,     0,   249,   250,   251,   252,   253,     0,   254,
     255,   256,     0,     0,   257,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,     0,   267,   268,   269,
     270,   271,   272,   273,     0,   274,     0,   275,   276,   277,
       0,   278,     0,   279,   679,     0,   680,   280,   281,     0,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
     681,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,   682,   299,   300,   301,   302,   303,   304,   305,
       0,   306,     0,   307,   683,   684,   308,   685,   309,   310,
     311,   312,   313,   314,   315,     0,   316,   686,   317,   687,
       0,   318,   319,   320,     0,     0,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     688,   335,   638,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,   689,   347,     0,   348,   349,
     350,   351,   352,     0,     0,   353,   639,     0,     0,   354,
     355,   356,     0,     0,   357,   690,   691,   692,   358,   359,
     360,   361,   362,   363,   364,     0,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,   693,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,     0,   406,   407,   408,   409,     0,   410,   411,   412,
     413,   694,   414,   415,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
       0,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,     0,   447,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,     0,   457,   695,   458,
     459,   460,     0,     0,   461,     0,     0,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     0,     0,     0,   696,   186,   187,   188,
     189,   190,   191,   192,   193,     0,   195,   196,   197,     0,
       0,     0,     0,     0,     0,     0,   198,   199,     0,   200,
     674,   201,   202,   203,   675,   204,   676,   205,   206,     0,
     207,   208,   209,   210,   211,     0,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,   220,   221,     0,     0,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   677,   237,   238,
       0,     0,     0,   678,     0,     0,     0,   239,   240,   241,
     242,   243,   244,   245,   246,   247,     0,   248,     0,   249,
     250,   251,   252,   253,     0,   254,   255,   256,     0,     0,
     257,   258,   259,   260,   261,     0,   262,   263,   264,     0,
     265,   266,     0,   267,   268,   269,   270,   271,   272,   273,
       0,   274,     0,   275,   276,   277,     0,   278,     0,   279,
     679,     0,   680,   280,   281,     0,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   815,   681,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   682,   299,
     300,   301,   302,   303,   304,   305,     0,   306,     0,   307,
     683,   684,   308,   685,   309,   310,   311,   312,   313,   314,
     315,     0,   316,   686,   317,   687,     0,   318,   319,   320,
       0,     0,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   688,   335,   638,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   689,   347,     0,   348,   349,   350,   351,   352,     0,
       0,   353,   639,     0,     0,   354,   355,   356,     0,     0,
     357,   690,   691,   692,   358,   359,   360,   361,   362,   363,
     364,     0,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,   693,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,     0,   406,   407,
     408,   409,     0,   410,   411,   412,   413,   694,   414,   415,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,   428,   429,     0,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,     0,
     447,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,     0,   457,   695,   458,   459,   460,     0,     0,
     461,     0,     0,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,     0,
       0,     0,   696,   186,   187,   188,   189,   190,   191,   192,
     193,     0,   195,   196,   197,     0,     0,     0,     0,     0,
       0,     0,   198,   199,     0,   200,   674,   201,   202,   203,
     675,   204,   676,   205,   206,     0,   207,   208,   209,   210,
     211,     0,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,   220,   221,     0,     0,   222,   223,   224,   225,
     226,   227,     0,   228,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   677,   237,   238,     0,     0,     0,   678,
       0,     0,     0,   239,   240,   241,   242,   243,   244,   245,
     246,   247,     0,   248,     0,   249,   250,   251,   252,   253,
       0,   254,   255,   256,     0,     0,   257,   258,   259,   260,
     261,     0,   262,   263,   264,     0,   265,   266,     0,   267,
     268,   269,   270,   271,   272,   273,     0,   274,     0,   275,
     276,   277,     0,   278,     0,   279,   679,     0,   680,   280,
     281,     0,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   823,   681,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   682,   299,   300,   301,   302,   303,
     304,   305,     0,   306,     0,   307,   683,   684,   308,   685,
     309,   310,   311,   312,   313,   314,   315,     0,   316,   686,
     317,   687,     0,   318,   319,   320,     0,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   688,   335,   638,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   689,   347,     0,
     348,   349,   350,   351,   352,     0,     0,   353,   639,     0,
       0,   354,   355,   356,     0,     0,   357,   690,   691,   692,
     358,   359,   360,   361,   362,   363,   364,     0,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   693,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,     0,   406,   407,   408,   409,     0,   410,
     411,   412,   413,   694,   414,   415,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,     0,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,     0,   447,   448,   449,   450,
       0,     0,   451,   452,   453,   454,   455,   456,     0,   457,
     695,   458,   459,   460,     0,     0,   461,     0,     0,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,     0,     0,     0,   696,   186,
     187,   188,   189,   190,   191,   192,   193,     0,   195,   196,
     197,     0,     0,     0,     0,     0,     0,     0,   198,   199,
       0,   200,     0,   201,   202,   203,     0,   204,     0,   205,
     206,     0,   207,   208,   209,   210,   211,     0,     0,   212,
     213,   214,   215,   216,  1670,   217,   218,   219,   220,   221,
       0,     0,   222,   223,   224,   225,   226,   227,  1671,   228,
     229,   230,   231,   232,   233,     0,   234,   235,   236,     0,
     237,   238,     0,     0,     0,     0,     0,     0,     0,   239,
     240,   241,   242,   243,   244,   245,   246,   247,     0,   248,
       0,   249,   250,   251,   252,   253,     0,   254,   255,   256,
       0,     0,   257,   258,   259,   260,   261,     0,   262,   263,
     264,     0,   265,   266,     0,   267,   268,   269,   270,   271,
     272,   273,     0,   274,     0,   275,   276,   277,     0,   278,
    1672,   279,     0,     0,     0,   280,   281,     0,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   299,   300,   301,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,  2402,     0,   318,
     319,   320,     0,     0,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,     0,   335,
       0,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,     0,   348,   349,   350,   351,
     352,     0,     0,   353,     0,     0,     0,   354,   355,   356,
       0,     0,   357,     0,     0,     0,   358,   359,   360,   361,
     362,   363,   364,     0,   365,   366,   367,   368,   369,   370,
     371,  1673,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,     0,
     406,   407,   408,   409,     0,   410,   411,   412,   413,     0,
     414,   415,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,     0,   428,   429,     0,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,  1674,   447,   448,   449,   450,     0,     0,   451,   452,
     453,   454,   455,   456,     0,   457,     0,   458,   459,   460,
       0,     0,   461,     0,     0,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,     0,     0,     0,   478,   186,   187,   188,   189,   190,
     610,   192,   193,   576,   195,   196,   197,     0,     0,     0,
       0,     0,     0,     0,   198,   199,     0,   200,     0,   201,
     202,   203,     0,   204,     0,   205,   206,     0,   207,   208,
     209,   210,   211,     0,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,   220,   221,     0,     0,   222,   223,
     224,   225,   226,   227,     0,   228,   229,   230,   231,   232,
     233,   577,   234,   235,   236,     0,   237,   238,     0,     0,
       0,     0,     0,     0,     0,   239,   240,   241,   242,   243,
     244,   245,   246,   247,     0,   248,     0,   249,   250,   251,
     252,   253,     0,   254,   255,   256,     0,     0,   257,   258,
     259,   260,   261,     0,   262,   263,   264,     0,   265,   266,
       0,   267,   268,   269,   270,   271,   272,   273,     0,   274,
       0,   275,   276,   277,     0,   278,     0,   279,     0,     0,
       0,   280,   281,   611,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   299,   300,   301,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,   319,   320,     0,     0,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,   335,     0,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,     0,   353,
       0,     0,     0,   354,   355,   356,     0,     0,   357,     0,
       0,     0,   358,   359,   360,   361,   362,   363,   364,     0,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   578,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   579,   406,   407,   408,   409,
       0,   410,   411,   412,   413,     0,   414,   415,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   428,   429,     0,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,     0,   447,   448,
     449,   450,     0,     0,   451,   452,   453,   454,   455,   456,
       0,   457,     0,   458,   459,   460,     0,     0,   461,     0,
       0,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     0,     0,     0,
     478,   186,   187,   188,   189,   190,   191,   192,   193,   576,
     195,   196,   197,     0,     0,     0,     0,     0,     0,     0,
     198,   199,     0,   200,     0,   201,   202,   203,     0,   204,
       0,   205,   206,     0,   207,   208,   209,   210,   211,     0,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
     220,   221,     0,     0,   222,   223,   224,   225,   226,   227,
       0,   228,   229,   230,   231,   232,   233,   577,   234,   235,
     236,     0,   237,   238,     0,     0,     0,     0,     0,     0,
       0,   239,   240,   241,   242,   243,   244,   245,   246,   247,
       0,   248,     0,   249,   250,   251,   252,   253,     0,   254,
     255,   256,     0,     0,   257,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,     0,   267,   268,   269,
     270,   271,   272,   273,     0,   274,     0,   275,   276,   277,
       0,   278,     0,   279,     0,     0,     0,   280,   281,     0,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   299,   300,   301,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,   319,   320,     0,     0,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
       0,   335,     0,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,     0,   353,     0,     0,     0,   354,
     355,   356,     0,     0,   357,     0,     0,     0,   358,   359,
     360,   361,   362,   363,   364,     0,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   578,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   579,   406,   407,   408,   409,     0,   410,   411,   412,
     413,     0,   414,   415,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
       0,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,     0,   447,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,     0,   457,     0,   458,
     459,   460,     0,     0,   461,     0,     0,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     0,     0,     0,   478,   186,   187,   188,
     189,   190,   191,   192,   193,     0,   195,   196,   197,     0,
       0,     0,     0,     0,     0,     0,   198,   199,     0,   200,
       0,   201,   202,   203,     0,   204,     0,   205,   206,     0,
     207,   208,   209,   210,   211,     0,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,   220,   221,     0,     0,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,     0,   237,   238,
       0,     0,     0,     0,     0,     0,     0,   239,   240,   241,
    1345,   243,   244,   245,   246,   247,     0,   248,     0,   249,
     250,   251,   252,   253,     0,   254,   255,   256,     0,     0,
     257,   258,   259,   260,   261,     0,   262,   263,   264,     0,
     265,   266,     0,   267,   268,   269,   270,   271,   272,   273,
       0,   274,     0,   275,   276,   277,     0,   278,  1346,   279,
       0,     0,     0,  1347,   281,     0,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   299,
     300,   301,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,   308,     0,   309,   310,  1348,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,   319,   320,
       0,     0,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,     0,   335,   638,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,     0,   348,   349,   350,   351,   352,     0,
       0,   353,   639,     0,     0,   354,   355,   356,     0,     0,
     357,     0,     0,     0,   358,   359,   360,   361,   362,   363,
     364,     0,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,     0,   395,   396,   397,   398,
     399,   400,  1349,   402,   403,   404,   405,     0,  1350,   407,
     408,   409,     0,   410,   411,   412,   413,     0,   414,   415,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,   428,   429,  1351,  1352,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,     0,
     447,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,     0,   457,     0,   458,   459,   460,     0,     0,
     461,     0,     0,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,     0,
       0,     0,   478,   186,   187,   188,   189,   190,   191,   192,
     193,     0,   195,   196,   197,     3,     4,     0,     0,     0,
       0,     0,   198,   199,     0,   200,     0,   201,   202,   203,
       0,   204,     0,   205,   206,     0,   207,   208,   209,   210,
     211,     0,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,   220,   221,     0,     0,   222,   223,   224,   225,
     226,   227,     0,   228,   229,   230,   231,   232,   233,     0,
     234,   235,   236,     0,   237,   238,     0,     0,     0,     0,
       0,     0,     0,   239,   240,   241,   242,   243,   244,   245,
     246,   247,     0,   248,     0,   249,   250,   251,   252,   253,
       0,   254,   255,   256,     0,     0,   257,   258,   259,   260,
     261,     0,   262,   263,   264,     0,   265,   266,     0,   267,
     268,   269,   270,   271,   272,   273,     0,   274,     0,   275,
     276,   277,     0,   278,     0,   279,     0,     0,     0,   280,
     281,     0,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   299,   300,   301,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,   319,   320,     0,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,     0,   335,   638,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,     0,
     348,   349,   350,   351,   352,     0,     0,   353,   639,     0,
       0,   354,   355,   356,     0,     0,   357,     0,     0,     0,
     358,   359,   360,   361,   362,   363,   364,     0,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,     0,   406,   407,   408,   409,     0,   410,
     411,   412,   413,     0,   414,   415,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,     0,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,     0,   447,   448,   449,   450,
       0,     0,   451,   452,   453,   454,   455,   456,     0,   457,
       0,   458,   459,   460,     0,     0,   461,     0,     0,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,     0,     0,     0,   478,   186,
     187,   188,   189,   190,   191,   192,   193,     0,   195,   196,
     197,     0,     0,     0,     0,     0,     0,     0,   198,   199,
       0,   200,     0,   201,   202,   203,     0,   204,     0,   205,
     206,     0,   207,   208,   209,   210,   211,     0,     0,   212,
     213,   214,   215,   216,     0,   217,   218,   219,   220,   221,
       0,     0,   222,   223,   224,   225,   226,   227,     0,   228,
     229,   230,   231,   232,   233,     0,   234,   235,   236,     0,
     237,   238,     0,     0,     0,     0,     0,     0,     0,   239,
     240,   241,   242,   243,   244,   245,   246,   247,     0,   248,
       0,   249,   250,   251,   252,   253,     0,   254,   255,   256,
       0,     0,   257,   258,   259,   260,   261,     0,   262,   263,
     264,     0,   265,   266,     0,   267,   268,   269,   270,   271,
     272,   273,     0,   274,     0,   275,   276,   277,     0,   278,
       0,   279,     0,     0,     0,   280,   281,     0,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   299,   300,   301,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
     319,   320,     0,     0,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,     0,   335,
     638,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,     0,   348,   349,   350,   351,
     352,     0,     0,   353,   639,     0,   640,   354,   355,   356,
       0,     0,   357,     0,     0,     0,   358,   359,   360,   361,
     362,   363,   364,     0,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,     0,
     406,   407,   408,   409,     0,   410,   411,   412,   413,     0,
     414,   415,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,     0,   428,   429,     0,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,     0,   447,   448,   449,   450,     0,     0,   451,   452,
     453,   454,   455,   456,     0,   457,     0,   458,   459,   460,
       0,     0,   461,     0,     0,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,     0,     0,     0,   478,   186,   187,   188,   189,   190,
     191,   192,   193,   993,   195,   196,   197,     0,     0,     0,
       0,     0,     0,     0,   198,   199,     0,   200,     0,   201,
     202,   203,     0,   204,     0,   205,   206,     0,   207,   208,
     209,   210,   211,     0,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,   220,   221,     0,     0,   222,   223,
     224,   225,   226,   227,     0,   228,   229,   230,   231,   232,
     233,     0,   234,   235,   236,     0,   237,   238,     0,     0,
       0,     0,     0,     0,     0,   239,   240,   241,   242,   243,
     244,   245,   246,   247,     0,   248,     0,   249,   250,   251,
     252,   253,     0,   254,   255,   256,     0,     0,   257,   258,
     259,   260,   261,     0,   262,   263,   264,     0,   265,   266,
       0,   267,   268,   269,   270,   271,   272,   273,     0,   274,
       0,   275,   276,   277,     0,   278,     0,   279,     0,     0,
       0,   280,   281,     0,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   299,   300,   301,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,   319,   320,     0,     0,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,   335,   638,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,     0,   353,
     639,     0,     0,   354,   355,   356,     0,     0,   357,     0,
       0,     0,   358,   359,   360,   361,   362,   363,   364,     0,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,     0,   406,   407,   408,   409,
       0,   410,   411,   412,   413,     0,   414,   415,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   428,   429,     0,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,     0,   447,   448,
     449,   450,     0,     0,   451,   452,   453,   454,   455,   456,
       0,   457,     0,   458,   459,   460,     0,     0,   461,     0,
       0,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     0,     0,     0,
     478,   186,   187,   188,   189,   190,   191,   192,   193,     0,
     195,   196,   197,     0,     0,     0,     0,     0,     0,     0,
     198,   199,     0,   200,     0,   201,   202,   203,     0,   204,
       0,   205,   206,     0,   207,   208,   209,   210,   211,     0,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
     220,   221,     0,     0,   222,   223,   224,   225,   226,   227,
       0,   228,   229,   230,   231,   232,   233,   577,   234,   235,
     236,     0,   237,   238,     0,     0,     0,     0,     0,     0,
       0,   239,   240,   241,   242,   243,   244,   245,   246,   247,
       0,   248,     0,   249,   250,   251,   252,   253,     0,   254,
     255,   256,     0,     0,   257,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,     0,   267,   268,   269,
     270,   271,   272,   273,     0,   274,     0,   275,   276,   277,
       0,   278,     0,   279,     0,     0,     0,   280,   281,     0,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   299,   300,   301,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,   319,   320,     0,     0,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
       0,   335,     0,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,     0,   353,     0,     0,     0,   354,
     355,   356,     0,     0,   357,     0,     0,     0,   358,   359,
     360,   361,   362,   363,   364,     0,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   578,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   579,   406,   407,   408,   409,     0,   410,   411,   412,
     413,     0,   414,   415,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
       0,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,     0,   447,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,     0,   457,     0,   458,
     459,   460,     0,     0,   461,     0,     0,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     0,     0,     0,   478,   186,   187,   188,
     189,   190,   191,   192,   193,     0,   195,   196,   197,     0,
       0,     0,     0,     0,     0,     0,   198,   199,     0,   200,
       0,   201,   202,   203,     0,   204,     0,   205,   206,     0,
     207,   208,   209,   210,   211,     0,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,   220,   221,     0,     0,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,     0,   237,   238,
       0,     0,     0,     0,     0,     0,     0,   239,   240,   241,
     242,   243,   244,   245,   246,   247,     0,   248,     0,   249,
     250,   251,   252,   253,     0,   254,   255,   256,     0,     0,
     257,   258,   259,   260,   261,     0,   262,   263,   264,     0,
     265,   266,     0,   267,   268,   269,   270,   271,   272,   273,
       0,   274,     0,   275,   276,   277,     0,   278,     0,   279,
       0,     0,     0,   280,  2101,     0,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   299,
     300,   301,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,   319,  2102,
       0,     0,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,     0,   335,   638,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,     0,   348,   349,   350,   351,   352,     0,
       0,   353,   639,     0,     0,   354,   355,   356,     0,     0,
     357,     0,     0,     0,   358,   359,   360,   361,   362,   363,
     364,     0,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,     0,   406,   407,
     408,   409,     0,   410,   411,   412,   413,     0,   414,   415,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,   428,   429,  2103,   430,  2104,   432,
    2105,   434,     0,   435,   436,     0,     0,   437,   438,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,     0,
     447,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,     0,   457,     0,   458,   459,   460,     0,     0,
     461,     0,     0,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,     0,
       0,     0,   478,   186,   187,   188,   189,   190,   191,   192,
     193,     0,   195,   196,   197,     0,     0,     0,     0,     0,
       0,     0,   198,   199,     0,   200,     0,   201,   202,   203,
       0,   204,     0,   205,   206,     0,   207,   208,   209,   210,
     211,     0,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,   220,   221,     0,     0,   222,   223,   224,   225,
     226,   227,     0,   228,   229,   230,   231,   232,   233,     0,
     234,   235,   236,     0,   237,   238,     0,     0,     0,     0,
       0,     0,     0,   239,   240,   241,   242,   243,   244,   245,
     246,   247,     0,   248,     0,   249,   250,   251,   252,   253,
       0,   254,   255,   256,     0,     0,   257,   258,   259,   260,
     261,     0,   262,   263,   264,     0,   265,   266,     0,   267,
     268,   269,   270,   271,   272,   273,     0,   274,     0,   275,
     276,   277,     0,   278,     0,   279,     0,     0,     0,   280,
     281,     0,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   299,   300,   301,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,   319,   320,     0,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,     0,   335,   638,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,     0,
     348,   349,   350,   351,   352,     0,     0,   353,   639,     0,
       0,   354,   355,   356,     0,     0,   357,     0,     0,     0,
     358,   359,   360,   361,   362,   363,   364,     0,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,     0,   406,   407,   408,   409,     0,   410,
     411,   412,   413,     0,   414,   415,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,     0,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,     0,   447,   448,   449,   450,
       0,     0,   451,   452,   453,   454,   455,   456,     0,   457,
       0,   458,   459,   460,     0,     0,   461,     0,     0,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,     0,     0,     0,   478,   186,
     187,   188,   189,   190,   191,   192,   193,     0,   195,   196,
     197,     0,     0,     0,     0,     0,     0,     0,   198,   199,
       0,   200,     0,   201,   202,   203,     0,   204,     0,   205,
     206,     0,   207,   208,   209,   210,   211,     0,     0,   212,
     213,   214,   215,   216,     0,   217,   218,   219,   220,   221,
       0,     0,   222,   223,   224,   225,   226,   227,     0,   228,
     229,   230,   231,   232,   233,     0,   234,   235,   236,     0,
     237,   238,     0,     0,     0,     0,     0,     0,  1781,   239,
     240,   241,   242,   243,   244,   245,   246,   247,     0,   248,
       0,   249,   250,   251,   252,   253,     0,   254,   255,   256,
       0,     0,   257,   258,   259,   260,   261,     0,   262,   263,
     264,     0,   265,   266,     0,   267,   268,   269,   270,   271,
     272,   273,     0,   274,     0,   275,   276,   277,     0,   278,
       0,   279,     0,     0,     0,   280,   281,     0,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   299,   300,   301,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
     319,   320,     0,     0,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,     0,   335,
       0,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,     0,   348,   349,   350,   351,
     352,     0,     0,   353,     0,     0,     0,   354,   355,   356,
       0,     0,   357,     0,     0,     0,   358,   359,   360,   361,
     362,   363,   364,     0,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,     0,
     406,   407,   408,   409,     0,   410,   411,   412,   413,     0,
     414,   415,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,     0,   428,   429,     0,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,     0,   447,   448,   449,   450,  1782,     0,   451,   452,
     453,   454,   455,   456,     0,   457,     0,   458,   459,   460,
       0,     0,   461,     0,     0,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,     0,     0,     0,   478,   186,   187,   188,   189,   190,
     191,   192,   193,  2214,   195,   196,   197,     0,     0,     0,
       0,     0,     0,     0,   198,   199,     0,   200,     0,   201,
     202,   203,     0,   204,     0,   205,   206,     0,   207,   208,
     209,   210,   211,     0,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,   220,   221,     0,     0,   222,   223,
     224,   225,   226,   227,     0,   228,   229,   230,   231,   232,
     233,     0,   234,   235,   236,     0,   237,   238,     0,     0,
       0,     0,     0,     0,     0,   239,   240,   241,   242,   243,
     244,   245,   246,   247,     0,   248,     0,   249,   250,   251,
     252,   253,     0,   254,   255,   256,     0,     0,   257,   258,
     259,   260,   261,     0,   262,   263,   264,     0,   265,   266,
       0,   267,   268,   269,   270,   271,   272,   273,     0,   274,
       0,   275,   276,   277,     0,   278,     0,   279,     0,     0,
       0,   280,   281,     0,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   299,   300,   301,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,   319,   320,     0,     0,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,   335,     0,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,     0,   353,
       0,     0,     0,   354,   355,   356,     0,     0,   357,     0,
       0,     0,   358,   359,   360,   361,   362,   363,   364,     0,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,     0,   406,   407,   408,   409,
       0,   410,   411,   412,   413,     0,   414,   415,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   428,   429,     0,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,     0,   447,   448,
     449,   450,  2215,     0,   451,   452,   453,   454,   455,   456,
       0,   457,     0,   458,   459,   460,     0,     0,   461,     0,
       0,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     0,     0,     0,
     478,   186,   187,   188,   189,   190,   191,   192,   193,  2224,
     195,   196,   197,     0,     0,     0,     0,     0,     0,     0,
     198,   199,     0,   200,     0,   201,   202,   203,     0,   204,
       0,   205,   206,     0,   207,   208,   209,   210,   211,     0,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
     220,   221,     0,     0,   222,   223,   224,   225,   226,   227,
       0,   228,   229,   230,   231,   232,   233,     0,   234,   235,
     236,     0,   237,   238,     0,     0,     0,     0,     0,     0,
       0,   239,   240,   241,   242,   243,   244,   245,   246,   247,
       0,   248,     0,   249,   250,   251,   252,   253,     0,   254,
     255,   256,     0,     0,   257,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,     0,   267,   268,   269,
     270,   271,   272,   273,     0,   274,     0,   275,   276,   277,
       0,   278,     0,   279,     0,     0,     0,   280,   281,     0,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   299,   300,   301,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,   319,   320,     0,     0,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
       0,   335,     0,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,     0,   353,     0,     0,     0,   354,
     355,   356,     0,     0,   357,     0,     0,     0,   358,   359,
     360,   361,   362,   363,   364,     0,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,     0,   406,   407,   408,   409,     0,   410,   411,   412,
     413,     0,   414,   415,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
       0,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,     0,   447,   448,   449,   450,  2225,     0,
     451,   452,   453,   454,   455,   456,     0,   457,     0,   458,
     459,   460,     0,     0,   461,     0,     0,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     0,     0,     0,   478,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,     0,
       0,     0,     0,     0,     0,     0,   198,   199,     0,   200,
       0,   201,   202,   203,     0,   204,     0,   205,   206,     0,
     207,   208,   209,   210,   211,     0,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,   220,   221,     0,     0,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,     0,   237,   238,
       0,     0,     0,     0,     0,     0,     0,   239,   240,   241,
     242,   243,   244,   245,   246,   247,     0,   248,     0,   249,
     250,   251,   252,   253,     0,   254,   255,   256,     0,     0,
     257,   258,   259,   260,   261,     0,   262,   263,   264,     0,
     265,   266,     0,   267,   268,   269,   270,   271,   272,   273,
       0,   274,     0,   275,   276,   277,     0,   278,     0,   279,
       0,     0,     0,   280,   281,     0,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   299,
     300,   301,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,   319,   320,
       0,     0,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,     0,   335,     0,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,     0,   348,   349,   350,   351,   352,     0,
       0,   353,     0,     0,     0,   354,   355,   356,     0,     0,
     357,     0,     0,     0,   358,   359,   360,   361,   362,   363,
     364,     0,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,     0,   406,   407,
     408,   409,     0,   410,   411,   412,   413,     0,   414,   415,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,   428,   429,     0,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,     0,
     447,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,     0,   457,     0,   458,   459,   460,     0,     0,
     461,     0,     0,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,     0,
       0,     0,   478,   186,   187,   188,   189,   190,   191,   192,
     193,   521,   195,   196,   197,     0,     0,     0,     0,     0,
       0,     0,   198,   199,     0,   200,     0,   201,   202,   203,
       0,   204,     0,   205,   206,     0,   207,   208,   209,   210,
     211,     0,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,   220,   221,     0,     0,   222,   223,   224,   225,
     226,   227,     0,   228,   229,   230,   231,   232,   233,     0,
     234,   235,   236,     0,   237,   238,     0,     0,     0,     0,
       0,     0,     0,   239,   240,   241,   242,   243,   244,   245,
     246,   247,     0,   248,     0,   249,   250,   251,   252,   253,
       0,   254,   255,   256,     0,     0,   257,   258,   259,   260,
     261,     0,   262,   263,   264,     0,   265,   266,     0,   267,
     268,   269,   270,   271,   272,   273,     0,   274,     0,   275,
     276,   277,     0,   278,     0,   279,     0,     0,     0,   280,
     281,     0,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   299,   300,   301,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,   319,   320,     0,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,     0,   335,     0,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,     0,
     348,   349,   350,   351,   352,     0,     0,   353,     0,     0,
       0,   354,   355,   356,     0,     0,   357,     0,     0,     0,
     358,   359,   360,   361,   362,   363,   364,     0,   365,   366,
     367,   368,   369,   522,   371,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,     0,   406,   407,   408,   409,     0,   410,
     411,   412,   413,     0,   414,   415,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,     0,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,     0,   447,   448,   449,   450,
       0,     0,   451,   452,   453,   454,   455,   456,     0,   457,
       0,   458,   459,   460,     0,     0,   461,     0,     0,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,     0,     0,     0,   478,   186,
     187,   188,   189,   190,   191,   192,   193,   604,   195,   196,
     197,     0,     0,     0,     0,     0,     0,     0,   198,   199,
       0,   200,     0,   201,   202,   203,     0,   204,     0,   205,
     206,     0,   207,   208,   209,   210,   211,     0,     0,   212,
     213,   214,   215,   216,     0,   217,   218,   219,   220,   221,
       0,     0,   222,   223,   224,   225,   226,   227,     0,   228,
     229,   230,   231,   232,   233,     0,   234,   235,   236,     0,
     237,   238,     0,     0,     0,     0,     0,     0,     0,   239,
     240,   241,   242,   243,   244,   245,   246,   247,     0,   248,
       0,   249,   250,   251,   252,   253,     0,   254,   255,   256,
       0,     0,   257,   258,   259,   260,   261,     0,   262,   263,
     264,     0,   265,   266,     0,   267,   268,   269,   270,   271,
     272,   273,     0,   274,     0,   275,   276,   277,     0,   278,
       0,   279,     0,     0,     0,   280,   281,     0,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   299,   300,   301,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
     319,   320,     0,     0,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,     0,   335,
       0,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,     0,   348,   349,   350,   351,
     352,     0,     0,   353,     0,     0,     0,   354,   355,   356,
       0,     0,   357,     0,     0,     0,   358,   359,   360,   361,
     362,   363,   364,     0,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,     0,
     406,   407,   408,   605,     0,   410,   411,   412,   413,     0,
     414,   415,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,     0,   428,   429,     0,   430,
     431,   432,   433,   434,     0,   606,   436,     0,     0,   607,
     438,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,     0,   447,   448,   449,   450,     0,     0,   451,   452,
     453,   454,   455,   456,     0,   457,     0,   458,   459,   460,
       0,     0,   461,     0,     0,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,     0,     0,     0,   478,   186,   187,   188,   189,   190,
     191,   192,   193,   632,   195,   196,   197,     0,     0,     0,
       0,     0,     0,     0,   198,   199,     0,   200,     0,   201,
     202,   203,     0,   204,     0,   205,   206,     0,   207,   208,
     209,   210,   211,     0,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,   220,   221,     0,     0,   222,   223,
     224,   225,   226,   227,     0,   228,   229,   230,   231,   232,
     233,     0,   234,   235,   236,     0,   237,   238,     0,     0,
       0,     0,     0,     0,     0,   239,   240,   241,   242,   243,
     244,   245,   246,   247,     0,   248,     0,   249,   250,   251,
     252,   253,     0,   254,   255,   256,     0,     0,   257,   258,
     259,   260,   261,     0,   262,   263,   264,     0,   265,   266,
       0,   267,   268,   269,   270,   271,   272,   273,     0,   274,
       0,   275,   276,   277,     0,   278,     0,   279,     0,     0,
       0,   280,   281,     0,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   299,   300,   301,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,   319,   320,     0,     0,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,   335,     0,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,     0,   353,
       0,     0,     0,   354,   355,   356,     0,     0,   357,     0,
       0,     0,   358,   359,   360,   361,   362,   363,   364,     0,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,     0,   406,   407,   408,   633,
       0,   410,   411,   412,   413,     0,   414,   415,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   428,   429,     0,   430,   431,   432,   433,   434,
       0,   634,   436,     0,     0,   635,   438,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,     0,   447,   448,
     449,   450,     0,     0,   451,   452,   453,   454,   455,   456,
       0,   457,     0,   458,   459,   460,     0,     0,   461,     0,
       0,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     0,     0,     0,
     478,   186,   187,   188,   189,   190,   191,   192,   193,   811,
     195,   196,   197,     0,     0,     0,     0,     0,     0,     0,
     198,   199,     0,   200,     0,   201,   202,   203,     0,   204,
       0,   205,   206,     0,   207,   208,   209,   210,   211,     0,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
     220,   221,     0,     0,   222,   223,   224,   225,   226,   227,
       0,   228,   229,   230,   231,   232,   233,     0,   234,   235,
     236,     0,   237,   238,     0,     0,     0,     0,     0,     0,
       0,   239,   240,   241,   242,   243,   244,   245,   246,   247,
       0,   248,     0,   249,   250,   251,   252,   253,     0,   254,
     255,   256,     0,     0,   257,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,     0,   267,   268,   269,
     270,   271,   272,   273,     0,   274,     0,   275,   276,   277,
       0,   278,     0,   279,     0,     0,     0,   280,   281,     0,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   299,   300,   301,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,   319,   320,     0,     0,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
       0,   335,     0,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,     0,   353,     0,     0,     0,   354,
     355,   356,     0,     0,   357,     0,     0,     0,   358,   359,
     360,   361,   362,   363,   364,     0,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,     0,   406,   407,   408,   409,     0,   410,   411,   412,
     413,     0,   414,   415,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
       0,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,     0,   447,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,     0,   457,     0,   458,
     459,   460,     0,     0,   461,     0,     0,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     0,     0,     0,   478,   186,   187,   188,
     189,   190,   191,   192,   193,     0,   195,   196,   197,     0,
       0,     0,     0,     0,     0,     0,   198,   199,     0,   200,
    1006,   201,   202,   203,     0,   204,     0,   205,   206,     0,
     207,   208,   209,   210,   211,     0,     0,   620,   213,   214,
     215,  1007,     0,   217,   218,   219,   220,   221,     0,     0,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,     0,   237,   238,
       0,     0,     0,     0,     0,     0,     0,   239,   240,   241,
     242,   243,   244,   245,   246,   247,     0,   248,     0,   249,
     250,   251,   252,   253,     0,   254,   255,   256,     0,     0,
     257,   258,   259,   260,   261,     0,   262,   263,   264,     0,
     265,   266,     0,   267,   268,   269,   270,   271,   272,   273,
       0,   274,     0,   275,   276,   277,     0,   278,     0,   279,
       0,     0,     0,   280,   281,     0,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   299,
     300,   301,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,   319,   320,
       0,     0,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   623,   334,     0,   335,     0,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,     0,   348,   349,   350,   351,   352,     0,
       0,   353,     0,     0,     0,   354,   355,   356,     0,     0,
     357,     0,     0,     0,   358,   359,   360,   361,   362,   363,
     364,     0,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,     0,   624,   396,   397,   398,
     399,   400,   625,   402,   403,   404,   405,     0,   406,   407,
     408,   997,     0,   410,   411,   412,   413,     0,   414,   415,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,   428,   429,     0,   430,   431,   432,
     433,   434,     0,   627,   436,     0,     0,   628,   438,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,     0,
     447,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,     0,   457,     0,   458,   459,   460,     0,     0,
     461,     0,     0,   462,   463,   464,   465,   629,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,     0,
       0,     0,   478,   186,   187,   188,   189,   190,   191,   192,
     193,     0,   195,   196,   197,     0,     0,     0,     0,     0,
       0,     0,   198,   199,     0,   200,   674,   201,   202,   203,
     675,  1205,   676,  1206,  1207,     0,   207,   208,   209,   210,
     211,     0,     0,   212,   213,  1208,  1209,   216,     0,   217,
     218,   219,   220,     0,     0,     0,   222,   223,   224,   225,
     226,   227,     0,   228,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   677,   237,   238,     0,     0,     0,   678,
       0,     0,     0,   239,   240,   241,   242,   243,   244,  1210,
    1211,   247,     0,   248,     0,   249,   250,   251,   252,   253,
       0,   254,   255,   256,     0,     0,   257,   258,   916,   260,
     261,     0,   262,   263,   264,     0,   265,   266,     0,   267,
     268,   269,     0,   271,   272,     0,     0,   274,     0,   275,
    1212,   277,     0,   278,     0,   279,   679,     0,   680,   280,
     281,     0,   282,     0,     0,   284,     0,   285,   286,   287,
     288,   289,   681,   290,   291,   292,  1698,   293,   294,   295,
     296,   297,   298,     0,   682,  1699,   300,   301,   302,   303,
    1213,  1214,     0,  1215,     0,   307,   683,   684,   308,   685,
     309,   310,   311,   312,   313,   314,   315,     0,     0,   686,
     317,   687,     0,   318,   319,   320,     0,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,  1216,   688,  1217,     0,   336,   337,   338,   339,   340,
     341,   342,     0,   344,     0,   345,   346,   689,   347,     0,
       0,   349,  1218,   351,   352,     0,     0,   353,     0,     0,
       0,   354,   355,   356,     0,     0,  1700,   690,   691,   692,
       0,   359,   360,   361,   362,   363,   364,     0,   365,     0,
     367,     0,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,  1219,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   693,   395,   396,     0,   398,   399,   400,   401,   402,
     403,   404,   405,     0,   406,   407,   408,   409,     0,   410,
    1701,   412,   413,   694,   414,  1221,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   427,     0,
     428,   429,     0,   430,   431,   432,   433,   434,     0,  1222,
    1223,     0,     0,   437,     0,   439,     0,     0,   441,   442,
     443,   444,   445,   446,     0,     0,   447,   448,   449,   450,
       0,     0,   451,   452,   453,   454,     0,  1224,  1702,   457,
     695,   458,   459,   460,     0,     0,   461,     0,     0,   462,
     463,   464,   465,   466,     0,     0,     0,     0,     0,     0,
       0,     0,   475,   476,   477,     0,     0,     0,  1225,   186,
     187,   188,   189,   190,   191,   192,   193,     0,   195,   196,
     197,     0,     0,     0,     0,     0,  2439,     0,   198,   199,
       0,   200,     0,   201,   202,   203,     0,   204,     0,   205,
     206,     0,   207,   208,   209,   210,   211,     0,     0,   212,
     213,   214,   215,   216,     0,   217,   218,   219,   220,   221,
       0,     0,   222,   223,   224,   225,   226,   227,     0,   228,
     229,   230,   231,   232,   233,     0,   234,   235,   236,     0,
     237,   238,     0,     0,     0,     0,     0,     0,     0,   239,
     240,   241,   242,   243,   244,   245,   246,   247,     0,   248,
       0,   249,   250,   251,   252,   253,     0,   254,   255,   256,
       0,     0,   257,   258,   259,   260,   261,     0,   262,   263,
     264,     0,   265,   266,     0,   267,   268,   269,   270,   271,
     272,   273,     0,   274,     0,   275,   276,   277,     0,   278,
       0,   279,     0,     0,     0,   280,   281,     0,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   299,   300,   301,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
     319,   320,     0,     0,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,     0,   335,
       0,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,     0,   348,   349,   350,   351,
     352,     0,     0,   353,     0,     0,     0,   354,   355,   356,
       0,     0,   357,     0,     0,     0,   358,   359,   360,   361,
     362,   363,   364,     0,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,     0,
     406,   407,   408,   409,     0,   410,   411,   412,   413,     0,
     414,   415,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,     0,   428,   429,     0,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,     0,   447,   448,   449,   450,     0,     0,   451,   452,
     453,   454,   455,   456,     0,   457,     0,   458,   459,   460,
       0,     0,   461,     0,     0,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,     0,     0,     0,   478,   186,   187,   188,   189,   190,
     191,   192,   193,     0,   195,   196,   197,     0,     0,     0,
       0,     0,  2452,     0,   198,   199,     0,   200,     0,   201,
     202,   203,     0,   204,     0,   205,   206,     0,   207,   208,
     209,   210,   211,     0,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,   220,   221,     0,     0,   222,   223,
     224,   225,   226,   227,     0,   228,   229,   230,   231,   232,
     233,     0,   234,   235,   236,     0,   237,   238,     0,     0,
       0,     0,     0,     0,     0,   239,   240,   241,   242,   243,
     244,   245,   246,   247,     0,   248,     0,   249,   250,   251,
     252,   253,     0,   254,   255,   256,     0,     0,   257,   258,
     259,   260,   261,     0,   262,   263,   264,     0,   265,   266,
       0,   267,   268,   269,   270,   271,   272,   273,     0,   274,
       0,   275,   276,   277,     0,   278,     0,   279,     0,     0,
       0,   280,   281,     0,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   299,   300,   301,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,   319,   320,     0,     0,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,   335,     0,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,     0,   353,
       0,     0,     0,   354,   355,   356,     0,     0,   357,     0,
       0,     0,   358,   359,   360,   361,   362,   363,   364,     0,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,     0,   406,   407,   408,   409,
       0,   410,   411,   412,   413,     0,   414,   415,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   428,   429,     0,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,     0,   447,   448,
     449,   450,     0,     0,   451,   452,   453,   454,   455,   456,
       0,   457,     0,   458,   459,   460,     0,     0,   461,     0,
       0,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     0,     0,     0,
     478,   186,   187,   188,   189,   190,   191,   192,   193,     0,
     195,   196,   197,     0,     0,     0,     0,     0,     0,     0,
     198,   199,     0,   200,     0,   201,   202,   203,     0,   204,
       0,   205,   206,     0,   207,   208,   209,   210,   211,     0,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
     220,   221,     0,     0,   222,   223,   224,   225,   226,   227,
       0,   228,   229,   230,   231,   232,   233,     0,   234,   235,
     236,     0,   237,   238,     0,     0,     0,     0,     0,     0,
       0,   239,   240,   241,   242,   243,   244,   245,   246,   247,
       0,   248,     0,   249,   250,   251,   252,   253,     0,   254,
     255,   256,     0,     0,   257,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,     0,   267,   268,   269,
     270,   271,   272,   273,     0,   274,     0,   275,   276,   277,
       0,   278,     0,   279,     0,     0,     0,   280,   281,     0,
     282,   283,  2486,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   299,   300,   301,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,   319,   320,     0,     0,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
       0,   335,     0,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,     0,   353,     0,     0,     0,   354,
     355,   356,     0,     0,   357,     0,     0,     0,   358,   359,
     360,   361,   362,   363,   364,     0,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,     0,   406,   407,   408,   409,     0,   410,   411,   412,
     413,     0,   414,   415,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
       0,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,     0,   447,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,     0,   457,     0,   458,
     459,   460,     0,     0,   461,     0,     0,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     0,     0,     0,   478,   186,   187,   188,
     189,   190,   191,   192,   193,     0,   195,   196,   197,     0,
       0,     0,     0,     0,     0,     0,   198,   199,     0,   200,
       0,   201,   202,   203,     0,   204,     0,   205,   206,     0,
     207,   208,   209,   210,   211,     0,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,   220,   221,     0,     0,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,     0,   237,   238,
       0,     0,     0,     0,     0,     0,     0,   239,   240,   241,
     242,   243,   244,   245,   246,   247,  3108,   248,     0,   249,
     250,   251,   252,   253,     0,   254,   255,   256,     0,     0,
     257,   258,   259,   260,   261,     0,   262,   263,   264,     0,
     265,   266,     0,   267,   268,   269,   270,   271,   272,   273,
       0,   274,     0,   275,   276,   277,     0,   278,     0,   279,
       0,     0,     0,   280,   281,     0,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   299,
     300,   301,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,   319,   320,
       0,     0,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,     0,   335,     0,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,     0,   348,   349,   350,   351,   352,     0,
       0,   353,     0,     0,     0,   354,   355,   356,     0,     0,
     357,     0,     0,     0,   358,   359,   360,   361,   362,   363,
     364,     0,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,     0,   406,   407,
     408,   409,     0,   410,   411,   412,   413,     0,   414,   415,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,   428,   429,     0,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,     0,
     447,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,     0,   457,     0,   458,   459,   460,     0,     0,
     461,     0,     0,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,     0,
       0,     0,   478,   186,   187,   188,   189,   190,   191,   192,
     193,     0,   195,   196,   197,     0,     0,     0,     0,     0,
       0,     0,   198,   199,     0,   200,     0,   201,   202,   203,
       0,   204,     0,   205,   206,     0,   207,   208,   209,   210,
     211,     0,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,   220,   221,     0,     0,   222,   223,   224,   225,
     226,   227,     0,   228,   229,   230,   231,   232,   233,     0,
     234,   235,   236,     0,   237,   238,     0,     0,     0,     0,
       0,     0,     0,   239,   240,   241,   242,   243,   244,   245,
     246,   247,  3110,   248,     0,   249,   250,   251,   252,   253,
       0,   254,   255,   256,     0,     0,   257,   258,   259,   260,
     261,     0,   262,   263,   264,     0,   265,   266,     0,   267,
     268,   269,   270,   271,   272,   273,     0,   274,     0,   275,
     276,   277,     0,   278,     0,   279,     0,     0,     0,   280,
     281,     0,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   299,   300,   301,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,   319,   320,     0,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,     0,   335,     0,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,     0,
     348,   349,   350,   351,   352,     0,     0,   353,     0,     0,
       0,   354,   355,   356,     0,     0,   357,     0,     0,     0,
     358,   359,   360,   361,   362,   363,   364,     0,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,     0,   406,   407,   408,   409,     0,   410,
     411,   412,   413,     0,   414,   415,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,     0,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,     0,   447,   448,   449,   450,
       0,     0,   451,   452,   453,   454,   455,   456,     0,   457,
       0,   458,   459,   460,     0,     0,   461,     0,     0,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,     0,     0,     0,   478,   186,
     187,   188,   189,   190,   191,   192,   193,     0,   195,   196,
     197,     0,     0,     0,     0,     0,     0,     0,   198,   199,
       0,   200,     0,   201,   202,   203,     0,   204,     0,   205,
     206,     0,   207,   208,   209,   210,   211,     0,     0,   212,
     213,   214,   215,   216,     0,   217,   218,   219,   220,   221,
       0,     0,   222,   223,   224,   225,   226,   227,     0,   228,
     229,   230,   231,   232,   233,     0,   234,   235,   236,     0,
     237,   238,     0,     0,     0,     0,     0,     0,     0,   239,
     240,   241,   242,   243,   244,   245,   246,   247,  3112,   248,
       0,   249,   250,   251,   252,   253,     0,   254,   255,   256,
       0,     0,   257,   258,   259,   260,   261,     0,   262,   263,
     264,     0,   265,   266,     0,   267,   268,   269,   270,   271,
     272,   273,     0,   274,     0,   275,   276,   277,     0,   278,
       0,   279,     0,     0,     0,   280,   281,     0,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   299,   300,   301,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
     319,   320,     0,     0,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,     0,   335,
       0,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,     0,   348,   349,   350,   351,
     352,     0,     0,   353,     0,     0,     0,   354,   355,   356,
       0,     0,   357,     0,     0,     0,   358,   359,   360,   361,
     362,   363,   364,     0,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,     0,
     406,   407,   408,   409,     0,   410,   411,   412,   413,     0,
     414,   415,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,     0,   428,   429,     0,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,     0,   447,   448,   449,   450,     0,     0,   451,   452,
     453,   454,   455,   456,     0,   457,     0,   458,   459,   460,
       0,     0,   461,     0,     0,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,     0,     0,     0,   478,   186,   187,   188,   189,   190,
     191,   192,   193,     0,   195,   196,   197,     0,     0,     0,
       0,     0,     0,     0,   198,   199,     0,   200,     0,   201,
     202,   203,     0,   204,     0,   205,   206,     0,   207,   208,
     209,   210,   211,     0,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,   220,   221,     0,     0,   222,   223,
     224,   225,   226,   227,     0,   228,   229,   230,   231,   232,
     233,     0,   234,   235,   236,     0,   237,   238,     0,     0,
       0,     0,     0,     0,     0,   239,   240,   241,   242,   243,
     244,   245,   246,   247,     0,   248,     0,   249,   250,   251,
     252,   253,     0,   254,   255,   256,     0,     0,   257,   258,
     259,   260,   261,     0,   262,   263,   264,     0,   265,   266,
       0,   267,   268,   269,   270,   271,   272,   273,     0,   274,
       0,   275,   276,   277,     0,   278,     0,   279,     0,     0,
       0,   280,   281,     0,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   299,   300,   301,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,   319,   320,     0,     0,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,   335,     0,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,     0,   353,
       0,     0,     0,   354,   355,   356,     0,     0,   357,     0,
       0,     0,   358,   359,   360,   361,   362,   363,   364,     0,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,     0,   406,   407,   408,   409,
       0,   410,   411,   412,   413,     0,   414,   415,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   428,   429,     0,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,     0,   447,   448,
     449,   450,     0,  3453,   451,   452,   453,   454,   455,   456,
       0,   457,     0,   458,   459,   460,     0,     0,   461,     0,
       0,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     0,     0,     0,
     478,   186,   187,   188,   189,   190,   191,   192,   193,     0,
     195,   196,   197,     0,     0,     0,     0,     0,     0,     0,
     198,   199,     0,   200,     0,   201,   202,   203,     0,   204,
       0,   205,   206,     0,   207,   208,   209,   210,   211,     0,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
     220,   221,     0,     0,   222,   223,   224,   225,   226,   227,
       0,   228,   229,   230,   231,   232,   233,     0,   234,   235,
     236,     0,   237,   238,     0,     0,     0,     0,     0,     0,
       0,   239,   240,   241,   242,   243,   244,   245,   246,   247,
       0,   248,     0,   249,   250,   251,   252,   253,     0,   254,
     255,   256,     0,     0,   257,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,     0,   267,   268,   269,
     270,   271,   272,   273,     0,   274,     0,   275,   276,   277,
       0,   278,     0,   279,     0,     0,     0,   280,   281,     0,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   299,   300,   301,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,   319,   320,     0,     0,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
       0,   335,     0,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,     0,   353,     0,     0,     0,   354,
     355,   356,     0,     0,   357,     0,     0,     0,   358,   359,
     360,   361,   362,   363,   364,     0,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,     0,   406,   407,   408,   409,     0,   410,   411,   412,
     413,     0,   414,   415,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
       0,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,     0,   447,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,     0,   457,     0,   458,
     459,   460,     0,     0,   461,     0,     0,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     0,     0,     0,   478,   186,   187,   188,
     189,   190,   191,   192,   193,     0,   195,   196,   197,     0,
       0,     0,     0,     0,     0,     0,   198,   199,     0,   200,
       0,   201,   202,   203,     0,   204,     0,   205,   206,     0,
     207,   208,   209,   210,   211,     0,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,   220,   221,     0,     0,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,     0,   237,   238,
       0,     0,     0,     0,     0,     0,     0,   239,   240,   241,
     242,   243,   244,   245,   246,   247,     0,   248,     0,   249,
     250,   251,   252,   253,     0,   254,   255,   256,     0,     0,
     257,   258,   259,   260,   261,     0,   262,   263,   264,     0,
     265,   266,     0,   267,   268,   269,   270,   271,   272,   273,
       0,   274,     0,   275,   276,   277,     0,   278,     0,   279,
       0,     0,     0,   280,   281,     0,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   299,
     300,   301,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,   319,   320,
       0,     0,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,     0,   335,     0,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,     0,   348,   349,   350,   351,   352,     0,
       0,   353,     0,     0,     0,   354,   355,   356,     0,     0,
     357,     0,     0,     0,   358,   359,   360,   361,   362,   363,
     364,     0,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,     0,   406,   407,
     408,   409,     0,   410,   411,   412,   413,     0,   414,   415,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,   428,   429,     0,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   594,   438,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,     0,
     447,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,     0,   457,     0,   458,   459,   460,     0,     0,
     461,     0,     0,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,     0,
       0,     0,   478,   186,   187,   188,   189,   190,   191,   192,
     193,     0,   195,   196,   197,     0,     0,     0,     0,     0,
       0,     0,   198,   199,     0,   200,     0,   201,   202,   203,
       0,   204,     0,   205,   206,     0,   207,   208,   209,   210,
     211,     0,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,   220,   221,     0,     0,   222,   223,   224,   225,
     226,   227,     0,   228,   229,   230,   231,   232,   233,     0,
     234,   235,   236,     0,   237,   238,     0,     0,     0,     0,
       0,     0,     0,   239,   240,   241,   242,   243,   244,   245,
     246,   247,     0,   248,     0,   249,   250,   251,   252,   253,
       0,   254,   255,   256,     0,     0,   257,   258,   259,   260,
     261,     0,   262,   263,   264,     0,   265,   266,     0,   267,
     268,   269,   270,   271,   272,   273,     0,   274,     0,   275,
     276,   277,     0,   278,     0,   279,     0,     0,     0,   280,
     281,     0,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   299,   300,   301,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,   319,   320,     0,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,     0,   335,     0,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,     0,
     348,   349,   350,   351,   352,     0,     0,   353,     0,     0,
       0,   354,   355,   356,     0,     0,   357,     0,     0,     0,
     358,   359,   360,   361,   362,   363,   364,     0,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,     0,   395,   396,   397,   398,   399,   602,   401,   402,
     403,   404,   405,     0,   406,   407,   408,   409,     0,   410,
     411,   412,   413,     0,   414,   415,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,     0,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,     0,   447,   448,   449,   450,
       0,     0,   451,   452,   453,   454,   455,   456,     0,   457,
       0,   458,   459,   460,     0,     0,   461,     0,     0,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,     0,     0,     0,   478,   186,
     187,   188,   189,   190,   191,   192,   193,     0,   195,   196,
     197,     0,     0,     0,     0,     0,     0,     0,   198,   199,
       0,   200,     0,   201,   202,   203,     0,   204,     0,   205,
     206,     0,   207,   208,   209,   210,   211,     0,     0,   620,
     213,   214,   215,   216,     0,   217,   218,   219,   220,   221,
       0,     0,   222,   223,   224,   225,   226,   227,     0,   621,
     229,   230,   231,   232,   233,     0,   234,   235,   236,     0,
     237,   238,     0,     0,     0,     0,     0,     0,     0,   239,
     240,   241,   242,   243,   244,   245,   246,   247,     0,   248,
       0,   249,   250,   251,   252,   253,     0,   254,   255,   256,
       0,     0,   257,   258,   259,   260,   261,     0,   262,   263,
     264,     0,   265,   266,     0,   267,   268,   269,   270,   271,
     272,   273,     0,   274,     0,   275,   276,   277,     0,   278,
       0,   279,     0,     0,     0,   280,   281,     0,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   299,   300,   301,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
     319,   622,     0,     0,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   623,   334,     0,   335,
       0,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,     0,   348,   349,   350,   351,
     352,     0,     0,   353,     0,     0,     0,   354,   355,   356,
       0,     0,   357,     0,     0,     0,   358,   359,   360,   361,
     362,   363,   364,     0,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,     0,   624,   396,
     397,   398,   399,   400,   625,   402,   403,   404,   405,     0,
     406,   407,   408,   626,     0,   410,   411,   412,   413,     0,
     414,   415,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,     0,   428,   429,     0,   430,
     431,   432,   433,   434,     0,   627,   436,     0,     0,   628,
     438,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,     0,   447,   448,   449,   450,     0,     0,   451,   452,
     453,   454,   455,   456,     0,   457,     0,   458,   459,   460,
       0,     0,   461,     0,     0,   462,   463,   464,   465,   629,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,     0,     0,     0,   478,   186,   187,   188,   189,   190,
     191,   192,   193,     0,   195,   196,   197,     0,     0,     0,
       0,     0,     0,     0,   198,   199,     0,   200,     0,   201,
     202,   203,     0,   204,     0,   205,   206,     0,   207,   208,
     209,   210,   211,     0,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,   220,   221,     0,     0,   222,   223,
     224,   225,   226,   227,     0,   228,   229,   230,   231,   232,
     233,     0,   234,   235,   236,     0,   237,   238,     0,     0,
       0,     0,     0,     0,     0,   239,   240,   241,   242,   243,
     244,   245,   246,   247,     0,   248,     0,   249,   250,   251,
     252,   253,     0,   254,   255,   256,     0,     0,   257,   258,
     259,   260,   261,     0,   262,   263,   264,     0,   265,   266,
       0,   267,   268,   269,   270,   271,   272,   273,     0,   274,
       0,   275,   276,   277,     0,   278,     0,   279,     0,     0,
       0,   280,   281,     0,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   299,   300,   301,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,   319,   320,     0,     0,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,   335,     0,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,     0,   353,
       0,     0,     0,   354,   355,   356,     0,     0,   357,     0,
       0,     0,   358,   359,   360,   361,   362,   363,   364,     0,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   655,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,     0,   406,   407,   408,   409,
       0,   410,   411,   412,   413,     0,   414,   415,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   428,   429,     0,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,     0,   447,   448,
     449,   450,     0,     0,   451,   452,   453,   454,   455,   456,
       0,   457,     0,   458,   459,   460,     0,     0,   461,     0,
       0,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     0,     0,     0,
     478,   186,   187,   188,   189,   190,   191,   192,   193,     0,
     195,   196,   197,     0,     0,     0,     0,     0,     0,     0,
     198,   199,     0,   200,     0,   201,   202,   203,     0,   204,
       0,   205,   206,     0,   207,   208,   209,   210,   211,     0,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
     220,   221,     0,     0,   222,   223,   224,   225,   226,   227,
       0,   228,   229,   230,   231,   232,   233,     0,   234,   235,
     236,     0,   237,   238,     0,     0,     0,     0,     0,     0,
       0,   239,   240,   241,   242,   243,   244,   245,   246,   247,
       0,   248,     0,   249,   250,   251,   252,   253,     0,   254,
     255,   256,     0,     0,   257,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,     0,   267,   268,   269,
     270,   271,   272,   273,     0,   274,     0,   275,   276,   277,
       0,   278,     0,   279,     0,     0,     0,   280,   281,     0,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   299,   300,   301,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,   319,   320,     0,     0,   321,   322,   323,   739,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
       0,   335,     0,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,     0,   353,     0,     0,     0,   354,
     355,   356,     0,     0,   357,     0,     0,     0,   358,   359,
     360,   361,   362,   363,   364,     0,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,     0,   406,   407,   408,   409,     0,   410,   411,   412,
     413,     0,   414,   415,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
       0,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,     0,   447,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,     0,   457,     0,   458,
     459,   460,     0,     0,   461,     0,     0,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     0,     0,     0,   478,   186,   187,   188,
     189,   190,   191,   192,   193,     0,   195,   196,   197,     0,
       0,     0,     0,     0,     0,     0,   198,   199,     0,   200,
       0,   201,   202,   203,     0,   204,     0,   205,   206,     0,
     207,   208,   209,   210,   211,     0,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,   220,   221,     0,     0,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,     0,   237,   238,
       0,     0,     0,     0,     0,     0,     0,   239,   240,   241,
     242,   243,   244,   245,   246,   247,     0,   248,     0,   249,
     250,   251,   252,   253,     0,   254,   255,   256,     0,     0,
     257,   258,   259,   260,   261,     0,   262,   263,   264,     0,
     265,   266,     0,   267,   268,   269,   270,   271,   272,   273,
       0,   274,     0,   275,   276,   277,     0,   278,     0,   279,
       0,     0,     0,   280,   281,     0,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   299,
     300,   301,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,   319,   320,
       0,     0,   321,   322,   323,   801,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,     0,   335,     0,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,     0,   348,   349,   350,   351,   352,     0,
       0,   353,     0,     0,     0,   354,   355,   356,     0,     0,
     357,     0,     0,     0,   358,   359,   360,   361,   362,   363,
     364,     0,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,     0,   406,   407,
     408,   409,     0,   410,   411,   412,   413,     0,   414,   415,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,   428,   429,     0,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,     0,
     447,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,     0,   457,     0,   458,   459,   460,     0,     0,
     461,     0,     0,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,     0,
       0,     0,   478,   186,   187,   188,   189,   190,   191,   192,
     193,     0,   195,   196,   197,     0,     0,     0,     0,     0,
       0,     0,   198,   199,     0,   200,     0,   201,   202,   203,
       0,   204,     0,   205,   206,     0,   207,   208,   209,   210,
     211,     0,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,   220,   221,     0,     0,   222,   223,   224,   225,
     226,   227,     0,   228,   229,   230,   231,   232,   233,     0,
     234,   235,   236,     0,   237,   238,     0,     0,     0,     0,
       0,     0,     0,   239,   240,   241,   242,   243,   244,   245,
     246,   247,     0,   248,     0,   249,   250,   251,   252,   253,
       0,   254,   255,   256,     0,     0,   257,   258,   259,   260,
     261,     0,   262,   263,   264,     0,   265,   266,     0,   267,
     268,   269,   270,   271,   272,   273,     0,   274,     0,   275,
     276,   277,     0,   278,     0,   279,     0,     0,     0,   280,
     281,     0,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   820,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   299,   300,   301,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,   319,   320,     0,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,     0,   335,     0,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,     0,
     348,   349,   350,   351,   352,     0,     0,   353,     0,     0,
       0,   354,   355,   356,     0,     0,   357,     0,     0,     0,
     358,   359,   360,   361,   362,   363,   364,     0,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,     0,   406,   407,   408,   409,     0,   410,
     411,   412,   413,     0,   414,   415,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,     0,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,     0,   447,   448,   449,   450,
       0,     0,   451,   452,   453,   454,   455,   456,     0,   457,
       0,   458,   459,   460,     0,     0,   461,     0,     0,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,     0,     0,     0,   478,   186,
     187,   188,   189,   190,   191,   192,   193,     0,   195,   196,
     197,     0,     0,     0,     0,     0,     0,     0,   198,   199,
       0,   200,     0,   201,   202,   203,     0,   204,     0,   205,
     206,     0,   207,   208,   209,   210,   211,     0,     0,   212,
     213,   214,   215,   216,     0,   217,   218,   219,   220,   221,
       0,     0,   222,   223,   224,   225,   226,   227,     0,   228,
     229,   230,   231,   232,   233,     0,   234,   235,   236,     0,
     237,   238,     0,     0,     0,     0,     0,     0,     0,   239,
     240,   241,   242,   243,   244,   245,   246,   247,     0,   248,
       0,   249,   250,   251,   252,   253,     0,   254,   255,   256,
       0,     0,   257,   258,   259,   260,   261,     0,   262,   263,
     264,     0,   265,   266,     0,   267,   268,   269,   270,   271,
     272,   273,     0,   274,     0,   275,   276,   277,     0,   278,
       0,   279,     0,     0,     0,   280,   281,     0,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   825,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   299,   300,   301,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
     319,   320,     0,     0,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,     0,   335,
       0,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,     0,   348,   349,   350,   351,
     352,     0,     0,   353,     0,     0,     0,   354,   355,   356,
       0,     0,   357,     0,     0,     0,   358,   359,   360,   361,
     362,   363,   364,     0,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,     0,
     406,   407,   408,   409,     0,   410,   411,   412,   413,     0,
     414,   415,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,     0,   428,   429,     0,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,     0,   447,   448,   449,   450,     0,     0,   451,   452,
     453,   454,   455,   456,     0,   457,     0,   458,   459,   460,
       0,     0,   461,     0,     0,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,     0,     0,     0,   478,   186,   187,   188,   189,   190,
     191,   192,   193,     0,   195,   196,   197,     0,     0,     0,
       0,     0,     0,     0,   198,   199,     0,   200,     0,   201,
     202,   203,     0,   204,     0,   205,   206,     0,   207,   208,
     209,   210,   211,     0,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,   220,   221,     0,     0,   222,   223,
     224,   225,   226,   227,     0,   228,   229,   230,   231,   232,
     233,     0,   234,   235,   236,     0,   237,   238,     0,     0,
       0,     0,     0,     0,     0,   239,   240,   241,   242,   243,
     244,   245,   246,   247,     0,   248,     0,   249,   250,   251,
     252,   253,     0,   254,   255,   256,     0,     0,   257,   258,
     259,   260,   261,     0,   262,   263,   264,     0,   265,   266,
       0,   267,   268,   269,   270,   271,   272,   273,     0,   274,
       0,   275,   276,   277,     0,   278,     0,   279,     0,     0,
       0,   280,   281,     0,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   833,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   299,   300,   301,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,   319,   320,     0,     0,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,   335,     0,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,     0,   353,
       0,     0,     0,   354,   355,   356,     0,     0,   357,     0,
       0,     0,   358,   359,   360,   361,   362,   363,   364,     0,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,     0,   406,   407,   408,   409,
       0,   410,   411,   412,   413,     0,   414,   415,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   428,   429,     0,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,     0,   447,   448,
     449,   450,     0,     0,   451,   452,   453,   454,   455,   456,
       0,   457,     0,   458,   459,   460,     0,     0,   461,     0,
       0,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     0,     0,     0,
     478,   186,   187,   188,   189,   190,   191,   192,   193,     0,
     195,   196,   197,     0,     0,     0,     0,     0,     0,     0,
     198,   199,     0,   200,     0,   201,   202,   203,     0,   204,
       0,   205,   206,     0,   207,   208,   209,   210,   211,     0,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
     220,   221,     0,     0,   222,   223,   224,   225,   226,   227,
       0,   228,   229,   230,   231,   232,   233,     0,   234,   235,
     236,     0,   237,   238,     0,     0,     0,     0,     0,     0,
       0,   239,   240,   241,   242,   243,   244,   245,   246,   247,
       0,   248,     0,   249,   250,   251,   252,   253,     0,   254,
     255,   256,     0,     0,   257,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,     0,   267,   268,   269,
     270,   271,   272,   273,     0,   274,     0,   275,   276,   277,
       0,   278,     0,   279,     0,     0,     0,   280,   281,     0,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   835,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   299,   300,   301,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,   319,   320,     0,     0,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
       0,   335,     0,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,     0,   353,     0,     0,     0,   354,
     355,   356,     0,     0,   357,     0,     0,     0,   358,   359,
     360,   361,   362,   363,   364,     0,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,     0,   406,   407,   408,   409,     0,   410,   411,   412,
     413,     0,   414,   415,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
       0,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,     0,   447,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,     0,   457,     0,   458,
     459,   460,     0,     0,   461,     0,     0,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     0,     0,     0,   478,   186,   187,   188,
     189,   190,   191,   192,   193,     0,   195,   196,   197,     0,
       0,     0,     0,     0,     0,     0,   198,   199,     0,   200,
       0,   201,   202,   203,     0,   204,     0,   205,   206,     0,
     207,   208,   209,   210,   211,     0,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,   220,   221,     0,     0,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,     0,   237,   238,
       0,     0,     0,     0,     0,     0,     0,   239,   240,   241,
     242,   243,   244,   245,   246,   247,     0,   248,     0,   249,
     250,   251,   252,   253,     0,   254,   255,   256,     0,     0,
     257,   258,   259,   260,   261,     0,   262,   263,   264,     0,
     265,   266,     0,   267,   268,   269,   270,   271,   272,   273,
       0,   274,     0,   275,   276,   277,     0,   278,     0,   279,
       0,     0,     0,   280,   281,     0,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   837,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   299,
     300,   301,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,   319,   320,
       0,     0,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,     0,   335,     0,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,     0,   348,   349,   350,   351,   352,     0,
       0,   353,     0,     0,     0,   354,   355,   356,     0,     0,
     357,     0,     0,     0,   358,   359,   360,   361,   362,   363,
     364,     0,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,     0,   406,   407,
     408,   409,     0,   410,   411,   412,   413,     0,   414,   415,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,   428,   429,     0,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,     0,
     447,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,     0,   457,     0,   458,   459,   460,     0,     0,
     461,     0,     0,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,     0,
       0,     0,   478,   186,   187,   188,   189,   190,   191,   192,
     193,     0,   195,   196,   197,     0,     0,     0,     0,     0,
       0,     0,   198,   199,     0,   200,     0,   201,   202,   203,
       0,   204,     0,   205,   206,     0,   207,   208,   209,   210,
     211,     0,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,   220,   221,     0,     0,   222,   223,   224,   225,
     226,   227,     0,   228,   229,   230,   231,   232,   233,     0,
     234,   235,   236,     0,   237,   238,     0,     0,     0,     0,
       0,     0,     0,   239,   240,   241,   242,   243,   244,   245,
     246,   247,     0,   248,     0,   249,   250,   251,   252,   253,
       0,   254,   255,   256,     0,     0,   257,   258,   259,   260,
     261,     0,   262,   263,   264,     0,   265,   266,     0,   267,
     268,   269,   270,   271,   272,   273,     0,   274,     0,   275,
     276,   277,     0,   278,     0,   279,     0,     0,     0,   280,
     281,     0,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   839,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   299,   300,   301,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,   319,   320,     0,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,     0,   335,     0,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,     0,
     348,   349,   350,   351,   352,     0,     0,   353,     0,     0,
       0,   354,   355,   356,     0,     0,   357,     0,     0,     0,
     358,   359,   360,   361,   362,   363,   364,     0,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,     0,   406,   407,   408,   409,     0,   410,
     411,   412,   413,     0,   414,   415,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,     0,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,     0,   447,   448,   449,   450,
       0,     0,   451,   452,   453,   454,   455,   456,     0,   457,
       0,   458,   459,   460,     0,     0,   461,     0,     0,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,     0,     0,     0,   478,   186,
     187,   188,   189,   190,   191,   192,   193,     0,   195,   196,
     197,     0,     0,     0,     0,     0,     0,     0,   198,   199,
       0,   200,     0,   201,   202,   203,     0,   204,     0,   205,
     206,     0,   207,   208,   209,   210,   211,     0,     0,   212,
     213,   214,   215,   216,     0,   217,   218,   219,   220,   221,
       0,     0,   222,   223,   224,   225,   226,   227,     0,   228,
     229,   230,   231,   232,   233,     0,   234,   235,   236,     0,
     237,   238,     0,     0,     0,     0,     0,     0,     0,   239,
     240,   241,   242,   243,   244,   245,   246,   247,     0,   248,
       0,   249,   250,   251,   252,   253,     0,   254,   255,   256,
       0,     0,   257,   258,   259,   260,   261,     0,   262,   263,
     264,     0,   265,   266,     0,   267,   268,   269,   270,   271,
     272,   273,     0,   274,     0,   275,   276,   277,     0,   278,
       0,   279,     0,     0,     0,   280,   281,     0,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   842,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   299,   300,   301,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
     319,   320,     0,     0,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,     0,   335,
       0,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,     0,   348,   349,   350,   351,
     352,     0,     0,   353,     0,     0,     0,   354,   355,   356,
       0,     0,   357,     0,     0,     0,   358,   359,   360,   361,
     362,   363,   364,     0,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,     0,
     406,   407,   408,   409,     0,   410,   411,   412,   413,     0,
     414,   415,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,     0,   428,   429,     0,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,     0,   447,   448,   449,   450,     0,     0,   451,   452,
     453,   454,   455,   456,     0,   457,     0,   458,   459,   460,
       0,     0,   461,     0,     0,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,     0,     0,     0,   478,   186,   187,   188,   189,   190,
     191,   192,   193,     0,   195,   196,   197,     0,     0,     0,
       0,     0,     0,     0,   198,   199,     0,   200,     0,   201,
     202,   203,     0,   204,     0,   205,   206,     0,   207,   208,
     209,   210,   211,     0,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,   220,   221,     0,     0,   222,   223,
     224,   225,   226,   227,     0,   228,   229,   230,   231,   232,
     233,     0,   234,   235,   236,     0,   237,   238,     0,     0,
       0,     0,     0,     0,     0,   239,   240,   241,   242,   243,
     244,   245,   246,   247,     0,   248,     0,   249,   250,   251,
     252,   253,     0,   254,   255,   256,     0,     0,   257,   258,
     259,   260,   261,     0,   262,   263,   264,     0,   265,   266,
       0,   267,   268,   269,   270,   271,   272,   273,     0,   274,
       0,   275,   276,   277,     0,   278,     0,   279,     0,     0,
       0,   280,   281,     0,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   844,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   299,   300,   301,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,   319,   320,     0,     0,
     321,   322,   323,   845,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,   335,     0,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,     0,   353,
       0,     0,     0,   354,   355,   356,     0,     0,   357,     0,
       0,     0,   358,   359,   360,   361,   362,   363,   364,     0,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,     0,   406,   407,   408,   409,
       0,   410,   411,   412,   413,     0,   414,   415,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   428,   429,     0,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,     0,   447,   448,
     449,   450,     0,     0,   451,   452,   453,   454,   455,   456,
       0,   457,     0,   458,   459,   460,     0,     0,   461,     0,
       0,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     0,     0,     0,
     478,   186,   187,   188,   189,   190,   191,   192,   193,     0,
     195,   196,   197,     0,     0,     0,     0,     0,     0,     0,
     198,   199,     0,   200,     0,   201,   202,   203,     0,   204,
       0,   205,   206,     0,   207,   208,   209,   210,   211,     0,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
     220,   221,     0,     0,   222,   223,   224,   225,   226,   227,
       0,   228,   229,   230,   231,   232,   233,     0,   234,   235,
     236,     0,   237,   238,     0,     0,     0,     0,     0,     0,
       0,   239,   240,   241,   242,   243,   244,   245,   246,   247,
       0,   248,     0,   249,   250,   251,   252,   253,     0,   254,
     255,   256,     0,     0,   257,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,     0,   267,   268,   269,
     270,   271,   272,   273,     0,   274,     0,   275,   276,   277,
       0,   278,     0,   279,     0,     0,     0,   280,   281,     0,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   848,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   299,   300,   301,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,   319,   320,     0,     0,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
       0,   335,     0,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,     0,   353,     0,     0,     0,   354,
     355,   356,     0,     0,   357,     0,     0,     0,   358,   359,
     360,   361,   362,   363,   364,     0,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,     0,   406,   407,   408,   409,     0,   410,   411,   412,
     413,     0,   414,   415,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
       0,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,     0,   447,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,     0,   457,     0,   458,
     459,   460,     0,     0,   461,     0,     0,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     0,     0,     0,   478,   186,   187,   188,
     189,   190,   191,   192,   193,     0,   195,   196,   197,     0,
       0,     0,     0,     0,     0,     0,   198,   199,     0,   200,
       0,   201,   202,   203,     0,   204,     0,   205,   206,     0,
     207,   208,   209,   210,   211,     0,     0,   620,   213,   214,
     215,   216,     0,   217,   218,   219,   220,   221,     0,     0,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,     0,   237,   238,
       0,     0,     0,     0,     0,     0,     0,   239,   240,   241,
     242,   243,   244,   245,   246,   247,     0,   248,     0,   249,
     250,   251,   252,   253,     0,   254,   255,   256,     0,     0,
     257,   258,   259,   260,   261,     0,   262,   263,   264,     0,
     265,   266,     0,   267,   268,   269,   270,   271,   272,   273,
       0,   274,     0,   275,   276,   277,     0,   278,     0,   279,
       0,     0,     0,   280,   281,     0,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   299,
     300,   301,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,   319,   320,
       0,     0,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   623,   334,     0,   335,     0,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,     0,   348,   349,   350,   351,   352,     0,
       0,   353,     0,     0,     0,   354,   355,   356,     0,     0,
     357,     0,     0,     0,   358,   359,   360,   361,   362,   363,
     364,     0,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,     0,   624,   396,   397,   398,
     399,   400,   625,   402,   403,   404,   405,     0,   406,   407,
     408,   997,     0,   410,   411,   412,   413,     0,   414,   415,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,   428,   429,     0,   430,   431,   432,
     433,   434,     0,   627,   436,     0,     0,   628,   438,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,     0,
     447,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,     0,   457,     0,   458,   459,   460,     0,     0,
     461,     0,     0,   462,   463,   464,   465,   629,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,     0,
       0,     0,   478,   186,   187,   188,   189,   190,   191,   192,
     193,     0,   195,   196,   197,     0,     0,     0,     0,     0,
    1027,     0,   198,   199,     0,   200,     0,   201,   202,   203,
       0,   204,     0,   205,   206,     0,   207,   208,   209,   210,
     211,     0,     0,   212,   213,   214,   215,   216,     0,   217,
     218,   219,   220,   221,     0,     0,   222,   223,   224,   225,
     226,   227,     0,   228,   229,   230,   231,   232,   233,     0,
     234,   235,   236,     0,   237,   238,     0,     0,     0,     0,
       0,     0,     0,   239,   240,   241,   242,   243,   244,   245,
     246,   247,     0,   248,     0,   249,   250,   251,   252,   253,
       0,   254,   255,   256,     0,     0,   257,   258,   259,   260,
     261,     0,   262,   263,   264,     0,   265,   266,     0,   267,
     268,   269,   270,   271,   272,   273,     0,   274,     0,   275,
     276,   277,     0,   278,     0,   279,     0,     0,     0,   280,
     281,     0,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   299,   300,   301,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,   319,   320,     0,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,     0,   335,     0,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,     0,
     348,   349,   350,   351,   352,     0,     0,   353,     0,     0,
       0,   354,   355,   356,     0,     0,   357,     0,     0,     0,
     358,   359,   360,   361,   362,   363,   364,     0,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,     0,   406,   407,   408,   409,     0,     0,
     411,   412,   413,     0,   414,   415,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,     0,   430,   431,   432,   433,   434,     0,   435,
     436,     0,     0,   437,   438,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,     0,   447,   448,   449,   450,
       0,     0,   451,   452,   453,   454,   455,   456,     0,   457,
       0,   458,   459,   460,     0,     0,   461,     0,     0,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,     0,     0,     0,   478,   186,
     187,   188,   189,   190,   191,   192,   193,     0,   195,   196,
     197,     0,     0,     0,     0,     0,     0,     0,   198,   199,
       0,   200,     0,   201,   202,   203,     0,   204,     0,   205,
     206,     0,   207,   208,   209,   210,   211,     0,     0,   212,
     213,   214,   215,   216,     0,   217,   218,   219,   220,   221,
       0,     0,   222,   223,   224,  1276,   226,   227,     0,   228,
     229,   230,   231,   232,   233,     0,   234,   235,   236,     0,
     237,   238,     0,     0,     0,     0,     0,     0,     0,   239,
     240,   241,   242,   243,   244,   245,   246,   247,     0,   248,
       0,   249,   250,   251,   252,   253,     0,   254,   255,   256,
       0,     0,   257,   258,   259,   260,   261,     0,   262,   263,
     264,     0,   265,   266,     0,   267,   268,   269,   270,   271,
     272,   273,     0,   274,     0,   275,   276,   277,     0,   278,
       0,   279,     0,     0,     0,   280,   281,     0,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   299,   300,   301,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
     319,   320,     0,     0,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,     0,   335,
       0,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,     0,   348,   349,   350,   351,
     352,     0,     0,   353,     0,     0,     0,   354,   355,   356,
       0,     0,   357,     0,     0,     0,   358,   359,   360,   361,
     362,   363,   364,     0,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,     0,
     406,   407,   408,   409,     0,   410,   411,   412,   413,     0,
     414,   415,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,     0,   428,   429,     0,   430,
     431,   432,   433,   434,     0,   435,   436,     0,     0,   437,
     438,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,     0,   447,   448,   449,   450,     0,     0,   451,   452,
     453,   454,   455,   456,     0,   457,     0,   458,   459,   460,
       0,     0,   461,     0,     0,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,     0,     0,     0,   478,   186,   187,   188,   189,   190,
     191,   192,   193,     0,   195,   196,   197,     0,     0,     0,
       0,     0,     0,     0,   198,   199,     0,   200,     0,   201,
     202,   203,     0,   204,     0,   205,   206,     0,   207,   208,
     209,   210,   211,     0,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,   220,   221,     0,     0,   222,   223,
     224,   225,   226,   227,     0,   228,   229,   230,   231,   232,
     233,     0,   234,   235,   236,     0,   237,   238,     0,     0,
       0,     0,     0,     0,     0,   239,   240,   241,   242,   243,
     244,   245,   246,   247,     0,   248,     0,   249,   250,   251,
     252,   253,     0,   254,   255,   256,     0,     0,   257,   258,
     259,   260,   261,     0,   262,   263,   264,     0,   265,   266,
       0,   267,   268,   269,   270,   271,   272,   273,     0,   274,
       0,   275,   276,   277,     0,   278,     0,   279,     0,     0,
       0,   280,   281,     0,   282,   283,     0,   284,     0,   285,
     286,   287,   288,  1301,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   299,   300,   301,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,   319,   320,     0,     0,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,   335,     0,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,     0,   353,
       0,     0,     0,   354,   355,   356,     0,     0,   357,     0,
       0,     0,   358,   359,   360,   361,   362,   363,   364,     0,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,     0,   406,   407,   408,   409,
       0,   410,   411,   412,   413,     0,   414,   415,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   428,   429,     0,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,     0,   447,   448,
     449,   450,     0,     0,   451,   452,   453,   454,   455,   456,
       0,   457,     0,   458,   459,   460,     0,     0,   461,     0,
       0,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     0,     0,     0,
     478,   186,   187,   188,   189,   190,   191,   192,   193,     0,
     195,   196,   197,     0,     0,     0,     0,     0,     0,     0,
     198,   199,     0,   200,     0,   201,   202,   203,     0,   204,
       0,   205,   206,     0,   207,   208,   209,   210,   211,     0,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
     220,   221,     0,     0,   222,   223,   224,   225,   226,   227,
       0,   228,   229,   230,   231,   232,   233,     0,   234,   235,
     236,     0,   237,   238,     0,     0,     0,     0,     0,     0,
       0,   239,   240,   241,   242,   243,   244,   245,   246,   247,
       0,   248,     0,   249,   250,   251,   252,   253,     0,   254,
     255,   256,     0,     0,   257,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,     0,   267,   268,   269,
     270,   271,   272,   273,     0,   274,     0,   275,   276,   277,
       0,   278,     0,   279,     0,     0,     0,   280,   281,     0,
     282,   283,     0,   284,     0,   285,   286,   287,   288,  1303,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   299,   300,   301,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,   319,   320,     0,     0,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
       0,   335,     0,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,     0,   353,     0,     0,     0,   354,
     355,   356,     0,     0,   357,     0,     0,     0,   358,   359,
     360,   361,   362,   363,   364,     0,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,     0,   406,   407,   408,   409,     0,   410,   411,   412,
     413,     0,   414,   415,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
       0,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,     0,   447,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,     0,   457,     0,   458,
     459,   460,     0,     0,   461,     0,     0,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     0,     0,     0,   478,   186,   187,   188,
     189,   190,   191,   192,   193,     0,   195,   196,   197,     0,
       0,     0,     0,     0,     0,     0,   198,   199,     0,   200,
       0,   201,   202,   203,     0,   204,     0,   205,   206,     0,
     207,   208,   209,   210,   211,     0,     0,   212,   213,   214,
     215,   216,     0,   217,   218,   219,   220,   221,     0,     0,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,     0,   237,   238,
       0,     0,     0,     0,     0,     0,     0,   239,   240,   241,
     242,   243,   244,   245,   246,   247,     0,   248,     0,   249,
     250,   251,   252,   253,     0,   254,   255,   256,     0,     0,
     257,   258,   259,   260,   261,     0,   262,   263,   264,     0,
     265,   266,     0,   267,   268,   269,   270,   271,   272,   273,
       0,   274,     0,   275,   276,   277,     0,   278,     0,   279,
       0,     0,     0,   280,   281,     0,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   299,
     300,   301,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,   319,   320,
       0,     0,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,     0,   335,     0,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,     0,   348,   349,   350,   351,   352,     0,
       0,   353,     0,     0,     0,   354,   355,   356,     0,     0,
     357,     0,     0,     0,   358,   359,   360,   361,   362,   363,
     364,     0,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,     0,   395,   396,   397,   398,
     399,  1379,   401,   402,   403,   404,   405,     0,   406,   407,
     408,   409,     0,   410,   411,   412,   413,     0,   414,   415,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,   428,   429,     0,   430,   431,   432,
     433,   434,     0,   435,   436,     0,     0,   437,   438,   439,
     440,     0,   441,   442,   443,   444,   445,   446,     0,     0,
     447,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,     0,   457,     0,   458,   459,   460,     0,     0,
     461,     0,     0,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,     0,
       0,     0,   478,   186,   187,   188,   189,   190,   191,   192,
     193,     0,   195,   196,   197,     0,     0,     0,     0,     0,
       0,     0,   198,   199,     0,   200,     0,   201,   202,   203,
       0,   204,     0,   205,   206,     0,   207,   208,   209,   210,
     211,     0,     0,   620,   213,   214,   215,   216,     0,   217,
     218,   219,   220,   221,     0,     0,   222,   223,   224,   225,
     226,   227,     0,   228,   229,   230,   231,   232,   233,     0,
     234,   235,   236,     0,   237,   238,     0,     0,     0,     0,
       0,     0,     0,   239,   240,   241,   242,   243,   244,   245,
     246,   247,     0,   248,     0,   249,   250,   251,   252,   253,
       0,   254,   255,   256,     0,     0,   257,   258,   259,   260,
     261,     0,   262,   263,   264,     0,   265,   266,     0,   267,
     268,   269,   270,   271,   272,   273,     0,   274,     0,   275,
     276,   277,     0,   278,     0,   279,     0,     0,     0,   280,
     281,     0,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   299,   300,   301,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,   319,   320,     0,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     623,   334,     0,   335,     0,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,     0,
     348,   349,   350,   351,   352,     0,     0,   353,     0,     0,
       0,   354,   355,   356,     0,     0,   357,     0,     0,     0,
     358,   359,   360,   361,   362,   363,   364,     0,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,     0,   624,   396,   397,   398,   399,   400,   625,   402,
     403,   404,   405,     0,   406,   407,   408,   997,     0,   410,
     411,   412,   413,     0,   414,   415,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,     0,  1665,   431,   432,   433,   434,     0,   627,
     436,     0,     0,   628,   438,   439,   440,     0,   441,   442,
     443,   444,   445,   446,     0,     0,   447,   448,   449,   450,
       0,     0,   451,   452,   453,   454,   455,   456,     0,   457,
       0,   458,   459,   460,     0,     0,   461,     0,     0,   462,
     463,   464,   465,   629,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,     0,     0,     0,   478,   186,
     187,   188,   189,   190,   191,   192,   193,     0,   195,   196,
     197,     0,     0,     0,     0,     0,     0,     0,   198,   199,
       0,   200,     0,   201,   202,   203,     0,   204,     0,   205,
     206,     0,   207,   208,   209,   210,   211,     0,     0,   620,
     213,   214,   215,   216,     0,   217,   218,   219,   220,   221,
       0,     0,   222,   223,   224,   225,   226,   227,     0,   228,
     229,   230,   231,   232,   233,     0,   234,   235,   236,     0,
     237,   238,     0,     0,     0,     0,     0,     0,     0,   239,
     240,   241,   242,   243,   244,   245,   246,   247,     0,   248,
       0,   249,   250,   251,   252,   253,     0,   254,   255,   256,
       0,     0,   257,   258,   259,   260,   261,     0,   262,   263,
     264,     0,   265,   266,     0,   267,   268,   269,   270,   271,
     272,   273,     0,   274,     0,   275,   276,   277,     0,   278,
       0,   279,     0,     0,     0,   280,   281,     0,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   299,   300,   301,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
     319,   320,     0,     0,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   623,   334,     0,   335,
       0,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,     0,   348,   349,   350,   351,
     352,     0,     0,   353,     0,     0,     0,   354,   355,   356,
       0,     0,   357,     0,     0,     0,   358,   359,   360,   361,
     362,   363,   364,     0,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,     0,   624,   396,
     397,   398,   399,   400,  1694,   402,   403,   404,   405,     0,
     406,   407,   408,   997,     0,   410,   411,   412,   413,     0,
     414,   415,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,     0,   428,   429,     0,   430,
     431,   432,   433,   434,     0,   627,   436,     0,     0,   628,
     438,   439,   440,     0,   441,   442,   443,   444,   445,   446,
       0,     0,   447,   448,   449,   450,     0,     0,   451,   452,
     453,   454,   455,   456,     0,   457,     0,   458,   459,   460,
       0,     0,   461,     0,     0,   462,   463,   464,   465,   629,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,     0,     0,     0,   478,   186,   187,   188,   189,   190,
     191,   192,   193,     0,   195,   196,   197,     0,     0,     0,
       0,     0,     0,     0,   198,   199,     0,   200,     0,   201,
     202,   203,     0,   204,     0,   205,   206,     0,   207,   208,
     209,   210,   211,     0,     0,   212,   213,   214,   215,   216,
       0,   217,   218,   219,   220,   221,     0,     0,   222,   223,
     224,   225,   226,   227,     0,   228,   229,   230,   231,   232,
     233,     0,   234,   235,   236,     0,   237,   238,     0,     0,
       0,     0,     0,     0,     0,   239,   240,   241,   242,   243,
     244,   245,   246,   247,     0,   248,     0,   249,   250,   251,
     252,   253,     0,   254,   255,   256,     0,     0,   257,   258,
     259,   260,   261,     0,   262,   263,   264,     0,   265,   266,
       0,   267,   268,   269,   270,   271,   272,   273,     0,   274,
       0,   275,   276,   277,     0,   278,     0,   279,     0,     0,
       0,   280,   281,     0,   282,   283,     0,   284,     0,   285,
     286,   287,   288,  1905,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   299,   300,   301,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,   319,   320,     0,     0,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,   335,     0,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,     0,   348,   349,   350,   351,   352,     0,     0,   353,
       0,     0,     0,   354,   355,   356,     0,     0,   357,     0,
       0,     0,   358,   359,   360,   361,   362,   363,   364,     0,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,     0,   406,   407,   408,   409,
       0,   410,   411,   412,   413,     0,   414,   415,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   428,   429,     0,   430,   431,   432,   433,   434,
       0,   435,   436,     0,     0,   437,   438,   439,   440,     0,
     441,   442,   443,   444,   445,   446,     0,     0,   447,   448,
     449,   450,     0,     0,   451,   452,   453,   454,   455,   456,
       0,   457,     0,   458,   459,   460,     0,     0,   461,     0,
       0,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     0,     0,     0,
     478,   186,   187,   188,   189,   190,   191,   192,   193,     0,
     195,   196,   197,     0,     0,     0,     0,     0,     0,     0,
     198,   199,     0,   200,   674,   201,   202,   203,   675,  1205,
     676,  1206,  1207,     0,   207,   208,   209,   210,   211,     0,
       0,   212,   213,  1208,  1209,   216,     0,   217,   218,   219,
     220,     0,     0,     0,   222,   223,   224,   225,   226,   227,
       0,   228,   229,   230,   231,   232,   233,     0,   234,   235,
     236,   677,   237,   238,     0,     0,     0,   678,     0,     0,
       0,   239,   240,   241,   242,   243,   244,  1210,  1211,   247,
       0,   248,     0,   249,   250,   251,   252,   253,     0,   254,
     255,   256,     0,     0,   257,   258,   916,   260,   261,     0,
     262,   263,   264,     0,   265,   266,     0,   267,   268,   269,
       0,   271,   272,     0,     0,   274,     0,   275,  1212,   277,
       0,   278,     0,   279,   679,     0,   680,   280,   281,     0,
     282,     0,     0,   284,     0,   285,   286,   287,   288,   289,
     681,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,   682,     0,   300,   301,   302,   303,  1213,  1214,
       0,  1215,     0,   307,   683,   684,   308,   685,   309,   310,
     311,   312,   313,   314,   315,     0,     0,   686,   317,   687,
       0,   318,   319,   320,     0,     0,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,  1216,
     688,  1217,     0,   336,   337,   338,   339,   340,   341,   342,
       0,   344,     0,   345,   346,   689,   347,  1690,     0,   349,
    1218,   351,   352,     0,     0,   353,     0,     0,     0,   354,
     355,   356,     0,     0,     0,   690,   691,   692,     0,   359,
     360,   361,   362,   363,   364,     0,   365,     0,   367,     0,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,  1219,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,   693,
     395,   396,     0,   398,   399,   400,   401,   402,   403,   404,
     405,     0,   406,   407,   408,   409,     0,   410,  1701,   412,
     413,   694,   414,  1221,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   427,     0,   428,   429,
    2853,   430,   431,   432,   433,   434,     0,  1222,  1223,     0,
       0,   437,     0,   439,     0,     0,   441,   442,   443,   444,
     445,   446,     0,     0,   447,   448,   449,   450,     0,     0,
     451,   452,   453,   454,     0,  1224,     0,   457,   695,   458,
     459,   460,     0,     0,   461,     0,     0,   462,   463,   464,
     465,   466,     0,     0,     0,     0,     0,     0,     0,     0,
     475,   476,   477,     0,     0,     0,  1225,   186,   187,   188,
     189,   190,   191,   192,   193,     0,   195,   196,   197,     0,
       0,     0,     0,     0,     0,     0,   198,   199,     0,   200,
     674,   201,   202,   203,   675,  1205,   676,  1206,  1207,     0,
     207,   208,   209,   210,   211,     0,     0,   212,   213,  1208,
    1209,   216,     0,   217,   218,   219,   220,     0,     0,     0,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   677,   237,   238,
       0,     0,     0,   678,     0,     0,     0,   239,   240,   241,
     242,   243,   244,  1210,  1211,   247,     0,   248,     0,   249,
     250,   251,   252,   253,     0,   254,   255,   256,     0,     0,
     257,   258,   916,   260,   261,     0,   262,   263,   264,     0,
     265,   266,     0,   267,   268,   269,     0,   271,   272,     0,
       0,   274,     0,   275,  1212,   277,     0,   278,     0,   279,
     679,     0,   680,   280,   281,     0,   282,     0,     0,   284,
       0,   285,   286,   287,   288,   289,   681,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   682,     0,
     300,   301,   302,   303,  1213,  1214,     0,  1215,     0,   307,
     683,   684,   308,   685,   309,   310,   311,   312,   313,   314,
     315,     0,     0,   686,   317,   687,     0,   318,   319,   320,
       0,     0,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,  1216,   688,  1217,     0,   336,
     337,   338,   339,   340,   341,   342,  1739,   344,     0,   345,
     346,   689,   347,     0,     0,   349,  1218,   351,   352,     0,
       0,   353,     0,     0,     0,   354,   355,   356,     0,     0,
       0,   690,   691,   692,     0,   359,   360,   361,   362,   363,
     364,     0,   365,     0,   367,     0,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,  1219,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,   693,   395,   396,     0,   398,
     399,   400,   401,   402,   403,   404,   405,     0,   406,   407,
     408,   409,     0,   410,  1220,   412,   413,   694,   414,  1221,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   427,     0,   428,   429,     0,   430,   431,   432,
     433,   434,     0,  1222,  1223,     0,     0,   437,     0,   439,
       0,     0,   441,   442,   443,   444,   445,   446,     0,     0,
     447,   448,   449,   450,     0,     0,   451,   452,   453,   454,
       0,  1224,     0,   457,   695,   458,   459,   460,     0,     0,
     461,     0,     0,   462,   463,   464,   465,   466,     0,     0,
       0,     0,     0,     0,     0,     0,   475,   476,   477,     0,
       0,     0,  1225,   186,   187,   188,   189,   190,   191,   192,
     193,     0,   195,   196,   197,     0,     0,     0,     0,     0,
       0,     0,   198,   199,     0,   200,   674,   201,   202,   203,
     675,  1205,   676,  1206,  1207,     0,   207,   208,   209,   210,
     211,     0,     0,   212,   213,  1208,  1209,   216,     0,   217,
     218,   219,   220,     0,     0,     0,   222,   223,   224,   225,
     226,   227,     0,   228,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   677,   237,   238,     0,     0,     0,   678,
       0,     0,     0,   239,   240,   241,   242,   243,   244,  1210,
    1211,   247,     0,   248,     0,   249,   250,   251,   252,   253,
       0,   254,   255,   256,     0,     0,   257,   258,   916,   260,
     261,     0,   262,   263,   264,     0,   265,   266,     0,   267,
     268,   269,     0,   271,   272,     0,     0,   274,     0,   275,
    1212,   277,     0,   278,     0,   279,   679,     0,   680,   280,
     281,     0,   282,     0,     0,   284,     0,   285,   286,   287,
     288,   289,   681,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   682,     0,   300,   301,   302,   303,
    1213,  1214,     0,  1215,     0,   307,   683,   684,   308,   685,
     309,   310,   311,   312,   313,   314,   315,     0,     0,   686,
     317,   687,     0,   318,   319,   320,     0,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,  1216,   688,  1217,     0,   336,   337,   338,   339,   340,
     341,   342,  2697,   344,     0,   345,   346,   689,   347,     0,
       0,   349,  1218,   351,   352,     0,     0,   353,     0,     0,
       0,   354,   355,   356,     0,     0,     0,   690,   691,   692,
       0,   359,   360,   361,   362,   363,   364,     0,   365,     0,
     367,     0,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,  1219,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   693,   395,   396,     0,   398,   399,   400,   401,   402,
     403,   404,   405,     0,   406,   407,   408,   409,     0,   410,
    1220,   412,   413,   694,   414,  1221,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   427,     0,
     428,   429,     0,   430,   431,   432,   433,   434,     0,  1222,
    1223,     0,     0,   437,     0,   439,     0,     0,   441,   442,
     443,   444,   445,   446,     0,     0,   447,   448,   449,   450,
       0,     0,   451,   452,   453,   454,     0,  1224,     0,   457,
     695,   458,   459,   460,     0,     0,   461,     0,     0,   462,
     463,   464,   465,   466,     0,     0,     0,     0,     0,     0,
       0,     0,   475,   476,   477,     0,     0,     0,  1225,   186,
     187,   188,   189,   190,   191,   192,   193,     0,   195,   196,
     197,     0,     0,     0,     0,     0,     0,     0,   198,   199,
       0,   200,   674,   201,   202,   203,   675,  1205,   676,  1206,
    1207,     0,   207,   208,   209,   210,   211,     0,     0,   212,
     213,  1208,  1209,   216,     0,   217,   218,   219,   220,     0,
       0,     0,   222,   223,   224,   225,   226,   227,     0,   228,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   677,
     237,   238,     0,     0,     0,   678,     0,     0,     0,   239,
     240,   241,   242,   243,   244,  1210,  1211,   247,     0,   248,
       0,   249,   250,   251,   252,   253,     0,   254,   255,   256,
       0,     0,   257,   258,   916,   260,   261,     0,   262,   263,
     264,     0,   265,   266,     0,   267,   268,   269,     0,   271,
     272,     0,     0,   274,     0,   275,  1212,   277,     0,   278,
       0,   279,   679,     0,   680,   280,   281,     0,   282,     0,
       0,   284,     0,   285,   286,   287,   288,   289,   681,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
     682,     0,   300,   301,   302,   303,  1213,  1214,     0,  1215,
       0,   307,   683,   684,   308,   685,   309,   310,   311,   312,
     313,   314,   315,     0,     0,   686,   317,   687,     0,   318,
     319,   320,     0,     0,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,  1216,   688,  1217,
       0,   336,   337,   338,   339,   340,   341,   342,     0,   344,
       0,   345,   346,   689,   347,     0,     0,   349,  1218,   351,
     352,     0,     0,   353,     0,     0,     0,   354,   355,   356,
       0,     0,     0,   690,   691,   692,     0,   359,   360,   361,
     362,   363,   364,     0,   365,     0,   367,     0,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,  1219,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,     0,   393,   394,   693,   395,   396,
       0,   398,   399,   400,   401,   402,   403,   404,   405,     0,
     406,   407,   408,   409,     0,   410,  1220,   412,   413,   694,
     414,  1221,     0,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   427,     0,   428,   429,     0,   430,
     431,   432,   433,   434,     0,  1222,  1223,     0,     0,   437,
       0,   439,     0,     0,   441,   442,   443,   444,   445,   446,
       0,     0,   447,   448,   449,   450,     0,     0,   451,   452,
     453,   454,     0,  1224,     0,   457,   695,   458,   459,   460,
       0,     0,   461,     0,     0,   462,   463,   464,   465,   466,
       0,     0,     0,     0,     0,     0,     0,     0,   475,   476,
     477,     0,     0,     0,  1225,   186,   187,   188,   189,   190,
     191,   192,   193,     0,   195,   196,   197,     0,     0,     0,
       0,     0,     0,     0,   198,   199,     0,   200,   674,   201,
     202,   203,   675,  1205,   676,  1206,  1207,     0,   207,   208,
     209,   210,   211,     0,     0,   212,   213,  1208,  1209,   216,
       0,   217,   218,   219,   220,     0,     0,     0,   222,   223,
     224,   225,   226,   227,     0,   228,   229,   230,   231,   232,
     233,     0,   234,   235,   236,   677,   237,   238,     0,     0,
       0,   678,     0,     0,     0,   239,   240,   241,   242,   243,
     244,  1210,  1211,   247,     0,   248,     0,   249,   250,   251,
     252,   253,     0,   254,   255,   256,     0,     0,   257,   258,
     916,   260,   261,     0,   262,   263,   264,     0,   265,   266,
       0,   267,   268,   269,     0,   271,   272,     0,     0,   274,
       0,   275,  1212,   277,     0,   278,     0,   279,   679,     0,
     680,   280,   281,     0,   282,     0,     0,   284,     0,   285,
     286,   287,   288,   289,   681,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,   682,     0,   300,   301,
     302,   303,  1213,  1214,     0,  1215,     0,   307,   683,   684,
     308,   685,   309,   310,   311,   312,   313,   314,   315,     0,
       0,   686,   317,   687,     0,   318,   319,   320,     0,     0,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,  1216,   688,  1217,     0,   336,   337,   338,
     339,   340,   341,   342,     0,   344,     0,   345,   346,   689,
     347,     0,     0,   349,  1218,   351,   352,     0,     0,   353,
       0,     0,     0,   354,   355,   356,     0,     0,     0,   690,
     691,   692,     0,   359,   360,   361,   362,   363,   364,     0,
     365,     0,   367,     0,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,  1219,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
       0,   393,   394,   693,   395,   396,     0,   398,   399,   400,
     401,   402,   403,   404,   405,     0,   406,   407,   408,   409,
       0,   410,  1701,   412,   413,   694,   414,  1221,     0,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     427,     0,   428,   429,     0,   430,   431,   432,   433,   434,
       0,  1222,  1223,     0,     0,   437,     0,   439,     0,     0,
     441,   442,   443,   444,   445,   446,     0,     0,   447,   448,
     449,   450,     0,     0,   451,   452,   453,   454,     0,  1224,
       0,   457,   695,   458,   459,   460,     0,     0,   461,     0,
       0,   462,   463,   464,   465,   466,     0,     0,     0,     0,
       0,     0,     0,     0,   475,   476,   477,     0,     0,     0,
    1225,   186,   187,   188,   189,   190,   191,   192,   193,     0,
     195,   196,   197,     0,     0,     0,     0,     0,     0,     0,
     198,   199,     0,   200,     0,   201,   202,   203,     0,   204,
       0,   205,   206,     0,   207,   208,   209,   210,   211,     0,
       0,   212,   213,   214,   215,   216,     0,   217,   218,   219,
     220,   221,     0,     0,   222,   223,   224,   225,   226,   227,
       0,   228,   229,   230,   231,   232,   233,     0,   234,   235,
     236,     0,   237,   238,     0,     0,     0,     0,     0,     0,
       0,   239,   240,   241,   242,   243,   244,   245,   246,   247,
       0,   248,     0,   249,   250,   251,   252,   253,     0,   254,
     255,   256,     0,     0,   257,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,     0,   267,   268,   269,
     270,   271,   272,   273,     0,   274,     0,   275,   276,   277,
       0,   278,     0,   279,     0,     0,     0,   280,   281,     0,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   299,   300,   301,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,   319,   320,     0,     0,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
       0,   335,     0,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,     0,   348,   349,
     350,   351,   352,     0,     0,   353,     0,     0,     0,   354,
     355,   356,     0,     0,   357,     0,     0,     0,   358,   359,
     360,   361,   362,     0,   364,     0,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,     0,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,     0,   393,   394,     0,
     395,   396,   397,     0,   399,   400,   401,   402,   403,   404,
     405,     0,   406,   407,   408,   409,     0,   410,   411,   412,
     413,     0,   414,   415,     0,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
       0,   430,   431,   432,   433,   434,     0,   435,   436,     0,
       0,   437,   438,   439,   440,     0,   441,   442,   443,   444,
     445,   446,     0,     0,   447,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,     0,   457,     0,   458,
     459,   460,     0,     0,   461,     0,     0,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     0,     0,     0,   478,   186,   187,   188,
     189,   190,   191,   192,   193,     0,   195,   196,   197,     0,
       0,     0,     0,     0,     0,     0,   198,   199,     0,   200,
     674,   201,   202,   203,   675,  1205,   676,  1206,  1207,     0,
     207,   208,   209,   210,   211,     0,     0,   212,   213,  1208,
    1209,   216,     0,   217,   218,   219,   220,     0,     0,     0,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   677,   237,   238,
       0,     0,     0,   678,     0,     0,     0,   239,   240,   241,
     242,   243,   244,  1210,  1211,   247,     0,   248,     0,   249,
     250,   251,   252,   253,     0,   254,   255,   256,     0,     0,
     257,   258,   916,   260,   261,     0,   262,   263,   264,     0,
     265,   266,     0,   267,   268,   269,     0,   271,   272,     0,
       0,   274,     0,   275,  1212,   277,     0,   278,     0,   279,
     679,     0,   680,   280,   281,     0,   282,     0,     0,   284,
       0,   285,   286,   287,   288,   289,   681,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   682,     0,
     300,   301,   302,   303,  1213,  1214,     0,  1215,     0,   307,
     683,   684,   308,   685,   309,   310,   311,   312,   313,   314,
     315,     0,     0,   686,   317,   687,     0,   318,   319,   320,
       0,     0,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,  1216,   688,  1217,     0,   336,
     337,   338,   339,   340,   341,   342,     0,   344,     0,   345,
     346,   689,   347,     0,     0,   349,  1218,   351,   352,     0,
       0,   353,     0,     0,     0,   354,   355,   356,     0,     0,
       0,   690,   691,   692,     0,   359,   360,   361,   362,   363,
     364,     0,   365,     0,   367,     0,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,  1219,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,     0,   393,   394,   693,   395,   396,     0,   398,
     399,   400,   401,   402,   403,   404,   405,     0,   406,   407,
     408,   409,     0,   410,     0,   412,   413,   694,   414,  1221,
       0,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   427,     0,   428,   429,     0,   430,   431,   432,
     433,   434,     0,  1222,  1223,     0,     0,   437,     0,   439,
       0,     0,   441,   442,   443,   444,   445,   446,     0,     0,
     447,   448,   449,   450,     0,     0,   451,   452,   453,   454,
       0,  1224,     0,   457,   695,   458,   459,   460,     0,     0,
     461,     0,     0,   462,   463,   464,   465,   466,     0,     0,
       0,     0,     0,     0,     0,     0,   475,   476,   477,     0,
       0,     0,  1225,   186,   187,   188,   189,   190,   191,   192,
     193,     0,   195,   196,   197,     0,     0,     0,     0,     0,
       0,     0,   198,   199,     0,   200,   674,   201,   202,   203,
     675,     0,   676,     0,     0,     0,   207,   208,   209,   210,
     211,     0,     0,   212,   213,     0,     0,   216,     0,   217,
     218,   219,   220,     0,     0,     0,   222,   223,   224,   225,
     226,   227,     0,   228,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   677,   237,   238,     0,     0,     0,   678,
       0,     0,     0,   239,   240,   241,   242,   243,   244,     0,
       0,   247,     0,   248,     0,   249,   250,   251,   252,   253,
       0,   254,   255,   256,     0,     0,   257,   258,   259,   260,
     261,     0,   262,   263,   264,     0,   265,   266,     0,   267,
     268,   269,     0,   271,   272,     0,     0,   274,     0,   275,
       0,   277,     0,   278,     0,   279,   679,     0,   680,   280,
     281,     0,   282,     0,     0,   284,     0,   285,   286,   287,
     288,   289,   681,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   682,     0,   300,   301,   302,   303,
       0,     0,     0,     0,     0,   307,   683,   684,   308,   685,
     309,   310,   311,   312,   313,   314,   315,     0,     0,   686,
     317,   687,     0,   318,   319,   320,     0,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,     0,   688,     0,     0,   336,   337,   338,   339,   340,
     341,   342,     0,   344,     0,   345,   346,   689,   347,     0,
       0,   349,     0,   351,   352,     0,     0,   353,     0,     0,
       0,   354,   355,   356,     0,     0,     0,   690,   691,   692,
       0,   359,   360,   361,   362,   363,   364,     0,   365,     0,
     367,     0,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,     0,   393,
     394,   693,   395,   396,     0,   398,   399,   400,   401,   402,
     403,   404,   405,     0,   406,   407,   408,   409,     0,   410,
       0,   412,   413,   694,   414,     0,     0,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   427,     0,
     428,   429,     0,   430,   431,   432,   433,   434,     0,     0,
       0,     0,     0,   437,     0,   439,     0,     0,   441,   442,
     443,   444,   445,   446,     0,     0,   447,   448,   449,   450,
       0,     0,   451,   452,   453,   454,     0,     0,     0,   457,
     695,   458,   459,   460,     0,     0,   461,     0,     0,   462,
     463,   464,   465,   466,     0,     0,     0,     0,     0,     0,
       0,     0,   475,   476,   477,     0,     0,     0,  1225
};

static const yytype_int16 yycheck[] =
{
       0,   671,    48,   704,     0,   171,   831,   708,   671,   621,
     824,    11,   673,    12,  1325,  1446,  1347,   880,   163,    21,
     502,  1116,   746,   168,    42,    27,   578,   579,   624,   730,
     731,   583,   943,   734,   914,   915,   729,  1220,   703,   800,
    1286,   893,  1706,  1151,  1738,   628,     0,   740,    48,   867,
       0,  1977,     0,   933,    22,     7,    34,  1382,   540,  1268,
     697,    13,    14,   777,  2146,  1100,    34,    19,    21,    21,
      22,  2428,    24,  1024,    27,    27,    28,    29,  1894,  1895,
      32,    33,    34,  1850,    36,   495,    38,    39,   781,  1022,
     169,    43,  1613,   786,   173,    47,  1951,  1851,  2339,   158,
     793,  2640,   816,   182,  1871,  2115,   158,  1851,    41,   802,
    1061,    44,  1321,  1706,  1707,  1851,  2277,   143,  2279,  2373,
    1851,  1851,  1145,     0,   534,  1900,  1851,  2804,  2854,     0,
    1066,    38,  2373,  1066,    17,  1622,  1814,  2825,    20,    25,
    1619,  1889,     0,    46,     0,    25,    25,    32,   904,   905,
    1844,   808,     0,     7,    65,    92,  1009,   708,   158,    13,
    1013,  1014,     0,  2357,  2358,  2359,  2360,  2361,  2362,  2363,
     838,    39,    39,   929,   668,    11,    46,  2557,    92,    26,
      58,   849,   668,    92,  2874,     7,  2876,    92,    87,    30,
      14,    92,   137,   109,   137,    48,    48,   156,    52,  3298,
       0,   116,     0,   851,   216,   178,   236,    24,    99,    62,
      62,    39,   164,   165,   166,   109,    85,   169,  1912,   171,
    1914,   173,   174,   775,   176,     0,   178,   174,   180,   181,
     182,  1084,    39,   234,    75,   137,    11,  1090,    52,    92,
    3142,    94,   175,    46,   177,    55,   237,   120,   102,   139,
     149,   847,    12,   267,   111,   109,    30,     0,   112,   252,
    1022,   240,   229,   283,   139,    92,   294,  3339,    11,    69,
      62,    69,   234,  3296,   264,    11,    24,    97,    11,   761,
    1133,   216,   134,  1136,  1137,    18,  1010,   109,   281,   109,
     176,   248,    69,  3567,    87,    25,    11,    48,    92,   272,
      92,   272,   137,    18,  1066,   204,    19,   161,   207,    11,
     163,    95,  1223,   178,   275,  1248,    18,   965,    40,   311,
      96,    21,   138,   142,   343,   252,    48,   417,   252,   406,
    1210,  1211,   422,   176,  1187,  3012,   502,   399,  1218,    26,
     311,   141,   404,   141,     7,   422,   491,  1415,   164,  3623,
     987,  1022,   296,   343,   281,    75,   149,   281,   378,   144,
      47,   380,   216,   179,   141,  1190,   241,   359,   104,   153,
      48,   224,  1186,   189,   540,   286,   229,    55,   152,    92,
     239,   393,   156,   134,    62,   530,     5,    97,   359,  3412,
     380,   419,   537,   309,   424,  1066,   239,   224,   252,   175,
     100,   345,   301,   382,   424,   419,   296,   272,  1476,   169,
    1006,   204,   265,   265,   207,   309,  3318,   191,   419,   287,
     287,   500,   258,   237,   277,   504,   419,   281,   419,   364,
     252,   285,   224,   400,  2688,   229,   515,   306,   311,   341,
      92,  1202,   262,   400,  3121,  3517,   109,  2688,  1141,   324,
    1143,   424,  1208,  1209,  1178,   309,   134,   419,   419,   287,
     284,  1217,  2656,   400,   538,   424,   369,   404,   542,  1183,
     361,   298,   296,   195,   352,   291,  1955,   424,   552,   424,
     287,   424,   398,  1434,  3161,   137,  1248,   309,   288,  3179,
     288,   400,   406,   392,   164,   400,   166,   400,   334,   400,
     336,   120,   355,   355,   419,  3604,  1199,   292,   301,    92,
     351,   181,   329,   424,   265,  1448,   419,   374,  1701,    39,
     419,   345,  1340,  1180,   410,   411,   412,   413,   414,   415,
    1481,   341,   484,   559,   419,   421,   415,   419,  2918,   313,
     492,   421,   421,   495,   398,   497,   137,  1098,   500,   419,
     502,   398,   504,   505,   506,   507,   424,   424,   560,   511,
     562,   513,   564,   515,  1058,   423,   568,   423,   570,   571,
     522,  2050,  1058,  1238,  3251,   423,  1684,  1248,   378,   531,
     378,   329,   534,   316,    48,   423,   538,   265,   540,   424,
     542,   543,   525,  2787,   546,   761,   548,   400,   550,   392,
     552,   316,   485,   555,   355,   424,   751,   560,  2201,   562,
    2203,   564,  2622,   758,   316,   568,   419,   424,   281,  1276,
     420,  1289,   420,   423,  3312,   423,  2320,  2321,    92,   404,
    1298,   351,   149,   176,   517,   410,   411,  2315,  1306,  1307,
    2318,  2319,  1124,  1889,  2322,   597,  2133,   599,   423,   359,
     602,  1407,  1408,   229,  2332,   120,  1324,   590,    60,    60,
      97,   404,   662,    86,   809,   138,   662,   410,   411,   229,
     622,   132,   624,   252,   626,   294,    94,   355,  1274,   121,
     423,   131,   412,   413,   414,   415,  1448,   204,   140,   341,
    2121,   421,   311,   406,  2442,  3323,   216,   649,  2446,   101,
     101,    60,   281,   655,   417,    95,   419,   420,   662,   422,
     294,   424,   662,   646,   662,   622,   341,   204,   118,   626,
     303,  1273,    92,  3252,     7,    11,  1662,     7,    85,  1662,
      13,   168,  3458,  1381,  1382,    60,   159,   419,  1350,  1351,
     422,   140,   101,   195,  1392,   163,  2339,  1395,   400,   332,
     341,    25,    94,    94,   406,  1403,  1404,    63,   832,    25,
     224,   713,   714,   153,    61,   229,   128,   287,  1416,  1417,
     422,   139,   172,    97,  3303,   359,   101,  1448,   129,  1427,
    2373,   254,   370,   366,   301,   662,   104,    93,   106,   309,
     742,   662,   334,    92,   336,   378,   195,  1730,   872,   424,
      23,   265,   754,   173,  3161,  3433,   224,  3460,   882,   761,
     260,   763,   216,   277,   301,   406,   113,   769,   104,   398,
     894,   773,   283,  1305,   400,   195,   109,   497,   780,   109,
     192,   422,   137,  2426,  1482,    85,   419,   789,   790,   243,
     400,   314,    92,   513,   168,   245,   311,  3524,   252,  1872,
     264,   253,   253,   853,   160,   807,   808,   853,   810,   216,
    2635,   303,  3391,  2109,   215,    87,   303,   410,   411,   412,
     413,   414,   415,   241,   236,   875,   828,   829,   421,   875,
     832,   239,   334,   224,   336,  1295,   244,   229,   185,   186,
     332,   355,  3441,   243,   253,   847,  1749,    84,   898,   853,
    1662,   198,   252,   853,  1757,   853,  1759,  3560,   331,   332,
     176,   177,   864,    95,   866,   867,   234,   917,    62,   965,
     872,   873,   359,    69,   366,   224,   878,   149,   253,   343,
     882,  1413,   155,   335,   335,   334,   378,   336,   890,  3455,
    3456,  3594,   894,  1611,   896,    91,    96,   947,  2016,  2017,
     296,    97,    32,  2021,   354,   252,  1836,   417,  1124,   419,
     364,   227,  3511,  3124,  1038,   965,   380,   400,  1730,   252,
    3519,   153,   252,   372,   224,   121,   335,   419,  2988,  2989,
    2990,    64,   204,  3522,  3523,   207,    84,  1046,  1047,   341,
    1049,  1662,  2060,  2061,  1046,  1047,   140,  1049,   281,   345,
    1762,   281,   379,    83,   174,  1031,  3260,  1009,  3557,    63,
     335,  1013,  1014,  1774,   119,   159,   203,   332,   205,  3260,
     397,   371,   168,   106,   348,   175,   322,   323,   398,   399,
     400,   104,   239,   106,   404,   359,   333,   244,   335,    93,
     410,   411,  3558,   713,   714,  2861,  1046,  1047,   304,  1049,
    2905,   195,   157,   304,  1006,   334,  3595,   336,  2736,  1730,
    2814,  1013,  1014,   161,  2742,  2743,  2744,  2745,  2746,  2747,
    2814,   321,   424,   252,   324,  1027,   332,  1029,  2814,   301,
    2188,   332,  1084,  2814,  2814,  1037,  1038,   167,  1090,  2814,
    1915,  1762,   379,  1907,   251,  2688,  1857,  1858,  1859,  1860,
     244,   398,   281,   773,   400,   203,   160,   205,  2041,   417,
     397,   419,  2633,  2046,   422,   404,   372,  2865,  1070,   789,
     790,   372,  2870,   378,   252,  2873,   343,   252,   296,   418,
    1082,  1133,   419,   378,  1136,  1137,   216,   807,  1839,  1305,
    1092,  1286,   252,  1288,   410,   411,   412,   413,   414,   415,
    2844,   224,  1297,   281,  2485,   421,   281,   303,   828,   829,
     298,   234,    15,    16,   303,  2200,  3248,  3524,   298,   424,
     392,   281,  1124,  1252,  1126,   285,   398,   345,   400,   424,
     704,   309,  1883,  2134,   309,  1187,   332,  1901,  2513,  2883,
     334,  2885,   336,   332,   281,   333,  2442,   224,   285,   309,
    2446,   345,  1347,   333,   104,   729,   106,  1159,  1160,  1161,
    1162,   355,   486,   359,   137,  1167,   740,   281,   139,   299,
     366,   285,   309,   138,   294,  1299,   126,   366,  1180,   252,
     378,    97,   378,   156,  1308,   369,  1188,  1189,  1906,    73,
     378,   379,  1194,   270,   165,   309,  1320,  1413,   378,   379,
     320,  3018,  1920,  1921,  1664,   128,  1924,   128,   281,   132,
    1897,   132,  1930,  3424,   303,  1077,   400,  2476,   378,  2122,
    3196,  1345,   419,   419,  1348,  1349,   424,   419,  1352,  2041,
     419,   419,   271,   379,  2046,   419,  1286,     0,   398,   419,
      55,   378,  1244,   332,  1106,    38,   104,    62,   106,   423,
    1252,   397,   168,   272,   138,  1257,   295,  1259,  1260,  1261,
    1262,  1979,  1358,   282,   378,   424,  1268,  2412,   126,   192,
     594,   192,  1274,   419,  1276,    68,  2206,   366,  2534,   229,
     164,  1330,  1928,    85,   234,   404,   305,   300,  1986,   378,
     614,   410,   411,  1295,  1296,   179,   620,  1299,  1300,   623,
     624,   625,  2558,  1305,  2785,   189,  1308,  1309,  1358,  1311,
    2178,  1313,   182,   236,   400,   236,  1318,  1367,  1320,  1321,
    2041,  1367,  1169,  1325,  1326,  2046,  3386,   334,   212,   336,
     419,   124,   400,   419,   345,   333,  2034,   298,  1340,  3067,
    3068,  1393,  1394,  1345,   341,   118,  1348,  1349,  1376,  1401,
    1352,   419,    85,  1405,  1406,   128,  1358,  1375,   176,   132,
     334,   154,   336,  1367,     9,  2063,   224,  1367,  1420,  1367,
    1422,   229,   333,  1375,  1376,   283,   234,  1379,  3176,  1362,
     378,   379,   665,    28,   667,    41,   400,   303,    44,  2372,
     132,  1443,   420,  1445,   379,   300,   424,   347,  1245,   172,
     268,  2099,  1452,   417,  1251,   419,   356,   291,   422,   151,
     159,  1413,   397,  2111,  2112,   400,   332,   378,   379,   192,
    2538,   419,  1269,  2541,  2542,  2543,  2544,  2545,  2546,  2547,
    2548,  2549,    66,  2551,   419,   379,   400,   118,   400,  1159,
    1160,  1161,  1162,   359,  1496,   400,  3160,   128,    45,    46,
     366,   132,   776,   397,  2455,   419,   400,   419,   419,   252,
      85,  2179,   378,   236,   419,  2277,  2278,  2279,  1188,  1189,
     300,   400,   245,   420,  1194,   419,   400,   424,   400,  2960,
     418,  2599,  2600,  2198,   151,  2118,   424,  2149,   281,   347,
     419,   172,   285,  2494,   400,   419,   289,   419,   356,  2217,
    2218,  1107,   295,   419,  1110,   378,   132,   163,   732,   302,
     734,   192,   168,   419,   170,     5,   309,   741,   420,   175,
      10,   177,   424,   847,   317,   151,   399,   183,    18,   420,
    1659,   404,   325,   424,  1663,  2286,    36,   410,   411,  1259,
    1260,  1261,  1262,   182,   418,    35,  1152,  1153,  2080,  3277,
     424,  1680,  2348,  2349,  2350,   236,  2277,  2278,  2279,  1688,
    2372,   404,   378,   379,   245,  3309,    17,   410,   411,  2865,
    2447,   419,  2449,  2731,  2870,  1625,   419,  2873,  2579,   399,
     373,   354,  1711,  1635,   404,   294,   295,   404,  1712,  2572,
     410,   411,   410,   411,   412,   413,   414,   415,   419,  1728,
    2561,  2562,   414,   421,  2506,   398,  1326,   419,   239,   415,
     422,  1613,    33,    36,  1743,   421,  1745,  3260,    39,  1053,
     412,   413,   414,   415,   419,    17,    26,  2752,  2753,   421,
     414,  2756,  1635,  2758,  1763,   419,    37,   420,   422,   394,
     420,   424,  1771,   967,   424,   178,   420,   420,   420,  1778,
     424,  2372,   424,   977,   422,   420,  1785,  1659,  1660,   424,
     242,  1663,  1664,  1665,   988,   239,   420,    17,   420,  1671,
     424,   419,   424,   354,   422,  1677,   420,  2428,  1680,  2797,
     424,  1683,  1006,    84,  2597,  1009,  1688,  1689,   242,  1013,
    1014,   420,  1694,   341,  1889,   424,  3513,  1749,  3341,   420,
     294,   295,   239,   424,  2687,  1757,  2689,  1759,   420,  1711,
    1712,   394,   424,  1715,  1716,  1717,  1718,  1719,  1720,  1721,
     378,   379,  1724,  1725,  2957,   176,  1728,  1729,   420,   420,
    1732,   420,   424,   424,   423,  1737,  1738,    26,  3555,   242,
    2670,  1743,  2460,  1745,  1746,  3459,  2464,   394,  2466,   420,
    2468,  2469,   423,  1755,  1756,   412,  1758,   158,  2456,  2477,
    2572,  1763,   395,   396,  3245,  1767,  1768,  1769,  1770,  1771,
    1772,   420,  2374,   378,   379,   424,  1778,  1779,  1780,  2425,
     178,  1833,   309,  1785,   176,  1787,  1788,   884,   885,  2507,
     241,  2659,  2660,  1889,  1430,     7,   420,  1433,  1800,   420,
     424,    13,   203,   424,   205,  1807,  1808,  1809,  1810,  1811,
    1812,   136,   420,   424,   420,   216,   424,  1941,   424,  2033,
    1949,  2035,  2036,  1873,   419,  1149,   176,  1873,   484,   420,
      73,   420,   420,   489,   420,   491,   424,   420,   424,  1889,
      52,   424,  1844,   420,  2962,  2963,    36,   424,  1977,   241,
     251,  2572,   420,  2627,   420,   419,   424,   420,   424,  3155,
     422,   424,   422,   420,  2080,   381,  1868,   424,   420,   525,
    2568,   419,   424,  1875,   530,  2687,   419,  2689,   420,   420,
    3176,   537,   424,   424,   398,   286,  2150,  2151,  1890,   190,
     102,   241,  1894,  1895,   420,   138,   239,   109,   424,   420,
     112,   420,   420,   424,  2716,   424,   424,  2152,  2153,  1911,
    1912,  1913,  1914,  3294,  2109,   420,   420,   132,   319,   424,
     424,   164,   361,   239,   239,   420,  1928,  2143,   584,   424,
     419,  1255,   300,   420,   590,  1937,   179,   424,   420,  1941,
     420,   233,   424,   182,   424,   601,   189,  1949,   419,   161,
    1274,  2666,   403,    48,   420,   406,   407,   408,   424,   410,
     411,   412,   413,   414,   415,   621,  2687,  2063,  2689,   212,
     421,  1973,   420,   420,   420,  1977,   424,   424,   424,   420,
       7,  1415,    20,   424,   640,   420,    13,   420,   420,   424,
     646,   424,   424,   378,   420,  2716,   239,   779,   424,   381,
      26,   420,   420,   419,   216,   424,   424,   663,   420,   350,
      97,   403,   424,  2063,   406,   407,   408,   252,   410,   411,
     412,   413,   414,   415,   420,    52,   420,  2077,   424,   421,
     424,    17,   132,  2162,   182,  1755,  2104,  2105,  3334,   420,
     252,   122,  3403,   424,  3405,  2856,   122,  2097,   291,   361,
    2052,   122,   419,   403,   381,  2968,   406,   407,   408,  2109,
     410,   411,   412,   413,   414,   415,    38,   122,  2120,   281,
    2122,   421,   122,   285,   122,   102,  1400,   424,  2080,   122,
    1800,   168,   109,  3201,   239,   112,   122,  1807,  1808,  1809,
    1810,  1811,  1812,   122,   122,   751,    68,   309,   880,   122,
     420,   420,   758,  2854,   424,   424,   420,  3225,  3226,   420,
     424,   239,   420,   424,   122,  2244,   424,   122,   361,   419,
    2122,    20,  2246,  2339,   133,   190,   132,   400,   132,  2131,
     400,   419,   419,   419,   161,   419,   419,   261,  2262,   226,
     419,   419,  2266,   419,   400,   400,   249,   803,   804,   805,
     419,   419,   124,   809,   419,    48,  3452,  2373,   419,   419,
    2162,  2163,  2164,  2881,   400,   419,   419,   419,   400,    62,
    2888,  2889,   419,   419,    25,  1499,  2178,   419,   419,    30,
     424,  2310,   154,    20,    75,  2187,   419,   190,   419,   216,
     176,  1911,   419,  1913,   419,   419,   419,    20,     7,    92,
     132,    94,   132,   341,    13,   341,   422,   341,   341,   406,
     341,   302,  2264,  3081,   239,   871,   303,  2219,  2220,  2221,
    2222,   341,  2016,  2017,   341,   252,   341,  2021,   229,    55,
     360,   341,   239,   161,   341,   419,   424,   893,   361,   361,
     252,    36,  2244,    52,  2246,   332,  3364,  2442,   341,  2947,
      36,  2446,   341,   341,   281,   241,   341,   419,   285,   176,
    2262,   341,   243,   341,  2266,   298,  2060,  2061,   341,   341,
     163,   341,   359,   341,   341,   239,   239,   378,   176,   366,
    1062,    20,   309,   369,   419,    19,     9,  2339,    92,  3000,
    2485,   378,  3205,   102,  2346,  2347,   371,   361,   419,  2351,
     109,   419,    20,   112,  2306,   156,   372,    20,  2310,  2311,
     198,   132,  3124,   285,   239,   287,    20,   289,  2320,  2321,
      38,  2373,   419,   295,   241,   176,   177,  2376,   299,   375,
     302,   224,   419,  3076,   122,   122,   229,   309,   122,   361,
    1122,   361,   122,   341,  1668,   317,   288,   366,   228,   339,
      68,   209,   161,   325,   137,   394,   419,  2486,   374,  2483,
     209,   421,   424,  1019,   309,  2415,   339,   419,   419,  2415,
    1694,   341,   265,  3518,   137,  2377,   227,   343,   420,  2508,
     424,  2505,   150,   150,   277,  2435,   240,   172,   406,  2435,
     241,   234,  2442,   424,   192,  2397,  2446,  2399,   341,   420,
     341,   373,  1184,  3124,   298,    61,   124,   216,   419,   180,
    3161,   180,   229,   229,  2416,   229,  3284,   403,   246,  1201,
     406,   407,   408,  2425,   410,   411,   412,   413,   414,   415,
     419,   239,   237,   424,  2436,   421,   154,  2439,   341,   281,
     281,   281,  2492,   252,   306,   341,  2492,   272,   176,   341,
    2452,    20,  3365,   361,   176,   176,  1112,   361,   237,   176,
    2462,  1243,   355,    19,   182,   176,   406,  3185,   417,  3187,
    3188,  3003,  2688,  2475,  2476,   341,   285,  3195,   417,   132,
     341,  2483,  1806,  3396,  2486,   341,   403,  3400,  3401,   341,
    1814,  2493,   419,   410,   411,   412,   413,   414,   415,   406,
     309,   134,    20,  2505,   421,   398,  2508,  1163,    32,   156,
     419,  2607,  1294,   306,   145,   239,   148,   132,   148,   424,
    3122,    20,   419,  3398,   122,   239,  1182,   239,   306,   176,
     132,   332,  1856,  3397,   381,  2664,     8,   424,  3236,   142,
     206,  2609,  2610,  2611,  2612,   239,   424,    36,   420,   420,
      74,   420,   403,   137,   424,  1879,   420,  2607,   394,   410,
     411,   412,   413,   414,   415,   420,   137,   285,   341,   419,
     421,   289,   420,   419,    98,   420,   420,   295,   375,  2703,
    2704,   420,  2016,  2017,   302,   420,   420,  2021,   420,   420,
     420,   309,   394,   117,   241,  2724,   420,  2726,   420,   317,
     248,   128,   176,   192,  1928,   364,   419,   325,   419,   133,
     341,    97,  3424,   166,   192,   229,   256,   256,   358,   201,
     201,  2623,   341,   147,   201,   341,  2060,  2061,   176,   176,
    1286,  2633,  1288,   341,   341,   341,  2688,   176,   341,   341,
     341,  1297,   176,   176,  3362,   176,   176,   398,   420,  2701,
     301,   417,   207,   243,  1310,   373,   420,  2659,  2660,   377,
    3322,   350,  2664,  1319,   192,  3385,    85,   241,   378,   419,
    2865,  3369,  3385,   420,   237,  2870,   424,   239,  2873,   341,
     398,   361,   168,   420,   419,   239,   179,   247,   179,   419,
    1472,  1347,   234,   361,  1350,  1351,   361,   242,  2701,   424,
     120,  2703,  2704,  3424,   120,   229,  1362,  3458,   417,  2761,
    2762,  3575,   115,   237,   137,   132,   421,   371,  2720,    46,
    2772,   420,  2724,  2725,  2726,  2727,  2728,  2729,  2730,   420,
     420,   137,  3264,   419,   144,   420,  2788,   420,   419,   225,
     226,   166,   406,   240,  2538,   350,   270,  2541,  2542,  2543,
    2544,  2545,  2546,  2547,  2548,  2549,   403,  2551,   350,   406,
     407,   408,   341,   410,   411,   412,   413,   414,   415,  2898,
     420,   341,   132,  3524,   421,   341,   341,  3475,   420,   420,
     176,   176,   420,   418,   418,   378,   180,  3003,    20,   283,
    2792,  2793,  2794,   420,  2796,   419,   419,   132,  2122,   162,
      57,   381,   378,   419,     7,  2599,  2600,   333,   419,   419,
      13,    14,   424,   179,   420,  2865,    19,   303,    21,   419,
    2870,  2823,  1478,  2873,    27,   306,    29,  2829,   419,   403,
    2832,  1487,  2834,   407,   408,   141,   410,   411,   412,   413,
     414,   415,  2844,   137,    47,     7,   332,   421,   420,   137,
      17,    13,   419,   376,   376,    36,   420,   146,    25,  2861,
     350,  2863,   420,    30,   229,   424,   406,   229,   122,   176,
      99,   229,  2874,   359,  2876,    37,  2878,    94,  3480,   163,
     366,  2883,   418,  2885,   139,   137,   424,   424,   361,   110,
      52,   361,   378,   121,    85,   420,  2898,   137,   419,  3028,
     181,   341,   170,   419,   419,   242,   137,   175,   419,   419,
    3039,   365,   420,   318,   420,   183,   377,   255,   420,   361,
     277,   419,    84,   419,   132,   378,    20,   229,  3052,  3053,
     202,  3055,   424,   419,   159,   269,   295,  2261,    48,   295,
     102,   242,    48,    36,   240,   245,   132,   109,   239,   333,
     112,   127,   242,   365,   378,  3007,  3008,   242,   424,  2283,
    3155,    20,   275,   378,  1620,   424,   176,   110,   239,   239,
    3022,   174,    20,   176,   419,   178,   105,   180,  3030,  3031,
     419,  3176,   420,  3035,  3036,   152,   294,   359,    97,   156,
    2992,  2315,     6,   121,  2318,  2319,   158,   294,  2322,   161,
      17,  3003,   269,  2797,  3007,  3008,   419,   662,  2332,   176,
     177,  2375,  1014,  2337,  2122,  2339,  1736,  3516,   706,  3022,
    2687,  3023,  2337,  3280,   191,  2829,  3028,  3029,  1715,  2832,
    2675,   241,  3115,  2175,  3538,  3574,  1937,  3039,  3040,  3505,
    3504,   203,  1824,   205,  3260,  3169,  3098,   853,  3264,  2373,
    3052,  3053,  3054,  3055,   216,  3179,  3546,   224,  2834,  1270,
     227,  1684,  2416,  2841,  2716,  2278,  2392,  3196,  3263,  2393,
    1256,  1727,  1838,  3636,   241,  3089,  3126,   244,  3611,  3081,
    3126,  2372,  3088,  2341,  3553,  3266,  1246,  3487,    27,   251,
     252,  3269,   873,  2898,  2843,  3098,   591,  3334,  3452,  3294,
    2424,  2425,  2847,  1707,  2538,  3599,  3459,  2541,  2542,  2543,
    2544,  2545,  2546,  2547,  2548,  2549,  3635,  2551,   637,   281,
    3310,  1620,    20,   285,   286,  1043,  3176,  3129,  2826,  2131,
    2493,  1037,  2140,   853,  2154,   655,    25,  1652,   853,  3334,
    1653,    30,  3007,  2652,  1056,  3147,   313,   309,  1889,  1614,
    1638,  2109,  2448,  3155,   525,  3177,  2132,   319,   646,  2823,
    1823,  2582,  3367,  2574,  3532,  2599,  2600,  3169,  2962,  2963,
    3533,  3536,  1479,  2143,  1988,  2075,    -1,  3179,  2077,  1956,
      -1,    -1,    -1,    -1,    -1,  1967,    -1,    -1,    -1,  3191,
    3192,    -1,  1848,   403,  3196,    -1,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,    -1,    -1,  3260,    -1,
      -1,   421,    -1,    -1,    -1,    -1,   484,    -1,  1874,    -1,
      -1,   489,    -1,    -1,    -1,  1881,  3350,    -1,   117,    -1,
      -1,    -1,    -1,  1889,    -1,    -1,   403,  3432,    -1,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,    -1,
     412,   418,    -1,    -1,   421,    -1,    -1,  3452,   425,  2583,
      -1,    -1,  3264,   152,    -1,    -1,    -1,   156,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    -1,    -1,    -1,    -1,
      -1,    -1,  3284,  3407,    -1,    -1,    -1,   176,   177,   492,
      -1,    -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2625,   191,   506,   507,    -1,   241,  3309,   511,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   584,    -1,    -1,   522,
      -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,   531,    -1,
      -1,  3333,  3334,   601,  3054,    -1,  3338,  3339,   227,    -1,
     543,    -1,    -1,   546,  3539,   548,    -1,   550,  3350,    -1,
      -1,    -1,   241,   621,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2797,  2688,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   640,    -1,    -1,    -1,    -1,    -1,  2702,   124,
    3382,    -1,    -1,    -1,    -1,  2709,    -1,  2711,    -1,    -1,
      -1,    -1,    -1,    -1,   597,   663,   599,    -1,    -1,    -1,
      -1,  3403,  3404,  3405,  3406,  3407,    -1,  3201,    -1,   154,
      -1,    -1,  2736,    -1,    -1,    -1,    -1,    -1,  2742,  2743,
    2744,  2745,  2746,  2747,   313,  3427,    -1,    -1,  2210,    -1,
    3625,  3225,  3226,    -1,    -1,    -1,    -1,   182,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2103,    -1,    -1,
    3452,  3453,   655,  2109,    -1,    -1,    -1,    -1,    -1,  2241,
      -1,  2243,    -1,    -1,  2788,  2789,  2790,  2791,   403,    -1,
      -1,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2149,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3554,    -1,  3506,     0,  3508,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   403,  3517,    -1,    -1,  2842,  3615,
      -1,   410,   411,   412,   413,   414,   415,    -1,  2962,  2963,
    3532,    -1,   421,    -1,  2316,   803,   804,   805,    -1,   742,
     285,  3543,    -1,    -1,   289,    -1,    -1,    -1,    -1,  3599,
     295,   754,  3554,    -1,    -1,    -1,    -1,   302,    -1,  3611,
     763,    -1,    -1,    -1,   309,  3615,   769,    -1,    -1,    -1,
    3364,    -1,   317,    -1,    69,    -1,    -1,   780,    -1,    -1,
     325,    -1,    -1,    -1,  3636,  3635,    -1,    20,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   871,    -1,    38,    -1,   810,    -1,  3611,
      -1,    -1,    -1,  3333,  2396,    -1,    -1,    -1,  3338,  3339,
      -1,    -1,    -1,   118,    -1,   893,    -1,    -1,   373,  2411,
      -1,    -1,   377,   128,  3636,    68,    -1,   132,    -1,    -1,
      -1,    -1,   137,    -1,    -1,    -1,   141,    25,    -1,   144,
      -1,   146,    30,   398,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   864,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2998,   878,    -1,   172,    -1,  2461,
      -1,    17,    -1,    -1,  3404,    -1,  3406,    -1,    -1,    25,
      -1,   124,    -1,    -1,    30,    -1,    -1,   192,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3453,    -1,  2391,    -1,  2519,    -1,    -1,
      -1,   236,    -1,  3067,  3068,    -1,  2402,    -1,    -1,   182,
     245,  1019,    -1,    -1,  3078,  3079,    -1,     0,  3082,  3083,
      -1,    -1,  2418,    -1,    -1,    -1,    -1,  3201,  2550,    -1,
      -1,    -1,   163,    -1,   152,    -1,    -1,   168,   156,    -1,
      25,  2563,    -1,    -1,    -1,    30,  2442,    -1,  3508,    -1,
    2446,  3225,  3226,   288,    -1,    -1,    -1,  3517,   176,   177,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3133,
      -1,    -1,    -1,   191,  2470,  2597,   152,  2473,    -1,    -1,
     156,    -1,    -1,  3543,  2480,    -1,    69,    -1,    -1,  2485,
      -1,    -1,    -1,    -1,  1037,  3159,    -1,   332,    -1,    -1,
     176,   177,    -1,    -1,  1112,    -1,    -1,    -1,    -1,   227,
    2506,    -1,   285,    -1,    -1,   191,   289,    -1,    -1,   354,
      -1,    -1,   295,   241,    -1,    -1,    -1,    -1,    -1,   302,
      -1,    -1,    -1,    -1,    -1,   118,   309,    -1,    -1,  1082,
     375,    -1,   377,   378,   317,   128,    -1,    -1,   224,   132,
      -1,   227,   325,    -1,   137,  1163,    -1,    -1,   141,    -1,
      -1,   144,    -1,   146,    -1,   241,    -1,   152,   244,    -1,
      -1,   156,    -1,    -1,  1182,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   417,    -1,    -1,   420,    -1,   422,   423,   172,
    3364,   176,   177,    -1,    -1,   313,  3260,    -1,    -1,    -1,
     373,    -1,    -1,    -1,   377,   378,   191,    -1,    -1,   192,
      -1,    -1,    -1,  3277,    -1,    -1,    -1,  3281,  2614,  2615,
      -1,    -1,    -1,    -1,    -1,   398,    -1,    -1,    17,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    25,   313,    -1,   224,
      -1,    30,   227,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   236,    -1,    -1,   241,    -1,    -1,    -1,
      -1,    -1,   245,    -1,    -1,    -1,    -1,  3331,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   403,    -1,    -1,  2810,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,    -1,    -1,
      42,  1244,  1310,   421,    -1,   288,    -1,    -1,    17,    -1,
      -1,  1319,    21,    55,  1257,    -1,    25,    -1,    -1,    -1,
      62,    30,    -1,    -1,    66,    -1,    -1,   403,   313,    -1,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
      -1,    -1,  1350,  1351,    86,   421,    -1,    -1,   424,   332,
      -1,    -1,    -1,  1296,    -1,    -1,    -1,  1300,    -1,    -1,
     491,    -1,    -1,   152,    -1,   107,  1309,   156,  1311,    -1,
    1313,   354,    -1,    -1,    -1,  1318,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,    -1,
    2786,   100,   375,    -1,   377,   378,    -1,   139,    -1,   530,
      -1,    -1,   191,    -1,    -1,    -1,   537,  2803,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   159,   403,    -1,
      -1,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,    -1,    -1,    -1,   417,   224,   421,   420,   227,   422,
     423,   183,    -1,   152,    -1,    -1,  2968,   156,    -1,    -1,
      -1,    -1,   241,    -1,    -1,   244,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,  2865,
    1478,    -1,    -1,    -1,  2870,    -1,    -1,  2873,    -1,  1487,
      -1,    -1,   191,    -1,    -1,    -1,    -1,    -1,   619,    -1,
    3554,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,
      -1,    -1,  3024,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3032,    -1,    -1,    -1,    -1,   224,    -1,    -1,   227,    -1,
      -1,    -1,   653,    -1,   313,    -1,   268,    -1,    -1,    -1,
      -1,    -1,   241,    -1,    -1,   244,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3611,    -1,    -1,
     292,    -1,    -1,    -1,   296,    -1,   298,    -1,    -1,    -1,
      -1,    -1,   304,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3636,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2979,  2980,  2981,  2982,    -1,    17,    -1,
     332,   333,    -1,    -1,    -1,   337,    25,    -1,    -1,    -1,
      -1,    30,    -1,   345,   313,    -1,    -1,    -1,   350,    -1,
      -1,    -1,  1620,    -1,   403,    -1,    -1,   406,   407,   408,
     751,   410,   411,   412,   413,   414,   415,   758,    17,    -1,
     372,    20,   421,    -1,    -1,   424,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    -1,    -1,    -1,   779,    -1,
      -1,    -1,   361,    -1,    -1,    -1,    -1,    -1,    -1,  3181,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   809,    -1,
      -1,    -1,    -1,  3205,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   403,    -1,    -1,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,    -1,    -1,    -1,
      -1,    -1,   421,    -1,    -1,    -1,    -1,  1660,    -1,  1727,
     851,    -1,  1665,   152,    -1,    -1,    -1,   156,  1671,    -1,
      -1,    -1,  3128,    -1,  1677,    -1,    -1,    -1,    -1,    -1,
    1683,    -1,    -1,    -1,    -1,    -1,  1689,   176,   177,   880,
      -1,  1694,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3155,
      -1,    -1,   191,   152,    -1,    -1,    -1,   156,    -1,    -1,
      -1,   902,    -1,    -1,  1717,  1718,  1719,  1720,    -1,    -1,
    3176,  1724,  1725,    -1,    -1,    -1,  1729,   176,   177,  1732,
      -1,    -1,    -1,    -1,    -1,   224,    25,    -1,   227,   930,
      -1,    30,   191,  1746,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   241,  1756,    -1,  1758,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1768,  1769,  1770,    -1,  1772,
      -1,   962,   963,    -1,   965,   224,  1779,  1780,   227,    -1,
    1848,    17,    -1,  3365,  1787,  1788,    -1,    -1,    -1,    25,
      -1,   982,   241,    -1,    30,   244,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1874,  3263,    -1,    -1,
      -1,    -1,    -1,  1881,  3396,    -1,    -1,    -1,  3400,  3401,
      -1,    -1,    -1,    -1,   313,    -1,    -1,    -1,    -1,    -1,
    1021,  1022,    -1,    -1,    -1,    -1,    -1,    -1,  3294,    -1,
      -1,  3297,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1048,    -1,    -1,
      -1,  1052,  1053,   152,   313,    -1,  3322,   156,    -1,    -1,
      -1,  1062,    -1,    -1,    -1,  1066,    -1,    -1,  3334,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,    -1,
    3346,    -1,    -1,    -1,    -1,    -1,   132,    -1,    -1,    -1,
      -1,   137,   191,    -1,    -1,    -1,    -1,    -1,    -1,  1100,
      -1,    -1,    -1,    -1,   403,    -1,   152,   406,   407,   408,
     156,   410,   411,   412,   413,   414,   415,    -1,    -1,    -1,
      -1,  1122,   421,    -1,  3390,    -1,    -1,    -1,   227,    25,
     176,   177,    -1,    -1,    30,    -1,    -1,    -1,    -1,   398,
      -1,    -1,   241,    -1,   403,   191,    -1,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,    -1,    -1,    -1,
    1973,    -1,   421,    -1,    -1,    -1,  3432,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,
      -1,   227,    -1,  1184,    -1,    -1,  3452,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,   244,    -1,
    1201,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   779,
      -1,    -1,    -1,    -1,   313,    -1,    -1,    -1,    -1,  1220,
      -1,   117,    -1,    -1,    -1,  2103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   779,    -1,
      -1,    -1,  1243,    -1,    -1,    -1,    -1,  1248,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   152,    -1,    -1,    -1,
     156,    -1,    -1,    -1,    -1,    -1,    -1,   313,    -1,    -1,
      -1,  2149,    -1,  3539,    -1,    -1,    -1,    -1,    -1,    -1,
     176,   177,    -1,    -1,    -1,  1286,    -1,  1288,    -1,    -1,
      -1,    -1,    -1,  1294,    -1,   191,  1297,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   403,    -1,    -1,   406,   407,   408,
     880,   410,   411,   412,   413,   414,   415,    -1,    -1,    -1,
      -1,    -1,   421,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   227,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   880,
      -1,    -1,    -1,    -1,    -1,   241,  1347,    -1,    -1,    -1,
    2163,  2164,    -1,    -1,    -1,    -1,    -1,   403,    -1,  3625,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
      -1,    -1,    -1,    -1,  2187,   421,    -1,    -1,    -1,    -1,
    1381,  1382,    -1,    -1,    -1,    -1,    -1,    -1,  1389,    -1,
      -1,  1392,    -1,    -1,  1395,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1403,  1404,    -1,    -1,  2219,  2220,  2221,  2222,
    1411,    -1,    -1,  1414,  1415,  1416,  1417,   313,    -1,    -1,
      -1,    -1,    -1,  1424,  1425,    -1,  1427,    -1,  1429,    -1,
      -1,  1432,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1447,  1448,    17,    -1,
    1451,    -1,    -1,    -1,  1455,    -1,    25,    -1,  1459,    -1,
      -1,    30,  1463,  1464,  1465,  1466,  1467,  1468,  1469,  1470,
    1471,  1472,    -1,  1474,    17,    -1,    -1,    -1,  1479,    -1,
      -1,  1482,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    -1,  1062,  2306,    -1,    -1,    -1,    -1,  2311,    -1,
      -1,    -1,    -1,    -1,    -1,    25,    -1,   403,    -1,    -1,
      30,    -1,    -1,  2391,   410,   411,   412,   413,   414,   415,
      -1,  1062,    -1,    -1,  2402,   421,    -1,    -1,    -1,    -1,
    1100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1122,    17,    -1,    -1,    20,    -1,    -1,  1100,
      -1,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1122,    -1,   152,  2397,    -1,  2399,   156,    -1,    -1,
      -1,    -1,  2470,    -1,    -1,  2473,    -1,   117,    -1,    -1,
      -1,    -1,  2480,  2416,    -1,    -1,    -1,   176,   177,   152,
      -1,    -1,    -1,   156,  1184,    -1,    -1,    -1,    -1,    -1,
      -1,  1622,   191,    -1,    -1,    -1,    -1,    -1,  2506,    -1,
      -1,  1201,   152,   176,   177,    -1,   156,    -1,    -1,    -1,
      -1,    -1,    -1,  1184,    -1,    -1,    -1,    -1,   191,  2462,
    1220,   619,    -1,    -1,    -1,   224,   176,   177,   227,    -1,
    1201,  1662,  2475,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   191,   241,  1243,    -1,   244,    -1,    -1,    -1,  1220,
    1681,   224,    -1,    -1,   227,   653,    -1,    -1,   152,    -1,
      -1,    -1,   156,   262,    -1,    -1,    -1,    -1,   241,    -1,
    1701,   244,  1243,    -1,    -1,  1706,  1707,   227,    -1,    -1,
      -1,    -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   241,    -1,    -1,  1294,    -1,    -1,   191,    -1,  1730,
      -1,    -1,    -1,    -1,    -1,    -1,  2614,  2615,    -1,    -1,
      -1,    -1,    -1,    -1,   313,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1294,    -1,    -1,    -1,   326,    -1,    -1,
     224,  1762,    -1,   227,    -1,    -1,    -1,    -1,    -1,    -1,
     313,    -1,    -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,
     244,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   313,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1822,    -1,  1824,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   403,    -1,    -1,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,    -1,    -1,   313,
      -1,    -1,   421,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     403,    -1,    -1,   406,   407,   408,    -1,   410,   411,   412,
     413,   414,   415,    -1,    -1,    -1,    -1,   420,   421,    -1,
      -1,  1882,    -1,   403,    -1,    -1,    -1,    -1,  1889,    -1,
     410,   411,   412,   413,   414,   415,    -1,    -1,  1899,    -1,
      -1,   421,  1472,    -1,    -1,    -1,    -1,  2720,  2786,    -1,
      -1,    -1,  2725,    -1,  2727,  2728,  2729,  2730,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2803,    -1,    -1,    -1,    -1,
      -1,  1472,  1933,    -1,   902,    -1,    -1,    -1,    -1,   403,
      -1,    -1,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,    -1,    -1,    -1,  1956,    -1,   421,    -1,    -1,
     779,    -1,   930,    -1,    -1,     8,  1967,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2792,
    2793,  2794,    -1,  2796,    -1,  1986,  1987,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   962,   963,    -1,   965,    -1,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    -1,    -1,   982,  2016,  2017,    -1,    61,    -1,
    2021,    -1,    -1,    -1,    -1,    -1,    -1,    70,    71,    72,
      -1,    -1,  2033,  2034,  2035,  2036,    -1,    -1,    -1,    -1,
    2041,    -1,    -1,    -1,  2045,  2046,    -1,  2048,    -1,    -1,
    2051,    -1,    -1,  1021,    -1,    -1,    -1,    -1,    -1,  2060,
    2061,   880,  2063,    -1,    -1,  2878,    -1,    -1,    -1,    -1,
      -1,   114,    -1,    -1,    -1,  2076,    -1,  2078,    -1,    -1,
    1048,  2082,    -1,    -1,  1052,  1053,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   117,    -1,    -1,  2099,    -1,
      -1,  2979,  2980,  2981,  2982,    -1,    -1,    -1,  2109,    -1,
    2111,  2112,  2113,   156,    -1,    -1,    -1,    -1,   161,    -1,
      -1,    -1,    -1,    -1,  2125,    -1,    -1,    -1,    -1,    -1,
     152,  1701,  2133,    -1,   156,    -1,  1706,  1707,    -1,  2140,
      -1,    -1,    -1,    -1,  2145,    -1,    -1,    -1,    -1,    -1,
      -1,  2152,  2153,  2154,   176,   177,    -1,   200,    -1,    -1,
    1701,    -1,    -1,    -1,    -1,  1706,  1707,    -1,    -1,   191,
      -1,    -1,    -1,  2174,   217,   218,   219,   220,   221,    -1,
     223,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1009,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2200,
    2201,    -1,  2203,    -1,    -1,   227,    -1,    -1,    -1,  2210,
      -1,    -1,    -1,   256,    -1,    -1,  3029,    -1,    -1,   241,
      -1,    -1,    -1,    -1,    17,    -1,    -1,  3040,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
    2241,    -1,  2243,  1062,    -1,    -1,    -1,    -1,    -1,   292,
    3128,    -1,    -1,    -1,  1824,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2277,  2278,  2279,    -1,
      -1,  1100,    -1,  1824,    -1,   328,    -1,   330,    -1,    -1,
      -1,   313,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1122,    -1,    -1,    -1,    -1,    -1,    -1,
     353,    -1,  1882,    -1,    -1,  2316,  3129,   360,    -1,    -1,
     363,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3147,    -1,    -1,    -1,  2339,    -1,
      -1,  1882,    -1,    -1,   137,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   152,
      -1,   779,    25,   156,    -1,  1184,    -1,    30,    -1,    -1,
      -1,  2372,  2373,    -1,    -1,    -1,    -1,    -1,  3191,    -1,
      -1,   403,  1201,   176,   177,    -1,    -1,    -1,   410,   411,
     412,   413,   414,   415,    -1,  2396,    -1,  1967,   191,   421,
      -1,  1220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2411,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3297,
      -1,  1389,   779,    -1,  1243,  2426,  1967,    -1,    -1,    -1,
      -1,   224,    10,    -1,   227,    -1,    -1,    -1,    -1,    -1,
      -1,  2442,    -1,  1411,  3322,  2446,  1414,    -1,   241,  1417,
      -1,   244,    -1,    -1,   117,  2456,  1424,  1425,    -1,    -1,
    2461,  1429,   880,    -1,  1432,    -1,    -1,    -1,  3346,    -1,
      -1,    -1,    -1,    -1,    -1,  1294,    -1,    -1,    -1,  1447,
      -1,    -1,    -1,  1451,  2485,    -1,    -1,  1455,    66,   152,
      -1,  1459,    -1,   156,    -1,  1463,  1464,  1465,  1466,  1467,
    1468,  1469,  1470,  1471,    -1,    -1,  1474,    -1,    86,    -1,
      -1,  1479,  3390,   176,   177,  2516,    -1,    -1,  2519,    -1,
     313,    -1,    -1,   880,  2525,    -1,    -1,    -1,   191,   107,
    2531,    -1,  2533,    -1,    -1,    -1,    -1,  2538,    -1,    -1,
    2541,  2542,  2543,  2544,  2545,  2546,  2547,  2548,  2549,  2550,
    2551,    -1,    -1,    -1,  2555,  2556,   134,    -1,    -1,    -1,
      -1,   139,  2563,    -1,   227,    -1,   144,  2568,    -1,    -1,
      -1,  2572,    -1,  2574,    -1,    -1,    -1,    -1,   241,    -1,
      -1,   159,    -1,  2584,    -1,    -1,  2587,    -1,  2589,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2597,  2598,  2599,  2600,
      -1,    -1,    -1,  2604,    -1,    -1,  2607,    -1,    -1,    -1,
     403,    -1,    -1,   406,   407,   408,  2617,   410,   411,   412,
     413,   414,   415,    -1,    -1,  2626,    -1,    -1,   421,    -1,
    2200,  2201,    -1,  2203,    -1,    -1,    -1,    -1,    -1,    -1,
    2210,    -1,    -1,    -1,  1062,    -1,    -1,    -1,    -1,    -1,
     313,    -1,    -1,  1472,  1622,    -1,    -1,    -1,    -1,  2200,
    2201,    -1,  2203,   241,    -1,    -1,    -1,    -1,    -1,  2210,
      -1,  2241,    -1,  2243,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1100,    -1,    -1,    -1,  2687,  2688,  2689,    -1,
     268,    -1,    -1,  3506,    -1,    -1,    -1,    -1,    -1,    17,
    2241,    -1,  2243,    -1,  1122,  1062,    -1,    25,    -1,    -1,
      -1,    -1,    30,  1681,   292,  2716,    -1,    -1,    -1,    -1,
     298,    -1,    -1,    -1,    -1,    -1,   304,    -1,   306,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     403,    -1,    -1,  1100,    -1,    -1,  2316,   410,   411,   412,
     413,   414,   415,    -1,   332,   333,    -1,    -1,   421,   337,
      -1,    -1,    -1,    -1,    -1,  1122,  1184,   345,    -1,  2339,
      -1,    -1,   350,    -1,    -1,  2316,    -1,    -1,    -1,    -1,
      -1,    -1,   360,  1201,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   372,    -1,  2797,    -1,  2339,    -1,
      -1,    -1,  1220,  2373,    -1,    -1,    -1,    -1,    -1,  2810,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1243,  2396,  1184,    -1,    -1,
      -1,    -1,  2373,    -1,   152,    -1,    -1,    -1,   156,    -1,
      -1,  2411,    -1,    -1,  1201,    -1,  2847,  2848,  2849,    -1,
      -1,    -1,    -1,    -1,  1822,  2396,  2426,    -1,   176,   177,
      -1,    -1,    -1,  1220,  2865,    -1,    -1,    -1,    -1,  2870,
    2411,    -1,  2873,   191,    -1,    -1,  1294,    -1,    -1,    -1,
      -1,    -1,  1701,    -1,    -1,  2426,  1243,  1706,  1707,    -1,
      -1,  2461,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,    -1,   227,
    2911,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2461,    -1,    -1,   241,    -1,    -1,   244,    -1,    -1,    -1,
      -1,  1899,    -1,    -1,    -1,    -1,    -1,  1294,    -1,   257,
      -1,    -1,    -1,    -1,    -1,    -1,  2947,    -1,    -1,  2519,
      -1,    -1,    -1,  2954,  2955,    -1,  2957,    -1,    -1,    -1,
      -1,  2962,  2963,    -1,    -1,  1933,  2967,  2968,    -1,    -1,
      -1,    -1,  2973,  2974,    -1,    -1,  2977,    -1,  2519,    -1,
    2550,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1956,    -1,
      -1,    -1,    -1,  2563,    -1,   313,  2997,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1824,    -1,    -1,    -1,  2550,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1987,
      -1,    -1,  2563,  3024,    -1,    -1,    -1,  2597,    -1,    -1,
      -1,  3032,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,
      -1,    -1,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      -1,    -1,    30,    -1,  1472,    -1,  2597,    -1,    -1,    -1,
      -1,    -1,    -1,  1882,    -1,  2033,    -1,  2035,  2036,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2045,    -1,    -1,
    2048,    -1,    -1,  2051,    -1,   403,    -1,    -1,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,    -1,    -1,
      -1,    -1,    -1,   421,    -1,    -1,    -1,    -1,  2076,    -1,
    2078,    -1,    17,  3114,  2082,  1472,    -1,    -1,  2688,    -1,
      25,    -1,    -1,  3124,    -1,    30,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2113,    -1,  2688,  1967,    -1,
      -1,    -1,    -1,    -1,  3155,    -1,    -1,  2125,    -1,  3160,
      -1,    -1,    -1,    -1,    -1,  2133,    -1,    -1,    -1,    -1,
      -1,  3172,  2140,    -1,   152,  3176,    -1,  2145,   156,    -1,
    3181,    -1,    -1,    -1,  2152,  2153,  2154,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,
    3201,    -1,    -1,    -1,  3205,    -1,  2174,    -1,    -1,   779,
      -1,    -1,    -1,   191,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3225,  3226,    -1,    -1,  3229,    -1,
      -1,    -1,    -1,    -1,    -1,  3236,  3237,    -1,    -1,    -1,
    2810,    -1,    -1,    -1,    -1,    -1,   224,   152,    -1,   227,
      -1,   156,    -1,    -1,    -1,    -1,    -1,    -1,   779,  3260,
      -1,    -1,  3263,   241,    -1,    -1,   244,    -1,    -1,  2810,
      -1,   176,   177,    -1,    -1,    -1,    -1,  2847,    -1,    -1,
      -1,    -1,    -1,  1701,    -1,    -1,   191,    -1,  1706,  1707,
      -1,    -1,    -1,  3294,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2847,    -1,    -1,    -1,
     880,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,
      -1,    -1,   227,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3334,  3335,   313,   241,    -1,    -1,   244,
    3341,    -1,    -1,    -1,  1701,    -1,    -1,    -1,    -1,  1706,
    1707,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   880,
      -1,    -1,    -1,  3364,  3365,    -1,  3367,    -1,  3369,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2200,  2201,    -1,  2203,    -1,    -1,  2957,    -1,    -1,
      -1,  2210,  3393,    -1,    -1,  3396,    -1,    -1,  2968,  3400,
    3401,    -1,    -1,    -1,    -1,    -1,  1824,    -1,   313,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2957,    -1,    -1,    -1,
      -1,    -1,  2241,  3424,  2243,   403,    -1,  2968,   406,   407,
     408,  3432,   410,   411,   412,   413,   414,   415,    -1,    -1,
      -1,    -1,    -1,   421,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3452,    -1,    -1,  3024,    -1,    -1,    -1,  3459,    -1,
      -1,    -1,  3032,    -1,  1882,    -1,    -1,  1824,    -1,    -1,
      -1,    -1,    -1,    -1,  3475,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3024,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3032,  1062,    -1,    -1,    -1,   779,  2316,   403,    -1,
      -1,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,    -1,    -1,    -1,    -1,   420,   421,    -1,    17,    -1,
    2339,    20,    -1,    -1,    -1,  1882,    25,    -1,    -1,    -1,
    1100,    30,    -1,    -1,    -1,    -1,    -1,    -1,  3539,    -1,
      -1,  1062,    -1,    -1,    -1,    25,    -1,    -1,  2516,  1967,
      30,    -1,  1122,    -1,  2373,    -1,    -1,  2525,    -1,    -1,
      -1,    -1,    -1,  2531,    -1,  2533,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2396,    -1,  1100,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2555,  2556,    -1,
    3160,    -1,  2411,    -1,    -1,    -1,    -1,   880,    -1,    -1,
      -1,  1122,    -1,    -1,    -1,    -1,  2574,  2426,    -1,    -1,
    1967,  3181,    -1,    -1,  1184,    -1,  2584,    -1,    -1,  2587,
      -1,  2589,    -1,    -1,  3625,    -1,    -1,    -1,    -1,    -1,
    2598,  1201,    -1,    -1,    -1,  3205,  2604,   117,    -1,  2607,
    3181,    -1,  2461,    -1,    -1,    -1,    -1,    -1,    -1,  2617,
    1220,    -1,    -1,   152,    -1,    -1,    -1,   156,  2626,    -1,
      -1,    -1,    10,  1184,  3205,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   152,  1243,    22,    -1,   156,   176,   177,    -1,
    1201,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3260,    -1,   191,    -1,    42,    -1,   176,   177,    -1,  1220,
    2519,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   191,    -1,    -1,    -1,    -1,    -1,    -1,    66,  3260,
      -1,    -1,  1243,    -1,  1294,   224,    -1,    -1,   227,    -1,
      -1,  2550,    -1,    -1,    -1,    -1,    -1,    -1,    86,    -1,
      -1,    -1,   241,    -1,  2563,   244,    -1,   227,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   107,
      -1,   241,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3341,    -1,  1294,    -1,    -1,    -1,    -1,  2597,  1062,
      -1,    -1,  2200,  2201,    -1,  2203,   134,    -1,    -1,    -1,
      -1,   139,  2210,    -1,    -1,  3365,   144,    -1,    -1,    -1,
    3341,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   159,    -1,    -1,   313,    -1,    -1,  1100,    -1,    -1,
      -1,    -1,    -1,  2241,  3365,  2243,  3396,    -1,    -1,    -1,
    3400,  3401,    -1,   313,    -1,    -1,    -1,    -1,    -1,  1122,
      -1,    -1,    -1,  2200,  2201,    -1,  2203,    -1,    -1,    -1,
      -1,    -1,    -1,  2210,    -1,  3396,    -1,    -1,    -1,  3400,
    3401,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2688,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2848,  2849,    17,    -1,  2241,    -1,  2243,    -1,    -1,  3459,
      25,    -1,    -1,   241,    -1,    30,    -1,    -1,  2316,    -1,
      -1,  1184,  1472,   251,   403,    -1,    -1,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,    -1,  1201,    -1,
     268,  2339,   421,   403,    -1,    -1,    -1,    -1,    -1,    -1,
     410,   411,   412,   413,   414,   415,    -1,  1220,    -1,    -1,
      -1,   421,    -1,  2911,   292,    -1,    -1,    -1,   296,    -1,
     298,  1472,    -1,    -1,    -1,  2373,   304,    -1,   306,  2316,
    1243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2396,    -1,
      -1,    -1,  2339,    -1,   332,   333,  2954,  2955,    -1,   337,
      -1,  2810,    -1,  2411,    -1,    -1,    -1,   345,    -1,  2967,
      -1,    -1,   350,    -1,    -1,  2973,  2974,    -1,  2426,  2977,
      -1,  1294,   360,    -1,    -1,    -1,  2373,   152,    -1,    -1,
      -1,   156,    -1,    -1,   372,    -1,    -1,    -1,  2847,  2997,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2396,
      -1,   176,   177,  2461,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2411,    -1,   191,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2426,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,
      -1,    -1,   227,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2519,    -1,    -1,  2461,    -1,   241,    -1,    -1,   244,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1701,  2550,    -1,    -1,    -1,  1706,  1707,  2957,    -1,
      -1,    -1,    -1,    -1,    -1,  2563,  3114,    -1,    -1,  2968,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2519,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   313,  2597,
    1701,    -1,    -1,    -1,    -1,  1706,  1707,    -1,    -1,  1472,
      -1,    -1,    -1,  2550,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,   338,  3172,  3024,  2563,    -1,    -1,    13,
      -1,    15,    16,  3032,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2597,    -1,    -1,    -1,    -1,    49,    -1,    51,    52,    -1,
      -1,    -1,    56,    57,  1824,    -1,    -1,    -1,    -1,    -1,
      -1,  3229,    -1,    67,    -1,    69,    -1,    -1,   403,  3237,
    2688,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,    -1,    -1,    -1,    88,    -1,   421,    91,    -1,    -1,
      -1,    -1,    -1,    97,    -1,    -1,    -1,    -1,    -1,   103,
      -1,    -1,    -1,  1824,    -1,   109,    -1,    -1,    -1,    -1,
      -1,   115,  1882,    17,    -1,    -1,    20,   121,    -1,   123,
      -1,    25,    -1,    -1,   128,    -1,    30,    -1,    -1,    -1,
      -1,  2688,    -1,    -1,    -1,    -1,    -1,   141,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1882,  3181,    -1,   168,    -1,    -1,  3335,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3205,    -1,    -1,   193,
     194,    -1,  2810,    -1,    -1,   199,    -1,  1967,    -1,  3367,
      -1,    -1,    -1,    -1,   208,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1701,    -1,
      -1,    -1,   226,  1706,  1707,  3393,    -1,    -1,    -1,  2847,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3260,    -1,    -1,    -1,    -1,  1967,    -1,   152,    -1,
      -1,    -1,   156,  2810,    -1,    -1,    -1,    -1,    -1,   263,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     274,    -1,   176,   177,   278,    -1,   280,    -1,   978,    -1,
      -1,   285,    -1,    -1,    -1,    -1,   290,   191,    17,   293,
    2847,    -1,    -1,   297,    -1,    -1,    25,    -1,    -1,   303,
      -1,    30,    -1,    -1,    -1,   309,    -1,    -1,   312,    -1,
      -1,    -1,    -1,    -1,    -1,   319,    -1,    -1,    -1,    -1,
     224,    -1,  3341,   227,    -1,    -1,    -1,    -1,   332,    -1,
      -1,    -1,    -1,  1033,    -1,    -1,    -1,   241,    -1,  2957,
     244,  1824,    -1,    -1,   348,    -1,  3365,    -1,    -1,    -1,
    2968,    -1,    -1,   357,    -1,   359,    -1,    -1,   362,    -1,
      -1,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   378,    -1,    -1,  3396,    -1,    -1,
      -1,  3400,  3401,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1882,
    2957,    -1,    -1,    -1,    -1,    -1,  3024,    -1,    -1,   313,
      -1,  2968,    -1,    -1,  3032,   419,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   152,    -1,    -1,    -1,   156,    -1,    -1,
    2200,  2201,    -1,  2203,    -1,    -1,    -1,    -1,    -1,    -1,
    2210,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   191,    -1,    -1,    -1,    -1,  3024,    -1,    -1,
      -1,  2241,    -1,  2243,    -1,  3032,    -1,    -1,    -1,  2200,
    2201,    -1,  2203,    -1,  1967,    -1,    -1,    -1,    -1,  2210,
      -1,    -1,    -1,    -1,    -1,   224,    -1,    -1,   227,   403,
      -1,    -1,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   241,    -1,    -1,   244,    -1,   421,    -1,    -1,
    2241,    -1,  2243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2316,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3181,    -1,    -1,    -1,    -1,    -1,  2339,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   313,    -1,    -1,  3205,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2316,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2373,    -1,    -1,    -1,    17,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    25,    -1,    -1,  2339,    -1,
      30,    -1,    -1,    -1,  3181,    -1,  2396,    -1,  1328,    -1,
      17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    25,    -1,
      -1,  2411,  3260,    30,    -1,    -1,    -1,    -1,  3205,    -1,
      -1,    -1,  2373,    -1,    -1,    -1,  2426,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   403,  2396,    -1,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,  1387,    -1,   418,
    2411,  2461,   421,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3260,    -1,  2426,    -1,    -1,    -1,    -1,
    1410,    -1,    -1,    17,    -1,  1415,    -1,  2200,  2201,    -1,
    2203,    25,    -1,  3341,    -1,    -1,    30,  2210,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1435,  1436,    -1,    -1,  1439,
    2461,    -1,   152,    -1,    -1,    -1,   156,  3365,    -1,  2519,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2241,    -1,
    2243,    -1,    17,    -1,    -1,   152,   176,   177,    -1,   156,
      25,    -1,    -1,    -1,    -1,    30,    -1,  1477,  3396,    -1,
    2550,   191,  3400,  3401,  3341,    -1,    -1,    -1,    -1,   176,
     177,    -1,    -1,  2563,    -1,    -1,    -1,    -1,  2519,    -1,
      -1,    -1,    -1,    -1,   191,    -1,    -1,    -1,  3365,    -1,
      -1,    -1,    -1,    -1,   224,    -1,    -1,   227,    -1,    -1,
    1520,    -1,    -1,    -1,    -1,    -1,    -1,  2597,    -1,  2550,
      -1,   241,    -1,  2316,   244,    -1,    -1,   224,    -1,  3396,
     227,    -1,  2563,  3400,  3401,    -1,    -1,    -1,   152,    -1,
      -1,    -1,   156,    -1,   241,    -1,  2339,   244,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   176,   177,    -1,    -1,  2597,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,    -1,    -1,
    2373,    -1,    -1,    -1,    -1,    -1,    -1,   152,    -1,    -1,
      -1,   156,    -1,   313,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2396,    -1,    -1,    -1,    -1,  2688,    -1,
     224,   176,   177,   227,    -1,    -1,   313,    -1,  2411,    -1,
      -1,  1631,    -1,    -1,    -1,    -1,   191,   241,    -1,    -1,
     244,  1641,    -1,  2426,  1644,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2688,    -1,   224,
      -1,    -1,   227,    -1,    -1,    -1,    -1,    -1,  2461,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,   244,
      -1,    -1,    -1,   403,    -1,    -1,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,    -1,    -1,    -1,   313,
     420,   421,    -1,    -1,    -1,    -1,   403,    -1,    -1,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,    -1,
      -1,    -1,    -1,   420,   421,    -1,  2519,    -1,    -1,    -1,
    2810,    -1,    -1,    17,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    -1,    -1,    30,    -1,   313,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2550,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    17,    -1,  2847,    -1,    -1,
    2563,    -1,    -1,    25,    -1,    -1,    -1,    -1,    30,  2810,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   403,
      -1,    -1,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,    -1,    -1,  2597,    -1,   420,   421,    -1,    -1,
      -1,    17,    -1,    -1,    -1,    -1,  2847,    -1,    -1,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   403,    -1,
      -1,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,    -1,    -1,    -1,    -1,   420,   421,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   152,    -1,
      -1,    -1,   156,    -1,    -1,    -1,    -1,  2957,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2968,    -1,
      -1,    -1,   176,   177,    -1,  2688,    -1,    -1,    -1,    -1,
     152,    -1,    -1,    -1,   156,    -1,    -1,   191,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   176,   177,  2957,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2968,    -1,   191,
     224,    -1,    -1,   227,  3024,    -1,   152,    -1,    -1,    -1,
     156,    -1,  3032,    -1,    -1,    -1,    -1,   241,    -1,    -1,
     244,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     176,   177,   224,    -1,    -1,   227,    -1,    -1,    -1,    -1,
    1990,    -1,    -1,    -1,    -1,   191,    -1,    -1,    -1,   241,
      -1,    -1,   244,  3024,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3032,  2012,    -1,  2014,    -1,  2016,  2017,  2018,    -1,
      -1,  2021,    -1,    -1,    -1,  2025,    -1,  2810,   224,    -1,
      -1,   227,  2032,    -1,    -1,    -1,    -1,  2037,    -1,   313,
      -1,    -1,  2042,    -1,    -1,   241,    -1,  2047,   244,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2056,    -1,    -1,    -1,
    2060,  2061,  2062,    -1,  2847,    -1,    -1,    -1,    -1,    -1,
      -1,   313,    -1,    -1,  2074,    -1,    -1,    -1,    -1,    -1,
      -1,  2081,    -1,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,    17,  2093,    -1,    -1,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    17,    -1,
      -1,  3181,    -1,    -1,    -1,    -1,    25,   313,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   403,
      -1,    -1,   406,   407,   408,  3205,   410,   411,   412,   413,
     414,   415,    -1,    -1,    -1,    -1,   420,   421,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3181,   403,    -1,    -1,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,  2957,    -1,    -1,    -1,   420,   421,
      -1,    -1,  2182,    -1,  3205,  2968,    -1,    -1,    -1,    -1,
    3260,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   403,    -1,    -1,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
      -1,    -1,    -1,    -1,   420,   421,    -1,   152,    -1,    -1,
      -1,   156,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3260,
      -1,  3024,    -1,   152,    -1,    -1,    -1,   156,    -1,  3032,
      -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   191,   176,   177,    -1,
      -1,  3341,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   191,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3365,    -1,    -1,    -1,   224,
      17,    -1,   227,    -1,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    -1,    -1,    30,    -1,   224,   241,    -1,   227,   244,
    3341,    -1,    -1,    -1,    -1,    -1,  3396,    -1,    -1,    -1,
    3400,  3401,   241,    -1,    -1,   244,    -1,    -1,    -1,    -1,
      -1,    -1,  2342,    -1,  3365,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3396,    -1,    -1,    -1,  3400,
    3401,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   313,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3181,    -1,
      -1,    -1,    -1,    -1,   313,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3205,    -1,    -1,    -1,    -1,    -1,    17,    -1,
      -1,    -1,    -1,    -1,    -1,   152,    25,    -1,    -1,   156,
      -1,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2458,   176,
     177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   191,    -1,    -1,  3260,   403,  2479,
      -1,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,    -1,    -1,    -1,   403,   420,   421,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,   224,    -1,    -1,
     227,   420,   421,    -1,    -1,  2515,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   241,    -1,    -1,   244,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2536,  2537,  2538,    -1,
      -1,  2541,  2542,  2543,  2544,  2545,  2546,  2547,  2548,  2549,
      -1,  2551,  2552,    -1,    -1,    -1,    -1,    -1,  3341,    -1,
      -1,    -1,    -1,   152,    -1,    -1,    -1,   156,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2575,    -1,    -1,  2578,    -1,
    2580,    -1,  3365,    -1,    -1,  2585,  2586,   176,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   313,    -1,    -1,  2599,
    2600,  2601,   191,  2603,    -1,    -1,  2606,    -1,    -1,    -1,
      -1,    -1,    -1,  3396,    -1,    -1,    -1,  3400,  3401,    -1,
      -1,  2621,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2631,    -1,    -1,    -1,   224,    -1,    -1,   227,    -1,
      -1,    -1,    -1,    -1,  2644,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   241,    -1,    -1,   244,    10,  2657,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   403,    -1,    42,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,    -1,
      -1,    -1,    -1,   420,   421,    -1,    -1,    -1,    62,    -1,
      -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   313,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   107,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     134,    -1,    -1,    -1,    -1,   139,   140,    -1,    -1,    -1,
     144,    -1,    -1,    -1,    -1,    -1,    -1,  2797,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   159,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   403,    -1,    -1,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,    -1,   182,    -1,
      -1,    -1,   421,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   195,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,
     244,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2912,    -1,   268,  2915,  2916,  2917,    -1,  2919,
      -1,    -1,    -1,    -1,  2924,  2925,  2926,  2927,  2928,  2929,
    2930,  2931,  2932,    -1,  2934,  2935,  2936,    -1,   292,    -1,
      -1,    -1,   296,    -1,   298,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   306,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2961,  2962,  2963,  2964,    -1,  2966,    -1,    -1,    -1,
    2970,  2971,  2972,    -1,    -1,  2975,    -1,    -1,  2978,   333,
     334,    -1,   336,   337,    -1,  2985,    -1,    -1,    -1,    -1,
      -1,   345,    -1,    -1,    -1,   349,   350,    -1,    -1,    -1,
      -1,   355,    -1,    -1,    -1,    -1,   360,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3116,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3157,  3158,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3197,    -1,    -1,
      -1,  3201,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3213,    -1,  3215,    -1,    -1,    -1,    -1,
    3220,  3221,  3222,    -1,    -1,  3225,  3226,  3227,  3228,    -1,
    3230,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3244,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3300,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3349,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3363,  3364,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3377,  3378,  3379,
      -1,  3381,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
    3450,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    -1,    74,    75,    -1,  3465,    -1,    -1,    -1,    -1,
      -1,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,  3482,    95,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,   124,   125,    -1,   127,    -1,   129,   130,   131,
      -1,   133,    -1,   135,    -1,    -1,    -1,   139,   140,    -1,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,    -1,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,   194,   195,    -1,    -1,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
      -1,   213,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,   226,    -1,   228,    -1,   230,   231,
     232,   233,   234,    -1,    -1,   237,    -1,    -1,    -1,   241,
     242,   243,    -1,    -1,   246,    -1,    -1,    -1,   250,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,    -1,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,    -1,
      -1,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,    -1,   356,   357,   358,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,    -1,   369,    -1,   371,
     372,   373,    -1,    -1,   376,    -1,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,    -1,    -1,   398,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,   417,    -1,    -1,    19,    -1,
     422,    22,    23,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      61,    -1,    63,    64,    65,    66,    67,    68,    -1,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    -1,    95,    96,    97,    98,    99,    -1,
     101,   102,   103,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,   116,   117,    -1,   119,   120,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,    -1,   133,    -1,   135,   136,    -1,   138,   139,   140,
      -1,   142,   143,    -1,   145,    -1,   147,   148,   149,   150,
     151,   152,   153,   154,   155,    -1,   157,   158,   159,   160,
     161,   162,    -1,   164,   165,   166,   167,   168,   169,   170,
     171,    -1,   173,    -1,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,   189,   190,
     191,    -1,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,    -1,    -1,   237,   238,    -1,    -1,
     241,   242,   243,    -1,    -1,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,    -1,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,    -1,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,    -1,   333,   334,   335,   336,   337,    -1,   339,   340,
      -1,    -1,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,    -1,    -1,   376,    -1,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,   410,
     411,   412,    -1,    -1,    -1,    -1,    -1,    -1,   419,   420,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    19,    -1,    -1,    22,
      23,    -1,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    61,    -1,
      63,    64,    65,    66,    67,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    -1,    95,    96,    97,    98,    99,    -1,   101,   102,
     103,    -1,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,   116,   117,    -1,   119,   120,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,    -1,
     133,    -1,   135,   136,    -1,   138,   139,   140,    -1,   142,
     143,    -1,   145,    -1,   147,   148,   149,   150,   151,   152,
     153,   154,   155,    -1,   157,   158,   159,   160,   161,   162,
      -1,   164,   165,   166,   167,   168,   169,   170,   171,    -1,
     173,    -1,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,   189,   190,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,    -1,    -1,   237,   238,    -1,    -1,   241,   242,
     243,    -1,    -1,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
      -1,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,    -1,
     333,   334,   335,   336,   337,    -1,   339,   340,    -1,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,    -1,   369,   370,   371,   372,
     373,    -1,    -1,   376,    -1,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,    -1,    -1,    -1,   410,   411,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   419,   420,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    20,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    61,    -1,    63,    64,
      65,    66,    67,    68,    -1,    70,    71,    72,    73,    74,
      75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    -1,
      95,    96,    97,    98,    99,    -1,   101,   102,   103,    -1,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,   116,   117,    -1,   119,   120,   121,   122,   123,   124,
     125,    -1,   127,    -1,   129,   130,   131,    -1,   133,    -1,
     135,    -1,    -1,   138,   139,   140,    -1,   142,   143,    -1,
     145,    -1,   147,   148,   149,   150,   151,    -1,   153,   154,
     155,    -1,   157,   158,   159,   160,   161,   162,    -1,   164,
     165,   166,   167,   168,   169,   170,   171,    -1,   173,    -1,
     175,    -1,    -1,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,   189,   190,    -1,    -1,   193,   194,
     195,    -1,    -1,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,   216,   217,   218,   219,   220,   221,   222,   223,    -1,
     225,   226,    -1,   228,    -1,   230,   231,   232,   233,   234,
      -1,    -1,   237,    -1,    -1,    -1,   241,   242,   243,    -1,
      -1,   246,    -1,    -1,    -1,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
      -1,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,    -1,   304,
     305,   306,   307,    -1,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,    -1,   333,   334,
     335,   336,   337,    -1,   339,   340,    -1,    -1,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
      -1,   356,   357,   358,   359,    -1,    -1,   362,   363,   364,
     365,   366,   367,    -1,   369,    -1,   371,   372,   373,    -1,
      -1,   376,    -1,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,    -1,    -1,   398,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,   420,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    -1,    -1,    -1,    56,    57,    58,
      59,    60,    61,    -1,    63,    64,    65,    66,    67,    68,
      -1,    70,    71,    72,    73,    74,    75,    -1,    -1,    -1,
      79,    -1,    -1,    -1,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    -1,    95,    96,    97,    98,
      99,    -1,   101,   102,   103,    -1,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,   116,   117,    -1,
     119,   120,   121,    -1,   123,   124,    -1,    -1,   127,    -1,
     129,   130,   131,    -1,   133,    -1,   135,   136,    -1,   138,
     139,   140,    -1,   142,    -1,    -1,   145,    -1,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,   165,   166,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,    -1,
     189,   190,   191,    -1,   193,   194,   195,    -1,    -1,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,   216,   217,   218,
     219,   220,   221,    -1,   223,    -1,   225,   226,   227,   228,
      -1,    -1,   231,   232,   233,   234,    -1,    -1,   237,    -1,
      -1,    -1,   241,   242,   243,    -1,    -1,   246,   247,   248,
     249,    -1,   251,   252,   253,   254,   255,   256,    -1,   258,
      -1,   260,    -1,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,    -1,   295,   296,   297,   298,
     299,   300,   301,   302,    -1,   304,   305,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
      -1,   330,   331,    -1,   333,   334,   335,   336,   337,    -1,
     339,   340,    -1,    -1,   343,    -1,   345,    -1,    -1,   348,
     349,   350,   351,   352,   353,    -1,    -1,   356,   357,   358,
     359,    -1,    -1,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,    -1,   376,    -1,    -1,
     379,   380,   381,   382,   383,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   392,   393,   394,    -1,    -1,    -1,   398,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,   420,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      -1,    -1,    -1,    56,    57,    58,    59,    60,    61,    -1,
      63,    64,    65,    66,    67,    68,    -1,    70,    71,    72,
      73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,    -1,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    -1,    95,    96,    97,    98,    99,    -1,   101,   102,
     103,    -1,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,   116,   117,    -1,   119,   120,   121,    -1,
     123,   124,    -1,    -1,   127,    -1,   129,   130,   131,    -1,
     133,    -1,   135,   136,    -1,   138,   139,   140,    -1,   142,
      -1,    -1,   145,    -1,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,   165,   166,   167,   168,   169,   170,   171,    -1,
     173,    -1,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,    -1,   189,   190,   191,    -1,
     193,   194,   195,    -1,    -1,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,    -1,   215,   216,   217,   218,   219,   220,   221,    -1,
     223,    -1,   225,   226,   227,   228,    -1,    -1,   231,   232,
     233,   234,    -1,    -1,   237,    -1,    -1,    -1,   241,   242,
     243,    -1,    -1,   246,   247,   248,   249,    -1,   251,   252,
     253,   254,   255,   256,    -1,   258,    -1,   260,    -1,   262,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,    -1,   295,   296,   297,   298,   299,   300,   301,   302,
      -1,   304,   305,   306,   307,    -1,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,    -1,   330,   331,    -1,
     333,   334,   335,   336,   337,    -1,   339,   340,    -1,    -1,
     343,    -1,   345,    -1,    -1,   348,   349,   350,   351,   352,
     353,    -1,    -1,   356,   357,   358,   359,    -1,    -1,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   392,
     393,   394,    -1,    -1,    -1,   398,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    19,    -1,    -1,    22,    23,   420,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    61,    -1,    63,    64,    65,    66,
      67,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    -1,    95,    96,
      97,    98,    99,    -1,   101,   102,   103,    -1,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,   116,
     117,    -1,   119,   120,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,    -1,   133,    -1,   135,   136,
     137,   138,   139,   140,    -1,   142,   143,    -1,   145,    -1,
     147,   148,   149,   150,   151,   152,   153,   154,   155,    -1,
     157,   158,   159,   160,   161,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,    -1,   173,    -1,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,    -1,    -1,
     237,   238,    -1,    -1,   241,   242,   243,    -1,    -1,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
      -1,   258,   259,   260,   261,   262,   263,   264,    -1,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,    -1,   333,   334,   335,   336,
     337,    -1,   339,   340,    -1,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,    -1,   369,   370,   371,   372,   373,    -1,    -1,   376,
      -1,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,    -1,
      -1,    -1,    -1,   410,   411,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   419,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    19,
      -1,    -1,    22,    23,    -1,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    -1,    95,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,    -1,   133,    -1,   135,   136,    -1,   138,   139,
     140,    -1,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,   152,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,   189,
     190,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,    -1,   237,   238,    -1,
      -1,   241,   242,   243,    -1,    -1,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
     340,    -1,    -1,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,    -1,   369,
     370,   371,   372,   373,    -1,    -1,   376,    -1,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,    -1,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,
     410,   411,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   419,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    19,    -1,    -1,    22,
      23,    -1,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    61,    -1,
      63,    64,    65,    66,    67,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    -1,    95,    96,    97,    98,    99,    -1,   101,   102,
     103,    -1,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,   116,   117,    -1,   119,   120,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,    -1,
     133,    -1,   135,   136,    -1,   138,   139,   140,    -1,   142,
     143,    -1,   145,    -1,   147,   148,   149,   150,   151,   152,
     153,   154,   155,    -1,   157,   158,   159,   160,   161,   162,
      -1,   164,   165,   166,   167,   168,   169,   170,   171,    -1,
     173,    -1,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,   189,   190,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,    -1,    -1,   237,   238,    -1,    -1,   241,   242,
     243,    -1,    -1,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
      -1,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,    -1,
     333,   334,   335,   336,   337,    -1,   339,   340,    -1,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,    -1,   369,   370,   371,   372,
     373,    -1,    -1,   376,    -1,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,    -1,    -1,    -1,   410,   411,    -1,
      -1,    -1,    -1,    -1,   417,   418,   419,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    19,    -1,    -1,    22,    23,    -1,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    -1,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    -1,    95,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,    -1,   133,    -1,   135,
     136,    -1,   138,   139,   140,    -1,   142,   143,    -1,   145,
      -1,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,   164,   165,
     166,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,   189,   190,   191,    -1,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
      -1,   237,   238,    -1,    -1,   241,   242,   243,    -1,    -1,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,    -1,    -1,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,    -1,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,    -1,   369,   370,   371,   372,   373,    -1,    -1,
     376,    -1,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
      -1,    -1,   398,   399,   400,   401,   402,   403,   404,   405,
      -1,    -1,    -1,    -1,   410,   411,   412,    -1,    -1,    -1,
      -1,    -1,    -1,   419,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      19,    -1,    -1,    22,    23,    -1,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    61,    -1,    63,    64,    65,    66,    67,    68,
      -1,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    -1,    95,    96,    97,    98,
      99,    -1,   101,   102,   103,    -1,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,   116,   117,    -1,
     119,   120,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,    -1,   133,    -1,   135,   136,    -1,   138,
     139,   140,    -1,   142,   143,    -1,   145,    -1,   147,   148,
     149,   150,   151,   152,   153,   154,   155,    -1,   157,   158,
     159,   160,   161,   162,    -1,   164,   165,   166,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
     189,   190,   191,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,    -1,    -1,   237,   238,
      -1,    -1,   241,   242,   243,    -1,    -1,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,    -1,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,    -1,   333,   334,   335,   336,   337,    -1,
     339,   340,    -1,    -1,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,    -1,
     369,   370,   371,   372,   373,    -1,    -1,   376,    -1,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,    -1,    -1,    -1,
      -1,   410,   411,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     419,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    19,    -1,    -1,
      22,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    -1,    95,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
      -1,   133,    -1,   135,   136,    -1,   138,   139,   140,    -1,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,   189,   190,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,    -1,    -1,   237,   238,    -1,    -1,   241,
     242,   243,    -1,    -1,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,    -1,
      -1,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,    -1,   369,   370,   371,
     372,   373,    -1,    -1,   376,    -1,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,    -1,    -1,   398,   399,   400,   401,
     402,   403,   404,   405,    -1,    -1,    -1,    -1,   410,   411,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   419,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    19,    -1,    -1,    22,    23,    -1,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    61,    -1,    63,    64,
      65,    66,    67,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    -1,
      95,    96,    97,    98,    99,    -1,   101,   102,   103,    -1,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,   116,   117,    -1,   119,   120,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,    -1,   133,    -1,
     135,   136,   137,   138,   139,   140,    -1,   142,   143,    -1,
     145,    -1,   147,   148,   149,   150,   151,   152,   153,   154,
     155,    -1,   157,   158,   159,   160,   161,   162,    -1,   164,
     165,   166,   167,   168,   169,   170,   171,    -1,   173,    -1,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,   189,   190,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
      -1,    -1,   237,   238,    -1,    -1,   241,   242,   243,    -1,
      -1,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
      -1,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,    -1,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,    -1,   333,   334,
     335,   336,   337,    -1,   339,   340,    -1,    -1,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,    -1,   369,   370,   371,   372,   373,    -1,
      -1,   376,    -1,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,    -1,    -1,    -1,    -1,   410,   411,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   419,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    19,    -1,    -1,    22,    23,    -1,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    -1,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    -1,    95,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,    -1,   133,    -1,   135,   136,    -1,
     138,   139,   140,    -1,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,   152,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,   164,   165,   166,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,   189,   190,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,    -1,   237,
     238,    -1,    -1,   241,   242,   243,    -1,    -1,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,    -1,    -1,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,    -1,    -1,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,    -1,    -1,
     398,   399,   400,   401,   402,   403,   404,   405,    -1,    -1,
      -1,    -1,   410,   411,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   419,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    19,    -1,
      -1,    22,    23,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      61,    -1,    63,    64,    65,    66,    67,    68,    -1,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    -1,    95,    96,    97,    98,    99,    -1,
     101,   102,   103,    -1,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,   116,   117,    -1,   119,   120,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,    -1,   133,    -1,   135,   136,    -1,   138,   139,   140,
      -1,   142,   143,    -1,   145,    -1,   147,   148,   149,   150,
     151,   152,   153,   154,   155,    -1,   157,   158,   159,   160,
     161,   162,    -1,   164,   165,   166,   167,   168,   169,   170,
     171,    -1,   173,    -1,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,   189,   190,
     191,    -1,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,    -1,    -1,   237,   238,    -1,    -1,
     241,   242,   243,    -1,    -1,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,    -1,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,    -1,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,    -1,   333,   334,   335,   336,   337,    -1,   339,   340,
      -1,    -1,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,    -1,   369,   370,
     371,   372,   373,    -1,    -1,   376,    -1,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,   410,
     411,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   419,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    19,    -1,    -1,    22,    23,
      -1,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    63,
      64,    65,    66,    67,    68,    -1,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      -1,    95,    96,    97,    98,    99,    -1,   101,   102,   103,
      -1,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,    -1,   133,
      -1,   135,   136,    -1,   138,   139,   140,    -1,   142,   143,
      -1,   145,    -1,   147,   148,   149,   150,   151,   152,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,   189,   190,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,    -1,   237,   238,    -1,    -1,   241,   242,   243,
      -1,    -1,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,    -1,    -1,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,    -1,   369,   370,   371,   372,   373,
      -1,    -1,   376,    -1,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,    -1,    -1,   398,   399,   400,   401,   402,   403,
     404,   405,    -1,    -1,    -1,    -1,   410,   411,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   419,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    19,    -1,    -1,    22,    23,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    61,    -1,    63,    64,    65,    66,
      67,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    -1,    95,    96,
      97,    98,    99,    -1,   101,   102,   103,    -1,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,   116,
     117,    -1,   119,   120,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,    -1,   133,    -1,   135,   136,
      -1,   138,   139,   140,    -1,   142,   143,    -1,   145,    -1,
     147,   148,   149,   150,   151,   152,   153,   154,   155,    -1,
     157,   158,   159,   160,   161,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,    -1,   173,    -1,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,   189,   190,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,    -1,    -1,
     237,   238,    -1,    -1,   241,   242,   243,    -1,    -1,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
      -1,   258,   259,   260,   261,   262,   263,   264,    -1,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,    -1,   333,   334,   335,   336,
     337,    -1,   339,   340,    -1,    -1,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,    -1,   369,   370,   371,   372,   373,    -1,    -1,   376,
      -1,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,    -1,
      -1,    -1,    -1,   410,   411,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   419,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    19,
      -1,    -1,    22,    23,    -1,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    -1,    95,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,    -1,   133,    -1,   135,   136,    -1,   138,   139,
     140,    -1,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,   152,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,   189,
     190,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,    -1,   237,   238,    -1,
      -1,   241,   242,   243,    -1,    -1,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,    -1,    -1,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,    -1,   369,
     370,   371,   372,   373,    -1,    -1,   376,    -1,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,    -1,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,
     410,   411,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   419,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    19,    -1,    -1,    22,
      23,    -1,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    61,    -1,
      63,    64,    65,    66,    67,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    -1,    95,    96,    97,    98,    99,    -1,   101,   102,
     103,    -1,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,   116,   117,    -1,   119,   120,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,    -1,
     133,    -1,   135,   136,    -1,   138,   139,   140,    -1,   142,
     143,    -1,   145,    -1,   147,   148,   149,   150,   151,   152,
     153,   154,   155,    -1,   157,   158,   159,   160,   161,   162,
      -1,   164,   165,   166,   167,   168,   169,   170,   171,    -1,
     173,    -1,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,   189,   190,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,    -1,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,    -1,    -1,   237,   238,    -1,    -1,   241,   242,
     243,    -1,    -1,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
      -1,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,    -1,
     333,   334,   335,   336,   337,    -1,   339,   340,    -1,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,    -1,    -1,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,    -1,   369,   370,   371,   372,
     373,    -1,    -1,   376,    -1,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,    -1,    -1,    -1,   410,   411,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   419,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    19,    -1,    -1,    22,    23,    -1,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    -1,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    -1,    95,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
     116,    -1,    -1,   119,   120,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,    -1,   133,    -1,   135,
     136,    -1,   138,   139,   140,    -1,   142,   143,    -1,   145,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,   164,   165,
     166,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,   189,   190,    -1,    -1,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
      -1,   237,   238,    -1,    -1,   241,   242,   243,    -1,    -1,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,    -1,    -1,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,    -1,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,    -1,   369,   370,   371,   372,   373,    -1,    -1,
     376,    -1,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
      -1,    -1,   398,   399,   400,   401,   402,   403,   404,   405,
      -1,    -1,    -1,    -1,   410,   411,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   419,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      19,    -1,    -1,    22,    23,    -1,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    61,    -1,    63,    64,    65,    66,    67,    68,
      -1,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    -1,    95,    96,    97,    98,
      99,    -1,   101,   102,   103,    -1,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,   116,    -1,    -1,
     119,   120,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,    -1,   133,    -1,   135,   136,    -1,   138,
     139,   140,    -1,   142,   143,    -1,   145,    -1,   147,   148,
     149,   150,   151,    -1,   153,   154,   155,    -1,   157,   158,
     159,   160,   161,   162,    -1,   164,   165,   166,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
     189,   190,    -1,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,    -1,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,    -1,    -1,   237,   238,
      -1,    -1,   241,   242,   243,    -1,    -1,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,    -1,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,    -1,   333,   334,   335,   336,   337,    -1,
     339,   340,    -1,    -1,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,    -1,    -1,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,    -1,
     369,   370,   371,   372,   373,    -1,    -1,   376,    -1,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,    -1,    -1,    -1,
      -1,   410,   411,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     419,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    -1,    95,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,   124,   125,    -1,   127,    -1,   129,   130,   131,
      -1,   133,    -1,   135,   136,    -1,   138,   139,   140,    -1,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,   189,   190,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,   226,   227,   228,    -1,   230,   231,
     232,   233,   234,    -1,    -1,   237,   238,    -1,   240,   241,
     242,   243,    -1,    -1,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,   340,    -1,
      -1,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,    -1,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,    -1,   369,   370,   371,
     372,   373,    -1,    -1,   376,    -1,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,    -1,    -1,   398,    -1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,   419,    22,    23,
      -1,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    63,
      64,    65,    66,    67,    68,    -1,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      -1,    95,    96,    97,    98,    99,    -1,   101,   102,   103,
      -1,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
     124,   125,    -1,   127,    -1,   129,   130,   131,    -1,   133,
      -1,   135,   136,    -1,   138,   139,   140,    -1,   142,   143,
      -1,   145,    -1,   147,   148,   149,   150,   151,   152,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,   189,   190,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,   226,   227,   228,    -1,   230,   231,   232,   233,
     234,    -1,    -1,   237,   238,    -1,   240,   241,   242,   243,
      -1,    -1,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,    -1,    -1,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
      -1,    -1,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,    -1,   369,   370,   371,   372,   373,
      -1,    -1,   376,    -1,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,    -1,    -1,   398,    -1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,   419,    22,    23,    -1,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    -1,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    -1,    95,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,   124,   125,
      -1,   127,    -1,   129,   130,   131,    -1,   133,    -1,   135,
     136,    -1,   138,   139,   140,    -1,   142,   143,    -1,   145,
      -1,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,   164,   165,
     166,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,   189,   190,   191,    -1,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
     226,   227,   228,    -1,   230,   231,   232,   233,   234,    -1,
      -1,   237,   238,    -1,    -1,   241,   242,   243,    -1,    -1,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,    -1,    -1,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,    -1,    -1,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,    -1,   369,   370,   371,   372,   373,    -1,    -1,
     376,    -1,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
      -1,    -1,   398,    -1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,   419,    22,    23,    -1,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    -1,    70,    71,    72,    73,    74,    75,    -1,    -1,
      -1,    79,    -1,    -1,    -1,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    -1,    95,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,   124,   125,    -1,   127,
      -1,   129,   130,   131,    -1,   133,    -1,   135,   136,    -1,
     138,   139,   140,    -1,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,   152,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,   164,   165,   166,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,   189,   190,   191,    -1,   193,   194,   195,    -1,    -1,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,   226,   227,
     228,    -1,   230,   231,   232,   233,   234,    -1,    -1,   237,
     238,    -1,    -1,   241,   242,   243,    -1,    -1,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,    -1,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,    -1,    -1,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,    -1,   356,   357,
     358,   359,    -1,    -1,   362,   363,   364,   365,   366,   367,
      -1,   369,   370,   371,   372,   373,    -1,    -1,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,    -1,    -1,
     398,    -1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,   419,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    -1,
      70,    71,    72,    -1,    74,    75,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    -1,    95,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,   125,    -1,   127,    -1,   129,
     130,   131,    -1,   133,    -1,   135,    -1,    -1,    -1,   139,
     140,    -1,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,    -1,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,   194,   195,    -1,    -1,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,    -1,   213,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,   226,    -1,   228,    -1,
     230,   231,   232,   233,   234,    -1,    -1,   237,    -1,    -1,
      -1,   241,   242,   243,    -1,    -1,   246,    -1,    -1,    -1,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,    -1,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
     340,    -1,    -1,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,    -1,   356,   357,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,    -1,   369,
      -1,   371,   372,   373,    -1,    -1,   376,    -1,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,    -1,    -1,   398,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,   419,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    -1,    74,    75,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    -1,    95,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,   124,   125,    -1,   127,    -1,   129,   130,   131,
      -1,   133,    -1,   135,    -1,    -1,    -1,   139,   140,    -1,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,    -1,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,   194,   195,    -1,    -1,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,   226,    -1,   228,    -1,   230,   231,
     232,   233,   234,    -1,    -1,   237,   238,    -1,    -1,   241,
     242,   243,    -1,    -1,   246,    -1,    -1,    -1,   250,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,    -1,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,    -1,
      -1,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,    -1,   356,   357,   358,   359,    -1,    -1,
     362,   363,   364,   365,   366,   367,    -1,   369,    -1,   371,
     372,   373,    -1,    -1,   376,    -1,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,    -1,    -1,   398,    -1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,   419,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    63,
      64,    65,    66,    67,    68,    -1,    70,    71,    72,    -1,
      74,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      -1,    95,    96,    97,    98,    99,    -1,   101,   102,   103,
      -1,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
     124,   125,    -1,   127,    -1,   129,   130,   131,    -1,   133,
      -1,   135,    -1,    -1,    -1,   139,   140,    -1,   142,   143,
      -1,   145,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,    -1,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
     194,   195,    -1,    -1,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,    -1,   213,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,   226,    -1,   228,    -1,   230,   231,   232,   233,
     234,    -1,    -1,   237,    -1,    -1,    -1,   241,   242,   243,
      -1,    -1,   246,    -1,    -1,    -1,   250,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,    -1,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,    -1,    -1,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
      -1,    -1,   356,   357,   358,   359,    -1,    -1,   362,   363,
     364,   365,   366,   367,    -1,   369,    -1,   371,   372,   373,
      -1,    -1,   376,    -1,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,    -1,    -1,   398,    -1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,   419,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    -1,    70,    71,    72,    -1,    74,    75,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    -1,    95,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,   124,   125,
      -1,   127,    -1,   129,   130,   131,    -1,   133,    -1,   135,
      -1,    -1,    -1,   139,   140,    -1,   142,   143,    -1,   145,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
      -1,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,   194,   195,
      -1,    -1,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,    -1,   213,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
     226,    -1,   228,    -1,   230,   231,   232,   233,   234,    -1,
      -1,   237,    -1,    -1,    -1,   241,   242,   243,    -1,    -1,
     246,    -1,    -1,    -1,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,    -1,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,    -1,   304,   305,
     306,   307,    -1,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,    -1,    -1,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,    -1,    -1,
     356,   357,   358,   359,    -1,    -1,   362,   363,   364,   365,
     366,   367,    -1,   369,    -1,   371,   372,   373,    -1,    -1,
     376,    -1,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
      -1,    -1,   398,    -1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,   419,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    -1,    70,    71,    72,    -1,    74,    75,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    -1,    95,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,   124,   125,    -1,   127,
      -1,   129,   130,   131,    -1,   133,    -1,   135,    -1,    -1,
      -1,   139,   140,    -1,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,    -1,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,   194,   195,    -1,    -1,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,    -1,   213,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,   226,    -1,
     228,    -1,   230,   231,   232,   233,   234,    -1,    -1,   237,
      -1,    -1,    -1,   241,   242,   243,    -1,    -1,   246,    -1,
      -1,    -1,   250,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,    -1,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,    -1,    -1,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,    -1,   356,   357,
     358,   359,    -1,    -1,   362,   363,   364,   365,   366,   367,
      -1,   369,    -1,   371,   372,   373,    -1,    -1,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,    -1,    -1,
     398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   419,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    -1,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,    -1,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,    -1,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,   247,   248,   249,    -1,
     251,   252,   253,   254,   255,   256,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   392,   393,   394,    -1,    -1,    -1,   398,   399,   400,
      -1,    -1,   403,   404,    -1,   406,   407,   408,    -1,   410,
     411,   412,   413,   414,   415,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    -1,    70,    71,    72,    -1,    74,    75,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    -1,    95,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,   124,   125,    -1,   127,
      -1,   129,   130,   131,    -1,   133,    -1,   135,    -1,    -1,
      -1,   139,   140,    -1,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,    -1,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,   194,   195,    -1,    -1,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,    -1,   213,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,   226,    -1,
     228,    -1,   230,   231,   232,   233,   234,    -1,    -1,   237,
      -1,    -1,    -1,   241,   242,   243,    -1,    -1,   246,    -1,
      -1,    -1,   250,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,    -1,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,    -1,    -1,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,    -1,   356,   357,
     358,   359,    -1,    -1,   362,   363,   364,   365,   366,   367,
      -1,   369,    -1,   371,   372,   373,    -1,    -1,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,    -1,    -1,
     398,    -1,    -1,    -1,    -1,   403,    -1,    -1,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    61,    -1,    63,    64,
      65,    66,    67,    68,    -1,    70,    71,    72,    -1,    74,
      75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    -1,
      95,    96,    97,    98,    99,    -1,   101,   102,   103,    -1,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,   116,   117,    -1,   119,   120,   121,   122,   123,   124,
     125,    -1,   127,    -1,   129,   130,   131,    -1,   133,    -1,
     135,    -1,    -1,    -1,   139,   140,    -1,   142,   143,    -1,
     145,    -1,   147,   148,   149,   150,   151,    -1,   153,   154,
     155,    -1,   157,   158,   159,   160,   161,   162,    -1,    -1,
     165,   166,   167,   168,   169,   170,   171,    -1,   173,    -1,
     175,    -1,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,   194,
     195,    -1,    -1,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,    -1,   213,    -1,
     215,   216,   217,   218,   219,   220,   221,   222,   223,    -1,
     225,   226,    -1,   228,    -1,   230,   231,   232,   233,   234,
      -1,    -1,   237,    -1,    -1,    -1,   241,   242,   243,    -1,
      -1,   246,    -1,    -1,    -1,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
      -1,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,    -1,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,    -1,   304,
     305,   306,   307,    -1,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,    -1,   333,   334,
     335,   336,   337,    -1,   339,   340,    -1,    -1,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
      -1,   356,   357,   358,   359,    -1,    -1,   362,   363,   364,
     365,   366,   367,    -1,   369,    -1,   371,   372,   373,    -1,
      -1,   376,    -1,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,    -1,    -1,   398,    -1,    -1,    -1,    -1,   403,    -1,
      -1,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    -1,    74,    75,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    -1,    95,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,   124,   125,    -1,   127,    -1,   129,   130,   131,
      -1,   133,    -1,   135,    -1,    -1,    -1,   139,   140,    -1,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,    -1,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,   194,   195,    -1,    -1,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
      -1,   213,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,   226,    -1,   228,    -1,   230,   231,
     232,   233,   234,    -1,    -1,   237,    -1,    -1,    -1,   241,
     242,   243,    -1,    -1,   246,    -1,    -1,    -1,   250,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,    -1,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,    -1,
      -1,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,    -1,   356,   357,   358,   359,    -1,    -1,
     362,   363,   364,   365,   366,   367,    -1,   369,    -1,   371,
     372,   373,    -1,    -1,   376,    -1,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,    -1,    -1,   398,    -1,    -1,    -1,
      -1,   403,    -1,    -1,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    61,    -1,    63,    64,    65,    66,    67,    68,
      -1,    70,    71,    72,    -1,    74,    75,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    -1,    95,    96,    97,    98,
      99,    -1,   101,   102,   103,    -1,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,   116,   117,    -1,
     119,   120,   121,   122,   123,   124,   125,    -1,   127,    -1,
     129,   130,   131,    -1,   133,    -1,   135,    -1,    -1,    -1,
     139,   140,    -1,   142,   143,    -1,   145,    -1,   147,   148,
     149,   150,   151,    -1,   153,   154,   155,    -1,   157,   158,
     159,   160,   161,   162,    -1,    -1,   165,   166,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,    -1,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,   194,   195,    -1,    -1,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,    -1,   213,    -1,   215,   216,   217,   218,
     219,   220,   221,   222,   223,    -1,   225,   226,    -1,   228,
      -1,   230,   231,   232,   233,   234,    -1,    -1,   237,    -1,
      -1,    -1,   241,   242,   243,    -1,    -1,   246,    -1,    -1,
      -1,   250,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,    -1,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,    -1,   304,   305,   306,   307,    -1,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,    -1,   333,   334,   335,   336,   337,    -1,
     339,   340,    -1,    -1,   343,   344,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,    -1,   356,   357,   358,
     359,    -1,    -1,   362,   363,   364,   365,   366,   367,    -1,
     369,    -1,   371,   372,   373,    -1,    -1,   376,    -1,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,    -1,    -1,   398,
      -1,    -1,    -1,    -1,   403,    -1,    -1,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    -1,    70,    71,    72,    -1,    74,    75,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    -1,    95,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,   124,   125,
      -1,   127,    -1,   129,   130,   131,    -1,   133,    -1,   135,
      -1,    -1,    -1,   139,   140,    -1,   142,   143,    -1,   145,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
      -1,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,   194,   195,
      -1,    -1,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,    -1,   213,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
     226,    -1,   228,    -1,   230,   231,   232,   233,   234,    -1,
      -1,   237,    -1,    -1,    -1,   241,   242,   243,    -1,    -1,
     246,    -1,    -1,    -1,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,    -1,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,    -1,   304,   305,
     306,   307,    -1,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,    -1,    -1,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,    -1,    -1,
     356,   357,   358,   359,    -1,    -1,   362,   363,   364,   365,
     366,   367,    -1,   369,    -1,   371,   372,   373,    -1,    -1,
     376,    -1,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
      -1,    -1,   398,    -1,    -1,    -1,    -1,   403,    -1,    -1,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,    -1,    -1,   398,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,   412,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    61,    -1,    63,    64,    65,    66,
      67,    68,    -1,    70,    71,    72,    -1,    74,    75,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    -1,    95,    96,
      97,    98,    99,    -1,   101,   102,   103,    -1,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,   116,
     117,    -1,   119,   120,   121,   122,   123,   124,   125,    -1,
     127,    -1,   129,   130,   131,    -1,   133,    -1,   135,    -1,
      -1,    -1,   139,   140,    -1,   142,   143,    -1,   145,    -1,
     147,   148,   149,   150,   151,    -1,   153,   154,   155,    -1,
     157,   158,   159,   160,   161,   162,    -1,    -1,   165,   166,
     167,   168,   169,   170,   171,    -1,   173,    -1,   175,    -1,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,   194,   195,    -1,
      -1,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,    -1,   213,    -1,   215,   216,
     217,   218,   219,   220,   221,   222,   223,    -1,   225,   226,
      -1,   228,    -1,   230,   231,   232,   233,   234,    -1,    -1,
     237,    -1,    -1,    -1,   241,   242,   243,    -1,    -1,   246,
      -1,    -1,    -1,   250,   251,   252,   253,   254,   255,   256,
      -1,   258,   259,   260,   261,   262,   263,   264,    -1,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,    -1,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,    -1,   309,   310,   311,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,    -1,   333,   334,   335,   336,
     337,    -1,   339,   340,    -1,    -1,   343,   344,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,    -1,   356,
     357,   358,   359,    -1,    -1,   362,   363,   364,   365,   366,
     367,    -1,   369,    -1,   371,   372,   373,    -1,    -1,   376,
      -1,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,    -1,
      -1,   398,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,   412,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    -1,    -1,    -1,    56,    57,    58,    59,    60,
      61,    -1,    63,    64,    65,    66,    67,    68,    -1,    70,
      71,    72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,
      -1,    -1,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    -1,    95,    96,    97,    98,    99,    -1,
     101,   102,   103,    -1,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,   116,   117,    -1,   119,   120,
     121,    -1,   123,   124,    -1,    -1,   127,    -1,   129,   130,
     131,    -1,   133,    -1,   135,   136,    -1,   138,   139,   140,
      -1,   142,    -1,    -1,   145,    -1,   147,   148,   149,   150,
     151,   152,   153,   154,   155,    -1,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
     171,    -1,   173,    -1,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,    -1,    -1,   189,   190,
     191,    -1,   193,   194,   195,    -1,    -1,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,   216,   217,   218,   219,   220,
     221,    -1,   223,    -1,   225,   226,   227,   228,    -1,    -1,
     231,   232,   233,   234,    -1,    -1,   237,    -1,    -1,    -1,
     241,   242,   243,    -1,    -1,    -1,   247,   248,   249,    -1,
     251,   252,   253,   254,   255,   256,    -1,   258,    -1,   260,
      -1,   262,   263,   264,    -1,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,    -1,   304,   305,   306,   307,    -1,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,    -1,   330,
     331,    -1,   333,   334,   335,   336,   337,    -1,   339,   340,
      -1,    -1,   343,    -1,   345,    -1,    -1,   348,   349,   350,
     351,   352,   353,    -1,    -1,   356,   357,   358,   359,    -1,
      -1,   362,   363,   364,   365,    -1,   367,    -1,   369,   370,
     371,   372,   373,    -1,    -1,   376,    -1,    -1,   379,   380,
     381,   382,   383,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   392,   393,   394,    -1,    -1,    -1,   398,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,   412,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    -1,    -1,
      -1,    56,    57,    58,    59,    60,    61,    -1,    63,    64,
      65,    66,    67,    68,    -1,    70,    71,    72,    73,    74,
      75,    -1,    -1,    -1,    79,    -1,    -1,    -1,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    -1,
      95,    96,    97,    98,    99,    -1,   101,   102,   103,    -1,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,   116,   117,    -1,   119,   120,   121,    -1,   123,   124,
      -1,    -1,   127,    -1,   129,   130,   131,    -1,   133,    -1,
     135,   136,    -1,   138,   139,   140,    -1,   142,    -1,    -1,
     145,    -1,   147,   148,   149,   150,   151,   152,   153,   154,
     155,    -1,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,   171,    -1,   173,    -1,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,    -1,   189,   190,   191,    -1,   193,   194,
     195,    -1,    -1,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,   216,   217,   218,   219,   220,   221,    -1,   223,    -1,
     225,   226,   227,   228,    -1,    -1,   231,   232,   233,   234,
      -1,    -1,   237,    -1,    -1,    -1,   241,   242,   243,    -1,
      -1,    -1,   247,   248,   249,    -1,   251,   252,   253,   254,
     255,   256,    -1,   258,    -1,   260,    -1,   262,   263,   264,
      -1,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,   292,   293,    -1,
     295,   296,   297,   298,   299,   300,   301,   302,    -1,   304,
     305,   306,   307,    -1,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,    -1,   330,   331,    -1,   333,   334,
     335,   336,   337,    -1,   339,   340,    -1,    -1,   343,    -1,
     345,    -1,    -1,   348,   349,   350,   351,   352,   353,    -1,
      -1,   356,   357,   358,   359,    -1,    -1,   362,   363,   364,
     365,    -1,   367,    -1,   369,   370,   371,   372,   373,    -1,
      -1,   376,    -1,    -1,   379,   380,   381,   382,   383,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   392,   393,   394,
      -1,    -1,    -1,   398,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,   412,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    61,    -1,    63,    64,    65,    66,    67,    68,
      -1,    70,    71,    72,    -1,    74,    75,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    -1,    95,    96,    97,    98,
      99,    -1,   101,   102,   103,    -1,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,   116,   117,    -1,
     119,   120,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,    -1,   133,    -1,   135,    -1,    -1,    -1,
     139,   140,    -1,   142,   143,    -1,   145,    -1,   147,   148,
     149,   150,   151,    -1,   153,   154,   155,    -1,   157,   158,
     159,   160,   161,   162,    -1,    -1,   165,   166,   167,   168,
     169,   170,   171,    -1,   173,    -1,   175,    -1,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,   194,   195,    -1,    -1,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,    -1,   213,    -1,   215,   216,   217,   218,
     219,   220,   221,   222,   223,    -1,   225,   226,    -1,   228,
      -1,   230,   231,   232,   233,   234,   235,    -1,   237,    -1,
     239,    -1,   241,   242,   243,    -1,    -1,   246,    -1,    -1,
      -1,   250,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,    -1,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,    -1,   304,   305,   306,   307,    -1,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,    -1,   333,   334,   335,   336,   337,    -1,
     339,   340,    -1,    -1,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,    -1,    -1,   356,   357,   358,
     359,    -1,    -1,   362,   363,   364,   365,   366,   367,    -1,
     369,    -1,   371,   372,   373,    -1,    -1,   376,    -1,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,    -1,    -1,   398,
     399,   400,    -1,    -1,    -1,   404,    -1,    -1,    -1,    -1,
      -1,   410,   411,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    -1,
      70,    71,    72,    -1,    74,    75,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    -1,    95,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,    -1,   133,    -1,   135,    -1,    -1,    -1,   139,
     140,    -1,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,    -1,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,   194,   195,    -1,    -1,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,    -1,   213,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,   226,    -1,   228,    -1,
     230,   231,   232,   233,   234,   235,    -1,   237,    -1,   239,
      -1,   241,   242,   243,    -1,    -1,   246,    -1,    -1,    -1,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,    -1,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,    -1,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,    -1,    -1,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,    -1,    -1,   356,   357,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,    -1,   369,
      -1,   371,   372,   373,    -1,    -1,   376,    -1,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,    -1,    -1,   398,   399,
     400,    -1,    -1,    -1,   404,    -1,    -1,    -1,    -1,    -1,
     410,   411,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    -1,    27,    28,    29,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      61,    -1,    63,    64,    65,    66,    67,    68,    -1,    70,
      71,    72,    -1,    74,    75,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    -1,    95,    96,    97,    98,    99,    -1,
     101,   102,   103,    -1,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,   116,   117,    -1,   119,   120,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,    -1,   133,    -1,   135,    -1,    -1,    -1,   139,   140,
      -1,   142,   143,    -1,   145,    -1,   147,   148,   149,   150,
     151,    -1,   153,   154,   155,    -1,   157,   158,   159,   160,
     161,   162,    -1,    -1,   165,   166,   167,   168,   169,   170,
     171,    -1,   173,    -1,   175,    -1,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,   194,   195,    -1,    -1,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,    -1,   213,    -1,   215,   216,   217,   218,   219,   220,
     221,   222,   223,    -1,   225,   226,    -1,   228,    -1,   230,
     231,   232,   233,   234,   235,    -1,   237,    -1,   239,    -1,
     241,   242,   243,    -1,    -1,   246,    -1,    -1,    -1,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,    -1,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
      -1,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,    -1,   304,   305,   306,   307,    -1,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,    -1,   333,   334,   335,   336,   337,    -1,   339,   340,
      -1,    -1,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,    -1,    -1,   356,   357,   358,   359,    -1,
      -1,   362,   363,   364,   365,   366,   367,    -1,   369,    -1,
     371,   372,   373,    -1,    -1,   376,    -1,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,    -1,    -1,   398,   399,   400,
      -1,    -1,    -1,   404,    -1,    -1,    -1,    -1,    -1,   410,
     411,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    -1,    74,    75,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    -1,    95,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,   124,   125,    -1,   127,    -1,   129,   130,   131,
      -1,   133,    -1,   135,    -1,    -1,    -1,   139,   140,    -1,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,    -1,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,   194,   195,    -1,    -1,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
      -1,   213,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,   226,    -1,   228,    -1,   230,   231,
     232,   233,   234,    -1,    -1,   237,    -1,    -1,    -1,   241,
     242,   243,    -1,    -1,   246,    -1,    -1,    -1,   250,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,    -1,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,    -1,
      -1,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,    -1,   356,   357,   358,   359,    -1,    -1,
     362,   363,   364,   365,   366,   367,    -1,   369,    -1,   371,
     372,   373,    -1,    -1,   376,    -1,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,    -1,    -1,   398,    -1,    -1,    -1,
      -1,    -1,   404,    -1,    -1,    -1,    -1,    -1,   410,   411,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    61,    -1,
      63,    64,    65,    66,    67,    68,    -1,    70,    71,    72,
      -1,    74,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    -1,    95,    96,    97,    98,    99,    -1,   101,   102,
     103,    -1,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,   116,   117,    -1,   119,   120,   121,   122,
     123,   124,   125,    -1,   127,    -1,   129,   130,   131,    -1,
     133,    -1,   135,    -1,    -1,    -1,   139,   140,    -1,   142,
     143,    -1,   145,    -1,   147,   148,   149,   150,   151,    -1,
     153,   154,   155,    -1,   157,   158,   159,   160,   161,   162,
      -1,    -1,   165,   166,   167,   168,   169,   170,   171,    -1,
     173,    -1,   175,    -1,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,   194,   195,    -1,    -1,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,    -1,
     213,    -1,   215,   216,   217,   218,   219,   220,   221,   222,
     223,    -1,   225,   226,    -1,   228,    -1,   230,   231,   232,
     233,   234,    -1,    -1,   237,    -1,    -1,    -1,   241,   242,
     243,    -1,    -1,   246,    -1,    -1,    -1,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
      -1,   304,   305,   306,   307,    -1,   309,   310,   311,   312,
      -1,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,    -1,
     333,   334,   335,   336,   337,    -1,   339,   340,    -1,    -1,
     343,   344,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,    -1,   356,   357,   358,   359,    -1,    -1,   362,
     363,   364,   365,   366,   367,    -1,   369,    -1,   371,   372,
     373,    -1,    -1,   376,    -1,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,    -1,    -1,   398,    -1,    -1,    -1,    -1,
      -1,    -1,   405,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    -1,
      70,    71,    72,    -1,    74,    75,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    -1,    95,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,   125,    -1,   127,    -1,   129,
     130,   131,    -1,   133,    -1,   135,    -1,    -1,    -1,   139,
     140,    -1,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,    -1,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,   194,   195,    -1,    -1,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,    -1,   213,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,   226,    -1,   228,    -1,
     230,   231,   232,   233,   234,    -1,    -1,   237,    -1,    -1,
      -1,   241,   242,   243,    -1,    -1,   246,    -1,    -1,    -1,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,    -1,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,    -1,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,    -1,    -1,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,    -1,   356,   357,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,    -1,   369,
      -1,   371,   372,   373,    -1,    -1,   376,    -1,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,    -1,    -1,   398,   399,
     400,   401,   402,    -1,   404,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    -1,    70,    71,    72,    -1,    74,    75,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    -1,    95,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,   124,   125,    -1,   127,
      -1,   129,   130,   131,    -1,   133,    -1,   135,    -1,    -1,
      -1,   139,   140,    -1,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,    -1,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,   194,   195,    -1,    -1,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,    -1,   213,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,   226,    -1,
     228,    -1,   230,   231,   232,   233,   234,    -1,    -1,   237,
      -1,    -1,    -1,   241,   242,   243,    -1,    -1,   246,    -1,
      -1,    -1,   250,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,    -1,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,    -1,    -1,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,    -1,   356,   357,
     358,   359,    -1,    -1,   362,   363,   364,   365,   366,   367,
      -1,   369,    -1,   371,   372,   373,    -1,    -1,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,    -1,    -1,
     398,    -1,   400,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    -1,
      70,    71,    72,    -1,    74,    75,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    -1,    95,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,   125,    -1,   127,    -1,   129,
     130,   131,    -1,   133,    -1,   135,    -1,    -1,    -1,   139,
     140,    -1,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,    -1,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,   194,   195,    -1,    -1,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,    -1,   213,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,   226,    -1,   228,    -1,
     230,   231,   232,   233,   234,    -1,    -1,   237,    -1,    -1,
      -1,   241,   242,   243,    -1,    -1,   246,    -1,    -1,    -1,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,    -1,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,    -1,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,    -1,    -1,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,    -1,   356,   357,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,    -1,   369,
      -1,   371,   372,   373,    -1,    -1,   376,    -1,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,    -1,    -1,   398,    -1,
     400,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    -1,    74,    75,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    -1,    95,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,   124,   125,    -1,   127,    -1,   129,   130,   131,
      -1,   133,    -1,   135,    -1,    -1,    -1,   139,   140,    -1,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,    -1,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,   194,   195,    -1,    -1,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
      -1,   213,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,   226,    -1,   228,    -1,   230,   231,
     232,   233,   234,    -1,    -1,   237,    -1,    -1,    -1,   241,
     242,   243,    -1,    -1,   246,    -1,    -1,    -1,   250,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,    -1,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,    -1,
      -1,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,    -1,   356,   357,   358,   359,    -1,    -1,
     362,   363,   364,   365,   366,   367,    -1,   369,    -1,   371,
     372,   373,    -1,    -1,   376,    -1,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,    -1,    -1,   398,    -1,   400,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,    -1,    -1,   398,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,    -1,    -1,
     398,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      -1,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    -1,    95,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,   124,   125,    -1,   127,    -1,   129,   130,   131,
      -1,   133,    -1,   135,   136,    -1,   138,   139,   140,    -1,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,   189,   190,   191,
      -1,   193,   194,   195,    -1,    -1,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,   226,   227,   228,    -1,   230,   231,
     232,   233,   234,    -1,    -1,   237,   238,    -1,    -1,   241,
     242,   243,    -1,    -1,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,    -1,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,    -1,
      -1,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,    -1,   356,   357,   358,   359,    -1,    -1,
     362,   363,   364,   365,   366,   367,    -1,   369,   370,   371,
     372,   373,    -1,    -1,   376,    -1,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,    -1,    -1,   398,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    -1,    70,    71,    72,    73,    74,    75,
      -1,    -1,    -1,    79,    -1,    -1,    -1,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    -1,    95,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,   124,   125,
      -1,   127,    -1,   129,   130,   131,    -1,   133,    -1,   135,
     136,    -1,   138,   139,   140,    -1,   142,   143,    -1,   145,
      -1,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,   164,   165,
     166,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,   189,   190,   191,    -1,   193,   194,   195,
      -1,    -1,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
     226,   227,   228,    -1,   230,   231,   232,   233,   234,    -1,
      -1,   237,   238,    -1,    -1,   241,   242,   243,    -1,    -1,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,    -1,   304,   305,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,    -1,    -1,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,    -1,    -1,
     356,   357,   358,   359,    -1,    -1,   362,   363,   364,   365,
     366,   367,    -1,   369,   370,   371,   372,   373,    -1,    -1,
     376,    -1,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
      -1,    -1,   398,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    -1,
      70,    71,    72,    73,    74,    75,    -1,    -1,    -1,    79,
      -1,    -1,    -1,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    -1,    95,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,   125,    -1,   127,    -1,   129,
     130,   131,    -1,   133,    -1,   135,   136,    -1,   138,   139,
     140,    -1,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,   152,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,   189,
     190,   191,    -1,   193,   194,   195,    -1,    -1,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,   226,   227,   228,    -1,
     230,   231,   232,   233,   234,    -1,    -1,   237,   238,    -1,
      -1,   241,   242,   243,    -1,    -1,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,    -1,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,    -1,    -1,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,    -1,   356,   357,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,    -1,   369,
     370,   371,   372,   373,    -1,    -1,   376,    -1,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,    -1,    -1,   398,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    -1,    70,    71,    72,    -1,
      74,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      -1,    95,    96,    97,    98,    99,    -1,   101,   102,   103,
      -1,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
     124,   125,    -1,   127,    -1,   129,   130,   131,    -1,   133,
     134,   135,    -1,    -1,    -1,   139,   140,    -1,   142,   143,
      -1,   145,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,    -1,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,    -1,   193,
     194,   195,    -1,    -1,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,    -1,   213,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,   226,    -1,   228,    -1,   230,   231,   232,   233,
     234,    -1,    -1,   237,    -1,    -1,    -1,   241,   242,   243,
      -1,    -1,   246,    -1,    -1,    -1,   250,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,    -1,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,    -1,    -1,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,    -1,    -1,   362,   363,
     364,   365,   366,   367,    -1,   369,    -1,   371,   372,   373,
      -1,    -1,   376,    -1,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,    -1,    -1,   398,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    -1,    74,    75,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    -1,    95,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,   124,   125,    -1,   127,
      -1,   129,   130,   131,    -1,   133,    -1,   135,    -1,    -1,
      -1,   139,   140,   141,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,    -1,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,   194,   195,    -1,    -1,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,    -1,   213,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,   226,    -1,
     228,    -1,   230,   231,   232,   233,   234,    -1,    -1,   237,
      -1,    -1,    -1,   241,   242,   243,    -1,    -1,   246,    -1,
      -1,    -1,   250,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,    -1,    -1,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,    -1,   356,   357,
     358,   359,    -1,    -1,   362,   363,   364,   365,   366,   367,
      -1,   369,    -1,   371,   372,   373,    -1,    -1,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,    -1,    -1,
     398,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    -1,    74,    75,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    -1,    95,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,   124,   125,    -1,   127,    -1,   129,   130,   131,
      -1,   133,    -1,   135,    -1,    -1,    -1,   139,   140,    -1,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,    -1,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,   194,   195,    -1,    -1,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
      -1,   213,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,   226,    -1,   228,    -1,   230,   231,
     232,   233,   234,    -1,    -1,   237,    -1,    -1,    -1,   241,
     242,   243,    -1,    -1,   246,    -1,    -1,    -1,   250,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,    -1,
      -1,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,    -1,   356,   357,   358,   359,    -1,    -1,
     362,   363,   364,   365,   366,   367,    -1,   369,    -1,   371,
     372,   373,    -1,    -1,   376,    -1,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,    -1,    -1,   398,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    -1,    70,    71,    72,    -1,    74,    75,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    -1,    95,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,   124,   125,
      -1,   127,    -1,   129,   130,   131,    -1,   133,   134,   135,
      -1,    -1,    -1,   139,   140,    -1,   142,   143,    -1,   145,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
      -1,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,   194,   195,
      -1,    -1,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
     226,    -1,   228,    -1,   230,   231,   232,   233,   234,    -1,
      -1,   237,   238,    -1,    -1,   241,   242,   243,    -1,    -1,
     246,    -1,    -1,    -1,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,    -1,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,    -1,   304,   305,
     306,   307,    -1,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,   340,    -1,    -1,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,    -1,    -1,
     356,   357,   358,   359,    -1,    -1,   362,   363,   364,   365,
     366,   367,    -1,   369,    -1,   371,   372,   373,    -1,    -1,
     376,    -1,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
      -1,    -1,   398,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    15,    16,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    -1,
      70,    71,    72,    -1,    74,    75,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    -1,    95,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,   125,    -1,   127,    -1,   129,
     130,   131,    -1,   133,    -1,   135,    -1,    -1,    -1,   139,
     140,    -1,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,    -1,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,   194,   195,    -1,    -1,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,   226,    -1,   228,    -1,
     230,   231,   232,   233,   234,    -1,    -1,   237,   238,    -1,
      -1,   241,   242,   243,    -1,    -1,   246,    -1,    -1,    -1,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,    -1,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,    -1,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,    -1,    -1,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,    -1,   356,   357,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,    -1,   369,
      -1,   371,   372,   373,    -1,    -1,   376,    -1,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,    -1,    -1,   398,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    63,
      64,    65,    66,    67,    68,    -1,    70,    71,    72,    -1,
      74,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      -1,    95,    96,    97,    98,    99,    -1,   101,   102,   103,
      -1,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
     124,   125,    -1,   127,    -1,   129,   130,   131,    -1,   133,
      -1,   135,    -1,    -1,    -1,   139,   140,    -1,   142,   143,
      -1,   145,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,    -1,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
     194,   195,    -1,    -1,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,   226,    -1,   228,    -1,   230,   231,   232,   233,
     234,    -1,    -1,   237,   238,    -1,   240,   241,   242,   243,
      -1,    -1,   246,    -1,    -1,    -1,   250,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,    -1,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,    -1,    -1,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
      -1,    -1,   356,   357,   358,   359,    -1,    -1,   362,   363,
     364,   365,   366,   367,    -1,   369,    -1,   371,   372,   373,
      -1,    -1,   376,    -1,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,    -1,    -1,   398,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    -1,    70,    71,    72,    -1,    74,    75,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    -1,    95,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,   124,   125,    -1,   127,
      -1,   129,   130,   131,    -1,   133,    -1,   135,    -1,    -1,
      -1,   139,   140,    -1,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,    -1,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,   194,   195,    -1,    -1,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,   226,    -1,
     228,    -1,   230,   231,   232,   233,   234,    -1,    -1,   237,
     238,    -1,    -1,   241,   242,   243,    -1,    -1,   246,    -1,
      -1,    -1,   250,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,    -1,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,    -1,    -1,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,    -1,   356,   357,
     358,   359,    -1,    -1,   362,   363,   364,   365,   366,   367,
      -1,   369,    -1,   371,   372,   373,    -1,    -1,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,    -1,    -1,
     398,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    -1,    74,    75,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    -1,    95,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,   124,   125,    -1,   127,    -1,   129,   130,   131,
      -1,   133,    -1,   135,    -1,    -1,    -1,   139,   140,    -1,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,    -1,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,   194,   195,    -1,    -1,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
      -1,   213,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,   226,    -1,   228,    -1,   230,   231,
     232,   233,   234,    -1,    -1,   237,    -1,    -1,    -1,   241,
     242,   243,    -1,    -1,   246,    -1,    -1,    -1,   250,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,    -1,
      -1,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,    -1,   356,   357,   358,   359,    -1,    -1,
     362,   363,   364,   365,   366,   367,    -1,   369,    -1,   371,
     372,   373,    -1,    -1,   376,    -1,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,    -1,    -1,   398,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    -1,    70,    71,    72,    -1,    74,    75,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    -1,    95,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,   124,   125,
      -1,   127,    -1,   129,   130,   131,    -1,   133,    -1,   135,
      -1,    -1,    -1,   139,   140,    -1,   142,   143,    -1,   145,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
      -1,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,   194,   195,
      -1,    -1,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
     226,    -1,   228,    -1,   230,   231,   232,   233,   234,    -1,
      -1,   237,   238,    -1,    -1,   241,   242,   243,    -1,    -1,
     246,    -1,    -1,    -1,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,    -1,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,    -1,   304,   305,
     306,   307,    -1,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,   340,    -1,    -1,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,    -1,    -1,
     356,   357,   358,   359,    -1,    -1,   362,   363,   364,   365,
     366,   367,    -1,   369,    -1,   371,   372,   373,    -1,    -1,
     376,    -1,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
      -1,    -1,   398,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    -1,
      70,    71,    72,    -1,    74,    75,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    -1,    95,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,   125,    -1,   127,    -1,   129,
     130,   131,    -1,   133,    -1,   135,    -1,    -1,    -1,   139,
     140,    -1,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,    -1,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,   194,   195,    -1,    -1,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,   226,    -1,   228,    -1,
     230,   231,   232,   233,   234,    -1,    -1,   237,   238,    -1,
      -1,   241,   242,   243,    -1,    -1,   246,    -1,    -1,    -1,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,    -1,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,    -1,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,    -1,    -1,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,    -1,   356,   357,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,    -1,   369,
      -1,   371,   372,   373,    -1,    -1,   376,    -1,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,    -1,    -1,   398,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    63,
      64,    65,    66,    67,    68,    -1,    70,    71,    72,    -1,
      74,    75,    -1,    -1,    -1,    -1,    -1,    -1,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      -1,    95,    96,    97,    98,    99,    -1,   101,   102,   103,
      -1,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
     124,   125,    -1,   127,    -1,   129,   130,   131,    -1,   133,
      -1,   135,    -1,    -1,    -1,   139,   140,    -1,   142,   143,
      -1,   145,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,    -1,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
     194,   195,    -1,    -1,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,    -1,   213,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,   226,    -1,   228,    -1,   230,   231,   232,   233,
     234,    -1,    -1,   237,    -1,    -1,    -1,   241,   242,   243,
      -1,    -1,   246,    -1,    -1,    -1,   250,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,    -1,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,    -1,    -1,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
      -1,    -1,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,    -1,   369,    -1,   371,   372,   373,
      -1,    -1,   376,    -1,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,    -1,    -1,   398,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    -1,    70,    71,    72,    -1,    74,    75,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    -1,    95,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,   124,   125,    -1,   127,
      -1,   129,   130,   131,    -1,   133,    -1,   135,    -1,    -1,
      -1,   139,   140,    -1,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,    -1,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,   194,   195,    -1,    -1,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,    -1,   213,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,   226,    -1,
     228,    -1,   230,   231,   232,   233,   234,    -1,    -1,   237,
      -1,    -1,    -1,   241,   242,   243,    -1,    -1,   246,    -1,
      -1,    -1,   250,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,    -1,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,    -1,    -1,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,    -1,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
      -1,   369,    -1,   371,   372,   373,    -1,    -1,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,    -1,    -1,
     398,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    -1,    74,    75,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    -1,    95,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,   124,   125,    -1,   127,    -1,   129,   130,   131,
      -1,   133,    -1,   135,    -1,    -1,    -1,   139,   140,    -1,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,    -1,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,   194,   195,    -1,    -1,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
      -1,   213,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,   226,    -1,   228,    -1,   230,   231,
     232,   233,   234,    -1,    -1,   237,    -1,    -1,    -1,   241,
     242,   243,    -1,    -1,   246,    -1,    -1,    -1,   250,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,    -1,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,    -1,
      -1,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,    -1,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,    -1,   369,    -1,   371,
     372,   373,    -1,    -1,   376,    -1,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,    -1,    -1,   398,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    -1,    70,    71,    72,    -1,    74,    75,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    -1,    95,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,   124,   125,
      -1,   127,    -1,   129,   130,   131,    -1,   133,    -1,   135,
      -1,    -1,    -1,   139,   140,    -1,   142,   143,    -1,   145,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
      -1,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,   194,   195,
      -1,    -1,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,    -1,   213,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
     226,    -1,   228,    -1,   230,   231,   232,   233,   234,    -1,
      -1,   237,    -1,    -1,    -1,   241,   242,   243,    -1,    -1,
     246,    -1,    -1,    -1,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,    -1,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,    -1,   304,   305,
     306,   307,    -1,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,    -1,    -1,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,    -1,    -1,
     356,   357,   358,   359,    -1,    -1,   362,   363,   364,   365,
     366,   367,    -1,   369,    -1,   371,   372,   373,    -1,    -1,
     376,    -1,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
      -1,    -1,   398,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    -1,
      70,    71,    72,    -1,    74,    75,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    -1,    95,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,   125,    -1,   127,    -1,   129,
     130,   131,    -1,   133,    -1,   135,    -1,    -1,    -1,   139,
     140,    -1,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,    -1,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,   194,   195,    -1,    -1,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,    -1,   213,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,   226,    -1,   228,    -1,
     230,   231,   232,   233,   234,    -1,    -1,   237,    -1,    -1,
      -1,   241,   242,   243,    -1,    -1,   246,    -1,    -1,    -1,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,    -1,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,    -1,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,    -1,    -1,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,    -1,   356,   357,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,    -1,   369,
      -1,   371,   372,   373,    -1,    -1,   376,    -1,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,    -1,    -1,   398,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    63,
      64,    65,    66,    67,    68,    -1,    70,    71,    72,    -1,
      74,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      -1,    95,    96,    97,    98,    99,    -1,   101,   102,   103,
      -1,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
     124,   125,    -1,   127,    -1,   129,   130,   131,    -1,   133,
      -1,   135,    -1,    -1,    -1,   139,   140,    -1,   142,   143,
      -1,   145,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,    -1,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
     194,   195,    -1,    -1,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,    -1,   213,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,   226,    -1,   228,    -1,   230,   231,   232,   233,
     234,    -1,    -1,   237,    -1,    -1,    -1,   241,   242,   243,
      -1,    -1,   246,    -1,    -1,    -1,   250,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,    -1,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,    -1,    -1,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
      -1,    -1,   356,   357,   358,   359,    -1,    -1,   362,   363,
     364,   365,   366,   367,    -1,   369,    -1,   371,   372,   373,
      -1,    -1,   376,    -1,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,    -1,    -1,   398,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    -1,    70,    71,    72,    -1,    74,    75,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    -1,    95,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,   124,   125,    -1,   127,
      -1,   129,   130,   131,    -1,   133,    -1,   135,    -1,    -1,
      -1,   139,   140,    -1,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,    -1,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,   194,   195,    -1,    -1,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,    -1,   213,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,   226,    -1,
     228,    -1,   230,   231,   232,   233,   234,    -1,    -1,   237,
      -1,    -1,    -1,   241,   242,   243,    -1,    -1,   246,    -1,
      -1,    -1,   250,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,    -1,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,    -1,    -1,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,    -1,   356,   357,
     358,   359,    -1,    -1,   362,   363,   364,   365,   366,   367,
      -1,   369,    -1,   371,   372,   373,    -1,    -1,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,    -1,    -1,
     398,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    -1,    74,    75,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    -1,    95,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,   124,   125,    -1,   127,    -1,   129,   130,   131,
      -1,   133,    -1,   135,    -1,    -1,    -1,   139,   140,    -1,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,    -1,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,   194,   195,    -1,    -1,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
      -1,   213,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,   226,    -1,   228,    -1,   230,   231,
     232,   233,   234,    -1,    -1,   237,    -1,    -1,    -1,   241,
     242,   243,    -1,    -1,   246,    -1,    -1,    -1,   250,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,    -1,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,    -1,
      -1,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,    -1,   356,   357,   358,   359,    -1,    -1,
     362,   363,   364,   365,   366,   367,    -1,   369,    -1,   371,
     372,   373,    -1,    -1,   376,    -1,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,    -1,    -1,   398,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      26,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    -1,    70,    71,    72,    -1,    74,    75,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    -1,    95,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,   124,   125,
      -1,   127,    -1,   129,   130,   131,    -1,   133,    -1,   135,
      -1,    -1,    -1,   139,   140,    -1,   142,   143,    -1,   145,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
      -1,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,   194,   195,
      -1,    -1,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,    -1,   213,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
     226,    -1,   228,    -1,   230,   231,   232,   233,   234,    -1,
      -1,   237,    -1,    -1,    -1,   241,   242,   243,    -1,    -1,
     246,    -1,    -1,    -1,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,    -1,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,    -1,   304,   305,
     306,   307,    -1,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,    -1,    -1,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,    -1,    -1,
     356,   357,   358,   359,    -1,    -1,   362,   363,   364,   365,
     366,   367,    -1,   369,    -1,   371,   372,   373,    -1,    -1,
     376,    -1,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
      -1,    -1,   398,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    -1,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    -1,
      70,    71,    72,    73,    74,    75,    -1,    -1,    -1,    79,
      -1,    -1,    -1,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    -1,    95,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,    -1,   123,   124,    -1,    -1,   127,    -1,   129,
     130,   131,    -1,   133,    -1,   135,   136,    -1,   138,   139,
     140,    -1,   142,    -1,    -1,   145,    -1,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,    -1,   189,
     190,   191,    -1,   193,   194,   195,    -1,    -1,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,   216,   217,   218,   219,
     220,   221,    -1,   223,    -1,   225,   226,   227,   228,    -1,
      -1,   231,   232,   233,   234,    -1,    -1,   237,    -1,    -1,
      -1,   241,   242,   243,    -1,    -1,   246,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,    -1,
     260,    -1,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,   291,   292,   293,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,    -1,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,    -1,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,    -1,    -1,   343,    -1,   345,    -1,    -1,   348,   349,
     350,   351,   352,   353,    -1,    -1,   356,   357,   358,   359,
      -1,    -1,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   392,   393,   394,    -1,    -1,    -1,   398,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    20,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    63,
      64,    65,    66,    67,    68,    -1,    70,    71,    72,    -1,
      74,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      -1,    95,    96,    97,    98,    99,    -1,   101,   102,   103,
      -1,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
     124,   125,    -1,   127,    -1,   129,   130,   131,    -1,   133,
      -1,   135,    -1,    -1,    -1,   139,   140,    -1,   142,   143,
      -1,   145,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,    -1,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
     194,   195,    -1,    -1,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,    -1,   213,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,   226,    -1,   228,    -1,   230,   231,   232,   233,
     234,    -1,    -1,   237,    -1,    -1,    -1,   241,   242,   243,
      -1,    -1,   246,    -1,    -1,    -1,   250,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,    -1,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,    -1,    -1,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
      -1,    -1,   356,   357,   358,   359,    -1,    -1,   362,   363,
     364,   365,   366,   367,    -1,   369,    -1,   371,   372,   373,
      -1,    -1,   376,    -1,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,    -1,    -1,   398,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    20,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    -1,    70,    71,    72,    -1,    74,    75,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    -1,    95,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,   124,   125,    -1,   127,
      -1,   129,   130,   131,    -1,   133,    -1,   135,    -1,    -1,
      -1,   139,   140,    -1,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,    -1,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,   194,   195,    -1,    -1,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,    -1,   213,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,   226,    -1,
     228,    -1,   230,   231,   232,   233,   234,    -1,    -1,   237,
      -1,    -1,    -1,   241,   242,   243,    -1,    -1,   246,    -1,
      -1,    -1,   250,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,    -1,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,    -1,    -1,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,    -1,   356,   357,
     358,   359,    -1,    -1,   362,   363,   364,   365,   366,   367,
      -1,   369,    -1,   371,   372,   373,    -1,    -1,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,    -1,    -1,
     398,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    -1,    74,    75,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    -1,    95,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,   124,   125,    -1,   127,    -1,   129,   130,   131,
      -1,   133,    -1,   135,    -1,    -1,    -1,   139,   140,    -1,
     142,   143,   144,   145,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,    -1,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,   194,   195,    -1,    -1,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
      -1,   213,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,   226,    -1,   228,    -1,   230,   231,
     232,   233,   234,    -1,    -1,   237,    -1,    -1,    -1,   241,
     242,   243,    -1,    -1,   246,    -1,    -1,    -1,   250,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,    -1,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,    -1,
      -1,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,    -1,   356,   357,   358,   359,    -1,    -1,
     362,   363,   364,   365,   366,   367,    -1,   369,    -1,   371,
     372,   373,    -1,    -1,   376,    -1,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,    -1,    -1,   398,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    -1,    70,    71,    72,    -1,    74,    75,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    -1,    95,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,   124,   125,
      -1,   127,    -1,   129,   130,   131,    -1,   133,    -1,   135,
      -1,    -1,    -1,   139,   140,    -1,   142,   143,    -1,   145,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
      -1,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,   194,   195,
      -1,    -1,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,    -1,   213,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
     226,    -1,   228,    -1,   230,   231,   232,   233,   234,    -1,
      -1,   237,    -1,    -1,    -1,   241,   242,   243,    -1,    -1,
     246,    -1,    -1,    -1,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,    -1,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,    -1,   304,   305,
     306,   307,    -1,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,    -1,    -1,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,    -1,    -1,
     356,   357,   358,   359,    -1,    -1,   362,   363,   364,   365,
     366,   367,    -1,   369,    -1,   371,   372,   373,    -1,    -1,
     376,    -1,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
      -1,    -1,   398,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    -1,
      70,    71,    72,    -1,    74,    75,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    -1,    95,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,   125,    -1,   127,    -1,   129,
     130,   131,    -1,   133,    -1,   135,    -1,    -1,    -1,   139,
     140,    -1,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,    -1,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,   194,   195,    -1,    -1,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,    -1,   213,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,   226,    -1,   228,    -1,
     230,   231,   232,   233,   234,    -1,    -1,   237,    -1,    -1,
      -1,   241,   242,   243,    -1,    -1,   246,    -1,    -1,    -1,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,    -1,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,    -1,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,    -1,    -1,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,    -1,   356,   357,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,    -1,   369,
      -1,   371,   372,   373,    -1,    -1,   376,    -1,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,    -1,    -1,   398,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    63,
      64,    65,    66,    67,    68,    -1,    70,    71,    72,    -1,
      74,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      -1,    95,    96,    97,    98,    99,    -1,   101,   102,   103,
      -1,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
     124,   125,    -1,   127,    -1,   129,   130,   131,    -1,   133,
      -1,   135,    -1,    -1,    -1,   139,   140,    -1,   142,   143,
      -1,   145,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,    -1,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
     194,   195,    -1,    -1,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,    -1,   213,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,   226,    -1,   228,    -1,   230,   231,   232,   233,
     234,    -1,    -1,   237,    -1,    -1,    -1,   241,   242,   243,
      -1,    -1,   246,    -1,    -1,    -1,   250,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,    -1,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,    -1,    -1,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
      -1,    -1,   356,   357,   358,   359,    -1,    -1,   362,   363,
     364,   365,   366,   367,    -1,   369,    -1,   371,   372,   373,
      -1,    -1,   376,    -1,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,    -1,    -1,   398,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    -1,    70,    71,    72,    -1,    74,    75,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    -1,    95,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,   124,   125,    -1,   127,
      -1,   129,   130,   131,    -1,   133,    -1,   135,    -1,    -1,
      -1,   139,   140,    -1,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,    -1,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,   194,   195,    -1,    -1,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,    -1,   213,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,   226,    -1,
     228,    -1,   230,   231,   232,   233,   234,    -1,    -1,   237,
      -1,    -1,    -1,   241,   242,   243,    -1,    -1,   246,    -1,
      -1,    -1,   250,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,    -1,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,    -1,    -1,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,    -1,   356,   357,
     358,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
      -1,   369,    -1,   371,   372,   373,    -1,    -1,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,    -1,    -1,
     398,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    -1,    74,    75,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    -1,    95,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,   124,   125,    -1,   127,    -1,   129,   130,   131,
      -1,   133,    -1,   135,    -1,    -1,    -1,   139,   140,    -1,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,    -1,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,   194,   195,    -1,    -1,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
      -1,   213,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,   226,    -1,   228,    -1,   230,   231,
     232,   233,   234,    -1,    -1,   237,    -1,    -1,    -1,   241,
     242,   243,    -1,    -1,   246,    -1,    -1,    -1,   250,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,    -1,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,    -1,
      -1,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,    -1,   356,   357,   358,   359,    -1,    -1,
     362,   363,   364,   365,   366,   367,    -1,   369,    -1,   371,
     372,   373,    -1,    -1,   376,    -1,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,    -1,    -1,   398,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    -1,    70,    71,    72,    -1,    74,    75,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    -1,    95,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,   124,   125,
      -1,   127,    -1,   129,   130,   131,    -1,   133,    -1,   135,
      -1,    -1,    -1,   139,   140,    -1,   142,   143,    -1,   145,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
      -1,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,   194,   195,
      -1,    -1,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,    -1,   213,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
     226,    -1,   228,    -1,   230,   231,   232,   233,   234,    -1,
      -1,   237,    -1,    -1,    -1,   241,   242,   243,    -1,    -1,
     246,    -1,    -1,    -1,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,    -1,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,    -1,   304,   305,
     306,   307,    -1,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,    -1,    -1,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,    -1,    -1,
     356,   357,   358,   359,    -1,    -1,   362,   363,   364,   365,
     366,   367,    -1,   369,    -1,   371,   372,   373,    -1,    -1,
     376,    -1,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
      -1,    -1,   398,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    -1,
      70,    71,    72,    -1,    74,    75,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    -1,    95,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,   125,    -1,   127,    -1,   129,
     130,   131,    -1,   133,    -1,   135,    -1,    -1,    -1,   139,
     140,    -1,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,    -1,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,   194,   195,    -1,    -1,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,    -1,   213,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,   226,    -1,   228,    -1,
     230,   231,   232,   233,   234,    -1,    -1,   237,    -1,    -1,
      -1,   241,   242,   243,    -1,    -1,   246,    -1,    -1,    -1,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,    -1,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,    -1,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,    -1,    -1,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,    -1,   356,   357,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,    -1,   369,
      -1,   371,   372,   373,    -1,    -1,   376,    -1,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,    -1,    -1,   398,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    63,
      64,    65,    66,    67,    68,    -1,    70,    71,    72,    -1,
      74,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      -1,    95,    96,    97,    98,    99,    -1,   101,   102,   103,
      -1,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
     124,   125,    -1,   127,    -1,   129,   130,   131,    -1,   133,
      -1,   135,    -1,    -1,    -1,   139,   140,    -1,   142,   143,
      -1,   145,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,    -1,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
     194,   195,    -1,    -1,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,    -1,   213,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,   226,    -1,   228,    -1,   230,   231,   232,   233,
     234,    -1,    -1,   237,    -1,    -1,    -1,   241,   242,   243,
      -1,    -1,   246,    -1,    -1,    -1,   250,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,    -1,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,    -1,    -1,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
      -1,    -1,   356,   357,   358,   359,    -1,    -1,   362,   363,
     364,   365,   366,   367,    -1,   369,    -1,   371,   372,   373,
      -1,    -1,   376,    -1,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,    -1,    -1,   398,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    -1,    70,    71,    72,    -1,    74,    75,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    -1,    95,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,   124,   125,    -1,   127,
      -1,   129,   130,   131,    -1,   133,    -1,   135,    -1,    -1,
      -1,   139,   140,    -1,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,    -1,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,   194,   195,    -1,    -1,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,    -1,   213,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,   226,    -1,
     228,    -1,   230,   231,   232,   233,   234,    -1,    -1,   237,
      -1,    -1,    -1,   241,   242,   243,    -1,    -1,   246,    -1,
      -1,    -1,   250,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,    -1,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,    -1,    -1,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,    -1,   356,   357,
     358,   359,    -1,    -1,   362,   363,   364,   365,   366,   367,
      -1,   369,    -1,   371,   372,   373,    -1,    -1,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,    -1,    -1,
     398,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    -1,    74,    75,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    -1,    95,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,   124,   125,    -1,   127,    -1,   129,   130,   131,
      -1,   133,    -1,   135,    -1,    -1,    -1,   139,   140,    -1,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,    -1,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,   194,   195,    -1,    -1,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
      -1,   213,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,   226,    -1,   228,    -1,   230,   231,
     232,   233,   234,    -1,    -1,   237,    -1,    -1,    -1,   241,
     242,   243,    -1,    -1,   246,    -1,    -1,    -1,   250,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,    -1,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,    -1,
      -1,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,    -1,   356,   357,   358,   359,    -1,    -1,
     362,   363,   364,   365,   366,   367,    -1,   369,    -1,   371,
     372,   373,    -1,    -1,   376,    -1,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,    -1,    -1,   398,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    -1,    70,    71,    72,    -1,    74,    75,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    -1,    95,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,   124,   125,
      -1,   127,    -1,   129,   130,   131,    -1,   133,    -1,   135,
      -1,    -1,    -1,   139,   140,    -1,   142,   143,    -1,   145,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
      -1,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,   194,   195,
      -1,    -1,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,    -1,   213,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
     226,    -1,   228,    -1,   230,   231,   232,   233,   234,    -1,
      -1,   237,    -1,    -1,    -1,   241,   242,   243,    -1,    -1,
     246,    -1,    -1,    -1,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,    -1,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,    -1,   304,   305,
     306,   307,    -1,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,    -1,    -1,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,    -1,    -1,
     356,   357,   358,   359,    -1,    -1,   362,   363,   364,   365,
     366,   367,    -1,   369,    -1,   371,   372,   373,    -1,    -1,
     376,    -1,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
      -1,    -1,   398,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    -1,
      70,    71,    72,    -1,    74,    75,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    -1,    95,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,   125,    -1,   127,    -1,   129,
     130,   131,    -1,   133,    -1,   135,    -1,    -1,    -1,   139,
     140,    -1,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,    -1,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,   194,   195,    -1,    -1,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,    -1,   213,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,   226,    -1,   228,    -1,
     230,   231,   232,   233,   234,    -1,    -1,   237,    -1,    -1,
      -1,   241,   242,   243,    -1,    -1,   246,    -1,    -1,    -1,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,    -1,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,    -1,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,    -1,    -1,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,    -1,   356,   357,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,    -1,   369,
      -1,   371,   372,   373,    -1,    -1,   376,    -1,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,    -1,    -1,   398,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    63,
      64,    65,    66,    67,    68,    -1,    70,    71,    72,    -1,
      74,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      -1,    95,    96,    97,    98,    99,    -1,   101,   102,   103,
      -1,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
     124,   125,    -1,   127,    -1,   129,   130,   131,    -1,   133,
      -1,   135,    -1,    -1,    -1,   139,   140,    -1,   142,   143,
      -1,   145,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,    -1,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
     194,   195,    -1,    -1,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,    -1,   213,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,   226,    -1,   228,    -1,   230,   231,   232,   233,
     234,    -1,    -1,   237,    -1,    -1,    -1,   241,   242,   243,
      -1,    -1,   246,    -1,    -1,    -1,   250,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,    -1,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,    -1,    -1,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
      -1,    -1,   356,   357,   358,   359,    -1,    -1,   362,   363,
     364,   365,   366,   367,    -1,   369,    -1,   371,   372,   373,
      -1,    -1,   376,    -1,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,    -1,    -1,   398,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    -1,    70,    71,    72,    -1,    74,    75,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    -1,    95,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,   124,   125,    -1,   127,
      -1,   129,   130,   131,    -1,   133,    -1,   135,    -1,    -1,
      -1,   139,   140,    -1,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,    -1,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,   194,   195,    -1,    -1,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,    -1,   213,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,   226,    -1,
     228,    -1,   230,   231,   232,   233,   234,    -1,    -1,   237,
      -1,    -1,    -1,   241,   242,   243,    -1,    -1,   246,    -1,
      -1,    -1,   250,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,    -1,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,    -1,    -1,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,    -1,   356,   357,
     358,   359,    -1,    -1,   362,   363,   364,   365,   366,   367,
      -1,   369,    -1,   371,   372,   373,    -1,    -1,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,    -1,    -1,
     398,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    -1,    74,    75,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    -1,    95,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,   124,   125,    -1,   127,    -1,   129,   130,   131,
      -1,   133,    -1,   135,    -1,    -1,    -1,   139,   140,    -1,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,    -1,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,   194,   195,    -1,    -1,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
      -1,   213,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,   226,    -1,   228,    -1,   230,   231,
     232,   233,   234,    -1,    -1,   237,    -1,    -1,    -1,   241,
     242,   243,    -1,    -1,   246,    -1,    -1,    -1,   250,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,    -1,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,    -1,
      -1,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,    -1,   356,   357,   358,   359,    -1,    -1,
     362,   363,   364,   365,   366,   367,    -1,   369,    -1,   371,
     372,   373,    -1,    -1,   376,    -1,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,    -1,    -1,   398,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    -1,    70,    71,    72,    -1,    74,    75,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    -1,    95,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,   124,   125,
      -1,   127,    -1,   129,   130,   131,    -1,   133,    -1,   135,
      -1,    -1,    -1,   139,   140,    -1,   142,   143,    -1,   145,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
      -1,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,   194,   195,
      -1,    -1,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,    -1,   213,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
     226,    -1,   228,    -1,   230,   231,   232,   233,   234,    -1,
      -1,   237,    -1,    -1,    -1,   241,   242,   243,    -1,    -1,
     246,    -1,    -1,    -1,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,    -1,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,    -1,   304,   305,
     306,   307,    -1,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,    -1,    -1,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,    -1,    -1,
     356,   357,   358,   359,    -1,    -1,   362,   363,   364,   365,
     366,   367,    -1,   369,    -1,   371,   372,   373,    -1,    -1,
     376,    -1,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
      -1,    -1,   398,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    -1,
      70,    71,    72,    -1,    74,    75,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    -1,    95,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,   125,    -1,   127,    -1,   129,
     130,   131,    -1,   133,    -1,   135,    -1,    -1,    -1,   139,
     140,    -1,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,    -1,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,   194,   195,    -1,    -1,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,    -1,   213,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,   226,    -1,   228,    -1,
     230,   231,   232,   233,   234,    -1,    -1,   237,    -1,    -1,
      -1,   241,   242,   243,    -1,    -1,   246,    -1,    -1,    -1,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,    -1,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,    -1,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,    -1,    -1,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,    -1,   356,   357,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,    -1,   369,
      -1,   371,   372,   373,    -1,    -1,   376,    -1,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,    -1,    -1,   398,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    63,
      64,    65,    66,    67,    68,    -1,    70,    71,    72,    -1,
      74,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      -1,    95,    96,    97,    98,    99,    -1,   101,   102,   103,
      -1,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
     124,   125,    -1,   127,    -1,   129,   130,   131,    -1,   133,
      -1,   135,    -1,    -1,    -1,   139,   140,    -1,   142,   143,
      -1,   145,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,    -1,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
     194,   195,    -1,    -1,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,    -1,   213,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,   226,    -1,   228,    -1,   230,   231,   232,   233,
     234,    -1,    -1,   237,    -1,    -1,    -1,   241,   242,   243,
      -1,    -1,   246,    -1,    -1,    -1,   250,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,    -1,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,    -1,    -1,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
      -1,    -1,   356,   357,   358,   359,    -1,    -1,   362,   363,
     364,   365,   366,   367,    -1,   369,    -1,   371,   372,   373,
      -1,    -1,   376,    -1,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,    -1,    -1,   398,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    -1,    70,    71,    72,    -1,    74,    75,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    -1,    95,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,   124,   125,    -1,   127,
      -1,   129,   130,   131,    -1,   133,    -1,   135,    -1,    -1,
      -1,   139,   140,    -1,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,    -1,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,   194,   195,    -1,    -1,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,    -1,   213,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,   226,    -1,
     228,    -1,   230,   231,   232,   233,   234,    -1,    -1,   237,
      -1,    -1,    -1,   241,   242,   243,    -1,    -1,   246,    -1,
      -1,    -1,   250,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,    -1,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,    -1,    -1,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,    -1,   356,   357,
     358,   359,    -1,    -1,   362,   363,   364,   365,   366,   367,
      -1,   369,    -1,   371,   372,   373,    -1,    -1,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,    -1,    -1,
     398,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    -1,    74,    75,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    -1,    95,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,   124,   125,    -1,   127,    -1,   129,   130,   131,
      -1,   133,    -1,   135,    -1,    -1,    -1,   139,   140,    -1,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,    -1,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,   194,   195,    -1,    -1,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
      -1,   213,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,   226,    -1,   228,    -1,   230,   231,
     232,   233,   234,    -1,    -1,   237,    -1,    -1,    -1,   241,
     242,   243,    -1,    -1,   246,    -1,    -1,    -1,   250,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,    -1,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,    -1,
      -1,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,    -1,   356,   357,   358,   359,    -1,    -1,
     362,   363,   364,   365,   366,   367,    -1,   369,    -1,   371,
     372,   373,    -1,    -1,   376,    -1,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,    -1,    -1,   398,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    -1,    70,    71,    72,    -1,    74,    75,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    -1,    95,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,   124,   125,
      -1,   127,    -1,   129,   130,   131,    -1,   133,    -1,   135,
      -1,    -1,    -1,   139,   140,    -1,   142,   143,    -1,   145,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
      -1,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,   194,   195,
      -1,    -1,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,    -1,   213,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
     226,    -1,   228,    -1,   230,   231,   232,   233,   234,    -1,
      -1,   237,    -1,    -1,    -1,   241,   242,   243,    -1,    -1,
     246,    -1,    -1,    -1,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,    -1,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,    -1,   304,   305,
     306,   307,    -1,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,    -1,    -1,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,    -1,    -1,
     356,   357,   358,   359,    -1,    -1,   362,   363,   364,   365,
     366,   367,    -1,   369,    -1,   371,   372,   373,    -1,    -1,
     376,    -1,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
      -1,    -1,   398,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      20,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    -1,
      70,    71,    72,    -1,    74,    75,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    -1,    95,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,   125,    -1,   127,    -1,   129,
     130,   131,    -1,   133,    -1,   135,    -1,    -1,    -1,   139,
     140,    -1,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,    -1,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,   194,   195,    -1,    -1,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,    -1,   213,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,   226,    -1,   228,    -1,
     230,   231,   232,   233,   234,    -1,    -1,   237,    -1,    -1,
      -1,   241,   242,   243,    -1,    -1,   246,    -1,    -1,    -1,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,    -1,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,    -1,   304,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,    -1,    -1,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,    -1,   356,   357,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,    -1,   369,
      -1,   371,   372,   373,    -1,    -1,   376,    -1,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,    -1,    -1,   398,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    63,
      64,    65,    66,    67,    68,    -1,    70,    71,    72,    -1,
      74,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      -1,    95,    96,    97,    98,    99,    -1,   101,   102,   103,
      -1,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
     124,   125,    -1,   127,    -1,   129,   130,   131,    -1,   133,
      -1,   135,    -1,    -1,    -1,   139,   140,    -1,   142,   143,
      -1,   145,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,    -1,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
     194,   195,    -1,    -1,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,    -1,   213,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,   226,    -1,   228,    -1,   230,   231,   232,   233,
     234,    -1,    -1,   237,    -1,    -1,    -1,   241,   242,   243,
      -1,    -1,   246,    -1,    -1,    -1,   250,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,    -1,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,    -1,    -1,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
      -1,    -1,   356,   357,   358,   359,    -1,    -1,   362,   363,
     364,   365,   366,   367,    -1,   369,    -1,   371,   372,   373,
      -1,    -1,   376,    -1,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,    -1,    -1,   398,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    -1,    70,    71,    72,    -1,    74,    75,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    -1,    95,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,   124,   125,    -1,   127,
      -1,   129,   130,   131,    -1,   133,    -1,   135,    -1,    -1,
      -1,   139,   140,    -1,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,    -1,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,   194,   195,    -1,    -1,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,    -1,   213,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,   226,    -1,
     228,    -1,   230,   231,   232,   233,   234,    -1,    -1,   237,
      -1,    -1,    -1,   241,   242,   243,    -1,    -1,   246,    -1,
      -1,    -1,   250,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,    -1,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,    -1,    -1,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,    -1,   356,   357,
     358,   359,    -1,    -1,   362,   363,   364,   365,   366,   367,
      -1,   369,    -1,   371,   372,   373,    -1,    -1,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,    -1,    -1,
     398,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    -1,    74,    75,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    -1,    95,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,   124,   125,    -1,   127,    -1,   129,   130,   131,
      -1,   133,    -1,   135,    -1,    -1,    -1,   139,   140,    -1,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,    -1,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,   194,   195,    -1,    -1,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
      -1,   213,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,   226,    -1,   228,    -1,   230,   231,
     232,   233,   234,    -1,    -1,   237,    -1,    -1,    -1,   241,
     242,   243,    -1,    -1,   246,    -1,    -1,    -1,   250,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,    -1,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,    -1,
      -1,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,    -1,   356,   357,   358,   359,    -1,    -1,
     362,   363,   364,   365,   366,   367,    -1,   369,    -1,   371,
     372,   373,    -1,    -1,   376,    -1,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,    -1,    -1,   398,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    -1,    70,    71,    72,    -1,    74,    75,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    -1,    95,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,   124,   125,
      -1,   127,    -1,   129,   130,   131,    -1,   133,    -1,   135,
      -1,    -1,    -1,   139,   140,    -1,   142,   143,    -1,   145,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
      -1,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,   194,   195,
      -1,    -1,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,    -1,   213,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
     226,    -1,   228,    -1,   230,   231,   232,   233,   234,    -1,
      -1,   237,    -1,    -1,    -1,   241,   242,   243,    -1,    -1,
     246,    -1,    -1,    -1,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,    -1,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,    -1,   304,   305,
     306,   307,    -1,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,    -1,    -1,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,    -1,    -1,
     356,   357,   358,   359,    -1,    -1,   362,   363,   364,   365,
     366,   367,    -1,   369,    -1,   371,   372,   373,    -1,    -1,
     376,    -1,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
      -1,    -1,   398,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    -1,
      70,    71,    72,    -1,    74,    75,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    -1,    95,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,   125,    -1,   127,    -1,   129,
     130,   131,    -1,   133,    -1,   135,    -1,    -1,    -1,   139,
     140,    -1,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,    -1,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,   194,   195,    -1,    -1,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,    -1,   213,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,   226,    -1,   228,    -1,
     230,   231,   232,   233,   234,    -1,    -1,   237,    -1,    -1,
      -1,   241,   242,   243,    -1,    -1,   246,    -1,    -1,    -1,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,    -1,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,    -1,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,    -1,    -1,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,    -1,   356,   357,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,    -1,   369,
      -1,   371,   372,   373,    -1,    -1,   376,    -1,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,    -1,    -1,   398,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    63,
      64,    65,    66,    67,    68,    -1,    70,    71,    72,    -1,
      74,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      -1,    95,    96,    97,    98,    99,    -1,   101,   102,   103,
      -1,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
     124,   125,    -1,   127,    -1,   129,   130,   131,    -1,   133,
      -1,   135,    -1,    -1,    -1,   139,   140,    -1,   142,   143,
      -1,   145,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,    -1,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
     194,   195,    -1,    -1,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,    -1,   213,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,   226,    -1,   228,    -1,   230,   231,   232,   233,
     234,    -1,    -1,   237,    -1,    -1,    -1,   241,   242,   243,
      -1,    -1,   246,    -1,    -1,    -1,   250,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,    -1,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,    -1,    -1,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
      -1,    -1,   356,   357,   358,   359,    -1,    -1,   362,   363,
     364,   365,   366,   367,    -1,   369,    -1,   371,   372,   373,
      -1,    -1,   376,    -1,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,    -1,    -1,   398,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    -1,    70,    71,    72,    -1,    74,    75,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    -1,    95,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,   124,   125,    -1,   127,
      -1,   129,   130,   131,    -1,   133,    -1,   135,    -1,    -1,
      -1,   139,   140,    -1,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,    -1,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,   194,   195,    -1,    -1,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,    -1,   213,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,   226,    -1,
     228,    -1,   230,   231,   232,   233,   234,    -1,    -1,   237,
      -1,    -1,    -1,   241,   242,   243,    -1,    -1,   246,    -1,
      -1,    -1,   250,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,    -1,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,    -1,    -1,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,    -1,   356,   357,
     358,   359,    -1,    -1,   362,   363,   364,   365,   366,   367,
      -1,   369,    -1,   371,   372,   373,    -1,    -1,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,    -1,    -1,
     398,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    -1,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      -1,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    -1,    95,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
      -1,   123,   124,    -1,    -1,   127,    -1,   129,   130,   131,
      -1,   133,    -1,   135,   136,    -1,   138,   139,   140,    -1,
     142,    -1,    -1,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,    -1,   189,   190,   191,
      -1,   193,   194,   195,    -1,    -1,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,   216,   217,   218,   219,   220,   221,
      -1,   223,    -1,   225,   226,   227,   228,   229,    -1,   231,
     232,   233,   234,    -1,    -1,   237,    -1,    -1,    -1,   241,
     242,   243,    -1,    -1,    -1,   247,   248,   249,    -1,   251,
     252,   253,   254,   255,   256,    -1,   258,    -1,   260,    -1,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,    -1,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,   340,    -1,
      -1,   343,    -1,   345,    -1,    -1,   348,   349,   350,   351,
     352,   353,    -1,    -1,   356,   357,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,    -1,   369,   370,   371,
     372,   373,    -1,    -1,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     392,   393,   394,    -1,    -1,    -1,   398,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    -1,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    -1,    70,    71,    72,    73,    74,    75,
      -1,    -1,    -1,    79,    -1,    -1,    -1,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    -1,    95,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,    -1,   123,   124,    -1,
      -1,   127,    -1,   129,   130,   131,    -1,   133,    -1,   135,
     136,    -1,   138,   139,   140,    -1,   142,    -1,    -1,   145,
      -1,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,    -1,   189,   190,   191,    -1,   193,   194,   195,
      -1,    -1,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
     226,   227,   228,    -1,    -1,   231,   232,   233,   234,    -1,
      -1,   237,    -1,    -1,    -1,   241,   242,   243,    -1,    -1,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,   291,   292,   293,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,    -1,   304,   305,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,    -1,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,    -1,    -1,   343,    -1,   345,
      -1,    -1,   348,   349,   350,   351,   352,   353,    -1,    -1,
     356,   357,   358,   359,    -1,    -1,   362,   363,   364,   365,
      -1,   367,    -1,   369,   370,   371,   372,   373,    -1,    -1,
     376,    -1,    -1,   379,   380,   381,   382,   383,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   392,   393,   394,    -1,
      -1,    -1,   398,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    -1,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    -1,
      70,    71,    72,    73,    74,    75,    -1,    -1,    -1,    79,
      -1,    -1,    -1,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    -1,    95,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,    -1,   123,   124,    -1,    -1,   127,    -1,   129,
     130,   131,    -1,   133,    -1,   135,   136,    -1,   138,   139,
     140,    -1,   142,    -1,    -1,   145,    -1,   147,   148,   149,
     150,   151,   152,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,   171,    -1,   173,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,    -1,   189,
     190,   191,    -1,   193,   194,   195,    -1,    -1,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,   226,   227,   228,    -1,
      -1,   231,   232,   233,   234,    -1,    -1,   237,    -1,    -1,
      -1,   241,   242,   243,    -1,    -1,    -1,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,    -1,
     260,    -1,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,   291,   292,   293,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,    -1,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,    -1,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,    -1,    -1,   343,    -1,   345,    -1,    -1,   348,   349,
     350,   351,   352,   353,    -1,    -1,   356,   357,   358,   359,
      -1,    -1,   362,   363,   364,   365,    -1,   367,    -1,   369,
     370,   371,   372,   373,    -1,    -1,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   392,   393,   394,    -1,    -1,    -1,   398,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    -1,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    63,
      64,    65,    66,    67,    68,    -1,    70,    71,    72,    73,
      74,    75,    -1,    -1,    -1,    79,    -1,    -1,    -1,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      -1,    95,    96,    97,    98,    99,    -1,   101,   102,   103,
      -1,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,    -1,   123,
     124,    -1,    -1,   127,    -1,   129,   130,   131,    -1,   133,
      -1,   135,   136,    -1,   138,   139,   140,    -1,   142,    -1,
      -1,   145,    -1,   147,   148,   149,   150,   151,   152,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,   171,    -1,   173,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,    -1,    -1,   189,   190,   191,    -1,   193,
     194,   195,    -1,    -1,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,   216,   217,   218,   219,   220,   221,    -1,   223,
      -1,   225,   226,   227,   228,    -1,    -1,   231,   232,   233,
     234,    -1,    -1,   237,    -1,    -1,    -1,   241,   242,   243,
      -1,    -1,    -1,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,    -1,   260,    -1,   262,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,   291,   292,   293,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,    -1,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,    -1,    -1,   343,
      -1,   345,    -1,    -1,   348,   349,   350,   351,   352,   353,
      -1,    -1,   356,   357,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,    -1,   369,   370,   371,   372,   373,
      -1,    -1,   376,    -1,    -1,   379,   380,   381,   382,   383,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   392,   393,
     394,    -1,    -1,    -1,   398,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    -1,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    -1,    70,    71,    72,    73,    74,    75,    -1,    -1,
      -1,    79,    -1,    -1,    -1,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    -1,    95,    96,    97,
      98,    99,    -1,   101,   102,   103,    -1,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,    -1,   123,   124,    -1,    -1,   127,
      -1,   129,   130,   131,    -1,   133,    -1,   135,   136,    -1,
     138,   139,   140,    -1,   142,    -1,    -1,   145,    -1,   147,
     148,   149,   150,   151,   152,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,   171,    -1,   173,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,    -1,
      -1,   189,   190,   191,    -1,   193,   194,   195,    -1,    -1,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,   216,   217,
     218,   219,   220,   221,    -1,   223,    -1,   225,   226,   227,
     228,    -1,    -1,   231,   232,   233,   234,    -1,    -1,   237,
      -1,    -1,    -1,   241,   242,   243,    -1,    -1,    -1,   247,
     248,   249,    -1,   251,   252,   253,   254,   255,   256,    -1,
     258,    -1,   260,    -1,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,   291,   292,   293,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,    -1,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,    -1,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,    -1,    -1,   343,    -1,   345,    -1,    -1,
     348,   349,   350,   351,   352,   353,    -1,    -1,   356,   357,
     358,   359,    -1,    -1,   362,   363,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,    -1,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   392,   393,   394,    -1,    -1,    -1,
     398,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    -1,    74,    75,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    -1,    95,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,   124,   125,    -1,   127,    -1,   129,   130,   131,
      -1,   133,    -1,   135,    -1,    -1,    -1,   139,   140,    -1,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,   167,   168,   169,   170,   171,
      -1,   173,    -1,   175,    -1,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,   194,   195,    -1,    -1,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
      -1,   213,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,   226,    -1,   228,    -1,   230,   231,
     232,   233,   234,    -1,    -1,   237,    -1,    -1,    -1,   241,
     242,   243,    -1,    -1,   246,    -1,    -1,    -1,   250,   251,
     252,   253,   254,    -1,   256,    -1,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,    -1,
     292,   293,   294,    -1,   296,   297,   298,   299,   300,   301,
     302,    -1,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,    -1,
      -1,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,    -1,   356,   357,   358,   359,    -1,    -1,
     362,   363,   364,   365,   366,   367,    -1,   369,    -1,   371,
     372,   373,    -1,    -1,   376,    -1,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,    -1,    -1,   398,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    -1,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    -1,    70,    71,    72,    73,    74,    75,
      -1,    -1,    -1,    79,    -1,    -1,    -1,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    -1,    95,
      96,    97,    98,    99,    -1,   101,   102,   103,    -1,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,    -1,   123,   124,    -1,
      -1,   127,    -1,   129,   130,   131,    -1,   133,    -1,   135,
     136,    -1,   138,   139,   140,    -1,   142,    -1,    -1,   145,
      -1,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,   171,    -1,   173,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,    -1,   189,   190,   191,    -1,   193,   194,   195,
      -1,    -1,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
     216,   217,   218,   219,   220,   221,    -1,   223,    -1,   225,
     226,   227,   228,    -1,    -1,   231,   232,   233,   234,    -1,
      -1,   237,    -1,    -1,    -1,   241,   242,   243,    -1,    -1,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,   291,   292,   293,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,    -1,   304,   305,
     306,   307,    -1,   309,    -1,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,    -1,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,    -1,    -1,   343,    -1,   345,
      -1,    -1,   348,   349,   350,   351,   352,   353,    -1,    -1,
     356,   357,   358,   359,    -1,    -1,   362,   363,   364,   365,
      -1,   367,    -1,   369,   370,   371,   372,   373,    -1,    -1,
     376,    -1,    -1,   379,   380,   381,   382,   383,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   392,   393,   394,    -1,
      -1,    -1,   398,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    26,    27,    28,    29,
      30,    -1,    32,    -1,    -1,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    -1,    -1,    47,    -1,    49,
      50,    51,    52,    -1,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    -1,
      70,    71,    72,    73,    74,    75,    -1,    -1,    -1,    79,
      -1,    -1,    -1,    83,    84,    85,    86,    87,    88,    -1,
      -1,    91,    -1,    93,    -1,    95,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,    -1,   123,   124,    -1,    -1,   127,    -1,   129,
      -1,   131,    -1,   133,    -1,   135,   136,    -1,   138,   139,
     140,    -1,   142,    -1,    -1,   145,    -1,   147,   148,   149,
     150,   151,   152,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
      -1,    -1,    -1,    -1,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,    -1,   189,
     190,   191,    -1,   193,   194,   195,    -1,    -1,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,   212,    -1,    -1,   215,   216,   217,   218,   219,
     220,   221,    -1,   223,    -1,   225,   226,   227,   228,    -1,
      -1,   231,    -1,   233,   234,    -1,    -1,   237,    -1,    -1,
      -1,   241,   242,   243,    -1,    -1,    -1,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,    -1,
     260,    -1,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,    -1,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,   291,   292,   293,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,    -1,   304,   305,   306,   307,    -1,   309,
      -1,   311,   312,   313,   314,    -1,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,    -1,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,    -1,
      -1,    -1,    -1,   343,    -1,   345,    -1,    -1,   348,   349,
     350,   351,   352,   353,    -1,    -1,   356,   357,   358,   359,
      -1,    -1,   362,   363,   364,   365,    -1,    -1,    -1,   369,
     370,   371,   372,   373,    -1,    -1,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   392,   393,   394,    -1,    -1,    -1,   398
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     3,    13,    15,    16,    29,    49,    51,    52,    56,
      57,    67,    69,    88,    91,    97,   103,   109,   115,   121,
     123,   128,   141,   168,   193,   194,   199,   208,   226,   263,
     274,   278,   280,   285,   290,   293,   297,   303,   309,   312,
     319,   332,   348,   357,   359,   362,   366,   378,   419,   427,
     428,   429,   430,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   444,   445,   449,   459,   461,   462,   465,   466,
     467,   477,   478,   487,   515,   521,   522,   528,   534,   536,
     538,   539,   540,   541,   550,   554,   555,   556,   558,   559,
     560,   573,   574,   575,   576,   586,   592,   593,   596,   597,
     598,   599,   600,   605,   607,   610,   613,   614,   624,   625,
     628,   636,   655,   658,   659,   660,   663,   665,   667,   670,
     673,   674,   675,   678,   686,   687,   688,   689,   690,   695,
     697,   698,   702,   703,   706,   707,   708,   710,   711,   712,
     713,   715,   716,   717,   722,   725,   728,   730,   731,   736,
     738,   742,   749,   752,   753,   754,   755,   756,   757,   784,
     343,   380,   691,    10,    66,    86,   107,   134,   139,   144,
     159,   241,   268,   292,   298,   304,   306,   332,   333,   337,
     345,   350,   360,   372,   535,   691,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    22,    23,
      25,    27,    28,    29,    31,    33,    34,    36,    37,    38,
      39,    40,    43,    44,    45,    46,    47,    49,    50,    51,
      52,    53,    56,    57,    58,    59,    60,    61,    63,    64,
      65,    66,    67,    68,    70,    71,    72,    74,    75,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    93,    95,
      96,    97,    98,    99,   101,   102,   103,   106,   107,   108,
     109,   110,   112,   113,   114,   116,   117,   119,   120,   121,
     122,   123,   124,   125,   127,   129,   130,   131,   133,   135,
     139,   140,   142,   143,   145,   147,   148,   149,   150,   151,
     153,   154,   155,   157,   158,   159,   160,   161,   162,   165,
     166,   167,   168,   169,   170,   171,   173,   175,   178,   180,
     181,   182,   183,   184,   185,   186,   188,   190,   193,   194,
     195,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   213,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   225,   226,   228,   230,   231,
     232,   233,   234,   237,   241,   242,   243,   246,   250,   251,
     252,   253,   254,   255,   256,   258,   259,   260,   261,   262,
     263,   264,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   289,   290,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   304,   305,   306,   307,
     309,   310,   311,   312,   314,   315,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   330,   331,
     333,   334,   335,   336,   337,   339,   340,   343,   344,   345,
     346,   348,   349,   350,   351,   352,   353,   356,   357,   358,
     359,   362,   363,   364,   365,   366,   367,   369,   371,   372,
     373,   376,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   398,   886,
     898,   901,   902,   370,   718,   239,   264,   691,    32,   483,
     753,    10,    22,    42,    62,    86,    92,   107,   134,   140,
     144,   195,   241,   244,   292,   298,   306,   333,   334,   336,
     337,   345,   349,   350,   355,   360,   488,   529,   589,   629,
     637,    11,   263,   886,   886,   137,    11,   258,   334,   336,
      10,    22,    42,    66,    86,   107,   134,   139,   144,   159,
     241,   251,   292,   296,   298,   304,   306,   332,   333,   337,
     345,   350,   360,   372,   535,   601,   691,   886,   717,   724,
       4,    11,    27,   129,   135,   184,   215,   266,   279,   404,
     410,   411,   611,   886,   894,   897,    11,    69,   277,   303,
     615,   616,   617,   898,   174,   898,   400,   891,   895,   332,
     762,   611,   886,   898,   343,   886,   251,    86,   159,   331,
     332,   668,   297,   898,    11,   307,   339,   343,   451,   898,
       8,   141,   615,   616,   264,   691,   898,    11,   104,   764,
      43,    63,   195,   210,   292,   298,   307,   339,   343,   383,
     450,   451,    11,   307,   339,   343,   451,   343,   214,   238,
     240,   793,   882,   884,   898,   905,   762,   412,   898,   793,
     795,   138,   719,   419,   879,   276,   758,   759,   886,   753,
     754,     0,   423,   718,   118,   172,   245,   354,   765,   766,
     753,   755,   756,   424,    26,    30,    32,    73,    79,   136,
     138,   152,   164,   176,   177,   179,   189,   191,   212,   227,
     247,   248,   249,   291,   313,   370,   398,   882,   892,   899,
     901,   903,   603,   898,   887,   898,   603,    85,   623,   892,
     896,   898,   884,    50,   127,   403,   406,   407,   408,   410,
     411,   412,   413,   414,   415,   662,   848,   849,   898,   896,
     886,   793,   884,   886,   793,   886,   300,   886,   603,   201,
     896,   884,   182,   178,   272,   692,   693,   694,   884,   890,
     898,    10,    42,    55,    62,    66,    86,   107,   139,   159,
     183,   241,   292,   296,   298,   304,   332,   333,   337,   345,
     350,   372,   535,   608,   895,   884,   341,   892,   886,   419,
     345,   887,   603,    85,   334,   336,   896,   334,   336,    50,
     127,   662,   283,   896,   446,   898,   886,   886,   300,   886,
     603,   201,   896,   304,   332,   372,   535,    66,   159,   139,
     296,    11,   886,   750,   795,   151,   892,   886,   151,   666,
     151,   887,    85,   151,   892,   151,   885,   886,    50,   127,
     151,   662,    36,   151,   885,   151,   886,   151,   886,   151,
     886,   300,   151,   886,   151,   201,   885,   182,   151,   602,
     603,   419,   729,   718,   897,    11,   897,    11,   897,   897,
     894,   894,   137,   156,   612,   267,   419,   419,   502,   502,
     502,   239,   341,   424,   502,   884,   793,   794,   612,   895,
     419,   726,    36,   886,   886,   884,   898,    26,   394,   178,
     422,   242,   242,   239,   137,   895,   341,   239,    19,    31,
      33,    34,    41,    42,    45,    46,    53,    76,    77,    78,
      79,    80,    81,    82,    89,    90,   108,   122,   125,   126,
     130,   143,   170,   171,   173,   188,   196,   197,   211,   213,
     224,   229,   230,   232,   241,   250,   259,   273,   294,   308,
     315,   327,   339,   340,   344,   346,   347,   355,   360,   367,
     385,   386,   387,   388,   389,   390,   391,   399,   401,   402,
     403,   405,   410,   411,   412,   419,   753,   804,   807,   810,
     811,   812,   814,   815,   816,   817,   820,   821,   825,   827,
     828,   846,   850,   867,   872,   880,   881,   882,   892,   893,
     894,   895,   895,    11,   463,   883,   884,   307,   450,    92,
     457,   895,   458,   895,   898,   895,    26,    47,   450,   394,
     693,   242,   137,   341,   406,    26,   394,   178,   694,   419,
     884,   417,   422,   873,   874,   412,   794,    20,   898,   309,
     136,   720,    92,   825,   877,   878,   758,   424,   419,   721,
     420,   420,   429,   884,    11,   104,   763,   763,    36,   763,
     128,   132,   192,   236,   769,   779,   781,   782,   765,   766,
     879,   874,   419,   581,   252,   281,   422,   604,   252,   281,
     309,   378,   398,   431,   459,   460,   677,     7,   109,   252,
     309,   470,   381,    38,    68,   124,   154,   252,   281,   289,
     295,   302,   309,   317,   325,   373,   460,   649,   656,   677,
     419,   638,     7,   109,   281,   443,     7,    13,    52,   102,
     109,   112,   161,   216,   252,   281,   285,   309,   468,   469,
     603,   603,   419,   661,   422,   281,   309,   431,   460,   252,
     281,   677,   677,    37,    84,   158,   203,   205,   216,   251,
     281,   286,   309,   319,   468,   524,   525,   243,   252,   371,
     544,   552,    13,   281,   309,   468,   677,   252,   281,    60,
     101,   253,   335,   239,   252,   281,   309,   132,   281,   431,
     460,   281,   309,   468,   886,   190,   240,   382,   424,   692,
     361,   714,   239,   892,   419,   886,   892,   233,    50,   127,
     662,   886,   300,   886,   182,   603,   502,   322,   323,   480,
     895,   419,   581,   582,    48,    31,    33,    34,    45,    46,
      89,    90,   130,   170,   171,   173,   211,   213,   232,   273,
     310,   315,   339,   340,   367,   398,   801,   803,   805,   807,
     809,   811,   812,   813,   815,   816,   820,   821,   899,   901,
     886,   431,    20,   709,   381,   431,   603,   603,   419,   577,
     488,   431,    26,   676,   677,   350,   551,   252,   537,    60,
     101,   253,   335,     9,    28,   561,    20,   577,   132,   431,
     884,   516,   884,   884,   182,   603,    59,   890,   898,   892,
     886,    32,    83,   167,   216,   299,   361,   737,   122,   581,
      39,   287,   471,   122,   419,   122,   381,   122,   638,   122,
     424,   151,   603,   151,   603,   122,   661,   885,   122,   122,
     239,   122,   471,   122,    60,   101,   253,   335,   122,   239,
     122,   132,   151,   151,   458,   122,   424,   471,   825,   853,
      69,   515,   723,   728,   731,   736,   742,   749,   752,   886,
     419,   503,   504,   898,   503,    86,   134,   139,   182,   298,
     304,   332,   333,   618,   883,   885,   617,    92,   419,   732,
     752,   156,   424,   739,   886,   801,   854,    20,   885,   133,
     669,   669,   669,   190,   898,   132,   132,   618,   885,   297,
     898,   419,   417,   753,   855,   369,   818,   825,   871,   419,
     818,   818,   419,   419,   419,   419,   806,   806,   261,   753,
     419,   419,   808,   419,   419,   419,   419,    45,    46,   818,
     825,   419,   806,   419,   419,   419,   419,   419,   379,   397,
     419,   822,   419,   822,   419,   419,   753,   419,   419,   419,
     419,   419,   419,   419,   875,   825,   825,   366,   753,   825,
     853,   895,    46,   419,   819,   419,   895,    17,    20,    25,
      30,   152,   156,   176,   177,   191,   224,   227,   241,   244,
     313,   398,   403,   406,   407,   408,   410,   411,   412,   413,
     414,   415,   421,   848,   850,   852,   249,   825,   174,   424,
     760,   874,   419,   895,    95,   153,   464,   424,    47,    92,
     458,    20,    92,   195,   398,   399,   411,   456,   527,   821,
     895,   897,    64,   106,   834,    75,    92,   126,   235,   239,
     347,   452,   453,   455,   458,   527,    92,   452,   190,   884,
     825,    11,    15,    16,    17,    18,    19,    20,    21,    24,
      35,    41,    42,    48,    54,    55,    62,    69,    76,    77,
      78,    80,    81,    82,    92,    94,   100,   104,   105,   111,
     115,   118,   126,   128,   132,   134,   137,   141,   144,   146,
     156,   163,   172,   174,   187,   192,   196,   197,   214,   224,
     229,   235,   236,   238,   239,   240,   244,   245,   257,   265,
     277,   288,   303,   308,   316,   329,   332,   338,   341,   342,
     347,   354,   355,   360,   361,   368,   374,   375,   377,   378,
     398,   412,   889,   900,   901,   902,   903,   904,   873,    65,
     286,   606,   898,   419,   743,   744,   745,   746,   747,   898,
     718,   420,   424,   759,   885,    20,   721,   755,   755,   767,
     768,   825,   755,   129,   215,   776,   272,   311,   359,    11,
     771,   825,   773,   774,   825,   827,   779,   780,   769,   770,
     132,   782,   769,   779,   412,   854,   252,   281,   309,   341,
     341,   889,   422,   341,   341,   333,   450,   406,   701,   704,
      48,    62,   134,   265,   355,   500,   501,    62,    92,   224,
     341,    92,   224,   298,   886,   239,   527,   302,   341,   341,
     229,   527,    96,   175,   298,   287,   649,   657,   156,   165,
     246,   310,   368,   420,   639,   642,   643,   644,   646,   801,
     899,   341,   360,    55,   500,   671,   671,   239,   296,   345,
      62,   671,    14,   284,   296,   345,   884,   161,   341,   341,
     419,   473,   333,   378,   379,   473,   424,   361,   361,   222,
     801,   252,   662,   341,   432,   341,   341,   527,    36,   526,
     527,   527,    84,   203,   205,    36,   341,   431,   298,   431,
     216,   525,   419,   341,   229,   895,   544,   671,   341,   671,
     298,   341,   341,   603,   603,   603,   603,   884,   341,   341,
     298,    82,   360,   557,   896,   341,   432,   341,   298,   252,
     281,   272,   282,   305,   454,   692,   890,   884,   581,   801,
     239,   638,   527,   603,   603,   661,   176,   239,    60,   101,
     253,   335,   239,   603,   176,   378,   484,   431,   398,   583,
     584,   577,   419,   803,    20,    19,   802,    87,   149,   204,
     207,   301,   392,   419,   823,   824,   604,   806,     9,   699,
     801,   886,   432,   589,   361,   578,   579,   900,   372,   432,
     896,   447,   895,   552,   553,   886,   198,   603,   603,   603,
     603,    97,   168,   348,   359,   562,   563,   116,   419,   557,
     432,   523,   524,    20,   234,   419,   517,   502,   458,   132,
     890,   239,   419,   640,    20,   378,   379,   751,   299,   419,
     753,   786,   787,   788,   793,   796,   828,   882,   892,   375,
     798,   892,   471,   801,   887,   151,   886,   892,   471,   885,
     886,   122,   361,   122,   361,   662,   471,   471,   885,   886,
     884,   886,   886,   886,   884,   885,   557,   122,   122,   471,
     602,   603,   420,   424,   488,   503,   420,   424,   420,   885,
      85,   306,   622,   623,   885,   885,   883,   883,   885,   341,
     378,   626,   366,   733,   734,   898,   288,   735,     5,   120,
     294,   311,   740,   793,   228,   741,   420,   424,   727,   731,
     736,   742,   752,   341,   616,   615,   616,   137,   142,   627,
     898,   853,   418,   853,   855,   856,   419,   374,   868,   869,
     825,   853,   894,   894,   853,    87,   149,   204,   207,   301,
     392,   398,   857,   858,   895,   894,   853,   853,   894,   894,
     818,   818,   825,   662,   825,   859,   410,   411,   826,   827,
     846,   850,   861,   420,   853,   825,   853,   862,   339,   394,
     894,   894,   825,    35,   137,   187,   342,   825,   853,   865,
     853,   209,   825,   832,   833,   834,   209,   825,   834,   873,
     420,   424,   309,   894,   894,   823,   825,   900,   339,    24,
     329,   876,   825,   419,   753,   866,   104,   106,   126,   224,
     229,   234,   347,   356,   825,    30,   152,   156,   191,   313,
     419,   825,   341,   825,   825,   825,   825,   825,   825,   825,
     825,   825,   801,   825,    11,    18,   316,   847,   294,   419,
     846,   140,   195,   332,   334,   336,   761,   884,   881,   137,
     785,    11,   104,   368,   412,   420,   853,   884,   343,   399,
     419,   895,   424,   420,   418,   425,   150,   150,   471,   747,
     748,   424,   785,   406,   875,   716,   884,   877,   420,   753,
     424,    21,   100,   361,   634,   419,   772,   897,   240,   234,
     783,   783,   236,   424,   192,   294,   295,   775,   780,   770,
     420,   420,   341,   341,   298,   896,   886,   889,   896,   887,
     886,   895,    61,   705,   419,   886,   180,   180,   419,   886,
     229,   896,   825,   229,   886,   216,   252,   364,   531,   544,
     229,    96,   175,   896,   886,   239,   886,   246,   899,   420,
     424,   644,   646,   643,   646,   899,   604,   896,   885,   492,
     898,   898,   886,   886,    11,   360,   886,   886,   898,   296,
     345,   296,   345,   886,    11,   360,   886,   884,   896,   886,
     475,   476,   900,   886,   237,    52,   237,   469,   888,   898,
     888,   424,   420,   424,   341,   896,     8,    61,    70,    71,
      72,   114,   156,   161,   200,   217,   218,   219,   220,   221,
     223,   256,   292,   328,   330,   353,   360,   363,   433,   896,
     886,   527,   603,   886,   527,   886,   527,     7,   109,   309,
     545,   546,   547,   548,   900,   896,   898,   886,   886,   886,
     896,   886,     7,    13,   109,   252,   281,   252,   281,   577,
     281,   281,   281,   896,   886,   886,   306,   896,   886,   886,
     341,   341,    58,   352,   272,   176,    20,   603,   176,   176,
     361,   361,   176,   229,   609,   895,   603,   603,   603,   603,
     603,   603,   176,   609,   237,   137,   341,   479,   481,   406,
     420,   424,   825,    19,   802,   801,   417,   417,   341,   341,
     341,   419,   341,   894,   806,   562,    61,   113,   185,   186,
     198,   252,   333,   335,   677,   700,   493,   531,   532,   132,
     888,   420,   424,   406,   884,   676,    69,   141,   448,   487,
     521,   560,   613,   628,   695,   134,   895,   577,   577,   577,
     577,   239,   244,   419,   799,   800,   898,   306,   676,   121,
     752,   884,   191,   489,   490,   491,   492,   497,   500,   518,
     519,   898,   378,   379,   511,    20,   145,   895,   239,   884,
     420,   641,   642,   647,    20,   182,   289,   377,   648,   649,
     650,   677,   679,   148,   148,   132,   753,   787,   788,    20,
     789,   898,   424,    73,   138,   164,   179,   189,   212,   291,
     790,   789,    20,   789,   898,   874,   419,    75,   825,   735,
     581,    20,   122,   471,   638,   603,   888,   603,   888,   661,
     239,   471,   471,   239,   471,   306,   132,   458,   471,   825,
     332,   420,   504,   381,   885,   424,   144,   619,   620,   896,
       8,   627,   420,   424,   875,   880,   120,   311,   120,   311,
     294,   359,   206,   801,   886,   137,   239,   619,    36,   471,
     420,   418,   418,   424,   853,   825,   111,   869,   870,    20,
     420,   420,   420,   420,   420,   137,   420,   420,   420,   420,
     420,   424,   420,   257,   860,   420,   826,   826,   156,   176,
     241,   406,   407,   408,   410,   411,   412,   413,   414,   415,
     421,   850,   826,   420,   420,   132,   137,   863,   864,   420,
     394,   420,   420,    20,   865,   853,   865,   865,   137,   420,
     420,   900,    20,   420,   424,   825,   900,   424,   825,   875,
     825,   898,   420,   420,   394,   826,   826,   117,   853,   137,
     104,   106,   126,   229,   234,   347,   356,   419,   117,   329,
     876,   825,   866,   825,   341,   662,   825,   419,   753,   334,
     336,   334,   336,   884,   762,   762,   786,   375,   797,   853,
     853,   825,   420,   248,   839,   420,   424,   693,   894,   823,
     453,   825,   420,   424,   744,   798,   877,   768,   241,   848,
     851,   395,   396,   635,   825,   775,   883,   741,   741,   773,
     773,   771,   128,   896,   886,   886,   192,   825,   501,   419,
     419,   503,   471,   364,   341,   530,   886,   544,   166,   229,
     604,   642,   646,   646,   414,   801,   109,   309,   470,   672,
     471,   471,   886,   886,   886,   886,   420,   424,   406,   422,
     252,   281,     7,   109,   252,   281,   801,   222,   801,   896,
     885,   192,   256,   144,   292,   229,   895,   885,   894,   256,
     885,   358,   547,   548,   547,   420,   424,   549,   895,   677,
     341,   201,   201,   201,   341,   341,   341,   341,   341,   341,
     341,   886,   896,   886,   609,   801,   176,   609,   609,   888,
     888,   609,   176,   176,   176,   176,   176,   176,   609,   480,
      32,    74,    98,   117,   133,   147,   229,   237,   270,   482,
     241,   410,   411,   527,   580,   646,   851,   895,   904,   398,
     584,   420,   417,   420,   894,   418,   894,   149,   204,   824,
     204,   824,   824,   894,   207,   420,   239,   192,   701,   701,
     701,   701,   701,   701,   701,    48,    62,    92,    94,   163,
     224,   229,   265,   277,   355,   494,   495,   496,   243,   542,
     350,   579,   580,   502,   447,   244,   488,    85,   884,   563,
     585,   895,   420,   424,   801,   886,   886,   378,   520,   419,
     884,   420,   424,   420,   424,   237,   473,   237,   239,   512,
     752,   530,   341,   884,   361,   630,   420,   424,    92,   406,
     651,   895,   458,   332,   645,   646,   378,   650,   652,   239,
     752,   420,   898,   419,   787,   179,   247,   791,   787,   791,
     179,   790,   791,   179,   419,   898,   419,   853,   234,   471,
     801,   886,   471,   361,   471,   361,   471,   471,   884,   884,
     886,   557,   471,   884,   885,   623,   896,   378,   424,   621,
     242,   752,   734,   120,   120,   885,   618,   471,   896,   855,
     420,   338,   825,   115,   801,   825,   825,   825,   863,   826,
     104,   106,   224,   234,   826,   826,   826,   826,   826,   826,
     826,   826,   826,   801,   826,   825,   825,   864,   863,   822,
     822,   801,   420,   420,   420,   853,   420,   424,   900,   833,
     262,   326,   835,   420,   424,   371,   829,    20,   420,   819,
     895,   825,    17,    17,   825,   420,   825,   137,   419,   854,
     825,   826,   826,   117,   117,   825,   420,   117,   825,   762,
     762,   762,   762,   884,   884,   825,   144,   777,   420,   420,
     420,   839,   419,   840,   898,   839,   895,   368,   420,   418,
     406,   747,   735,   419,   635,   420,   240,   776,   701,   420,
     503,   503,   420,   896,   604,   166,   414,   350,   493,   224,
      85,   224,   321,   324,   350,   476,   580,   900,   341,   341,
     139,   241,   324,   587,   588,   139,   241,   594,   595,   341,
     341,   420,   420,   420,   897,   895,   885,   885,   895,   895,
     546,   886,   132,   132,   283,   132,   151,   896,   886,   896,
     886,   886,   886,   886,   544,   420,   609,   176,   176,   609,
     609,   609,   609,   609,   609,   361,   485,   486,   709,   709,
     224,   270,   709,   709,    94,   163,   224,   570,   571,   572,
     894,   378,   379,   418,   418,   420,   823,   884,   701,    92,
     894,   895,    92,   895,    92,   895,    92,   895,    92,   886,
      92,   886,    92,   886,   419,   886,   826,    95,   153,    94,
     229,   180,   884,   652,   419,   801,    20,   283,   332,   381,
     132,   564,   420,   424,   800,   542,   729,    85,   216,   489,
     498,   162,   510,   491,   519,   898,    57,   333,   513,   378,
     696,   532,   895,   630,   888,   419,   647,   825,   825,   424,
     419,   648,   577,    97,   168,   303,   359,   684,   789,   419,
     885,   787,   239,   361,   792,   787,   179,   787,   799,   419,
     799,   898,   420,   405,   886,   420,   471,   888,   888,   471,
     471,   306,   419,   141,   620,   627,   137,   825,   420,   420,
     864,   137,   104,   106,   234,   419,   420,   384,   831,   853,
     376,   376,   420,   825,   216,   825,   424,   830,   803,   823,
     826,   826,   825,   854,   420,    17,    17,   825,   825,   117,
     825,   420,   884,   884,   884,   884,    36,   146,   778,   839,
     839,   839,   841,   898,   825,   895,   879,   662,   772,   897,
     420,   420,   652,   350,   676,   229,   229,   897,   898,   801,
     406,   896,   886,   894,   894,   801,   424,   894,   894,   424,
     896,   886,   885,   885,   603,   885,   122,   176,   609,   609,
     431,    99,   895,   895,   229,   503,   895,   895,    95,   153,
      94,   572,   571,   418,   139,   165,   139,   137,   569,   897,
     825,   224,   495,   652,   502,   361,   514,   543,   547,   361,
     752,   884,   886,   110,   565,   121,   895,    85,   420,   119,
     157,   499,   419,   511,    97,   109,   262,   886,    40,    48,
     195,   181,   533,   137,   419,   419,   631,   632,   828,   898,
     895,   644,   653,   654,   899,   652,   341,   885,   420,   825,
     419,   787,   792,   420,   799,   420,   471,   471,   471,   886,
     242,   471,   619,   826,   137,   419,   854,   419,   420,   424,
     420,   420,   365,   318,   420,   420,   420,   826,   826,   825,
     853,   825,   377,   836,   255,   842,   420,   823,   420,   775,
     277,   652,   514,   361,   472,   580,   419,   892,   662,   588,
     419,   419,   595,   378,   283,   378,   378,   132,   609,   481,
     895,   503,   623,    20,   664,   664,   884,   570,   420,   514,
     202,   505,   159,   420,   424,   888,   696,   419,   542,   294,
     320,   566,   269,   511,    63,    93,   160,    63,    93,   160,
     883,   512,   295,   295,    48,   242,    48,   895,   603,   631,
     825,   420,   424,   361,   603,   633,   633,   646,   420,   424,
     884,   420,   885,   420,   471,   826,   854,   420,   832,   853,
     216,   393,   837,   838,   898,    36,   765,   766,   839,   240,
     884,   514,   825,   854,   638,   275,   591,   661,   854,   854,
     602,   603,   602,   603,   885,   664,    23,   155,   132,   138,
     254,   314,   239,   506,   507,   508,   333,   547,   127,   590,
     892,   512,   420,   513,   242,   242,   420,   420,   378,   474,
     632,   603,   634,   634,   648,   653,   797,   420,   420,   420,
     420,   365,   424,    20,   853,   271,   295,   843,   502,   420,
     591,   420,   420,   378,   110,    97,   359,   239,   508,   239,
     507,   886,   603,    20,   419,   513,   676,   474,   633,   473,
     513,   635,   635,   652,   105,   838,   840,    30,    75,   351,
     844,   845,   844,   420,   505,   892,   603,   294,    39,   216,
     287,   309,   509,   509,   587,   399,   401,   402,   567,   568,
     894,   895,   898,   676,   513,   634,   797,    12,   169,   685,
     845,   294,   131,   260,   506,   638,   121,     6,    92,   229,
     420,   424,   797,   635,   225,   419,   680,   682,   687,   731,
     736,   742,   752,    17,   570,   269,   568,   681,   682,   683,
     753,   754,   845,   892,   420,   423,   419,   683,   567,   420
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[2];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 585 "gram.y"
    { parsetree = (yyvsp[(1) - (1)].list); ;}
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 590 "gram.y"
    { if ((yyvsp[(3) - (3)].node) != NULL)
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				  else
					(yyval.list) = (yyvsp[(1) - (3)].list);
				;}
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 596 "gram.y"
    { if ((yyvsp[(1) - (1)].node) != NULL)
						(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
					  else
						(yyval.list) = NIL;
					;}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 706 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 717 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 727 "gram.y"
    {;}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 728 "gram.y"
    {;}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 737 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 738 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 743 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[(2) - (2)].str)));
				;}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 748 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password", NULL);
				;}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 752 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 757 "gram.y"
    {
					(yyval.defelt) = makeDefElem("unencryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 762 "gram.y"
    {
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
				;}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 766 "gram.y"
    {
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
				;}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 770 "gram.y"
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(TRUE));
				;}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 774 "gram.y"
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(FALSE));
				;}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 778 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(TRUE));
				;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 782 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(FALSE));
				;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 786 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(TRUE));
				;}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 790 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(FALSE));
				;}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 794 "gram.y"
    {
					/* For backwards compatibility, synonym for SUPERUSER */
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
				;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 799 "gram.y"
    {
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
				;}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 803 "gram.y"
    {
					(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(TRUE));
				;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 807 "gram.y"
    {
					(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(FALSE));
				;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 811 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				;}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 815 "gram.y"
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 820 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 825 "gram.y"
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[(2) - (2)].ival)));
				;}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 829 "gram.y"
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 833 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 837 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 841 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 855 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 873 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 884 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (4)].str);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 901 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 913 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (4)].str);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 933 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 940 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 959 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 966 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[(5) - (5)].list);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 983 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 1001 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[(6) - (6)].list)));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 1011 "gram.y"
    { (yyval.ival) = +1; ;}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 1012 "gram.y"
    { (yyval.ival) = -1; ;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 1025 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 1032 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 1049 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[(3) - (7)].str) != NULL)
						n->schemaname = (yyvsp[(3) - (7)].str);
					else
						n->schemaname = (yyvsp[(5) - (7)].str);
					n->authid = (yyvsp[(5) - (7)].str);
					n->secLabel = (Node *)(yyvsp[(6) - (7)].defelt);
					n->schemaElts = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 1062 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[(3) - (5)].str);
					n->authid = NULL;
					n->secLabel = (Node *)(yyvsp[(4) - (5)].defelt);
					n->schemaElts = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 1074 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 1075 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 1079 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 1080 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 1108 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(2) - (2)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 1114 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 1120 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 1129 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 1137 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 1145 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 1152 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 1159 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 1167 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[(3) - (3)].node) != NULL)
						n->args = list_make1((yyvsp[(3) - (3)].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				;}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 1178 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[(2) - (2)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 1186 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[(5) - (5)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 1194 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 scanner_errposition((yylsp[(2) - (2)]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				;}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 1202 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 1210 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[(2) - (2)].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				;}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 1221 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 1229 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 1237 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				;}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 1244 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 1253 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 1255 "gram.y"
    {
					(yyval.str) = palloc(strlen((yyvsp[(1) - (3)].str)) + strlen((yyvsp[(3) - (3)].str)) + 2);
					sprintf((yyval.str), "%s.%s", (yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str));
				;}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 1261 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 1262 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 1266 "gram.y"
    { (yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)])); ;}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 1268 "gram.y"
    { (yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)])); ;}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 1270 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value), (yylsp[(1) - (1)])); ;}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 1273 "gram.y"
    { (yyval.str) = "read uncommitted"; ;}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 1274 "gram.y"
    { (yyval.str) = "read committed"; ;}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 1275 "gram.y"
    { (yyval.str) = "repeatable read"; ;}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 1276 "gram.y"
    { (yyval.str) = "serializable"; ;}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 1280 "gram.y"
    { (yyval.str) = "true"; ;}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 1281 "gram.y"
    { (yyval.str) = "false"; ;}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 1282 "gram.y"
    { (yyval.str) = "on"; ;}
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 1283 "gram.y"
    { (yyval.str) = "off"; ;}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 1296 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 1300 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 1304 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (3)].typnam);
					if ((yyvsp[(3) - (3)].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[(3) - (3)].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 scanner_errposition((yylsp[(3) - (3)]))));
					}
					t->typmods = (yyvsp[(3) - (3)].list);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (3)].str), (yylsp[(2) - (3)]), t);
				;}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 1319 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (6)].typnam);
					if ((yyvsp[(6) - (6)].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[(6) - (6)].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 scanner_errposition((yylsp[(6) - (6)]))));
						if (list_length((yyvsp[(6) - (6)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 scanner_errposition((yylsp[(1) - (6)]))));
						t->typmods = lappend((yyvsp[(6) - (6)].list), makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (6)].str), (yylsp[(5) - (6)]), t);
				;}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 1341 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value), (yylsp[(1) - (1)])); ;}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 1342 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 1343 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 1347 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 1348 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 1349 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 1353 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 1354 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 1359 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 1366 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 1373 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 1380 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 1387 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 1396 "gram.y"
    { (yyval.vsetstmt) = (yyvsp[(2) - (2)].vsetstmt); ;}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 1397 "gram.y"
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[(1) - (1)].node); ;}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 1403 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 1409 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 1415 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 1421 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 1427 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 1437 "gram.y"
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[(3) - (4)].list);
					n->deferred    = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 1446 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 1447 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 1451 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 1452 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 1461 "gram.y"
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 1476 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 1482 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 1488 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 1494 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 1512 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_TABLE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 1520 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_INDEX;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 1528 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_SEQUENCE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 1536 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_VIEW;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 1546 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 1547 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 1553 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(3) - (3)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 1561 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[(3) - (4)].str);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 1570 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 1578 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 1586 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeInteger((yyvsp[(6) - (6)].ival));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 1595 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeString((yyvsp[(6) - (6)].str));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 1604 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 1616 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[(3) - (7)].str);
					n->def = (Node *) (yyvsp[(6) - (7)].typnam);
					n->transform = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 1626 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 1634 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 1643 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddOids;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 1650 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 1657 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 1665 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 1673 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 1681 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 1689 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 1697 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 1704 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 1711 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 1719 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 1726 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 1733 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 1741 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 1749 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 1757 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 1765 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[(2) - (2)].range);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 1773 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[(3) - (3)].range);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 1781 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 1789 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 1797 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 1805 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 1814 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (3)].node); ;}
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 1815 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 1819 "gram.y"
    { (yyval.dbehavior) = DROP_CASCADE; ;}
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 1820 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; ;}
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 1821 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ ;}
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 1825 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 1826 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 1830 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 1833 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 1834 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 1838 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 1839 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 1845 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node));
				;}
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 1849 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				;}
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 1853 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[(1) - (5)].str), (yyvsp[(3) - (5)].str), (Node *) (yyvsp[(5) - (5)].node),
											 DEFELEM_UNSPEC);
				;}
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 1858 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str), NULL, DEFELEM_UNSPEC);
				;}
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 1873 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 1879 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 1903 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[(3) - (10)].range);
					n->query = NULL;
					n->attlist = (yyvsp[(4) - (10)].list);
					n->is_from = (yyvsp[(6) - (10)].boolean);
					n->filename = (yyvsp[(7) - (10)].str);

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[(2) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(2) - (10)].defelt));
					if ((yyvsp[(5) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(5) - (10)].defelt));
					if ((yyvsp[(8) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(8) - (10)].defelt));
					if ((yyvsp[(10) - (10)].list))
						n->options = list_concat(n->options, (yyvsp[(10) - (10)].list));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 1925 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[(2) - (6)].node);
					n->attlist = NIL;
					n->is_from = false;
					n->filename = (yyvsp[(4) - (6)].str);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 288:

/* Line 1455 of yacc.c  */
#line 1938 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 1939 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 1948 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 1949 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 1950 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 1956 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 294:

/* Line 1455 of yacc.c  */
#line 1957 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 295:

/* Line 1455 of yacc.c  */
#line 1963 "gram.y"
    {
					(yyval.defelt) = makeDefElem("binary", (Node *)makeInteger(TRUE));
				;}
    break;

  case 296:

/* Line 1455 of yacc.c  */
#line 1967 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				;}
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 1971 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 1975 "gram.y"
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 1979 "gram.y"
    {
					(yyval.defelt) = makeDefElem("csv", (Node *)makeInteger(TRUE));
				;}
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 1983 "gram.y"
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE));
				;}
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 1987 "gram.y"
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 1991 "gram.y"
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 1995 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 1999 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_notnull", (Node *)(yyvsp[(4) - (4)].list));
				;}
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 2008 "gram.y"
    {
					(yyval.defelt) = makeDefElem("binary", (Node *)makeInteger(TRUE));
				;}
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 2011 "gram.y"
    { (yyval.defelt) = NULL; ;}
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 2016 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				;}
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 2019 "gram.y"
    { (yyval.defelt) = NULL; ;}
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 2025 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 2028 "gram.y"
    { (yyval.defelt) = NULL; ;}
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 2032 "gram.y"
    {;}
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 2033 "gram.y"
    {;}
    break;

  case 313:

/* Line 1455 of yacc.c  */
#line 2046 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (12)].range)->istemp = (yyvsp[(2) - (12)].boolean);
					n->relation = (yyvsp[(4) - (12)].range);
					n->tableElts = (yyvsp[(6) - (12)].list);
					n->inhRelations = (yyvsp[(8) - (12)].list);
					n->constraints = NIL;
					n->options = (yyvsp[(9) - (12)].list);
					n->oncommit = (yyvsp[(10) - (12)].oncommit);
					n->tablespacename = (yyvsp[(11) - (12)].str);
					n->secLabel = (Node *) (yyvsp[(12) - (12)].defelt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 2061 "gram.y"
    {
					/* SQL99 CREATE TABLE OF <UDT> (cols) seems to be satisfied
					 * by our inheritance capabilities. Let's try it...
					 */
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (13)].range)->istemp = (yyvsp[(2) - (13)].boolean);
					n->relation = (yyvsp[(4) - (13)].range);
					n->tableElts = (yyvsp[(8) - (13)].list);
					n->inhRelations = list_make1((yyvsp[(6) - (13)].range));
					n->constraints = NIL;
					n->options = (yyvsp[(10) - (13)].list);
					n->oncommit = (yyvsp[(11) - (13)].oncommit);
					n->tablespacename = (yyvsp[(12) - (13)].str);
					n->secLabel = (Node *) (yyvsp[(13) - (13)].defelt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 2086 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 316:

/* Line 1455 of yacc.c  */
#line 2087 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 317:

/* Line 1455 of yacc.c  */
#line 2088 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 318:

/* Line 1455 of yacc.c  */
#line 2089 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 319:

/* Line 1455 of yacc.c  */
#line 2090 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 320:

/* Line 1455 of yacc.c  */
#line 2091 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 321:

/* Line 1455 of yacc.c  */
#line 2092 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 2096 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 323:

/* Line 1455 of yacc.c  */
#line 2097 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 2102 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 325:

/* Line 1455 of yacc.c  */
#line 2106 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 2112 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 2113 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 2114 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 2118 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (4)].str);
					n->typename = (yyvsp[(2) - (4)].typnam);
					n->constraints = (yyvsp[(3) - (4)].list);
					n->is_local = true;
					n->secLabel = (Node *) (yyvsp[(4) - (4)].defelt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 2130 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 331:

/* Line 1455 of yacc.c  */
#line 2131 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 332:

/* Line 1455 of yacc.c  */
#line 2136 "gram.y"
    {
					switch (nodeTag((yyvsp[(3) - (3)].node)))
					{
						case T_Constraint:
							{
								Constraint *n = (Constraint *)(yyvsp[(3) - (3)].node);
								n->name = (yyvsp[(2) - (3)].str);
							}
							break;
						case T_FkConstraint:
							{
								FkConstraint *n = (FkConstraint *)(yyvsp[(3) - (3)].node);
								n->constr_name = (yyvsp[(2) - (3)].str);
							}
							break;
						default:
							break;
					}
					(yyval.node) = (yyvsp[(3) - (3)].node);
				;}
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 2156 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 2157 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 2177 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->name = NULL;
					n->raw_expr = NULL;
					n->cooked_expr = NULL;
					n->keys = NULL;
					n->indexspace = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 336:

/* Line 1455 of yacc.c  */
#line 2188 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->name = NULL;
					n->raw_expr = NULL;
					n->cooked_expr = NULL;
					n->keys = NULL;
					n->indexspace = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 2199 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->name = NULL;
					n->raw_expr = NULL;
					n->cooked_expr = NULL;
					n->keys = NULL;
					n->options = (yyvsp[(2) - (3)].list);
					n->indexspace = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 338:

/* Line 1455 of yacc.c  */
#line 2211 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->name = NULL;
					n->raw_expr = NULL;
					n->cooked_expr = NULL;
					n->keys = NULL;
					n->options = (yyvsp[(3) - (4)].list);
					n->indexspace = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 2223 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->name = NULL;
					n->raw_expr = (yyvsp[(3) - (4)].node);
					n->cooked_expr = NULL;
					n->keys = NULL;
					n->indexspace = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 2234 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->name = NULL;
					n->raw_expr = (yyvsp[(2) - (2)].node);
					n->cooked_expr = NULL;
					n->keys = NULL;
					n->indexspace = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 2245 "gram.y"
    {
					FkConstraint *n = makeNode(FkConstraint);
					n->constr_name		= NULL;
					n->pktable			= (yyvsp[(2) - (5)].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[(3) - (5)].list);
					n->fk_matchtype		= (yyvsp[(4) - (5)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(5) - (5)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(5) - (5)].ival) & 0xFF);
					n->deferrable		= FALSE;
					n->initdeferred		= FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 342:

/* Line 1455 of yacc.c  */
#line 2274 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 2280 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 344:

/* Line 1455 of yacc.c  */
#line 2286 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 345:

/* Line 1455 of yacc.c  */
#line 2292 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 346:

/* Line 1455 of yacc.c  */
#line 2310 "gram.y"
    {
					InhRelation *n = makeNode(InhRelation);
					n->relation = (yyvsp[(2) - (3)].range);
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 2319 "gram.y"
    { (yyval.list) = lappend_int((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].ival)); ;}
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 2320 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 349:

/* Line 1455 of yacc.c  */
#line 2324 "gram.y"
    { (yyval.ival) = 	CREATE_TABLE_LIKE_INCLUDING_DEFAULTS; ;}
    break;

  case 350:

/* Line 1455 of yacc.c  */
#line 2325 "gram.y"
    { (yyval.ival) = 	CREATE_TABLE_LIKE_EXCLUDING_DEFAULTS; ;}
    break;

  case 351:

/* Line 1455 of yacc.c  */
#line 2326 "gram.y"
    { (yyval.ival) = 	CREATE_TABLE_LIKE_INCLUDING_CONSTRAINTS; ;}
    break;

  case 352:

/* Line 1455 of yacc.c  */
#line 2327 "gram.y"
    { (yyval.ival) = 	CREATE_TABLE_LIKE_EXCLUDING_CONSTRAINTS; ;}
    break;

  case 353:

/* Line 1455 of yacc.c  */
#line 2328 "gram.y"
    { (yyval.ival) = 	CREATE_TABLE_LIKE_INCLUDING_INDEXES; ;}
    break;

  case 354:

/* Line 1455 of yacc.c  */
#line 2329 "gram.y"
    { (yyval.ival) = 	CREATE_TABLE_LIKE_EXCLUDING_INDEXES; ;}
    break;

  case 355:

/* Line 1455 of yacc.c  */
#line 2339 "gram.y"
    {
					switch (nodeTag((yyvsp[(3) - (3)].node)))
					{
						case T_Constraint:
							{
								Constraint *n = (Constraint *)(yyvsp[(3) - (3)].node);
								n->name = (yyvsp[(2) - (3)].str);
							}
							break;
						case T_FkConstraint:
							{
								FkConstraint *n = (FkConstraint *)(yyvsp[(3) - (3)].node);
								n->constr_name = (yyvsp[(2) - (3)].str);
							}
							break;
						default:
							break;
					}
					(yyval.node) = (yyvsp[(3) - (3)].node);
				;}
    break;

  case 356:

/* Line 1455 of yacc.c  */
#line 2359 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 357:

/* Line 1455 of yacc.c  */
#line 2364 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->name = NULL;
					n->raw_expr = (yyvsp[(3) - (4)].node);
					n->cooked_expr = NULL;
					n->indexspace = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 358:

/* Line 1455 of yacc.c  */
#line 2374 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->name = NULL;
					n->raw_expr = NULL;
					n->cooked_expr = NULL;
					n->keys = (yyvsp[(3) - (6)].list);
					n->options = (yyvsp[(5) - (6)].list);
					n->indexspace = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 359:

/* Line 1455 of yacc.c  */
#line 2386 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->name = NULL;
					n->raw_expr = NULL;
					n->cooked_expr = NULL;
					n->keys = (yyvsp[(4) - (7)].list);
					n->options = (yyvsp[(6) - (7)].list);
					n->indexspace = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 360:

/* Line 1455 of yacc.c  */
#line 2399 "gram.y"
    {
					FkConstraint *n = makeNode(FkConstraint);
					n->constr_name		= NULL;
					n->pktable			= (yyvsp[(7) - (11)].range);
					n->fk_attrs			= (yyvsp[(4) - (11)].list);
					n->pk_attrs			= (yyvsp[(8) - (11)].list);
					n->fk_matchtype		= (yyvsp[(9) - (11)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(10) - (11)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(10) - (11)].ival) & 0xFF);
					n->deferrable		= ((yyvsp[(11) - (11)].ival) & 1) != 0;
					n->initdeferred		= ((yyvsp[(11) - (11)].ival) & 2) != 0;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 361:

/* Line 1455 of yacc.c  */
#line 2415 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 362:

/* Line 1455 of yacc.c  */
#line 2416 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 363:

/* Line 1455 of yacc.c  */
#line 2420 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 364:

/* Line 1455 of yacc.c  */
#line 2421 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 365:

/* Line 1455 of yacc.c  */
#line 2425 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str));
				;}
    break;

  case 366:

/* Line 1455 of yacc.c  */
#line 2431 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			;}
    break;

  case 367:

/* Line 1455 of yacc.c  */
#line 2435 "gram.y"
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 scanner_errposition((yylsp[(1) - (2)]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			;}
    break;

  case 368:

/* Line 1455 of yacc.c  */
#line 2443 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_UNSPECIFIED;
			;}
    break;

  case 369:

/* Line 1455 of yacc.c  */
#line 2447 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_UNSPECIFIED;
			;}
    break;

  case 370:

/* Line 1455 of yacc.c  */
#line 2460 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (1)].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); ;}
    break;

  case 371:

/* Line 1455 of yacc.c  */
#line 2462 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[(1) - (1)].ival) & 0xFF); ;}
    break;

  case 372:

/* Line 1455 of yacc.c  */
#line 2464 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (2)].ival) << 8) | ((yyvsp[(2) - (2)].ival) & 0xFF); ;}
    break;

  case 373:

/* Line 1455 of yacc.c  */
#line 2466 "gram.y"
    { (yyval.ival) = ((yyvsp[(2) - (2)].ival) << 8) | ((yyvsp[(1) - (2)].ival) & 0xFF); ;}
    break;

  case 374:

/* Line 1455 of yacc.c  */
#line 2468 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); ;}
    break;

  case 375:

/* Line 1455 of yacc.c  */
#line 2471 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); ;}
    break;

  case 376:

/* Line 1455 of yacc.c  */
#line 2474 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); ;}
    break;

  case 377:

/* Line 1455 of yacc.c  */
#line 2478 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; ;}
    break;

  case 378:

/* Line 1455 of yacc.c  */
#line 2479 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; ;}
    break;

  case 379:

/* Line 1455 of yacc.c  */
#line 2480 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; ;}
    break;

  case 380:

/* Line 1455 of yacc.c  */
#line 2481 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; ;}
    break;

  case 381:

/* Line 1455 of yacc.c  */
#line 2482 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; ;}
    break;

  case 382:

/* Line 1455 of yacc.c  */
#line 2485 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 383:

/* Line 1455 of yacc.c  */
#line 2486 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 384:

/* Line 1455 of yacc.c  */
#line 2491 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 385:

/* Line 1455 of yacc.c  */
#line 2492 "gram.y"
    { (yyval.list) = list_make1(defWithOids(true)); ;}
    break;

  case 386:

/* Line 1455 of yacc.c  */
#line 2493 "gram.y"
    { (yyval.list) = list_make1(defWithOids(false)); ;}
    break;

  case 387:

/* Line 1455 of yacc.c  */
#line 2494 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 388:

/* Line 1455 of yacc.c  */
#line 2497 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DROP; ;}
    break;

  case 389:

/* Line 1455 of yacc.c  */
#line 2498 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; ;}
    break;

  case 390:

/* Line 1455 of yacc.c  */
#line 2499 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; ;}
    break;

  case 391:

/* Line 1455 of yacc.c  */
#line 2500 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_NOOP; ;}
    break;

  case 392:

/* Line 1455 of yacc.c  */
#line 2503 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 393:

/* Line 1455 of yacc.c  */
#line 2504 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 394:

/* Line 1455 of yacc.c  */
#line 2507 "gram.y"
    { (yyval.str) = (yyvsp[(4) - (4)].str); ;}
    break;

  case 395:

/* Line 1455 of yacc.c  */
#line 2508 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 396:

/* Line 1455 of yacc.c  */
#line 2519 "gram.y"
    {
					/*
					 * When the SelectStmt is a set-operation tree, we must
					 * stuff the INTO information into the leftmost component
					 * Select, because that's where analyze.c will expect
					 * to find it.	Similarly, the output column names must
					 * be attached to that Select's target list.
					 */
					SelectStmt *n = findLeftmostSelect((SelectStmt *) (yyvsp[(6) - (7)].node));
					if (n->intoClause != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("CREATE TABLE AS cannot specify INTO"),
								 scanner_errposition(exprLocation((Node *) n->intoClause))));
					(yyvsp[(4) - (7)].into)->rel->istemp = (yyvsp[(2) - (7)].boolean);
					n->intoClause = (yyvsp[(4) - (7)].into);
					/* Implement WITH NO DATA by forcing top-level LIMIT 0 */
					if (!(yyvsp[(7) - (7)].boolean))
						((SelectStmt *) (yyvsp[(6) - (7)].node))->limitCount = makeIntConst(0, -1);
					(yyval.node) = (yyvsp[(6) - (7)].node);
				;}
    break;

  case 397:

/* Line 1455 of yacc.c  */
#line 2544 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(1) - (5)].range);
					(yyval.into)->colNames = (yyvsp[(2) - (5)].list);
					(yyval.into)->options = (yyvsp[(3) - (5)].list);
					(yyval.into)->onCommit = (yyvsp[(4) - (5)].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[(5) - (5)].str);
				;}
    break;

  case 398:

/* Line 1455 of yacc.c  */
#line 2555 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 399:

/* Line 1455 of yacc.c  */
#line 2556 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 400:

/* Line 1455 of yacc.c  */
#line 2560 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 401:

/* Line 1455 of yacc.c  */
#line 2561 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 402:

/* Line 1455 of yacc.c  */
#line 2566 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (1)].str);
					n->typename = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->constraints = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 403:

/* Line 1455 of yacc.c  */
#line 2581 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 404:

/* Line 1455 of yacc.c  */
#line 2582 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 405:

/* Line 1455 of yacc.c  */
#line 2583 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 406:

/* Line 1455 of yacc.c  */
#line 2597 "gram.y"
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[(4) - (6)].range)->istemp = (yyvsp[(2) - (6)].boolean);
					n->sequence = (yyvsp[(4) - (6)].range);
					n->options = (yyvsp[(5) - (6)].list);
					n->secLabel = (Node *)(yyvsp[(6) - (6)].defelt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 407:

/* Line 1455 of yacc.c  */
#line 2609 "gram.y"
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[(3) - (4)].range);
					n->options = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 408:

/* Line 1455 of yacc.c  */
#line 2617 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 409:

/* Line 1455 of yacc.c  */
#line 2618 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 410:

/* Line 1455 of yacc.c  */
#line 2621 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 411:

/* Line 1455 of yacc.c  */
#line 2622 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 412:

/* Line 1455 of yacc.c  */
#line 2626 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 413:

/* Line 1455 of yacc.c  */
#line 2630 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(TRUE));
				;}
    break;

  case 414:

/* Line 1455 of yacc.c  */
#line 2634 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(FALSE));
				;}
    break;

  case 415:

/* Line 1455 of yacc.c  */
#line 2638 "gram.y"
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[(3) - (3)].value));
				;}
    break;

  case 416:

/* Line 1455 of yacc.c  */
#line 2642 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 417:

/* Line 1455 of yacc.c  */
#line 2646 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 418:

/* Line 1455 of yacc.c  */
#line 2650 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL);
				;}
    break;

  case 419:

/* Line 1455 of yacc.c  */
#line 2654 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL);
				;}
    break;

  case 420:

/* Line 1455 of yacc.c  */
#line 2658 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 421:

/* Line 1455 of yacc.c  */
#line 2662 "gram.y"
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[(3) - (3)].value));
				;}
    break;

  case 422:

/* Line 1455 of yacc.c  */
#line 2666 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", NULL);
				;}
    break;

  case 423:

/* Line 1455 of yacc.c  */
#line 2670 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[(3) - (3)].value));
				;}
    break;

  case 424:

/* Line 1455 of yacc.c  */
#line 2675 "gram.y"
    {;}
    break;

  case 425:

/* Line 1455 of yacc.c  */
#line 2676 "gram.y"
    {;}
    break;

  case 426:

/* Line 1455 of yacc.c  */
#line 2680 "gram.y"
    { (yyval.value) = makeFloat((yyvsp[(1) - (1)].str)); ;}
    break;

  case 427:

/* Line 1455 of yacc.c  */
#line 2682 "gram.y"
    {
					(yyval.value) = makeFloat((yyvsp[(2) - (2)].str));
					doNegateFloat((yyval.value));
				;}
    break;

  case 428:

/* Line 1455 of yacc.c  */
#line 2686 "gram.y"
    { (yyval.value) = makeInteger((yyvsp[(1) - (1)].ival)); ;}
    break;

  case 429:

/* Line 1455 of yacc.c  */
#line 2699 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->plname = (yyvsp[(5) - (5)].str);
				/* parameters are all to be supplied by system */
				n->plhandler = NIL;
				n->plvalidator = NIL;
				n->pltrusted = false;
				(yyval.node) = (Node *)n;
			;}
    break;

  case 430:

/* Line 1455 of yacc.c  */
#line 2710 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->plname = (yyvsp[(5) - (9)].str);
				n->plhandler = (yyvsp[(7) - (9)].list);
				n->plvalidator = (yyvsp[(8) - (9)].list);
				n->pltrusted = (yyvsp[(2) - (9)].boolean);
				/* LANCOMPILER is now ignored entirely */
				(yyval.node) = (Node *)n;
			;}
    break;

  case 431:

/* Line 1455 of yacc.c  */
#line 2722 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 432:

/* Line 1455 of yacc.c  */
#line 2723 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 433:

/* Line 1455 of yacc.c  */
#line 2731 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 434:

/* Line 1455 of yacc.c  */
#line 2732 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); ;}
    break;

  case 435:

/* Line 1455 of yacc.c  */
#line 2736 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 436:

/* Line 1455 of yacc.c  */
#line 2737 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 437:

/* Line 1455 of yacc.c  */
#line 2741 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 438:

/* Line 1455 of yacc.c  */
#line 2742 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 439:

/* Line 1455 of yacc.c  */
#line 2746 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 440:

/* Line 1455 of yacc.c  */
#line 2747 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 441:

/* Line 1455 of yacc.c  */
#line 2752 "gram.y"
    {
					DropPLangStmt *n = makeNode(DropPLangStmt);
					n->plname = (yyvsp[(4) - (5)].str);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 442:

/* Line 1455 of yacc.c  */
#line 2760 "gram.y"
    {
					DropPLangStmt *n = makeNode(DropPLangStmt);
					n->plname = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 443:

/* Line 1455 of yacc.c  */
#line 2770 "gram.y"
    {;}
    break;

  case 444:

/* Line 1455 of yacc.c  */
#line 2771 "gram.y"
    {;}
    break;

  case 445:

/* Line 1455 of yacc.c  */
#line 2782 "gram.y"
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (6)].str);
					n->owner = (yyvsp[(4) - (6)].str);
					n->location = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 446:

/* Line 1455 of yacc.c  */
#line 2791 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 447:

/* Line 1455 of yacc.c  */
#line 2792 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 448:

/* Line 1455 of yacc.c  */
#line 2806 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (3)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 449:

/* Line 1455 of yacc.c  */
#line 2813 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(5) - (5)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 450:

/* Line 1455 of yacc.c  */
#line 2829 "gram.y"
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[(5) - (7)].str);
					n->validator = (yyvsp[(6) - (7)].list);
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 451:

/* Line 1455 of yacc.c  */
#line 2846 "gram.y"
    {
					DropFdwStmt *n = makeNode(DropFdwStmt);
					n->fdwname = (yyvsp[(5) - (6)].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 452:

/* Line 1455 of yacc.c  */
#line 2854 "gram.y"
    {
					DropFdwStmt *n = makeNode(DropFdwStmt);
					n->fdwname = (yyvsp[(7) - (8)].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 453:

/* Line 1455 of yacc.c  */
#line 2871 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (7)].str);
					n->validator = (yyvsp[(6) - (7)].list);
					n->change_validator = true;
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 454:

/* Line 1455 of yacc.c  */
#line 2880 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (6)].str);
					n->validator = (yyvsp[(6) - (6)].list);
					n->change_validator = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 455:

/* Line 1455 of yacc.c  */
#line 2888 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (6)].str);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 456:

/* Line 1455 of yacc.c  */
#line 2898 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 457:

/* Line 1455 of yacc.c  */
#line 2899 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 458:

/* Line 1455 of yacc.c  */
#line 2904 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				;}
    break;

  case 459:

/* Line 1455 of yacc.c  */
#line 2908 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				;}
    break;

  case 460:

/* Line 1455 of yacc.c  */
#line 2915 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 461:

/* Line 1455 of yacc.c  */
#line 2920 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				;}
    break;

  case 462:

/* Line 1455 of yacc.c  */
#line 2924 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				;}
    break;

  case 463:

/* Line 1455 of yacc.c  */
#line 2931 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				;}
    break;

  case 464:

/* Line 1455 of yacc.c  */
#line 2935 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(2) - (2)].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				;}
    break;

  case 465:

/* Line 1455 of yacc.c  */
#line 2940 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(2) - (2)].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				;}
    break;

  case 466:

/* Line 1455 of yacc.c  */
#line 2945 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[(2) - (2)].str), NULL, DEFELEM_DROP);
				;}
    break;

  case 467:

/* Line 1455 of yacc.c  */
#line 2952 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				;}
    break;

  case 468:

/* Line 1455 of yacc.c  */
#line 2958 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 469:

/* Line 1455 of yacc.c  */
#line 2963 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 470:

/* Line 1455 of yacc.c  */
#line 2975 "gram.y"
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[(3) - (10)].str);
					n->servertype = (yyvsp[(4) - (10)].str);
					n->version = (yyvsp[(5) - (10)].str);
					n->fdwname = (yyvsp[(9) - (10)].str);
					n->options = (yyvsp[(10) - (10)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 471:

/* Line 1455 of yacc.c  */
#line 2987 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 472:

/* Line 1455 of yacc.c  */
#line 2988 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 473:

/* Line 1455 of yacc.c  */
#line 2993 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 474:

/* Line 1455 of yacc.c  */
#line 2994 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 475:

/* Line 1455 of yacc.c  */
#line 2998 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 476:

/* Line 1455 of yacc.c  */
#line 2999 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 477:

/* Line 1455 of yacc.c  */
#line 3010 "gram.y"
    {
					DropForeignServerStmt *n = makeNode(DropForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 478:

/* Line 1455 of yacc.c  */
#line 3018 "gram.y"
    {
					DropForeignServerStmt *n = makeNode(DropForeignServerStmt);
					n->servername = (yyvsp[(5) - (6)].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 479:

/* Line 1455 of yacc.c  */
#line 3035 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (5)].str);
					n->version = (yyvsp[(4) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 480:

/* Line 1455 of yacc.c  */
#line 3044 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->version = (yyvsp[(4) - (4)].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 481:

/* Line 1455 of yacc.c  */
#line 3052 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->options = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 482:

/* Line 1455 of yacc.c  */
#line 3068 "gram.y"
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->username = (yyvsp[(5) - (8)].str);
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 483:

/* Line 1455 of yacc.c  */
#line 3079 "gram.y"
    { (yyval.str) = "current_user"; ;}
    break;

  case 484:

/* Line 1455 of yacc.c  */
#line 3080 "gram.y"
    { (yyval.str) = "current_user"; ;}
    break;

  case 485:

/* Line 1455 of yacc.c  */
#line 3081 "gram.y"
    { (yyval.str) = (strcmp((yyvsp[(1) - (1)].str), "public") == 0) ? NULL : (yyvsp[(1) - (1)].str); ;}
    break;

  case 486:

/* Line 1455 of yacc.c  */
#line 3092 "gram.y"
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[(5) - (7)].str);
					n->servername = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 487:

/* Line 1455 of yacc.c  */
#line 3100 "gram.y"
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[(7) - (9)].str);
					n->servername = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 488:

/* Line 1455 of yacc.c  */
#line 3117 "gram.y"
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->username = (yyvsp[(5) - (8)].str);
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 489:

/* Line 1455 of yacc.c  */
#line 3138 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (14)].str);
					n->relation = (yyvsp[(7) - (14)].range);
					n->funcname = (yyvsp[(11) - (14)].list);
					n->args = (yyvsp[(13) - (14)].list);
					n->before = (yyvsp[(4) - (14)].boolean);
					n->row = (yyvsp[(8) - (14)].boolean);
					n->events = (yyvsp[(5) - (14)].ival);
					n->isconstraint  = FALSE;
					n->deferrable	 = FALSE;
					n->initdeferred  = FALSE;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 490:

/* Line 1455 of yacc.c  */
#line 3158 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(4) - (19)].str);
					n->relation = (yyvsp[(8) - (19)].range);
					n->funcname = (yyvsp[(16) - (19)].list);
					n->args = (yyvsp[(18) - (19)].list);
					n->before = FALSE;
					n->row = TRUE;
					n->events = (yyvsp[(6) - (19)].ival);
					n->isconstraint  = TRUE;
					n->deferrable = ((yyvsp[(10) - (19)].ival) & 1) != 0;
					n->initdeferred = ((yyvsp[(10) - (19)].ival) & 2) != 0;
					n->constrrel = (yyvsp[(9) - (19)].range);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 491:

/* Line 1455 of yacc.c  */
#line 3176 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 492:

/* Line 1455 of yacc.c  */
#line 3177 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 493:

/* Line 1455 of yacc.c  */
#line 3182 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 494:

/* Line 1455 of yacc.c  */
#line 3184 "gram.y"
    {
					if ((yyvsp[(1) - (3)].ival) & (yyvsp[(3) - (3)].ival))
						yyerror("duplicate trigger events specified");
					(yyval.ival) = (yyvsp[(1) - (3)].ival) | (yyvsp[(3) - (3)].ival);
				;}
    break;

  case 495:

/* Line 1455 of yacc.c  */
#line 3192 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_INSERT; ;}
    break;

  case 496:

/* Line 1455 of yacc.c  */
#line 3193 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_DELETE; ;}
    break;

  case 497:

/* Line 1455 of yacc.c  */
#line 3194 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_UPDATE; ;}
    break;

  case 498:

/* Line 1455 of yacc.c  */
#line 3195 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_TRUNCATE; ;}
    break;

  case 499:

/* Line 1455 of yacc.c  */
#line 3200 "gram.y"
    {
					(yyval.boolean) = (yyvsp[(3) - (3)].boolean);
				;}
    break;

  case 500:

/* Line 1455 of yacc.c  */
#line 3204 "gram.y"
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = FALSE;
				;}
    break;

  case 501:

/* Line 1455 of yacc.c  */
#line 3214 "gram.y"
    {;}
    break;

  case 502:

/* Line 1455 of yacc.c  */
#line 3215 "gram.y"
    {;}
    break;

  case 503:

/* Line 1455 of yacc.c  */
#line 3219 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 504:

/* Line 1455 of yacc.c  */
#line 3220 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 505:

/* Line 1455 of yacc.c  */
#line 3224 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].value)); ;}
    break;

  case 506:

/* Line 1455 of yacc.c  */
#line 3225 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].value)); ;}
    break;

  case 507:

/* Line 1455 of yacc.c  */
#line 3226 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 508:

/* Line 1455 of yacc.c  */
#line 3231 "gram.y"
    {
					char buf[64];
					snprintf(buf, sizeof(buf), "%d", (yyvsp[(1) - (1)].ival));
					(yyval.value) = makeString(pstrdup(buf));
				;}
    break;

  case 509:

/* Line 1455 of yacc.c  */
#line 3236 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 510:

/* Line 1455 of yacc.c  */
#line 3237 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 511:

/* Line 1455 of yacc.c  */
#line 3238 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 512:

/* Line 1455 of yacc.c  */
#line 3239 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 513:

/* Line 1455 of yacc.c  */
#line 3240 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 514:

/* Line 1455 of yacc.c  */
#line 3244 "gram.y"
    { (yyval.range) = (yyvsp[(2) - (2)].range); ;}
    break;

  case 515:

/* Line 1455 of yacc.c  */
#line 3245 "gram.y"
    { (yyval.range) = NULL; ;}
    break;

  case 516:

/* Line 1455 of yacc.c  */
#line 3250 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 517:

/* Line 1455 of yacc.c  */
#line 3252 "gram.y"
    {
					if ((yyvsp[(1) - (2)].ival) == 0 && (yyvsp[(2) - (2)].ival) != 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 scanner_errposition((yylsp[(1) - (2)]))));
					(yyval.ival) = (yyvsp[(1) - (2)].ival) | (yyvsp[(2) - (2)].ival);
				;}
    break;

  case 518:

/* Line 1455 of yacc.c  */
#line 3261 "gram.y"
    {
					if ((yyvsp[(1) - (1)].ival) != 0)
						(yyval.ival) = 3;
					else
						(yyval.ival) = 0;
				;}
    break;

  case 519:

/* Line 1455 of yacc.c  */
#line 3268 "gram.y"
    {
					if ((yyvsp[(2) - (2)].ival) == 0 && (yyvsp[(1) - (2)].ival) != 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 scanner_errposition((yylsp[(1) - (2)]))));
					(yyval.ival) = (yyvsp[(1) - (2)].ival) | (yyvsp[(2) - (2)].ival);
				;}
    break;

  case 520:

/* Line 1455 of yacc.c  */
#line 3277 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 521:

/* Line 1455 of yacc.c  */
#line 3281 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 522:

/* Line 1455 of yacc.c  */
#line 3282 "gram.y"
    { (yyval.ival) = 1; ;}
    break;

  case 523:

/* Line 1455 of yacc.c  */
#line 3286 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 524:

/* Line 1455 of yacc.c  */
#line 3287 "gram.y"
    { (yyval.ival) = 2; ;}
    break;

  case 525:

/* Line 1455 of yacc.c  */
#line 3293 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->property = (yyvsp[(3) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->removeType = OBJECT_TRIGGER;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 526:

/* Line 1455 of yacc.c  */
#line 3303 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(7) - (8)].range);
					n->property = (yyvsp[(5) - (8)].str);
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->removeType = OBJECT_TRIGGER;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 527:

/* Line 1455 of yacc.c  */
#line 3326 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (8)].str);
					n->args = list_make1((yyvsp[(6) - (8)].node));
					n->isconstraint  = TRUE;
					n->deferrable = ((yyvsp[(8) - (8)].ival) & 1) != 0;
					n->initdeferred = ((yyvsp[(8) - (8)].ival) & 2) != 0;

					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = (Node *)n;
				;}
    break;

  case 528:

/* Line 1455 of yacc.c  */
#line 3344 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = NULL;
					n->property = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->removeType = OBJECT_TRIGGER; /* XXX */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("DROP ASSERTION is not yet implemented")));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 529:

/* Line 1455 of yacc.c  */
#line 3367 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->definition = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 530:

/* Line 1455 of yacc.c  */
#line 3377 "gram.y"
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 531:

/* Line 1455 of yacc.c  */
#line 3388 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 532:

/* Line 1455 of yacc.c  */
#line 3398 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 533:

/* Line 1455 of yacc.c  */
#line 3408 "gram.y"
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (3)].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 534:

/* Line 1455 of yacc.c  */
#line 3419 "gram.y"
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);
					RangeVar *r = makeNode(RangeVar);

					/* can't use qualified_name, sigh */
					switch (list_length((yyvsp[(3) - (7)].list)))
					{
						case 1:
							r->catalogname = NULL;
							r->schemaname = NULL;
							r->relname = strVal(linitial((yyvsp[(3) - (7)].list)));
							break;
						case 2:
							r->catalogname = NULL;
							r->schemaname = strVal(linitial((yyvsp[(3) - (7)].list)));
							r->relname = strVal(lsecond((yyvsp[(3) - (7)].list)));
							break;
						case 3:
							r->catalogname = strVal(linitial((yyvsp[(3) - (7)].list)));
							r->schemaname = strVal(lsecond((yyvsp[(3) - (7)].list)));
							r->relname = strVal(lthird((yyvsp[(3) - (7)].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString((yyvsp[(3) - (7)].list))),
											scanner_errposition((yylsp[(3) - (7)]))));
							break;
					}
					r->location = (yylsp[(3) - (7)]);
					n->typevar = r;
					n->coldeflist = (yyvsp[(6) - (7)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 535:

/* Line 1455 of yacc.c  */
#line 3455 "gram.y"
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typename = (yyvsp[(3) - (8)].list);
					n->vals = (yyvsp[(7) - (8)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 536:

/* Line 1455 of yacc.c  */
#line 3462 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 537:

/* Line 1455 of yacc.c  */
#line 3471 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 538:

/* Line 1455 of yacc.c  */
#line 3480 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 539:

/* Line 1455 of yacc.c  */
#line 3489 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 540:

/* Line 1455 of yacc.c  */
#line 3499 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 541:

/* Line 1455 of yacc.c  */
#line 3502 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 542:

/* Line 1455 of yacc.c  */
#line 3503 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 543:

/* Line 1455 of yacc.c  */
#line 3507 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node));
				;}
    break;

  case 544:

/* Line 1455 of yacc.c  */
#line 3511 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				;}
    break;

  case 545:

/* Line 1455 of yacc.c  */
#line 3517 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].typnam); ;}
    break;

  case 546:

/* Line 1455 of yacc.c  */
#line 3518 "gram.y"
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[(1) - (1)].keyword))); ;}
    break;

  case 547:

/* Line 1455 of yacc.c  */
#line 3519 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].list); ;}
    break;

  case 548:

/* Line 1455 of yacc.c  */
#line 3520 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].value); ;}
    break;

  case 549:

/* Line 1455 of yacc.c  */
#line 3521 "gram.y"
    { (yyval.node) = (Node *)makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 550:

/* Line 1455 of yacc.c  */
#line 3524 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 551:

/* Line 1455 of yacc.c  */
#line 3525 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 552:

/* Line 1455 of yacc.c  */
#line 3528 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 553:

/* Line 1455 of yacc.c  */
#line 3531 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 554:

/* Line 1455 of yacc.c  */
#line 3532 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 555:

/* Line 1455 of yacc.c  */
#line 3541 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *)(yyvsp[(3) - (3)].node));
				;}
    break;

  case 556:

/* Line 1455 of yacc.c  */
#line 3547 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 557:

/* Line 1455 of yacc.c  */
#line 3549 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); ;}
    break;

  case 558:

/* Line 1455 of yacc.c  */
#line 3567 "gram.y"
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[(4) - (13)].list);
					n->isDefault = (yyvsp[(5) - (13)].boolean);
					n->datatype = (yyvsp[(8) - (13)].typnam);
					n->amname = (yyvsp[(10) - (13)].str);
					n->opfamilyname = (yyvsp[(11) - (13)].list);
					n->items = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 559:

/* Line 1455 of yacc.c  */
#line 3580 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 560:

/* Line 1455 of yacc.c  */
#line 3581 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 561:

/* Line 1455 of yacc.c  */
#line 3586 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->number = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 562:

/* Line 1455 of yacc.c  */
#line 3595 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->number = (yyvsp[(2) - (5)].ival);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 563:

/* Line 1455 of yacc.c  */
#line 3604 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(3) - (4)].list);
					n->args = extractArgTypes((yyvsp[(4) - (4)].list));
					n->number = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 564:

/* Line 1455 of yacc.c  */
#line 3613 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(6) - (7)].list);
					n->args = extractArgTypes((yyvsp[(7) - (7)].list));
					n->number = (yyvsp[(2) - (7)].ival);
					n->class_args = (yyvsp[(4) - (7)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 565:

/* Line 1455 of yacc.c  */
#line 3623 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[(2) - (2)].typnam);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 566:

/* Line 1455 of yacc.c  */
#line 3631 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 567:

/* Line 1455 of yacc.c  */
#line 3632 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 568:

/* Line 1455 of yacc.c  */
#line 3635 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 569:

/* Line 1455 of yacc.c  */
#line 3636 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 570:

/* Line 1455 of yacc.c  */
#line 3640 "gram.y"
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 scanner_errposition((yylsp[(1) - (1)]))));
					(yyval.boolean) = TRUE;
				;}
    break;

  case 571:

/* Line 1455 of yacc.c  */
#line 3653 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 572:

/* Line 1455 of yacc.c  */
#line 3659 "gram.y"
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (6)].list);
					n->amname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 573:

/* Line 1455 of yacc.c  */
#line 3669 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = false;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 574:

/* Line 1455 of yacc.c  */
#line 3678 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = true;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 575:

/* Line 1455 of yacc.c  */
#line 3689 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 576:

/* Line 1455 of yacc.c  */
#line 3690 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 577:

/* Line 1455 of yacc.c  */
#line 3695 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 578:

/* Line 1455 of yacc.c  */
#line 3703 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 579:

/* Line 1455 of yacc.c  */
#line 3715 "gram.y"
    {
					RemoveOpClassStmt *n = makeNode(RemoveOpClassStmt);
					n->opclassname = (yyvsp[(4) - (7)].list);
					n->amname = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 580:

/* Line 1455 of yacc.c  */
#line 3724 "gram.y"
    {
					RemoveOpClassStmt *n = makeNode(RemoveOpClassStmt);
					n->opclassname = (yyvsp[(6) - (9)].list);
					n->amname = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 581:

/* Line 1455 of yacc.c  */
#line 3736 "gram.y"
    {
					RemoveOpFamilyStmt *n = makeNode(RemoveOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (7)].list);
					n->amname = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 582:

/* Line 1455 of yacc.c  */
#line 3745 "gram.y"
    {
					RemoveOpFamilyStmt *n = makeNode(RemoveOpFamilyStmt);
					n->opfamilyname = (yyvsp[(6) - (9)].list);
					n->amname = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 583:

/* Line 1455 of yacc.c  */
#line 3766 "gram.y"
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 584:

/* Line 1455 of yacc.c  */
#line 3776 "gram.y"
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[(4) - (6)].list);
					n->newrole = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 585:

/* Line 1455 of yacc.c  */
#line 3794 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (6)].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[(5) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 586:

/* Line 1455 of yacc.c  */
#line 3803 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (4)].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[(3) - (4)].list);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 587:

/* Line 1455 of yacc.c  */
#line 3814 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; ;}
    break;

  case 588:

/* Line 1455 of yacc.c  */
#line 3815 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; ;}
    break;

  case 589:

/* Line 1455 of yacc.c  */
#line 3816 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; ;}
    break;

  case 590:

/* Line 1455 of yacc.c  */
#line 3817 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; ;}
    break;

  case 591:

/* Line 1455 of yacc.c  */
#line 3818 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; ;}
    break;

  case 592:

/* Line 1455 of yacc.c  */
#line 3819 "gram.y"
    { (yyval.objtype) = OBJECT_DOMAIN; ;}
    break;

  case 593:

/* Line 1455 of yacc.c  */
#line 3820 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; ;}
    break;

  case 594:

/* Line 1455 of yacc.c  */
#line 3821 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; ;}
    break;

  case 595:

/* Line 1455 of yacc.c  */
#line 3822 "gram.y"
    { (yyval.objtype) = OBJECT_TSPARSER; ;}
    break;

  case 596:

/* Line 1455 of yacc.c  */
#line 3823 "gram.y"
    { (yyval.objtype) = OBJECT_TSDICTIONARY; ;}
    break;

  case 597:

/* Line 1455 of yacc.c  */
#line 3824 "gram.y"
    { (yyval.objtype) = OBJECT_TSTEMPLATE; ;}
    break;

  case 598:

/* Line 1455 of yacc.c  */
#line 3825 "gram.y"
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; ;}
    break;

  case 599:

/* Line 1455 of yacc.c  */
#line 3829 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); ;}
    break;

  case 600:

/* Line 1455 of yacc.c  */
#line 3830 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); ;}
    break;

  case 601:

/* Line 1455 of yacc.c  */
#line 3833 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 602:

/* Line 1455 of yacc.c  */
#line 3834 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); ;}
    break;

  case 603:

/* Line 1455 of yacc.c  */
#line 3838 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(2) - (2)].str))); ;}
    break;

  case 604:

/* Line 1455 of yacc.c  */
#line 3840 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); ;}
    break;

  case 605:

/* Line 1455 of yacc.c  */
#line 3853 "gram.y"
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[(3) - (5)].list);
					n->restart_seqs = (yyvsp[(4) - (5)].boolean);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 606:

/* Line 1455 of yacc.c  */
#line 3863 "gram.y"
    { (yyval.boolean) = false; ;}
    break;

  case 607:

/* Line 1455 of yacc.c  */
#line 3864 "gram.y"
    { (yyval.boolean) = true; ;}
    break;

  case 608:

/* Line 1455 of yacc.c  */
#line 3865 "gram.y"
    { (yyval.boolean) = false; ;}
    break;

  case 609:

/* Line 1455 of yacc.c  */
#line 3891 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[(3) - (6)].objtype);
					n->objname = (yyvsp[(4) - (6)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 610:

/* Line 1455 of yacc.c  */
#line 3900 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = (yyvsp[(5) - (7)].list);
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 611:

/* Line 1455 of yacc.c  */
#line 3909 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = extractArgTypes((yyvsp[(5) - (7)].list));
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 612:

/* Line 1455 of yacc.c  */
#line 3918 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = (yyvsp[(5) - (7)].list);
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 613:

/* Line 1455 of yacc.c  */
#line 3927 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CONSTRAINT;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 614:

/* Line 1455 of yacc.c  */
#line 3936 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 615:

/* Line 1455 of yacc.c  */
#line 3945 "gram.y"
    {
					/* Obsolete syntax supported for awhile for compatibility */
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = list_make1(makeString((yyvsp[(4) - (6)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 616:

/* Line 1455 of yacc.c  */
#line 3955 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 617:

/* Line 1455 of yacc.c  */
#line 3964 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[(5) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 618:

/* Line 1455 of yacc.c  */
#line 3973 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[(5) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 619:

/* Line 1455 of yacc.c  */
#line 3982 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[(5) - (7)].value));
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 620:

/* Line 1455 of yacc.c  */
#line 3991 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[(5) - (10)].typnam));
					n->objargs = list_make1((yyvsp[(7) - (10)].typnam));
					n->comment = (yyvsp[(10) - (10)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 621:

/* Line 1455 of yacc.c  */
#line 4000 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[(5) - (7)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 622:

/* Line 1455 of yacc.c  */
#line 4009 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSPARSER;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 623:

/* Line 1455 of yacc.c  */
#line 4017 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSDICTIONARY;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 624:

/* Line 1455 of yacc.c  */
#line 4025 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSTEMPLATE;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 625:

/* Line 1455 of yacc.c  */
#line 4033 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 626:

/* Line 1455 of yacc.c  */
#line 4043 "gram.y"
    { (yyval.objtype) = OBJECT_COLUMN; ;}
    break;

  case 627:

/* Line 1455 of yacc.c  */
#line 4044 "gram.y"
    { (yyval.objtype) = OBJECT_DATABASE; ;}
    break;

  case 628:

/* Line 1455 of yacc.c  */
#line 4045 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; ;}
    break;

  case 629:

/* Line 1455 of yacc.c  */
#line 4046 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; ;}
    break;

  case 630:

/* Line 1455 of yacc.c  */
#line 4047 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; ;}
    break;

  case 631:

/* Line 1455 of yacc.c  */
#line 4048 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; ;}
    break;

  case 632:

/* Line 1455 of yacc.c  */
#line 4049 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; ;}
    break;

  case 633:

/* Line 1455 of yacc.c  */
#line 4050 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; ;}
    break;

  case 634:

/* Line 1455 of yacc.c  */
#line 4051 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; ;}
    break;

  case 635:

/* Line 1455 of yacc.c  */
#line 4052 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; ;}
    break;

  case 636:

/* Line 1455 of yacc.c  */
#line 4053 "gram.y"
    { (yyval.objtype) = OBJECT_TABLESPACE; ;}
    break;

  case 637:

/* Line 1455 of yacc.c  */
#line 4054 "gram.y"
    { (yyval.objtype) = OBJECT_ROLE; ;}
    break;

  case 638:

/* Line 1455 of yacc.c  */
#line 4058 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 639:

/* Line 1455 of yacc.c  */
#line 4059 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 640:

/* Line 1455 of yacc.c  */
#line 4070 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (4)].node);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 641:

/* Line 1455 of yacc.c  */
#line 4077 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					n->portalname = (yyvsp[(2) - (2)].str);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 642:

/* Line 1455 of yacc.c  */
#line 4086 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (4)].node);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 643:

/* Line 1455 of yacc.c  */
#line 4093 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					n->portalname = (yyvsp[(2) - (2)].str);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 644:

/* Line 1455 of yacc.c  */
#line 4105 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 645:

/* Line 1455 of yacc.c  */
#line 4112 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 646:

/* Line 1455 of yacc.c  */
#line 4119 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 647:

/* Line 1455 of yacc.c  */
#line 4126 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 648:

/* Line 1455 of yacc.c  */
#line 4133 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 649:

/* Line 1455 of yacc.c  */
#line 4140 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[(2) - (2)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 650:

/* Line 1455 of yacc.c  */
#line 4147 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[(2) - (2)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 651:

/* Line 1455 of yacc.c  */
#line 4154 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(1) - (1)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 652:

/* Line 1455 of yacc.c  */
#line 4161 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 653:

/* Line 1455 of yacc.c  */
#line 4168 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 654:

/* Line 1455 of yacc.c  */
#line 4175 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(2) - (2)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 655:

/* Line 1455 of yacc.c  */
#line 4182 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 656:

/* Line 1455 of yacc.c  */
#line 4189 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 657:

/* Line 1455 of yacc.c  */
#line 4196 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[(2) - (2)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 658:

/* Line 1455 of yacc.c  */
#line 4203 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 659:

/* Line 1455 of yacc.c  */
#line 4211 "gram.y"
    {;}
    break;

  case 660:

/* Line 1455 of yacc.c  */
#line 4212 "gram.y"
    {;}
    break;

  case 661:

/* Line 1455 of yacc.c  */
#line 4224 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->grant_option = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 662:

/* Line 1455 of yacc.c  */
#line 4239 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 663:

/* Line 1455 of yacc.c  */
#line 4252 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[(5) - (10)].list);
					n->objtype = ((yyvsp[(7) - (10)].privtarget))->objtype;
					n->objects = ((yyvsp[(7) - (10)].privtarget))->objs;
					n->grantees = (yyvsp[(9) - (10)].list);
					n->behavior = (yyvsp[(10) - (10)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 664:

/* Line 1455 of yacc.c  */
#line 4276 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 665:

/* Line 1455 of yacc.c  */
#line 4278 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 666:

/* Line 1455 of yacc.c  */
#line 4280 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 667:

/* Line 1455 of yacc.c  */
#line 4282 "gram.y"
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[(3) - (4)].list);
					(yyval.list) = list_make1(n);
				;}
    break;

  case 668:

/* Line 1455 of yacc.c  */
#line 4289 "gram.y"
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[(4) - (5)].list);
					(yyval.list) = list_make1(n);
				;}
    break;

  case 669:

/* Line 1455 of yacc.c  */
#line 4297 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].accesspriv)); ;}
    break;

  case 670:

/* Line 1455 of yacc.c  */
#line 4298 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].accesspriv)); ;}
    break;

  case 671:

/* Line 1455 of yacc.c  */
#line 4302 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			;}
    break;

  case 672:

/* Line 1455 of yacc.c  */
#line 4309 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			;}
    break;

  case 673:

/* Line 1455 of yacc.c  */
#line 4316 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			;}
    break;

  case 674:

/* Line 1455 of yacc.c  */
#line 4323 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[(1) - (2)].str);
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			;}
    break;

  case 675:

/* Line 1455 of yacc.c  */
#line 4337 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(1) - (1)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 676:

/* Line 1455 of yacc.c  */
#line 4344 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 677:

/* Line 1455 of yacc.c  */
#line 4351 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 678:

/* Line 1455 of yacc.c  */
#line 4358 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->objtype = ACL_OBJECT_FDW;
					n->objs = (yyvsp[(4) - (4)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 679:

/* Line 1455 of yacc.c  */
#line 4365 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->objtype = ACL_OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[(3) - (3)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 680:

/* Line 1455 of yacc.c  */
#line 4372 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 681:

/* Line 1455 of yacc.c  */
#line 4379 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->objtype = ACL_OBJECT_DATABASE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 682:

/* Line 1455 of yacc.c  */
#line 4386 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->objtype = ACL_OBJECT_LANGUAGE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 683:

/* Line 1455 of yacc.c  */
#line 4393 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->objtype = ACL_OBJECT_NAMESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 684:

/* Line 1455 of yacc.c  */
#line 4400 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->objtype = ACL_OBJECT_TABLESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 685:

/* Line 1455 of yacc.c  */
#line 4410 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 686:

/* Line 1455 of yacc.c  */
#line 4411 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 687:

/* Line 1455 of yacc.c  */
#line 4415 "gram.y"
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* This hack lets us avoid reserving PUBLIC as a keyword*/
					if (strcmp((yyvsp[(1) - (1)].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[(1) - (1)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 688:

/* Line 1455 of yacc.c  */
#line 4425 "gram.y"
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* Treat GROUP PUBLIC as a synonym for PUBLIC */
					if (strcmp((yyvsp[(2) - (2)].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 689:

/* Line 1455 of yacc.c  */
#line 4438 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 690:

/* Line 1455 of yacc.c  */
#line 4439 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 691:

/* Line 1455 of yacc.c  */
#line 4443 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].funwithargs)); ;}
    break;

  case 692:

/* Line 1455 of yacc.c  */
#line 4445 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].funwithargs)); ;}
    break;

  case 693:

/* Line 1455 of yacc.c  */
#line 4450 "gram.y"
    {
					FuncWithArgs *n = makeNode(FuncWithArgs);
					n->funcname = (yyvsp[(1) - (2)].list);
					n->funcargs = extractArgTypes((yyvsp[(2) - (2)].list));
					(yyval.funwithargs) = n;
				;}
    break;

  case 694:

/* Line 1455 of yacc.c  */
#line 4466 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->admin_opt = (yyvsp[(5) - (6)].boolean);
					n->grantor = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 695:

/* Line 1455 of yacc.c  */
#line 4479 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 696:

/* Line 1455 of yacc.c  */
#line 4489 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[(5) - (9)].list);
					n->grantee_roles = (yyvsp[(7) - (9)].list);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 697:

/* Line 1455 of yacc.c  */
#line 4500 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 698:

/* Line 1455 of yacc.c  */
#line 4501 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 699:

/* Line 1455 of yacc.c  */
#line 4504 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); ;}
    break;

  case 700:

/* Line 1455 of yacc.c  */
#line 4505 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 701:

/* Line 1455 of yacc.c  */
#line 4523 "gram.y"
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[(2) - (13)].boolean);
					n->concurrent = false;
					n->idxname = (yyvsp[(4) - (13)].str);
					n->relation = (yyvsp[(6) - (13)].range);
					n->accessMethod = (yyvsp[(7) - (13)].str);
					n->indexParams = (yyvsp[(9) - (13)].list);
					n->options = (yyvsp[(11) - (13)].list);
					n->tableSpace = (yyvsp[(12) - (13)].str);
					n->whereClause = (yyvsp[(13) - (13)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 702:

/* Line 1455 of yacc.c  */
#line 4539 "gram.y"
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[(2) - (14)].boolean);
					n->concurrent = true;
					n->idxname = (yyvsp[(5) - (14)].str);
					n->relation = (yyvsp[(7) - (14)].range);
					n->accessMethod = (yyvsp[(8) - (14)].str);
					n->indexParams = (yyvsp[(10) - (14)].list);
					n->options = (yyvsp[(12) - (14)].list);
					n->tableSpace = (yyvsp[(13) - (14)].str);
					n->whereClause = (yyvsp[(14) - (14)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 703:

/* Line 1455 of yacc.c  */
#line 4555 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 704:

/* Line 1455 of yacc.c  */
#line 4556 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 705:

/* Line 1455 of yacc.c  */
#line 4560 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 706:

/* Line 1455 of yacc.c  */
#line 4561 "gram.y"
    { (yyval.str) = DEFAULT_INDEX_TYPE; ;}
    break;

  case 707:

/* Line 1455 of yacc.c  */
#line 4564 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].ielem)); ;}
    break;

  case 708:

/* Line 1455 of yacc.c  */
#line 4565 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].ielem)); ;}
    break;

  case 709:

/* Line 1455 of yacc.c  */
#line 4574 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[(1) - (4)].str);
					(yyval.ielem)->expr = NULL;
					(yyval.ielem)->opclass = (yyvsp[(2) - (4)].list);
					(yyval.ielem)->ordering = (yyvsp[(3) - (4)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(4) - (4)].ival);
				;}
    break;

  case 710:

/* Line 1455 of yacc.c  */
#line 4583 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(1) - (4)].node);
					(yyval.ielem)->opclass = (yyvsp[(2) - (4)].list);
					(yyval.ielem)->ordering = (yyvsp[(3) - (4)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(4) - (4)].ival);
				;}
    break;

  case 711:

/* Line 1455 of yacc.c  */
#line 4592 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(2) - (6)].node);
					(yyval.ielem)->opclass = (yyvsp[(4) - (6)].list);
					(yyval.ielem)->ordering = (yyvsp[(5) - (6)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(6) - (6)].ival);
				;}
    break;

  case 712:

/* Line 1455 of yacc.c  */
#line 4602 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 713:

/* Line 1455 of yacc.c  */
#line 4603 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 714:

/* Line 1455 of yacc.c  */
#line 4604 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 715:

/* Line 1455 of yacc.c  */
#line 4607 "gram.y"
    { (yyval.ival) = SORTBY_ASC; ;}
    break;

  case 716:

/* Line 1455 of yacc.c  */
#line 4608 "gram.y"
    { (yyval.ival) = SORTBY_DESC; ;}
    break;

  case 717:

/* Line 1455 of yacc.c  */
#line 4609 "gram.y"
    { (yyval.ival) = SORTBY_DEFAULT; ;}
    break;

  case 718:

/* Line 1455 of yacc.c  */
#line 4612 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_FIRST; ;}
    break;

  case 719:

/* Line 1455 of yacc.c  */
#line 4613 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_LAST; ;}
    break;

  case 720:

/* Line 1455 of yacc.c  */
#line 4614 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; ;}
    break;

  case 721:

/* Line 1455 of yacc.c  */
#line 4632 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (9)].boolean);
					n->funcname = (yyvsp[(4) - (9)].list);
					n->parameters = (yyvsp[(5) - (9)].list);
					n->returnType = (yyvsp[(7) - (9)].typnam);
					n->options = (yyvsp[(8) - (9)].list);
					n->withClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 722:

/* Line 1455 of yacc.c  */
#line 4644 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (12)].boolean);
					n->funcname = (yyvsp[(4) - (12)].list);
					n->parameters = mergeTableFuncParameters((yyvsp[(5) - (12)].list), (yyvsp[(9) - (12)].list));
					n->returnType = TableFuncTypeName((yyvsp[(9) - (12)].list));
					n->returnType->location = (yylsp[(7) - (12)]);
					n->options = (yyvsp[(11) - (12)].list);
					n->withClause = (yyvsp[(12) - (12)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 723:

/* Line 1455 of yacc.c  */
#line 4657 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (7)].boolean);
					n->funcname = (yyvsp[(4) - (7)].list);
					n->parameters = (yyvsp[(5) - (7)].list);
					n->returnType = NULL;
					n->options = (yyvsp[(6) - (7)].list);
					n->withClause = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 724:

/* Line 1455 of yacc.c  */
#line 4670 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 725:

/* Line 1455 of yacc.c  */
#line 4671 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 726:

/* Line 1455 of yacc.c  */
#line 4674 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 727:

/* Line 1455 of yacc.c  */
#line 4675 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 728:

/* Line 1455 of yacc.c  */
#line 4679 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); ;}
    break;

  case 729:

/* Line 1455 of yacc.c  */
#line 4680 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); ;}
    break;

  case 730:

/* Line 1455 of yacc.c  */
#line 4688 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 731:

/* Line 1455 of yacc.c  */
#line 4689 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 732:

/* Line 1455 of yacc.c  */
#line 4693 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); ;}
    break;

  case 733:

/* Line 1455 of yacc.c  */
#line 4695 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); ;}
    break;

  case 734:

/* Line 1455 of yacc.c  */
#line 4710 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(2) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(1) - (3)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 735:

/* Line 1455 of yacc.c  */
#line 4719 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(2) - (3)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 736:

/* Line 1455 of yacc.c  */
#line 4728 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 737:

/* Line 1455 of yacc.c  */
#line 4737 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = (yyvsp[(1) - (2)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 738:

/* Line 1455 of yacc.c  */
#line 4746 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(1) - (1)].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 739:

/* Line 1455 of yacc.c  */
#line 4757 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; ;}
    break;

  case 740:

/* Line 1455 of yacc.c  */
#line 4758 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; ;}
    break;

  case 741:

/* Line 1455 of yacc.c  */
#line 4759 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; ;}
    break;

  case 742:

/* Line 1455 of yacc.c  */
#line 4760 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; ;}
    break;

  case 743:

/* Line 1455 of yacc.c  */
#line 4761 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; ;}
    break;

  case 745:

/* Line 1455 of yacc.c  */
#line 4772 "gram.y"
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 746:

/* Line 1455 of yacc.c  */
#line 4786 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 747:

/* Line 1455 of yacc.c  */
#line 4788 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (4)].str)), (yyvsp[(2) - (4)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[(1) - (4)]);
				;}
    break;

  case 748:

/* Line 1455 of yacc.c  */
#line 4794 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(2) - (5)].str)), (yyvsp[(3) - (5)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = TRUE;
					(yyval.typnam)->location = (yylsp[(2) - (5)]);
				;}
    break;

  case 749:

/* Line 1455 of yacc.c  */
#line 4804 "gram.y"
    {
				    (yyval.fun_param) = (yyvsp[(1) - (1)].fun_param);
			    ;}
    break;

  case 750:

/* Line 1455 of yacc.c  */
#line 4808 "gram.y"
    {
				    (yyval.fun_param) = (yyvsp[(1) - (3)].fun_param);
				    (yyval.fun_param)->defexpr = (yyvsp[(3) - (3)].node);
			    ;}
    break;

  case 751:

/* Line 1455 of yacc.c  */
#line 4813 "gram.y"
    {
				    (yyval.fun_param) = (yyvsp[(1) - (3)].fun_param);
				    (yyval.fun_param)->defexpr = (yyvsp[(3) - (3)].node);
			    ;}
    break;

  case 752:

/* Line 1455 of yacc.c  */
#line 4822 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 753:

/* Line 1455 of yacc.c  */
#line 4823 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 754:

/* Line 1455 of yacc.c  */
#line 4831 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(FALSE));
				;}
    break;

  case 755:

/* Line 1455 of yacc.c  */
#line 4835 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				;}
    break;

  case 756:

/* Line 1455 of yacc.c  */
#line 4839 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				;}
    break;

  case 757:

/* Line 1455 of yacc.c  */
#line 4843 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"));
				;}
    break;

  case 758:

/* Line 1455 of yacc.c  */
#line 4847 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"));
				;}
    break;

  case 759:

/* Line 1455 of yacc.c  */
#line 4851 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"));
				;}
    break;

  case 760:

/* Line 1455 of yacc.c  */
#line 4855 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				;}
    break;

  case 761:

/* Line 1455 of yacc.c  */
#line 4859 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				;}
    break;

  case 762:

/* Line 1455 of yacc.c  */
#line 4863 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				;}
    break;

  case 763:

/* Line 1455 of yacc.c  */
#line 4867 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				;}
    break;

  case 764:

/* Line 1455 of yacc.c  */
#line 4871 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 765:

/* Line 1455 of yacc.c  */
#line 4875 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 766:

/* Line 1455 of yacc.c  */
#line 4879 "gram.y"
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[(1) - (1)].vsetstmt));
				;}
    break;

  case 767:

/* Line 1455 of yacc.c  */
#line 4887 "gram.y"
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 768:

/* Line 1455 of yacc.c  */
#line 4891 "gram.y"
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[(2) - (2)].str)));
				;}
    break;

  case 769:

/* Line 1455 of yacc.c  */
#line 4895 "gram.y"
    {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(TRUE));
				;}
    break;

  case 770:

/* Line 1455 of yacc.c  */
#line 4899 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				;}
    break;

  case 771:

/* Line 1455 of yacc.c  */
#line 4903 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				;}
    break;

  case 772:

/* Line 1455 of yacc.c  */
#line 4908 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 773:

/* Line 1455 of yacc.c  */
#line 4910 "gram.y"
    {
					(yyval.list) = list_make2(makeString((yyvsp[(1) - (3)].str)), makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 774:

/* Line 1455 of yacc.c  */
#line 4916 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 775:

/* Line 1455 of yacc.c  */
#line 4917 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 776:

/* Line 1455 of yacc.c  */
#line 4921 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 777:

/* Line 1455 of yacc.c  */
#line 4933 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param));
				;}
    break;

  case 778:

/* Line 1455 of yacc.c  */
#line 4937 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param));
				;}
    break;

  case 779:

/* Line 1455 of yacc.c  */
#line 4952 "gram.y"
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->func = (yyvsp[(3) - (5)].funwithargs);
					n->actions = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 780:

/* Line 1455 of yacc.c  */
#line 4962 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 781:

/* Line 1455 of yacc.c  */
#line 4963 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 784:

/* Line 1455 of yacc.c  */
#line 4985 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_FUNCTION;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = extractArgTypes((yyvsp[(4) - (5)].list));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 785:

/* Line 1455 of yacc.c  */
#line 4995 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_FUNCTION;
					n->name = (yyvsp[(5) - (7)].list);
					n->args = extractArgTypes((yyvsp[(6) - (7)].list));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 786:

/* Line 1455 of yacc.c  */
#line 5008 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_AGGREGATE;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 787:

/* Line 1455 of yacc.c  */
#line 5018 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_AGGREGATE;
					n->name = (yyvsp[(5) - (7)].list);
					n->args = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 788:

/* Line 1455 of yacc.c  */
#line 5031 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_OPERATOR;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 789:

/* Line 1455 of yacc.c  */
#line 5041 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_OPERATOR;
					n->name = (yyvsp[(5) - (7)].list);
					n->args = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 790:

/* Line 1455 of yacc.c  */
#line 5054 "gram.y"
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							scanner_errposition((yylsp[(3) - (3)]))));
				;}
    break;

  case 791:

/* Line 1455 of yacc.c  */
#line 5062 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (5)].typnam), (yyvsp[(4) - (5)].typnam)); ;}
    break;

  case 792:

/* Line 1455 of yacc.c  */
#line 5064 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(4) - (5)].typnam)); ;}
    break;

  case 793:

/* Line 1455 of yacc.c  */
#line 5066 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (5)].typnam), NULL); ;}
    break;

  case 794:

/* Line 1455 of yacc.c  */
#line 5071 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 795:

/* Line 1455 of yacc.c  */
#line 5073 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(3) - (3)].list)); ;}
    break;

  case 796:

/* Line 1455 of yacc.c  */
#line 5085 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (11)].typnam);
					n->targettype = (yyvsp[(6) - (11)].typnam);
					n->func = (yyvsp[(10) - (11)].funwithargs);
					n->context = (CoercionContext) (yyvsp[(11) - (11)].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 797:

/* Line 1455 of yacc.c  */
#line 5096 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 798:

/* Line 1455 of yacc.c  */
#line 5107 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 799:

/* Line 1455 of yacc.c  */
#line 5118 "gram.y"
    { (yyval.ival) = COERCION_IMPLICIT; ;}
    break;

  case 800:

/* Line 1455 of yacc.c  */
#line 5119 "gram.y"
    { (yyval.ival) = COERCION_ASSIGNMENT; ;}
    break;

  case 801:

/* Line 1455 of yacc.c  */
#line 5120 "gram.y"
    { (yyval.ival) = COERCION_EXPLICIT; ;}
    break;

  case 802:

/* Line 1455 of yacc.c  */
#line 5125 "gram.y"
    {
					DropCastStmt *n = makeNode(DropCastStmt);
					n->sourcetype = (yyvsp[(5) - (9)].typnam);
					n->targettype = (yyvsp[(7) - (9)].typnam);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = (yyvsp[(3) - (9)].boolean);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 803:

/* Line 1455 of yacc.c  */
#line 5135 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 804:

/* Line 1455 of yacc.c  */
#line 5136 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 805:

/* Line 1455 of yacc.c  */
#line 5151 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[(2) - (4)].objtype);
					n->relation = (yyvsp[(3) - (4)].range);
					n->name = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 806:

/* Line 1455 of yacc.c  */
#line 5159 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[(3) - (4)].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 807:

/* Line 1455 of yacc.c  */
#line 5169 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[(3) - (4)].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 808:

/* Line 1455 of yacc.c  */
#line 5181 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; ;}
    break;

  case 809:

/* Line 1455 of yacc.c  */
#line 5182 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; ;}
    break;

  case 810:

/* Line 1455 of yacc.c  */
#line 5185 "gram.y"
    {  (yyval.boolean) = TRUE; ;}
    break;

  case 811:

/* Line 1455 of yacc.c  */
#line 5186 "gram.y"
    {  (yyval.boolean) = FALSE; ;}
    break;

  case 812:

/* Line 1455 of yacc.c  */
#line 5197 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newname = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 813:

/* Line 1455 of yacc.c  */
#line 5206 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 814:

/* Line 1455 of yacc.c  */
#line 5214 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 815:

/* Line 1455 of yacc.c  */
#line 5222 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 816:

/* Line 1455 of yacc.c  */
#line 5231 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 817:

/* Line 1455 of yacc.c  */
#line 5239 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->subname = (yyvsp[(4) - (7)].str);
					n->newname = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 818:

/* Line 1455 of yacc.c  */
#line 5247 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->subname = (yyvsp[(6) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 819:

/* Line 1455 of yacc.c  */
#line 5256 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->subname = (yyvsp[(6) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 820:

/* Line 1455 of yacc.c  */
#line 5265 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 821:

/* Line 1455 of yacc.c  */
#line 5273 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 822:

/* Line 1455 of yacc.c  */
#line 5282 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 823:

/* Line 1455 of yacc.c  */
#line 5291 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 824:

/* Line 1455 of yacc.c  */
#line 5300 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 825:

/* Line 1455 of yacc.c  */
#line 5309 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relation = (yyvsp[(3) - (8)].range);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 826:

/* Line 1455 of yacc.c  */
#line 5318 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = (yyvsp[(3) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 827:

/* Line 1455 of yacc.c  */
#line 5327 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 828:

/* Line 1455 of yacc.c  */
#line 5335 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 829:

/* Line 1455 of yacc.c  */
#line 5343 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 830:

/* Line 1455 of yacc.c  */
#line 5351 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 831:

/* Line 1455 of yacc.c  */
#line 5359 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 832:

/* Line 1455 of yacc.c  */
#line 5367 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 833:

/* Line 1455 of yacc.c  */
#line 5375 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 834:

/* Line 1455 of yacc.c  */
#line 5383 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 835:

/* Line 1455 of yacc.c  */
#line 5392 "gram.y"
    { (yyval.ival) = COLUMN; ;}
    break;

  case 836:

/* Line 1455 of yacc.c  */
#line 5393 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 837:

/* Line 1455 of yacc.c  */
#line 5396 "gram.y"
    { (yyval.ival) = 1; ;}
    break;

  case 838:

/* Line 1455 of yacc.c  */
#line 5397 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 839:

/* Line 1455 of yacc.c  */
#line 5408 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newschema = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 840:

/* Line 1455 of yacc.c  */
#line 5417 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 841:

/* Line 1455 of yacc.c  */
#line 5425 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 842:

/* Line 1455 of yacc.c  */
#line 5434 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 843:

/* Line 1455 of yacc.c  */
#line 5442 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 844:

/* Line 1455 of yacc.c  */
#line 5450 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 845:

/* Line 1455 of yacc.c  */
#line 5458 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 846:

/* Line 1455 of yacc.c  */
#line 5474 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 847:

/* Line 1455 of yacc.c  */
#line 5483 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 848:

/* Line 1455 of yacc.c  */
#line 5491 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 849:

/* Line 1455 of yacc.c  */
#line 5499 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 850:

/* Line 1455 of yacc.c  */
#line 5507 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 851:

/* Line 1455 of yacc.c  */
#line 5516 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 852:

/* Line 1455 of yacc.c  */
#line 5524 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 853:

/* Line 1455 of yacc.c  */
#line 5533 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->addname = (yyvsp[(6) - (9)].str);
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 854:

/* Line 1455 of yacc.c  */
#line 5542 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->addname = (yyvsp[(6) - (9)].str);
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 855:

/* Line 1455 of yacc.c  */
#line 5551 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 856:

/* Line 1455 of yacc.c  */
#line 5559 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 857:

/* Line 1455 of yacc.c  */
#line 5567 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 858:

/* Line 1455 of yacc.c  */
#line 5575 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 859:

/* Line 1455 of yacc.c  */
#line 5583 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 860:

/* Line 1455 of yacc.c  */
#line 5591 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[(5) - (8)].str)));
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 861:

/* Line 1455 of yacc.c  */
#line 5599 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 862:

/* Line 1455 of yacc.c  */
#line 5615 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[(3) - (4)].str)));
					n->secLabel = (Node *)(yyvsp[(4) - (4)].defelt);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 863:

/* Line 1455 of yacc.c  */
#line 5623 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[(3) - (4)].str)));
					n->secLabel = (Node *)(yyvsp[(4) - (4)].defelt);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 864:

/* Line 1455 of yacc.c  */
#line 5631 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (4)].range);
					n->secLabel = (Node *)(yyvsp[(4) - (4)].defelt);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 865:

/* Line 1455 of yacc.c  */
#line 5639 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_COLUMN;
					n->relation = (yyvsp[(3) - (7)].range);
					n->subname = (yyvsp[(6) - (7)].str);
					n->secLabel = (Node *)(yyvsp[(7) - (7)].defelt);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 866:

/* Line 1455 of yacc.c  */
#line 5648 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (4)].range);
					n->secLabel = (Node *)(yyvsp[(4) - (4)].defelt);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 867:

/* Line 1455 of yacc.c  */
#line 5656 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (4)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (4)].funwithargs)->funcargs;
					n->secLabel = (Node *)(yyvsp[(4) - (4)].defelt);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 868:

/* Line 1455 of yacc.c  */
#line 5666 "gram.y"
    { (yyval.defelt) = (yyvsp[(1) - (1)].defelt); ;}
    break;

  case 869:

/* Line 1455 of yacc.c  */
#line 5667 "gram.y"
    { (yyval.defelt) = NULL; ;}
    break;

  case 870:

/* Line 1455 of yacc.c  */
#line 5671 "gram.y"
    {
					if (strcmp("security_context", (yyvsp[(1) - (3)].str)) != 0)
						yyerror("syntax error");
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 871:

/* Line 1455 of yacc.c  */
#line 5686 "gram.y"
    { QueryIsRule=TRUE; ;}
    break;

  case 872:

/* Line 1455 of yacc.c  */
#line 5689 "gram.y"
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[(2) - (14)].boolean);
					n->relation = (yyvsp[(10) - (14)].range);
					n->rulename = (yyvsp[(4) - (14)].str);
					n->whereClause = (yyvsp[(11) - (14)].node);
					n->event = (yyvsp[(8) - (14)].ival);
					n->instead = (yyvsp[(13) - (14)].boolean);
					n->actions = (yyvsp[(14) - (14)].list);
					(yyval.node) = (Node *)n;
					QueryIsRule=FALSE;
				;}
    break;

  case 873:

/* Line 1455 of yacc.c  */
#line 5704 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 874:

/* Line 1455 of yacc.c  */
#line 5705 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 875:

/* Line 1455 of yacc.c  */
#line 5706 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 876:

/* Line 1455 of yacc.c  */
#line 5712 "gram.y"
    { if ((yyvsp[(3) - (3)].node) != NULL)
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				  else
					(yyval.list) = (yyvsp[(1) - (3)].list);
				;}
    break;

  case 877:

/* Line 1455 of yacc.c  */
#line 5718 "gram.y"
    { if ((yyvsp[(1) - (1)].node) != NULL)
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				  else
					(yyval.list) = NIL;
				;}
    break;

  case 883:

/* Line 1455 of yacc.c  */
#line 5734 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 884:

/* Line 1455 of yacc.c  */
#line 5735 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 885:

/* Line 1455 of yacc.c  */
#line 5738 "gram.y"
    { (yyval.ival) = CMD_SELECT; ;}
    break;

  case 886:

/* Line 1455 of yacc.c  */
#line 5739 "gram.y"
    { (yyval.ival) = CMD_UPDATE; ;}
    break;

  case 887:

/* Line 1455 of yacc.c  */
#line 5740 "gram.y"
    { (yyval.ival) = CMD_DELETE; ;}
    break;

  case 888:

/* Line 1455 of yacc.c  */
#line 5741 "gram.y"
    { (yyval.ival) = CMD_INSERT; ;}
    break;

  case 889:

/* Line 1455 of yacc.c  */
#line 5745 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 890:

/* Line 1455 of yacc.c  */
#line 5746 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 891:

/* Line 1455 of yacc.c  */
#line 5747 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 892:

/* Line 1455 of yacc.c  */
#line 5753 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->property = (yyvsp[(3) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->removeType = OBJECT_RULE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 893:

/* Line 1455 of yacc.c  */
#line 5763 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(7) - (8)].range);
					n->property = (yyvsp[(5) - (8)].str);
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->removeType = OBJECT_RULE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 894:

/* Line 1455 of yacc.c  */
#line 5784 "gram.y"
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 895:

/* Line 1455 of yacc.c  */
#line 5792 "gram.y"
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 896:

/* Line 1455 of yacc.c  */
#line 5801 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 897:

/* Line 1455 of yacc.c  */
#line 5807 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 898:

/* Line 1455 of yacc.c  */
#line 5826 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 899:

/* Line 1455 of yacc.c  */
#line 5833 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 900:

/* Line 1455 of yacc.c  */
#line 5840 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 901:

/* Line 1455 of yacc.c  */
#line 5847 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 902:

/* Line 1455 of yacc.c  */
#line 5854 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 903:

/* Line 1455 of yacc.c  */
#line 5861 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 904:

/* Line 1455 of yacc.c  */
#line 5868 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 905:

/* Line 1455 of yacc.c  */
#line 5876 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(3) - (3)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 906:

/* Line 1455 of yacc.c  */
#line 5884 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 907:

/* Line 1455 of yacc.c  */
#line 5892 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(5) - (5)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 908:

/* Line 1455 of yacc.c  */
#line 5900 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(4) - (4)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 909:

/* Line 1455 of yacc.c  */
#line 5908 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 910:

/* Line 1455 of yacc.c  */
#line 5915 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 911:

/* Line 1455 of yacc.c  */
#line 5922 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 912:

/* Line 1455 of yacc.c  */
#line 5930 "gram.y"
    {;}
    break;

  case 913:

/* Line 1455 of yacc.c  */
#line 5931 "gram.y"
    {;}
    break;

  case 914:

/* Line 1455 of yacc.c  */
#line 5932 "gram.y"
    {;}
    break;

  case 915:

/* Line 1455 of yacc.c  */
#line 5937 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)]))); ;}
    break;

  case 916:

/* Line 1455 of yacc.c  */
#line 5940 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(TRUE, (yylsp[(1) - (2)]))); ;}
    break;

  case 917:

/* Line 1455 of yacc.c  */
#line 5943 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(FALSE, (yylsp[(1) - (2)]))); ;}
    break;

  case 918:

/* Line 1455 of yacc.c  */
#line 5950 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 919:

/* Line 1455 of yacc.c  */
#line 5952 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 920:

/* Line 1455 of yacc.c  */
#line 5954 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 922:

/* Line 1455 of yacc.c  */
#line 5960 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 923:

/* Line 1455 of yacc.c  */
#line 5974 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(4) - (8)].range);
					n->view->istemp = (yyvsp[(2) - (8)].boolean);
					n->aliases = (yyvsp[(5) - (8)].list);
					n->query = (yyvsp[(7) - (8)].node);
					n->replace = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 924:

/* Line 1455 of yacc.c  */
#line 5985 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(6) - (10)].range);
					n->view->istemp = (yyvsp[(4) - (10)].boolean);
					n->aliases = (yyvsp[(7) - (10)].list);
					n->query = (yyvsp[(9) - (10)].node);
					n->replace = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 925:

/* Line 1455 of yacc.c  */
#line 5998 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				;}
    break;

  case 926:

/* Line 1455 of yacc.c  */
#line 6004 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				;}
    break;

  case 927:

/* Line 1455 of yacc.c  */
#line 6010 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				;}
    break;

  case 928:

/* Line 1455 of yacc.c  */
#line 6015 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 929:

/* Line 1455 of yacc.c  */
#line 6026 "gram.y"
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 930:

/* Line 1455 of yacc.c  */
#line 6042 "gram.y"
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 931:

/* Line 1455 of yacc.c  */
#line 6051 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 932:

/* Line 1455 of yacc.c  */
#line 6052 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 933:

/* Line 1455 of yacc.c  */
#line 6057 "gram.y"
    {
					(yyval.defelt) = makeDefElem("tablespace", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 934:

/* Line 1455 of yacc.c  */
#line 6061 "gram.y"
    {
					(yyval.defelt) = makeDefElem("tablespace", NULL);
				;}
    break;

  case 935:

/* Line 1455 of yacc.c  */
#line 6065 "gram.y"
    {
					(yyval.defelt) = makeDefElem("location", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 936:

/* Line 1455 of yacc.c  */
#line 6069 "gram.y"
    {
					(yyval.defelt) = makeDefElem("location", NULL);
				;}
    break;

  case 937:

/* Line 1455 of yacc.c  */
#line 6073 "gram.y"
    {
					(yyval.defelt) = makeDefElem("template", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 938:

/* Line 1455 of yacc.c  */
#line 6077 "gram.y"
    {
					(yyval.defelt) = makeDefElem("template", NULL);
				;}
    break;

  case 939:

/* Line 1455 of yacc.c  */
#line 6081 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 940:

/* Line 1455 of yacc.c  */
#line 6085 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				;}
    break;

  case 941:

/* Line 1455 of yacc.c  */
#line 6089 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", NULL);
				;}
    break;

  case 942:

/* Line 1455 of yacc.c  */
#line 6093 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_collate", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 943:

/* Line 1455 of yacc.c  */
#line 6097 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_collate", NULL);
				;}
    break;

  case 944:

/* Line 1455 of yacc.c  */
#line 6101 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_ctype", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 945:

/* Line 1455 of yacc.c  */
#line 6105 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_ctype", NULL);
				;}
    break;

  case 946:

/* Line 1455 of yacc.c  */
#line 6109 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(4) - (4)].ival)));
				;}
    break;

  case 947:

/* Line 1455 of yacc.c  */
#line 6113 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owner", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 948:

/* Line 1455 of yacc.c  */
#line 6117 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owner", NULL);
				;}
    break;

  case 949:

/* Line 1455 of yacc.c  */
#line 6121 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				;}
    break;

  case 950:

/* Line 1455 of yacc.c  */
#line 6130 "gram.y"
    {;}
    break;

  case 951:

/* Line 1455 of yacc.c  */
#line 6131 "gram.y"
    {;}
    break;

  case 952:

/* Line 1455 of yacc.c  */
#line 6143 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 953:

/* Line 1455 of yacc.c  */
#line 6150 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (6)].str);
					n->options = list_make1(makeDefElem("tablespace",
													(Node *)makeString((yyvsp[(6) - (6)].str))));
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 954:

/* Line 1455 of yacc.c  */
#line 6161 "gram.y"
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[(3) - (4)].str);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 955:

/* Line 1455 of yacc.c  */
#line 6171 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 956:

/* Line 1455 of yacc.c  */
#line 6172 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 957:

/* Line 1455 of yacc.c  */
#line 6177 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(4) - (4)].ival)));
				;}
    break;

  case 958:

/* Line 1455 of yacc.c  */
#line 6191 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(3) - (3)].str);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 959:

/* Line 1455 of yacc.c  */
#line 6198 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(5) - (5)].str);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 960:

/* Line 1455 of yacc.c  */
#line 6215 "gram.y"
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[(3) - (6)].list);
					n->typename = (yyvsp[(5) - (6)].typnam);
					n->constraints = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 961:

/* Line 1455 of yacc.c  */
#line 6227 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typename = (yyvsp[(3) - (4)].list);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 962:

/* Line 1455 of yacc.c  */
#line 6236 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typename = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 963:

/* Line 1455 of yacc.c  */
#line 6244 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typename = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 964:

/* Line 1455 of yacc.c  */
#line 6252 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typename = (yyvsp[(3) - (5)].list);
					n->def = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 965:

/* Line 1455 of yacc.c  */
#line 6261 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typename = (yyvsp[(3) - (7)].list);
					n->name = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 966:

/* Line 1455 of yacc.c  */
#line 6271 "gram.y"
    {;}
    break;

  case 967:

/* Line 1455 of yacc.c  */
#line 6272 "gram.y"
    {;}
    break;

  case 968:

/* Line 1455 of yacc.c  */
#line 6284 "gram.y"
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[(5) - (6)].list);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 969:

/* Line 1455 of yacc.c  */
#line 6294 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 970:

/* Line 1455 of yacc.c  */
#line 6304 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 971:

/* Line 1455 of yacc.c  */
#line 6314 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[(9) - (11)].list),(yyvsp[(11) - (11)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 972:

/* Line 1455 of yacc.c  */
#line 6324 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (13)].list);
					n->tokentype = (yyvsp[(9) - (13)].list);
					n->dicts = list_make2((yyvsp[(11) - (13)].list),(yyvsp[(13) - (13)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 973:

/* Line 1455 of yacc.c  */
#line 6334 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (9)].list);
					n->tokentype = (yyvsp[(9) - (9)].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 974:

/* Line 1455 of yacc.c  */
#line 6342 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(11) - (11)].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 975:

/* Line 1455 of yacc.c  */
#line 6364 "gram.y"
    {
			  CreateConversionStmt *n = makeNode(CreateConversionStmt);
			  n->conversion_name = (yyvsp[(4) - (10)].list);
			  n->for_encoding_name = (yyvsp[(6) - (10)].str);
			  n->to_encoding_name = (yyvsp[(8) - (10)].str);
			  n->func_name = (yyvsp[(10) - (10)].list);
			  n->def = (yyvsp[(2) - (10)].boolean);
			  (yyval.node) = (Node *)n;
			;}
    break;

  case 976:

/* Line 1455 of yacc.c  */
#line 6386 "gram.y"
    {
			       ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = (yyvsp[(3) - (4)].range);
				   n->indexname = (yyvsp[(4) - (4)].str);
				   n->verbose = (yyvsp[(2) - (4)].boolean);
				   (yyval.node) = (Node*)n;
				;}
    break;

  case 977:

/* Line 1455 of yacc.c  */
#line 6394 "gram.y"
    {
				   ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = NULL;
				   n->indexname = NULL;
				   n->verbose = (yyvsp[(2) - (2)].boolean);
				   (yyval.node) = (Node*)n;
				;}
    break;

  case 978:

/* Line 1455 of yacc.c  */
#line 6403 "gram.y"
    {
				   ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = (yyvsp[(5) - (5)].range);
				   n->indexname = (yyvsp[(3) - (5)].str);
				   n->verbose = (yyvsp[(2) - (5)].boolean);
				   (yyval.node) = (Node*)n;
				;}
    break;

  case 979:

/* Line 1455 of yacc.c  */
#line 6413 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 980:

/* Line 1455 of yacc.c  */
#line 6414 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 981:

/* Line 1455 of yacc.c  */
#line 6427 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->vacuum = true;
					n->analyze = false;
					n->full = (yyvsp[(2) - (4)].boolean);
					n->freeze_min_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->verbose = (yyvsp[(4) - (4)].boolean);
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 982:

/* Line 1455 of yacc.c  */
#line 6440 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->vacuum = true;
					n->analyze = false;
					n->full = (yyvsp[(2) - (5)].boolean);
					n->freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->verbose = (yyvsp[(4) - (5)].boolean);
					n->relation = (yyvsp[(5) - (5)].range);
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 983:

/* Line 1455 of yacc.c  */
#line 6453 "gram.y"
    {
					VacuumStmt *n = (VacuumStmt *) (yyvsp[(5) - (5)].node);
					n->vacuum = true;
					n->full = (yyvsp[(2) - (5)].boolean);
					n->freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->verbose |= (yyvsp[(4) - (5)].boolean);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 984:

/* Line 1455 of yacc.c  */
#line 6466 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->vacuum = false;
					n->analyze = true;
					n->full = false;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->verbose = (yyvsp[(2) - (2)].boolean);
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 985:

/* Line 1455 of yacc.c  */
#line 6479 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->vacuum = false;
					n->analyze = true;
					n->full = false;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->verbose = (yyvsp[(2) - (4)].boolean);
					n->relation = (yyvsp[(3) - (4)].range);
					n->va_cols = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 986:

/* Line 1455 of yacc.c  */
#line 6494 "gram.y"
    {;}
    break;

  case 987:

/* Line 1455 of yacc.c  */
#line 6495 "gram.y"
    {;}
    break;

  case 988:

/* Line 1455 of yacc.c  */
#line 6499 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 989:

/* Line 1455 of yacc.c  */
#line 6500 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 990:

/* Line 1455 of yacc.c  */
#line 6503 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 991:

/* Line 1455 of yacc.c  */
#line 6504 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 992:

/* Line 1455 of yacc.c  */
#line 6507 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 993:

/* Line 1455 of yacc.c  */
#line 6508 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 994:

/* Line 1455 of yacc.c  */
#line 6512 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 995:

/* Line 1455 of yacc.c  */
#line 6513 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 996:

/* Line 1455 of yacc.c  */
#line 6525 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->analyze = (yyvsp[(2) - (4)].boolean);
					n->verbose = (yyvsp[(3) - (4)].boolean);
					n->query = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1004:

/* Line 1455 of yacc.c  */
#line 6545 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1005:

/* Line 1455 of yacc.c  */
#line 6546 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1006:

/* Line 1455 of yacc.c  */
#line 6557 "gram.y"
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[(2) - (5)].str);
					n->argtypes = (yyvsp[(3) - (5)].list);
					n->query = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1007:

/* Line 1455 of yacc.c  */
#line 6566 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1008:

/* Line 1455 of yacc.c  */
#line 6567 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1013:

/* Line 1455 of yacc.c  */
#line 6585 "gram.y"
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(2) - (3)].str);
					n->params = (yyvsp[(3) - (3)].list);
					n->into = NULL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1014:

/* Line 1455 of yacc.c  */
#line 6594 "gram.y"
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(7) - (8)].str);
					n->params = (yyvsp[(8) - (8)].list);
					(yyvsp[(4) - (8)].into)->rel->istemp = (yyvsp[(2) - (8)].boolean);
					n->into = (yyvsp[(4) - (8)].into);
					if ((yyvsp[(4) - (8)].into)->colNames)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("column name list not allowed in CREATE TABLE / AS EXECUTE")));
					/* ... because it's not implemented, but it could be */
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1015:

/* Line 1455 of yacc.c  */
#line 6609 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1016:

/* Line 1455 of yacc.c  */
#line 6610 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1017:

/* Line 1455 of yacc.c  */
#line 6621 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(2) - (2)].str);
						(yyval.node) = (Node *) n;
					;}
    break;

  case 1018:

/* Line 1455 of yacc.c  */
#line 6627 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(3) - (3)].str);
						(yyval.node) = (Node *) n;
					;}
    break;

  case 1019:

/* Line 1455 of yacc.c  */
#line 6633 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					;}
    break;

  case 1020:

/* Line 1455 of yacc.c  */
#line 6639 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					;}
    break;

  case 1021:

/* Line 1455 of yacc.c  */
#line 6655 "gram.y"
    {
					(yyvsp[(4) - (5)].istmt)->relation = (yyvsp[(3) - (5)].range);
					(yyvsp[(4) - (5)].istmt)->returningList = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *) (yyvsp[(4) - (5)].istmt);
				;}
    break;

  case 1022:

/* Line 1455 of yacc.c  */
#line 6664 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[(1) - (1)].node);
				;}
    break;

  case 1023:

/* Line 1455 of yacc.c  */
#line 6670 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[(2) - (4)].list);
					(yyval.istmt)->selectStmt = (yyvsp[(4) - (4)].node);
				;}
    break;

  case 1024:

/* Line 1455 of yacc.c  */
#line 6676 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				;}
    break;

  case 1025:

/* Line 1455 of yacc.c  */
#line 6685 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1026:

/* Line 1455 of yacc.c  */
#line 6687 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); ;}
    break;

  case 1027:

/* Line 1455 of yacc.c  */
#line 6692 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = check_indirection((yyvsp[(2) - (2)].list));
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1028:

/* Line 1455 of yacc.c  */
#line 6702 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1029:

/* Line 1455 of yacc.c  */
#line 6703 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1030:

/* Line 1455 of yacc.c  */
#line 6716 "gram.y"
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[(3) - (6)].range);
					n->usingClause = (yyvsp[(4) - (6)].list);
					n->whereClause = (yyvsp[(5) - (6)].node);
					n->returningList = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1031:

/* Line 1455 of yacc.c  */
#line 6727 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1032:

/* Line 1455 of yacc.c  */
#line 6728 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1033:

/* Line 1455 of yacc.c  */
#line 6740 "gram.y"
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[(3) - (5)].list);
					n->mode = (yyvsp[(4) - (5)].ival);
					n->nowait = (yyvsp[(5) - (5)].boolean);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1034:

/* Line 1455 of yacc.c  */
#line 6750 "gram.y"
    { (yyval.ival) = (yyvsp[(2) - (3)].ival); ;}
    break;

  case 1035:

/* Line 1455 of yacc.c  */
#line 6751 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; ;}
    break;

  case 1036:

/* Line 1455 of yacc.c  */
#line 6754 "gram.y"
    { (yyval.ival) = AccessShareLock; ;}
    break;

  case 1037:

/* Line 1455 of yacc.c  */
#line 6755 "gram.y"
    { (yyval.ival) = RowShareLock; ;}
    break;

  case 1038:

/* Line 1455 of yacc.c  */
#line 6756 "gram.y"
    { (yyval.ival) = RowExclusiveLock; ;}
    break;

  case 1039:

/* Line 1455 of yacc.c  */
#line 6757 "gram.y"
    { (yyval.ival) = ShareUpdateExclusiveLock; ;}
    break;

  case 1040:

/* Line 1455 of yacc.c  */
#line 6758 "gram.y"
    { (yyval.ival) = ShareLock; ;}
    break;

  case 1041:

/* Line 1455 of yacc.c  */
#line 6759 "gram.y"
    { (yyval.ival) = ShareRowExclusiveLock; ;}
    break;

  case 1042:

/* Line 1455 of yacc.c  */
#line 6760 "gram.y"
    { (yyval.ival) = ExclusiveLock; ;}
    break;

  case 1043:

/* Line 1455 of yacc.c  */
#line 6761 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; ;}
    break;

  case 1044:

/* Line 1455 of yacc.c  */
#line 6764 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1045:

/* Line 1455 of yacc.c  */
#line 6765 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1046:

/* Line 1455 of yacc.c  */
#line 6781 "gram.y"
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[(2) - (7)].range);
					n->targetList = (yyvsp[(4) - (7)].list);
					n->fromClause = (yyvsp[(5) - (7)].list);
					n->whereClause = (yyvsp[(6) - (7)].node);
					n->returningList = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1047:

/* Line 1455 of yacc.c  */
#line 6793 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1048:

/* Line 1455 of yacc.c  */
#line 6794 "gram.y"
    { (yyval.list) = list_concat((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].list)); ;}
    break;

  case 1049:

/* Line 1455 of yacc.c  */
#line 6798 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1050:

/* Line 1455 of yacc.c  */
#line 6799 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1051:

/* Line 1455 of yacc.c  */
#line 6804 "gram.y"
    {
					(yyval.target) = (yyvsp[(1) - (3)].target);
					(yyval.target)->val = (Node *) (yyvsp[(3) - (3)].node);
				;}
    break;

  case 1052:

/* Line 1455 of yacc.c  */
#line 6812 "gram.y"
    {
					ListCell *col_cell;
					ListCell *val_cell;

					/*
					 * Break the ctext_row apart, merge individual expressions
					 * into the destination ResTargets.  XXX this approach
					 * cannot work for general row expressions as sources.
					 */
					if (list_length((yyvsp[(2) - (5)].list)) != list_length((yyvsp[(5) - (5)].list)))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("number of columns does not match number of values"),
								 scanner_errposition((yylsp[(1) - (5)]))));
					forboth(col_cell, (yyvsp[(2) - (5)].list), val_cell, (yyvsp[(5) - (5)].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						Node *res_val = (Node *) lfirst(val_cell);

						res_col->val = res_val;
					}

					(yyval.list) = (yyvsp[(2) - (5)].list);
				;}
    break;

  case 1053:

/* Line 1455 of yacc.c  */
#line 6840 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = check_indirection((yyvsp[(2) - (2)].list));
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1054:

/* Line 1455 of yacc.c  */
#line 6850 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1055:

/* Line 1455 of yacc.c  */
#line 6851 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].target)); ;}
    break;

  case 1056:

/* Line 1455 of yacc.c  */
#line 6862 "gram.y"
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[(2) - (7)].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[(3) - (7)].ival) | (yyvsp[(5) - (7)].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1057:

/* Line 1455 of yacc.c  */
#line 6872 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1058:

/* Line 1455 of yacc.c  */
#line 6873 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | CURSOR_OPT_NO_SCROLL; ;}
    break;

  case 1059:

/* Line 1455 of yacc.c  */
#line 6874 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_SCROLL; ;}
    break;

  case 1060:

/* Line 1455 of yacc.c  */
#line 6875 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_BINARY; ;}
    break;

  case 1061:

/* Line 1455 of yacc.c  */
#line 6876 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_INSENSITIVE; ;}
    break;

  case 1062:

/* Line 1455 of yacc.c  */
#line 6879 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1063:

/* Line 1455 of yacc.c  */
#line 6880 "gram.y"
    { (yyval.ival) = CURSOR_OPT_HOLD; ;}
    break;

  case 1064:

/* Line 1455 of yacc.c  */
#line 6881 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1067:

/* Line 1455 of yacc.c  */
#line 6934 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); ;}
    break;

  case 1068:

/* Line 1455 of yacc.c  */
#line 6935 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); ;}
    break;

  case 1069:

/* Line 1455 of yacc.c  */
#line 6949 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1070:

/* Line 1455 of yacc.c  */
#line 6951 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].list), NIL,
										NULL, NULL, NULL);
					(yyval.node) = (yyvsp[(1) - (2)].node);
				;}
    break;

  case 1071:

/* Line 1455 of yacc.c  */
#line 6957 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(3) - (4)].list),
										list_nth((yyvsp[(4) - (4)].list), 0), list_nth((yyvsp[(4) - (4)].list), 1),
										NULL);
					(yyval.node) = (yyvsp[(1) - (4)].node);
				;}
    break;

  case 1072:

/* Line 1455 of yacc.c  */
#line 6964 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(4) - (4)].list),
										list_nth((yyvsp[(3) - (4)].list), 0), list_nth((yyvsp[(3) - (4)].list), 1),
										NULL);
					(yyval.node) = (yyvsp[(1) - (4)].node);
				;}
    break;

  case 1073:

/* Line 1455 of yacc.c  */
#line 6971 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (2)].node), NULL, NIL,
										NULL, NULL,
										(yyvsp[(1) - (2)].with));
					(yyval.node) = (yyvsp[(2) - (2)].node);
				;}
    break;

  case 1074:

/* Line 1455 of yacc.c  */
#line 6978 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].list), NIL,
										NULL, NULL,
										(yyvsp[(1) - (3)].with));
					(yyval.node) = (yyvsp[(2) - (3)].node);
				;}
    break;

  case 1075:

/* Line 1455 of yacc.c  */
#line 6985 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (5)].node), (yyvsp[(3) - (5)].list), (yyvsp[(4) - (5)].list),
										list_nth((yyvsp[(5) - (5)].list), 0), list_nth((yyvsp[(5) - (5)].list), 1),
										(yyvsp[(1) - (5)].with));
					(yyval.node) = (yyvsp[(2) - (5)].node);
				;}
    break;

  case 1076:

/* Line 1455 of yacc.c  */
#line 6992 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (5)].node), (yyvsp[(3) - (5)].list), (yyvsp[(5) - (5)].list),
										list_nth((yyvsp[(4) - (5)].list), 0), list_nth((yyvsp[(4) - (5)].list), 1),
										(yyvsp[(1) - (5)].with));
					(yyval.node) = (yyvsp[(2) - (5)].node);
				;}
    break;

  case 1077:

/* Line 1455 of yacc.c  */
#line 7001 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1078:

/* Line 1455 of yacc.c  */
#line 7002 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1079:

/* Line 1455 of yacc.c  */
#line 7032 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[(2) - (9)].list);
					n->targetList = (yyvsp[(3) - (9)].list);
					n->intoClause = (yyvsp[(4) - (9)].into);
					n->fromClause = (yyvsp[(5) - (9)].list);
					n->whereClause = (yyvsp[(6) - (9)].node);
					n->groupClause = (yyvsp[(7) - (9)].list);
					n->havingClause = (yyvsp[(8) - (9)].node);
					n->windowClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1080:

/* Line 1455 of yacc.c  */
#line 7044 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1081:

/* Line 1455 of yacc.c  */
#line 7046 "gram.y"
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[(2) - (2)].range));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1082:

/* Line 1455 of yacc.c  */
#line 7065 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1083:

/* Line 1455 of yacc.c  */
#line 7069 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1084:

/* Line 1455 of yacc.c  */
#line 7073 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1085:

/* Line 1455 of yacc.c  */
#line 7088 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(2) - (2)].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[(1) - (2)]);
			;}
    break;

  case 1086:

/* Line 1455 of yacc.c  */
#line 7095 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(3) - (3)].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[(1) - (3)]);
			;}
    break;

  case 1087:

/* Line 1455 of yacc.c  */
#line 7104 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1088:

/* Line 1455 of yacc.c  */
#line 7105 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1089:

/* Line 1455 of yacc.c  */
#line 7109 "gram.y"
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[(1) - (4)].str);
				n->aliascolnames = (yyvsp[(2) - (4)].list);
				n->ctequery = (yyvsp[(4) - (4)].node);
				n->location = (yylsp[(1) - (4)]);
				(yyval.node) = (Node *) n;
			;}
    break;

  case 1090:

/* Line 1455 of yacc.c  */
#line 7121 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(2) - (2)].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
				;}
    break;

  case 1091:

/* Line 1455 of yacc.c  */
#line 7130 "gram.y"
    { (yyval.into) = NULL; ;}
    break;

  case 1092:

/* Line 1455 of yacc.c  */
#line 7139 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1093:

/* Line 1455 of yacc.c  */
#line 7144 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1094:

/* Line 1455 of yacc.c  */
#line 7149 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1095:

/* Line 1455 of yacc.c  */
#line 7154 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1096:

/* Line 1455 of yacc.c  */
#line 7159 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1097:

/* Line 1455 of yacc.c  */
#line 7164 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1098:

/* Line 1455 of yacc.c  */
#line 7169 "gram.y"
    {
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->istemp = false;
				;}
    break;

  case 1099:

/* Line 1455 of yacc.c  */
#line 7174 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->istemp = false;
				;}
    break;

  case 1100:

/* Line 1455 of yacc.c  */
#line 7180 "gram.y"
    {;}
    break;

  case 1101:

/* Line 1455 of yacc.c  */
#line 7181 "gram.y"
    {;}
    break;

  case 1102:

/* Line 1455 of yacc.c  */
#line 7184 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1103:

/* Line 1455 of yacc.c  */
#line 7185 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1104:

/* Line 1455 of yacc.c  */
#line 7186 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1105:

/* Line 1455 of yacc.c  */
#line 7193 "gram.y"
    { (yyval.list) = list_make1(NIL); ;}
    break;

  case 1106:

/* Line 1455 of yacc.c  */
#line 7194 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (5)].list); ;}
    break;

  case 1107:

/* Line 1455 of yacc.c  */
#line 7195 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1108:

/* Line 1455 of yacc.c  */
#line 7196 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1109:

/* Line 1455 of yacc.c  */
#line 7200 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list);;}
    break;

  case 1110:

/* Line 1455 of yacc.c  */
#line 7201 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1111:

/* Line 1455 of yacc.c  */
#line 7205 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); ;}
    break;

  case 1112:

/* Line 1455 of yacc.c  */
#line 7209 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].sortby)); ;}
    break;

  case 1113:

/* Line 1455 of yacc.c  */
#line 7210 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].sortby)); ;}
    break;

  case 1114:

/* Line 1455 of yacc.c  */
#line 7214 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (4)].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[(4) - (4)].ival);
					(yyval.sortby)->useOp = (yyvsp[(3) - (4)].list);
					(yyval.sortby)->location = (yylsp[(3) - (4)]);
				;}
    break;

  case 1115:

/* Line 1455 of yacc.c  */
#line 7223 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (3)].node);
					(yyval.sortby)->sortby_dir = (yyvsp[(2) - (3)].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[(3) - (3)].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				;}
    break;

  case 1116:

/* Line 1455 of yacc.c  */
#line 7236 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(4) - (4)].node), (yyvsp[(2) - (4)].node)); ;}
    break;

  case 1117:

/* Line 1455 of yacc.c  */
#line 7238 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (4)].node), (yyvsp[(4) - (4)].node)); ;}
    break;

  case 1118:

/* Line 1455 of yacc.c  */
#line 7240 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1119:

/* Line 1455 of yacc.c  */
#line 7242 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (2)].node), NULL); ;}
    break;

  case 1120:

/* Line 1455 of yacc.c  */
#line 7244 "gram.y"
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 scanner_errposition((yylsp[(1) - (4)]))));
				;}
    break;

  case 1121:

/* Line 1455 of yacc.c  */
#line 7254 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (3)].node), NULL); ;}
    break;

  case 1122:

/* Line 1455 of yacc.c  */
#line 7256 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(3) - (5)].node)); ;}
    break;

  case 1123:

/* Line 1455 of yacc.c  */
#line 7258 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (8)].node), (yyvsp[(6) - (8)].node)); ;}
    break;

  case 1124:

/* Line 1455 of yacc.c  */
#line 7262 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1125:

/* Line 1455 of yacc.c  */
#line 7264 "gram.y"
    { (yyval.list) = list_make2(NULL,NULL); ;}
    break;

  case 1126:

/* Line 1455 of yacc.c  */
#line 7268 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1127:

/* Line 1455 of yacc.c  */
#line 7270 "gram.y"
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[(1) - (1)]));
				;}
    break;

  case 1128:

/* Line 1455 of yacc.c  */
#line 7282 "gram.y"
    { (yyval.node) = makeIntConst((yyvsp[(1) - (1)].ival), (yylsp[(1) - (1)])); ;}
    break;

  case 1129:

/* Line 1455 of yacc.c  */
#line 7283 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); ;}
    break;

  case 1130:

/* Line 1455 of yacc.c  */
#line 7284 "gram.y"
    { (yyval.node) = makeIntConst(1, -1); ;}
    break;

  case 1131:

/* Line 1455 of yacc.c  */
#line 7288 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1132:

/* Line 1455 of yacc.c  */
#line 7296 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1133:

/* Line 1455 of yacc.c  */
#line 7301 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1134:

/* Line 1455 of yacc.c  */
#line 7302 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1135:

/* Line 1455 of yacc.c  */
#line 7307 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1136:

/* Line 1455 of yacc.c  */
#line 7308 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1137:

/* Line 1455 of yacc.c  */
#line 7312 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); ;}
    break;

  case 1138:

/* Line 1455 of yacc.c  */
#line 7313 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1139:

/* Line 1455 of yacc.c  */
#line 7317 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1140:

/* Line 1455 of yacc.c  */
#line 7318 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1141:

/* Line 1455 of yacc.c  */
#line 7322 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1142:

/* Line 1455 of yacc.c  */
#line 7323 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1143:

/* Line 1455 of yacc.c  */
#line 7327 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1144:

/* Line 1455 of yacc.c  */
#line 7328 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1145:

/* Line 1455 of yacc.c  */
#line 7332 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1146:

/* Line 1455 of yacc.c  */
#line 7333 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1147:

/* Line 1455 of yacc.c  */
#line 7338 "gram.y"
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[(3) - (4)].list);
					n->forUpdate = TRUE;
					n->noWait = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1148:

/* Line 1455 of yacc.c  */
#line 7346 "gram.y"
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[(3) - (4)].list);
					n->forUpdate = FALSE;
					n->noWait = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1149:

/* Line 1455 of yacc.c  */
#line 7356 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1150:

/* Line 1455 of yacc.c  */
#line 7357 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1151:

/* Line 1455 of yacc.c  */
#line 7363 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[(2) - (2)].list));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1152:

/* Line 1455 of yacc.c  */
#line 7369 "gram.y"
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[(1) - (3)].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[(3) - (3)].list));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1153:

/* Line 1455 of yacc.c  */
#line 7386 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1154:

/* Line 1455 of yacc.c  */
#line 7387 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1155:

/* Line 1455 of yacc.c  */
#line 7391 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1156:

/* Line 1455 of yacc.c  */
#line 7392 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1157:

/* Line 1455 of yacc.c  */
#line 7403 "gram.y"
    {
					(yyval.node) = (Node *) (yyvsp[(1) - (1)].range);
				;}
    break;

  case 1158:

/* Line 1455 of yacc.c  */
#line 7407 "gram.y"
    {
					(yyvsp[(1) - (2)].range)->alias = (yyvsp[(2) - (2)].alias);
					(yyval.node) = (Node *) (yyvsp[(1) - (2)].range);
				;}
    break;

  case 1159:

/* Line 1455 of yacc.c  */
#line 7412 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (1)].node);
					n->coldeflist = NIL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1160:

/* Line 1455 of yacc.c  */
#line 7419 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (2)].node);
					n->alias = (yyvsp[(2) - (2)].alias);
					n->coldeflist = NIL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1161:

/* Line 1455 of yacc.c  */
#line 7427 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (5)].node);
					n->coldeflist = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1162:

/* Line 1455 of yacc.c  */
#line 7434 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					Alias *a = makeNode(Alias);
					n->funccallnode = (yyvsp[(1) - (6)].node);
					a->aliasname = (yyvsp[(3) - (6)].str);
					n->alias = a;
					n->coldeflist = (yyvsp[(5) - (6)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1163:

/* Line 1455 of yacc.c  */
#line 7444 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					Alias *a = makeNode(Alias);
					n->funccallnode = (yyvsp[(1) - (5)].node);
					a->aliasname = (yyvsp[(2) - (5)].str);
					n->alias = a;
					n->coldeflist = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1164:

/* Line 1455 of yacc.c  */
#line 7454 "gram.y"
    {
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if (IsA((yyvsp[(1) - (1)].node), SelectStmt) &&
						((SelectStmt *) (yyvsp[(1) - (1)].node))->valuesLists)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("VALUES in FROM must have an alias"),
								 errhint("For example, FROM (VALUES ...) [AS] foo."),
								 scanner_errposition((yylsp[(1) - (1)]))));
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("subquery in FROM must have an alias"),
								 errhint("For example, FROM (SELECT ...) [AS] foo."),
								 scanner_errposition((yylsp[(1) - (1)]))));
					(yyval.node) = NULL;
				;}
    break;

  case 1165:

/* Line 1455 of yacc.c  */
#line 7482 "gram.y"
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->subquery = (yyvsp[(1) - (2)].node);
					n->alias = (yyvsp[(2) - (2)].alias);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1166:

/* Line 1455 of yacc.c  */
#line 7489 "gram.y"
    {
					(yyval.node) = (Node *) (yyvsp[(1) - (1)].jexpr);
				;}
    break;

  case 1167:

/* Line 1455 of yacc.c  */
#line 7493 "gram.y"
    {
					(yyvsp[(2) - (4)].jexpr)->alias = (yyvsp[(4) - (4)].alias);
					(yyval.node) = (Node *) (yyvsp[(2) - (4)].jexpr);
				;}
    break;

  case 1168:

/* Line 1455 of yacc.c  */
#line 7519 "gram.y"
    {
					(yyval.jexpr) = (yyvsp[(2) - (3)].jexpr);
				;}
    break;

  case 1169:

/* Line 1455 of yacc.c  */
#line 7523 "gram.y"
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->using = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				;}
    break;

  case 1170:

/* Line 1455 of yacc.c  */
#line 7535 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(2) - (5)].jtype);
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(4) - (5)].node);
					if ((yyvsp[(5) - (5)].node) != NULL && IsA((yyvsp[(5) - (5)].node), List))
						n->using = (List *) (yyvsp[(5) - (5)].node); /* USING clause */
					else
						n->quals = (yyvsp[(5) - (5)].node); /* ON clause */
					(yyval.jexpr) = n;
				;}
    break;

  case 1171:

/* Line 1455 of yacc.c  */
#line 7548 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(3) - (4)].node);
					if ((yyvsp[(4) - (4)].node) != NULL && IsA((yyvsp[(4) - (4)].node), List))
						n->using = (List *) (yyvsp[(4) - (4)].node); /* USING clause */
					else
						n->quals = (yyvsp[(4) - (4)].node); /* ON clause */
					(yyval.jexpr) = n;
				;}
    break;

  case 1172:

/* Line 1455 of yacc.c  */
#line 7562 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(3) - (5)].jtype);
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(5) - (5)].node);
					n->using = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				;}
    break;

  case 1173:

/* Line 1455 of yacc.c  */
#line 7573 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->using = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				;}
    break;

  case 1174:

/* Line 1455 of yacc.c  */
#line 7588 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (5)].str);
					(yyval.alias)->colnames = (yyvsp[(4) - (5)].list);
				;}
    break;

  case 1175:

/* Line 1455 of yacc.c  */
#line 7594 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (2)].str);
				;}
    break;

  case 1176:

/* Line 1455 of yacc.c  */
#line 7599 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (4)].str);
					(yyval.alias)->colnames = (yyvsp[(3) - (4)].list);
				;}
    break;

  case 1177:

/* Line 1455 of yacc.c  */
#line 7605 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (1)].str);
				;}
    break;

  case 1178:

/* Line 1455 of yacc.c  */
#line 7611 "gram.y"
    { (yyval.jtype) = JOIN_FULL; ;}
    break;

  case 1179:

/* Line 1455 of yacc.c  */
#line 7612 "gram.y"
    { (yyval.jtype) = JOIN_LEFT; ;}
    break;

  case 1180:

/* Line 1455 of yacc.c  */
#line 7613 "gram.y"
    { (yyval.jtype) = JOIN_RIGHT; ;}
    break;

  case 1181:

/* Line 1455 of yacc.c  */
#line 7614 "gram.y"
    { (yyval.jtype) = JOIN_INNER; ;}
    break;

  case 1182:

/* Line 1455 of yacc.c  */
#line 7618 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1183:

/* Line 1455 of yacc.c  */
#line 7619 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1184:

/* Line 1455 of yacc.c  */
#line 7631 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(3) - (4)].list); ;}
    break;

  case 1185:

/* Line 1455 of yacc.c  */
#line 7632 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1186:

/* Line 1455 of yacc.c  */
#line 7638 "gram.y"
    {
					/* default inheritance */
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->inhOpt = INH_DEFAULT;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 1187:

/* Line 1455 of yacc.c  */
#line 7645 "gram.y"
    {
					/* inheritance query */
					(yyval.range) = (yyvsp[(1) - (2)].range);
					(yyval.range)->inhOpt = INH_YES;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 1188:

/* Line 1455 of yacc.c  */
#line 7652 "gram.y"
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 1189:

/* Line 1455 of yacc.c  */
#line 7659 "gram.y"
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[(3) - (4)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 1190:

/* Line 1455 of yacc.c  */
#line 7669 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); ;}
    break;

  case 1191:

/* Line 1455 of yacc.c  */
#line 7670 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); ;}
    break;

  case 1192:

/* Line 1455 of yacc.c  */
#line 7684 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
				;}
    break;

  case 1193:

/* Line 1455 of yacc.c  */
#line 7688 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(2) - (2)].str);
					(yyvsp[(1) - (2)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (2)].range);
				;}
    break;

  case 1194:

/* Line 1455 of yacc.c  */
#line 7695 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(3) - (3)].str);
					(yyvsp[(1) - (3)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (3)].range);
				;}
    break;

  case 1195:

/* Line 1455 of yacc.c  */
#line 7704 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1196:

/* Line 1455 of yacc.c  */
#line 7709 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1197:

/* Line 1455 of yacc.c  */
#line 7710 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1198:

/* Line 1455 of yacc.c  */
#line 7715 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1199:

/* Line 1455 of yacc.c  */
#line 7717 "gram.y"
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[(4) - (4)].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1200:

/* Line 1455 of yacc.c  */
#line 7725 "gram.y"
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = NULL;
					n->cursor_param = (yyvsp[(4) - (4)].ival);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1201:

/* Line 1455 of yacc.c  */
#line 7732 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1202:

/* Line 1455 of yacc.c  */
#line 7738 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 1203:

/* Line 1455 of yacc.c  */
#line 7742 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1204:

/* Line 1455 of yacc.c  */
#line 7748 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (2)].str);
					n->typename = (yyvsp[(2) - (2)].typnam);
					n->constraints = NIL;
					n->is_local = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1205:

/* Line 1455 of yacc.c  */
#line 7769 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(2) - (2)].list);
				;}
    break;

  case 1206:

/* Line 1455 of yacc.c  */
#line 7774 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->setof = TRUE;
				;}
    break;

  case 1207:

/* Line 1455 of yacc.c  */
#line 7781 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(4) - (5)].ival)));
				;}
    break;

  case 1208:

/* Line 1455 of yacc.c  */
#line 7786 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (6)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(5) - (6)].ival)));
					(yyval.typnam)->setof = TRUE;
				;}
    break;

  case 1209:

/* Line 1455 of yacc.c  */
#line 7792 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				;}
    break;

  case 1210:

/* Line 1455 of yacc.c  */
#line 7797 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = TRUE;
				;}
    break;

  case 1211:

/* Line 1455 of yacc.c  */
#line 7806 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeInteger(-1)); ;}
    break;

  case 1212:

/* Line 1455 of yacc.c  */
#line 7808 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (4)].list), makeInteger((yyvsp[(3) - (4)].ival))); ;}
    break;

  case 1213:

/* Line 1455 of yacc.c  */
#line 7810 "gram.y"
    {  (yyval.list) = NIL; ;}
    break;

  case 1214:

/* Line 1455 of yacc.c  */
#line 7814 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1215:

/* Line 1455 of yacc.c  */
#line 7815 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1216:

/* Line 1455 of yacc.c  */
#line 7816 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1217:

/* Line 1455 of yacc.c  */
#line 7817 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1218:

/* Line 1455 of yacc.c  */
#line 7818 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1219:

/* Line 1455 of yacc.c  */
#line 7820 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
				;}
    break;

  case 1220:

/* Line 1455 of yacc.c  */
#line 7825 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					if ((yyvsp[(5) - (5)].list) != NIL)
					{
						if (list_length((yyvsp[(5) - (5)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 scanner_errposition((yylsp[(1) - (5)]))));
						(yyval.typnam)->typmods = lappend((yyvsp[(5) - (5)].list), makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					}
					else
						(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												 makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
				;}
    break;

  case 1221:

/* Line 1455 of yacc.c  */
#line 7854 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1222:

/* Line 1455 of yacc.c  */
#line 7855 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1223:

/* Line 1455 of yacc.c  */
#line 7856 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1224:

/* Line 1455 of yacc.c  */
#line 7857 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1225:

/* Line 1455 of yacc.c  */
#line 7869 "gram.y"
    {
					(yyval.typnam) = makeTypeName((yyvsp[(1) - (2)].str));
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1226:

/* Line 1455 of yacc.c  */
#line 7875 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(2) - (3)].list)));
					(yyval.typnam)->typmods = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->location = (yylsp[(1) - (3)]);
				;}
    break;

  case 1227:

/* Line 1455 of yacc.c  */
#line 7882 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1228:

/* Line 1455 of yacc.c  */
#line 7883 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1229:

/* Line 1455 of yacc.c  */
#line 7890 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1230:

/* Line 1455 of yacc.c  */
#line 7895 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1231:

/* Line 1455 of yacc.c  */
#line 7900 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1232:

/* Line 1455 of yacc.c  */
#line 7905 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1233:

/* Line 1455 of yacc.c  */
#line 7910 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1234:

/* Line 1455 of yacc.c  */
#line 7915 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (2)].typnam);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1235:

/* Line 1455 of yacc.c  */
#line 7920 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1236:

/* Line 1455 of yacc.c  */
#line 7925 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1237:

/* Line 1455 of yacc.c  */
#line 7931 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1238:

/* Line 1455 of yacc.c  */
#line 7937 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1239:

/* Line 1455 of yacc.c  */
#line 7943 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1240:

/* Line 1455 of yacc.c  */
#line 7950 "gram.y"
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[(2) - (3)].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 scanner_errposition((yylsp[(2) - (3)]))));
					else if ((yyvsp[(2) - (3)].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[(2) - (3)].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 scanner_errposition((yylsp[(2) - (3)]))));
				;}
    break;

  case 1241:

/* Line 1455 of yacc.c  */
#line 7971 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
				;}
    break;

  case 1242:

/* Line 1455 of yacc.c  */
#line 7981 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1243:

/* Line 1455 of yacc.c  */
#line 7985 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1244:

/* Line 1455 of yacc.c  */
#line 7993 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1245:

/* Line 1455 of yacc.c  */
#line 7997 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				;}
    break;

  case 1246:

/* Line 1455 of yacc.c  */
#line 8005 "gram.y"
    {
					char *typname;

					typname = (yyvsp[(2) - (5)].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[(4) - (5)].list);
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				;}
    break;

  case 1247:

/* Line 1455 of yacc.c  */
#line 8017 "gram.y"
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[(2) - (2)].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1248:

/* Line 1455 of yacc.c  */
#line 8038 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1249:

/* Line 1455 of yacc.c  */
#line 8042 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1250:

/* Line 1455 of yacc.c  */
#line 8048 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1251:

/* Line 1455 of yacc.c  */
#line 8052 "gram.y"
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				;}
    break;

  case 1252:

/* Line 1455 of yacc.c  */
#line 8065 "gram.y"
    {
					if (((yyvsp[(5) - (5)].str) != NULL) && (strcmp((yyvsp[(5) - (5)].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[(1) - (5)].str)) + 1 + strlen((yyvsp[(5) - (5)].str)) + 1);
						strcpy(type, (yyvsp[(1) - (5)].str));
						strcat(type, "_");
						strcat(type, (yyvsp[(5) - (5)].str));
						(yyvsp[(1) - (5)].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (5)].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				;}
    break;

  case 1253:

/* Line 1455 of yacc.c  */
#line 8084 "gram.y"
    {
					if (((yyvsp[(2) - (2)].str) != NULL) && (strcmp((yyvsp[(2) - (2)].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[(1) - (2)].str)) + 1 + strlen((yyvsp[(2) - (2)].str)) + 1);
						strcpy(type, (yyvsp[(1) - (2)].str));
						strcat(type, "_");
						strcat(type, (yyvsp[(2) - (2)].str));
						(yyvsp[(1) - (2)].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (2)].str));

					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[(1) - (2)].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));

					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1254:

/* Line 1455 of yacc.c  */
#line 8107 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1255:

/* Line 1455 of yacc.c  */
#line 8109 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1256:

/* Line 1455 of yacc.c  */
#line 8111 "gram.y"
    { (yyval.str) = "varchar"; ;}
    break;

  case 1257:

/* Line 1455 of yacc.c  */
#line 8113 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1258:

/* Line 1455 of yacc.c  */
#line 8115 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1259:

/* Line 1455 of yacc.c  */
#line 8117 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1260:

/* Line 1455 of yacc.c  */
#line 8121 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1261:

/* Line 1455 of yacc.c  */
#line 8122 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1262:

/* Line 1455 of yacc.c  */
#line 8126 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); ;}
    break;

  case 1263:

/* Line 1455 of yacc.c  */
#line 8127 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 1264:

/* Line 1455 of yacc.c  */
#line 8135 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				;}
    break;

  case 1265:

/* Line 1455 of yacc.c  */
#line 8144 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1266:

/* Line 1455 of yacc.c  */
#line 8152 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				;}
    break;

  case 1267:

/* Line 1455 of yacc.c  */
#line 8161 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1268:

/* Line 1455 of yacc.c  */
#line 8172 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1269:

/* Line 1455 of yacc.c  */
#line 8179 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1270:

/* Line 1455 of yacc.c  */
#line 8180 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1271:

/* Line 1455 of yacc.c  */
#line 8181 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1272:

/* Line 1455 of yacc.c  */
#line 8186 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[(1) - (1)]))); ;}
    break;

  case 1273:

/* Line 1455 of yacc.c  */
#line 8188 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[(1) - (1)]))); ;}
    break;

  case 1274:

/* Line 1455 of yacc.c  */
#line 8190 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[(1) - (1)]))); ;}
    break;

  case 1275:

/* Line 1455 of yacc.c  */
#line 8192 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[(1) - (1)]))); ;}
    break;

  case 1276:

/* Line 1455 of yacc.c  */
#line 8194 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[(1) - (1)]))); ;}
    break;

  case 1277:

/* Line 1455 of yacc.c  */
#line 8196 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1278:

/* Line 1455 of yacc.c  */
#line 8198 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[(1) - (3)])));
				;}
    break;

  case 1279:

/* Line 1455 of yacc.c  */
#line 8203 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[(1) - (3)])));
				;}
    break;

  case 1280:

/* Line 1455 of yacc.c  */
#line 8208 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[(1) - (3)])));
				;}
    break;

  case 1281:

/* Line 1455 of yacc.c  */
#line 8214 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				;}
    break;

  case 1282:

/* Line 1455 of yacc.c  */
#line 8222 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[(1) - (3)])));
				;}
    break;

  case 1283:

/* Line 1455 of yacc.c  */
#line 8227 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				;}
    break;

  case 1284:

/* Line 1455 of yacc.c  */
#line 8234 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				;}
    break;

  case 1285:

/* Line 1455 of yacc.c  */
#line 8240 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1286:

/* Line 1455 of yacc.c  */
#line 8245 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[(1) - (1)])));
				;}
    break;

  case 1287:

/* Line 1455 of yacc.c  */
#line 8249 "gram.y"
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[(1) - (4)])),
									makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
				;}
    break;

  case 1288:

/* Line 1455 of yacc.c  */
#line 8278 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1289:

/* Line 1455 of yacc.c  */
#line 8280 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam), (yylsp[(2) - (3)])); ;}
    break;

  case 1290:

/* Line 1455 of yacc.c  */
#line 8282 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("timezone");
					n->args = list_make2((yyvsp[(5) - (5)].node), (yyvsp[(1) - (5)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1291:

/* Line 1455 of yacc.c  */
#line 8303 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1292:

/* Line 1455 of yacc.c  */
#line 8305 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1293:

/* Line 1455 of yacc.c  */
#line 8307 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1294:

/* Line 1455 of yacc.c  */
#line 8309 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1295:

/* Line 1455 of yacc.c  */
#line 8311 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1296:

/* Line 1455 of yacc.c  */
#line 8313 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1297:

/* Line 1455 of yacc.c  */
#line 8315 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1298:

/* Line 1455 of yacc.c  */
#line 8317 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1299:

/* Line 1455 of yacc.c  */
#line 8319 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1300:

/* Line 1455 of yacc.c  */
#line 8321 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1301:

/* Line 1455 of yacc.c  */
#line 8323 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1302:

/* Line 1455 of yacc.c  */
#line 8326 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1303:

/* Line 1455 of yacc.c  */
#line 8328 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1304:

/* Line 1455 of yacc.c  */
#line 8330 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); ;}
    break;

  case 1305:

/* Line 1455 of yacc.c  */
#line 8333 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1306:

/* Line 1455 of yacc.c  */
#line 8335 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1307:

/* Line 1455 of yacc.c  */
#line 8337 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1308:

/* Line 1455 of yacc.c  */
#line 8340 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1309:

/* Line 1455 of yacc.c  */
#line 8342 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(4) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				;}
    break;

  case 1310:

/* Line 1455 of yacc.c  */
#line 8354 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)])); ;}
    break;

  case 1311:

/* Line 1455 of yacc.c  */
#line 8356 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(5) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				;}
    break;

  case 1312:

/* Line 1455 of yacc.c  */
#line 8368 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1313:

/* Line 1455 of yacc.c  */
#line 8370 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(4) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				;}
    break;

  case 1314:

/* Line 1455 of yacc.c  */
#line 8382 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)])); ;}
    break;

  case 1315:

/* Line 1455 of yacc.c  */
#line 8384 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(5) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				;}
    break;

  case 1316:

/* Line 1455 of yacc.c  */
#line 8397 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(4) - (4)].node), makeNullAConst(-1));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[(1) - (4)].node), (Node *) n, (yylsp[(2) - (4)]));
				;}
    break;

  case 1317:

/* Line 1455 of yacc.c  */
#line 8409 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(5) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				;}
    break;

  case 1318:

/* Line 1455 of yacc.c  */
#line 8421 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(5) - (5)].node), makeNullAConst(-1));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(5) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				;}
    break;

  case 1319:

/* Line 1455 of yacc.c  */
#line 8433 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(5) - (7)].node), (yyvsp[(7) - (7)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(6) - (7)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[(1) - (7)].node), (Node *) n, (yylsp[(2) - (7)]));
				;}
    break;

  case 1320:

/* Line 1455 of yacc.c  */
#line 8455 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (3)].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1321:

/* Line 1455 of yacc.c  */
#line 8462 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1322:

/* Line 1455 of yacc.c  */
#line 8469 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (4)].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1323:

/* Line 1455 of yacc.c  */
#line 8476 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1324:

/* Line 1455 of yacc.c  */
#line 8483 "gram.y"
    {
					(yyval.node) = (Node *)makeOverlaps((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list), (yylsp[(2) - (3)]));
				;}
    break;

  case 1325:

/* Line 1455 of yacc.c  */
#line 8487 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_TRUE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1326:

/* Line 1455 of yacc.c  */
#line 8494 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_TRUE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1327:

/* Line 1455 of yacc.c  */
#line 8501 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_FALSE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1328:

/* Line 1455 of yacc.c  */
#line 8508 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_FALSE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1329:

/* Line 1455 of yacc.c  */
#line 8515 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_UNKNOWN;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1330:

/* Line 1455 of yacc.c  */
#line 8522 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1331:

/* Line 1455 of yacc.c  */
#line 8529 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				;}
    break;

  case 1332:

/* Line 1455 of yacc.c  */
#line 8533 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
									(Node *) makeSimpleA_Expr(AEXPR_DISTINCT,
															  "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));

				;}
    break;

  case 1333:

/* Line 1455 of yacc.c  */
#line 8541 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				;}
    break;

  case 1334:

/* Line 1455 of yacc.c  */
#line 8545 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				;}
    break;

  case 1335:

/* Line 1455 of yacc.c  */
#line 8554 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));
				;}
    break;

  case 1336:

/* Line 1455 of yacc.c  */
#line 8561 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
											 (yylsp[(2) - (7)]));
				;}
    break;

  case 1337:

/* Line 1455 of yacc.c  */
#line 8568 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeA_Expr(AEXPR_AND, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											(yylsp[(2) - (6)])),
						(Node *) makeA_Expr(AEXPR_AND, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
											(yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));
				;}
    break;

  case 1338:

/* Line 1455 of yacc.c  */
#line 8581 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeA_Expr(AEXPR_OR, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
											(yylsp[(2) - (7)])),
						(Node *) makeA_Expr(AEXPR_OR, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
											(yylsp[(2) - (7)])),
											 (yylsp[(2) - (7)]));
				;}
    break;

  case 1339:

/* Line 1455 of yacc.c  */
#line 8594 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(3) - (3)].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[(3) - (3)].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[(1) - (3)].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[(2) - (3)]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)]));
					}
				;}
    break;

  case 1340:

/* Line 1455 of yacc.c  */
#line 8613 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(4) - (4)].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[(4) - (4)].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[(1) - (4)].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[(3) - (4)]);
						/* Stick a NOT on top */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (Node *) n, (yylsp[(2) - (4)]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)]));
					}
				;}
    break;

  case 1341:

/* Line 1455 of yacc.c  */
#line 8634 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[(3) - (4)].ival);
					n->testexpr = (yyvsp[(1) - (4)].node);
					n->operName = (yyvsp[(2) - (4)].list);
					n->subselect = (yyvsp[(4) - (4)].node);
					n->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1342:

/* Line 1455 of yacc.c  */
#line 8644 "gram.y"
    {
					if ((yyvsp[(3) - (6)].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
				;}
    break;

  case 1343:

/* Line 1455 of yacc.c  */
#line 8651 "gram.y"
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 scanner_errposition((yylsp[(1) - (2)]))));
				;}
    break;

  case 1344:

/* Line 1455 of yacc.c  */
#line 8667 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[(1) - (3)].node)), (yylsp[(2) - (3)]));
				;}
    break;

  case 1345:

/* Line 1455 of yacc.c  */
#line 8672 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[(1) - (4)].node)), (yylsp[(2) - (4)])),
											 (yylsp[(2) - (4)]));
				;}
    break;

  case 1346:

/* Line 1455 of yacc.c  */
#line 8690 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1347:

/* Line 1455 of yacc.c  */
#line 8692 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam), (yylsp[(2) - (3)])); ;}
    break;

  case 1348:

/* Line 1455 of yacc.c  */
#line 8694 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1349:

/* Line 1455 of yacc.c  */
#line 8696 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1350:

/* Line 1455 of yacc.c  */
#line 8698 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1351:

/* Line 1455 of yacc.c  */
#line 8700 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1352:

/* Line 1455 of yacc.c  */
#line 8702 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1353:

/* Line 1455 of yacc.c  */
#line 8704 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1354:

/* Line 1455 of yacc.c  */
#line 8706 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1355:

/* Line 1455 of yacc.c  */
#line 8708 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1356:

/* Line 1455 of yacc.c  */
#line 8710 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1357:

/* Line 1455 of yacc.c  */
#line 8712 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1358:

/* Line 1455 of yacc.c  */
#line 8714 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1359:

/* Line 1455 of yacc.c  */
#line 8716 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1360:

/* Line 1455 of yacc.c  */
#line 8718 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1361:

/* Line 1455 of yacc.c  */
#line 8720 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); ;}
    break;

  case 1362:

/* Line 1455 of yacc.c  */
#line 8722 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				;}
    break;

  case 1363:

/* Line 1455 of yacc.c  */
#line 8726 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL,
						NULL, (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])), (yylsp[(2) - (6)]));
				;}
    break;

  case 1364:

/* Line 1455 of yacc.c  */
#line 8731 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				;}
    break;

  case 1365:

/* Line 1455 of yacc.c  */
#line 8735 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				;}
    break;

  case 1366:

/* Line 1455 of yacc.c  */
#line 8739 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[(1) - (3)].node)), (yylsp[(2) - (3)]));
				;}
    break;

  case 1367:

/* Line 1455 of yacc.c  */
#line 8744 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[(1) - (4)].node)), (yylsp[(2) - (4)])),
											 (yylsp[(2) - (4)]));
				;}
    break;

  case 1368:

/* Line 1455 of yacc.c  */
#line 8760 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1369:

/* Line 1455 of yacc.c  */
#line 8761 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1370:

/* Line 1455 of yacc.c  */
#line 8763 "gram.y"
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[(1) - (2)].ival);
					p->location = (yylsp[(1) - (2)]);
					if ((yyvsp[(2) - (2)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[(2) - (2)].list));
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				;}
    break;

  case 1371:

/* Line 1455 of yacc.c  */
#line 8778 "gram.y"
    {
					if ((yyvsp[(4) - (4)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[(2) - (4)].node);
						n->indirection = check_indirection((yyvsp[(4) - (4)].list));
						(yyval.node) = (Node *)n;
					}
					else
						(yyval.node) = (yyvsp[(2) - (4)].node);
				;}
    break;

  case 1372:

/* Line 1455 of yacc.c  */
#line 8790 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1373:

/* Line 1455 of yacc.c  */
#line 8792 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1374:

/* Line 1455 of yacc.c  */
#line 8794 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(1) - (1)].node);
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1375:

/* Line 1455 of yacc.c  */
#line 8804 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1376:

/* Line 1455 of yacc.c  */
#line 8814 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1377:

/* Line 1455 of yacc.c  */
#line 8824 "gram.y"
    {
					A_ArrayExpr *n = (A_ArrayExpr *) (yyvsp[(2) - (2)].node);
					Assert(IsA(n, A_ArrayExpr));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1378:

/* Line 1455 of yacc.c  */
#line 8832 "gram.y"
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[(1) - (1)].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)r;
				;}
    break;

  case 1379:

/* Line 1455 of yacc.c  */
#line 8850 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (4)].list);
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(4) - (4)].windef);
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1380:

/* Line 1455 of yacc.c  */
#line 8862 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (5)].list);
					n->args = (yyvsp[(3) - (5)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(5) - (5)].windef);
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1381:

/* Line 1455 of yacc.c  */
#line 8874 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (6)].list);
					n->args = list_make1((yyvsp[(4) - (6)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = TRUE;
					n->over = (yyvsp[(6) - (6)].windef);
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1382:

/* Line 1455 of yacc.c  */
#line 8886 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (8)].list);
					n->args = lappend((yyvsp[(3) - (8)].list), (yyvsp[(6) - (8)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = TRUE;
					n->over = (yyvsp[(8) - (8)].windef);
					n->location = (yylsp[(1) - (8)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1383:

/* Line 1455 of yacc.c  */
#line 8898 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (6)].list);
					n->args = (yyvsp[(4) - (6)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					n->func_variadic = FALSE;
					n->over = (yyvsp[(6) - (6)].windef);
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1384:

/* Line 1455 of yacc.c  */
#line 8914 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (6)].list);
					n->args = (yyvsp[(4) - (6)].list);
					n->agg_star = FALSE;
					n->agg_distinct = TRUE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(6) - (6)].windef);
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1385:

/* Line 1455 of yacc.c  */
#line 8926 "gram.y"
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL92 that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (5)].list);
					n->args = NIL;
					n->agg_star = TRUE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(5) - (5)].windef);
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1386:

/* Line 1455 of yacc.c  */
#line 8948 "gram.y"
    {
					/*
					 * Translate as "'now'::text::date".
					 *
					 * We cannot use "'now'::date" because coerce_type() will
					 * immediately reduce that to a constant representing
					 * today's date.  We need to delay the conversion until
					 * runtime, else the wrong things will happen when
					 * CURRENT_DATE is used in a column default value or rule.
					 *
					 * This could be simplified if we had a way to generate
					 * an expression tree representing runtime application
					 * of type-input conversion functions.  (As of PG 7.3
					 * that is actually possible, but not clear that we want
					 * to rely on it.)
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[(1) - (1)]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("date"), -1);
				;}
    break;

  case 1387:

/* Line 1455 of yacc.c  */
#line 8969 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[(1) - (1)]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timetz"), -1);
				;}
    break;

  case 1388:

/* Line 1455 of yacc.c  */
#line 8979 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[(1) - (4)]), SystemTypeName("text"));
					d = SystemTypeName("timetz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, -1);
				;}
    break;

  case 1389:

/* Line 1455 of yacc.c  */
#line 8992 "gram.y"
    {
					/*
					 * Translate as "now()", since we have a function that
					 * does exactly what is needed.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("now");
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1390:

/* Line 1455 of yacc.c  */
#line 9008 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamptz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[(1) - (4)]), SystemTypeName("text"));
					d = SystemTypeName("timestamptz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, -1);
				;}
    break;

  case 1391:

/* Line 1455 of yacc.c  */
#line 9021 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[(1) - (1)]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast((Node *)n, SystemTypeName("time"), -1);
				;}
    break;

  case 1392:

/* Line 1455 of yacc.c  */
#line 9031 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[(1) - (4)]), SystemTypeName("text"));
					d = SystemTypeName("time");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast((Node *)n, d, -1);
				;}
    break;

  case 1393:

/* Line 1455 of yacc.c  */
#line 9044 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[(1) - (1)]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timestamp"), -1);
				;}
    break;

  case 1394:

/* Line 1455 of yacc.c  */
#line 9054 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[(1) - (4)]), SystemTypeName("text"));
					d = SystemTypeName("timestamp");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, -1);
				;}
    break;

  case 1395:

/* Line 1455 of yacc.c  */
#line 9067 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1396:

/* Line 1455 of yacc.c  */
#line 9079 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1397:

/* Line 1455 of yacc.c  */
#line 9091 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("session_user");
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1398:

/* Line 1455 of yacc.c  */
#line 9103 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1399:

/* Line 1455 of yacc.c  */
#line 9115 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_database");
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1400:

/* Line 1455 of yacc.c  */
#line 9127 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_schema");
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1401:

/* Line 1455 of yacc.c  */
#line 9139 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].typnam), (yylsp[(1) - (6)])); ;}
    break;

  case 1402:

/* Line 1455 of yacc.c  */
#line 9141 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("date_part");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1403:

/* Line 1455 of yacc.c  */
#line 9153 "gram.y"
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * substring(A, 1, C-1) || B || substring(A, C+1, C+D)
					 * overlay(A PLACING B FROM C) is converted to
					 * substring(A, 1, C-1) || B || substring(A, C+1, C+char_length(B))
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("overlay");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1404:

/* Line 1455 of yacc.c  */
#line 9170 "gram.y"
    {
					/* position(A in B) is converted to position(B, A) */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("position");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1405:

/* Line 1455 of yacc.c  */
#line 9183 "gram.y"
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("substring");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1406:

/* Line 1455 of yacc.c  */
#line 9198 "gram.y"
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 */
					FuncCall *n = makeNode(FuncCall);
					/* Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					n->funcname = SystemFuncName(((Value *)llast((yyvsp[(5) - (6)].typnam)->names))->val.str);
					n->args = list_make1((yyvsp[(3) - (6)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1407:

/* Line 1455 of yacc.c  */
#line 9219 "gram.y"
    {
					/* various trim expressions are defined in SQL92
					 * - thomas 1997-07-19
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1408:

/* Line 1455 of yacc.c  */
#line 9234 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("ltrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1409:

/* Line 1455 of yacc.c  */
#line 9246 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("rtrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1410:

/* Line 1455 of yacc.c  */
#line 9258 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1411:

/* Line 1455 of yacc.c  */
#line 9270 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(1) - (6)]));
				;}
    break;

  case 1412:

/* Line 1455 of yacc.c  */
#line 9274 "gram.y"
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[(3) - (4)].list);
					c->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)c;
				;}
    break;

  case 1413:

/* Line 1455 of yacc.c  */
#line 9281 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)v;
				;}
    break;

  case 1414:

/* Line 1455 of yacc.c  */
#line 9289 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_LEAST;
					v->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)v;
				;}
    break;

  case 1415:

/* Line 1455 of yacc.c  */
#line 9297 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				;}
    break;

  case 1416:

/* Line 1455 of yacc.c  */
#line 9301 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (5)].str), NIL, NIL, (yylsp[(1) - (5)]));
				;}
    break;

  case 1417:

/* Line 1455 of yacc.c  */
#line 9305 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), (yyvsp[(6) - (7)].list), NIL, (yylsp[(1) - (7)]));
				;}
    break;

  case 1418:

/* Line 1455 of yacc.c  */
#line 9309 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), NIL, (yyvsp[(6) - (7)].list), (yylsp[(1) - (7)]));
				;}
    break;

  case 1419:

/* Line 1455 of yacc.c  */
#line 9313 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (9)].str), (yyvsp[(6) - (9)].list), (yyvsp[(8) - (9)].list), (yylsp[(1) - (9)]));
				;}
    break;

  case 1420:

/* Line 1455 of yacc.c  */
#line 9317 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[(3) - (4)].list), NIL, (yylsp[(1) - (4)]));
				;}
    break;

  case 1421:

/* Line 1455 of yacc.c  */
#line 9321 "gram.y"
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[(4) - (6)].node), makeBoolAConst((yyvsp[(5) - (6)].boolean), -1)),
									(yylsp[(1) - (6)]));
					x->xmloption = (yyvsp[(3) - (6)].ival);
					(yyval.node) = (Node *)x;
				;}
    break;

  case 1422:

/* Line 1455 of yacc.c  */
#line 9330 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (5)].str), NULL, NIL, (yylsp[(1) - (5)]));
				;}
    break;

  case 1423:

/* Line 1455 of yacc.c  */
#line 9334 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (7)].str), NULL, list_make1((yyvsp[(6) - (7)].node)), (yylsp[(1) - (7)]));
				;}
    break;

  case 1424:

/* Line 1455 of yacc.c  */
#line 9338 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[(3) - (7)].node), (yyvsp[(5) - (7)].node), (yyvsp[(6) - (7)].node)), (yylsp[(1) - (7)]));
				;}
    break;

  case 1425:

/* Line 1455 of yacc.c  */
#line 9343 "gram.y"
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[(3) - (7)].ival);
					n->expr = (yyvsp[(4) - (7)].node);
					n->typename = (yyvsp[(6) - (7)].typnam);
					n->location = (yylsp[(1) - (7)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1426:

/* Line 1455 of yacc.c  */
#line 9357 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1427:

/* Line 1455 of yacc.c  */
#line 9359 "gram.y"
    { (yyval.node) = makeNullAConst(-1); ;}
    break;

  case 1428:

/* Line 1455 of yacc.c  */
#line 9363 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); ;}
    break;

  case 1429:

/* Line 1455 of yacc.c  */
#line 9365 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); ;}
    break;

  case 1430:

/* Line 1455 of yacc.c  */
#line 9367 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); ;}
    break;

  case 1431:

/* Line 1455 of yacc.c  */
#line 9369 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); ;}
    break;

  case 1432:

/* Line 1455 of yacc.c  */
#line 9372 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1433:

/* Line 1455 of yacc.c  */
#line 9375 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1434:

/* Line 1455 of yacc.c  */
#line 9376 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); ;}
    break;

  case 1435:

/* Line 1455 of yacc.c  */
#line 9380 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				;}
    break;

  case 1436:

/* Line 1455 of yacc.c  */
#line 9388 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1437:

/* Line 1455 of yacc.c  */
#line 9397 "gram.y"
    { (yyval.ival) = XMLOPTION_DOCUMENT; ;}
    break;

  case 1438:

/* Line 1455 of yacc.c  */
#line 9398 "gram.y"
    { (yyval.ival) = XMLOPTION_CONTENT; ;}
    break;

  case 1439:

/* Line 1455 of yacc.c  */
#line 9401 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1440:

/* Line 1455 of yacc.c  */
#line 9402 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1441:

/* Line 1455 of yacc.c  */
#line 9403 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1442:

/* Line 1455 of yacc.c  */
#line 9410 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1443:

/* Line 1455 of yacc.c  */
#line 9411 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1444:

/* Line 1455 of yacc.c  */
#line 9415 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].windef)); ;}
    break;

  case 1445:

/* Line 1455 of yacc.c  */
#line 9417 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].windef)); ;}
    break;

  case 1446:

/* Line 1455 of yacc.c  */
#line 9422 "gram.y"
    {
					WindowDef *n = (yyvsp[(3) - (3)].windef);
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.windef) = n;
				;}
    break;

  case 1447:

/* Line 1455 of yacc.c  */
#line 9430 "gram.y"
    { (yyval.windef) = (yyvsp[(2) - (2)].windef); ;}
    break;

  case 1448:

/* Line 1455 of yacc.c  */
#line 9432 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[(2) - (2)].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->location = (yylsp[(2) - (2)]);
					(yyval.windef) = n;
				;}
    break;

  case 1449:

/* Line 1455 of yacc.c  */
#line 9443 "gram.y"
    { (yyval.windef) = NULL; ;}
    break;

  case 1450:

/* Line 1455 of yacc.c  */
#line 9448 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[(2) - (6)].str);
					n->partitionClause = (yyvsp[(3) - (6)].list);
					n->orderClause = (yyvsp[(4) - (6)].list);
					n->frameOptions = (yyvsp[(5) - (6)].ival);
					n->location = (yylsp[(1) - (6)]);
					(yyval.windef) = n;
				;}
    break;

  case 1451:

/* Line 1455 of yacc.c  */
#line 9470 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1452:

/* Line 1455 of yacc.c  */
#line 9471 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 1453:

/* Line 1455 of yacc.c  */
#line 9474 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); ;}
    break;

  case 1454:

/* Line 1455 of yacc.c  */
#line 9475 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1455:

/* Line 1455 of yacc.c  */
#line 9485 "gram.y"
    {
					(yyval.ival) = FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE | (yyvsp[(2) - (2)].ival);
				;}
    break;

  case 1456:

/* Line 1455 of yacc.c  */
#line 9489 "gram.y"
    {
					(yyval.ival) = FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS | (yyvsp[(2) - (2)].ival);
				;}
    break;

  case 1457:

/* Line 1455 of yacc.c  */
#line 9493 "gram.y"
    { (yyval.ival) = FRAMEOPTION_DEFAULTS; ;}
    break;

  case 1458:

/* Line 1455 of yacc.c  */
#line 9497 "gram.y"
    {
					/* reject invalid cases */
					if ((yyvsp[(1) - (1)].ival) & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 scanner_errposition((yylsp[(1) - (1)]))));
					if ((yyvsp[(1) - (1)].ival) & FRAMEOPTION_START_CURRENT_ROW)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("frame start at CURRENT ROW is not implemented"),
								 scanner_errposition((yylsp[(1) - (1)]))));
					(yyval.ival) = (yyvsp[(1) - (1)].ival) | FRAMEOPTION_END_CURRENT_ROW;
				;}
    break;

  case 1459:

/* Line 1455 of yacc.c  */
#line 9512 "gram.y"
    {
					/* reject invalid cases */
					if ((yyvsp[(2) - (4)].ival) & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 scanner_errposition((yylsp[(2) - (4)]))));
					if ((yyvsp[(2) - (4)].ival) & FRAMEOPTION_START_CURRENT_ROW)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("frame start at CURRENT ROW is not implemented"),
								 scanner_errposition((yylsp[(2) - (4)]))));
					if ((yyvsp[(4) - (4)].ival) & FRAMEOPTION_START_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 scanner_errposition((yylsp[(4) - (4)]))));
					/* shift converts START_ options to END_ options */
					(yyval.ival) = FRAMEOPTION_BETWEEN | (yyvsp[(2) - (4)].ival) | ((yyvsp[(4) - (4)].ival) << 1);
				;}
    break;

  case 1460:

/* Line 1455 of yacc.c  */
#line 9541 "gram.y"
    {
					(yyval.ival) = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
				;}
    break;

  case 1461:

/* Line 1455 of yacc.c  */
#line 9545 "gram.y"
    {
					(yyval.ival) = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
				;}
    break;

  case 1462:

/* Line 1455 of yacc.c  */
#line 9549 "gram.y"
    {
					(yyval.ival) = FRAMEOPTION_START_CURRENT_ROW;
				;}
    break;

  case 1463:

/* Line 1455 of yacc.c  */
#line 9565 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1464:

/* Line 1455 of yacc.c  */
#line 9566 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1465:

/* Line 1455 of yacc.c  */
#line 9567 "gram.y"
    { (yyval.list) = lappend((yyvsp[(2) - (5)].list), (yyvsp[(4) - (5)].node)); ;}
    break;

  case 1466:

/* Line 1455 of yacc.c  */
#line 9570 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; ;}
    break;

  case 1467:

/* Line 1455 of yacc.c  */
#line 9571 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; ;}
    break;

  case 1468:

/* Line 1455 of yacc.c  */
#line 9572 "gram.y"
    { (yyval.ival) = ALL_SUBLINK; ;}
    break;

  case 1469:

/* Line 1455 of yacc.c  */
#line 9575 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1470:

/* Line 1455 of yacc.c  */
#line 9576 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1471:

/* Line 1455 of yacc.c  */
#line 9579 "gram.y"
    { (yyval.str) = "+"; ;}
    break;

  case 1472:

/* Line 1455 of yacc.c  */
#line 9580 "gram.y"
    { (yyval.str) = "-"; ;}
    break;

  case 1473:

/* Line 1455 of yacc.c  */
#line 9581 "gram.y"
    { (yyval.str) = "*"; ;}
    break;

  case 1474:

/* Line 1455 of yacc.c  */
#line 9582 "gram.y"
    { (yyval.str) = "/"; ;}
    break;

  case 1475:

/* Line 1455 of yacc.c  */
#line 9583 "gram.y"
    { (yyval.str) = "%"; ;}
    break;

  case 1476:

/* Line 1455 of yacc.c  */
#line 9584 "gram.y"
    { (yyval.str) = "^"; ;}
    break;

  case 1477:

/* Line 1455 of yacc.c  */
#line 9585 "gram.y"
    { (yyval.str) = "<"; ;}
    break;

  case 1478:

/* Line 1455 of yacc.c  */
#line 9586 "gram.y"
    { (yyval.str) = ">"; ;}
    break;

  case 1479:

/* Line 1455 of yacc.c  */
#line 9587 "gram.y"
    { (yyval.str) = "="; ;}
    break;

  case 1480:

/* Line 1455 of yacc.c  */
#line 9591 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1481:

/* Line 1455 of yacc.c  */
#line 9593 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1482:

/* Line 1455 of yacc.c  */
#line 9598 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1483:

/* Line 1455 of yacc.c  */
#line 9600 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1484:

/* Line 1455 of yacc.c  */
#line 9605 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1485:

/* Line 1455 of yacc.c  */
#line 9607 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1486:

/* Line 1455 of yacc.c  */
#line 9609 "gram.y"
    { (yyval.list) = list_make1(makeString("~~")); ;}
    break;

  case 1487:

/* Line 1455 of yacc.c  */
#line 9611 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~")); ;}
    break;

  case 1488:

/* Line 1455 of yacc.c  */
#line 9613 "gram.y"
    { (yyval.list) = list_make1(makeString("~~*")); ;}
    break;

  case 1489:

/* Line 1455 of yacc.c  */
#line 9615 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~*")); ;}
    break;

  case 1490:

/* Line 1455 of yacc.c  */
#line 9627 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 1491:

/* Line 1455 of yacc.c  */
#line 9631 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1492:

/* Line 1455 of yacc.c  */
#line 9636 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].typnam)); ;}
    break;

  case 1493:

/* Line 1455 of yacc.c  */
#line 9637 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].typnam)); ;}
    break;

  case 1494:

/* Line 1455 of yacc.c  */
#line 9641 "gram.y"
    {
					(yyval.node) = makeAArrayExpr((yyvsp[(2) - (3)].list), (yylsp[(1) - (3)]));
				;}
    break;

  case 1495:

/* Line 1455 of yacc.c  */
#line 9645 "gram.y"
    {
					(yyval.node) = makeAArrayExpr((yyvsp[(2) - (3)].list), (yylsp[(1) - (3)]));
				;}
    break;

  case 1496:

/* Line 1455 of yacc.c  */
#line 9649 "gram.y"
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[(1) - (2)]));
				;}
    break;

  case 1497:

/* Line 1455 of yacc.c  */
#line 9654 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1498:

/* Line 1455 of yacc.c  */
#line 9655 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1499:

/* Line 1455 of yacc.c  */
#line 9661 "gram.y"
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[(1) - (3)].str), (yylsp[(1) - (3)])), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1500:

/* Line 1455 of yacc.c  */
#line 9664 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1501:

/* Line 1455 of yacc.c  */
#line 9671 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1502:

/* Line 1455 of yacc.c  */
#line 9672 "gram.y"
    { (yyval.str) = "year"; ;}
    break;

  case 1503:

/* Line 1455 of yacc.c  */
#line 9673 "gram.y"
    { (yyval.str) = "month"; ;}
    break;

  case 1504:

/* Line 1455 of yacc.c  */
#line 9674 "gram.y"
    { (yyval.str) = "day"; ;}
    break;

  case 1505:

/* Line 1455 of yacc.c  */
#line 9675 "gram.y"
    { (yyval.str) = "hour"; ;}
    break;

  case 1506:

/* Line 1455 of yacc.c  */
#line 9676 "gram.y"
    { (yyval.str) = "minute"; ;}
    break;

  case 1507:

/* Line 1455 of yacc.c  */
#line 9677 "gram.y"
    { (yyval.str) = "second"; ;}
    break;

  case 1508:

/* Line 1455 of yacc.c  */
#line 9678 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1509:

/* Line 1455 of yacc.c  */
#line 9688 "gram.y"
    {
					(yyval.list) = list_make4((yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].node), (yyvsp[(3) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1510:

/* Line 1455 of yacc.c  */
#line 9692 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1511:

/* Line 1455 of yacc.c  */
#line 9699 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1512:

/* Line 1455 of yacc.c  */
#line 9705 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(3) - (3)].node), (yyvsp[(1) - (3)].node)); ;}
    break;

  case 1513:

/* Line 1455 of yacc.c  */
#line 9706 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1514:

/* Line 1455 of yacc.c  */
#line 9723 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1515:

/* Line 1455 of yacc.c  */
#line 9727 "gram.y"
    {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yyvsp[(2) - (3)].node));
				;}
    break;

  case 1516:

/* Line 1455 of yacc.c  */
#line 9732 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node));
				;}
    break;

  case 1517:

/* Line 1455 of yacc.c  */
#line 9736 "gram.y"
    {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[(1) - (2)].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[(2) - (2)].node),
												 SystemTypeName("int4"), -1));
				;}
    break;

  case 1518:

/* Line 1455 of yacc.c  */
#line 9751 "gram.y"
    {
					(yyval.list) = (yyvsp[(1) - (1)].list);
				;}
    break;

  case 1519:

/* Line 1455 of yacc.c  */
#line 9755 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1520:

/* Line 1455 of yacc.c  */
#line 9759 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1521:

/* Line 1455 of yacc.c  */
#line 9762 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1522:

/* Line 1455 of yacc.c  */
#line 9765 "gram.y"
    { (yyval.list) = lappend((yyvsp[(3) - (3)].list), (yyvsp[(1) - (3)].node)); ;}
    break;

  case 1523:

/* Line 1455 of yacc.c  */
#line 9766 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1524:

/* Line 1455 of yacc.c  */
#line 9767 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1525:

/* Line 1455 of yacc.c  */
#line 9771 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[(1) - (1)].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1526:

/* Line 1455 of yacc.c  */
#line 9777 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(2) - (3)].list); ;}
    break;

  case 1527:

/* Line 1455 of yacc.c  */
#line 9788 "gram.y"
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[(2) - (5)].node);
					c->args = (yyvsp[(3) - (5)].list);
					c->defresult = (Expr *) (yyvsp[(4) - (5)].node);
					c->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)c;
				;}
    break;

  case 1528:

/* Line 1455 of yacc.c  */
#line 9801 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1529:

/* Line 1455 of yacc.c  */
#line 9802 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1530:

/* Line 1455 of yacc.c  */
#line 9807 "gram.y"
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[(2) - (4)].node);
					w->result = (Expr *) (yyvsp[(4) - (4)].node);
					w->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)w;
				;}
    break;

  case 1531:

/* Line 1455 of yacc.c  */
#line 9817 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1532:

/* Line 1455 of yacc.c  */
#line 9818 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1533:

/* Line 1455 of yacc.c  */
#line 9821 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1534:

/* Line 1455 of yacc.c  */
#line 9822 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1535:

/* Line 1455 of yacc.c  */
#line 9831 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (1)].str), NIL, (yylsp[(1) - (1)]));
				;}
    break;

  case 1536:

/* Line 1455 of yacc.c  */
#line 9835 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].list), (yylsp[(1) - (2)]));
				;}
    break;

  case 1537:

/* Line 1455 of yacc.c  */
#line 9842 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(2) - (2)].str));
				;}
    break;

  case 1538:

/* Line 1455 of yacc.c  */
#line 9846 "gram.y"
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				;}
    break;

  case 1539:

/* Line 1455 of yacc.c  */
#line 9850 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = NULL;
					ai->uidx = (yyvsp[(2) - (3)].node);
					(yyval.node) = (Node *) ai;
				;}
    break;

  case 1540:

/* Line 1455 of yacc.c  */
#line 9857 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = (yyvsp[(2) - (5)].node);
					ai->uidx = (yyvsp[(4) - (5)].node);
					(yyval.node) = (Node *) ai;
				;}
    break;

  case 1541:

/* Line 1455 of yacc.c  */
#line 9866 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1542:

/* Line 1455 of yacc.c  */
#line 9867 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1543:

/* Line 1455 of yacc.c  */
#line 9871 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1544:

/* Line 1455 of yacc.c  */
#line 9872 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1547:

/* Line 1455 of yacc.c  */
#line 9887 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].node); ;}
    break;

  case 1548:

/* Line 1455 of yacc.c  */
#line 9889 "gram.y"
    {
					SetToDefault *n = makeNode(SetToDefault);
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1549:

/* Line 1455 of yacc.c  */
#line 9897 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1550:

/* Line 1455 of yacc.c  */
#line 9898 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1551:

/* Line 1455 of yacc.c  */
#line 9906 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1552:

/* Line 1455 of yacc.c  */
#line 9917 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1553:

/* Line 1455 of yacc.c  */
#line 9918 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); ;}
    break;

  case 1554:

/* Line 1455 of yacc.c  */
#line 9922 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				;}
    break;

  case 1555:

/* Line 1455 of yacc.c  */
#line 9938 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(2) - (2)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (2)].node);
					(yyval.target)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1556:

/* Line 1455 of yacc.c  */
#line 9946 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1557:

/* Line 1455 of yacc.c  */
#line 9954 "gram.y"
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[(1) - (1)]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1558:

/* Line 1455 of yacc.c  */
#line 9975 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1559:

/* Line 1455 of yacc.c  */
#line 9976 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1560:

/* Line 1455 of yacc.c  */
#line 9980 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); ;}
    break;

  case 1561:

/* Line 1455 of yacc.c  */
#line 9981 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); ;}
    break;

  case 1562:

/* Line 1455 of yacc.c  */
#line 9993 "gram.y"
    {
					(yyval.range) = makeNode(RangeVar);
					(yyval.range)->catalogname = NULL;
					(yyval.range)->schemaname = NULL;
					(yyval.range)->relname = (yyvsp[(1) - (1)].str);
					(yyval.range)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1563:

/* Line 1455 of yacc.c  */
#line 10001 "gram.y"
    {
					check_qualified_name((yyvsp[(2) - (2)].list));
					(yyval.range) = makeNode(RangeVar);
					switch (list_length((yyvsp[(2) - (2)].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[(1) - (2)].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[(2) - (2)].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[(1) - (2)].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[(2) - (2)].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[(2) - (2)].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)))),
									 scanner_errposition((yylsp[(1) - (2)]))));
							break;
					}
					(yyval.range)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1564:

/* Line 1455 of yacc.c  */
#line 10029 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1565:

/* Line 1455 of yacc.c  */
#line 10031 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); ;}
    break;

  case 1566:

/* Line 1455 of yacc.c  */
#line 10035 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1567:

/* Line 1455 of yacc.c  */
#line 10038 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1568:

/* Line 1455 of yacc.c  */
#line 10041 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1569:

/* Line 1455 of yacc.c  */
#line 10043 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1570:

/* Line 1455 of yacc.c  */
#line 10045 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1571:

/* Line 1455 of yacc.c  */
#line 10047 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1572:

/* Line 1455 of yacc.c  */
#line 10058 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1573:

/* Line 1455 of yacc.c  */
#line 10060 "gram.y"
    { (yyval.list) = check_func_name(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list))); ;}
    break;

  case 1574:

/* Line 1455 of yacc.c  */
#line 10068 "gram.y"
    {
					(yyval.node) = makeIntConst((yyvsp[(1) - (1)].ival), (yylsp[(1) - (1)]));
				;}
    break;

  case 1575:

/* Line 1455 of yacc.c  */
#line 10072 "gram.y"
    {
					(yyval.node) = makeFloatConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 1576:

/* Line 1455 of yacc.c  */
#line 10076 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 1577:

/* Line 1455 of yacc.c  */
#line 10080 "gram.y"
    {
					(yyval.node) = makeBitStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 1578:

/* Line 1455 of yacc.c  */
#line 10084 "gram.y"
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 1579:

/* Line 1455 of yacc.c  */
#line 10093 "gram.y"
    {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[(1) - (2)].list));
					t->location = (yylsp[(1) - (2)]);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)]), t);
				;}
    break;

  case 1580:

/* Line 1455 of yacc.c  */
#line 10100 "gram.y"
    {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[(1) - (5)].list));
					t->typmods = (yyvsp[(3) - (5)].list);
					t->location = (yylsp[(1) - (5)]);
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (5)].str), (yylsp[(5) - (5)]), t);
				;}
    break;

  case 1581:

/* Line 1455 of yacc.c  */
#line 10108 "gram.y"
    {
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)]), (yyvsp[(1) - (2)].typnam));
				;}
    break;

  case 1582:

/* Line 1455 of yacc.c  */
#line 10112 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (3)].typnam);
					t->typmods = (yyvsp[(3) - (3)].list);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (3)].str), (yylsp[(2) - (3)]), t);
				;}
    break;

  case 1583:

/* Line 1455 of yacc.c  */
#line 10118 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (6)].typnam);
					if ((yyvsp[(6) - (6)].list) != NIL)
					{
						if (list_length((yyvsp[(6) - (6)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 scanner_errposition((yylsp[(1) - (6)]))));
						t->typmods = lappend((yyvsp[(6) - (6)].list), makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (6)].str), (yylsp[(5) - (6)]), t);
				;}
    break;

  case 1584:

/* Line 1455 of yacc.c  */
#line 10135 "gram.y"
    {
					(yyval.node) = makeBoolAConst(TRUE, (yylsp[(1) - (1)]));
				;}
    break;

  case 1585:

/* Line 1455 of yacc.c  */
#line 10139 "gram.y"
    {
					(yyval.node) = makeBoolAConst(FALSE, (yylsp[(1) - (1)]));
				;}
    break;

  case 1586:

/* Line 1455 of yacc.c  */
#line 10143 "gram.y"
    {
					(yyval.node) = makeNullAConst((yylsp[(1) - (1)]));
				;}
    break;

  case 1587:

/* Line 1455 of yacc.c  */
#line 10148 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 1588:

/* Line 1455 of yacc.c  */
#line 10149 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1589:

/* Line 1455 of yacc.c  */
#line 10150 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1590:

/* Line 1455 of yacc.c  */
#line 10152 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 1591:

/* Line 1455 of yacc.c  */
#line 10153 "gram.y"
    { (yyval.ival) = + (yyvsp[(2) - (2)].ival); ;}
    break;

  case 1592:

/* Line 1455 of yacc.c  */
#line 10154 "gram.y"
    { (yyval.ival) = - (yyvsp[(2) - (2)].ival); ;}
    break;

  case 1593:

/* Line 1455 of yacc.c  */
#line 10170 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1594:

/* Line 1455 of yacc.c  */
#line 10171 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1595:

/* Line 1455 of yacc.c  */
#line 10172 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1596:

/* Line 1455 of yacc.c  */
#line 10177 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1597:

/* Line 1455 of yacc.c  */
#line 10178 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1598:

/* Line 1455 of yacc.c  */
#line 10179 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1599:

/* Line 1455 of yacc.c  */
#line 10185 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1600:

/* Line 1455 of yacc.c  */
#line 10186 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1601:

/* Line 1455 of yacc.c  */
#line 10187 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1602:

/* Line 1455 of yacc.c  */
#line 10188 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1603:

/* Line 1455 of yacc.c  */
#line 10189 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1996:

/* Line 1455 of yacc.c  */
#line 10641 "gram.y"
    {
					if (QueryIsRule)
						(yyval.str) = "*OLD*";
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("OLD used in query that is not in a rule"),
								 scanner_errposition((yylsp[(1) - (1)]))));
				;}
    break;

  case 1997:

/* Line 1455 of yacc.c  */
#line 10651 "gram.y"
    {
					if (QueryIsRule)
						(yyval.str) = "*NEW*";
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("NEW used in query that is not in a rule"),
								 scanner_errposition((yylsp[(1) - (1)]))));
				;}
    break;



/* Line 1455 of yacc.c  */
#line 31006 "gram.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }

  yyerror_range[0] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[0] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[0] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[1] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, (yyerror_range - 1), 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 10662 "gram.y"


static Node *
makeColumnRef(char *colname, List *indirection, int location)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields));
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(l) != NULL)
				yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typename = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* makeOverlaps()
 * Create and populate a FuncCall node to support the OVERLAPS operator.
 */
static FuncCall *
makeOverlaps(List *largs, List *rargs, int location)
{
	FuncCall *n = makeNode(FuncCall);

	n->funcname = SystemFuncName("overlaps");
	if (list_length(largs) == 1)
		largs = lappend(largs, largs);
	else if (list_length(largs) != 2)
		ereport(ERROR,
				(errcode(ERRCODE_SYNTAX_ERROR),
				 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
				 scanner_errposition(location)));
	if (list_length(rargs) == 1)
		rargs = lappend(rargs, rargs);
	else if (list_length(rargs) != 2)
		ereport(ERROR,
				(errcode(ERRCODE_SYNTAX_ERROR),
				 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
				 scanner_errposition(location)));
	n->args = list_concat(largs, rargs);
	n->agg_star = FALSE;
	n->agg_distinct = FALSE;
	n->func_variadic = FALSE;
	n->over = NULL;
	n->location = location;
	return n;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(l) != NULL)
				yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* findLeftmostSelect()
 * Find the leftmost component SelectStmt in a set-operation parsetree.
 */
static SelectStmt *
findLeftmostSelect(SelectStmt *node)
{
	while (node && node->op != SETOP_NONE)
		node = node->larg;
	Assert(node && IsA(node, SelectStmt) && node->larg == NULL);
	return node;
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					Node *limitOffset, Node *limitCount,
					WithClause *withClause)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 scanner_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 scanner_errposition(exprLocation(limitOffset))));
		stmt->limitOffset = limitOffset;
	}
	if (limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 scanner_errposition(exprLocation(limitCount))));
		stmt->limitCount = limitCount;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 scanner_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
	{
		char   *newval = (char *) palloc(strlen(oldval) + 2);

		*newval = '-';
		strcpy(newval+1, oldval);
		v->val.str = newval;
	}
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr    *x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->location = location;
	return (Node *) x;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(void)
{
	QueryIsRule = FALSE;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_IN && p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = (TypeName *) copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Must undefine base_yylex before including scan.c, since we want it
 * to create the function base_yylex not filtered_base_yylex.
 */
#undef base_yylex

#include "scan.c"

